/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/base/common/collections","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(be){for(var e=[],w=0,F=be.length;w<F;w++)e[w]=Ae[be[w]];return e};define(Ae[64],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=e.$6g=e.$5g=void 0;function w(A){return(l,S,f)=>{let P=null,D=null;if(typeof f.value=="function"?(P="value",D=f.value):typeof f.get=="function"&&(P="get",D=f.get),!D)throw new Error("not supported");f[P]=A(D,S)}}function F(A,l,S){let f=null,P=null;if(typeof S.value=="function"?(f="value",P=S.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(f="get",P=S.get),!P)throw new Error("not supported");const D=`$memoize$${l}`;S[f]=function(...u){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,u)}),this[D]}}e.$5g=F;function C(A,l,S){return w((f,P)=>{const D=`$debounce$${P}`,u=`$debounce$result$${P}`;return function(...p){this[u]||(this[u]=S?S():void 0),clearTimeout(this[D]),l&&(this[u]=l(this[u],...p),p=[this[u]]),this[D]=setTimeout(()=>{f.apply(this,p),this[u]=S?S():void 0},A)}})}e.$6g=C;function L(A,l,S){return w((f,P)=>{const D=`$throttle$timer$${P}`,u=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,$=`$throttle$pending$${P}`;return function(...h){if(this[u]||(this[u]=S?S():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),l&&(this[u]=l(this[u],...h)),this[$])return;const t=this[p]+A;t<=Date.now()?(this[p]=Date.now(),f.apply(this,[this[u]]),this[u]=S?S():void 0):(this[$]=!0,this[D]=setTimeout(()=>{this[$]=!1,this[p]=Date.now(),f.apply(this,[this[u]]),this[u]=S?S():void 0},t-Date.now()))}})}e.$7g=L}),define(Ae[88],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=e.$2L=void 0;class w{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$2L=w,e.$3L=new w("id#")}),define(Ae[116],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var F;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var C;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(n,a=!1){let s=0;const o=n.length;let y="",m=0,I=16,E=0;function r(W){let O=0,z=0;for(;O<W;){const ee=n.charCodeAt(s);if(ee>=48&&ee<=57)z=z*16+ee-48;else if(ee>=65&&ee<=70)z=z*16+ee-65+10;else if(ee>=97&&ee<=102)z=z*16+ee-97+10;else break;s++,O++}return O<W&&(z=-1),z}function d(W){s=W,y="",m=0,I=16,E=0}function v(){const W=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&f(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&f(n.charCodeAt(s)))for(s++;s<n.length&&f(n.charCodeAt(s));)s++;else return E=3,n.substring(W,s);let O=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&f(n.charCodeAt(s))){for(s++;s<n.length&&f(n.charCodeAt(s));)s++;O=s}else E=3;return n.substring(W,O)}function R(){let W="",O=s;for(;;){if(s>=o){W+=n.substring(O,s),E=2;break}const z=n.charCodeAt(s);if(z===34){W+=n.substring(O,s),s++;break}if(z===92){if(W+=n.substring(O,s),s++,s>=o){E=2;break}switch(n.charCodeAt(s++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const X=r(4);X>=0?W+=String.fromCharCode(X):E=4;break}default:E=5}O=s;continue}if(z>=0&&z<=31)if(S(z)){W+=n.substring(O,s),E=2;break}else E=6;s++}return W}function B(){if(y="",E=0,m=s,s>=o)return m=o,I=17;let W=n.charCodeAt(s);if(l(W)){do s++,y+=String.fromCharCode(W),W=n.charCodeAt(s);while(l(W));return I=15}if(S(W))return s++,y+=String.fromCharCode(W),W===13&&n.charCodeAt(s)===10&&(s++,y+=`
`),I=14;switch(W){case 123:return s++,I=1;case 125:return s++,I=2;case 91:return s++,I=3;case 93:return s++,I=4;case 58:return s++,I=6;case 44:return s++,I=5;case 34:return s++,y=R(),I=10;case 47:{const O=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<o&&!S(n.charCodeAt(s));)s++;return y=n.substring(O,s),I=12}if(n.charCodeAt(s+1)===42){s+=2;const z=o-1;let ee=!1;for(;s<z;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,ee=!0;break}s++}return ee||(s++,E=1),y=n.substring(O,s),I=13}return y+=String.fromCharCode(W),s++,I=16}case 45:if(y+=String.fromCharCode(W),s++,s===o||!f(n.charCodeAt(s)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return y+=v(),I=11;default:for(;s<o&&V(W);)s++,W=n.charCodeAt(s);if(m!==s){switch(y=n.substring(m,s),y){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return y+=String.fromCharCode(W),s++,I=16}}function V(W){if(l(W)||S(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let W;do W=B();while(W>=12&&W<=15);return W}return{setPosition:d,getPosition:()=>s,scan:a?j:B,getToken:()=>I,getTokenValue:()=>y,getTokenOffset:()=>m,getTokenLength:()=>s-m,getTokenError:()=>E}}e.$Im=A;function l(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function S(n){return n===10||n===13||n===8232||n===8233}function f(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function D(n,a){const s=[],o=new Object;let y;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function E(r,d,v,R){m.value=r,m.offset=d,m.length=v,m.type=R,m.colonOffset=void 0,y=m}try{g(n,{onObjectBegin:(r,d)=>{if(a<=r)throw o;y=void 0,I=a>r,s.push("")},onObjectProperty:(r,d,v)=>{if(a<d||(E(r,d,v,"property"),s[s.length-1]=r,a<=d+v))throw o},onObjectEnd:(r,d)=>{if(a<=r)throw o;y=void 0,s.pop()},onArrayBegin:(r,d)=>{if(a<=r)throw o;y=void 0,s.push(0)},onArrayEnd:(r,d)=>{if(a<=r)throw o;y=void 0,s.pop()},onLiteralValue:(r,d,v)=>{if(a<d||(E(r,d,v,b(r)),a<=d+v))throw o},onSeparator:(r,d,v)=>{if(a<=d)throw o;if(r===":"&&y&&y.type==="property")y.colonOffset=d,I=!1,y=void 0;else if(r===","){const R=s[s.length-1];typeof R=="number"?s[s.length-1]=R+1:(I=!0,s[s.length-1]=""),y=void 0}}})}catch(r){if(r!==o)throw r}return{path:s,previousNode:y,isAtPropertyKey:I,matches:r=>{let d=0;for(let v=0;d<r.length&&v<s.length;v++)if(r[d]===s[v]||r[d]==="*")d++;else if(r[d]!=="**")return!1;return d===r.length}}}e.$Jm=D;function u(n,a=[],s=L.DEFAULT){let o=null,y=[];const m=[];function I(r){Array.isArray(y)?y.push(r):o!==null&&(y[o]=r)}return g(n,{onObjectBegin:()=>{const r={};I(r),m.push(y),y=r,o=null},onObjectProperty:r=>{o=r},onObjectEnd:()=>{y=m.pop()},onArrayBegin:()=>{const r=[];I(r),m.push(y),y=r,o=null},onArrayEnd:()=>{y=m.pop()},onLiteralValue:I,onError:(r,d,v)=>{a.push({error:r,offset:d,length:v})}},s),y[0]}e.$Km=u;function p(n,a=[],s=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function y(r){o.type==="property"&&(o.length=r-o.offset,o=o.parent)}function m(r){return o.children.push(r),r}g(n,{onObjectBegin:r=>{o=m({type:"object",offset:r,length:-1,parent:o,children:[]})},onObjectProperty:(r,d,v)=>{o=m({type:"property",offset:d,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:r,offset:d,length:v,parent:o})},onObjectEnd:(r,d)=>{o.length=r+d-o.offset,o=o.parent,y(r+d)},onArrayBegin:(r,d)=>{o=m({type:"array",offset:r,length:-1,parent:o,children:[]})},onArrayEnd:(r,d)=>{o.length=r+d-o.offset,o=o.parent,y(r+d)},onLiteralValue:(r,d,v)=>{m({type:b(r),offset:d,length:v,parent:o,value:r}),y(d+v)},onSeparator:(r,d,v)=>{o.type==="property"&&(r===":"?o.colonOffset=d:r===","&&y(d))},onError:(r,d,v)=>{a.push({error:r,offset:d,length:v})}},s);const E=o.children[0];return E&&delete E.parent,E}e.$Lm=p;function $(n,a){if(!n)return;let s=n;for(const o of a)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let y=!1;for(const m of s.children)if(Array.isArray(m.children)&&m.children[0].value===o){s=m.children[1],y=!0;break}if(!y)return}else{const y=o;if(s.type!=="array"||y<0||!Array.isArray(s.children)||y>=s.children.length)return;s=s.children[y]}return s}e.$Mm=$;function h(n){if(!n.parent||!n.parent.children)return[];const a=h(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;a.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&a.push(s)}return a}e.$Nm=h;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const a=Object.create(null);for(const s of n.children){const o=s.children[1];o&&(a[s.children[0].value]=t(o))}return a}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$Om=t;function i(n,a,s=!1){return a>=n.offset&&a<n.offset+n.length||s&&a===n.offset+n.length}e.$Pm=i;function c(n,a,s=!1){if(i(n,a,s)){const o=n.children;if(Array.isArray(o))for(let y=0;y<o.length&&o[y].offset<=a;y++){const m=c(o[y],a,s);if(m)return m}return n}}e.$Qm=c;function g(n,a,s=L.DEFAULT){const o=A(n,!1);function y(ye){return ye?()=>ye(o.getTokenOffset(),o.getTokenLength()):()=>!0}function m(ye){return ye?ce=>ye(ce,o.getTokenOffset(),o.getTokenLength()):()=>!0}const I=y(a.onObjectBegin),E=m(a.onObjectProperty),r=y(a.onObjectEnd),d=y(a.onArrayBegin),v=y(a.onArrayEnd),R=m(a.onLiteralValue),B=m(a.onSeparator),V=y(a.onComment),j=m(a.onError),W=s&&s.disallowComments,O=s&&s.allowTrailingComma;function z(){for(;;){const ye=o.scan();switch(o.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:W||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(ye){case 12:case 13:W?ee(10):V();break;case 16:ee(1);break;case 15:case 14:break;default:return ye}}}function ee(ye,ce=[],$e=[]){if(j(ye),ce.length+$e.length>0){let ie=o.getToken();for(;ie!==17;){if(ce.indexOf(ie)!==-1){z();break}else if($e.indexOf(ie)!==-1)break;ie=z()}}}function X(ye){const ce=o.getTokenValue();return ye?R(ce):E(ce),z(),!0}function Ee(){switch(o.getToken()){case 11:{let ye=0;try{ye=JSON.parse(o.getTokenValue()),typeof ye!="number"&&(ee(2),ye=0)}catch{ee(2)}R(ye);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return z(),!0}function ke(){return o.getToken()!==10?(ee(3,[],[2,5]),!1):(X(!1),o.getToken()===6?(B(":"),z(),ue()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function Pe(){I(),z();let ye=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ye||ee(4,[],[]),B(","),z(),o.getToken()===2&&O)break}else ye&&ee(6,[],[]);ke()||ee(4,[],[2,5]),ye=!0}return r(),o.getToken()!==2?ee(7,[2],[]):z(),!0}function Z(){d(),z();let ye=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ye||ee(4,[],[]),B(","),z(),o.getToken()===4&&O)break}else ye&&ee(6,[],[]);ue()||ee(4,[],[4,5]),ye=!0}return v(),o.getToken()!==4?ee(8,[4],[]):z(),!0}function ue(){switch(o.getToken()){case 3:return Z();case 1:return Pe();case 10:return X(!0);default:return Ee()}}return z(),o.getToken()===17?s.allowEmptyContent?!0:(ee(4,[],[]),!1):ue()?(o.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.$Rm=g;function k(n,a){const s=A(n),o=[];let y,m=0,I;do switch(I=s.getPosition(),y=s.scan(),y){case 12:case 13:case 17:m!==I&&o.push(n.substring(m,I)),a!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,a)),m=s.getPosition();break}while(y!==17);return o.join("")}e.$Sm=k;function b(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$Tm=b}),define(Ae[28],Re([1,0]),function(be,e){"use strict";var w,F,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.Touch=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;function L(t,i,c){let g=t.get(i);return g===void 0&&(g=c,t.set(i,g)),g}e.$vi=L;function A(t){const i=[];return t.forEach((c,g)=>{i.push(`${g} => ${c}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.$wi=A;function l(t){const i=[];return t.forEach(c=>{i.push(c)}),`Set(${t.size}) {${i.join(", ")}}`}e.$xi=l;class S{constructor(i,c){this.uri=i,this.value=c}}class f{static{this.a=i=>i.toString()}constructor(i,c){this[w]="ResourceMap",i instanceof f?(this.b=new Map(i.b),this.c=c??f.a):(this.b=new Map,this.c=i??f.a)}set(i,c){return this.b.set(this.c(i),new S(i,c)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,c){typeof c<"u"&&(i=i.bind(c));for(const[g,k]of this.b)i(k.value,k.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}e.$yi=f;class P{constructor(i,c){this[F]="ResourceSet",!i||typeof i=="function"?this.a=new f(i):(this.a=new f(c),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,c){this.a.forEach((g,k)=>i.call(c,k,k,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zi=P;var D;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(D||(e.Touch=D={}));class u{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,c=0){const g=this.a.get(i);if(g)return c!==0&&this.j(g,c),g.value}set(i,c,g=0){let k=this.a.get(i);if(k)k.value=c,g!==0&&this.j(k,g);else{switch(k={key:i,value:c,next:void 0,previous:void 0},g){case 0:this.h(k);break;case 1:this.g(k);break;case 2:this.h(k);break;default:this.h(k);break}this.a.set(i,k),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const c=this.a.get(i);if(c)return this.a.delete(i),this.i(c),this.d--,c.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,c){const g=this.e;let k=this.b;for(;k;){if(c?i.bind(c)(k.value,k.key,this):i(k.value,k.key,this),this.e!==g)throw new Error("LinkedMap got modified during iteration.");k=k.next}}keys(){const i=this,c=this.e;let g=this.b;const k={[Symbol.iterator](){return k},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(g){const b={value:g.key,done:!1};return g=g.next,b}else return{value:void 0,done:!0}}};return k}values(){const i=this,c=this.e;let g=this.b;const k={[Symbol.iterator](){return k},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(g){const b={value:g.value,done:!1};return g=g.next,b}else return{value:void 0,done:!0}}};return k}entries(){const i=this,c=this.e;let g=this.b;const k={[Symbol.iterator](){return k},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(g){const b={value:[g.key,g.value],done:!1};return g=g.next,b}else return{value:void 0,done:!0}}};return k}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let c=this.b,g=this.size;for(;c&&g>i;)this.a.delete(c.key),c=c.next,g--;this.b=c,this.d=g,c&&(c.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const c=i.next,g=i.previous;if(!c||!g)throw new Error("Invalid list");c.previous=g,g.next=c}i.next=void 0,i.previous=void 0,this.e++}j(i,c){if(!this.b||!this.c)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(i===this.b)return;const g=i.next,k=i.previous;i===this.c?(k.next=void 0,this.c=k):(g.previous=k,k.next=g),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(c===2){if(i===this.c)return;const g=i.next,k=i.previous;i===this.b?(g.previous=void 0,this.b=g):(g.previous=k,k.next=g),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((c,g)=>{i.push([g,c])}),i}fromJSON(i){this.clear();for(const[c,g]of i)this.set(c,g)}}e.$Ai=u;class p extends u{constructor(i,c=1){super(),this.k=i,this.l=Math.min(Math.max(0,c),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,c=2){return super.get(i,c)}peek(i){return super.get(i,0)}set(i,c){return super.set(i,c,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bi=p;class ${constructor(){this.a=new Map}add(i){return this.a.set(i,(this.a.get(i)||0)+1),this}delete(i){let c=this.a.get(i)||0;return c===0?!1:(c--,c===0?this.a.delete(i):this.a.set(i,c),!0)}has(i){return this.a.has(i)}}e.$Ci=$;class h{constructor(i){if(this.a=new Map,this.b=new Map,i)for(const[c,g]of i)this.set(c,g)}clear(){this.a.clear(),this.b.clear()}set(i,c){this.a.set(i,c),this.b.set(c,i)}get(i){return this.a.get(i)}getKey(i){return this.b.get(i)}delete(i){const c=this.a.get(i);return c===void 0?!1:(this.a.delete(i),this.b.delete(c),!0)}forEach(i,c){this.a.forEach((g,k)=>{i.call(c,g,k,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Di=h}),function(be,e){typeof define=="function"&&define.amd?define(Ae[117],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(ve,me){for(var De=0;De<me.length;De++){var ne=me[De];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(ve,ne.key,ne)}}function w(ve,me,De){return me&&e(ve.prototype,me),De&&e(ve,De),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function F(ve,me){if(ve){if(typeof ve=="string")return C(ve,me);var De=Object.prototype.toString.call(ve).slice(8,-1);if(De==="Object"&&ve.constructor&&(De=ve.constructor.name),De==="Map"||De==="Set")return Array.from(ve);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return C(ve,me)}}function C(ve,me){(me==null||me>ve.length)&&(me=ve.length);for(var De=0,ne=new Array(me);De<me;De++)ne[De]=ve[De];return ne}function L(ve,me){var De=typeof Symbol<"u"&&ve[Symbol.iterator]||ve["@@iterator"];if(De)return(De=De.call(ve)).next.bind(De);if(Array.isArray(ve)||(De=F(ve))||me&&ve&&typeof ve.length=="number"){De&&(ve=De);var ne=0;return function(){return ne>=ve.length?{done:!0}:{done:!1,value:ve[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=A();function l(ve){be.defaults=ve}var S=/[&<>"']/,f=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(me){return u[me]};function $(ve,me){if(me){if(S.test(ve))return ve.replace(f,p)}else if(P.test(ve))return ve.replace(D,p);return ve}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ve){return ve.replace(h,function(me,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var i=/(^|[^\[])\^/g;function c(ve,me){ve=typeof ve=="string"?ve:ve.source,me=me||"";var De={replace:function(he,se){return se=se.source||se,se=se.replace(i,"$1"),ve=ve.replace(he,se),De},getRegex:function(){return new RegExp(ve,me)}};return De}var g=/[^\w:]/g,k=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(ve,me,De){if(ve){var ne;try{ne=decodeURIComponent(t(De)).replace(g,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}me&&!k.test(De)&&(De=y(me,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var n={},a=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function y(ve,me){n[" "+ve]||(a.test(ve)?n[" "+ve]=ve+"/":n[" "+ve]=r(ve,"/",!0)),ve=n[" "+ve];var De=ve.indexOf(":")===-1;return me.substring(0,2)==="//"?De?me:ve.replace(s,"$1")+me:me.charAt(0)==="/"?De?me:ve.replace(o,"$1")+me:ve+me}var m={exec:function(){}};function I(ve){for(var me=1,De,ne;me<arguments.length;me++){De=arguments[me];for(ne in De)Object.prototype.hasOwnProperty.call(De,ne)&&(ve[ne]=De[ne])}return ve}function E(ve,me){var De=ve.replace(/\|/g,function(se,oe,fe){for(var Ie=!1,M=oe;--M>=0&&fe[M]==="\\";)Ie=!Ie;return Ie?"|":" |"}),ne=De.split(/ \|/),he=0;if(ne[0].trim()||ne.shift(),ne.length>0&&!ne[ne.length-1].trim()&&ne.pop(),ne.length>me)ne.splice(me);else for(;ne.length<me;)ne.push("");for(;he<ne.length;he++)ne[he]=ne[he].trim().replace(/\\\|/g,"|");return ne}function r(ve,me,De){var ne=ve.length;if(ne===0)return"";for(var he=0;he<ne;){var se=ve.charAt(ne-he-1);if(se===me&&!De)he++;else if(se!==me&&De)he++;else break}return ve.slice(0,ne-he)}function d(ve,me){if(ve.indexOf(me[1])===-1)return-1;for(var De=ve.length,ne=0,he=0;he<De;he++)if(ve[he]==="\\")he++;else if(ve[he]===me[0])ne++;else if(ve[he]===me[1]&&(ne--,ne<0))return he;return-1}function v(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(ve,me){if(me<1)return"";for(var De="";me>1;)me&1&&(De+=ve),me>>=1,ve+=ve;return De+ve}function B(ve,me,De,ne){var he=me.href,se=me.title?$(me.title):null,oe=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){ne.state.inLink=!0;var fe={type:"link",raw:De,href:he,title:se,text:oe,tokens:ne.inlineTokens(oe)};return ne.state.inLink=!1,fe}return{type:"image",raw:De,href:he,title:se,text:$(oe)}}function V(ve,me){var De=ve.match(/^(\s+)(?:```)/);if(De===null)return me;var ne=De[1];return me.split(`
`).map(function(he){var se=he.match(/^\s+/);if(se===null)return he;var oe=se[0];return oe.length>=ne.length?he.slice(ne.length):he}).join(`
`)}var j=function(){function ve(De){this.options=De||be.defaults}var me=ve.prototype;return me.space=function(ne){var he=this.rules.block.newline.exec(ne);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},me.code=function(ne){var he=this.rules.block.code.exec(ne);if(he){var se=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?se:r(se,`
`)}}},me.fences=function(ne){var he=this.rules.block.fences.exec(ne);if(he){var se=he[0],oe=V(se,he[3]||"");return{type:"code",raw:se,lang:he[2]?he[2].trim():he[2],text:oe}}},me.heading=function(ne){var he=this.rules.block.heading.exec(ne);if(he){var se=he[2].trim();if(/#$/.test(se)){var oe=r(se,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(se=oe.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:se,tokens:this.lexer.inline(se)}}},me.hr=function(ne){var he=this.rules.block.hr.exec(ne);if(he)return{type:"hr",raw:he[0]}},me.blockquote=function(ne){var he=this.rules.block.blockquote.exec(ne);if(he){var se=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},me.list=function(ne){var he=this.rules.block.list.exec(ne);if(he){var se,oe,fe,Ie,M,K,G,Y,J,x,ae,Le,Ue=he[1].trim(),Ye=Ue.length>1,He={type:"list",raw:"",ordered:Ye,start:Ye?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Ye?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Ye?Ue:"[*+-]");for(var et=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");ne&&(Le=!1,!(!(he=et.exec(ne))||this.rules.block.hr.test(ne)));){if(se=he[0],ne=ne.substring(se.length),Y=he[2].split(`
`,1)[0],J=ne.split(`
`,1)[0],this.options.pedantic?(Ie=2,ae=Y.trimLeft()):(Ie=he[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ae=Y.slice(Ie),Ie+=he[1].length),K=!1,!Y&&/^ *$/.test(J)&&(se+=J+`
`,ne=ne.substring(J.length+1),Le=!0),!Le)for(var Ze=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");ne&&(x=ne.split(`
`,1)[0],Y=x,this.options.pedantic&&(Y=Y.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Y)||tt.test(Y)||Ze.test(Y)||_e.test(ne)));){if(Y.search(/[^ ]/)>=Ie||!Y.trim())ae+=`
`+Y.slice(Ie);else if(!K)ae+=`
`+Y;else break;!K&&!Y.trim()&&(K=!0),se+=x+`
`,ne=ne.substring(x.length+1)}He.loose||(G?He.loose=!0:/\n *\n *$/.test(se)&&(G=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ae),oe&&(fe=oe[0]!=="[ ] ",ae=ae.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:se,task:!!oe,checked:fe,loose:!1,text:ae}),He.raw+=se}He.items[He.items.length-1].raw=se.trimRight(),He.items[He.items.length-1].text=ae.trimRight(),He.raw=He.raw.trimRight();var Ne=He.items.length;for(M=0;M<Ne;M++){this.lexer.state.top=!1,He.items[M].tokens=this.lexer.blockTokens(He.items[M].text,[]);var st=He.items[M].tokens.filter(function(Q){return Q.type==="space"}),_=st.every(function(Q){for(var pe=Q.raw.split(""),je=0,ze=L(pe),Qe;!(Qe=ze()).done;){var nt=Qe.value;if(nt===`
`&&(je+=1),je>1)return!0}return!1});!He.loose&&st.length&&_&&(He.loose=!0,He.items[M].loose=!0)}return He}},me.html=function(ne){var he=this.rules.block.html.exec(ne);if(he){var se={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(he[0]):$(he[0]);se.type="paragraph",se.text=oe,se.tokens=this.lexer.inline(oe)}return se}},me.def=function(ne){var he=this.rules.block.def.exec(ne);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var se=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:he[0],href:he[2],title:he[3]}}},me.table=function(ne){var he=this.rules.block.table.exec(ne);if(he){var se={type:"table",header:E(he[1]).map(function(G){return{text:G}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=he[0];var oe=se.align.length,fe,Ie,M,K;for(fe=0;fe<oe;fe++)/^ *-+: *$/.test(se.align[fe])?se.align[fe]="right":/^ *:-+: *$/.test(se.align[fe])?se.align[fe]="center":/^ *:-+ *$/.test(se.align[fe])?se.align[fe]="left":se.align[fe]=null;for(oe=se.rows.length,fe=0;fe<oe;fe++)se.rows[fe]=E(se.rows[fe],se.header.length).map(function(G){return{text:G}});for(oe=se.header.length,Ie=0;Ie<oe;Ie++)se.header[Ie].tokens=this.lexer.inline(se.header[Ie].text);for(oe=se.rows.length,Ie=0;Ie<oe;Ie++)for(K=se.rows[Ie],M=0;M<K.length;M++)K[M].tokens=this.lexer.inline(K[M].text);return se}}},me.lheading=function(ne){var he=this.rules.block.lheading.exec(ne);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},me.paragraph=function(ne){var he=this.rules.block.paragraph.exec(ne);if(he){var se=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:se,tokens:this.lexer.inline(se)}}},me.text=function(ne){var he=this.rules.block.text.exec(ne);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},me.escape=function(ne){var he=this.rules.inline.escape.exec(ne);if(he)return{type:"escape",raw:he[0],text:$(he[1])}},me.tag=function(ne){var he=this.rules.inline.tag.exec(ne);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):$(he[0]):he[0]}},me.link=function(ne){var he=this.rules.inline.link.exec(ne);if(he){var se=he[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var oe=r(se.slice(0,-1),"\\");if((se.length-oe.length)%2===0)return}else{var fe=d(he[2],"()");if(fe>-1){var Ie=he[0].indexOf("!")===0?5:4,M=Ie+he[1].length+fe;he[2]=he[2].substring(0,fe),he[0]=he[0].substring(0,M).trim(),he[3]=""}}var K=he[2],G="";if(this.options.pedantic){var Y=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);Y&&(K=Y[1],G=Y[3])}else G=he[3]?he[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(se)?K=K.slice(1):K=K.slice(1,-1)),B(he,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},me.reflink=function(ne,he){var se;if((se=this.rules.inline.reflink.exec(ne))||(se=this.rules.inline.nolink.exec(ne))){var oe=(se[2]||se[1]).replace(/\s+/g," ");if(oe=he[oe.toLowerCase()],!oe||!oe.href){var fe=se[0].charAt(0);return{type:"text",raw:fe,text:fe}}return B(se,oe,se[0],this.lexer)}},me.emStrong=function(ne,he,se){se===void 0&&(se="");var oe=this.rules.inline.emStrong.lDelim.exec(ne);if(oe&&!(oe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=oe[1]||oe[2]||"";if(!fe||fe&&(se===""||this.rules.inline.punctuation.exec(se))){var Ie=oe[0].length-1,M,K,G=Ie,Y=0,J=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,he=he.slice(-1*ne.length+Ie);(oe=J.exec(he))!=null;)if(M=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!M){if(K=M.length,oe[3]||oe[4]){G+=K;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+K)%3)){Y+=K;continue}if(G-=K,!(G>0)){if(K=Math.min(K,K+G+Y),Math.min(Ie,K)%2){var x=ne.slice(1,Ie+oe.index+K);return{type:"em",raw:ne.slice(0,Ie+oe.index+K+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ae=ne.slice(2,Ie+oe.index+K-1);return{type:"strong",raw:ne.slice(0,Ie+oe.index+K+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}}}}},me.codespan=function(ne){var he=this.rules.inline.code.exec(ne);if(he){var se=he[2].replace(/\n/g," "),oe=/[^ ]/.test(se),fe=/^ /.test(se)&&/ $/.test(se);return oe&&fe&&(se=se.substring(1,se.length-1)),se=$(se,!0),{type:"codespan",raw:he[0],text:se}}},me.br=function(ne){var he=this.rules.inline.br.exec(ne);if(he)return{type:"br",raw:he[0]}},me.del=function(ne){var he=this.rules.inline.del.exec(ne);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},me.autolink=function(ne,he){var se=this.rules.inline.autolink.exec(ne);if(se){var oe,fe;return se[2]==="@"?(oe=$(this.options.mangle?he(se[1]):se[1]),fe="mailto:"+oe):(oe=$(se[1]),fe=oe),{type:"link",raw:se[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},me.url=function(ne,he){var se;if(se=this.rules.inline.url.exec(ne)){var oe,fe;if(se[2]==="@")oe=$(this.options.mangle?he(se[0]):se[0]),fe="mailto:"+oe;else{var Ie;do Ie=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Ie!==se[0]);oe=$(se[0]),se[1]==="www."?fe="http://"+oe:fe=oe}return{type:"link",raw:se[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},me.inlineText=function(ne,he){var se=this.rules.inline.text.exec(ne);if(se){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):$(se[0]):se[0]:oe=$(this.options.smartypants?he(se[0]):se[0]),{type:"text",raw:se[0],text:oe}}},ve}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=c(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=c(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=c(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=c(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=c(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=c(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=I({},W),W.gfm=I({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=c(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=c(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=I({},W.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:c(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=c(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=c(W._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=c(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=c(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=c(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=c(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=c(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=c(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=c(O.reflink).replace("label",O._label).replace("ref",W._label).getRegex(),O.nolink=c(O.nolink).replace("ref",W._label).getRegex(),O.reflinkSearch=c(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=I({},O),O.pedantic=I({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=I({},O.normal,{escape:c(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=c(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=I({},O.gfm,{br:c(O.br).replace("{2,}","*").getRegex(),text:c(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee(ve){var me="",De,ne,he=ve.length;for(De=0;De<he;De++)ne=ve.charCodeAt(De),Math.random()>.5&&(ne="x"+ne.toString(16)),me+="&#"+ne+";";return me}var X=function(){function ve(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||be.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:W.normal,inline:O.normal};this.options.pedantic?(ne.block=W.pedantic,ne.inline=O.pedantic):this.options.gfm&&(ne.block=W.gfm,this.options.breaks?ne.inline=O.breaks:ne.inline=O.gfm),this.tokenizer.rules=ne}ve.lex=function(ne,he){var se=new ve(he);return se.lex(ne)},ve.lexInline=function(ne,he){var se=new ve(he);return se.inlineTokens(ne)};var me=ve.prototype;return me.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`),this.blockTokens(ne,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},me.blockTokens=function(ne,he){var se=this;he===void 0&&(he=[]),this.options.pedantic?ne=ne.replace(/\t/g,"    ").replace(/^ +$/gm,""):ne=ne.replace(/^( *)(\t+)/gm,function(G,Y,J){return Y+"    ".repeat(J.length)});for(var oe,fe,Ie,M;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(oe=G.call({lexer:se},ne,he))?(ne=ne.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.space(ne)){ne=ne.substring(oe.raw.length),oe.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(oe);continue}if(oe=this.tokenizer.code(ne)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe);continue}if(oe=this.tokenizer.fences(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.heading(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.hr(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.blockquote(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.list(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.html(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.def(ne)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.lheading(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(Ie=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,Y=ne.slice(1),J=void 0;se.options.extensions.startBlock.forEach(function(x){J=x.call({lexer:this},Y),typeof J=="number"&&J>=0&&(G=Math.min(G,J))}),G<1/0&&G>=0&&(Ie=ne.substring(0,G+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){fe=he[he.length-1],M&&fe.type==="paragraph"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe),M=Ie.length!==ne.length,ne=ne.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(ne)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe);continue}if(ne){var K="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,he},me.inline=function(ne,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:ne,tokens:he}),he},me.inlineTokens=function(ne,he){var se=this;he===void 0&&(he=[]);var oe,fe,Ie,M=ne,K,G,Y;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec(M))!=null;)J.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&(M=M.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+M.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec(M))!=null;)M=M.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+M.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec(M))!=null;)M=M.slice(0,K.index)+"++"+M.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(G||(Y=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(oe=ae.call({lexer:se},ne,he))?(ne=ne.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.tag(ne)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.link(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.emStrong(ne,M,Y)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.codespan(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.br(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.del(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.autolink(ne,ee)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(ne,ee))){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(Ie=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=1/0,Le=ne.slice(1),Ue=void 0;se.options.extensions.startInline.forEach(function(Ye){Ue=Ye.call({lexer:this},Le),typeof Ue=="number"&&Ue>=0&&(ae=Math.min(ae,Ue))}),ae<1/0&&ae>=0&&(Ie=ne.substring(0,ae+1))}(),oe=this.tokenizer.inlineText(Ie,z)){ne=ne.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Y=oe.raw.slice(-1)),G=!0,fe=he[he.length-1],fe&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(ne){var x="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return he},w(ve,null,[{key:"rules",get:function(){return{block:W,inline:O}}}]),ve}(),Ee=function(){function ve(De){this.options=De||be.defaults}var me=ve.prototype;return me.code=function(ne,he,se){var oe=(he||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(ne,oe);fe!=null&&fe!==ne&&(se=!0,ne=fe)}return ne=ne.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+$(oe,!0)+'">'+(se?ne:$(ne,!0))+`</code></pre>
`:"<pre><code>"+(se?ne:$(ne,!0))+`</code></pre>
`},me.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},me.html=function(ne){return ne},me.heading=function(ne,he,se,oe){if(this.options.headerIds){var fe=this.options.headerPrefix+oe.slug(se);return"<h"+he+' id="'+fe+'">'+ne+"</h"+he+`>
`}return"<h"+he+">"+ne+"</h"+he+`>
`},me.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},me.list=function(ne,he,se){var oe=he?"ol":"ul",fe=he&&se!==1?' start="'+se+'"':"";return"<"+oe+fe+`>
`+ne+"</"+oe+`>
`},me.listitem=function(ne){return"<li>"+ne+`</li>
`},me.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},me.paragraph=function(ne){return"<p>"+ne+`</p>
`},me.table=function(ne,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+he+`</table>
`},me.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},me.tablecell=function(ne,he){var se=he.header?"th":"td",oe=he.align?"<"+se+' align="'+he.align+'">':"<"+se+">";return oe+ne+("</"+se+`>
`)},me.strong=function(ne){return"<strong>"+ne+"</strong>"},me.em=function(ne){return"<em>"+ne+"</em>"},me.codespan=function(ne){return"<code>"+ne+"</code>"},me.br=function(){return this.options.xhtml?"<br/>":"<br>"},me.del=function(ne){return"<del>"+ne+"</del>"},me.link=function(ne,he,se){if(ne=b(this.options.sanitize,this.options.baseUrl,ne),ne===null)return se;var oe='<a href="'+$(ne)+'"';return he&&(oe+=' title="'+he+'"'),oe+=">"+se+"</a>",oe},me.image=function(ne,he,se){if(ne=b(this.options.sanitize,this.options.baseUrl,ne),ne===null)return se;var oe='<img src="'+ne+'" alt="'+se+'"';return he&&(oe+=' title="'+he+'"'),oe+=this.options.xhtml?"/>":">",oe},me.text=function(ne){return ne},ve}(),ke=function(){function ve(){}var me=ve.prototype;return me.strong=function(ne){return ne},me.em=function(ne){return ne},me.codespan=function(ne){return ne},me.del=function(ne){return ne},me.html=function(ne){return ne},me.text=function(ne){return ne},me.link=function(ne,he,se){return""+se},me.image=function(ne,he,se){return""+se},me.br=function(){return""},ve}(),Pe=function(){function ve(){this.seen={}}var me=ve.prototype;return me.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},me.getNextSafeSlug=function(ne,he){var se=ne,oe=0;if(this.seen.hasOwnProperty(se)){oe=this.seen[ne];do oe++,se=ne+"-"+oe;while(this.seen.hasOwnProperty(se))}return he||(this.seen[ne]=oe,this.seen[se]=0),se},me.slug=function(ne,he){he===void 0&&(he={});var se=this.serialize(ne);return this.getNextSafeSlug(se,he.dryrun)},ve}(),Z=function(){function ve(De){this.options=De||be.defaults,this.options.renderer=this.options.renderer||new Ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ke,this.slugger=new Pe}ve.parse=function(ne,he){var se=new ve(he);return se.parse(ne)},ve.parseInline=function(ne,he){var se=new ve(he);return se.parseInline(ne)};var me=ve.prototype;return me.parse=function(ne,he){he===void 0&&(he=!0);var se="",oe,fe,Ie,M,K,G,Y,J,x,ae,Le,Ue,Ye,He,et,Ze,_e,it,tt,Ne=ne.length;for(oe=0;oe<Ne;oe++){if(ae=ne[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(tt=this.options.extensions.renderers[ae.type].call({parser:this},ae),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){se+=tt||"";continue}switch(ae.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,t(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(J="",Y="",M=ae.header.length,fe=0;fe<M;fe++)Y+=this.renderer.tablecell(this.parseInline(ae.header[fe].tokens),{header:!0,align:ae.align[fe]});for(J+=this.renderer.tablerow(Y),x="",M=ae.rows.length,fe=0;fe<M;fe++){for(G=ae.rows[fe],Y="",K=G.length,Ie=0;Ie<K;Ie++)Y+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:ae.align[Ie]});x+=this.renderer.tablerow(Y)}se+=this.renderer.table(J,x);continue}case"blockquote":{x=this.parse(ae.tokens),se+=this.renderer.blockquote(x);continue}case"list":{for(Le=ae.ordered,Ue=ae.start,Ye=ae.loose,M=ae.items.length,x="",fe=0;fe<M;fe++)et=ae.items[fe],Ze=et.checked,_e=et.task,He="",et.task&&(it=this.renderer.checkbox(Ze),Ye?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=it+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=it+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:it}):He+=it),He+=this.parse(et.tokens,Ye),x+=this.renderer.listitem(He,_e,Ze);se+=this.renderer.list(x,Le,Ue);continue}case"html":{se+=this.renderer.html(ae.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(x=ae.tokens?this.parseInline(ae.tokens):ae.text;oe+1<Ne&&ne[oe+1].type==="text";)ae=ne[++oe],x+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);se+=he?this.renderer.paragraph(x):x;continue}default:{var st='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return se},me.parseInline=function(ne,he){he=he||this.renderer;var se="",oe,fe,Ie,M=ne.length;for(oe=0;oe<M;oe++){if(fe=ne[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(Ie=this.options.extensions.renderers[fe.type].call({parser:this},fe),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){se+=Ie||"";continue}switch(fe.type){case"escape":{se+=he.text(fe.text);break}case"html":{se+=he.html(fe.text);break}case"link":{se+=he.link(fe.href,fe.title,this.parseInline(fe.tokens,he));break}case"image":{se+=he.image(fe.href,fe.title,fe.text);break}case"strong":{se+=he.strong(this.parseInline(fe.tokens,he));break}case"em":{se+=he.em(this.parseInline(fe.tokens,he));break}case"codespan":{se+=he.codespan(fe.text);break}case"br":{se+=he.br();break}case"del":{se+=he.del(this.parseInline(fe.tokens,he));break}case"text":{se+=he.text(fe.text);break}default:{var K='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return se},ve}();function ue(ve,me,De){if(typeof ve>"u"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof me=="function"&&(De=me,me=null),me=I({},ue.defaults,me||{}),v(me),De){var ne=me.highlight,he;try{he=X.lex(ve,me)}catch(M){return De(M)}var se=function(K){var G;if(!K)try{me.walkTokens&&ue.walkTokens(he,me.walkTokens),G=Z.parse(he,me)}catch(Y){K=Y}return me.highlight=ne,K?De(K):De(null,G)};if(!ne||ne.length<3||(delete me.highlight,!he.length))return se();var oe=0;ue.walkTokens(he,function(M){M.type==="code"&&(oe++,setTimeout(function(){ne(M.text,M.lang,function(K,G){if(K)return se(K);G!=null&&G!==M.text&&(M.text=G,M.escaped=!0),oe--,oe===0&&se()})},0))}),oe===0&&se();return}function fe(M){if(M.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+$(M.message+"",!0)+"</pre>";throw M}try{var Ie=X.lex(ve,me);if(me.walkTokens){if(me.async)return Promise.all(ue.walkTokens(Ie,me.walkTokens)).then(function(){return Z.parse(Ie,me)}).catch(fe);ue.walkTokens(Ie,me.walkTokens)}return Z.parse(Ie,me)}catch(M){fe(M)}}ue.options=ue.setOptions=function(ve){return I(ue.defaults,ve),l(ue.defaults),ue},ue.getDefaults=A,ue.defaults=be.defaults,ue.use=function(){for(var ve=arguments.length,me=new Array(ve),De=0;De<ve;De++)me[De]=arguments[De];var ne=I.apply(void 0,[{}].concat(me)),he=ue.defaults.extensions||{renderers:{},childTokens:{}},se;me.forEach(function(oe){if(oe.extensions&&(se=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var M=he.renderers?he.renderers[Ie.name]:null;M?he.renderers[Ie.name]=function(){for(var K=arguments.length,G=new Array(K),Y=0;Y<K;Y++)G[Y]=arguments[Y];var J=Ie.renderer.apply(this,G);return J===!1&&(J=M.apply(this,G)),J}:he.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Ie.level]?he[Ie.level].unshift(Ie.tokenizer):he[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?he.startBlock?he.startBlock.push(Ie.start):he.startBlock=[Ie.start]:Ie.level==="inline"&&(he.startInline?he.startInline.push(Ie.start):he.startInline=[Ie.start]))}Ie.childTokens&&(he.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=ue.defaults.renderer||new Ee,M=function(Y){var J=Ie[Y];Ie[Y]=function(){for(var x=arguments.length,ae=new Array(x),Le=0;Le<x;Le++)ae[Le]=arguments[Le];var Ue=oe.renderer[Y].apply(Ie,ae);return Ue===!1&&(Ue=J.apply(Ie,ae)),Ue}};for(var K in oe.renderer)M(K);ne.renderer=Ie}(),oe.tokenizer&&function(){var Ie=ue.defaults.tokenizer||new j,M=function(Y){var J=Ie[Y];Ie[Y]=function(){for(var x=arguments.length,ae=new Array(x),Le=0;Le<x;Le++)ae[Le]=arguments[Le];var Ue=oe.tokenizer[Y].apply(Ie,ae);return Ue===!1&&(Ue=J.apply(Ie,ae)),Ue}};for(var K in oe.tokenizer)M(K);ne.tokenizer=Ie}(),oe.walkTokens){var fe=ue.defaults.walkTokens;ne.walkTokens=function(Ie){var M=[];return M.push(oe.walkTokens.call(this,Ie)),fe&&(M=M.concat(fe.call(this,Ie))),M}}se&&(ne.extensions=he),ue.setOptions(ne)})},ue.walkTokens=function(ve,me){for(var De=[],ne=function(){var fe=se.value;switch(De=De.concat(me.call(ue,fe)),fe.type){case"table":{for(var Ie=L(fe.header),M;!(M=Ie()).done;){var K=M.value;De=De.concat(ue.walkTokens(K.tokens,me))}for(var G=L(fe.rows),Y;!(Y=G()).done;)for(var J=Y.value,x=L(J),ae;!(ae=x()).done;){var Le=ae.value;De=De.concat(ue.walkTokens(Le.tokens,me))}break}case"list":{De=De.concat(ue.walkTokens(fe.items,me));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[fe.type]?ue.defaults.extensions.childTokens[fe.type].forEach(function(Ue){De=De.concat(ue.walkTokens(fe[Ue],me))}):fe.tokens&&(De=De.concat(ue.walkTokens(fe.tokens,me)))}},he=L(ve),se;!(se=he()).done;)ne();return De},ue.parseInline=function(ve,me){if(typeof ve>"u"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");me=I({},ue.defaults,me||{}),v(me);try{var De=X.lexInline(ve,me);return me.walkTokens&&ue.walkTokens(De,me.walkTokens),Z.parseInline(De,me)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+$(ne.message+"",!0)+"</pre>";throw ne}},ue.Parser=Z,ue.parser=Z.parse,ue.Renderer=Ee,ue.TextRenderer=ke,ue.Lexer=X,ue.lexer=X.lex,ue.Tokenizer=j,ue.Slugger=Pe,ue.parse=ue;var ye=ue.options,ce=ue.setOptions,$e=ue.use,ie=ue.walkTokens,N=ue.parseInline,q=ue,le=Z.parse,we=X.lex;be.Lexer=X,be.Parser=Z,be.Renderer=Ee,be.Slugger=Pe,be.TextRenderer=ke,be.Tokenizer=j,be.getDefaults=A,be.lexer=we,be.marked=ue,be.options=ye,be.parse=q,be.parseInline=N,be.parser=le,be.setOptions=ce,be.use=$e,be.walkTokens=ie,Object.defineProperty(be,"__esModule",{value:!0})}),define(Ae[118],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.rot=e.$Gl=void 0;function w(l,S,f){return Math.min(Math.max(l,S),f)}e.$Gl=w;function F(l,S){return(S+l%S)%S}e.rot=F;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Il=C;class L{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Jl=L;class A{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const f=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Kl=A}),function(){function be(C){const L=[];typeof C=="number"&&L.push("code/timeOrigin",C);function A(S){L.push(S,Date.now())}function l(){const S=[];for(let f=0;f<L.length;f+=2)S.push({name:L[f],startTime:L[f+1]});return S}return{mark:A,getMarks:l}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(C+A.startTime)});return L}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function w(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=w(F))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var F in w)(typeof exports=="object"?exports:be)[F]=w[F]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function w(F){if(e[F])return e[F].exports;var C=e[F]={i:F,l:!1,exports:{}};return be[F].call(C.exports,C,C.exports,w),C.l=!0,C.exports}return w.m=be,w.c=e,w.d=function(F,C,L){w.o(F,C)||Object.defineProperty(F,C,{enumerable:!0,get:L})},w.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},w.t=function(F,C){if(1&C&&(F=w(F)),8&C||4&C&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(w.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&C&&typeof F!="string")for(var A in F)w.d(L,A,function(l){return F[l]}.bind(null,A));return L},w.n=function(F){var C=F&&F.__esModule?function(){return F.default}:function(){return F};return w.d(C,"a",C),C},w.o=function(F,C){return Object.prototype.hasOwnProperty.call(F,C)},w.p="",w(w.s=0)}([function(be,e,w){(function(F){var C;e=be.exports=$e,C=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,l=e.re=[],S=e.src=[],f=0,P=f++;S[P]="0|[1-9]\\d*";var D=f++;S[D]="[0-9]+";var u=f++;S[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=f++;S[p]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var $=f++;S[$]="("+S[D]+")\\.("+S[D]+")\\.("+S[D]+")";var h=f++;S[h]="(?:"+S[P]+"|"+S[u]+")";var t=f++;S[t]="(?:"+S[D]+"|"+S[u]+")";var i=f++;S[i]="(?:-("+S[h]+"(?:\\."+S[h]+")*))";var c=f++;S[c]="(?:-?("+S[t]+"(?:\\."+S[t]+")*))";var g=f++;S[g]="[0-9A-Za-z-]+";var k=f++;S[k]="(?:\\+("+S[g]+"(?:\\."+S[g]+")*))";var b=f++,n="v?"+S[p]+S[i]+"?"+S[k]+"?";S[b]="^"+n+"$";var a="[v=\\s]*"+S[$]+S[c]+"?"+S[k]+"?",s=f++;S[s]="^"+a+"$";var o=f++;S[o]="((?:<|>)?=?)";var y=f++;S[y]=S[D]+"|x|X|\\*";var m=f++;S[m]=S[P]+"|x|X|\\*";var I=f++;S[I]="[v=\\s]*("+S[m]+")(?:\\.("+S[m]+")(?:\\.("+S[m]+")(?:"+S[i]+")?"+S[k]+"?)?)?";var E=f++;S[E]="[v=\\s]*("+S[y]+")(?:\\.("+S[y]+")(?:\\.("+S[y]+")(?:"+S[c]+")?"+S[k]+"?)?)?";var r=f++;S[r]="^"+S[o]+"\\s*"+S[I]+"$";var d=f++;S[d]="^"+S[o]+"\\s*"+S[E]+"$";var v=f++;S[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=f++;S[R]="(?:~>?)";var B=f++;S[B]="(\\s*)"+S[R]+"\\s+",l[B]=new RegExp(S[B],"g");var V=f++;S[V]="^"+S[R]+S[I]+"$";var j=f++;S[j]="^"+S[R]+S[E]+"$";var W=f++;S[W]="(?:\\^)";var O=f++;S[O]="(\\s*)"+S[W]+"\\s+",l[O]=new RegExp(S[O],"g");var z=f++;S[z]="^"+S[W]+S[I]+"$";var ee=f++;S[ee]="^"+S[W]+S[E]+"$";var X=f++;S[X]="^"+S[o]+"\\s*("+a+")$|^$";var Ee=f++;S[Ee]="^"+S[o]+"\\s*("+n+")$|^$";var ke=f++;S[ke]="(\\s*)"+S[o]+"\\s*("+a+"|"+S[I]+")",l[ke]=new RegExp(S[ke],"g");var Pe=f++;S[Pe]="^\\s*("+S[I]+")\\s+-\\s+("+S[I]+")\\s*$";var Z=f++;S[Z]="^\\s*("+S[E]+")\\s+-\\s+("+S[E]+")\\s*$";var ue=f++;S[ue]="(<|>)?=?\\s*\\*";for(var ye=0;ye<35;ye++)C(ye,S[ye]),l[ye]||(l[ye]=new RegExp(S[ye]));function ce(J,x){if(J instanceof $e)return J;if(typeof J!="string"||J.length>L||!(x?l[s]:l[b]).test(J))return null;try{return new $e(J,x)}catch{return null}}function $e(J,x){if(J instanceof $e){if(J.loose===x)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof $e))return new $e(J,x);C("SemVer",J,x),this.loose=x;var ae=J.trim().match(x?l[s]:l[b]);if(!ae)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var Ue=+Le;if(Ue>=0&&Ue<A)return Ue}return Le}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=ce,e.valid=function(J,x){var ae=ce(J,x);return ae?ae.version:null},e.clean=function(J,x){var ae=ce(J.trim().replace(/^[=v]+/,""),x);return ae?ae.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(J){return C("SemVer.compare",this.version,this.loose,J),J instanceof $e||(J=new $e(J,this.loose)),this.compareMain(J)||this.comparePre(J)},$e.prototype.compareMain=function(J){return J instanceof $e||(J=new $e(J,this.loose)),N(this.major,J.major)||N(this.minor,J.minor)||N(this.patch,J.patch)},$e.prototype.comparePre=function(J){if(J instanceof $e||(J=new $e(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var x=0;do{var ae=this.prerelease[x],Le=J.prerelease[x];if(C("prerelease compare",x,ae,Le),ae===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(ae===void 0)return-1;if(ae!==Le)return N(ae,Le)}while(++x)},$e.prototype.inc=function(J,x){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,x,ae,Le){typeof ae=="string"&&(Le=ae,ae=void 0);try{return new $e(J,ae).inc(x,Le).version}catch{return null}},e.diff=function(J,x){if(ve(J,x))return null;var ae=ce(J),Le=ce(x);if(ae.prerelease.length||Le.prerelease.length){for(var Ue in ae)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ae[Ue]!==Le[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ae)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ae[Ue]!==Le[Ue])return Ue},e.compareIdentifiers=N;var ie=/^[0-9]+$/;function N(J,x){var ae=ie.test(J),Le=ie.test(x);return ae&&Le&&(J=+J,x=+x),ae&&!Le?-1:Le&&!ae?1:J<x?-1:J>x?1:0}function q(J,x,ae){return new $e(J,ae).compare(new $e(x,ae))}function le(J,x,ae){return q(J,x,ae)>0}function we(J,x,ae){return q(J,x,ae)<0}function ve(J,x,ae){return q(J,x,ae)===0}function me(J,x,ae){return q(J,x,ae)!==0}function De(J,x,ae){return q(J,x,ae)>=0}function ne(J,x,ae){return q(J,x,ae)<=0}function he(J,x,ae,Le){var Ue;switch(x){case"===":typeof J=="object"&&(J=J.version),typeof ae=="object"&&(ae=ae.version),Ue=J===ae;break;case"!==":typeof J=="object"&&(J=J.version),typeof ae=="object"&&(ae=ae.version),Ue=J!==ae;break;case"":case"=":case"==":Ue=ve(J,ae,Le);break;case"!=":Ue=me(J,ae,Le);break;case">":Ue=le(J,ae,Le);break;case">=":Ue=De(J,ae,Le);break;case"<":Ue=we(J,ae,Le);break;case"<=":Ue=ne(J,ae,Le);break;default:throw new TypeError("Invalid operator: "+x)}return Ue}function se(J,x){if(J instanceof se){if(J.loose===x)return J;J=J.value}if(!(this instanceof se))return new se(J,x);C("comparator",J,x),this.loose=x,this.parse(J),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(J,x){return N(x,J)},e.major=function(J,x){return new $e(J,x).major},e.minor=function(J,x){return new $e(J,x).minor},e.patch=function(J,x){return new $e(J,x).patch},e.compare=q,e.compareLoose=function(J,x){return q(J,x,!0)},e.rcompare=function(J,x,ae){return q(x,J,ae)},e.sort=function(J,x){return J.sort(function(ae,Le){return e.compare(ae,Le,x)})},e.rsort=function(J,x){return J.sort(function(ae,Le){return e.rcompare(ae,Le,x)})},e.gt=le,e.lt=we,e.eq=ve,e.neq=me,e.gte=De,e.lte=ne,e.cmp=he,e.Comparator=se;var oe={};function fe(J,x){if(J instanceof fe)return J.loose===x?J:new fe(J.raw,x);if(J instanceof se)return new fe(J.value,x);if(!(this instanceof fe))return new fe(J,x);if(this.loose=x,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ie(J){return!J||J.toLowerCase()==="x"||J==="*"}function M(J,x,ae,Le,Ue,Ye,He,et,Ze,_e,it,tt,Ne){return((x=Ie(ae)?"":Ie(Le)?">="+ae+".0.0":Ie(Ue)?">="+ae+"."+Le+".0":">="+x)+" "+(et=Ie(Ze)?"":Ie(_e)?"<"+(+Ze+1)+".0.0":Ie(it)?"<"+Ze+"."+(+_e+1)+".0":tt?"<="+Ze+"."+_e+"."+it+"-"+tt:"<="+et)).trim()}function K(J,x){for(var ae=0;ae<J.length;ae++)if(!J[ae].test(x))return!1;if(x.prerelease.length){for(ae=0;ae<J.length;ae++)if(C(J[ae].semver),J[ae].semver!==oe&&J[ae].semver.prerelease.length>0){var Le=J[ae].semver;if(Le.major===x.major&&Le.minor===x.minor&&Le.patch===x.patch)return!0}return!1}return!0}function G(J,x,ae){try{x=new fe(x,ae)}catch{return!1}return x.test(J)}function Y(J,x,ae,Le){var Ue,Ye,He,et,Ze;switch(J=new $e(J,Le),x=new fe(x,Le),ae){case">":Ue=le,Ye=ne,He=we,et=">",Ze=">=";break;case"<":Ue=we,Ye=De,He=le,et="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(J,x,Le))return!1;for(var _e=0;_e<x.set.length;++_e){var it=x.set[_e],tt=null,Ne=null;if(it.forEach(function(st){st.semver===oe&&(st=new se(">=0.0.0")),tt=tt||st,Ne=Ne||st,Ue(st.semver,tt.semver,Le)?tt=st:He(st.semver,Ne.semver,Le)&&(Ne=st)}),tt.operator===et||tt.operator===Ze||(!Ne.operator||Ne.operator===et)&&Ye(J,Ne.semver)||Ne.operator===Ze&&He(J,Ne.semver))return!1}return!0}se.prototype.parse=function(J){var x=this.loose?l[X]:l[Ee],ae=J.match(x);if(!ae)throw new TypeError("Invalid comparator: "+J);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new $e(ae[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(J){return C("Comparator.test",J,this.loose),this.semver===oe||(typeof J=="string"&&(J=new $e(J,this.loose)),he(J,this.operator,this.semver,this.loose))},se.prototype.intersects=function(J,x){if(!(J instanceof se))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new fe(J.value,x),G(this.value,ae,x);if(J.operator==="")return ae=new fe(this.value,x),G(J.semver,ae,x);var Le=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Ye=this.semver.version===J.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),et=he(this.semver,"<",J.semver,x)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ze=he(this.semver,">",J.semver,x)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Le||Ue||Ye&&He||et||Ze},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(J){var x=this.loose;J=J.trim(),C("range",J,x);var ae=x?l[Z]:l[Pe];J=J.replace(ae,M),C("hyphen replace",J),J=J.replace(l[ke],"$1$2$3"),C("comparator trim",J,l[ke]),J=(J=(J=J.replace(l[B],"$1~")).replace(l[O],"$1^")).split(/\s+/).join(" ");var Le=x?l[X]:l[Ee],Ue=J.split(" ").map(function(Ye){return function(He,et){return C("comp",He),He=function(Ze,_e){return Ze.trim().split(/\s+/).map(function(it){return function(tt,Ne){C("caret",tt,Ne);var st=Ne?l[ee]:l[z];return tt.replace(st,function(_,Q,pe,je,ze){var Qe;return C("caret",tt,_,Q,pe,je,ze),Ie(Q)?Qe="":Ie(pe)?Qe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(je)?Qe=Q==="0"?">="+Q+"."+pe+".0 <"+Q+"."+(+pe+1)+".0":">="+Q+"."+pe+".0 <"+(+Q+1)+".0.0":ze?(C("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Qe=Q==="0"?pe==="0"?">="+Q+"."+pe+"."+je+ze+" <"+Q+"."+pe+"."+(+je+1):">="+Q+"."+pe+"."+je+ze+" <"+Q+"."+(+pe+1)+".0":">="+Q+"."+pe+"."+je+ze+" <"+(+Q+1)+".0.0"):(C("no pr"),Qe=Q==="0"?pe==="0"?">="+Q+"."+pe+"."+je+" <"+Q+"."+pe+"."+(+je+1):">="+Q+"."+pe+"."+je+" <"+Q+"."+(+pe+1)+".0":">="+Q+"."+pe+"."+je+" <"+(+Q+1)+".0.0"),C("caret return",Qe),Qe})}(it,_e)}).join(" ")}(He,et),C("caret",He),He=function(Ze,_e){return Ze.trim().split(/\s+/).map(function(it){return function(tt,Ne){var st=Ne?l[j]:l[V];return tt.replace(st,function(_,Q,pe,je,ze){var Qe;return C("tilde",tt,_,Q,pe,je,ze),Ie(Q)?Qe="":Ie(pe)?Qe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(je)?Qe=">="+Q+"."+pe+".0 <"+Q+"."+(+pe+1)+".0":ze?(C("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Qe=">="+Q+"."+pe+"."+je+ze+" <"+Q+"."+(+pe+1)+".0"):Qe=">="+Q+"."+pe+"."+je+" <"+Q+"."+(+pe+1)+".0",C("tilde return",Qe),Qe})}(it,_e)}).join(" ")}(He,et),C("tildes",He),He=function(Ze,_e){return C("replaceXRanges",Ze,_e),Ze.split(/\s+/).map(function(it){return function(tt,Ne){tt=tt.trim();var st=Ne?l[d]:l[r];return tt.replace(st,function(_,Q,pe,je,ze,Qe){C("xRange",tt,_,Q,pe,je,ze,Qe);var nt=Ie(pe),gt=nt||Ie(je),vt=gt||Ie(ze);return Q==="="&&vt&&(Q=""),nt?_=Q===">"||Q==="<"?"<0.0.0":"*":Q&&vt?(gt&&(je=0),vt&&(ze=0),Q===">"?(Q=">=",gt?(pe=+pe+1,je=0,ze=0):vt&&(je=+je+1,ze=0)):Q==="<="&&(Q="<",gt?pe=+pe+1:je=+je+1),_=Q+pe+"."+je+"."+ze):gt?_=">="+pe+".0.0 <"+(+pe+1)+".0.0":vt&&(_=">="+pe+"."+je+".0 <"+pe+"."+(+je+1)+".0"),C("xRange return",_),_})}(it,_e)}).join(" ")}(He,et),C("xrange",He),He=function(Ze,_e){return C("replaceStars",Ze,_e),Ze.trim().replace(l[ue],"")}(He,et),C("stars",He),He}(Ye,x)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Ye){return!!Ye.match(Le)})),Ue=Ue.map(function(Ye){return new se(Ye,x)})},fe.prototype.intersects=function(J,x){if(!(J instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(Le){return J.set.some(function(Ue){return Ue.every(function(Ye){return Le.intersects(Ye,x)})})})})},e.toComparators=function(J,x){return new fe(J,x).set.map(function(ae){return ae.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new $e(J,this.loose));for(var x=0;x<this.set.length;x++)if(K(this.set[x],J))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(J,x,ae){var Le=null,Ue=null;try{var Ye=new fe(x,ae)}catch{return null}return J.forEach(function(He){Ye.test(He)&&(Le&&Ue.compare(He)!==-1||(Ue=new $e(Le=He,ae)))}),Le},e.minSatisfying=function(J,x,ae){var Le=null,Ue=null;try{var Ye=new fe(x,ae)}catch{return null}return J.forEach(function(He){Ye.test(He)&&(Le&&Ue.compare(He)!==1||(Ue=new $e(Le=He,ae)))}),Le},e.validRange=function(J,x){try{return new fe(J,x).range||"*"}catch{return null}},e.ltr=function(J,x,ae){return Y(J,x,"<",ae)},e.gtr=function(J,x,ae){return Y(J,x,">",ae)},e.outside=Y,e.prerelease=function(J,x){var ae=ce(J,x);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(J,x,ae){return J=new fe(J,ae),x=new fe(x,ae),J.intersects(x)},e.coerce=function(J){if(J instanceof $e)return J;if(typeof J!="string")return null;var x=J.match(l[v]);return x==null?null:ce((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,w(1))},function(be,e){var w,F,C=be.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function l(t){if(w===setTimeout)return setTimeout(t,0);if((w===L||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:L}catch{w=L}try{F=typeof clearTimeout=="function"?clearTimeout:A}catch{F=A}})();var S,f=[],P=!1,D=-1;function u(){P&&S&&(P=!1,S.length?f=S.concat(f):D=-1,f.length&&p())}function p(){if(!P){var t=l(u);P=!0;for(var i=f.length;i;){for(S=f,f=[];++D<i;)S&&S[D].run();D=-1,i=f.length}S=null,P=!1,function(c){if(F===clearTimeout)return clearTimeout(c);if((F===A||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(c);try{F(c)}catch{try{return F.call(null,c)}catch{return F.call(this,c)}}}(t)}}function $(t,i){this.fun=t,this.array=i}function h(){}C.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)i[c-1]=arguments[c];f.push(new $(t,i)),f.length!==1||P||l(p)},$.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=h,C.addListener=h,C.once=h,C.off=h,C.removeListener=h,C.removeAllListeners=h,C.emit=h,C.prependListener=h,C.prependOnceListener=h,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[119],Re([1,0,9,6]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=void 0;function C(k){const b=k;return b?typeof b.read=="function":!1}e.$pd=C;function L(k){const b=k;return b?[b.on,b.pause,b.resume,b.destroy].every(n=>typeof n=="function"):!1}e.$qd=L;function A(k){const b=k;return b?L(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.$rd=A;function l(k,b){return new S(k,b)}e.$sd=l;class S{constructor(b,n){this.e=b,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(n=>n(b))}h(b){this.c.error.length===0?(0,w.$Y)(b):this.c.error.slice(0).forEach(n=>n(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,n){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(b,n){if(this.a.destroyed)return;let a;switch(b){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const s=a.indexOf(n);s>=0&&a.splice(s,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(k,b){const n=[];let a;for(;(a=k.read())!==null;)n.push(a);return b(n)}e.$td=f;function P(k,b,n){const a=[];let s;for(;(s=k.read())!==null&&a.length<n;)a.push(s);return s===null&&a.length>0?b(a):{read:()=>{if(a.length>0)return a.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return k.read()}}}e.$ud=P;function D(k,b){return new Promise((n,a)=>{const s=[];u(k,{onData:o=>{b&&s.push(o)},onError:o=>{b?a(o):n(void 0)},onEnd:()=>{n(b?b(s):void 0)}})})}e.$vd=D;function u(k,b,n){k.on("error",a=>{n?.isCancellationRequested||b.onError(a)}),k.on("end",()=>{n?.isCancellationRequested||b.onEnd()}),k.on("data",a=>{n?.isCancellationRequested||b.onData(a)})}e.$wd=u;function p(k,b){return new Promise((n,a)=>{const s=new F.$ic,o=[],y=E=>{if(o.push(E),o.length>b)return s.dispose(),k.pause(),n({stream:k,buffer:o,ended:!1})},m=E=>(s.dispose(),a(E)),I=()=>(s.dispose(),n({stream:k,buffer:o,ended:!0}));s.add((0,F.$hc)(()=>k.removeListener("error",m))),k.on("error",m),s.add((0,F.$hc)(()=>k.removeListener("end",I))),k.on("end",I),s.add((0,F.$hc)(()=>k.removeListener("data",y))),k.on("data",y)})}e.$xd=p;function $(k,b){const n=l(b);return n.end(k),n}e.$yd=$;function h(){const k=l(()=>{throw new Error("not supported")});return k.end(),k}e.$zd=h;function t(k){let b=!1;return{read:()=>b?null:(b=!0,k)}}e.$Ad=t;function i(k,b,n){const a=l(n);return u(k,{onData:s=>a.write(b.data(s)),onError:s=>a.error(b.error?b.error(s):s),onEnd:()=>a.end()}),a}e.$Bd=i;function c(k,b,n){let a=!1;return{read:()=>{const s=b.read();return a?s:(a=!0,s!==null?n([k,s]):k)}}}e.$Cd=c;function g(k,b,n){let a=!1;const s=l(n);return u(b,{onData:o=>a?s.write(o):(a=!0,s.write(n([k,o]))),onError:o=>s.error(o),onEnd:()=>{a||(a=!0,s.write(k)),s.end()}}),s}e.$Dd=g}),define(Ae[25],Re([1,0,65,119]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=void 0;const C=typeof Buffer<"u",L=new w.$T(()=>new Uint8Array(256));let A,l;class S{static alloc(v){return C?new S(Buffer.allocUnsafe(v)):new S(new Uint8Array(v))}static wrap(v){return C&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new S(v)}static fromString(v,R){return!(R?.dontUseNodeBuffer||!1)&&C?new S(Buffer.from(v)):(A||(A=new TextEncoder),new S(A.encode(v)))}static fromByteArray(v){const R=S.alloc(v.length);for(let B=0,V=v.length;B<V;B++)R.buffer[B]=v[B];return R}static concat(v,R){if(typeof R>"u"){R=0;for(let j=0,W=v.length;j<W;j++)R+=v[j].byteLength}const B=S.alloc(R);let V=0;for(let j=0,W=v.length;j<W;j++){const O=v[j];B.set(O,V),V+=O.byteLength}return B}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=S.alloc(this.byteLength);return v.set(this),v}toString(){return C?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(v,R){return new S(this.buffer.subarray(v,R))}set(v,R){if(v instanceof S)this.buffer.set(v.buffer,R);else if(v instanceof Uint8Array)this.buffer.set(v,R);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),R);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return u(this.buffer,v)}writeUInt32BE(v,R){p(this.buffer,v,R)}readUInt32LE(v){return $(this.buffer,v)}writeUInt32LE(v,R){h(this.buffer,v,R)}readUInt8(v){return t(this.buffer,v)}writeUInt8(v,R){i(this.buffer,v,R)}indexOf(v,R=0){return f(this.buffer,v instanceof S?v.buffer:v,R)}}e.$Ed=S;function f(d,v,R=0){const B=v.byteLength,V=d.byteLength;if(B===0)return 0;if(B===1)return d.indexOf(v[0]);if(B>V-R)return-1;const j=L.value;j.fill(v.length);for(let ee=0;ee<v.length;ee++)j[v[ee]]=v.length-ee-1;let W=R+v.length-1,O=W,z=-1;for(;W<V;)if(d[W]===v[O]){if(O===0){z=W;break}W--,O--}else W+=Math.max(v.length-O,j[d[W]]),O=v.length-1;return z}e.$Fd=f;function P(d,v){return d[v+0]<<0>>>0|d[v+1]<<8>>>0}e.$Gd=P;function D(d,v,R){d[R+0]=v&255,v=v>>>8,d[R+1]=v&255}e.$Hd=D;function u(d,v){return d[v]*2**24+d[v+1]*2**16+d[v+2]*2**8+d[v+3]}e.$Id=u;function p(d,v,R){d[R+3]=v,v=v>>>8,d[R+2]=v,v=v>>>8,d[R+1]=v,v=v>>>8,d[R]=v}e.$Jd=p;function $(d,v){return d[v+0]<<0>>>0|d[v+1]<<8>>>0|d[v+2]<<16>>>0|d[v+3]<<24>>>0}e.$Kd=$;function h(d,v,R){d[R+0]=v&255,v=v>>>8,d[R+1]=v&255,v=v>>>8,d[R+2]=v&255,v=v>>>8,d[R+3]=v&255}e.$Ld=h;function t(d,v){return d[v]}e.$Md=t;function i(d,v,R){d[R]=v}e.$Nd=i;function c(d){return F.$td(d,v=>S.concat(v))}e.$Od=c;function g(d){return F.$Ad(d)}e.$Pd=g;function k(d){return F.$vd(d,v=>S.concat(v))}e.$Qd=k;async function b(d){return d.ended?S.concat(d.buffer):S.concat([...d.buffer,await k(d.stream)])}e.$Rd=b;function n(d){return F.$yd(d,v=>S.concat(v))}e.$Sd=n;function a(d){return F.$Bd(d,{data:v=>typeof v=="string"?S.fromString(v):S.wrap(v)},v=>S.concat(v))}e.$Td=a;function s(d){return F.$sd(v=>S.concat(v),d)}e.$Ud=s;function o(d,v){return F.$Cd(d,v,R=>S.concat(R))}e.$Vd=o;function y(d,v){return F.$Dd(d,v,R=>S.concat(R))}e.$Wd=y;function m(d){let v=0,R=0,B=0;const V=new Uint8Array(Math.floor(d.length/4*3)),j=O=>{switch(R){case 3:V[B++]=v|O,R=0;break;case 2:V[B++]=v|O>>>2,v=O<<6,R=3;break;case 1:V[B++]=v|O>>>4,v=O<<4,R=2;break;default:v=O<<2,R=1}};for(let O=0;O<d.length;O++){const z=d.charCodeAt(O);if(z>=65&&z<=90)j(z-65);else if(z>=97&&z<=122)j(z-97+26);else if(z>=48&&z<=57)j(z-48+52);else if(z===43||z===45)j(62);else if(z===47||z===95)j(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${d[O]}`)}}const W=B;for(;R>0;)j(0);return S.wrap(V).slice(0,W)}e.$Xd=m;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function r({buffer:d},v=!0,R=!1){const B=R?E:I;let V="";const j=d.byteLength%3;let W=0;for(;W<d.byteLength-j;W+=3){const O=d[W+0],z=d[W+1],ee=d[W+2];V+=B[O>>>2],V+=B[(O<<4|z>>>4)&63],V+=B[(z<<2|ee>>>6)&63],V+=B[ee&63]}if(j===1){const O=d[W+0];V+=B[O>>>2],V+=B[O<<4&63],v&&(V+="==")}else if(j===2){const O=d[W+0],z=d[W+1];V+=B[O>>>2],V+=B[(O<<4|z>>>4)&63],V+=B[z<<2&63],v&&(V+="=")}return V}e.$Yd=r}),define(Ae[120],Re([1,0,28,15]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.FuzzyScore=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.or=void 0;function C(...se){return function(oe,fe){for(let Ie=0,M=se.length;Ie<M;Ie++){const K=se[Ie](oe,fe);if(K)return K}return null}}e.or=C,e.$wj=L.bind(void 0,!1),e.$xj=L.bind(void 0,!0);function L(se,oe,fe){if(!fe||fe.length<oe.length)return null;let Ie;return se?Ie=F.$Me(fe,oe):Ie=fe.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function A(se,oe){const fe=oe.toLowerCase().indexOf(se.toLowerCase());return fe===-1?null:[{start:fe,end:fe+se.length}]}e.$yj=A;function l(se,oe){return S(se.toLowerCase(),oe.toLowerCase(),0,0)}e.$zj=l;function S(se,oe,fe,Ie){if(fe===se.length)return[];if(Ie===oe.length)return null;if(se[fe]===oe[Ie]){let M=null;return(M=S(se,oe,fe+1,Ie+1))?i({start:Ie,end:Ie+1},M):null}return S(se,oe,fe,Ie+1)}function f(se){return 97<=se&&se<=122}function P(se){return 65<=se&&se<=90}e.$Aj=P;function D(se){return 48<=se&&se<=57}function u(se){return se===32||se===9||se===10||se===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>p.add(se.charCodeAt(0)));function $(se){return u(se)||p.has(se)}function h(se,oe){return se===oe||$(se)&&$(oe)}function t(se){return f(se)||P(se)||D(se)}function i(se,oe){return oe.length===0?oe=[se]:se.end===oe[0].start?oe[0].start=se.start:oe.unshift(se),oe}function c(se,oe){for(let fe=oe;fe<se.length;fe++){const Ie=se.charCodeAt(fe);if(P(Ie)||D(Ie)||fe>0&&!t(se.charCodeAt(fe-1)))return fe}return se.length}function g(se,oe,fe,Ie){if(fe===se.length)return[];if(Ie===oe.length)return null;if(se[fe]!==oe[Ie].toLowerCase())return null;{let M=null,K=Ie+1;for(M=g(se,oe,fe+1,Ie+1);!M&&(K=c(oe,K))<oe.length;)M=g(se,oe,fe+1,K),K++;return M===null?null:i({start:Ie,end:Ie+1},M)}}function k(se){let oe=0,fe=0,Ie=0,M=0,K=0;for(let ae=0;ae<se.length;ae++)K=se.charCodeAt(ae),P(K)&&oe++,f(K)&&fe++,t(K)&&Ie++,D(K)&&M++;const G=oe/se.length,Y=fe/se.length,J=Ie/se.length,x=M/se.length;return{upperPercent:G,lowerPercent:Y,alphaPercent:J,numericPercent:x}}function b(se){const{upperPercent:oe,lowerPercent:fe}=se;return fe===0&&oe>.6}function n(se){const{upperPercent:oe,lowerPercent:fe,alphaPercent:Ie,numericPercent:M}=se;return fe>.2&&oe<.8&&Ie>.6&&M<.2}function a(se){let oe=0,fe=0,Ie=0,M=0;for(let K=0;K<se.length;K++)Ie=se.charCodeAt(K),P(Ie)&&oe++,f(Ie)&&fe++,u(Ie)&&M++;return(oe===0||fe===0)&&M===0?se.length<=30:oe<=5}function s(se,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!a(se)||oe.length>60)return null;const fe=k(oe);if(!n(fe)){if(!b(fe))return null;oe=oe.toLowerCase()}let Ie=null,M=0;for(se=se.toLowerCase();M<oe.length&&(Ie=g(se,oe,0,M))===null;)M=c(oe,M+1);return Ie}e.$Bj=s;function o(se,oe,fe=!1){if(!oe||oe.length===0)return null;let Ie=null,M=0;for(se=se.toLowerCase(),oe=oe.toLowerCase();M<oe.length&&(Ie=y(se,oe,0,M,fe))===null;)M=m(oe,M+1);return Ie}e.$Cj=o;function y(se,oe,fe,Ie,M){if(fe===se.length)return[];if(Ie===oe.length)return null;if(h(se.charCodeAt(fe),oe.charCodeAt(Ie))){let K=null,G=Ie+1;if(K=y(se,oe,fe+1,Ie+1,M),!M)for(;!K&&(G=m(oe,G))<oe.length;)K=y(se,oe,fe+1,G,M),G++;return K?se.charCodeAt(fe)!==oe.charCodeAt(Ie)?K:i({start:Ie,end:Ie+1},K):null}else return null}function m(se,oe){for(let fe=oe;fe<se.length;fe++)if($(se.charCodeAt(fe))||fe>0&&$(se.charCodeAt(fe-1)))return fe;return se.length}const I=C(e.$xj,s,A),E=C(e.$xj,s,l),r=new w.$Bi(1e4);function d(se,oe,fe=!1){if(typeof se!="string"||typeof oe!="string")return null;let Ie=r.get(se);Ie||(Ie=new RegExp(F.$ve(se),"i"),r.set(se,Ie));const M=Ie.exec(oe);return M?[{start:M.index,end:M.index+M[0].length}]:fe?E(se,oe):I(se,oe)}e.$Dj=d;function v(se,oe){const fe=le(se,se.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return fe?B(fe):null}e.$Ej=v;function R(se,oe,fe,Ie,M,K){const G=Math.min(13,se.length);for(;fe<G;fe++){const Y=le(se,oe,fe,Ie,M,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Y)return Y}return[0,K]}e.$Fj=R;function B(se){if(typeof se>"u")return[];const oe=[],fe=se[1];for(let Ie=se.length-1;Ie>1;Ie--){const M=se[Ie]+fe,K=oe[oe.length-1];K&&K.end===M?K.end=M+1:oe.push({start:M,end:M+1})}return oe}e.$Gj=B;const V=128;function j(){const se=[],oe=[];for(let fe=0;fe<=V;fe++)oe[fe]=0;for(let fe=0;fe<=V;fe++)se.push(oe.slice(0));return se}function W(se){const oe=[];for(let fe=0;fe<=se;fe++)oe[fe]=0;return oe}const O=W(2*V),z=W(2*V),ee=j(),X=j(),Ee=j(),ke=!1;function Pe(se,oe,fe,Ie,M){function K(Y,J,x=" "){for(;Y.length<J;)Y=x+Y;return Y}let G=` |   |${Ie.split("").map(Y=>K(Y,3)).join("|")}
`;for(let Y=0;Y<=fe;Y++)Y===0?G+=" |":G+=`${oe[Y-1]}|`,G+=se[Y].slice(0,M+1).map(J=>K(J.toString(),3)).join("|")+`
`;return G}function Z(se,oe,fe,Ie){se=se.substr(oe),fe=fe.substr(Ie),console.log(Pe(X,se,se.length,fe,fe.length)),console.log(Pe(Ee,se,se.length,fe,fe.length)),console.log(Pe(ee,se,se.length,fe,fe.length))}function ue(se,oe){if(oe<0||oe>=se.length)return!1;const fe=se.codePointAt(oe);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$5e(fe)}}function ye(se,oe){if(oe<0||oe>=se.length)return!1;switch(se.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ce(se,oe,fe){return oe[se]!==fe[se]}function $e(se,oe,fe,Ie,M,K,G=!1){for(;oe<fe&&M<K;)se[oe]===Ie[M]&&(G&&(O[oe]=M),oe+=1),M+=1;return oe===fe}e.$Hj=$e;var ie;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var N;(function(se){se.Default=[-100,0];function oe(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}se.isDefault=oe})(N||(e.FuzzyScore=N={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,fe){this.firstMatchCanBeWeak=oe,this.boostFullMatch=fe}}e.$Ij=q;function le(se,oe,fe,Ie,M,K,G=q.default){const Y=se.length>V?V:se.length,J=Ie.length>V?V:Ie.length;if(fe>=Y||K>=J||Y-fe>J-K||!$e(oe,fe,Y,M,K,J,!0))return;we(Y,J,fe,K,oe,M);let x=1,ae=1,Le=fe,Ue=K;const Ye=[!1];for(x=1,Le=fe;Le<Y;x++,Le++){const it=O[Le],tt=z[Le],Ne=Le+1<Y?z[Le+1]:J;for(ae=it-K+1,Ue=it;Ue<Ne;ae++,Ue++){let st=Number.MIN_SAFE_INTEGER,_=!1;Ue<=tt&&(st=ve(se,oe,Le,fe,Ie,M,Ue,J,K,ee[x-1][ae-1]===0,Ye));let Q=0;st!==Number.MAX_SAFE_INTEGER&&(_=!0,Q=st+X[x-1][ae-1]);const pe=Ue>it,je=pe?X[x][ae-1]+(ee[x][ae-1]>0?-5:0):0,ze=Ue>it+1&&ee[x][ae-1]>0,Qe=ze?X[x][ae-2]+(ee[x][ae-2]>0?-5:0):0;if(ze&&(!pe||Qe>=je)&&(!_||Qe>=Q))X[x][ae]=Qe,Ee[x][ae]=3,ee[x][ae]=0;else if(pe&&(!_||je>=Q))X[x][ae]=je,Ee[x][ae]=2,ee[x][ae]=0;else if(_)X[x][ae]=Q,Ee[x][ae]=1,ee[x][ae]=ee[x-1][ae-1]+1;else throw new Error("not possible")}}if(ke&&Z(se,fe,Ie,K),!Ye[0]&&!G.firstMatchCanBeWeak)return;x--,ae--;const He=[X[x][ae],K];let et=0,Ze=0;for(;x>=1;){let it=ae;do{const tt=Ee[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);et>1&&oe[fe+x-1]===M[K+ae-1]&&!ce(it+K-1,Ie,M)&&et+1>ee[x][it]&&(it=ae),it===ae?et++:et=1,Ze||(Ze=it),x--,ae=it-1,He.push(ae)}J===Y&&G.boostFullMatch&&(He[0]+=2);const _e=Ze-Y;return He[0]-=_e,He}e.$Jj=le;function we(se,oe,fe,Ie,M,K){let G=se-1,Y=oe-1;for(;G>=fe&&Y>=Ie;)M[G]===K[Y]&&(z[G]=Y,G--),Y--}function ve(se,oe,fe,Ie,M,K,G,Y,J,x,ae){if(oe[fe]!==K[G])return Number.MIN_SAFE_INTEGER;let Le=1,Ue=!1;return G===fe-Ie?Le=se[fe]===M[G]?7:5:ce(G,M,K)&&(G===0||!ce(G-1,M,K))?(Le=se[fe]===M[G]?7:5,Ue=!0):ue(K,G)&&(G===0||!ue(K,G-1))?Le=5:(ue(K,G-1)||ye(K,G-1))&&(Le=5,Ue=!0),Le>1&&fe===Ie&&(ae[0]=!0),Ue||(Ue=ce(G,M,K)||ue(K,G-1)||ye(K,G-1)),fe===Ie?G>J&&(Le-=Ue?3:5):x?Le+=Ue?2:0:Le+=Ue?0:1,G+1===Y&&(Le-=Ue?3:5),Le}function me(se,oe,fe,Ie,M,K,G){return ne(se,oe,fe,Ie,M,K,!0,G)}e.$Kj=me;function De(se,oe,fe,Ie,M,K,G){return ne(se,oe,fe,Ie,M,K,!1,G)}e.$Lj=De;function ne(se,oe,fe,Ie,M,K,G,Y){let J=le(se,oe,fe,Ie,M,K,Y);if(J&&!G)return J;if(se.length>=3){const x=Math.min(7,se.length-1);for(let ae=fe+1;ae<x;ae++){const Le=he(se,ae);if(Le){const Ue=le(Le,Le.toLowerCase(),fe,Ie,M,K,Y);Ue&&(Ue[0]-=3,(!J||Ue[0]>J[0])&&(J=Ue))}}}return J}function he(se,oe){if(oe+1>=se.length)return;const fe=se[oe],Ie=se[oe+1];if(fe!==Ie)return se.slice(0,oe)+Ie+fe+se.slice(oe+2)}}),define(Ae[29],Re([1,0,15]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(F||(F={})),function(C){const L="error",A="warning",l="warn",S="info",f="ignore";function P(u){return u?w.$Le(L,u)?C.Error:w.$Le(A,u)||w.$Le(l,u)?C.Warning:w.$Le(S,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=P;function D(u){switch(u){case C.Error:return L;case C.Warning:return A;case C.Info:return S;default:return f}}C.toString=D}(F||(F={})),e.default=F}),define(Ae[121],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$bd=Symbol("MicrotaskDelay")}),define(Ae[48],Re([1,0,18,15]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const $=p.charCodeAt(0),h=this.b.charCodeAt(this.c);return $-h}value(){return this.b[this.c]}}e.$Ch=C;class L{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,F.$Fe)(p,this.b,0,p.length,this.c,this.d):(0,F.$He)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Dh=L;class A{constructor(p=!0,$=!0){this.f=p,this.g=$}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let $=p.length-1;$>=0;$--,this.c--){const h=this.b.charCodeAt($);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,F.$Fe)(p,this.b,0,p.length,this.d,this.e):(0,F.$He)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Eh=A;var l;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(l||(l={}));class S{constructor(p,$){this.f=p,this.g=$,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,F.$Ge)(p,this.c.scheme);if(this.d[this.e]===2)return(0,F.$Ge)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,F.$Ee)(p,this.c.query);if(this.d[this.e]===5)return(0,F.$Ee)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fh=S;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(P||(P={}));class D{static forUris(p=()=>!1,$=()=>!1){return new D(new S(p,$))}static forPaths(p=!1){return new D(new A(void 0,!p))}static forStrings(){return new D(new C)}static forConfigKeys(){return new D(new L)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,$){if($){const h=$.slice(0);(0,w.$Ub)(h);for(const t of h)this.set(t,p)}else{const h=p.slice(0);(0,w.$Ub)(h);for(const t of h)this.set(t[0],t[1])}}set(p,$){const h=this.b.reset(p);let t;this.c||(this.c=new f,this.c.segment=h.value());const i=[];for(t=this.c;;){const g=h.cmp(t.segment);if(g>0)t.left||(t.left=new f,t.left.segment=h.value()),i.push([-1,t]),t=t.left;else if(g<0)t.right||(t.right=new f,t.right.segment=h.value()),i.push([1,t]),t=t.right;else if(h.hasNext())h.next(),t.mid||(t.mid=new f,t.mid.segment=h.value()),i.push([0,t]),t=t.mid;else break}const c=t.value;t.value=$,t.key=p;for(let g=i.length-1;g>=0;g--){const k=i[g][1];k.updateHeight();const b=k.balanceFactor();if(b<-1||b>1){const n=i[g][0],a=i[g+1][0];if(n===1&&a===1)i[g][1]=k.rotateLeft();else if(n===-1&&a===-1)i[g][1]=k.rotateRight();else if(n===1&&a===-1)k.right=i[g+1][1]=i[g+1][1].rotateRight(),i[g][1]=k.rotateLeft();else if(n===-1&&a===1)k.left=i[g+1][1]=i[g+1][1].rotateLeft(),i[g][1]=k.rotateRight();else throw new Error;if(g>0)switch(i[g-1][0]){case-1:i[g-1][1].left=i[g][1];break;case 1:i[g-1][1].right=i[g][1];break;case 0:i[g-1][1].mid=i[g][1];break}else this.c=i[0][1]}}return c}get(p){return this.d(p)?.value}d(p){const $=this.b.reset(p);let h=this.c;for(;h;){const t=$.cmp(h.segment);if(t>0)h=h.left;else if(t<0)h=h.right;else if($.hasNext())$.next(),h=h.mid;else break}return h}has(p){const $=this.d(p);return!($?.value===void 0&&$?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,$){const h=this.b.reset(p),t=[];let i=this.c;for(;i;){const c=h.cmp(i.segment);if(c>0)t.push([-1,i]),i=i.left;else if(c<0)t.push([1,i]),i=i.right;else if(h.hasNext())h.next(),t.push([0,i]),i=i.mid;else break}if(i){if($?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const c=this.f(i.right);if(c.key){const{key:g,value:k,segment:b}=c;this.e(c.key,!1),i.key=g,i.value=k,i.segment=b}}else{const c=i.left??i.right;if(t.length>0){const[g,k]=t[t.length-1];switch(g){case-1:k.left=c;break;case 0:k.mid=c;break;case 1:k.right=c;break}}else this.c=c}for(let c=t.length-1;c>=0;c--){const g=t[c][1];g.updateHeight();const k=g.balanceFactor();if(k>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),t[c][1]=g.rotateLeft()):k<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),t[c][1]=g.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this.c=t[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const $=this.b.reset(p);let h=this.c,t;for(;h;){const i=$.cmp(h.segment);if(i>0)h=h.left;else if(i<0)h=h.right;else if($.hasNext())$.next(),t=h.value||t,h=h.mid;else break}return h&&h.value||t}findSuperstr(p){return this.g(p,!1)}g(p,$){const h=this.b.reset(p);let t=this.c;for(;t;){const i=h.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(h.hasNext())h.next(),t=t.mid;else return t.mid?this.h(t.mid):$?t.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[$,h]of this)p(h,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const $=[];return this.j(p,$),$[Symbol.iterator]()}j(p,$){p&&(p.left&&this.j(p.left,$),p.value&&$.push([p.key,p.value]),p.mid&&this.j(p.mid,$),p.right&&this.j(p.right,$))}_isBalanced(){const p=$=>{if(!$)return!0;const h=$.balanceFactor();return h<-1||h>1?!1:p($.left)&&p($.right)};return p(this.c)}}e.$Gh=D}),define(Ae[40],Re([1,0,89]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Pj=e.ThemeColor=void 0;var F;(function(A){function l(S){return S&&typeof S=="object"&&typeof S.id=="string"}A.isThemeColor=l})(F||(e.ThemeColor=F={}));function C(A){return{id:A}}e.$Pj=C;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const l=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function S(c){const g=l.exec(c.id);if(!g)return S(w.$Oj.error);const[,k,b]=g,n=["codicon","codicon-"+k];return b&&n.push("codicon-modifier-"+b.substring(1)),n}A.asClassNameArray=S;function f(c){return S(c).join(" ")}A.asClassName=f;function P(c){return"."+S(c).join(".")}A.asCSSSelector=P;function D(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||F.isThemeColor(c.color))}A.isThemeIcon=D;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function p(c){const g=u.exec(c);if(!g)return;const[,k]=g;return{id:k}}A.fromString=p;function $(c){return{id:c}}A.fromId=$;function h(c,g){let k=c.id;const b=k.lastIndexOf("~");return b!==-1&&(k=k.substring(0,b)),g&&(k=`${k}~${g}`),{id:k}}A.modify=h;function t(c){const g=c.id.lastIndexOf("~");if(g!==-1)return c.id.substring(g+1)}A.getModifier=t;function i(c,g){return c.id===g.id&&c.color?.id===g.color?.id}A.isEqual=i})(L||(e.ThemeIcon=L={}))}),define(Ae[122],Re([1,0,120,15,40]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=void 0;const L="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),l=new RegExp(`(\\\\)?${A.source}`,"g");function S(i){return i.replace(l,(c,g)=>g?c:`\\${c}`)}e.$Qj=S;const f=new RegExp(`\\\\${A.source}`,"g");function P(i){return i.replace(f,c=>`\\${c}`)}e.$Rj=P;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(i){return i.indexOf(L)===-1?i:i.replace(D,(c,g,k,b)=>k?c:g||b||"")}e.$Sj=u;function p(i){return i?i.replace(/\$\((.*?)\)/g,(c,g)=>` ${g} `).trim():""}e.$Tj=p;const $=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(i){$.lastIndex=0;let c="";const g=[];let k=0;for(;;){const b=$.lastIndex,n=$.exec(i),a=i.substring(b,n?.index);if(a.length>0){c+=a;for(let s=0;s<a.length;s++)g.push(k)}if(!n)break;k+=n[0].length}return{text:c,iconOffsets:g}}e.$Uj=h;function t(i,c,g=!1){const{text:k,iconOffsets:b}=c;if(!b||b.length===0)return(0,w.$Dj)(i,k,g);const n=(0,F.$te)(k," "),a=k.length-n.length,s=(0,w.$Dj)(i,n,g);if(s)for(const o of s){const y=b[o.start+a]+a;o.start+=y,o.end+=y}return s}e.$Vj=t}),define(Ae[36],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(C){return w.test(C)}e.$2f=F,e.$3f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(l){for(let S=0;S<l.length;S++)l[S]=Math.floor(Math.random()*256);return l};const L=new Uint8Array(16),A=[];for(let l=0;l<256;l++)A.push(l.toString(16).padStart(2,"0"));return function(){C(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,f="";return f+=A[L[S++]],f+=A[L[S++]],f+=A[L[S++]],f+=A[L[S++]],f+="-",f+=A[L[S++]],f+=A[L[S++]],f+="-",f+=A[L[S++]],f+=A[L[S++]],f+="-",f+=A[L[S++]],f+=A[L[S++]],f+="-",f+=A[L[S++]],f+=A[L[S++]],f+=A[L[S++]],f+=A[L[S++]],f+=A[L[S++]],f+=A[L[S++]],f}}()}),define(Ae[123],Re([1,0,18,66,36]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=e.$Qs=e.$Ps=e.$Os=e.$Ns=void 0;function L(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$Ns=L;function A(D,u,p){const $={id:(0,C.$3f)(),name:D,uri:u,data:p};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$Os=A;class l{constructor(){this.a=new Map}get size(){let u=0;for(const p of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const p=[...this.a.keys()];return F.Iterable.some(this,([$,h])=>h.asFile())&&p.push("files"),P(S(u),p)}get(u){return this.a.get(this.b(u))?.[0]}append(u,p){const $=this.a.get(u);$?$.push(p):this.a.set(this.b(u),[p])}replace(u,p){this.a.set(this.b(u),[p])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,p]of this.a)for(const $ of p)yield[u,$]}b(u){return S(u)}}e.$Ps=l;function S(D){return D.toLowerCase()}function f(D,u){return P(S(D),u.map(S))}e.$Qs=f;function P(D,u){if(D==="*/*")return u.length>0;if(u.includes(D))return!0;const p=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[$,h,t]=p;return t==="*"?u.some(i=>i.startsWith(h+"/")):!1}e.$Rs=Object.freeze({create:D=>(0,w.$Jb)(D.map(u=>u.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Rs.split(D).filter(u=>!u.startsWith("#"))})}),define(Ae[124],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=void 0,e.$Sr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[125],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=e.IndentAction=void 0;var w;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class F{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let S=0,f=l.notIn.length;S<f;S++)switch(l.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(l,S){if(l.getTokenCount()===0)return!0;const f=l.findTokenIndexAtOffset(S-2),P=l.getStandardTokenType(f);return this.isOK(P)}g(l,S){for(let f=l;f<=S;f++){const P=String.fromCharCode(f);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$et=F;class C{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of l)L(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),L(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),L(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),L(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&L(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.$ft=C;function L(A,l,S){A.has(l)?A.get(l).push(S):A.set(l,[S])}}),define(Ae[126],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b7=e.$a7=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$a7=w;class F{constructor(L){this.identifier=L}}e.$b7=F}),define(Ae[127],Re([10,11]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Ae[128],Re([1,0,5,6,127]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=void 0;class L extends F.$jc{constructor(u,p="",$="",h=!0,t){super(),this.h=this.B(new w.$ed),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=p,this.u=$,this.w=h,this.C=t}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,p){this.C&&await this.C(u)}}e.$fi=L;class A extends F.$jc{constructor(){super(...arguments),this.f=this.B(new w.$ed),this.onWillRun=this.f.event,this.m=this.B(new w.$ed),this.onDidRun=this.m.event}async run(u,p){if(!u.enabled)return;this.f.fire({action:u});let $;try{await this.u(u,p)}catch(h){$=h}this.m.fire({action:u,error:$})}async u(u,p){await u.run(p)}}e.$gi=A;class l{constructor(){this.id=l.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let p=[];for(const $ of u)$.length&&(p.length?p=[...p,new l,...$]:p=$);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$hi=l;class S{get actions(){return this.a}constructor(u,p,$,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=p,this.class=h,this.a=$}async run(){}}e.$ii=S;class f extends L{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,C.localize(0,null),void 0,!1)}}e.$ji=f;function P(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...u)=>D.run(),tooltip:D.label}}e.$ki=P}),define(Ae[129],Re([10,11]),function(be,e){return be.create("vs/base/common/date",e)}),define(Ae[130],Re([1,0,129]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=void 0;const F=60,C=F*60,L=C*24,A=L*7,l=L*30,S=L*365;function f(D,u,p,$){typeof D!="number"&&(D=D.getTime());const h=Math.round((new Date().getTime()-D)/1e3);if(h<-30)return(0,w.localize)(0,null,f(new Date().getTime()+h*1e3,!1));if(!$&&h<30)return(0,w.localize)(1,null);let t;return h<F?(t=h,u?t===1?p?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):p?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?p?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):p?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):h<C?(t=Math.floor(h/F),u?t===1?p?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):p?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?p?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):p?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):h<L?(t=Math.floor(h/C),u?t===1?p?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):p?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?p?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):p?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):h<A?(t=Math.floor(h/L),u?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):h<l?(t=Math.floor(h/A),u?t===1?p?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):p?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?p?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):p?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):h<S?(t=Math.floor(h/l),u?t===1?p?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):p?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?p?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):p?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(h/S),u?t===1?p?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):p?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?p?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):p?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.$5l=f;function P(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$6l=P}),define(Ae[131],Re([10,11]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Ae[41],Re([1,0,18,16,131]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=void 0;function L(D,u){return u&&(D.stack||D.stacktrace)?C.localize(0,null,l(D),A(D.stack)||A(D.stacktrace)):l(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function l(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?C.localize(1,null,D.message):D.message||C.localize(2,null)}function S(D=null,u=!1){if(!D)return C.localize(3,null);if(Array.isArray(D)){const p=w.$Eb(D),$=S(p[0],u);return p.length>1?C.localize(4,null,$,p.length):$}if(F.$if(D))return D;if(D.detail){const p=D.detail;if(p.error)return L(p.error,u);if(p.exception)return L(p.exception,u)}return D.stack?L(D,u):D.message?D.message:C.localize(5,null)}e.$li=S;function f(D){const u=D;return u instanceof Error&&Array.isArray(u.actions)}e.$mi=f;function P(D,u){let p;return typeof D=="string"?p=new Error(D):p=D,p.actions=u,p}e.$ni=P}),define(Ae[132],Re([1,0,65,19]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=e.$9p=e.$8p=void 0;const C=new w.$T(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),L=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function l(E,r,d=!1){const v=E||"",R=r||"",B=C.value.collator.compare(v,R);return C.value.collatorIsNumeric&&B===0&&v!==R?v<R?-1:1:B}e.$8p=l;function S(E,r){const d=L.value.collator;return E=E||"",r=r||"",k(d,E,r)}e.$9p=S;function f(E,r){const d=L.value.collator;return E=E||"",r=r||"",s(E,r)||k(d,E,r)}e.$0p=f;function P(E,r){const d=L.value.collator;return E=E||"",r=r||"",a(E,r)||k(d,E,r)}e.$$p=P;function D(E,r){return E=E||"",r=r||"",E===r?0:E<r?-1:1}e.$_p=D;function u(E,r){const[d,v]=c(E),[R,B]=c(r);let V=C.value.collator.compare(v,B);if(V===0){if(C.value.collatorIsNumeric&&v!==B)return v<B?-1:1;if(V=C.value.collator.compare(d,R),C.value.collatorIsNumeric&&V===0&&d!==R)return d<R?-1:1}return V}e.$aq=u;function p(E,r){E=E||"",r=r||"";const d=g(E),v=g(r),R=L.value.collator,B=A.value.collator;return k(B,d,v)||k(R,E,r)}e.$bq=p;function $(E,r){E=E||"",r=r||"";const d=g(E),v=g(r),R=L.value.collator,B=A.value.collator;return k(B,d,v)||s(E,r)||k(R,E,r)}e.$cq=$;function h(E,r){E=E||"",r=r||"";const d=g(E),v=g(r),R=L.value.collator,B=A.value.collator;return k(B,d,v)||a(E,r)||k(R,E,r)}e.$dq=h;function t(E,r){E=E||"",r=r||"";const d=g(E).toLowerCase(),v=g(r).toLowerCase();return d!==v?d<v?-1:1:E!==r?E<r?-1:1:0}e.$eq=t;const i=/^(.*?)(\.([^.]*))?$/;function c(E,r=!1){const d=E?i.exec(E):[];let v=[d&&d[1]||"",d&&d[3]||""];return r&&(!v[0]&&v[1]||v[0]&&v[0].charAt(0)===".")&&(v=[v[0]+"."+v[1],""]),v}function g(E){const r=E?i.exec(E):[];return r&&r[1]&&r[1].charAt(0)!=="."&&r[3]||""}function k(E,r,d){const v=E.compare(r,d);return v!==0?v:r.length!==d.length?r.length<d.length?-1:1:0}function b(E){const r=E.charAt(0);return r.toLocaleUpperCase()!==r}function n(E){const r=E.charAt(0);return r.toLocaleLowerCase()!==r}function a(E,r){return b(E)&&n(r)?-1:n(E)&&b(r)?1:0}function s(E,r){return n(E)&&b(r)?-1:b(E)&&n(r)?1:0}function o(E,r,d=!1){return d||(E=E&&E.toLowerCase(),r=r&&r.toLowerCase()),E===r?0:E<r?-1:1}function y(E,r,d=!1){const v=E.split(F.sep),R=r.split(F.sep),B=v.length-1,V=R.length-1;let j,W;for(let O=0;;O++){if(j=B===O,W=V===O,j&&W)return l(v[O],R[O],d);if(j)return-1;if(W)return 1;const z=o(v[O],R[O],d);if(z!==0)return z}}e.$fq=y;function m(E,r,d){const v=E.toLowerCase(),R=r.toLowerCase(),B=I(E,r,d);if(B)return B;const V=v.endsWith(d),j=R.endsWith(d);if(V!==j)return V?-1:1;const W=l(v,R);return W!==0?W:v.localeCompare(R)}e.$gq=m;function I(E,r,d){const v=E.toLowerCase(),R=r.toLowerCase(),B=v.startsWith(d),V=R.startsWith(d);if(B!==V)return B?-1:1;if(B&&V){if(v.length<R.length)return-1;if(v.length>R.length)return 1}return 0}e.$hq=I}),define(Ae[42],Re([1,0,19,22,15,16]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=void 0;function A(m){return m===47||m===92}e.$Af=A;function l(m){return m.replace(/[\\/]/g,w.$5d.sep)}e.$Bf=l;function S(m){return m.indexOf("/")===-1&&(m=l(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}e.$Cf=S;function f(m,I=w.$5d.sep){if(!m)return"";const E=m.length,r=m.charCodeAt(0);if(A(r)){if(A(m.charCodeAt(1))&&!A(m.charCodeAt(2))){let v=3;const R=v;for(;v<E&&!A(m.charCodeAt(v));v++);if(R!==v&&!A(m.charCodeAt(v+1))){for(v+=1;v<E;v++)if(A(m.charCodeAt(v)))return m.slice(0,v+1).replace(/[\\/]/g,I)}}return I}else if(i(r)&&m.charCodeAt(1)===58)return A(m.charCodeAt(2))?m.slice(0,2)+I:m.slice(0,2);let d=m.indexOf("://");if(d!==-1){for(d+=3;d<E;d++)if(A(m.charCodeAt(d)))return m.slice(0,d+1)}return""}e.$Df=f;function P(m){if(!F.$i||!m||m.length<5)return!1;let I=m.charCodeAt(0);if(I!==92||(I=m.charCodeAt(1),I!==92))return!1;let E=2;const r=E;for(;E<m.length&&(I=m.charCodeAt(E),I!==92);E++);return!(r===E||(I=m.charCodeAt(E+1),isNaN(I)||I===92))}e.$Ef=P;const D=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(m,I=F.$i){const E=I?D:u;return!(!m||m.length===0||/^\s+$/.test(m)||(E.lastIndex=0,E.test(m))||I&&p.test(m)||m==="."||m===".."||I&&m[m.length-1]==="."||I&&m.length!==m.trim().length||m.length>255)}e.$Ff=$;function h(m,I,E){const r=m===I;return!E||r?r:!m||!I?!1:(0,C.$Le)(m,I)}e.$Gf=h;function t(m,I,E,r=w.sep){if(m===I)return!0;if(!m||!I||I.length>m.length)return!1;if(E){if(!(0,C.$Me)(m,I))return!1;if(I.length===m.length)return!0;let v=I.length;return I.charAt(I.length-1)===r&&v--,m.charAt(v)===r}return I.charAt(I.length-1)!==r&&(I+=r),m.indexOf(I)===0}e.$Hf=t;function i(m){return m>=65&&m<=90||m>=97&&m<=122}e.$If=i;function c(m,I){return F.$i&&m.endsWith(":")&&(m+=w.sep),(0,w.$7d)(m)||(m=(0,w.$8d)(I,m)),m=(0,w.$6d)(m),F.$i?(m=(0,C.$ue)(m,w.sep),m.endsWith(":")&&(m+=w.sep)):(m=(0,C.$ue)(m,w.sep),m||(m=w.sep)),m}e.$Jf=c;function g(m){const I=(0,w.$6d)(m);return F.$i?m.length>3?!1:k(I)&&(m.length===2||I.charCodeAt(2)===92):I===w.$5d.sep}e.$Kf=g;function k(m,I=F.$i){return I?i(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}e.$Lf=k;function b(m,I=F.$i){return k(m,I)?m[0]:void 0}e.$Mf=b;function n(m,I,E){return I.length>m.length?-1:m===I?0:(E&&(m=m.toLowerCase(),I=I.toLowerCase()),m.indexOf(I))}e.$Nf=n;function a(m){const I=m.split(":");let E,r,d;for(const v of I){const R=Number(v);(0,L.$mf)(R)?r===void 0?r=R:d===void 0&&(d=R):E=E?[E,v].join(":"):v}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:r!==void 0?r:void 0,column:d!==void 0?d:r!==void 0?1:void 0}}e.$Of=a;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y(m,I,E=8){let r="";for(let v=0;v<E;v++){let R;v===0&&F.$i&&!I&&(E===3||E===4)?R=o:R=s,r+=R.charAt(Math.floor(Math.random()*R.length))}let d;return I?d=`${I}-${r}`:d=r,m?(0,w.$8d)(m,d):d}e.$Pf=y}),define(Ae[67],Re([1,0,19]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=e.$Hr=e.$Gr=e.$Fr=void 0,e.$Fr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const D=(0,w.$ae)(P),u=F[D.toLowerCase()];return u!==void 0?u:A(P)}e.$Gr=L;function A(P){const D=(0,w.$ae)(P);return C[D.toLowerCase()]}e.$Hr=A;function l(P){for(const D in C)if(C[D]===P)return D}e.$Ir=l;const S=/^(.+)\/(.+?)(;.+)?$/;function f(P,D){const u=S.exec(P);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:D?void 0:P}e.$Jr=f}),define(Ae[68],Re([1,0,25,2]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=e.$9g=e.$8g=void 0;function C(S){return JSON.stringify(S,A)}e.$8g=C;function L(S){let f=JSON.parse(S);return f=l(f),f}e.$9g=L;function A(S,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function l(S,f=0){if(!S||f>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return F.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof w.$Ed||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let P=0;P<S.length;++P)S[P]=l(S[P],f+1);else for(const P in S)Object.hasOwnProperty.call(S,P)&&(S[P]=l(S[P],f+1))}return S}e.$0g=l}),define(Ae[12],Re([1,0,9,22,2]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.Schemas=void 0;var L;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$Tf="vscode-tkn",e.$Uf="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${L.vscodeRemoteResource}`}set(P,D,u){this.a[P]=D,this.b[P]=u}setConnectionToken(P,D){this.c[P]=D}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(t){return w.$Y(t),P}const D=P.authority;let u=this.a[D];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const p=this.b[D],$=this.c[D];let h=`path=${encodeURIComponent(P.path)}`;return typeof $=="string"&&(h+=`&${e.$Uf}=${encodeURIComponent($)}`),C.URI.from({scheme:F.$o?this.d:L.vscodeRemoteResource,authority:`${u}:${p}`,path:this.f,query:h})}}e.$Vf=new A,e.$Wf="vs/../../extensions",e.$Xf="vs/../../node_modules",e.$Yf="vs/../../node_modules.asar",e.$Zf="vs/../../node_modules.asar.unpacked";class l{static{this.a="vscode-app"}asBrowserUri(P){const D=this.b(P,be);return this.uriToBrowserUri(D)}uriToBrowserUri(P){return P.scheme===L.vscodeRemote?e.$Vf.rewrite(P):P.scheme===L.file&&(F.$m||F.$p&&F.$g.origin===`${L.vscodeFileResource}://${l.a}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||l.a,query:null,fragment:null}):P}asFileUri(P){const D=this.b(P,be);return this.uriToFileUri(D)}uriToFileUri(P){return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==l.a?P.authority:null,query:null,fragment:null}):P}b(P,D){return C.URI.isUri(P)?P:C.URI.parse(D.toUrl(P))}}e.$1f=new l;var S;(function(f){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(P.get("3"));const D="vscode-coi";function u($){let h;typeof $=="string"?h=new URL($).searchParams:$ instanceof URL?h=$.searchParams:C.URI.isUri($)&&(h=new URL($.toString(!0)).searchParams);const t=h?.get(D);if(t)return P.get(t)}f.getHeadersFromQuery=u;function p($,h,t){if(!globalThis.crossOriginIsolated)return;const i=h&&t?"3":t?"2":"1";$ instanceof URLSearchParams?$.set(D,i):$[D]=i}f.addSearchParam=p})(S||(e.COI=S={}))}),define(Ae[23],Re([1,0,42,12,19,22,15,2]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.DataUri=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=void 0;function S(p){return(0,l.$Sf)(p,!0)}e.$8f=S;class f{constructor($){this.a=$}compare($,h,t=!1){return $===h?0:(0,A.$Ee)(this.getComparisonKey($,t),this.getComparisonKey(h,t))}isEqual($,h,t=!1){return $===h?!0:!$||!h?!1:this.getComparisonKey($,t)===this.getComparisonKey(h,t)}getComparisonKey($,h=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,h,t=!1){if($.scheme===h.scheme){if($.scheme===F.Schemas.file)return w.$Hf(S($),S(h),this.a($))&&$.query===h.query&&(t||$.fragment===h.fragment);if((0,e.$mg)($.authority,h.authority))return w.$Hf($.path,h.path,this.a($),"/")&&$.query===h.query&&(t||$.fragment===h.fragment)}return!1}joinPath($,...h){return l.URI.joinPath($,...h)}basenameOrAuthority($){return(0,e.$eg)($)||$.authority}basename($){return C.$5d.basename($.path)}extname($){return C.$5d.extname($.path)}dirname($){if($.path.length===0)return $;let h;return $.scheme===F.Schemas.file?h=l.URI.file(C.$$d(S($))).path:(h=C.$5d.dirname($.path),$.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),h="/")),$.with({path:h})}normalizePath($){if(!$.path.length)return $;let h;return $.scheme===F.Schemas.file?h=l.URI.file(C.$6d(S($))).path:h=C.$5d.normalize($.path),$.with({path:h})}relativePath($,h){if($.scheme!==h.scheme||!(0,e.$mg)($.authority,h.authority))return;if($.scheme===F.Schemas.file){const c=C.$0d(S($),S(h));return L.$i?w.$Bf(c):c}let t=$.path||"/";const i=h.path||"/";if(this.a($)){let c=0;for(const g=Math.min(t.length,i.length);c<g&&!(t.charCodeAt(c)!==i.charCodeAt(c)&&t.charAt(c).toLowerCase()!==i.charAt(c).toLowerCase());c++);t=i.substr(0,c)+t.substr(c)}return C.$5d.relative(t,i)}resolvePath($,h){if($.scheme===F.Schemas.file){const t=l.URI.file(C.$9d(S($),h));return $.with({authority:t.authority,path:t.path})}return h=w.$Cf(h),$.with({path:C.$5d.resolve($.path,h)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,h){return $===h||$!==void 0&&h!==void 0&&(0,A.$Le)($,h)}hasTrailingPathSeparator($,h=C.sep){if($.scheme===F.Schemas.file){const t=S($);return t.length>w.$Df(t).length&&t[t.length-1]===h}else{const t=$.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,h=C.sep){return(0,e.$ng)($,h)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,h=C.sep){let t=!1;if($.scheme===F.Schemas.file){const i=S($);t=i!==void 0&&i.length===w.$Df(i).length&&i[i.length-1]===h}else{h="/";const i=$.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$ng)($,h)?$.with({path:$.path+"/"}):$}}e.$9f=f,e.$0f=new f(()=>!1),e.$$f=new f(p=>p.scheme===F.Schemas.file?!L.$k:!0),e.$_f=new f(p=>!0),e.$ag=e.$0f.isEqual.bind(e.$0f),e.$bg=e.$0f.isEqualOrParent.bind(e.$0f),e.$cg=e.$0f.getComparisonKey.bind(e.$0f),e.$dg=e.$0f.basenameOrAuthority.bind(e.$0f),e.$eg=e.$0f.basename.bind(e.$0f),e.$fg=e.$0f.extname.bind(e.$0f),e.$gg=e.$0f.dirname.bind(e.$0f),e.$hg=e.$0f.joinPath.bind(e.$0f),e.$ig=e.$0f.normalizePath.bind(e.$0f),e.$jg=e.$0f.relativePath.bind(e.$0f),e.$kg=e.$0f.resolvePath.bind(e.$0f),e.$lg=e.$0f.isAbsolutePath.bind(e.$0f),e.$mg=e.$0f.isEqualAuthority.bind(e.$0f),e.$ng=e.$0f.hasTrailingPathSeparator.bind(e.$0f),e.$og=e.$0f.removeTrailingPathSeparator.bind(e.$0f),e.$pg=e.$0f.addTrailingPathSeparator.bind(e.$0f);function P(p,$){const h=[];for(let t=0;t<p.length;t++){const i=$(p[t]);p.some((c,g)=>g===t?!1:(0,e.$bg)(i,$(c)))||h.push(p[t])}return h}e.$qg=P;var D;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function $(h){const t=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(g=>{const[k,b]=g.split(":");k&&b&&t.set(k,b)});const c=h.path.substring(0,h.path.indexOf(";"));return c&&t.set(p.META_DATA_MIME,c),t}p.parseMetaData=$})(D||(e.DataUri=D={}));function u(p,$,h){if($){let t=p.path;return t&&t[0]!==C.$5d.sep&&(t=C.$5d.sep+t),p.with({scheme:h,authority:$,path:t})}return p.with({scheme:h})}e.$rg=u}),define(Ae[13],Re([1,0,21,9,5,6,23,22,121]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.$3g=e.$2g=e.Promises=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=void 0;function f(N){return!!N&&typeof N.then=="function"}e.$sg=f;function P(N){const q=new w.$od,le=N(q.token),we=new Promise((ve,me)=>{const De=q.token.onCancellationRequested(()=>{De.dispose(),q.dispose(),me(new F.$3)});Promise.resolve(le).then(ne=>{De.dispose(),q.dispose(),ve(ne)},ne=>{De.dispose(),q.dispose(),me(ne)})});return new class{cancel(){q.cancel()}then(ve,me){return we.then(ve,me)}catch(ve){return this.then(void 0,ve)}finally(ve){return we.finally(ve)}}}e.$tg=P;function D(N,q,le){return new Promise((we,ve)=>{const me=q.onCancellationRequested(()=>{me.dispose(),we(le)});N.then(we,ve).finally(()=>me.dispose())})}e.$ug=D;function u(N,q){return new Promise((le,we)=>{const ve=q.onCancellationRequested(()=>{ve.dispose(),we(new F.$3)});N.then(le,we).finally(()=>ve.dispose())})}e.$vg=u;async function p(N){let q=-1;const le=N.map((we,ve)=>we.then(me=>(q=ve,me)));try{return await Promise.race(le)}finally{N.forEach((we,ve)=>{ve!==q&&we.cancel()})}}e.$wg=p;function $(N,q,le){let we;const ve=setTimeout(()=>{we?.(void 0),le?.()},q);return Promise.race([N.finally(()=>clearTimeout(ve)),new Promise(me=>we=me)])}e.$xg=$;function h(N){return new Promise((q,le)=>{const we=N();f(we)?we.then(q,le):q(we)})}e.$yg=h;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const le=()=>{if(this.b=null,this.f)return;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(le,le).then(we)})}return new Promise((le,we)=>{this.b.then(le,we)})}return this.a=q(),new Promise((le,we)=>{this.a.then(ve=>{this.a=null,le(ve)},ve=>{this.a=null,we(ve)})})}dispose(){this.f=!0}}e.$zg=t;class i{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$Ag=i;class c{constructor(){this.a=new Map}queue(q,le){const ve=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(q)===ve&&this.a.delete(q)});return this.a.set(q,ve),ve}}e.$Bg=c;const g=(N,q)=>{let le=!0;const we=setTimeout(()=>{le=!1,q()},N);return{isTriggered:()=>le,dispose:()=>{clearTimeout(we),le=!1}}},k=N=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,N())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class b{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,le=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((ve,me)=>{this.d=ve,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=le===S.$bd?k(we):g(le,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Cg=b;class n{constructor(q){this.a=new b(q),this.b=new t}trigger(q,le){return this.a.trigger(()=>this.b.queue(q),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dg=n;class a{constructor(){this.a=!1,this.b=new Promise((q,le)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eg=a;class s extends a{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Fg=s;function o(N,q){return q?new Promise((le,we)=>{const ve=setTimeout(()=>{me.dispose(),le()},N),me=q.onCancellationRequested(()=>{clearTimeout(ve),me.dispose(),we(new F.$3)})}):P(le=>o(N,le))}e.$Gg=o;function y(N,q=0){const le=setTimeout(N,q);return(0,L.$hc)(()=>clearTimeout(le))}e.$Hg=y;function m(N){const q=[];let le=0;const we=N.length;function ve(){return le<we?N[le++]():null}function me(De){De!=null&&q.push(De);const ne=ve();return ne?ne.then(me):Promise.resolve(q)}return Promise.resolve(null).then(me)}e.$Ig=m;function I(N,q=we=>!!we,le=null){let we=0;const ve=N.length,me=()=>{if(we>=ve)return Promise.resolve(le);const De=N[we++];return Promise.resolve(De()).then(he=>q(he)?Promise.resolve(he):me())};return me()}e.$Jg=I;function E(N,q=we=>!!we,le=null){if(N.length===0)return Promise.resolve(le);let we=N.length;const ve=()=>{we=-1;for(const me of N)me.cancel?.()};return new Promise((me,De)=>{for(const ne of N)ne.then(he=>{--we>=0&&q(he)?(ve(),me(he)):we===0&&me(le)}).catch(he=>{--we>=0&&(ve(),De(he))})})}e.$Kg=E;class r{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new C.$ed}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((le,we)=>{this.f.push({factory:q,c:le,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const le=q.factory();le.then(q.c,q.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Lg=r;class d extends r{constructor(){super(1)}}e.$Mg=d;class v{constructor(){this.a=new Ee,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$Ng=v;class R{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new Z;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,le=A.$0f){const we=le.getComparisonKey(q);let ve=this.a.get(we);if(!ve){ve=new d;const me=this.f++,De=C.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$rc),this.d.set(me,De),this.a.set(we,ve)}return ve}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Og=R;class B{constructor(q,le){this.a=-1,typeof q=="function"&&typeof le=="number"&&this.setIfNotSet(q,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},le)}setIfNotSet(q,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},le))}}e.$Pg=B;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,le){this.cancel(),this.a=setInterval(()=>{q()},le)}}e.$Qg=V;class j{constructor(q,le){this.b=-1,this.a=q,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rg=j;class W{constructor(q,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=q,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sg=W;class O extends j{constructor(q,le){super(q,le),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$Tg=O;class z extends L.$jc{constructor(q,le){super(),this.g=q,this.h=le,this.a=[],this.b=this.B(new L.$kc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of q)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ug=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Vg=N=>{(0,l.$A)(()=>{if(q)return;const le=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.$Vg=(N,q)=>{const le=requestIdleCallback(N,typeof q=="number"?{timeout:q}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(le))}}}}();class ee{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(le){this.g=le}finally{this.d=!0}},this.b=(0,e.$Vg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Wg=ee;async function X(N,q,le){let we;for(let ve=0;ve<le;ve++)try{return await N()}catch(me){we=me,await o(q)}throw we}e.$Xg=X;class Ee{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,le,we){return this.a={taskId:q,cancel:()=>we?.(),promise:le},le.then(()=>this.d(q),()=>this.d(q)),le}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{let le,we;const ve=new Promise((me,De)=>{le=me,we=De});this.b={run:q,promise:ve,promiseResolve:le,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Yg=Ee;class ke{constructor(q,le=()=>Date.now()){this.d=q,this.f=le,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$Zg=ke;var Pe;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(Pe||(Pe={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,le)=>{this.a=q,this.b=le})}complete(q){return new Promise(le=>{this.a(q),this.d={outcome:0,value:q},le()})}error(q){return new Promise(le=>{this.b(q),this.d={outcome:1,value:q},le()})}cancel(){return this.error(new F.$3)}}e.$1g=Z;var ue;(function(N){async function q(we){let ve;const me=await Promise.all(we.map(De=>De.then(ne=>ne,ne=>{ve||(ve=ne)})));if(typeof ve<"u")throw ve;return me}N.settled=q;function le(we){return new Promise(async(ve,me)=>{try{await we(ve,me)}catch(De){me(De)}})}N.withAsyncBody=le})(ue||(e.Promises=ue={}));var ye;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(ye||(ye={}));class ce{static fromArray(q){return new ce(le=>{le.emitMany(q)})}static fromPromise(q){return new ce(async le=>{le.emitMany(await q)})}static fromPromises(q){return new ce(async le=>{await Promise.all(q.map(async we=>le.emitOne(await we)))})}static merge(q){return new ce(async le=>{await Promise.all(q.map(async we=>{for await(const ve of we)le.emitOne(ve)}))})}static{this.EMPTY=ce.fromArray([])}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new C.$ed,queueMicrotask(async()=>{const le={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(q(le)),this.j()}catch(we){this.k(we)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(q,le){return new ce(async we=>{for await(const ve of q)we.emitOne(le(ve))})}map(q){return ce.map(this,q)}static filter(q,le){return new ce(async we=>{for await(const ve of q)le(ve)&&we.emitOne(ve)})}filter(q){return ce.filter(this,q)}static coalesce(q){return ce.filter(q,le=>!!le)}coalesce(){return ce.coalesce(this)}static async toPromise(q){const le=[];for await(const we of q)le.push(we);return le}toPromise(){return ce.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$2g=ce;class $e extends ce{constructor(q,le){super(le),this.l=q}cancel(){this.l.cancel()}}e.$3g=$e;function ie(N){const q=new w.$od,le=N(q.token);return new $e(q,async we=>{const ve=q.token.onCancellationRequested(()=>{ve.dispose(),q.dispose(),we.reject(new F.$3)});try{for await(const me of le){if(q.token.isCancellationRequested)return;we.emitOne(me)}ve.dispose(),q.dispose()}catch(me){ve.dispose(),q.dispose(),we.reject(me)}})}e.$4g=ie}),define(Ae[37],Re([1,0,18,13,42,28,19,22,15]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0;function f(){return Object.create(null)}e.$lj=f,e.$mj="**",e.$nj="/";const P="[/\\\\]",D="[^/\\\\]",u=/\//g;function p(Ee,ke){switch(Ee){case 0:return"";case 1:return`${D}*?`;default:return`(?:${P}|${D}+${P}${ke?`|${P}${D}+`:""})*?`}}function $(Ee,ke){if(!Ee)return[];const Pe=[];let Z=!1,ue=!1,ye="";for(const ce of Ee){switch(ce){case ke:if(!Z&&!ue){Pe.push(ye),ye="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ye+=ce}return ye&&Pe.push(ye),Pe}e.$oj=$;function h(Ee){if(!Ee)return"";let ke="";const Pe=$(Ee,e.$nj);if(Pe.every(Z=>Z===e.$mj))ke=".*";else{let Z=!1;Pe.forEach((ue,ye)=>{if(ue===e.$mj){if(Z)return;ke+=p(2,ye===Pe.length-1)}else{let ce=!1,$e="",ie=!1,N="";for(const q of ue){if(q!=="}"&&ce){$e+=q;continue}if(ie&&(q!=="]"||!N)){let le;q==="-"?le=q:(q==="^"||q==="!")&&!N?le="^":q===e.$nj?le="":le=(0,S.$pe)(q),N+=le;continue}switch(q){case"{":ce=!0;continue;case"[":ie=!0;continue;case"}":{const we=`(?:${$($e,",").map(ve=>h(ve)).join("|")})`;ke+=we,ce=!1,$e="";break}case"]":{ke+="["+N+"]",ie=!1,N="";break}case"?":ke+=D;continue;case"*":ke+=p(1);continue;default:ke+=(0,S.$pe)(q)}}ye<Pe.length-1&&(Pe[ye+1]!==e.$mj||ye+2<Pe.length)&&(ke+=P)}Z=ue===e.$mj})}return ke}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,k=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.$Bi(1e4),a=function(){return!1},s=function(){return null};function o(Ee,ke){if(!Ee)return s;let Pe;typeof Ee!="string"?Pe=Ee.pattern:Pe=Ee,Pe=Pe.trim();const Z=`${Pe}_${!!ke.trimForExclusions}`;let ue=n.get(Z);if(ue)return y(ue,Ee);let ye;return t.test(Pe)?ue=I(Pe.substr(4),Pe):(ye=i.exec(m(Pe,ke)))?ue=E(ye[1],Pe):(ke.trimForExclusions?g:c).test(Pe)?ue=r(Pe,ke):(ye=k.exec(m(Pe,ke)))?ue=d(ye[1].substr(1),Pe,!0):(ye=b.exec(m(Pe,ke)))?ue=d(ye[1],Pe,!1):ue=v(Pe),n.set(Z,ue),y(ue,Ee)}function y(Ee,ke){if(typeof ke=="string")return Ee;const Pe=function(Z,ue){return(0,C.$Hf)(Z,ke.base,!l.$k)?Ee((0,S.$te)(Z.substr(ke.base.length),A.sep),ue):null};return Pe.allBasenames=Ee.allBasenames,Pe.allPaths=Ee.allPaths,Pe.basenames=Ee.basenames,Pe.patterns=Ee.patterns,Pe}function m(Ee,ke){return ke.trimForExclusions&&Ee.endsWith("/**")?Ee.substr(0,Ee.length-2):Ee}function I(Ee,ke){return function(Pe,Z){return typeof Pe=="string"&&Pe.endsWith(Ee)?ke:null}}function E(Ee,ke){const Pe=`/${Ee}`,Z=`\\${Ee}`,ue=function(ce,$e){return typeof ce!="string"?null:$e?$e===Ee?ke:null:ce===Ee||ce.endsWith(Pe)||ce.endsWith(Z)?ke:null},ye=[Ee];return ue.basenames=ye,ue.patterns=[ke],ue.allBasenames=ye,ue}function r(Ee,ke){const Pe=ee(Ee.slice(1,-1).split(",").map($e=>o($e,ke)).filter($e=>$e!==s),Ee),Z=Pe.length;if(!Z)return s;if(Z===1)return Pe[0];const ue=function($e,ie){for(let N=0,q=Pe.length;N<q;N++)if(Pe[N]($e,ie))return Ee;return null},ye=Pe.find($e=>!!$e.allBasenames);ye&&(ue.allBasenames=ye.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(ue.allPaths=ce),ue}function d(Ee,ke,Pe){const Z=A.sep===A.$5d.sep,ue=Z?Ee:Ee.replace(u,A.sep),ye=A.sep+ue,ce=A.$5d.sep+Ee;let $e;return Pe?$e=function(ie,N){return typeof ie=="string"&&(ie===ue||ie.endsWith(ye)||!Z&&(ie===Ee||ie.endsWith(ce)))?ke:null}:$e=function(ie,N){return typeof ie=="string"&&(ie===ue||!Z&&ie===Ee)?ke:null},$e.allPaths=[(Pe?"*/":"./")+Ee],$e}function v(Ee){try{const ke=new RegExp(`^${h(Ee)}$`);return function(Pe){return ke.lastIndex=0,typeof Pe=="string"&&ke.test(Pe)?Ee:null}}catch{return s}}function R(Ee,ke,Pe){return!Ee||typeof ke!="string"?!1:B(Ee)(ke,void 0,Pe)}e.$pj=R;function B(Ee,ke={}){if(!Ee)return a;if(typeof Ee=="string"||V(Ee)){const Pe=o(Ee,ke);if(Pe===s)return a;const Z=function(ue,ye){return!!Pe(ue,ye)};return Pe.allBasenames&&(Z.allBasenames=Pe.allBasenames),Pe.allPaths&&(Z.allPaths=Pe.allPaths),Z}return O(Ee,ke)}e.$qj=B;function V(Ee){const ke=Ee;return ke?typeof ke.base=="string"&&typeof ke.pattern=="string":!1}e.$rj=V;function j(Ee){return Ee.allBasenames||[]}e.$sj=j;function W(Ee){return Ee.allPaths||[]}e.$tj=W;function O(Ee,ke){const Pe=ee(Object.getOwnPropertyNames(Ee).map($e=>z($e,Ee[$e],ke)).filter($e=>$e!==s)),Z=Pe.length;if(!Z)return s;if(!Pe.some($e=>!!$e.requiresSiblings)){if(Z===1)return Pe[0];const $e=function(q,le){let we;for(let ve=0,me=Pe.length;ve<me;ve++){const De=Pe[ve](q,le);if(typeof De=="string")return De;(0,F.$sg)(De)&&(we||(we=[]),we.push(De))}return we?(async()=>{for(const ve of we){const me=await ve;if(typeof me=="string")return me}return null})():null},ie=Pe.find(q=>!!q.allBasenames);ie&&($e.allBasenames=ie.allBasenames);const N=Pe.reduce((q,le)=>le.allPaths?q.concat(le.allPaths):q,[]);return N.length&&($e.allPaths=N),$e}const ue=function($e,ie,N){let q,le;for(let we=0,ve=Pe.length;we<ve;we++){const me=Pe[we];me.requiresSiblings&&N&&(ie||(ie=(0,A.$_d)($e)),q||(q=ie.substr(0,ie.length-(0,A.$ae)($e).length)));const De=me($e,ie,q,N);if(typeof De=="string")return De;(0,F.$sg)(De)&&(le||(le=[]),le.push(De))}return le?(async()=>{for(const we of le){const ve=await we;if(typeof ve=="string")return ve}return null})():null},ye=Pe.find($e=>!!$e.allBasenames);ye&&(ue.allBasenames=ye.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(ue.allPaths=ce),ue}function z(Ee,ke,Pe){if(ke===!1)return s;const Z=o(Ee,Pe);if(Z===s)return s;if(typeof ke=="boolean")return Z;if(ke){const ue=ke.when;if(typeof ue=="string"){const ye=(ce,$e,ie,N)=>{if(!N||!Z(ce,$e))return null;const q=ue.replace("$(basename)",()=>ie),le=N(q);return(0,F.$sg)(le)?le.then(we=>we?Ee:null):le?Ee:null};return ye.requiresSiblings=!0,ye}}return Z}function ee(Ee,ke){const Pe=Ee.filter($e=>!!$e.basenames);if(Pe.length<2)return Ee;const Z=Pe.reduce(($e,ie)=>{const N=ie.basenames;return N?$e.concat(N):$e},[]);let ue;if(ke){ue=[];for(let $e=0,ie=Z.length;$e<ie;$e++)ue.push(ke)}else ue=Pe.reduce(($e,ie)=>{const N=ie.patterns;return N?$e.concat(N):$e},[]);const ye=function($e,ie){if(typeof $e!="string")return null;if(!ie){let q;for(q=$e.length;q>0;q--){const le=$e.charCodeAt(q-1);if(le===47||le===92)break}ie=$e.substr(q)}const N=Z.indexOf(ie);return N!==-1?ue[N]:null};ye.basenames=Z,ye.patterns=ue,ye.allBasenames=Z;const ce=Ee.filter($e=>!$e.basenames);return ce.push(ye),ce}function X(Ee,ke){return(0,w.$sb)(Ee,ke,(Pe,Z)=>typeof Pe=="string"&&typeof Z=="string"?Pe===Z:typeof Pe!="string"&&typeof Z!="string"?Pe.base===Z.base&&Pe.pattern===Z.pattern:!1)}e.$uj=X}),define(Ae[49],Re([1,0,9,122,23,15,2]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.MarkdownStringTextNewlineStyle=void 0;var l;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(l||(e.MarkdownStringTextNewlineStyle=l={}));class S{constructor(i="",c=!1){if(this.value=i,typeof this.value!="string")throw(0,w.$5)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(i,c=0){return this.value+=u(this.supportThemeIcons?(0,F.$Qj)(i):i).replace(/([ \t]+)/g,(g,k)=>"&nbsp;".repeat(k.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,c){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(i,c,g){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(i),")"),g&&(this.value+=` "${this.c(this.c(g,'"'),")")}"`),this.value+=")",this}c(i,c){const g=new RegExp((0,L.$pe)(c),"g");return i.replace(g,(k,b)=>i.charAt(b-1)!=="\\"?`\\${k}`:k)}}e.$Wj=S;function f(t){return P(t)?!t.value:Array.isArray(t)?t.every(f):!0}e.$Xj=f;function P(t){return t instanceof S?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$Yj=P;function D(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,C.$ag)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$Zj=D;function u(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$1j=u;function p(t){return t.replace(/"/g,"&quot;")}e.$2j=p;function $(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$3j=$;function h(t){const i=[],c=t.split("|").map(k=>k.trim());t=c[0];const g=c[1];if(g){const k=/height=(\d+)/.exec(g),b=/width=(\d+)/.exec(g),n=k?k[1]:"",a=b?b[1]:"",s=isFinite(parseInt(a)),o=isFinite(parseInt(n));s&&i.push(`width="${a}"`),o&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$4j=h}),define(Ae[90],Re([1,0,18,42,19,22,23,15]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lA=e.$kA=e.$jA=e.$iA=e.$hA=e.$gA=e.$fA=e.$eA=e.$dA=e.$cA=void 0;function S(o,y){const{os:m,tildify:I,relative:E}=y;if(E){const v=f(o,E,m);if(typeof v=="string")return v}let r=o.fsPath;if(m===1&&!L.$i?r=r.replace(/\//g,"\\"):m!==1&&L.$i&&(r=r.replace(/\\/g,"/")),m!==1&&I?.userHome){const v=I.userHome.fsPath;let R;o.scheme!==I.userHome.scheme&&o.path.startsWith(C.$5d.sep)?R=I.userHome.with({path:o.path}).fsPath:R=o.fsPath,r=u(R,v,m)}return(m===1?C.$4d:C.$5d).normalize(P(r,m===1))}e.$cA=S;function f(o,y,m){const I=m===1?C.$4d:C.$5d,E=m===3?A.$0f:A.$_f,r=y.getWorkspace(),d=(0,w.$Lb)(r.folders);if(!d)return;o.scheme!==d.uri.scheme&&o.path.startsWith(C.$5d.sep)&&(o=d.uri.with({path:o.path}));const v=y.getWorkspaceFolder(o);if(!v)return;let R;if(E.isEqual(v.uri,o)?R="":R=E.relativePath(v.uri,o)??"",R&&(R=I.normalize(R)),r.folders.length>1&&!y.noPrefix){const B=v.name?v.name:E.basenameOrAuthority(v.uri);R=R?`${B} \u2022 ${R}`:B}return R}function P(o,y=L.$i){return(0,F.$Lf)(o,y)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$dA=P;let D=Object.create(null);function u(o,y,m=L.OS){if(m===1||!o||!y)return o;let I=D.original===y?D.normalized:void 0;I||(I=y,L.$i&&(I=(0,F.$Bf)(I)),I=`${(0,l.$ue)(I,C.$5d.sep)}${C.$5d.sep}`,D={original:y,normalized:I});let E=o;return L.$i&&(E=(0,F.$Bf)(E)),(m===3?E.startsWith(I):(0,l.$Me)(E,I))?`~/${E.substr(I.length)}`:o}e.$eA=u;function p(o,y){return o.replace(/^~($|\/|\\)/,`${y}$1`)}e.$fA=p;const $="\u2026",h="\\\\",t="~";function i(o,y=C.sep){const m=new Array(o.length);let I=!1;for(let E=0;E<o.length;E++){const r=o[E];if(r===""){m[E]=`.${y}`;continue}if(!r){m[E]=r;continue}I=!0;let d="",v=r;v.indexOf(h)===0?(d=v.substr(0,v.indexOf(h)+h.length),v=v.substr(v.indexOf(h)+h.length)):v.indexOf(y)===0?(d=v.substr(0,v.indexOf(y)+y.length),v=v.substr(v.indexOf(y)+y.length)):v.indexOf(t)===0&&(d=v.substr(0,v.indexOf(t)+t.length),v=v.substr(v.indexOf(t)+t.length));const R=v.split(y);for(let B=1;I&&B<=R.length;B++)for(let V=R.length-B;I&&V>=0;V--){I=!1;let j=R.slice(V,V+B).join(y);for(let W=0;!I&&W<o.length;W++)if(W!==E&&o[W]&&o[W].indexOf(j)>-1){const O=V+B===R.length,z=V>0&&o[W].indexOf(y)>-1?y+j:j,ee=o[W].endsWith(z);I=!O||ee}if(!I){let W="";(R[0].endsWith(":")||d!=="")&&(V===1&&(V=0,B++,j=R[0]+y+j),V>0&&(W=R[0]+y),W=d+W),V>0&&(W=W+$+y),W=W+j,V+B<R.length&&(W=W+y+$),m[E]=W}}I&&(m[E]=r)}return m}e.$gA=i;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function g(o,y=Object.create(null)){const m=[];let I=!1,E="";for(const r of o)if(r==="$"||I&&r==="{")E&&m.push({value:E,type:c.TEXT}),E="",I=!0;else if(r==="}"&&I){const d=y[E];if(typeof d=="string")d.length&&m.push({value:d,type:c.VARIABLE});else if(d){const v=m[m.length-1];(!v||v.type!==c.SEPARATOR)&&m.push({value:d.label,type:c.SEPARATOR})}E="",I=!1}else E+=r;return E&&!I&&m.push({value:E,type:c.TEXT}),m.filter((r,d)=>{if(r.type===c.SEPARATOR){const v=m[d-1],R=m[d+1];return[v,R].every(B=>B&&(B.type===c.VARIABLE||B.type===c.TEXT)&&B.value.length>0)}return!0}).map(r=>r.value).join("")}e.$hA=g;function k(o,y){return L.$j||y?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):o.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.$iA=k;function b(o,y){return L.$j||y?o.replace(/\(&&\w\)|&&/g,""):L.$i?o.replace(/&&|&/g,m=>m==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$jA=b;function n(o){return o.replace(/&/g,"&&")}e.$kA=n;function a(o){if(o.endsWith("]")){const y=o.lastIndexOf(" [",o.length-2);if(y!==-1){const m=s(o.substring(0,y));return{name:m.name,parentPath:m.parentPath+o.substring(y)}}}return s(o)}e.$lA=a;function s(o){const y=o.indexOf("/")!==-1?C.$5d:C.$4d,m=y.basename(o),I=y.dirname(o);return m.length?{name:m,parentPath:I}:{name:I,parentPath:""}}}),define(Ae[133],Re([1,0,25,2]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=void 0;function C(D){return D.toJSON()}class L{constructor(u){this.a=u}transformIncoming(u){const p=this.a.transformIncoming(u);return p===u?u:C(F.URI.from(p))}transformOutgoing(u){const p=this.a.transformOutgoing(u);return p===u?u:C(F.URI.from(p))}transformOutgoingURI(u){const p=this.a.transformOutgoing(u);return p===u?u:F.URI.from(p)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$Am=L,e.$Bm=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,u,p){if(!D||p>200)return null;if(typeof D=="object"){if(D instanceof F.URI)return u.transformOutgoing(D);for(const $ in D)if(Object.hasOwnProperty.call(D,$)){const h=A(D[$],u,p+1);h!==null&&(D[$]=h)}}return null}function l(D,u){const p=A(D,u,0);return p===null?D:p}e.$Cm=l;function S(D,u,p,$){if(!D||$>200)return null;if(typeof D=="object"){if(D.$mid===1)return p?F.URI.revive(u.transformIncoming(D)):u.transformIncoming(D);if(D instanceof w.$Ed)return null;for(const h in D)if(Object.hasOwnProperty.call(D,h)){const t=S(D[h],u,p,$+1);t!==null&&(D[h]=t)}}return null}function f(D,u){const p=S(D,u,!1,0);return p===null?D:p}e.$Dm=f;function P(D,u){const p=S(D,u,!0,0);return p===null?D:p}e.$Em=P}),define(Ae[134],Re([1,0,37,19]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=void 0;function C(L,A,l,S,f,P){if(Array.isArray(L)){let D=0;for(const u of L){const p=C(u,A,l,S,f,P);if(p===10)return p;p>D&&(D=p)}return D}else{if(typeof L=="string")return S?L==="*"?5:L===l?10:0:0;if(L){const{language:D,pattern:u,scheme:p,hasAccessToAllModels:$,notebookType:h}=L;if(!S&&!$)return 0;h&&f&&(A=f);let t=0;if(p)if(p===A.scheme)t=10;else if(p==="*")t=5;else return 0;if(D)if(D===l)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(h)if(h===P)t=10;else if(h==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(u){let i;if(typeof u=="string"?i=u:i={...u,base:(0,F.$6d)(u.base)},i===A.fsPath||(0,w.$pj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$aF=C}),define(Ae[91],Re([1,0,25,22]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l0=e.$k0=void 0;var C;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(C||(C={}));function L(D){for(let u=0,p=D.length;u<p;u+=4){const $=D[u+0],h=D[u+1],t=D[u+2],i=D[u+3];D[u+0]=i,D[u+1]=t,D[u+2]=h,D[u+3]=$}}function A(D){const u=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return F.$C()||L(u),w.$Ed.wrap(u)}function l(D){const u=D.buffer;if(F.$C()||L(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const p=new Uint8Array(u.byteLength);return p.set(u),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function S(D){const u=new Uint32Array(f(D));let p=0;if(u[p++]=D.id,D.type==="full")u[p++]=1,u[p++]=D.data.length,u.set(D.data,p),p+=D.data.length;else{u[p++]=2,u[p++]=D.deltas.length;for(const $ of D.deltas)u[p++]=$.start,u[p++]=$.deleteCount,$.data?(u[p++]=$.data.length,u.set($.data,p),p+=$.data.length):u[p++]=0}return A(u)}e.$k0=S;function f(D){let u=0;if(u+=1+1,D.type==="full")u+=1+D.data.length;else{u+=1,u+=(1+1+1)*D.deltas.length;for(const p of D.deltas)p.data&&(u+=p.data.length)}return u}function P(D){const u=l(D);let p=0;const $=u[p++];if(u[p++]===1){const c=u[p++],g=u.subarray(p,p+c);return p+=c,{id:$,type:"full",data:g}}const t=u[p++],i=[];for(let c=0;c<t;c++){const g=u[p++],k=u[p++],b=u[p++];let n;b>0&&(n=u.subarray(p,p+b),p+=b),i[c]={start:g,deleteCount:k,data:n}}return{id:$,type:"delta",deltas:i}}e.$l0=P}),define(Ae[135],Re([10,11]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Ae[136],Re([1,0,18,24,22,124,137,135]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(S||(e.EditorAutoIndentStrategy=S={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=f;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class D{constructor(Q,pe,je,ze){this.id=Q,this.name=pe,this.defaultValue=je,this.schema=ze}applyUpdate(Q,pe){return p(Q,pe)}compute(Q,pe,je){return je}}class u{constructor(Q,pe){this.newValue=Q,this.didChange=pe}}e.ApplyUpdateResult=u;function p(_,Q){if(typeof _!="object"||typeof Q!="object"||!_||!Q)return new u(Q,_!==Q);if(Array.isArray(_)||Array.isArray(Q)){const je=Array.isArray(_)&&Array.isArray(Q)&&w.$sb(_,Q);return new u(Q,!je)}let pe=!1;for(const je in Q)if(Q.hasOwnProperty(je)){const ze=p(_[je],Q[je]);ze.didChange&&(_[je]=ze.newValue,pe=!0)}return new u(_,pe)}class ${constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,pe){return p(Q,pe)}validate(Q){return this.defaultValue}}class h{constructor(Q,pe,je,ze){this.id=Q,this.name=pe,this.defaultValue=je,this.schema=ze}applyUpdate(Q,pe){return p(Q,pe)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,pe,je){return je}}function t(_,Q){return typeof _>"u"?Q:_==="false"?!1:!!_}e.boolean=t;class i extends h{constructor(Q,pe,je,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=je),super(Q,pe,je,ze)}validate(Q){return t(Q,this.defaultValue)}}function c(_,Q,pe,je){if(typeof _>"u")return Q;let ze=parseInt(_,10);return isNaN(ze)?Q:(ze=Math.max(pe,ze),ze=Math.min(je,ze),ze|0)}e.clampedInt=c;class g extends h{static clampedInt(Q,pe,je,ze){return c(Q,pe,je,ze)}constructor(Q,pe,je,ze,Qe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=je,nt.minimum=ze,nt.maximum=Qe),super(Q,pe,je,nt),this.minimum=ze,this.maximum=Qe}validate(Q){return g.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function k(_,Q,pe,je){if(typeof _>"u")return Q;const ze=b.float(_,Q);return b.clamp(ze,pe,je)}e.clampedFloat=k;class b extends h{static clamp(Q,pe,je){return Q<pe?pe:Q>je?je:Q}static float(Q,pe){if(typeof Q=="number")return Q;if(typeof Q>"u")return pe;const je=parseFloat(Q);return isNaN(je)?pe:je}constructor(Q,pe,je,ze,Qe){typeof Qe<"u"&&(Qe.type="number",Qe.default=je),super(Q,pe,je,Qe),this.validationFn=ze}validate(Q){return this.validationFn(b.float(Q,this.defaultValue))}}class n extends h{static string(Q,pe){return typeof Q!="string"?pe:Q}constructor(Q,pe,je,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=je),super(Q,pe,je,ze)}validate(Q){return n.string(Q,this.defaultValue)}}function a(_,Q,pe,je){return typeof _!="string"?Q:je&&_ in je?je[_]:pe.indexOf(_)===-1?Q:_}e.stringSet=a;class s extends h{constructor(Q,pe,je,ze,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.enum=ze,Qe.default=je),super(Q,pe,je,Qe),this.c=ze}validate(Q){return a(Q,this.defaultValue,this.c)}}class o extends D{constructor(Q,pe,je,ze,Qe,nt,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=Qe,gt.default=ze),super(Q,pe,je,gt),this.c=Qe,this.d=nt}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function y(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,pe,je){return je===0?Q.accessibilitySupport:je}}class I extends D{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:l.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{insertSpace:t(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var E;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(E||(e.TextEditorCursorBlinkingStyle=E={}));function r(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(d||(e.TextEditorCursorStyle=d={}));function v(_){switch(_){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function R(_){switch(_){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class B extends ${constructor(){super(140)}compute(Q,pe,je){const ze=["monaco-editor"];return pe.get(39)&&ze.push(pe.get(39)),Q.extraEditorClassName&&ze.push(Q.extraEditorClassName),pe.get(73)==="default"?ze.push("mouse-default"):pe.get(73)==="copy"&&ze.push("mouse-copy"),pe.get(110)&&ze.push("showUnused"),pe.get(138)&&ze.push("showDeprecated"),ze.join(" ")}}class V extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(Q,pe,je){return je&&Q.emptySelectionClipboard}}class j extends D{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:l.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:l.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{cursorMoveOnType:t(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":a(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":a(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(pe.loop,this.defaultValue.loop)}}}class W extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?W.OFF:Q==="true"?W.ON:Q:Q?W.ON:W.OFF}}e.EditorFontLigatures=W;class O extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?O.OFF:Q==="true"?O.TRANSLATE:Q:Q?O.TRANSLATE:O.OFF}compute(Q,pe,je){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class z extends ${constructor(){super(50)}compute(Q,pe,je){return Q.fontInfo}}class ee extends h{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(Q){const pe=b.float(Q,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:b.clamp(pe,6,100)}compute(Q,pe,je){return Q.fontInfo.fontSize}}class X extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(g.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class Ee extends D{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:je,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:je,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:je,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:je,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:je,description:l.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{multiple:a(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??a(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??a(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??a(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??a(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??a(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ke extends D{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:l.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:t(pe.enabled,this.defaultValue.enabled),delay:g.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:t(pe.sticky,this.defaultValue.sticky),hidingDelay:g.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(pe.above,this.defaultValue.above)}}}var Pe;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class Z extends ${constructor(){super(143)}compute(Q,pe,je){return Z.computeLayout(pe,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const pe=Q.height/Q.lineHeight,je=Math.floor(Q.paddingTop/Q.lineHeight);let ze=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(ze=Math.max(ze,pe-1));const Qe=(je+Q.viewLineCount+ze)/(Q.pixelRatio*Q.height),nt=Math.floor(Q.viewLineCount/Qe);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:ze,desiredRatio:Qe,minimapLineCount:nt}}static c(Q,pe){const je=Q.outerWidth,ze=Q.outerHeight,Qe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const nt=pe.stableMinimapLayoutInput,gt=nt&&Q.outerHeight===nt.outerHeight&&Q.lineHeight===nt.lineHeight&&Q.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Q.pixelRatio===nt.pixelRatio&&Q.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Q.paddingTop===nt.paddingTop&&Q.paddingBottom===nt.paddingBottom&&Q.minimap.enabled===nt.minimap.enabled&&Q.minimap.side===nt.minimap.side&&Q.minimap.size===nt.minimap.size&&Q.minimap.showSlider===nt.minimap.showSlider&&Q.minimap.renderCharacters===nt.minimap.renderCharacters&&Q.minimap.maxColumn===nt.minimap.maxColumn&&Q.minimap.scale===nt.minimap.scale&&Q.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Q.isViewportWrapping===nt.isViewportWrapping,vt=Q.lineHeight,Mt=Q.typicalHalfwidthCharacterWidth,Qt=Q.scrollBeyondLastLine,Vt=Q.minimap.renderCharacters;let wt=Qe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Tt=Q.minimap.maxColumn,Ot=Q.minimap.size,Jt=Q.minimap.side,Pt=Q.verticalScrollbarWidth,At=Q.viewLineCount,zt=Q.remainingWidth,jt=Q.isViewportWrapping,qt=Vt?2:3;let Bt=Math.floor(Qe*ze);const at=Bt/Qe;let ut=!1,Ht=!1,Ct=qt*wt,kt=wt/Qe,ht=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Fe,extraLinesBeforeFirstLine:ge,extraLinesBeyondLastLine:H,desiredRatio:Me,minimapLineCount:Be}=Z.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Qt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:ze,lineHeight:vt,pixelRatio:Qe});if(At/Be>1)ut=!0,Ht=!0,wt=1,Ct=1,kt=wt/Qe;else{let We=!1,xe=wt+1;if(Ot==="fit"){const pt=Math.ceil((ge+At+H)*Ct);jt&&gt&&zt<=pe.stableFitRemainingWidth?(We=!0,xe=pe.stableFitMaxMinimapScale):We=pt>Bt}if(Ot==="fill"||We){ut=!0;const pt=wt;Ct=Math.min(vt*Qe,Math.max(1,Math.floor(1/Me))),jt&&gt&&zt<=pe.stableFitRemainingWidth&&(xe=pe.stableFitMaxMinimapScale),wt=Math.min(xe,Math.max(1,Math.floor(Ct/qt))),wt>pt&&(ht=Math.min(2,wt/pt)),kt=wt/Qe/ht,Bt=Math.ceil(Math.max(Fe,ge+At+H)*Ct),jt?(pe.stableMinimapLayoutInput=Q,pe.stableFitRemainingWidth=zt,pe.stableFitMaxMinimapScale=wt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const St=Math.floor(Tt*kt),Lt=Math.min(St,Math.max(0,Math.floor((zt-Pt-2)*kt/(Mt+kt)))+e.MINIMAP_GUTTER_WIDTH);let Et=Math.floor(Qe*Lt);const qe=Et/Qe;Et=Math.floor(Et*ht);const Nt=Vt?1:2,Ce=Jt==="left"?0:je-Lt-Pt;return{renderMinimap:Nt,minimapLeft:Ce,minimapWidth:Lt,minimapHeightIsEditorHeight:ut,minimapIsSampling:Ht,minimapScale:wt,minimapLineHeight:Ct,minimapCanvasInnerWidth:Et,minimapCanvasInnerHeight:Bt,minimapCanvasOuterWidth:qe,minimapCanvasOuterHeight:at}}static computeLayout(Q,pe){const je=pe.outerWidth|0,ze=pe.outerHeight|0,Qe=pe.lineHeight|0,nt=pe.lineNumbersDigitCount|0,gt=pe.typicalHalfwidthCharacterWidth,vt=pe.maxDigitWidth,Mt=pe.pixelRatio,Qt=pe.viewLineCount,Vt=Q.get(135),wt=Vt==="inherit"?Q.get(134):Vt,Tt=wt==="inherit"?Q.get(130):wt,Ot=Q.get(133),Jt=pe.isDominatedByLongLines,Pt=Q.get(57),At=Q.get(67).renderType!==0,zt=Q.get(68),jt=Q.get(104),qt=Q.get(83),Bt=Q.get(72),at=Q.get(102),ut=at.verticalScrollbarSize,Ht=at.verticalHasArrows,Ct=at.arrowSize,kt=at.horizontalScrollbarSize,ht=Q.get(43),St=Q.get(109)!=="never";let Lt=Q.get(65);ht&&St&&(Lt+=16);let Et=0;if(At){const dt=Math.max(nt,zt);Et=Math.round(dt*vt)}let qe=0;Pt&&(qe=Qe*pe.glyphMarginDecorationLaneCount);let Nt=0,Ce=Nt+qe,Fe=Ce+Et,ge=Fe+Lt;const H=je-qe-Et-Lt;let Me=!1,Be=!1,Ge=-1;wt==="inherit"&&Jt?(Me=!0,Be=!0):Tt==="on"||Tt==="bounded"?Be=!0:Tt==="wordWrapColumn"&&(Ge=Ot);const We=Z.c({outerWidth:je,outerHeight:ze,lineHeight:Qe,typicalHalfwidthCharacterWidth:gt,pixelRatio:Mt,scrollBeyondLastLine:jt,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:Bt,verticalScrollbarWidth:ut,viewLineCount:Qt,remainingWidth:H,isViewportWrapping:Be},pe.memory||new P);We.renderMinimap!==0&&We.minimapLeft===0&&(Nt+=We.minimapWidth,Ce+=We.minimapWidth,Fe+=We.minimapWidth,ge+=We.minimapWidth);const xe=H-We.minimapWidth,pt=Math.max(1,Math.floor((xe-ut-2)/gt)),bt=Ht?Ct:0;return Be&&(Ge=Math.max(1,pt),Tt==="bounded"&&(Ge=Math.min(Ge,Ot))),{width:je,height:ze,glyphMarginLeft:Nt,glyphMarginWidth:qe,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Ce,lineNumbersWidth:Et,decorationsLeft:Fe,decorationsWidth:Lt,contentLeft:ge,contentWidth:xe,minimap:We,viewportColumn:pt,isWordWrapMinified:Me,isViewportWrapping:Be,wrappingColumn:Ge,verticalScrollbarWidth:ut,horizontalScrollbarHeight:kt,overviewRuler:{top:bt,width:ut,height:ze-2*bt,right:0}}}}e.EditorLayoutInfoComputer=Z;class ue extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(Q){return a(Q,"simple",["simple","advanced"])}compute(Q,pe,je){return pe.get(2)===2?"advanced":je}}class ye extends D{constructor(){const Q={enabled:!0};super(64,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:l.localize(50,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:t(Q.enabled,this.defaultValue.enabled)}}}class ce extends D{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:l.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:l.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:l.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:l.localize(54,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:t(pe.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class $e extends D{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:l.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(56,null),l.localize(57,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(58,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:l.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:l.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:l.localize(62,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:a(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(pe.fontFamily,this.defaultValue.fontFamily),padding:t(pe.padding,this.defaultValue.padding)}}}class ie extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):g.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,pe,je){return je<0?g.clampedInt(-je*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class N extends b{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>b.clamp(Q,0,150),{markdownDescription:l.localize(63,null)})}compute(Q,pe,je){return Q.fontInfo.lineHeight}}class q extends D{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:l.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:l.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(66,null),l.localize(67,null),l.localize(68,null)],default:Q.size,description:l.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:l.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:l.localize(71,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:l.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:l.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:t(pe.enabled,this.defaultValue.enabled),autohide:t(pe.autohide,this.defaultValue.autohide),size:a(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(pe.side,this.defaultValue.side,["right","left"]),showSlider:a(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(pe.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(pe.scale,1,1,3),maxColumn:g.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(_){return _==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class we extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{top:g.clampedInt(pe.top,0,0,1e3),bottom:g.clampedInt(pe.bottom,0,0,1e3)}}}class ve extends D{constructor(){const Q={enabled:!0,cycle:!0};super(85,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:l.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:l.localize(78,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:t(pe.enabled,this.defaultValue.enabled),cycle:t(pe.cycle,this.defaultValue.cycle)}}}class me extends ${constructor(){super(141)}compute(Q,pe,je){return Q.pixelRatio}}class De extends D{constructor(){const Q={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(79,null),l.localize(80,null),l.localize(81,null)]}];super(88,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Q.strings,description:l.localize(82,null)},comments:{anyOf:pe,default:Q.comments,description:l.localize(83,null)},other:{anyOf:pe,default:Q.other,description:l.localize(84,null)}},default:Q,markdownDescription:l.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Mt=Q?"on":"off";return{comments:Mt,strings:Mt,other:Mt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:pe,comments:je,strings:ze}=Q,Qe=["on","inline","off"];let nt,gt,vt;return typeof pe=="boolean"?nt=pe?"on":"off":nt=a(pe,this.defaultValue.other,Qe),typeof je=="boolean"?gt=je?"on":"off":gt=a(je,this.defaultValue.comments,Qe),typeof ze=="boolean"?vt=ze?"on":"off":vt=a(ze,this.defaultValue.strings,Qe),{other:nt,comments:gt,strings:vt}}}var ne;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(ne||(e.RenderLineNumbersType=ne={}));class he extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null),l.localize(89,null)],default:"on",description:l.localize(90,null)})}validate(Q){let pe=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(pe=4,je=Q):Q==="interval"?pe=3:Q==="relative"?pe=2:Q==="on"?pe=1:pe=0),{renderType:pe,renderFn:je}}}function se(_){const Q=_.get(97);return Q==="editable"?_.get(90):Q!=="on"}e.filterValidationDecorations=se;class oe extends D{constructor(){const Q=[],pe={type:"number",description:l.localize(91,null)};super(101,"rulers",Q,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:l.localize(92,null),format:"color-hex"}}}]},default:Q,description:l.localize(93,null)})}validate(Q){if(Array.isArray(Q)){const pe=[];for(const je of Q)if(typeof je=="number")pe.push({column:g.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const ze=je;pe.push({column:g.clampedInt(ze.column,0,0,1e4),color:ze.color})}return pe.sort((je,ze)=>je.column-ze.column),pe}return this.defaultValue}}class fe extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Ie(_,Q){if(typeof _!="string")return Q;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class M extends D{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"auto",description:l.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(98,null),l.localize(99,null),l.localize(100,null)],default:"auto",description:l.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:l.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:l.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:l.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q,je=g.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=g.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(pe.vertical,this.defaultValue.vertical),horizontal:Ie(pe.horizontal,this.defaultValue.horizontal),useShadows:t(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:g.clampedInt(pe.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:g.clampedInt(pe.verticalSliderSize,ze,0,1e3),scrollByPage:t(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends D{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:l.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:l.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:l.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:l.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:l.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:l.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:l.localize(111,null)}})}applyUpdate(Q,pe){let je=!1;pe.allowedCharacters&&Q&&(F.$Ym(Q.allowedCharacters,pe.allowedCharacters)||(Q={...Q,allowedCharacters:pe.allowedCharacters},je=!0)),pe.allowedLocales&&Q&&(F.$Ym(Q.allowedLocales,pe.allowedLocales)||(Q={...Q,allowedLocales:pe.allowedLocales},je=!0));const ze=super.applyUpdate(Q,pe);return je?new u(ze.newValue,!0):ze}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{nonBasicASCII:x(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,pe){if(typeof Q!="object"||!Q)return pe;const je={};for(const[ze,Qe]of Object.entries(Q))Qe===!0&&(je[ze]=!0);return je}}class G extends D{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:l.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[l.localize(113,null),l.localize(114,null)],description:l.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:l.localize(116,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:t(pe.enabled,this.defaultValue.enabled),mode:a(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Y extends D{constructor(){const Q={enabled:L.$Sr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Sr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:l.localize(118,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:t(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends D{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(119,null),l.localize(120,null),l.localize(121,null)],default:Q.bracketPairs,description:l.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(123,null),l.localize(124,null),l.localize(125,null)],default:Q.bracketPairsHorizontal,description:l.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:l.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:l.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(129,null),l.localize(130,null),l.localize(131,null)],default:Q.highlightActiveIndentation,description:l.localize(132,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{bracketPairs:x(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(_,Q,pe){const je=pe.indexOf(_);return je===-1?Q:pe[je]}class ae extends D{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(133,null),l.localize(134,null)],default:Q.insertMode,description:l.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:l.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:l.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:l.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(139,null),l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:Q.selectionMode,markdownDescription:l.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:l.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:l.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:l.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:l.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:l.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{insertMode:a(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(pe.showIcons,this.defaultValue.showIcons),showStatusBar:t(pe.showStatusBar,this.defaultValue.showStatusBar),preview:t(pe.preview,this.defaultValue.preview),previewMode:a(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(pe.showMethods,this.defaultValue.showMethods),showFunctions:t(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:t(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(pe.showFields,this.defaultValue.showFields),showVariables:t(pe.showVariables,this.defaultValue.showVariables),showClasses:t(pe.showClasses,this.defaultValue.showClasses),showStructs:t(pe.showStructs,this.defaultValue.showStructs),showInterfaces:t(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:t(pe.showModules,this.defaultValue.showModules),showProperties:t(pe.showProperties,this.defaultValue.showProperties),showEvents:t(pe.showEvents,this.defaultValue.showEvents),showOperators:t(pe.showOperators,this.defaultValue.showOperators),showUnits:t(pe.showUnits,this.defaultValue.showUnits),showValues:t(pe.showValues,this.defaultValue.showValues),showConstants:t(pe.showConstants,this.defaultValue.showConstants),showEnums:t(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:t(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(pe.showKeywords,this.defaultValue.showKeywords),showWords:t(pe.showWords,this.defaultValue.showWords),showColors:t(pe.showColors,this.defaultValue.showColors),showFiles:t(pe.showFiles,this.defaultValue.showFiles),showReferences:t(pe.showReferences,this.defaultValue.showReferences),showFolders:t(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:t(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(pe.showSnippets,this.defaultValue.showSnippets),showUsers:t(pe.showUsers,this.defaultValue.showUsers),showIssues:t(pe.showIssues,this.defaultValue.showIssues)}}}class Le extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(182,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Ye extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(183,null),l.localize(184,null),l.localize(185,null),l.localize(186,null)],description:l.localize(187,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,pe,je){return pe.get(2)===2?0:je}}class He extends ${constructor(){super(144)}compute(Q,pe,je){const ze=pe.get(143);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class et extends D{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(190,null),l.localize(191,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:t(pe.enabled,this.defaultValue.enabled),showDropSelector:a(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ze extends D{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(194,null),l.localize(195,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:t(pe.enabled,this.defaultValue.enabled),showPasteSelector:a(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const _e="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?it:C.$k?tt:_e,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(_){return e.editorOptionsRegistry[_.id]=_,_}var st;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.letterSpacing=63]="letterSpacing",_[_.lightbulb=64]="lightbulb",_[_.lineDecorationsWidth=65]="lineDecorationsWidth",_[_.lineHeight=66]="lineHeight",_[_.lineNumbers=67]="lineNumbers",_[_.lineNumbersMinChars=68]="lineNumbersMinChars",_[_.linkedEditing=69]="linkedEditing",_[_.links=70]="links",_[_.matchBrackets=71]="matchBrackets",_[_.minimap=72]="minimap",_[_.mouseStyle=73]="mouseStyle",_[_.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=75]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",_[_.multiCursorModifier=77]="multiCursorModifier",_[_.multiCursorPaste=78]="multiCursorPaste",_[_.multiCursorLimit=79]="multiCursorLimit",_[_.occurrencesHighlight=80]="occurrencesHighlight",_[_.overviewRulerBorder=81]="overviewRulerBorder",_[_.overviewRulerLanes=82]="overviewRulerLanes",_[_.padding=83]="padding",_[_.pasteAs=84]="pasteAs",_[_.parameterHints=85]="parameterHints",_[_.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",_[_.quickSuggestions=88]="quickSuggestions",_[_.quickSuggestionsDelay=89]="quickSuggestionsDelay",_[_.readOnly=90]="readOnly",_[_.readOnlyMessage=91]="readOnlyMessage",_[_.renameOnType=92]="renameOnType",_[_.renderControlCharacters=93]="renderControlCharacters",_[_.renderFinalNewline=94]="renderFinalNewline",_[_.renderLineHighlight=95]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=97]="renderValidationDecorations",_[_.renderWhitespace=98]="renderWhitespace",_[_.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",_[_.roundedSelection=100]="roundedSelection",_[_.rulers=101]="rulers",_[_.scrollbar=102]="scrollbar",_[_.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=104]="scrollBeyondLastLine",_[_.scrollPredominantAxis=105]="scrollPredominantAxis",_[_.selectionClipboard=106]="selectionClipboard",_[_.selectionHighlight=107]="selectionHighlight",_[_.selectOnLineNumbers=108]="selectOnLineNumbers",_[_.showFoldingControls=109]="showFoldingControls",_[_.showUnused=110]="showUnused",_[_.snippetSuggestions=111]="snippetSuggestions",_[_.smartSelect=112]="smartSelect",_[_.smoothScrolling=113]="smoothScrolling",_[_.stickyScroll=114]="stickyScroll",_[_.stickyTabStops=115]="stickyTabStops",_[_.stopRenderingLineAfter=116]="stopRenderingLineAfter",_[_.suggest=117]="suggest",_[_.suggestFontSize=118]="suggestFontSize",_[_.suggestLineHeight=119]="suggestLineHeight",_[_.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",_[_.suggestSelection=121]="suggestSelection",_[_.tabCompletion=122]="tabCompletion",_[_.tabIndex=123]="tabIndex",_[_.unicodeHighlighting=124]="unicodeHighlighting",_[_.unusualLineTerminators=125]="unusualLineTerminators",_[_.useShadowDOM=126]="useShadowDOM",_[_.useTabStops=127]="useTabStops",_[_.wordBreak=128]="wordBreak",_[_.wordSeparators=129]="wordSeparators",_[_.wordWrap=130]="wordWrap",_[_.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=133]="wordWrapColumn",_[_.wordWrapOverride1=134]="wordWrapOverride1",_[_.wordWrapOverride2=135]="wordWrapOverride2",_[_.wrappingIndent=136]="wrappingIndent",_[_.wrappingStrategy=137]="wrappingStrategy",_[_.showDeprecated=138]="showDeprecated",_[_.inlayHints=139]="inlayHints",_[_.editorClassName=140]="editorClassName",_[_.pixelRatio=141]="pixelRatio",_[_.tabFocusMode=142]="tabFocusMode",_[_.layoutInfo=143]="layoutInfo",_[_.wrappingInfo=144]="wrappingInfo",_[_.defaultColorDecorators=145]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(196,null)})),acceptSuggestionOnEnter:Ne(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(197,null),""],markdownDescription:l.localize(198,null)})),accessibilitySupport:Ne(new m),accessibilityPageSize:Ne(new g(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(199,null),tags:["accessibility"]})),ariaLabel:Ne(new n(4,"ariaLabel",l.localize(200,null))),ariaRequired:Ne(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(202,null),l.localize(203,null),""],description:l.localize(204,null)})),autoClosingComments:Ne(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(205,null),l.localize(206,null),""],description:l.localize(207,null)})),autoClosingDelete:Ne(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(208,null),""],description:l.localize(209,null)})),autoClosingOvertype:Ne(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(210,null),""],description:l.localize(211,null)})),autoClosingQuotes:Ne(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(212,null),l.localize(213,null),""],description:l.localize(214,null)})),autoIndent:Ne(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[l.localize(215,null),l.localize(216,null),l.localize(217,null),l.localize(218,null),l.localize(219,null)],description:l.localize(220,null)})),automaticLayout:Ne(new i(13,"automaticLayout",!1)),autoSurround:Ne(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(221,null),l.localize(222,null),l.localize(223,null),""],description:l.localize(224,null)})),bracketPairColorization:Ne(new Y),bracketPairGuides:Ne(new J),stickyTabStops:Ne(new i(115,"stickyTabStops",!1,{description:l.localize(225,null)})),codeLens:Ne(new i(17,"codeLens",!0,{description:l.localize(226,null)})),codeLensFontFamily:Ne(new n(18,"codeLensFontFamily","",{description:l.localize(227,null)})),codeLensFontSize:Ne(new g(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(228,null)})),colorDecorators:Ne(new i(20,"colorDecorators",!0,{description:l.localize(229,null)})),colorDecoratorActivatedOn:Ne(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(230,null),l.localize(231,null),l.localize(232,null)],description:l.localize(233,null)})),colorDecoratorsLimit:Ne(new g(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(234,null)})),columnSelection:Ne(new i(22,"columnSelection",!1,{description:l.localize(235,null)})),comments:Ne(new I),contextmenu:Ne(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new i(25,"copyWithSyntaxHighlighting",!0,{description:l.localize(236,null)})),cursorBlinking:Ne(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:l.localize(237,null)})),cursorSmoothCaretAnimation:Ne(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(238,null),l.localize(239,null),l.localize(240,null)],description:l.localize(241,null)})),cursorStyle:Ne(new o(28,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:l.localize(242,null)})),cursorSurroundingLines:Ne(new g(29,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(243,null)})),cursorSurroundingLinesStyle:Ne(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(244,null),l.localize(245,null)],markdownDescription:l.localize(246,null)})),cursorWidth:Ne(new g(31,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(247,null)})),disableLayerHinting:Ne(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new i(34,"domReadOnly",!1)),dragAndDrop:Ne(new i(35,"dragAndDrop",!0,{description:l.localize(248,null)})),emptySelectionClipboard:Ne(new V),dropIntoEditor:Ne(new et),stickyScroll:Ne(new ce),experimentalWhitespaceRendering:Ne(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),extraEditorClassName:Ne(new n(39,"extraEditorClassName","")),fastScrollSensitivity:Ne(new b(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:l.localize(253,null)})),find:Ne(new j),fixedOverflowWidgets:Ne(new i(42,"fixedOverflowWidgets",!1)),folding:Ne(new i(43,"folding",!0,{description:l.localize(254,null)})),foldingStrategy:Ne(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(255,null),l.localize(256,null)],description:l.localize(257,null)})),foldingHighlight:Ne(new i(45,"foldingHighlight",!0,{description:l.localize(258,null)})),foldingImportsByDefault:Ne(new i(46,"foldingImportsByDefault",!1,{description:l.localize(259,null)})),foldingMaximumRegions:Ne(new g(47,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(260,null)})),unfoldOnClickAfterEndOfLine:Ne(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(261,null)})),fontFamily:Ne(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(262,null)})),fontInfo:Ne(new z),fontLigatures2:Ne(new W),fontSize:Ne(new ee),fontWeight:Ne(new X),fontVariations:Ne(new O),formatOnPaste:Ne(new i(55,"formatOnPaste",!1,{description:l.localize(263,null)})),formatOnType:Ne(new i(56,"formatOnType",!1,{description:l.localize(264,null)})),glyphMargin:Ne(new i(57,"glyphMargin",!0,{description:l.localize(265,null)})),gotoLocation:Ne(new Ee),hideCursorInOverviewRuler:Ne(new i(59,"hideCursorInOverviewRuler",!1,{description:l.localize(266,null)})),hover:Ne(new ke),inDiffEditor:Ne(new i(61,"inDiffEditor",!1)),letterSpacing:Ne(new b(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>b.clamp(_,-5,20),{description:l.localize(267,null)})),lightbulb:Ne(new ye),lineDecorationsWidth:Ne(new ie),lineHeight:Ne(new N),lineNumbers:Ne(new he),lineNumbersMinChars:Ne(new g(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new i(69,"linkedEditing",!1,{description:l.localize(268,null)})),links:Ne(new i(70,"links",!0,{description:l.localize(269,null)})),matchBrackets:Ne(new s(71,"matchBrackets","always",["always","near","never"],{description:l.localize(270,null)})),minimap:Ne(new q),mouseStyle:Ne(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new b(74,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:l.localize(271,null)})),mouseWheelZoom:Ne(new i(75,"mouseWheelZoom",!1,{markdownDescription:l.localize(272,null)})),multiCursorMergeOverlapping:Ne(new i(76,"multiCursorMergeOverlapping",!0,{description:l.localize(273,null)})),multiCursorModifier:Ne(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[l.localize(274,null),l.localize(275,null)],markdownDescription:l.localize(276,null)})),multiCursorPaste:Ne(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(277,null),l.localize(278,null)],markdownDescription:l.localize(279,null)})),multiCursorLimit:Ne(new g(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(280,null)})),occurrencesHighlight:Ne(new i(80,"occurrencesHighlight",!0,{description:l.localize(281,null)})),overviewRulerBorder:Ne(new i(81,"overviewRulerBorder",!0,{description:l.localize(282,null)})),overviewRulerLanes:Ne(new g(82,"overviewRulerLanes",3,0,3)),padding:Ne(new we),pasteAs:Ne(new Ze),parameterHints:Ne(new ve),peekWidgetDefaultFocus:Ne(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(283,null),l.localize(284,null)],description:l.localize(285,null)})),definitionLinkOpensInPeek:Ne(new i(87,"definitionLinkOpensInPeek",!1,{description:l.localize(286,null)})),quickSuggestions:Ne(new De),quickSuggestionsDelay:Ne(new g(89,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(287,null)})),readOnly:Ne(new i(90,"readOnly",!1)),readOnlyMessage:Ne(new fe),renameOnType:Ne(new i(92,"renameOnType",!1,{description:l.localize(288,null),markdownDeprecationMessage:l.localize(289,null)})),renderControlCharacters:Ne(new i(93,"renderControlCharacters",!0,{description:l.localize(290,null),restricted:!0})),renderFinalNewline:Ne(new s(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:l.localize(291,null)})),renderLineHighlight:Ne(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(292,null)],description:l.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Ne(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(294,null)})),renderValidationDecorations:Ne(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(295,null),l.localize(296,null),l.localize(297,null),""],description:l.localize(298,null)})),revealHorizontalRightPadding:Ne(new g(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new i(100,"roundedSelection",!0,{description:l.localize(299,null)})),rulers:Ne(new oe),scrollbar:Ne(new M),scrollBeyondLastColumn:Ne(new g(103,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(300,null)})),scrollBeyondLastLine:Ne(new i(104,"scrollBeyondLastLine",!0,{description:l.localize(301,null)})),scrollPredominantAxis:Ne(new i(105,"scrollPredominantAxis",!0,{description:l.localize(302,null)})),selectionClipboard:Ne(new i(106,"selectionClipboard",!0,{description:l.localize(303,null),included:C.$k})),selectionHighlight:Ne(new i(107,"selectionHighlight",!0,{description:l.localize(304,null)})),selectOnLineNumbers:Ne(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(305,null),l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),showUnused:Ne(new i(110,"showUnused",!0,{description:l.localize(309,null)})),showDeprecated:Ne(new i(138,"showDeprecated",!0,{description:l.localize(310,null)})),inlayHints:Ne(new $e),snippetSuggestions:Ne(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(311,null),l.localize(312,null),l.localize(313,null),l.localize(314,null)],description:l.localize(315,null)})),smartSelect:Ne(new Le),smoothScrolling:Ne(new i(113,"smoothScrolling",!1,{description:l.localize(316,null)})),stopRenderingLineAfter:Ne(new g(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new ae),inlineSuggest:Ne(new G),inlineCompletionsAccessibilityVerbose:Ne(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(317,null)})),suggestFontSize:Ne(new g(118,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new g(119,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new i(120,"suggestOnTriggerCharacters",!0,{description:l.localize(320,null)})),suggestSelection:Ne(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(321,null),l.localize(322,null),l.localize(323,null)],description:l.localize(324,null)})),tabCompletion:Ne(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(325,null),l.localize(326,null),l.localize(327,null)],description:l.localize(328,null)})),tabIndex:Ne(new g(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new K),unusualLineTerminators:Ne(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(329,null),l.localize(330,null),l.localize(331,null)],description:l.localize(332,null)})),useShadowDOM:Ne(new i(126,"useShadowDOM",!0)),useTabStops:Ne(new i(127,"useTabStops",!0,{description:l.localize(333,null)})),wordBreak:Ne(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(334,null),l.localize(335,null)],description:l.localize(336,null)})),wordSeparators:Ne(new n(129,"wordSeparators",A.$Tr,{description:l.localize(337,null)})),wordWrap:Ne(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(338,null),l.localize(339,null),l.localize(340,null),l.localize(341,null)],description:l.localize(342,null)})),wordWrapBreakAfterCharacters:Ne(new n(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new n(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new g(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(343,null)})),wordWrapOverride1:Ne(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new B),defaultColorDecorators:Ne(new i(145,"defaultColorDecorators",!1,{markdownDescription:l.localize(344,null)})),pixelRatio:Ne(new me),tabFocusMode:Ne(new i(142,"tabFocusMode",!1,{markdownDescription:l.localize(345,null)})),layoutInfo:Ne(new Z),wrappingInfo:Ne(new He),wrappingIndent:Ne(new Ye),wrappingStrategy:Ne(new ue)}}),define(Ae[138],Re([10,11]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[139],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[140],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[141],Re([10,11]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[142],Re([10,11]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[143],Re([10,11]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Ae[144],Re([10,11]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Ae[145],Re([10,11]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[146],Re([10,11]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Ae[147],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[148],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[149],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[150],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[151],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[152],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[153],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[154],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[155],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[156],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[157],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[158],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[159],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[160],Re([10,11]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Ae[161],Re([10,11]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Ae[162],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[163],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[164],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[165],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[166],Re([10,11]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[167],Re([10,11]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[168],Re([10,11]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[169],Re([1,0,9,140]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.TokenType=void 0;var C;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(C||(e.TokenType=C={}));function L(...f){switch(f.length){case 1:return(0,F.localize)(0,null,f[0]);case 2:return(0,F.localize)(1,null,f[0],f[1]);case 3:return(0,F.localize)(2,null,f[0],f[1],f[2]);default:return}}const A=(0,F.localize)(3,null),l=(0,F.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,w.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const D=this.d,u=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:u};this.g.push({offset:D,lexeme:u,additionalInfo:P}),this.f.push(p)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const D=this.c.substring(this.d,this.e),u=S.b.get(D);u?this.k(u):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,D=!1,u=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(l);return}const $=this.c.charCodeAt(P);if(D)D=!1;else if($===47&&!u){P++;break}else $===91?u=!0:$===92?D=!0:$===93&&(u=!1);P++}for(;P<this.c.length&&S.a.has(this.c.charCodeAt(P));)P++;this.e=P;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ei=S}),define(Ae[170],Re([1,0,23,29,142,276]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function S(i){return i=i.trim(),i==="*"||A.test(i)}e.$Ao=S;function f(i){if(!S(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=i.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$Bo=f;function P(i){if(!i)return null;const c=i.majorBase,g=i.majorMustEqual,k=i.minorBase;let b=i.minorMustEqual;const n=i.patchBase;let a=i.patchMustEqual;i.hasCaret&&(c===0||(b=!1),a=!1);let s=0;if(i.preRelease){const o=l.exec(i.preRelease);if(o){const[,y,m,I]=o;s=Date.UTC(Number(y),Number(m)-1,Number(I))}}return{majorBase:c,majorMustEqual:g,minorBase:k,minorMustEqual:b,patchBase:n,patchMustEqual:a,isMinimum:i.hasGreaterEquals,notBefore:s}}e.$Co=P;function D(i,c,g){let k;typeof i=="string"?k=P(f(i)):k=i;let b;c instanceof Date?b=c.getTime():typeof c=="string"&&(b=new Date(c).getTime());let n;if(typeof g=="string"?n=P(f(g)):n=g,!k||!n)return!1;const a=k.majorBase,s=k.minorBase,o=k.patchBase;let y=n.majorBase,m=n.minorBase,I=n.patchBase;const E=n.notBefore;let r=n.majorMustEqual,d=n.minorMustEqual,v=n.patchMustEqual;return n.isMinimum?a>y?!0:a<y?!1:s>m?!0:s<m||b&&b<E?!1:o>=I:(a===1&&y===0&&(!r||!d||!v)&&(y=1,m=0,I=0,r=!0,d=!1,v=!1),a<y?!1:a>y?!r:s<m?!1:s>m?!d:o<I?!1:o>I?!v:!(b&&b<E))}e.$Do=D;function u(i,c,g,k,b){const n=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return n.push([F.default.Error,C.localize(0,null)]),n;if(typeof k.name!="string")return n.push([F.default.Error,C.localize(1,null,"name")]),n;if(typeof k.version!="string")return n.push([F.default.Error,C.localize(2,null,"version")]),n;if(!k.engines)return n.push([F.default.Error,C.localize(3,null,"engines")]),n;if(typeof k.engines.vscode!="string")return n.push([F.default.Error,C.localize(4,null,"engines.vscode")]),n;if(typeof k.extensionDependencies<"u"&&!t(k.extensionDependencies))return n.push([F.default.Error,C.localize(5,null,"extensionDependencies")]),n;if(typeof k.activationEvents<"u"){if(!t(k.activationEvents))return n.push([F.default.Error,C.localize(6,null,"activationEvents")]),n;if(typeof k.main>"u"&&typeof k.browser>"u")return n.push([F.default.Error,C.localize(7,null,"activationEvents","main","browser")]),n}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&n.push([F.default.Warning,C.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return n.push([F.default.Error,C.localize(9,null,"main")]),n;{const o=(0,w.$hg)(g,k.main);(0,w.$bg)(o,g)||n.push([F.default.Warning,C.localize(10,null,o.path,g.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return n.push([F.default.Error,C.localize(11,null,"browser")]),n;{const o=(0,w.$hg)(g,k.browser);(0,w.$bg)(o,g)||n.push([F.default.Warning,C.localize(12,null,o.path,g.path)])}}if(!L.valid(k.version))return n.push([F.default.Error,C.localize(13,null)]),n;const a=[];if(!p(i,c,k,b,a))for(const o of a)n.push([F.default.Error,o]);return n}e.$Eo=u;function p(i,c,g,k,b){return k||typeof g.main>"u"&&typeof g.browser>"u"?!0:h(i,c,g.engines.vscode,b)}e.$Fo=p;function $(i,c,g){return i==="*"||h(c,g,i)}e.$Go=$;function h(i,c,g,k=[]){const b=P(f(g));if(!b)return k.push(C.localize(14,null,g)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return k.push(C.localize(15,null,g)),!1}else if(!b.majorMustEqual)return k.push(C.localize(16,null,g)),!1;return D(i,c,b)?!0:(k.push(C.localize(17,null,i,g)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let c=0,g=i.length;c<g;c++)if(typeof i[c]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class w{constructor(C,L=[],A=!1){this.ctor=C,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$xh=w}),define(Ae[70],Re([1,0,69]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.InstantiationType=void 0;const F=[];var C;(function(l){l[l.Eager=0]="Eager",l[l.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function L(l,S,f){S instanceof w.$xh||(S=new w.$xh(S,[],!!f)),F.push([l,S])}e.$kr=L;function A(){return F}e.$lr=A}),define(Ae[171],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0;class w{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$2p=w;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const l=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(A);l.outgoing.set(S.key,S),S.incoming.set(l.key,l)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const l of this.a.values())l.outgoing.delete(A),l.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let l=this.a.get(A);return l||(l=new w(A,L),this.a.set(A,l)),l}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,l]of this.a)L.push(`${A}
	(-> incoming)[${[...l.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...l.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const l=new Set([L]),S=this.c(A,l);if(S)return S}}c(L,A){for(const[l,S]of L.outgoing){if(A.has(l))return[...A,l].join(" -> ");A.add(l);const f=this.c(S,A);if(f)return f;A.delete(l)}}}e.$3p=F}),define(Ae[4],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e._util=void 0;var w;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function l(S){return S[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=l})(w||(e._util=w={})),e.$zh=C("instantiationService");function F(A,l,S){l[w.DI_TARGET]===l?l[w.DI_DEPENDENCIES].push({id:A,index:S}):(l[w.DI_DEPENDENCIES]=[{id:A,index:S}],l[w.DI_TARGET]=l)}function C(A){if(w.serviceIds.has(A))return w.serviceIds.get(A);const l=function(S,f,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(l,S,P)};return l.toString=()=>A,w.serviceIds.set(A,l),l}e.$Ah=C;function L(A){return A}e.$Bh=L}),define(Ae[43],Re([1,0,16,2,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.ConfigurationTarget=e.$9h=e.$8h=e.$7h=void 0,e.$7h=(0,C.$Ah)("configurationService");function L(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof F.URI)}e.$8h=L;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof F.URI)}e.$9h=A;var l;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(l||(e.ConfigurationTarget=l={}));function S(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$0h=S;function f(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$$h=f;function P(i,c){const g=Object.create(null);for(const k in i)D(g,k,i[k],c);return g}e.$_h=P;function D(i,c,g,k){const b=c.split("."),n=b.pop();let a=i;for(let s=0;s<b.length;s++){const o=b[s];let y=a[o];switch(typeof y){case"undefined":y=a[o]=Object.create(null);break;case"object":break;default:k(`Ignoring ${c} as ${b.slice(0,s+1).join(".")} is ${JSON.stringify(y)}`);return}a=y}if(typeof a=="object"&&a!==null)try{a[n]=g}catch{k(`Ignoring ${c} as ${b.join(".")} is ${JSON.stringify(a)}`)}else k(`Ignoring ${c} as ${b.join(".")} is ${JSON.stringify(a)}`)}e.$ai=D;function u(i,c){const g=c.split(".");p(i,g)}e.$bi=u;function p(i,c){const g=c.shift();if(c.length===0){delete i[g];return}if(Object.keys(i).indexOf(g)!==-1){const k=i[g];typeof k=="object"&&!Array.isArray(k)&&(p(k,c),Object.keys(k).length===0&&delete i[g])}}function $(i,c,g){function k(a,s){let o=a;for(const y of s){if(typeof o!="object"||o===null)return;o=o[y]}return o}const b=c.split("."),n=k(i,b);return typeof n>"u"?g:n}e.$ci=$;function h(i,c,g){Object.keys(c).forEach(k=>{k!=="__proto__"&&(k in i?w.$kf(i[k])&&w.$kf(c[k])?h(i[k],c[k],g):g&&(i[k]=c[k]):i[k]=c[k])})}e.$di=h;function t(i){return i.replace(/[\[\]]/g,"")}e.$ei=t}),define(Ae[32],Re([1,0,22,15,169,4,139,9]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.ContextKeyExprType=e.$Fi=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",w.$j),S.set("isLinux",w.$k),S.set("isWindows",w.$i),S.set("isWeb",w.$o),S.set("isMacNative",w.$j&&!w.$o),S.set("isEdge",w.$G),S.set("isFirefox",w.$E),S.set("isChrome",w.$D),S.set("isSafari",w.$F);function f(ie,N){if(S.get(ie)!==void 0)throw(0,l.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(ie,N)}e.$Fi=f;const P=Object.prototype.hasOwnProperty;var D;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const u={regexParsingWithErrorRecovery:!0},p=(0,A.localize)(0,null),$=(0,A.localize)(1,null),h=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),c=(0,A.localize)(5,null),g=(0,A.localize)(6,null),k=(0,A.localize)(7,null);class b{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(N=u){this.k=N,this.d=new C.$Ei,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(N){if(N===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(N).scan(),this.g=0,this.h=[];try{const q=this.l();if(!this.E()){const le=this.D(),we=le.type===17?c:void 0;throw this.h.push({message:i,offset:le.offset,lexeme:C.$Ei.getLexeme(le),additionalInfo:we}),b.c}return q}catch(q){if(q!==b.c)throw q;return}}l(){return this.m()}m(){const N=[this.o()];for(;this.y(16);){const q=this.o();N.push(q)}return N.length===1?N[0]:n.or(...N)}o(){const N=[this.s()];for(;this.y(15);){const q=this.s();N.push(q)}return N.length===1?N[0]:n.and(...N)}s(){if(this.y(2)){const N=this.D();switch(N.type){case 11:return this.z(),y.INSTANCE;case 12:return this.z(),m.INSTANCE;case 0:{this.z();const q=this.l();return this.A(1,t),q?.negate()}case 17:return this.z(),R.create(N.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",N)}}return this.t()}t(){const N=this.D();switch(N.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const q=this.l();return this.A(1,t),q}case 17:{const q=N.lexeme;if(this.z(),this.y(9)){const we=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),we.type!==10)throw this.B("REGEX",we);const ve=we.lexeme,me=ve.lastIndexOf("/"),De=me===ve.length-1?void 0:this.w(ve.substring(me+1));let ne;try{ne=new RegExp(ve.substring(1,me),De)}catch{throw this.B("REGEX",we)}return z.create(q,ne)}switch(we.type){case 10:case 19:{const ve=[we.lexeme];this.z();let me=this.D(),De=0;for(let fe=0;fe<we.lexeme.length;fe++)we.lexeme.charCodeAt(fe)===40?De++:we.lexeme.charCodeAt(fe)===41&&De--;for(;!this.E()&&me.type!==15&&me.type!==16;){switch(me.type){case 0:De++;break;case 1:De--;break;case 10:case 18:for(let fe=0;fe<me.lexeme.length;fe++)me.lexeme.charCodeAt(fe)===40?De++:we.lexeme.charCodeAt(fe)===41&&De--}if(De<0)break;ve.push(C.$Ei.getLexeme(me)),this.z(),me=this.D()}const ne=ve.join(""),he=ne.lastIndexOf("/"),se=he===ne.length-1?void 0:this.w(ne.substring(he+1));let oe;try{oe=new RegExp(ne.substring(1,he),se)}catch{throw this.B("REGEX",we)}return n.regex(q,oe)}case 18:{const ve=we.lexeme;this.z();let me=null;if(!(0,F.$le)(ve)){const De=ve.indexOf("/"),ne=ve.lastIndexOf("/");if(De!==ne&&De>=0){const he=ve.slice(De+1,ne),se=ve[ne+1]==="i"?"i":"";try{me=new RegExp(he,se)}catch{throw this.B("REGEX",we)}}}if(me===null)throw this.B("REGEX",we);return z.create(q,me)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,h);const we=this.u();return n.notIn(q,we)}switch(this.D().type){case 3:{this.z();const we=this.u();if(this.x().type===18)return n.equals(q,we);switch(we){case"true":return n.has(q);case"false":return n.not(q);default:return n.equals(q,we)}}case 4:{this.z();const we=this.u();if(this.x().type===18)return n.notEquals(q,we);switch(we){case"true":return n.not(q);case"false":return n.has(q);default:return n.notEquals(q,we)}}case 5:return this.z(),W.create(q,this.u());case 6:return this.z(),O.create(q,this.u());case 7:return this.z(),V.create(q,this.u());case 8:return this.z(),j.create(q,this.u());case 13:return this.z(),n.in(q,this.u());default:return n.has(q)}}case 20:throw this.h.push({message:g,offset:N.offset,lexeme:"",additionalInfo:k}),b.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const N=this.D();switch(N.type){case 17:case 18:return this.z(),N.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(N){return N.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(N){return this.C(N)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(N,q){if(this.C(N))return this.z();throw this.B(q,this.D())}B(N,q,le){const we=(0,A.localize)(8,null,N,C.$Ei.getLexeme(q)),ve=q.offset,me=C.$Ei.getLexeme(q);return this.h.push({message:we,offset:ve,lexeme:me,additionalInfo:le}),b.c}C(N){return this.D().type===N}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Gi=b;class n{static false(){return y.INSTANCE}static true(){return m.INSTANCE}static has(N){return I.create(N)}static equals(N,q){return E.create(N,q)}static notEquals(N,q){return v.create(N,q)}static regex(N,q){return z.create(N,q)}static in(N,q){return r.create(N,q)}static notIn(N,q){return d.create(N,q)}static not(N){return R.create(N)}static and(...N){return Ee.create(N,null,!0)}static or(...N){return ke.create(N,null,!0)}static greater(N,q){return V.create(N,q)}static greaterEquals(N,q){return j.create(N,q)}static smaller(N,q){return W.create(N,q)}static smallerEquals(N,q){return O.create(N,q)}static{this.c=new b({regexParsingWithErrorRecovery:!1})}static deserialize(N){return N==null?void 0:this.c.parse(N)}}e.$Hi=n;function a(ie){const N=new b({regexParsingWithErrorRecovery:!1});return ie.map(q=>(N.parse(q),N.lexingErrors.length>0?N.lexingErrors.map(le=>({errorMessage:le.additionalInfo?(0,A.localize)(9,null,le.additionalInfo):(0,A.localize)(10,null),offset:le.offset,length:le.lexeme.length})):N.parsingErrors.length>0?N.parsingErrors.map(le=>({errorMessage:le.additionalInfo?`${le.message}. ${le.additionalInfo}`:le.message,offset:le.offset,length:le.lexeme.length})):[]))}e.$Ii=a;function s(ie,N){const q=ie?ie.substituteConstants():void 0,le=N?N.substituteConstants():void 0;return!q&&!le?!0:!q||!le?!1:q.equals(le)}e.$Ji=s;function o(ie,N){return ie.cmp(N)}class y{static{this.INSTANCE=new y}constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return m.INSTANCE}}e.$Ki=y;class m{static{this.INSTANCE=new m}constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return y.INSTANCE}}e.$Li=m;class I{static create(N,q=null){const le=S.get(N);return typeof le=="boolean"?le?m.INSTANCE:y.INSTANCE:new I(N,q)}constructor(N,q){this.key=N,this.c=q,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:Z(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=S.get(this.key);return typeof N=="boolean"?N?m.INSTANCE:y.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$Mi=I;class E{static create(N,q,le=null){if(typeof q=="boolean")return q?I.create(N,le):R.create(N,le);const we=S.get(N);return typeof we=="boolean"?q===(we?"true":"false")?m.INSTANCE:y.INSTANCE:new E(N,q,le)}constructor(N,q,le){this.c=N,this.d=q,this.f=le,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:ue(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=S.get(this.c);if(typeof N=="boolean"){const q=N?"true":"false";return this.d===q?m.INSTANCE:y.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Ni=E;class r{static create(N,q){return new r(N,q)}constructor(N,q){this.d=N,this.f=q,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:ue(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const q=N.getValue(this.f),le=N.getValue(this.d);return Array.isArray(q)?q.includes(le):typeof le=="string"&&typeof q=="object"&&q!==null?P.call(q,le):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.$Oi=r;class d{static create(N,q){return new d(N,q)}constructor(N,q){this.d=N,this.f=q,this.type=11,this.c=r.create(N,q)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Pi=d;class v{static create(N,q,le=null){if(typeof q=="boolean")return q?R.create(N,le):I.create(N,le);const we=S.get(N);return typeof we=="boolean"?q===(we?"true":"false")?y.INSTANCE:m.INSTANCE:new v(N,q,le)}constructor(N,q,le){this.c=N,this.d=q,this.f=le,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:ue(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=S.get(this.c);if(typeof N=="boolean"){const q=N?"true":"false";return this.d===q?y.INSTANCE:m.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$Qi=v;class R{static create(N,q=null){const le=S.get(N);return typeof le=="boolean"?le?y.INSTANCE:m.INSTANCE:new R(N,q)}constructor(N,q){this.c=N,this.d=q,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:Z(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=S.get(this.c);return typeof N=="boolean"?N?y.INSTANCE:m.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Ri=R;function B(ie,N){if(typeof ie=="string"){const q=parseFloat(ie);isNaN(q)||(ie=q)}return typeof ie=="string"||typeof ie=="number"?N(ie):y.INSTANCE}class V{static create(N,q,le=null){return B(q,we=>new V(N,we,le))}constructor(N,q,le){this.c=N,this.d=q,this.f=le,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:ue(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Si=V;class j{static create(N,q,le=null){return B(q,we=>new j(N,we,le))}constructor(N,q,le){this.c=N,this.d=q,this.f=le,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:ue(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Ti=j;class W{static create(N,q,le=null){return B(q,we=>new W(N,we,le))}constructor(N,q,le){this.c=N,this.d=q,this.f=le,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:ue(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Ui=W;class O{static create(N,q,le=null){return B(q,we=>new O(N,we,le))}constructor(N,q,le){this.c=N,this.d=q,this.f=le,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:ue(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Vi=O;class z{static create(N,q){return new z(N,q)}constructor(N,q){this.d=N,this.f=q,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const q=this.f?this.f.source:"",le=N.f?N.f.source:"";return q<le?-1:q>le?1:0}equals(N){if(N.type===this.type){const q=this.f?this.f.source:"",le=N.f?N.f.source:"";return this.d===N.d&&q===le}return!1}substituteConstants(){return this}evaluate(N){const q=N.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$Wi=z;class ee{static create(N){return new ee(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(N){return new ee(this.c.map(N))}negate(){return this.c}}e.$Xi=ee;function X(ie){let N=null;for(let q=0,le=ie.length;q<le;q++){const we=ie[q].substituteConstants();if(ie[q]!==we&&N===null){N=[];for(let ve=0;ve<q;ve++)N[ve]=ie[ve]}N!==null&&(N[q]=we)}return N===null?ie:N}class Ee{static create(N,q,le){return Ee.d(N,q,le)}constructor(N,q){this.expr=N,this.c=q,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let q=0,le=this.expr.length;q<le;q++){const we=o(this.expr[q],N.expr[q]);if(we!==0)return we}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].equals(N.expr[q]))return!1;return!0}return!1}substituteConstants(){const N=X(this.expr);return N===this.expr?this:Ee.create(N,this.c,!1)}evaluate(N){for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].evaluate(N))return!1;return!0}static d(N,q,le){const we=[];let ve=!1;for(const me of N)if(me){if(me.type===1){ve=!0;continue}if(me.type===0)return y.INSTANCE;if(me.type===6){we.push(...me.expr);continue}we.push(me)}if(we.length===0&&ve)return m.INSTANCE;if(we.length!==0){if(we.length===1)return we[0];we.sort(o);for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];for(;we.length>1;){const me=we[we.length-1];if(me.type!==9)break;we.pop();const De=we.pop(),ne=we.length===0,he=ke.create(me.expr.map(se=>Ee.create([se,De],null,le)),null,ne);he&&(we.push(he),we.sort(o))}if(we.length===1)return we[0];if(le){for(let me=0;me<we.length;me++)for(let De=me+1;De<we.length;De++)if(we[me].negate().equals(we[De]))return y.INSTANCE;if(we.length===1)return we[0]}return new Ee(we,q)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const q of this.expr)N.push(...q.keys());return N}map(N){return new Ee(this.expr.map(q=>q.map(N)),null)}negate(){if(!this.c){const N=[];for(const q of this.expr)N.push(q.negate());this.c=ke.create(N,this,!0)}return this.c}}e.$Yi=Ee;class ke{static create(N,q,le){return ke.d(N,q,le)}constructor(N,q){this.expr=N,this.c=q,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let q=0,le=this.expr.length;q<le;q++){const we=o(this.expr[q],N.expr[q]);if(we!==0)return we}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].equals(N.expr[q]))return!1;return!0}return!1}substituteConstants(){const N=X(this.expr);return N===this.expr?this:ke.create(N,this.c,!1)}evaluate(N){for(let q=0,le=this.expr.length;q<le;q++)if(this.expr[q].evaluate(N))return!0;return!1}static d(N,q,le){let we=[],ve=!1;if(N){for(let me=0,De=N.length;me<De;me++){const ne=N[me];if(ne){if(ne.type===0){ve=!0;continue}if(ne.type===1)return m.INSTANCE;if(ne.type===9){we=we.concat(ne.expr);continue}we.push(ne)}}if(we.length===0&&ve)return y.INSTANCE;we.sort(o)}if(we.length!==0){if(we.length===1)return we[0];for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];if(le){for(let me=0;me<we.length;me++)for(let De=me+1;De<we.length;De++)if(we[me].negate().equals(we[De]))return m.INSTANCE;if(we.length===1)return we[0]}return new ke(we,q)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const q of this.expr)N.push(...q.keys());return N}map(N){return new ke(this.expr.map(q=>q.map(N)),null)}negate(){if(!this.c){const N=[];for(const q of this.expr)N.push(q.negate());for(;N.length>1;){const q=N.shift(),le=N.shift(),we=[];for(const ve of $e(q))for(const me of $e(le))we.push(Ee.create([ve,me],null,!1));N.unshift(ke.create(we,null,!1))}this.c=ke.create(N,this,!0)}return this.c}}e.$Zi=ke;class Pe extends I{static{this.d=[]}static all(){return Pe.d.values()}constructor(N,q,le){super(N,null),this.f=q,typeof le=="object"?Pe.d.push({...le,key:N}):le!==!0&&Pe.d.push({key:N,description:le,type:q!=null?typeof q:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return E.create(this.key,N)}notEqualsTo(N){return v.create(this.key,N)}}e.$1i=Pe,e.$2i=(0,L.$Ah)("contextKeyService");function Z(ie,N){return ie<N?-1:ie>N?1:0}function ue(ie,N,q,le){return ie<q?-1:ie>q?1:N<le?-1:N>le?1:0}function ye(ie,N){if(ie.type===0||N.type===1)return!0;if(ie.type===9)return N.type===9?ce(ie.expr,N.expr):!1;if(N.type===9){for(const q of N.expr)if(ye(ie,q))return!0;return!1}if(ie.type===6){if(N.type===6)return ce(N.expr,ie.expr);for(const q of ie.expr)if(ye(q,N))return!0;return!1}return ie.equals(N)}e.$3i=ye;function ce(ie,N){let q=0,le=0;for(;q<ie.length&&le<N.length;){const we=ie[q].cmp(N[le]);if(we<0)return!1;we===0&&q++,le++}return q===ie.length}function $e(ie){return ie.type===9?ie.expr:[ie]}}),define(Ae[172],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=void 0,e.$Hh=(0,w.$Ah)("environmentService"),e.$Ih=(0,w.$Bh)(e.$Hh)}),define(Ae[92],Re([1,0,141,4]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Yn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0,e.$Ln="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Mn=new RegExp(e.$Ln),e.$Nn="__web_extension",e.$On="skipWalkthrough",e.$Pn="extensionsSync",e.$Qn="dependecyOrPackExtensionInstall";function C(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Rn=C;function L(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Sn=L;function A(c,g){switch(c){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Tn=A;function l(c,g){return g==="web"&&!c.includes("web")}e.$Un=l;function S(c,g,k){return l(g,k)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===k?!0:f(k).includes(c)}e.$Vn=S;function f(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Wn=f;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$Xn=P;var D;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var u;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(u||(e.SortOrder=u={}));var p;(function(c){c.Install="install",c.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var $;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Yn=(0,F.$Ah)("extensionGalleryService");var h;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(h||(e.ExtensionManagementErrorCode=h={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(g,k){super(g),this.code=k,this.name=k}}e.$Zn=i,e.$1n=(0,F.$Ah)("extensionManagementService"),e.$2n="extensionsIdentifiers/disabled",e.$3n="extensionsIdentifiers/enabled",e.$4n=(0,F.$Ah)("IGlobalExtensionEnablementService"),e.$5n=(0,F.$Ah)("IExtensionTipsService"),e.$6n=(0,w.localize)(0,null),e.$7n={value:e.$6n,original:"Extensions"},e.$8n={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Ae[38],Re([1,0,48,19,15,16,2,143,4,22,12]),function(be,e,w,F,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileKind=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileOperationResult=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileChangeType=e.$jk=e.FileOperation=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileSystemProviderErrorCode=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$6j=e.$5j=void 0,e.$5j=(0,S.$Ah)("fileService");function D(Z){return Z.create===!0}e.$6j=D;var u;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var p;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var $;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function h(Z){return!!(Z.capabilities&2)}e.$7j=h;function t(Z){return!!(Z.capabilities&8)}e.$8j=t;function i(Z){return!!(Z.capabilities&131072)}e.$9j=i;function c(Z){return!!(Z.capabilities&4)}e.$0j=c;function g(Z){return!!(Z.capabilities&16)}e.$$j=g;function k(Z){return h(Z)?!!(Z.capabilities&16384):!1}e.$_j=k;function b(Z){return h(Z)?!!(Z.capabilities&32768):!1}e.$ak=b;function n(Z){return!!(Z.capabilities&65536)}e.$bk=n;function a(Z){return!!(Z.capabilities&2048)}e.$ck=a;var s;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class o extends Error{static create(ue,ye){const ce=new o(ue.toString(),ye);return I(ce,ye),ce}constructor(ue,ye){super(ue),this.code=ye}}e.$dk=o;function y(Z,ue){return o.create(Z,ue)}e.$ek=y;function m(Z){return Z||y((0,l.localize)(0,null),s.Unknown)}e.$fk=m;function I(Z,ue){return Z.name=ue?`${ue} (FileSystemError)`:"FileSystemError",Z}e.$gk=I;function E(Z){if(!Z)return s.Unknown;if(Z instanceof o)return Z.code;const ue=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!ue)return s.Unknown;switch(ue[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$hk=E;function r(Z){if(Z instanceof j)return Z.fileOperationResult;switch(E(Z)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$ik=r;var d;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(d||(e.FileOperation=d={}));class v{constructor(ue,ye,ce){this.resource=ue,this.operation=ye,this.target=ce}isOperation(ue){return this.operation===ue}}e.$jk=v;var R;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(R||(e.FileChangeType=R={}));class B{constructor(ue,ye){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const $e of ue){const ie=ce.get($e.type);switch(ie?ie.push([$e.resource,$e]):ce.set($e.type,[[$e.resource,$e]]),$e.type){case 1:this.rawAdded.push($e.resource);break;case 0:this.rawUpdated.push($e.resource);break;case 2:this.rawDeleted.push($e.resource);break}}for(const[$e,ie]of ce)switch($e){case 1:this.a=w.$Gh.forUris(()=>ye),this.a.fill(ie);break;case 0:this.b=w.$Gh.forUris(()=>ye),this.b.fill(ie);break;case 2:this.c=w.$Gh.forUris(()=>ye),this.c.fill(ie);break}}contains(ue,...ye){return this.d(ue,{includeChildren:!1},...ye)}affects(ue,...ye){return this.d(ue,{includeChildren:!0},...ye)}d(ue,ye,...ce){if(!ue)return!1;const $e=ce.length>0;return!!((!$e||ce.includes(1))&&(this.a?.get(ue)||ye.includeChildren&&this.a?.findSuperstr(ue))||(!$e||ce.includes(0))&&(this.b?.get(ue)||ye.includeChildren&&this.b?.findSuperstr(ue))||(!$e||ce.includes(2))&&(this.c?.findSubstr(ue)||ye.includeChildren&&this.c?.findSuperstr(ue)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$kk=B;function V(Z,ue,ye){return!Z||!ue||Z===ue||ue.length>Z.length?!1:(ue.charAt(ue.length-1)!==F.sep&&(ue+=F.sep),ye?(0,C.$Me)(Z,ue):Z.indexOf(ue)===0)}e.$lk=V;class j extends Error{constructor(ue,ye,ce){super(ue),this.fileOperationResult=ye,this.options=ce}}e.$mk=j;class W extends j{constructor(ue,ye,ce,$e){super(ue,ye,$e),this.fileOperationResult=ye,this.size=ce}}e.$nk=W;class O extends j{constructor(ue,ye,ce){super(ue,2,ce),this.stat=ye}}e.$ok=O;var z;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(z||(e.FileOperationResult=z={})),e.$pk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$qk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$rk="files.associations",e.$sk="files.exclude",e.$tk="files.readonlyInclude",e.$uk="files.readonlyExclude",e.$vk="files.readonlyFromPermissions";var ee;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(ee||(e.FileKind=ee={})),e.$wk="";function X(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}e.$xk=X;async function Ee(Z,ue){if(!ue.hasProvider(A.URI.from({scheme:Z.scheme})))return new Promise(ye=>{const ce=ue.onDidChangeFileSystemProviderRegistrations($e=>{$e.scheme===Z.scheme&&$e.added&&(ce.dispose(),ye())})})}e.$yk=Ee;class ke{static{this.KB=1024}static{this.MB=ke.KB*ke.KB}static{this.GB=ke.MB*ke.KB}static{this.TB=ke.GB*ke.KB}static formatSize(ue){return(0,L.$mf)(ue)||(ue=0),ue<ke.KB?(0,l.localize)(1,null,ue.toFixed(0)):ue<ke.MB?(0,l.localize)(2,null,(ue/ke.KB).toFixed(2)):ue<ke.GB?(0,l.localize)(3,null,(ue/ke.MB).toFixed(2)):ue<ke.TB?(0,l.localize)(4,null,(ue/ke.GB).toFixed(2)):(0,l.localize)(5,null,(ue/ke.TB).toFixed(2))}}e.$zk=ke;function Pe(Z){const ue=typeof Z=="string"||Z?.scheme===P.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===P.Schemas.file?1024*ke.MB:ue?10*ke.MB:f.$o?50*ke.MB:1024*ke.MB}e.$Ak=Pe}),define(Ae[71],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class w{constructor(...C){this.a=new Map;for(const[L,A]of C)this.set(L,A)}set(C,L){const A=this.a.get(C);return this.a.set(C,L),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$yh=w}),define(Ae[173],Re([1,0,13,9,6,69,171,4,71,174]),function(be,e,w,F,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;const P=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class u{constructor(t=new S.$yh,i=!1,c,g=P){this.f=t,this.g=i,this.h=c,this.i=g,this.o=new Set,this.f.set(l.$zh,this),this._globalGraph=g?c?._globalGraph??new A.$3p(k=>k):void 0}createChild(t){return new u(t,this.g,this,this.i)}invokeFunction(t,...i){const c=$.traceInvocation(this.i,t);let g=!1;try{return t({get:b=>{if(g)throw(0,F.$6)("service accessor is only valid during the invocation of its target method");const n=this.m(b,c);if(!n)throw new Error(`[invokeFunction] unknown service '${b}'`);return n}},...i)}finally{g=!0,c.stop()}}createInstance(t,...i){let c,g;return t instanceof L.$xh?(c=$.traceCreation(this.i,t.ctor),g=this.j(t.ctor,t.staticArguments.concat(i),c)):(c=$.traceCreation(this.i,t),g=this.j(t,i,c)),c.stop(),g}j(t,i=[],c){const g=l._util.getServiceDependencies(t).sort((n,a)=>n.index-a.index),k=[];for(const n of g){const a=this.m(n.id,c);a||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),k.push(a)}const b=g.length>0?g[0].index:i.length;if(i.length!==b){console.trace(`[createInstance] First service dependency of ${t.name} at position ${b+1} conflicts with ${i.length} static arguments`);const n=b-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,b)}return Reflect.construct(t,i.concat(k))}k(t,i){if(this.f.get(t)instanceof L.$xh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const c=this.l(t);return c instanceof L.$xh?this.q(t,c,i.branch(t,!0)):(i.branch(t,!1),c)}q(t,i,c){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,c)}finally{this.o.delete(t)}}r(t,i,c){const g=new A.$3p(n=>n.id.toString());let k=0;const b=[{id:t,desc:i,_trace:c}];for(;b.length;){const n=b.pop();if(g.lookupOrInsertNode(n),k++>1e3)throw new D(g);for(const a of l._util.getServiceDependencies(n.desc.ctor)){const s=this.l(a.id);if(s||this.u(`[createInstance] ${t} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(a.id)),s instanceof L.$xh){const o={id:a.id,desc:s,_trace:n._trace.branch(a.id,!0)};g.insertEdge(n,o),b.push(o)}}}for(;;){const n=g.roots();if(n.length===0){if(!g.isEmpty())throw new D(g);break}for(const{data:a}of n){if(this.l(a.id)instanceof L.$xh){const o=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,o)}g.removeNode(a)}}return this.l(t)}s(t,i,c=[],g,k){if(this.f.get(t)instanceof L.$xh)return this.t(t,i,c,g,k);if(this.h)return this.h.s(t,i,c,g,k);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,c=[],g,k){if(g){const b=new u(void 0,this.g,this,this.i);b.c=String(t);const n=new Map,a=new w.$Wg(()=>{const s=b.j(i,c,k);for(const[o,y]of n){const m=s[o];if(typeof m=="function")for(const I of y)m.apply(s,I)}return n.clear(),s});return new Proxy(Object.create(null),{get(s,o){if(!a.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let I=n.get(o);return I||(I=new f.$sc,n.set(o,I)),(r,d,v)=>{const R=I.push([r,d,v]);return(0,C.$hc)(R)}}if(o in s)return s[o];const y=a.value;let m=y[o];return typeof m!="function"||(m=m.bind(y),s[o]=m),m},set(s,o,y){return a.value[o]=y,!0},getPrototypeOf(s){return i.prototype}})}else return this.j(i,c,k)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$4p=u;var p;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(p||(p={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new $(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(t,i){return t?new $(1,i.name):$.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const c=new $(3,t.toString());return this.h.push([t,i,c]),c}stop(){const t=Date.now()-this.g;$.f+=t;let i=!1;function c(k,b){const n=[],a=new Array(k+1).join("	");for(const[s,o,y]of b.h)if(o&&y){i=!0,n.push(`${a}CREATES -> ${s}`);const m=c(k+1,y);m&&n.push(m)}else n.push(`${a}uses -> ${s}`);return n.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(t>2||i)&&$.all.add(g.join(`
`))}}e.$5p=$}),define(Ae[14],Re([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(be,e,w,F,C,L,A,l,S,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.log=e.$7i=e.LogLevel=e.$6i=e.$5i=e.$4i=void 0,e.$4i=(0,u.$Ah)("logService"),e.$5i=(0,u.$Ah)("loggerService");function p(){return new Date().toISOString()}function $(r){return(0,f.$mf)(r)}e.$6i=$;var h;(function(r){r[r.Off=0]="Off",r[r.Trace=1]="Trace",r[r.Debug=2]="Debug",r[r.Info=3]="Info",r[r.Warning=4]="Warning",r[r.Error=5]="Error"})(h||(e.LogLevel=h={})),e.$7i=h.Info;function t(r,d,v){switch(d){case h.Trace:r.trace(v);break;case h.Debug:r.debug(v);break;case h.Info:r.info(v);break;case h.Warning:r.warn(v);break;case h.Error:r.error(v);break;case h.Off:break;default:throw new Error(`Invalid log level ${d}`)}}e.log=t;function i(r,d=!1){let v="";for(let R=0;R<r.length;R++){let B=r[R];if(B instanceof Error&&(B=(0,w.$li)(B,d)),typeof B=="object")try{B=JSON.stringify(B)}catch{}v+=(R>0?" ":"")+B}return v}class c extends L.$jc{constructor(){super(...arguments),this.b=e.$7i,this.c=this.B(new F.$ed),this.onDidChangeLogLevel=this.c.event}setLevel(d){this.b!==d&&(this.b=d,this.c.fire(this.b))}getLevel(){return this.b}f(d){return this.b!==h.Off&&this.b<=d}}e.$9i=c;class g extends c{constructor(d){super(),this.h=d}f(d){return this.h||super.f(d)}trace(d,...v){this.f(h.Trace)&&this.g(h.Trace,i([d,...v],!0))}debug(d,...v){this.f(h.Debug)&&this.g(h.Debug,i([d,...v]))}info(d,...v){this.f(h.Info)&&this.g(h.Info,i([d,...v]))}warn(d,...v){this.f(h.Warning)&&this.g(h.Warning,i([d,...v]))}error(d,...v){if(this.f(h.Error))if(d instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=d.stack,this.g(h.Error,i(R))}else this.g(h.Error,i([d,...v]))}flush(){}}e.$0i=g;class k extends c{constructor(d=e.$7i){super(),this.setLevel(d),this.g=!l.$i}trace(d,...v){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,d,...v):console.log(`[main ${p()}]`,d,...v))}debug(d,...v){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,d,...v):console.log(`[main ${p()}]`,d,...v))}info(d,...v){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,d,...v):console.log(`[main ${p()}]`,d,...v))}warn(d,...v){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,d,...v):console.warn(`[main ${p()}]`,d,...v))}error(d,...v){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,d,...v):console.error(`[main ${p()}]`,d,...v))}dispose(){}flush(){}}e.$$i=k;class b extends c{constructor(d=e.$7i,v=!0){super(),this.g=v,this.setLevel(d)}trace(d,...v){this.f(h.Trace)&&(this.g?console.log("%cTRACE","color: #888",d,...v):console.log(d,...v))}debug(d,...v){this.f(h.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",d,...v):console.log(d,...v))}info(d,...v){this.f(h.Info)&&(this.g?console.log("%c INFO","color: #33f",d,...v):console.log(d,...v))}warn(d,...v){this.f(h.Warning)&&(this.g?console.log("%c WARN","color: #993",d,...v):console.log(d,...v))}error(d,...v){this.f(h.Error)&&(this.g?console.log("%c  ERR","color: #f33",d,...v):console.error(d,...v))}dispose(){}flush(){}}e.$_i=b;class n extends c{constructor(d,v=e.$7i){super(),this.g=d,this.setLevel(v)}trace(d,...v){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(d),...v])}debug(d,...v){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(d),...v])}info(d,...v){this.f(h.Info)&&this.g.log(h.Info,[this.h(d),...v])}warn(d,...v){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(d),...v])}error(d,...v){this.f(h.Error)&&this.g.log(h.Error,[this.h(d),...v])}h(d){return typeof d=="string"?d:(0,w.$li)(d,this.f(h.Trace))}dispose(){}flush(){}}e.$aj=n;class a extends c{constructor(d){super(),this.g=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const v of this.g)v.setLevel(d);super.setLevel(d)}trace(d,...v){for(const R of this.g)R.trace(d,...v)}debug(d,...v){for(const R of this.g)R.debug(d,...v)}info(d,...v){for(const R of this.g)R.info(d,...v)}warn(d,...v){for(const R of this.g)R.warn(d,...v)}error(d,...v){for(const R of this.g)R.error(d,...v)}flush(){for(const d of this.g)d.flush()}dispose(){for(const d of this.g)d.dispose()}}e.$bj=a;class s extends L.$jc{constructor(d,v,R){if(super(),this.h=d,this.j=v,this.b=new A.$yi,this.c=this.B(new F.$ed),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$ed),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$ed),this.onDidChangeVisibility=this.g.event,R)for(const B of R)this.b.set(B.resource,{logger:void 0,info:B})}m(d){return(0,f.$if)(d)?[...this.b.values()].find(v=>v.info.id===d):this.b.get(d)}getLogger(d){return this.m(d)?.logger}createLogger(d,v){const R=this.n(d),B=(0,f.$if)(d)?d:v?.id??(0,C.$oi)(R.toString()).toString(16);let V=this.b.get(R)?.logger;const j=v?.logLevel==="always"?h.Trace:v?.logLevel;V||(V=this.s(R,j??this.getLogLevel(R)??this.h,{...v,id:B}));const W={logger:V,info:{resource:R,id:B,logLevel:j,name:v?.name,hidden:v?.hidden,extensionId:v?.extensionId,when:v?.when}};return this.registerLogger(W.info),this.b.set(R,W),V}n(d){return(0,f.$if)(d)?(0,S.$hg)(this.j,`${d}.log`):d}setLogLevel(d,v){if(P.URI.isUri(d)){const R=d,B=v,V=this.b.get(R);V&&B!==V.info.logLevel&&(V.info.logLevel=B===this.h?void 0:B,V.logger?.setLevel(B),this.b.set(V.info.resource,V),this.f.fire([R,B]))}else{this.h=d;for(const[R,B]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(d,v){const R=this.m(d);R&&v!==!R.info.hidden&&(R.info.hidden=!v,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,v]))}getLogLevel(d){let v;return d&&(v=this.b.get(d)?.info.logLevel),v??this.h}registerLogger(d){const v=this.b.get(d.resource);v?v.info.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this.b.set(d.resource,{info:d,logger:void 0}),this.c.fire({added:[d],removed:[]}))}deregisterLogger(d){const v=this.b.get(d);v&&(v.logger&&v.logger.dispose(),this.b.delete(d),this.c.fire({added:[],removed:[v.info]}))}*getRegisteredLoggers(){for(const d of this.b.values())yield d.info}getRegisteredLogger(d){return this.b.get(d)?.info}dispose(){this.b.forEach(d=>d.logger?.dispose()),this.b.clear(),super.dispose()}}e.$cj=s;class o{constructor(){this.onDidChangeLogLevel=new F.$ed().event}setLevel(d){}getLevel(){return h.Info}trace(d,...v){}debug(d,...v){}info(d,...v){}warn(d,...v){}error(d,...v){}critical(d,...v){}dispose(){}flush(){}}e.$dj=o;class y extends o{}e.$ej=y;function m(r){if(r.verbose)return h.Trace;if(typeof r.logLevel=="string"){const d=E(r.logLevel.toLowerCase());if(d!==void 0)return d}return e.$7i}e.$fj=m;function I(r){switch(r){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.$gj=I;function E(r){switch(r){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.$hj=E,e.$ij=new D.$1i("logLevel",I(h.Info))}),define(Ae[175],Re([1,0,6,14]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0;class C extends w.$jc{constructor(A,l=[]){super(),this.a=new F.$bj([A,...l]),this.B(A.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...l){this.a.trace(A,...l)}debug(A,...l){this.a.debug(A,...l)}info(A,...l){this.a.info(A,...l)}warn(A,...l){this.a.warn(A,...l)}error(A,...l){this.a.error(A,...l)}flush(){this.a.flush()}}e.$hN=C}),define(Ae[94],Re([1,0,29,144,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(S){function f($,h){return h-$}S.compare=f;const P=Object.create(null);P[S.Error]=(0,F.localize)(0,null),P[S.Warning]=(0,F.localize)(1,null),P[S.Info]=(0,F.localize)(2,null);function D($){return P[$]||""}S.toString=D;function u($){switch($){case w.default.Error:return S.Error;case w.default.Warning:return S.Warning;case w.default.Info:return S.Info;case w.default.Ignore:return S.Hint}}S.fromSeverity=u;function p($){switch($){case S.Error:return w.default.Error;case S.Warning:return w.default.Warning;case S.Info:return w.default.Info;case S.Hint:return w.default.Ignore}}S.toSeverity=p}(A||(e.MarkerSeverity=A={}));var l;(function(S){const f="";function P(u){return D(u,!0)}S.makeKey=P;function D(u,p){const $=[f];return u.source?$.push(u.source.replace("\xA6","\\\xA6")):$.push(f),u.code?typeof u.code=="string"?$.push(u.code.replace("\xA6","\\\xA6")):$.push(u.code.value.replace("\xA6","\\\xA6")):$.push(f),u.severity!==void 0&&u.severity!==null?$.push(A.toString(u.severity)):$.push(f),u.message&&p?$.push(u.message.replace("\xA6","\\\xA6")):$.push(f),u.startLineNumber!==void 0&&u.startLineNumber!==null?$.push(u.startLineNumber.toString()):$.push(f),u.startColumn!==void 0&&u.startColumn!==null?$.push(u.startColumn.toString()):$.push(f),u.endLineNumber!==void 0&&u.endLineNumber!==null?$.push(u.endLineNumber.toString()):$.push(f),u.endColumn!==void 0&&u.endColumn!==null?$.push(u.endColumn.toString()):$.push(f),$.push(f),$.join("\xA6")}S.makeKeyOptionalMessage=D})(l||(e.IMarkerData=l={})),e.$1s=(0,C.$Ah)("markerService")}),define(Ae[176],Re([1,0,5,29,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yu=e.$Xu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Wu=e.Severity=void 0,e.Severity=F.default,e.$Wu=(0,C.$Ah)("notificationService");var L;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var l;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(l||(e.NotificationsFilter=l={}));class S{constructor(){this.progress=new f,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.$Xu=S;class f{infinite(){}done(){}total(D){}worked(D){}}e.$Yu=f}),define(Ae[95],Re([1,0,15,2,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HT=e.$GT=e.$FT=e.$ET=e.$DT=void 0,e.$DT=(0,C.$Ah)("openerService");function L(f,P){return F.URI.isUri(f)?(0,w.$Le)(f.scheme,P):(0,w.$Me)(f,P+":")}e.$ET=L;function A(f,...P){return P.some(D=>L(f,D))}e.$FT=A;function l(f,P){return f.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$GT=l;function S(f){let P;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(f.fragment);return D&&(P={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},f=f.with({fragment:""})),{selection:P,uri:f}}e.$HT=S}),define(Ae[177],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=void 0,e.$jj=(0,w.$Ah)("productService"),e.$kj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(be,e,w,F){var C=arguments.length,L=C<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,w):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(be,e,w,F);else for(var l=be.length-1;l>=0;l--)(A=be[l])&&(L=(C<3?A(L):C>3?A(e,w,L):A(e,w))||L);return C>3&&L&&Object.defineProperty(e,w,L),L},Ve=this&&this.__param||function(be,e){return function(w,F){e(w,F,be)}};define(Ae[72],Re([1,0,13,21,6,4]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5u=e.$4u=e.$3u=e.$2u=e.$1u=e.ProgressLocation=e.$Zu=void 0,e.$Zu=(0,L.$Ah)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$1u=Object.freeze({total(){},worked(){},done(){}});class l{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(D,u){this.c=D,this.report=u?.async?this.e.bind(this):this.d.bind(this)}d(D){this.a=D,this.c(this.a)}e(D){Promise.resolve(this.b).finally(()=>{this.a=D;const u=this.c(this.a);this.b=Promise.resolve(u).finally(()=>this.b=void 0)})}}e.$2u=l;let S=class extends C.$jc{constructor(D,u){super(),this.a=new w.$1g,u.withProgress(D,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,C.$hc)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};e.$3u=S,e.$3u=S=Ke([Ve(1,e.$Zu)],S);class f extends C.$jc{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new C.$ic)}start(D){this.stop();const u=++this.a,p=new F.$od;return this.f=setTimeout(()=>{u===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,C.$hc)(()=>clearTimeout(this.f))),this.b.add((0,C.$hc)(()=>p.cancel())),this.b.add((0,C.$hc)(()=>this.c?this.c.done():void 0)),{id:u,token:p.token,stop:()=>this.h(u),isCurrent:()=>this.a===u}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.$4u=f,e.$5u=(0,L.$Ah)("editorProgressService")}),define(Ae[30],Re([1,0,50,16]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0;class C{constructor(){this.a=new Map}add(A,l){w.ok(F.$if(A)),w.ok(F.$kf(l)),w.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,l)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$7m=new C}),define(Ae[73],Re([1,0,5,30]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$8m={JSONContribution:"base.contributions.json"};function C(l){return l.length>0&&l.charAt(l.length-1)==="#"?l.substring(0,l.length-1):l}class L{constructor(){this.b=new w.$ed,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,f){this.a[C(S)]=f,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;F.$7m.add(e.$8m.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,16,138,43,73,30]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ConfigurationScope=e.$_m=e.EditPresentationTypes=void 0;var f;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$_m={Configuration:"base.contributions.configuration"};var P;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn="vscode://schemas/settings/resourceLanguage",e.$hn="vscode://schemas/settings/configurationDefaults";const D=S.$7m.as(l.$8m.JSONContribution);class u{constructor(){this.h=new Set,this.i=new F.$ed,this.onDidSchemaChange=this.i.event,this.j=new F.$ed,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$gn,this.g),this.v()}registerConfiguration(n,a=!0){this.registerConfigurations([n],a)}registerConfigurations(n,a=!0){const s=new Set;this.n(n,a,s),D.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(n){const a=new Set;this.o(n,a),D.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:n,remove:a}){const s=new Set;this.o(a,s),this.n(n,!1,s),D.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(n){const a=new Set;this.k(n,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(n,a){const s=[];for(const{overrides:o,source:y}of n)for(const m in o)if(a.add(m),e.$jn.test(m)){const I=this.a.get(m),E=I?.valuesSources??new Map;if(y)for(const R of Object.keys(o[m]))E.set(R,y);const r={...I?.value||{},...o[m]};this.a.set(m,{source:y,value:r,valuesSources:E});const d=(0,A.$ei)(m),v={type:"object",default:r,description:L.localize(1,null,d),$ref:e.$gn,defaultDefaultValue:r,source:C.$if(y)?void 0:y,defaultValueSource:y};s.push(...h(m)),this.d[m]=v,this.b.properties[m]=v}else{this.a.set(m,{value:o[m],source:y});const I=this.d[m];I&&(this.w(m,I),this.r(m,I))}this.m(s)}deregisterDefaultConfigurations(n){const a=new Set;this.l(n,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(n,a){for(const{overrides:s,source:o}of n)for(const y in s){const m=this.a.get(y),I=C.$if(o)?o:o?.id,E=C.$if(m?.source)?m?.source:m?.source?.id;if(I===E)if(a.add(y),this.a.delete(y),e.$jn.test(y))delete this.d[y],delete this.b.properties[y];else{const r=this.d[y];r&&(this.w(y,r),this.r(y,r))}}this.u()}deltaConfiguration(n){let a=!1;const s=new Set;n.removedDefaults&&(this.l(n.removedDefaults,s),a=!0),n.addedDefaults&&(this.k(n.addedDefaults,s),a=!0),n.removedConfigurations&&this.o(n.removedConfigurations,s),n.addedConfigurations&&this.n(n.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const a of n)this.h.add(a);this.u()}n(n,a,s){n.forEach(o=>{this.p(o,a,o.extensionInfo,o.restrictedProperties,void 0,s),this.c.push(o),this.q(o)})}o(n,a){const s=o=>{if(o.properties)for(const y in o.properties){a.add(y);const m=this.d[y];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[y],this.s(y,o.properties[y])}o.allOf?.forEach(y=>s(y))};for(const o of n){s(o);const y=this.c.indexOf(o);y!==-1&&this.c.splice(y,1)}}p(n,a=!0,s,o,y=3,m){y=C.$rf(n.scope)?y:n.scope;const I=n.properties;if(I)for(const r in I){const d=I[r];if(a&&g(r,d)){delete I[r];continue}if(d.source=s,d.defaultDefaultValue=I[r].default,this.w(r,d),e.$jn.test(r)?d.scope=void 0:(d.scope=C.$rf(d.scope)?y:d.scope,d.restricted=C.$rf(d.restricted)?!!o?.includes(r):d.restricted),I[r].hasOwnProperty("included")&&!I[r].included){this.f[r]=I[r],delete I[r];continue}else this.d[r]=I[r],I[r].policy?.name&&this.e.set(I[r].policy.name,r);!I[r].deprecationMessage&&I[r].markdownDeprecationMessage&&(I[r].deprecationMessage=I[r].markdownDeprecationMessage),m.add(r)}const E=n.allOf;if(E)for(const r of E)this.p(r,a,s,o,y,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const a=s=>{const o=s.properties;if(o)for(const m in o)this.r(m,o[m]);s.allOf?.forEach(a)};a(n)}r(n,a){switch(e.$an.properties[n]=a,a.scope){case 1:e.$bn.properties[n]=a;break;case 2:e.$cn.properties[n]=a;break;case 6:e.$dn.properties[n]=a;break;case 3:e.$en.properties[n]=a;break;case 4:e.$fn.properties[n]=a;break;case 5:e.$fn.properties[n]=a,this.g.properties[n]=a;break}}s(n,a){switch(delete e.$an.properties[n],a.scope){case 1:delete e.$bn.properties[n];break;case 2:delete e.$cn.properties[n];break;case 6:delete e.$dn.properties[n];break;case 3:delete e.$en.properties[n];break;case 4:case 5:delete e.$fn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const a=`[${n}]`,s={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$gn};this.w(a,s),e.$an.properties[a]=s,e.$bn.properties[a]=s,e.$cn.properties[a]=s,e.$dn.properties[a]=s,e.$en.properties[a]=s,e.$fn.properties[a]=s}}v(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$gn};e.$an.patternProperties[e.$in]=n,e.$bn.patternProperties[e.$in]=n,e.$cn.patternProperties[e.$in]=n,e.$dn.patternProperties[e.$in]=n,e.$en.patternProperties[e.$in]=n,e.$fn.patternProperties[e.$in]=n,this.i.fire()}w(n,a){const s=this.a.get(n);let o=s?.value,y=s?.source;C.$pf(o)&&(o=a.defaultDefaultValue,y=void 0),C.$pf(o)&&(o=i(a.type)),a.default=o,a.defaultValueSource=y}}const p="\\[([^\\]]+)\\]",$=new RegExp(p,"g");e.$in=`^(${p})+$`,e.$jn=new RegExp(e.$in);function h(b){const n=[];if(e.$jn.test(b)){let a=$.exec(b);for(;a?.length;){const s=a[1].trim();s&&n.push(s),a=$.exec(b)}}return(0,w.$Jb)(n)}e.$kn=h;function t(b){return b.reduce((n,a)=>`${n}[${a}]`,"")}e.$ln=t;function i(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$mn=i;const c=new u;S.$7m.add(e.$_m.Configuration,c);function g(b,n){return b.trim()?e.$jn.test(b)?L.localize(7,null,b):c.getConfigurationProperties()[b]!==void 0?L.localize(8,null,b):n.policy?.name&&c.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,b,n.policy?.name,c.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}e.$nn=g;function k(){const b=[],n=c.getConfigurationProperties();for(const a of Object.keys(n))b.push([a,n[a].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.$on=k}),define(Ae[178],Re([1,0,18,5,116,6,28,24,16,2,43,96,30]),function(be,e,w,F,C,L,A,l,S,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=void 0;function p(a){return Object.isFrozen(a)?a:l.$Vm(a)}class ${constructor(s={},o=[],y=[],m){this.b=s,this.c=o,this.d=y,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(o=>{if(o instanceof $)return o;const y=new h("");return y.parseRaw(o),y.configurationModel});this.f=s.reduce((o,y)=>y===o?y:o.merge(y),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,P.$ci)(this.contents,s):this.contents}inspect(s,o){const y=this.rawConfiguration.getValue(s),m=o?this.rawConfiguration.getOverrideValue(s,o):void 0,I=o?this.rawConfiguration.override(o).getValue(s):y;return{value:y,override:m,merged:I}}getOverrideValue(s,o){const y=this.i(o);return y?s?(0,P.$ci)(y,s):y:void 0}getKeysForOverrideIdentifier(s){const o=[];for(const y of this.overrides)y.identifiers.includes(s)&&o.push(...y.keys);return w.$Jb(o)}getAllOverrideIdentifiers(){const s=[];for(const o of this.overrides)s.push(...o.identifiers);return w.$Jb(s)}override(s){let o=this.a.get(s);return o||(o=this.g(s),this.a.set(s,o)),o}merge(...s){const o=l.$Um(this.contents),y=l.$Um(this.overrides),m=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const E of s)if(I.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(o,E.contents);for(const r of E.overrides){const[d]=y.filter(v=>w.$sb(v.identifiers,r.identifiers));d?(this.h(d.contents,r.contents),d.keys.push(...r.keys),d.keys=w.$Jb(d.keys)):y.push(l.$Um(r))}for(const r of E.keys)m.indexOf(r)===-1&&m.push(r)}return new $(o,m,y,I.every(E=>E instanceof $)?void 0:I)}g(s){const o=this.i(s);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const y={};for(const m of w.$Jb([...Object.keys(this.contents),...Object.keys(o)])){let I=this.contents[m];const E=o[m];E&&(typeof I=="object"&&typeof E=="object"?(I=l.$Um(I),this.h(I,E)):I=E),y[m]=I}return new $(y,this.keys,this.overrides)}h(s,o){for(const y of Object.keys(o)){if(y in s&&S.$kf(s[y])&&S.$kf(o[y])){this.h(s[y],o[y]);continue}s[y]=l.$Um(o[y])}}i(s){let o=null,y=null;const m=I=>{I&&(y?this.h(y,I):y=l.$Um(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===s?o=I.contents:I.identifiers.includes(s)&&m(I.contents);return m(o),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,o){this.j(s,o,!0)}setValue(s,o){this.j(s,o,!1)}removeValue(s){const o=this.keys.indexOf(s);o!==-1&&(this.keys.splice(o,1),(0,P.$bi)(this.contents,s),D.$jn.test(s)&&this.overrides.splice(this.overrides.findIndex(y=>w.$sb(y.identifiers,(0,D.$kn)(s))),1))}j(s,o,y){(0,P.$ai)(this.contents,s,o,m=>console.error(m)),y=y||this.keys.indexOf(s)===-1,y&&this.keys.push(s),D.$jn.test(s)&&this.overrides.push({identifiers:(0,D.$kn)(s),keys:Object.keys(this.contents[s]),contents:(0,P.$_h)(this.contents[s],m=>console.error(m))})}}e.$pn=$;class h{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,o){if(!S.$rf(s)){const y=this.g(s);this.parseRaw(y,o)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,o){this.a=s;const{contents:y,keys:m,overrides:I,restricted:E,hasExcludedProperties:r}=this.h(s,o);this.b=new $(y,m,I,r?[s]:void 0),this.c=E||[]}g(s){let o={},y=null,m=[];const I=[],E=[];function r(v){Array.isArray(m)?m.push(v):y!==null&&(m[y]=v)}const d={onObjectBegin:()=>{const v={};r(v),I.push(m),m=v,y=null},onObjectProperty:v=>{y=v},onObjectEnd:()=>{m=I.pop()},onArrayBegin:()=>{const v=[];r(v),I.push(m),m=v,y=null},onArrayEnd:()=>{m=I.pop()},onLiteralValue:r,onError:(v,R,B)=>{E.push({error:v,offset:R,length:B})}};if(s)try{C.$Rm(s,d),o=m[0]||{}}catch(v){console.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return o}h(s,o){const y=u.$7m.as(D.$_m.Configuration).getConfigurationProperties(),m=this.i(s,y,!0,o);s=m.raw;const I=(0,P.$_h)(s,d=>console.error(`Conflict in settings file ${this.f}: ${d}`)),E=Object.keys(s),r=this.j(s,d=>console.error(`Conflict in settings file ${this.f}: ${d}`));return{contents:I,keys:E,overrides:r,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(s,o,y,m){let I=!1;if(!m?.scopes&&!m?.skipRestricted&&!m?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:I};const E={},r=[];for(const d in s)if(D.$jn.test(d)&&y){const v=this.i(s[d],o,!1,m);E[d]=v.raw,I=I||v.hasExcludedProperties,r.push(...v.restricted)}else{const v=o[d],R=v?typeof v.scope<"u"?v.scope:3:void 0;v?.restricted&&r.push(d),!m.exclude?.includes(d)&&(m.include?.includes(d)||(R===void 0||m.scopes===void 0||m.scopes.includes(R))&&!(m.skipRestricted&&v?.restricted))?E[d]=s[d]:I=!0}return{raw:E,restricted:r,hasExcludedProperties:I}}j(s,o){const y=[];for(const m of Object.keys(s))if(D.$jn.test(m)){const I={};for(const E in s[m])I[E]=s[m][E];y.push({identifiers:(0,D.$kn)(m),keys:Object.keys(I),contents:(0,P.$_h)(I,o)})}return y}}e.$qn=h;class t extends L.$jc{constructor(s,o,y,m){super(),this.c=s,this.f=o,this.g=m,this.b=this.B(new F.$ed),this.onDidChange=this.b.event,this.a=new h(this.c.toString()),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&y.isEqual(I.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$rn=t;class i{constructor(s,o,y,m,I,E,r,d,v,R,B,V,j){this.a=s,this.b=o,this.c=y,this.overrideIdentifiers=m,this.d=I,this.f=E,this.g=r,this.h=d,this.i=v,this.j=R,this.k=B,this.l=V,this.m=j}get value(){return p(this.c)}n(s,o,y){const m=s.inspect(o,y);return{get value(){return p(m.value)},get override(){return p(m.override)},get merged(){return p(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(s,o,y,m,I=new $,E=new $,r=new A.$yi,d=new $,v=new A.$yi){this.c=s,this.d=o,this.f=y,this.g=m,this.h=I,this.i=E,this.j=r,this.l=d,this.m=v,this.a=null,this.b=new A.$yi,this.n=null}getValue(s,o,y){return this.q(s,o,y).getValue(s)}updateValue(s,o,y={}){let m;y.resource?(m=this.m.get(y.resource),m||(m=new $,this.m.set(y.resource,m))):m=this.l,o===void 0?m.removeValue(s):m.setValue(s,o),y.resource||(this.a=null)}inspect(s,o,y){const m=this.q(s,o,y),I=this.u(o.resource,y),E=o.resource?this.m.get(o.resource)||this.l:this.l,r=new Set;for(const d of m.overrides)for(const v of d.identifiers)m.getOverrideValue(s,v)!==void 0&&r.add(v);return new i(s,o,m.getValue(s),r.size?[...r]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.i:void 0,I||void 0,E)}keys(s){const o=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,o){this.j.set(s,o),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,o){const y=[];if(!o){const{added:m,updated:I,removed:E}=b(this.c,s);o=[...m,...I,...E]}for(const m of o)for(const I of(0,D.$kn)(m)){const E=this.c.getKeysForOverrideIdentifier(I),r=s.getKeysForOverrideIdentifier(I),d=[...r.filter(v=>E.indexOf(v)===-1),...E.filter(v=>r.indexOf(v)===-1),...E.filter(v=>!l.$Ym(this.c.override(I).getValue(v),s.override(I).getValue(v)))];y.push([I,d])}return this.updateDefaultConfiguration(s),{keys:o,overrides:y}}compareAndUpdatePolicyConfiguration(s){const{added:o,updated:y,removed:m}=b(this.d,s),I=[...o,...y,...m];return I.length&&this.updatePolicyConfiguration(s),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:o,updated:y,removed:m,overrides:I}=b(this.applicationConfiguration,s),E=[...o,...y,...m];return E.length&&this.updateApplicationConfiguration(s),{keys:E,overrides:I}}compareAndUpdateLocalUserConfiguration(s){const{added:o,updated:y,removed:m,overrides:I}=b(this.localUserConfiguration,s),E=[...o,...y,...m];return E.length&&this.updateLocalUserConfiguration(s),{keys:E,overrides:I}}compareAndUpdateRemoteUserConfiguration(s){const{added:o,updated:y,removed:m,overrides:I}=b(this.remoteUserConfiguration,s),E=[...o,...y,...m];return E.length&&this.updateRemoteUserConfiguration(s),{keys:E,overrides:I}}compareAndUpdateWorkspaceConfiguration(s){const{added:o,updated:y,removed:m,overrides:I}=b(this.workspaceConfiguration,s),E=[...o,...y,...m];return E.length&&this.updateWorkspaceConfiguration(s),{keys:E,overrides:I}}compareAndUpdateFolderConfiguration(s,o){const y=this.p.get(s),{added:m,updated:I,removed:E,overrides:r}=b(y,o),d=[...m,...I,...E];return(d.length||!y)&&this.updateFolderConfiguration(s,o),{keys:d,overrides:r}}compareAndDeleteFolderConfiguration(s){const o=this.p.get(s);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:y,updated:m,removed:I,overrides:E}=b(o,void 0);return{keys:[...y,...m,...I],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,o,y){let m=this.r(o,y);return o.overrideIdentifier&&(m=m.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(m=m.merge(this.d)),m}r({resource:s},o){let y=this.s();if(o&&s){const m=o.getFolder(s);m&&(y=this.t(m.uri)||y);const I=this.m.get(s);I&&(y=y.merge(I))}return y}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let o=this.b.get(s);if(!o){const y=this.s(),m=this.j.get(s);m?(o=y.merge(m),this.b.set(s,o)):o=y}return o}u(s,o){if(o&&s){const y=o.getFolder(s);if(y)return this.j.get(y.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,o)=>{const{contents:y,overrides:m,keys:I}=this.j.get(o);return s.push([o,{contents:y,overrides:m,keys:I}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(o=>s.add(o)),this.userConfiguration.keys.forEach(o=>s.add(o)),this.i.keys.forEach(o=>s.add(o)),this.j.forEach(o=>o.keys.forEach(y=>s.add(y))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(y=>s.add(y))),[...s.values()]}w(s){const o=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(y=>o.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(y=>o.add(y)),this.i.getKeysForOverrideIdentifier(s).forEach(y=>o.add(y)),this.j.forEach(y=>y.getKeysForOverrideIdentifier(s).forEach(m=>o.add(m))),[...o.values()]}static parse(s){const o=this.x(s.defaults),y=this.x(s.policy),m=this.x(s.application),I=this.x(s.user),E=this.x(s.workspace),r=s.folders.reduce((d,v)=>(d.set(f.URI.revive(v[0]),this.x(v[1])),d),new A.$yi);return new c(o,y,m,I,new $,E,r,new $,new A.$yi)}static x(s){return new $(s.contents,s.keys,s.overrides)}}e.$sn=c;function g(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const s=new Set,o=new Map;for(const m of a)m.keys.forEach(I=>s.add(I)),m.overrides.forEach(([I,E])=>{const r=(0,A.$vi)(o,I,new Set);E.forEach(d=>r.add(d))});const y=[];return o.forEach((m,I)=>y.push([I,[...m.values()]])),{keys:[...s.values()],overrides:y}}e.$tn=g;class k{constructor(s,o,y,m){this.change=s,this.f=o,this.g=y,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of s.keys)this.affectedKeys.add(I);for(const[,I]of s.overrides)for(const E of I)this.affectedKeys.add(E);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(s,o){const y=this.a+s,m=this.d.indexOf(y);if(m<0)return!1;const I=m+y.length;if(I>=this.d.length)return!1;const E=this.d.charCodeAt(I);if(E!==this.b&&E!==this.c)return!1;if(o){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,o,this.f?.workspace):void 0,d=this.g.getValue(s,o,this.h);return!l.$Ym(r,d)}return!0}}e.$un=k;function b(a,s){const{added:o,removed:y,updated:m}=n(s?.rawConfiguration,a?.rawConfiguration),I=[],E=a?.getAllOverrideIdentifiers()||[],r=s?.getAllOverrideIdentifiers()||[];if(s){const d=r.filter(v=>!E.includes(v));for(const v of d)I.push([v,s.getKeysForOverrideIdentifier(v)])}if(a){const d=E.filter(v=>!r.includes(v));for(const v of d)I.push([v,a.getKeysForOverrideIdentifier(v)])}if(s&&a){for(const d of E)if(r.includes(d)){const v=n({contents:a.getOverrideValue(void 0,d)||{},keys:a.getKeysForOverrideIdentifier(d)},{contents:s.getOverrideValue(void 0,d)||{},keys:s.getKeysForOverrideIdentifier(d)});I.push([d,[...v.added,...v.removed,...v.updated]])}}return{added:o,removed:y,updated:m,overrides:I}}function n(a,s){const o=a?s?a.keys.filter(I=>s.keys.indexOf(I)===-1):[...a.keys]:[],y=s?a?s.keys.filter(I=>a.keys.indexOf(I)===-1):[...s.keys]:[],m=[];if(a&&s){for(const I of s.keys)if(a.keys.indexOf(I)!==-1){const E=(0,P.$ci)(s.contents,I),r=(0,P.$ci)(a.contents,I);l.$Ym(E,r)||m.push(I)}}return{added:o,removed:y,updated:m}}}),define(Ae[97],Re([1,0,9,4]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.RemoteAuthorityResolverErrorCode=e.$Kk=e.$Jk=e.RemoteConnectionType=e.$Ik=void 0,e.$Ik=(0,F.$Ah)("remoteAuthorityResolverService");var C;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class L{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Jk=L;class A{constructor(D,u){this.host=D,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Kk=A;var l;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class S extends w.$_{static isNotAvailable(D){return D instanceof S&&D._code===l.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof S&&D._code===l.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof S&&D._code===l.NoResolverFound}static isInvalidAuthority(D){return D instanceof S&&D._code===l.InvalidAuthority}static isHandled(D){return D instanceof S&&D.isHandled}constructor(D,u=l.Unknown,p){super(D),this._message=D,this._code=u,this._detail=p,this.isHandled=u===l.NotAvailable&&p===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Lk=S;function f(P){const D=P.indexOf("+");return D===-1?P:P.substring(0,D)}e.$Mk=f}),define(Ae[51],Re([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=void 0;function F(f){return f.scheme===w.Schemas.vscodeRemote?f.authority:void 0}e.$Nk=F;function C(f){if(!f)return;const P=f.indexOf("+");return P<0?f:f.substr(0,P)}e.$Ok=C;function L(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.$Pk=L;function A(f){const{host:P,port:D}=S(f);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:D}}e.$Qk=A;function l(f,P){let{host:D,port:u}=S(f);return typeof u>"u"&&(u=P),{host:D,port:u}}e.$Rk=l;function S(f){const P=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const D=f.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const u=f.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:f,port:void 0}}}),define(Ae[20],Re([1,0,15,4,51]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.TargetPlatform=e.ExtensionType=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=void 0,e.$Ol="extensions.user.cache",e.$Pl="extensions.builtin.cache",e.$Ql="undefined_publisher",e.$Rl=["ui","workspace","web"];function L(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$Sl=L,e.$Tl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(A||(e.ExtensionType=A={}));var l;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(l||(e.TargetPlatform=l={}));class S{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const c=typeof t=="string"?t:t.value,g=typeof i=="string"?i:i.value;return w.$Le(c,g)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Ul=S;class f{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(S.toKey(t))}delete(t){return this.c.delete(S.toKey(t))}has(t){return this.c.has(S.toKey(t))}}e.$Vl=f;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(S.toKey(t))}get(t){return this.c.get(S.toKey(t))}has(t){return this.c.has(S.toKey(t))}set(t,i){this.c.set(S.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Wl=P;function D(h){return u(h)}e.$Xl=D;function u(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.$Yl=u;function p(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.$Zl=p;function $(h,t){if(t){const i=`onResolveRemoteAuthority:${(0,C.$Ok)(t)}`;return!!h.activationEvents?.includes(i)}return!1}e.$1l=$,e.$2l=(0,F.$Ah)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,20]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zF=e.$yF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,l){this.a.set(A,l)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const l=Object.create(null);for(const S of A){const f=this.readActivationEvents(S);f.length>0&&(l[F.$Ul.toKey(S.identifier)]=f)}return l}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const l=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return l;for(const S in A.contributes){const f=this.a.get(S);if(!f)continue;const P=A.contributes[S],D=Array.isArray(P)?P:[P];try{f(D,l)}catch(u){(0,w.$Y)(u)}}return l}}e.$yF=C,e.$zF=new C}),define(Ae[179],Re([1,0,22,74,36]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=void 0;function L(S){if(w.$t===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function A(S,f,P,D,u,p,$,h){const t=Object.create(null);t["common.machineId"]=p,t.sessionID=(0,C.$3f)()+Date.now(),t.commitHash=D,t.version=u,t["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,w.$h)(w.$t),t["common.nodePlatform"]=F.$2d,t["common.nodeArch"]=P,t["common.product"]=h||"desktop",$&&(t["common.msftInternal"]=$);let i=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),w.$l&&(t["common.snap"]="true");const g=L(f);return g&&(t["common.platformDetail"]=g),t}e.$9n=A;function l(S){const f=F.env.USERDNSDOMAIN;if(!f)return!1;const P=f.toLowerCase();return S.some(D=>P===D)}e.$0n=l}),define(Ae[180],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0,e.$8k=(0,w.$Ah)("telemetryService"),e.$9k=(0,w.$Ah)("customEndpointTelemetryService"),e.$0k="telemetry.currentSessionDate",e.$$k="telemetry.firstSessionDate",e.$_k="telemetry.lastSessionDate",e.$al="telemetry.machineId",e.$bl="telemetry",e.$cl="telemetry.telemetryLevel",e.$dl="telemetry.enableCrashReporter",e.$el="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var C;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[52],Re([1,0,24,16,5,43,51,179,180]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=void 0;class f{constructor(y){this.value=y,this.isTrustedTelemetryValue=!0}}e.$$n=f;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$_n=P,e.$ao=new P;class D{async publicLog(y,m,I){}async publicLogError(y,m,I){}}e.$bo=D,e.$co="telemetry",e.$do="extensionTelemetryLog",e.$eo={log:()=>null,flush:()=>Promise.resolve(null)};function u(o,y){return C.Event.debounce(y.onDidChangeConfiguration,(I,E)=>{const r=I?new Set([...I.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:r}},1e3,!0)(I=>{I.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,L.$0h)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$fo=u;function p(o,y){return!y.isBuilt&&!y.disableTelemetry?!0:!(y.disableTelemetry||!o.enableTelemetry||y.extensionTestsLocationURI)}e.$go=p;function $(o,y){return!(y.isBuilt||y.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$ho=$;function h(o){const y=o.getValue(S.$cl),m=o.getValue(S.$dl);if(o.getValue(S.$el)===!1||m===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$io=h;function t(o){const y={},m={},I={};g(o,I);for(let E in I){E=E.length>150?E.substr(E.length-149):E;const r=I[E];typeof r=="number"?m[E]=r:typeof r=="boolean"?m[E]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${r.length}`),y[E]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(y[E]=r)}return{properties:y,measurements:m}}e.$jo=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(o){if(!o)return"none";const y=(0,A.$Ok)(o);return i.has(y)?y:"other"}e.$ko=c;function g(o,y,m=0,I){if(o)for(const E of Object.getOwnPropertyNames(o)){const r=o[E],d=I?I+E:E;Array.isArray(r)?y[d]=(0,w.$Zm)(r):r instanceof Date?y[d]=r.toISOString():(0,F.$kf)(r)?m<2?g(r,y,m+1,d+"."):y[d]=(0,w.$Zm)(r):y[d]=r}}function k(o,y){const m=o.msftInternalDomains||[],I=y.getValue("telemetry.internalTesting");return(0,l.$0n)(m)||I}e.$lo=k;function b(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$mo=b;function n(o,y){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let m=o;const I=[];for(const v of y)for(;;){const R=v.exec(o);if(!R)break;I.push([R.index,v.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(m="";;){const v=r.exec(o);if(!v)break;const R=I.some(([B,V])=>v.index<V&&B<r.lastIndex);!E.test(v[0])&&!R&&(m+=o.substring(d,v.index)+"<REDACTED: user-file-path>",d=r.lastIndex)}return d<o.length&&(m+=o.substr(d)),m}function a(o){if(!o)return o;const y=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of y)if(m.regex.test(o))return`<REDACTED: ${m.label}>`;return o}function s(o,y){return(0,w.$Wm)(o,m=>{if(m instanceof f||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let I=m.replaceAll("%20"," ");I=n(I,y);for(const E of y)I=I.replace(E,"");return I=a(I),I}})}e.$no=s}),define(Ae[181],Re([1,0,15,92,20,22,2,9,74,52]),function(be,e,w,F,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;function P(s,o){return s.uuid&&o.uuid?s.uuid===o.uuid:s.id===o.id?!0:(0,w.$Ge)(s.id,o.id)===0}e.$oo=P;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(o){const y=o.manifest?o.manifest.version:o.version,m=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new u(o.identifier,y,m)}static parse(o){const y=D.exec(o);return y&&y[1]&&y[2]?new u({id:y[1]},y[2],y[4]||void 0):null}constructor(o,y,m="undefined"){this.version=y,this.targetPlatform=m,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof u?P(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$po=u;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(s){const o=p.exec(s);return o&&o[1]?[t(o[1]),o[2]]:[t(s),void 0]}e.$qo=$;function h(s,o){return`${s}.${o}`}e.$ro=h;function t(s){return s.toLowerCase()}e.$so=t;function i(s,o){return t(h(s??C.$Ql,o))}e.$to=i;function c(s,o){const y=[],m=I=>{for(const E of y)if(E.some(r=>P(o(r),o(I))))return E;return null};for(const I of s){const E=m(I);E?E.push(I):y.push([I])}return y}e.$uo=c;function g(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$vo=g;function k(s){return{id:new f.$$n(s.identifier.id),name:new f.$$n(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$wo=k,e.$xo=new C.$Ul("pprice.better-merge");function b(s,o){const y=[],m=o.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const I=m.shift();if(I&&y.every(E=>!P(E.identifier,{id:I}))){const E=s.filter(r=>P(r.identifier,{id:I}));E.length===1&&(y.push(E[0]),m.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.$yo=b;async function n(s,o){if(!L.$k)return!1;let y;try{y=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{y=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){o.debug("Error while getting the os-release file.",(0,l.$8)(I))}}return!!y&&(y.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(s,o){const y=await n(s,o),m=(0,F.$Tn)(y?"alpine":L.$t,S.$3d);return o.debug("ComputeTargetPlatform:",m),m}e.$zo=a}),define(Ae[182],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=e.$ar=e.$_q=e.$$q=void 0;function w(S){return[...S.entries()]}e.$$q=w;function F(S){return S?[...S.entries()]:[]}e.$_q=F;function C(S){return new Map(S)}e.$ar=C;function L(S){return new Map(S??[])}e.$br=L;function A(S){return Array.from(S.entries()).map(f=>[f[0],w(f[1].map),F(f[1].descriptionMap)])}e.$cr=A;function l(S){return new Map(S.map(f=>[f[0],{map:C(f[1]),descriptionMap:L(f[2])}]))}e.$dr=l}),define(Ae[183],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkb=void 0;class w{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,L,A=5){const l=L(S=>{const f=typeof S=="string"?S:S.data;let P=this.a.get(C);if(P){P.data.push(f);return}const D=setTimeout(()=>this.flushBuffer(C),A);P={data:[f],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(C),l.dispose()}},this.a.set(C,P)});return l}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const L=this.a.get(C);L&&(this.a.delete(C),this.b(C,L.data.join("")))}}e.$Dkb=w}),define(Ae[184],Re([1,0,13,89,40,5,16,2,145,73,30]),function(be,e,w,F,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.IconFontDefinition=e.IconContribution=e.$6u=void 0,e.$6u={IconContribution:"base.contributions.icons"};var D;(function(k){function b(n,a){let s=n.defaults;for(;C.ThemeIcon.isThemeIcon(s);){const o=$.getIcon(s.id);if(!o)return;s=o.defaults}return s}k.getDefinition=b})(D||(e.IconContribution=D={}));var u;(function(k){function b(a){return{weight:a.weight,style:a.style,src:a.src.map(s=>({format:s.format,location:s.location.toString()}))}}k.toJSONObject=b;function n(a){const s=o=>(0,A.$if)(o)?o:void 0;if(a&&Array.isArray(a.src)&&a.src.every(o=>(0,A.$if)(o.format)&&(0,A.$if)(o.location)))return{weight:s(a.weight),style:s(a.style),src:a.src.map(o=>({format:o.format,location:l.URI.parse(o.location)}))}}k.fromJSONObject=n})(u||(e.IconFontDefinition=u={}));class p{constructor(){this.a=new L.$ed,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(b,n,a,s){const o=this.b[b];if(o){if(a&&!o.description){o.description=a,this.d.properties[b].markdownDescription=`${a} $(${b})`;const I=this.e.enum.indexOf(b);I!==-1&&(this.e.enumDescriptions[I]=a),this.a.fire()}return o}const y={id:b,description:a,defaults:n,deprecationMessage:s};this.b[b]=y;const m={$ref:"#/definitions/icons"};return s&&(m.deprecationMessage=s),a&&(m.markdownDescription=`${a}: $(${b})`),this.d.properties[b]=m,this.e.enum.push(b),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:b}}deregisterIcon(b){delete this.b[b],delete this.d.properties[b];const n=this.e.enum.indexOf(b);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(b=>this.b[b])}getIcon(b){return this.b[b]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(b,n){const a=this.f[b];return a||(this.f[b]=n,this.a.fire(),n)}deregisterIconFont(b){delete this.f[b]}getIconFont(b){return this.f[b]}toString(){const b=(o,y)=>o.id.localeCompare(y.id),n=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(o=>this.b[o]);for(const o of s.filter(y=>!!y.description).sort(b))a.push(`|<i class="${n(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const o of s.filter(y=>!C.ThemeIcon.isThemeIcon(y.defaults)).sort(b))a.push(`|<i class="${n(o)}"></i>|${o.id}|`);return a.join(`
`)}}const $=new p;P.$7m.add(e.$6u.IconContribution,$);function h(k,b,n,a){return $.registerIcon(k,b,n,a)}e.$7u=h;function t(){return $}e.$8u=t;function i(){const k=(0,F.$Mj)();for(const b in k){const n="\\"+k[b].toString(16);$.registerIcon(b,{fontCharacter:n})}}i(),e.$9u="vscode://schemas/icons";const c=P.$7m.as(f.$8m.JSONContribution);c.registerSchema(e.$9u,$.getIconSchema());const g=new w.$Rg(()=>c.notifySchemaChanged(e.$9u),200);$.onDidChange(()=>{g.isScheduled()||g.schedule()}),e.$0u=h("widget-close",F.$Oj.close,(0,S.localize)(2,null)),e.$$u=h("goto-previous-location",F.$Oj.arrowUp,(0,S.localize)(3,null)),e.$_u=h("goto-next-location",F.$Oj.arrowDown,(0,S.localize)(4,null)),e.$av=C.ThemeIcon.modify(F.$Oj.sync,"spin"),e.$bv=C.ThemeIcon.modify(F.$Oj.loading,"spin")}),define(Ae[185],Re([1,0,5,43,4,14]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5z=e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.$Xz=e.ProvidedOnAutoForward=e.$Wz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Vz=e.$Uz=void 0,e.$Uz=(0,C.$Ah)("tunnelService"),e.$Vz=(0,C.$Ah)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var l;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(l||(e.TunnelPrivacyId=l={}));function S(t){return!!t.forwardPort}e.$Wz=S;var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$Xz=P,e.$Yz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(t){return e.$Yz.indexOf(t)>=0}e.$Zz=D,e.$1z=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(t){return e.$1z.indexOf(t)>=0}e.$2z=u;function p(t,i,c,g){if(c===1)return!1;if(c===2&&u(i)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(k?.length===4&&parseInt(k[1])>=18)return!1}return t<1024}e.$3z=p;class ${constructor(i,c,g){this.remoteAddress=i,this.localAddress=c,this.b=g,this.a=new w.$ed,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$4z=$;let h=class{constructor(i,c){this.j=i,this.k=c,this.a=new w.$ed,this.onTunnelOpened=this.a.event,this.b=new w.$ed,this.onTunnelClosed=this.b.event,this.c=new w.$ed,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],c=Array.from(this.e.values());for(const g of c){const k=Array.from(g.values());for(const b of k){const n=await b.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(g=>typeof g!="string"?g?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,g,k,b){this.p(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:g,privacy:k,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(u(i)||D(i))&&(i=e.$Yz[0]);const g=this.r(i,c);if(g)return++g.refcount,g.value}openTunnel(i,c,g,k,b,n=!1,a,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${g} on local port ${b}.`);const o=this.f??i;if(!o)return;if(c||(c="localhost"),k||(k=this.l),this.f&&this.i.has(g)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.s(o,c,g,k,b,n,a,s);return y?y.then(m=>{if(m){if(typeof m=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,g),m}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,g);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(m);return(m.tunnelRemoteHost!==c||m.tunnelRemotePort!==g)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&m.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const g=c.get(i.tunnelRemotePort);g&&(g.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,g))}}}}async o(i,c,g){if(g.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const k=g.value.then(async b=>{b&&typeof b!="string"&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),k}}async closeTunnel(i,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const g=this.e.get(i);if(g&&g.has(c)){const k=g.get(c);k.refcount=0,await this.o(i,c,k)}}p(i,c,g){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:g})}async q(i,c){const g=this.e.get(i);if(g){const k=g.get(c),b=k?await k.value:void 0;(!b||typeof b=="string")&&g.delete(c),g.size===0&&this.e.delete(i)}}r(i,c){const g=[i];D(i)?(g.push(...e.$Yz),g.push(...e.$1z)):u(i)&&g.push(...e.$1z);const k=g.map(b=>this.e.get(b));for(const b of k){const n=b?.get(c);if(n)return n}}canTunnel(i){return!!P(i)}t(i,c,g,k,b,n,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${g} on local port ${k}.`);const s=g;this.i.add(s);const o=k===void 0?g:k,y={elevationRequired:b?this.isPortPrivileged(o):!1},m={remoteAddress:{host:c,port:g},localAddressPort:k,privacy:n,public:n?n!==l.Private:void 0,protocol:a},I=i.forwardPort(m,y);return I?(this.p(c,g,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),I}};e.$5z=h,e.$5z=h=Ke([Ve(0,L.$4i),Ve(1,F.$7h)],h)}),define(Ae[186],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$6z=void 0,e.$6z=(0,w.$Ah)("editSessionIdentityService");var F;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Ae[187],Re([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=void 0;function F(S){return S.scheme!==w.Schemas.file&&S.scheme!==w.Schemas.vscodeRemote}e.$lJ=F;function C(S){if(S.folders.length)return S.folders.every(f=>F(f.uri))?S.folders[0].uri:void 0;if(S.configuration&&F(S.configuration))return S.configuration}e.$mJ=C;function L(S){return C(S)?.scheme}e.$nJ=L;function A(S){return C(S)?.authority}e.$oJ=A;function l(S){return C(S)!==void 0}e.$pJ=l}),define(Ae[53],Re([1,0,146,19,48,23,2,4,12]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.WorkbenchState=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=void 0,e.$Jh=(0,l.$Ah)("contextService");function f(o){const y=o;return typeof y?.id=="string"&&A.URI.isUri(y.uri)}e.$Kh=f;function P(o){return typeof o?.id=="string"&&!f(o)&&!u(o)}e.$Lh=P,e.$Mh={id:"ext-dev"},e.$Nh={id:"empty-window"};function D(o,y){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,F.$_d)(o)}:y?e.$Mh:e.$Nh;const m=o;return m.configuration?{id:m.id,configPath:m.configuration}:m.folders.length===1?{id:m.id,uri:m.folders[0].uri}:{id:m.id}}e.$Oh=D;function u(o){const y=o;return typeof y?.id=="string"&&A.URI.isUri(y.configPath)}e.$Ph=u;function p(o){const y=o;if(y?.uri)return{id:y.id,uri:A.URI.revive(y.uri)};const m=o;if(m?.configPath)return{id:m.id,configPath:A.URI.revive(m.configPath)};if(o?.id)return{id:o.id}}e.$Qh=p;var $;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function h(o){const y=o;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.$Rh=h;function t(o){const y=o;return!!(y&&typeof y=="object"&&A.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.$Sh=t;class i{constructor(y,m,I,E,r){this.h=y,this.j=I,this.k=E,this.l=r,this.c=C.$Gh.forUris(this.l,()=>!0),this.folders=m}update(y){this.h=y.id,this.k=y.configuration,this.j=y.transient,this.l=y.l,this.folders=y.folders}get folders(){return this.g}set folders(y){this.g=y,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(y){this.k=y}getFolder(y){return y&&this.c.findSubstr(y)||null}n(){this.c=C.$Gh.forUris(this.l,()=>!0);for(const y of this.folders)this.c.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Th=i;class c{constructor(y,m){this.raw=m,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,L.$hg)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Uh=c;function g(o){return new c({uri:o,index:0,name:(0,L.$dg)(o)},{uri:o.toString()})}e.$Vh=g,e.$Wh="code-workspace",e.$Xh=`.${e.$Wh}`,e.$Yh=[{name:(0,w.localize)(0,null),extensions:[e.$Wh]}],e.$Zh="workspace.json";function k(o,y){return L.$$f.isEqualOrParent(o,y.untitledWorkspacesHome)}e.$1h=k;function b(o){let y;return A.URI.isUri(o)?y=o:y=o.configuration,y?.scheme===S.Schemas.tmp}e.$2h=b,e.$3h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(o){return o.id===e.$3h}e.$4h=n;function a(o,y){return!k(o,y)&&!b(o)}e.$5h=a;function s(o){return(typeof o=="string"?(0,F.$ae)(o):(0,L.$fg)(o))===e.$Xh}e.$6h=s}),define(Ae[54],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=void 0;class w{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const L=this.c++;return this.b.set(L,C),this.e(),L}get(C,L){return this.b.has(C)?this.b.get(C)[L]:void 0}delete(C){this.b.delete(C),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Lac=w}),define(Ae[39],Re([1,0,12,23,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oac=e.$Nac=void 0;class L{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new F.$9f(l=>{const S=this.b.get(l.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(l,S){S===null?this.b.delete(l.scheme):this.b.set(l.scheme,S)}isFreeScheme(l){return!this.b.has(l)&&!this.a.has(l)}getCapabilities(l){return this.b.get(l)}}e.$Nac=L,e.$Oac=(0,C.$Ah)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=void 0,e.$aM=(0,w.$Ah)("IExtHostInitDataService")}),define(Ae[188],Re([1,0,151,14,175,27]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;let A=class extends C.$hN{constructor(S,f,P){const D=P.remote.isRemote?"remoteexthost":S?"workerexthost":"exthost",u=P.remote.isRemote?(0,w.localize)(0,null):S?(0,w.localize)(1,null):(0,w.localize)(2,null);super(f.createLogger(D,{name:u}))}};e.$Ucc=A,e.$Ucc=A=Ke([Ve(1,F.$5i),Ve(2,L.$aM)],A)}),define(Ae[189],Re([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fbc=e.$ebc=void 0;class F{constructor(A,l,S){this.h=new Map,this.a=A,this.b=l,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(f=>(this.f=f,this)),this.g=this.c.onDidChangeStorage(f=>{f.shared===this.b&&f.key===this.a&&(this.f=f.value)}),this.i=new w.$Rg(()=>{const f=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of f.values())P.complete()}catch(P){for(const D of f.values())D.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,l){let S=this.f[A];return typeof S>"u"&&(S=l),S}update(A,l){this.f[A]=l;const S=this.h.get(A);if(S!==void 0)return S.p;const f=new w.$1g;return this.h.set(A,f),this.i.isScheduled()||this.i.schedule(),f.p}dispose(){this.g.dispose()}}e.$ebc=F;class C extends F{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,l){super(A.identifier.value,!0,l),this.j=A}}e.$fbc=C}),define(Ae[190],Re([1,0,5,2]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;class C{constructor(A){this.c=A,this.a=new w.$ed,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$ed,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,l,S,f){const D=this.c.getNotebookDocument(F.URI.revive(A)).acceptModelChanged(l.value,S,f);this.b.fire(D)}$acceptDirtyStateChanged(A,l){this.c.getNotebookDocument(F.URI.revive(A)).acceptDirty(l)}$acceptModelSaved(A){const l=this.c.getNotebookDocument(F.URI.revive(A));this.a.fire(l.apiNotebook)}}e.$Dcc=C}),define(Ae[17],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=e.$WL=void 0,e.$WL=(0,w.$Ah)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$XL=F}),define(Ae[191],Re([1,0,20,5]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=void 0;class C{#e;constructor(A,l){this.b=new F.$ed,this.onDidChange=this.b.event,this.a=w.$Ul.toKey(A.identifier),this.#e=l,this.#e.onDidChangePassword(S=>{S.extensionId===this.a&&this.b.fire({key:S.key})})}get(A){return this.#e.get(this.a,A)}store(A,l){return this.#e.store(this.a,A,l)}delete(A){return this.#e.delete(this.a,A)}}e.$qbc=C}),define(Ae[55],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=e.$Yac=void 0,e.$Yac=(0,w.$Ah)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Zac=F}),define(Ae[192],Re([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbb=e.$Ybb=void 0;class F{constructor(){this.buffers=[]}add(S){let f=this.buffers.indexOf(S);return f<0&&(f=this.buffers.length,this.buffers.push(S)),f}}function C(l,S){if(S.serializeBuffersForPostMessage){const f=new F,D=JSON.stringify(l,(p,$)=>{if($ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:f.add($)};if(ArrayBuffer.isView($)){const h=L($);if(h)return{$$vscode_array_buffer_reference$$:!0,index:f.add($.buffer),view:{type:h,byteLength:$.byteLength,byteOffset:$.byteOffset}}}return $}),u=f.buffers.map(p=>{const $=new Uint8Array(p);return w.$Ed.wrap($)});return{message:D,buffers:u}}else return{message:JSON.stringify(l),buffers:[]}}e.$Ybb=C;function L(l){switch(l.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(l,S){const f=S.map(u=>{const p=new ArrayBuffer(u.byteLength);return new Uint8Array(p).set(u.buffer),p}),P=S.length?(u,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const $=p,{index:h}=$,t=f[h];if($.view)switch($.view.type){case 1:return new Int8Array(t,$.view.byteOffset,$.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,$.view.byteOffset,$.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,$.view.byteOffset,$.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,$.view.byteOffset,$.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,$.view.byteOffset,$.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,$.view.byteOffset,$.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,$.view.byteOffset,$.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,$.view.byteOffset,$.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,$.view.byteOffset,$.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,$.view.byteOffset,$.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,$.view.byteOffset,$.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return p}:void 0;return{message:JSON.parse(l,P),arrayBuffers:f}}e.$Zbb=A}),define(Ae[99],Re([1,0,160,16,2,6,4,30,38,12,41,128,29]),function(be,e,w,F,C,L,A,l,S,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5E=e.$4E=e.$3E=e.EditorsOrder=e.$2E=e.CloseDirection=e.$1E=e.$ZE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.EditorInputCapabilities=e.$QE=e.SaveReason=e.Verbosity=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$IE=e.$HE=e.$GE=e.$FE=e.$EE=void 0,e.$EE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$FE={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$GE="workbench.editor.sidebysideEditor",e.$HE="workbench.editors.textDiffEditor",e.$IE="workbench.editors.binaryResourceDiffEditor";var p;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var $;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function h(ce){const $e=ce;return!!$e&&typeof $e.getSelection=="function"&&!!$e.onDidChangeSelection}e.$JE=h;function t(ce,$e,ie){for(const N of ie.visibleEditorPanes)if(N.group.id===$e&&ce.matches(N.input))return N.getViewState()}e.$KE=t;function i(ce){if(m(ce))return!1;const $e=ce;return C.URI.isUri($e?.resource)}e.$LE=i;function c(ce){if(m(ce))return!1;const $e=ce;return $e?.original!==void 0&&$e.modified!==void 0}e.$ME=c;function g(ce){if(m(ce)||c(ce))return!1;const $e=ce;return $e?.primary!==void 0&&$e.secondary!==void 0}e.$NE=g;function k(ce){if(m(ce))return!1;const $e=ce;return $e?$e.resource===void 0||$e.resource.scheme===f.Schemas.untitled||$e.forceUntitled===!0:!1}e.$OE=k;function b(ce){if(m(ce))return!1;const $e=ce;return C.URI.isUri($e?.base?.resource)&&C.URI.isUri($e?.input1?.resource)&&C.URI.isUri($e?.input2?.resource)&&C.URI.isUri($e?.result?.resource)}e.$PE=b;var n;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var a;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class s{constructor(){this.a=new Map}registerSource($e,ie){let N=this.a.get($e);return N||(N={source:$e,label:ie},this.a.set($e,N)),N.source}getSourceLabel($e){return this.a.get($e)?.label??$e}}e.$QE=new s;var o;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class y extends L.$jc{}e.$RE=y;function m(ce){return ce instanceof y}e.$SE=m;function I(ce){const $e=ce;return C.URI.isUri($e?.preferredResource)}function E(ce){const $e=ce;return m($e?.primary)&&m($e?.secondary)}e.$TE=E;function r(ce){const $e=ce;return m($e?.modified)&&m($e?.original)}e.$UE=r;function d(ce,$e,ie,N,q){return ye(N,[(0,D.$ki)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const le={...ie,limits:{size:Number.MAX_VALUE}};ce.openEditor($e,le)}}),(0,D.$ki)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.$VE=d;function v(ce){return m(ce?.editor)}e.$WE=v;function R(ce){const $e=ce;return v(ce)&&$e?.group!==void 0}e.$XE=R;function B(ce){const $e=ce;return typeof $e?.groupId=="number"&&m($e.editor)}e.$YE=B;var V;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var j;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var W;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class O{getOriginalUri($e,ie){if(!$e)return;if(b($e))return e.$1E.getOriginalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:le}=this.a($e);if(q&&le){if(ie?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===W.ANY)return this.getOriginalUri(q,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(le,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===W.PRIMARY?q:le}}if(c($e)||g($e)||b($e))return;const N=I($e)?$e.preferredResource:$e.resource;return!N||!ie||!ie.filterByScheme?N:this.b(N,ie.filterByScheme)}a($e){return E($e)||g($e)?{primary:$e.primary,secondary:$e.secondary}:r($e)||c($e)?{primary:$e.modified,secondary:$e.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($e,ie){if(!$e)return;if(b($e))return e.$1E.getCanonicalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:le}=this.a($e);if(q&&le){if(ie?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===W.ANY)return this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===W.PRIMARY?q:le}}if(c($e)||g($e)||b($e))return;const N=$e.resource;return!N||!ie||!ie.filterByScheme?N:this.b(N,ie.filterByScheme)}b($e,ie){if(Array.isArray(ie)){if(ie.some(N=>$e.scheme===N))return $e}else if(ie===$e.scheme)return $e}}var z;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(z||(e.EditorCloseMethod=z={}));function ee(ce,$e,ie,N){if(!ce.isSticky($e))return!1;switch(N.preventPinnedEditorClose){case"keyboardAndMouse":return ie===z.MOUSE||ie===z.KEYBOARD;case"mouse":return ie===z.MOUSE;case"keyboard":return ie===z.KEYBOARD}return!1}e.$ZE=ee,e.$1E=new O;var X;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(X||(e.CloseDirection=X={}));class Ee{constructor(){this.c=new Map,this.d=new Map}start($e){const ie=this.a=$e.get(A.$zh);for(const[N,q]of this.c)this.e(N,q,ie);this.c.clear()}e($e,ie,N){const q=N.createInstance(ie);this.d.set($e,q)}registerFileEditorFactory($e){if(this.b)throw new Error("Can only register one file editor factory.");this.b=$e}getFileEditorFactory(){return(0,F.$tf)(this.b)}registerEditorSerializer($e,ie){if(this.c.has($e)||this.d.has($e))throw new Error(`A editor serializer with type ID '${$e}' was already registered.`);return this.a?this.e($e,ie,this.a):this.c.set($e,ie),(0,L.$hc)(()=>{this.c.delete($e),this.d.delete($e)})}getEditorSerializer($e){return this.d.get(typeof $e=="string"?$e:$e.typeId)}}l.$7m.add(e.$EE.EditorFactory,new Ee);async function ke(ce,$e,ie){return!ce||!ce.length?[]:await Promise.all(ce.map(async N=>{const q=C.URI.revive(N.fileUri);if(!q){ie.info("Cannot resolve the path because it is not valid.",N);return}if(!await $e.canHandleResource(q)){ie.info("Cannot resolve the path because it cannot be handled",N);return}let we=N.exists,ve=N.type;if(typeof we!="boolean"||typeof ve!="number")try{ve=(await $e.stat(q)).isDirectory?S.FileType.Directory:S.FileType.Unknown,we=!0}catch(De){ie.error(De),we=!1}if(!we&&N.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",N);return}if(ve===S.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",N);return}const me={...N.options,pinned:!0};return we?{resource:q,options:me}:{resource:q,options:me,forceUntitled:!0}}))}e.$2E=ke;var Pe;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function Z(ce){const $e=ce;if(!$e)return!1;const ie=$e;if(ie.modified)return Z(ie.modified);const N=$e;return!!(N.contributionsState&&N.viewState&&Array.isArray(N.cursorState))}e.$3E=Z;function ue(ce){return(0,P.$mi)(ce)}e.$4E=ue;function ye(ce,$e,ie){const N=(0,P.$ni)(ce,$e);return N.forceMessage=ie?.forceMessage,N.forceSeverity=ie?.forceSeverity,N.allowDialog=ie?.allowDialog,N}e.$5E=ye}),define(Ae[193],Re([1,0,5,161,4,6,28,30,18,100,24,89,184]),function(be,e,w,F,C,L,A,l,S,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=e.$$E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$0E=e.$9E=e.ViewContentGroups=e.$8E=e.$7E=e.ViewContainerLocation=e.Extensions=e.$6E=void 0,e.$6E=(0,u.$7u)("default-view-icon",D.$Oj.window,(0,F.localize)(0,null));var p;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var $;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})($||(e.ViewContainerLocation=$={})),e.$7E=[0,1,2];function h(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$8E=h;class t extends L.$jc{constructor(){super(...arguments),this.c=this.B(new w.$ed),this.onDidRegister=this.c.event,this.f=this.B(new w.$ed),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.$Ob)([...this.g.values()])}registerViewContainer(o,y,m){const I=this.get(o.id);if(I)return I;const E=o;return E.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,A.$vi)(this.g,y,[]).push(E),m?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:y}),E}deregisterViewContainer(o){for(const y of this.g.keys()){const m=this.g.get(y),I=m?.indexOf(o);if(I!==-1){m?.splice(I,1),m.length===0&&this.g.delete(y),this.f.fire({viewContainer:o,viewContainerLocation:y});return}}}get(o){return this.all.filter(y=>y.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(y=>this.getViewContainers(y).filter(m=>m?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(y=>this.getViewContainerLocation(y)===o)}}l.$7m.add(p.ViewContainersRegistry,new t);var i;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(i||(e.ViewContentGroups=i={}));function c(s,o){const y=s.group??i.More,m=o.group??i.More;return y!==m?y.localeCompare(m):(s.order??5)-(o.order??5)}class g extends L.$jc{constructor(){super(...arguments),this.c=this.B(new w.$ed),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$ed),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$ed),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$ed),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new f.$L}registerViews(o,y){this.registerViews2([{views:o,viewContainer:y}])}registerViews2(o){o.forEach(({views:y,viewContainer:m})=>this.r(y,m)),this.c.fire(o)}deregisterViews(o,y){const m=this.s(o,y);m.length&&this.f.fire({views:m,viewContainer:y})}moveViews(o,y){for(const m of this.m.keys())if(m!==y){const I=this.s(o,m);I.length&&(this.r(I,y),this.g.fire({views:I,from:m,to:y}))}}getViews(o){return this.m.get(o)||[]}getView(o){for(const y of this.j){const m=(this.m.get(y)||[]).filter(I=>I.id===o)[0];if(m)return m}return null}getViewContainer(o){for(const y of this.j)if((this.m.get(y)||[]).filter(I=>I.id===o)[0])return y;return null}registerViewWelcomeContent(o,y){return this.n.add(o,y),this.h.fire(o),(0,L.$hc)(()=>{this.n.delete(o,y),this.h.fire(o)})}registerViewWelcomeContent2(o,y){const m=new Map;for(const[I,E]of y)this.n.add(o,E),m.set(I,(0,L.$hc)(()=>{this.n.delete(o,E),this.h.fire(o)}));return this.h.fire(o),m}getViewWelcomeContent(o){const y=[];return this.n.forEach(o,m=>y.push(m)),y.sort(c)}r(o,y){let m=this.m.get(y);m||(m=[],this.m.set(y,m),this.j.push(y));for(const I of o){if(this.getView(I.id)!==null)throw new Error((0,F.localize)(1,null,I.id));m.push(I)}}s(o,y){const m=this.m.get(y);if(!m)return[];const I=[],E=[];for(const r of m)o.includes(r)?I.push(r):E.push(r);return I.length&&(E.length?this.m.set(y,E):(this.m.delete(y),this.j.splice(this.j.indexOf(y),1))),I}}l.$7m.add(p.ViewsRegistry,new g),e.$9E=(0,C.$Ah)("viewsService"),e.$0E=(0,C.$Ah)("viewDescriptorService");var k;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(k||(e.ViewVisibilityState=k={}));var b;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(b||(e.TreeItemCollapsibleState=b={}));class n{constructor(o,y){this.c=!1,this.d=!1,(0,P.$Xm)(this,o),this.d=!!y,this.resolve=async m=>{if(y&&!this.c){const I=await y(m);I&&(this.tooltip=this.tooltip??I.tooltip,this.command=this.command??I.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$$E=n;class a extends Error{constructor(o){super((0,F.localize)(2,null,o)),this.name="NoTreeViewError"}static is(o){return o.name==="NoTreeViewError"}}e.$_E=a}),define(Ae[194],Re([1,0,5,13,162]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new w.$ed,this.n=new w.$ed,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(l){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=l}onEvent(l){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=l}onRequest(l){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=l}sendResponse(l){l.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${l.command}`)):this.s("response",l)}sendRequest(l,S,f,P){const D={command:l};if(S&&Object.keys(S).length>0&&(D.arguments=S),this.s("request",D),typeof P=="number"){const u=setTimeout(()=>{clearTimeout(u);const p=this.f.get(D.seq);if(p){this.f.delete(D.seq);const $={type:"response",seq:0,request_seq:D.seq,success:!1,command:l,message:(0,C.localize)(0,null,P,l)};p($)}},P)}return f&&this.f.set(D.seq,f),D.seq}acceptMessage(l){this.j?this.j(l):(this.k.push(l),this.k.length===1&&this.q())}o(l,S){return l.type!=="event"||S.type!=="event"}async q(){let l;for(;this.k.length;){if((!l||this.o(this.k[0],l))&&await(0,F.$Gg)(0),l=this.k.shift(),!l)return;switch(l.type){case"event":this.i?.(l);break;case"request":this.g?.(l);break;case"response":{const S=l,f=this.f.get(S.request_seq);f&&(this.f.delete(S.request_seq),f(S));break}}}}s(l,S){S.type=l,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const l=new Map;this.f.forEach((S,f)=>l.set(f,S)),await(0,F.$Gg)(500),l.forEach((S,f)=>{S({type:"response",seq:0,request_seq:f,success:!1,command:"canceled",message:"canceled"}),this.f.delete(f)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$scb=L}),define(Ae[195],Re([1,0,163,32,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$lH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$kH=e.MemoryRangeType=e.$jH=e.State=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=void 0,e.$hG="workbench.view.debug",e.$iG="workbench.debug.variablesView",e.$jG="workbench.debug.watchExpressionsView",e.$kG="workbench.debug.callStackView",e.$lG="workbench.debug.loadedScriptsView",e.$mG="workbench.debug.breakPointsView",e.$nG="workbench.debug.disassemblyView",e.$oG="workbench.panel.repl",e.$pG="workbench.panel.repl.view",e.$qG=new F.$1i("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.$rG=new F.$1i("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.$sG=new F.$1i("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.$tG="debugUx",e.$uG=new F.$1i(e.$tG,"default",{type:"string",description:w.localize(3,null)}),e.$vG=new F.$1i("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.$wG=new F.$1i("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.$xG=new F.$1i("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.$yG=new F.$1i("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.$zG=new F.$1i("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.$AG=new F.$1i("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.$BG=new F.$1i("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.$CG=new F.$1i("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.$DG=new F.$1i("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.$EG=new F.$1i("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.$FG=new F.$1i("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.$GG=new F.$1i("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.$HG=new F.$1i("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.$IG=new F.$1i("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.$JG=new F.$1i("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.$KG=new F.$1i("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.$LG=new F.$1i("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.$MG=new F.$1i("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.$NG=new F.$1i("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.$OG=new F.$1i("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.$PG=new F.$1i("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.$QG=new F.$1i("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.$RG=new F.$1i("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.$SG=new F.$1i("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.$TG=new F.$1i("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.$UG=new F.$1i("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.$VG=new F.$1i("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.$WG=new F.$1i("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.$XG=new F.$1i("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.$YG=new F.$1i("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.$ZG=new F.$1i("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.$1G=new F.$1i("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.$2G=new F.$1i("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.$3G=new F.$1i("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.$4G=new F.$1i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.$5G=new F.$1i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.$6G=new F.$1i("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.$7G=new F.$1i("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.$8G=new F.$1i("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.$9G=new F.$1i("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.$0G=new F.$1i("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.$$G=new F.$1i("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.$_G=new F.$1i("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.$aH=new F.$1i("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.$bH=new F.$1i("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.$cH=new F.$1i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.$dH=new F.$1i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const L=u=>w.localize(51,null,u);e.$eH=L,e.$fH="editor.contrib.debug",e.$gH="editor.contrib.breakpoint",e.$hH="debug",e.$iH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var A;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(A||(e.State=A={}));function l(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$jH=l;var S;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$kH="vscode-debug-memory";var f;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var P;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$lH=(0,C.$Ah)("debugService");var D;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Ae[196],Re([1,0,15,2,19,24,12,44,21,18]),function(be,e,w,F,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=void 0;const P=/{([^}]+)}/g;function D(E,r,d){return E.replace(P,function(v,R){return r&&R.length>0&&R[0]!=="_"?v:d&&d.hasOwnProperty(R)?d[R]:v})}e.$gF=D;function u(E){const r={};for(const d of Object.keys(E))d.startsWith("!")||(r[d]=E[d]);return r}e.$hF=u;function p(E){return E.configuration.request==="attach"&&!$(E)&&(!E.parentSession||p(E.parentSession))}e.$iF=p;function $(E){let r=E.configuration.type;if(r)return r==="vslsShare"&&(r=E.configuration.adapterProxy.configuration.type),(0,w.$Le)(r,"extensionhost")||(0,w.$Le)(r,"pwa-extensionhost")?E:E.parentSession?$(E.parentSession):void 0}e.$jF=$;function h(E){return E.type&&(E.label||E.program||E.runtime)}e.$kF=h;function t(E,r,d){let v,R=0;const B=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=B.exec(E);){const j=V.index+1,W=j+V[0].length;if(j<=r&&W>=d){v=V[0],R=j;break}}if(v){const j=/\w+/g;let W=null;for(;(W=j.exec(v))&&!(W.index+1+R+W[0].length>=d););W&&(v=v.substring(0,j.lastIndex))}return v?{start:R,end:R+v.length-1}:{start:0,end:0}}e.$lF=t;async function i(E,r,d,v){if(E.evaluatableExpressionProvider.has(r)){const R=E.evaluatableExpressionProvider.ordered(r),B=(0,f.$Eb)(await Promise.all(R.map(async V=>{try{return await V.provideEvaluatableExpression(r,d,v??S.CancellationToken.None)}catch{return}})));if(B.length>0){let V=B[0].expression;const j=B[0].range;return V||(V=r.getLineContent(d.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:V}}}else{const R=r.getLineContent(d.lineNumber),{start:B,end:V}=t(R,d.column,d.column),j=R.substring(B-1,V);return{matchingExpression:j,range:new l.$is(d.lineNumber,B,d.lineNumber,B+j.length)}}return null}e.$mF=i;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(E){return!!(E&&E.match(c))}e.$nF=g;function k(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(g(E.path))return F.URI.parse(E.path);if((0,C.$7d)(E.path))return F.URI.file(E.path)}return E.path}function b(E){if(typeof E.path=="object"){const r=F.URI.revive(E.path);if(r)return r.scheme===A.Schemas.file?r.fsPath:r.toString()}return E.path}function n(E,r){const d=r?k:b,v=(0,L.$Um)(E);return s(v,(R,B)=>{R&&B&&(B.path=d(B))}),v}e.$oF=n;function a(E,r){const d=r?k:b,v=(0,L.$Um)(E);return s(v,(R,B)=>{!R&&B&&(B.path=d(B))}),v}e.$pF=a;function s(E,r){switch(E.type){case"event":{const d=E;switch(d.event){case"output":r(!1,d.body.source);break;case"loadedSource":r(!1,d.body.source);break;case"breakpoint":r(!1,d.body.breakpoint.source);break;default:break}break}case"request":{const d=E;switch(d.command){case"setBreakpoints":r(!0,d.arguments.source);break;case"breakpointLocations":r(!0,d.arguments.source);break;case"source":r(!0,d.arguments.source);break;case"gotoTargets":r(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(v=>r(!1,v));break;default:break}break}case"response":{const d=E;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(v=>r(!1,v.source));break;case"loadedSources":d.body.sources.forEach(v=>r(!1,v));break;case"scopes":d.body.scopes.forEach(v=>r(!1,v.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(v=>r(!1,v.source));break;case"setBreakpoints":d.body.breakpoints.forEach(v=>r(!1,v.source));break;case"disassemble":d.body?.instructions.forEach(R=>r(!1,R.location));break;default:break}break}}}function o(E){return E.filter(r=>!r.presentation?.hidden).sort((r,d)=>r.presentation?d.presentation?r.presentation.group?d.presentation.group?r.presentation.group!==d.presentation.group?r.presentation.group.localeCompare(d.presentation.group):y(r.presentation.order,d.presentation.order):-1:d.presentation.group?1:y(r.presentation.order,d.presentation.order):-1:d.presentation?1:0)}e.$qF=o;function y(E,r){return typeof E!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:E-r}async function m(E,r){const d=E.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorLanguageId});if(d!=="none"&&(await r.saveAll(),d==="allEditorsInActiveGroup")){const v=r.activeEditorPane;v&&v.input.resource?.scheme===A.Schemas.untitled&&await r.save({editor:v.input,groupId:v.group.id})}await E.reloadConfiguration()}e.$rF=m;const I=(E,r)=>!E||!r?E===r:E.name===r.name&&E.path===r.path&&E.sourceReference===r.sourceReference;e.$sF=I}),define(Ae[75],Re([1,0,25,37,66,67,12,19,22,32]),function(be,e,w,F,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4H=e.$3H=e.$2H=e.$1H=e.CellStatusbarAlignment=e.$ZH=e.$YH=e.$XH=e.NotebookEditorPriority=e.$WH=e.$VH=e.$UH=e.$TH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$SH=e.$RH=e.$QH=e.$PH=e.CellKind=e.$OH=e.$NH=e.$MH=void 0,e.$MH="workbench.editor.notebook",e.$NH="workbench.editor.notebookTextDiffEditor",e.$OH="workbench.editor.interactive";var P;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(P||(e.CellKind=P={})),e.$PH=["application/json","application/javascript","text/html","image/svg+xml",L.$Fr.latex,L.$Fr.markdown,"image/png","image/jpeg",L.$Fr.text],e.$QH=[L.$Fr.latex,L.$Fr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Fr.text],e.$RH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$SH="_notAvailable";var D;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var u;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var p;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var $;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})($||(e.NotebookRendererMatch=$={}));var h;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(h||(e.RendererMessagingSpec=h={}));var t;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var c;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var g;(function(z){z.scheme=A.Schemas.vscodeNotebookCell;const ee=["W","X","Y","Z","a","b","c","d","e","f"],X=new RegExp(`^[${ee.join("")}]+`),Ee=7;function ke($e,ie){const N=ie.toString(Ee),le=`${N.length<ee.length?ee[N.length-1]:"z"}${N}s${(0,w.$Yd)(w.$Ed.fromString($e.scheme),!0,!0)}`;return $e.with({scheme:z.scheme,fragment:le})}z.generate=ke;function Pe($e){if($e.scheme!==z.scheme)return;const ie=$e.fragment.indexOf("s");if(ie<0)return;const N=parseInt($e.fragment.substring(0,ie).replace(X,""),Ee),q=(0,w.$Xd)($e.fragment.substring(ie+1)).toString();if(!isNaN(N))return{handle:N,notebook:$e.with({scheme:q,fragment:null})}}z.parse=Pe;function Z($e,ie){return $e.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${$e.scheme!==A.Schemas.file?$e.scheme:""}`})}z.generateCellOutputUri=Z;function ue($e){if($e.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!ie)return;const N=ie[1]&&ie[1]!==""?ie[1]:void 0,q=ie[2];return{outputId:N,notebook:$e.with({scheme:q||A.Schemas.file,fragment:null})}}z.parseCellOutputUri=ue;function ye($e,ie,N){return z.generate($e,ie).with({scheme:N})}z.generateCellPropertyUri=ye;function ce($e,ie){if($e.scheme===ie)return z.parse($e.with({scheme:z.scheme}))}z.parseCellPropertyUri=ce})(g||(e.CellUri=g={}));const k=z=>S.$i?z.replace(/\//g,"\\"):z;class b{constructor(ee=[],X=e.$PH){this.e=X,this.d=[...new Set(ee)].map(Ee=>({pattern:Ee,matches:F.$qj(k(Ee))}))}sort(ee){const X=new Map(C.Iterable.map(ee,ke=>[ke,k(ke)]));let Ee=[];for(const{matches:ke}of this.d)for(const[Pe,Z]of X)if(ke(Z)){Ee.push(Pe),X.delete(Pe);break}return X.size&&(Ee=Ee.concat([...X.keys()].sort((ke,Pe)=>this.e.indexOf(ke)-this.e.indexOf(Pe)))),Ee}prioritize(ee,X){const Ee=this.f(ee);if(Ee===-1){this.d.unshift({pattern:ee,matches:F.$qj(k(ee))});return}const ke=new Set(X.map(Z=>this.f(Z,Ee)));ke.delete(-1);const Pe=Array.from(ke).sort();this.d.splice(Ee+1,0,...Pe.map(Z=>this.d[Z]));for(let Z=Pe.length-1;Z>=0;Z--)this.d.splice(Pe[Z],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,X=this.d.length){const Ee=k(ee);for(let ke=0;ke<X;ke++)if(this.d[ke].matches(Ee))return ke;return-1}}e.$TH=b;function n(z,ee,X,Ee=(ke,Pe)=>ke===Pe){const ke=[];function Pe(ye,ce,$e){if(ce===0&&$e.length===0)return;const ie=ke[ke.length-1];ie&&ie.start+ie.deleteCount===ye?(ie.deleteCount+=ce,ie.toInsert.push(...$e)):ke.push({start:ye,deleteCount:ce,toInsert:$e})}let Z=0,ue=0;for(;;){if(Z===z.length){Pe(Z,0,ee.slice(ue));break}if(ue===ee.length){Pe(Z,z.length-Z,[]);break}const ye=z[Z],ce=ee[ue];if(Ee(ye,ce)){Z+=1,ue+=1;continue}X(ce)?(Pe(Z,1,[]),Z+=1):(Pe(Z,0,[ce]),ue+=1)}return ke}e.$UH=n,e.$VH=new f.$1i("notebookEditorCursorAtBoundary","none"),e.$WH=new f.$1i("notebookEditorCursorAtLineBoundary","none");var a;(function(z){z.default="default",z.option="option"})(a||(e.NotebookEditorPriority=a={}));function s(z){const ee=z;return!!((typeof ee.include=="string"||F.$rj(ee.include))&&(typeof ee.exclude=="string"||F.$rj(ee.exclude)))}e.$XH=s;function o(z,ee,X){if(Array.isArray(z.viewType)&&z.viewType.indexOf(ee)>=0||z.viewType===ee)return!0;if(z.filenamePattern){const Ee=s(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,ke=s(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(F.$pj(Ee,(0,l.$_d)(X.fsPath).toLowerCase()))return!(ke&&F.$pj(ke,(0,l.$_d)(X.fsPath).toLowerCase()))}return!1}e.$YH=o,e.$ZH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols"};var y;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class m{static{this.d="notebook/"}static create(ee){return`${m.d}${ee}`}static parse(ee){if(ee.startsWith(m.d))return ee.substring(m.d.length)}}e.$1H=m;function I(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.$2H=I;const E=new TextDecoder;function r(z){const ee=[];let X=!1;for(const Z of z)(ee.length===0||X)&&(ee.push(Z),X=!0);let Ee=R(ee);const ke=w.$Ed.concat(ee.map(Z=>w.$Ed.wrap(Z))),Pe=O(ke);return Ee=Ee||Pe.byteLength!==ke.byteLength,{data:Pe,didCompression:Ee}}e.$3H=r,e.$4H=`${String.fromCharCode(27)}[A`;const d=e.$4H.split("").map(z=>z.charCodeAt(0)),v=10;function R(z){let ee=!1;return z.forEach((X,Ee)=>{if(Ee===0||X.length<e.$4H.length)return;const ke=z[Ee-1],Pe=X.subarray(0,e.$4H.length);if(Pe[0]===d[0]&&Pe[1]===d[1]&&Pe[2]===d[2]){const Z=ke.lastIndexOf(v);if(Z===-1)return;ee=!0,z[Ee-1]=ke.subarray(0,Z),z[Ee]=X.subarray(e.$4H.length)}}),ee}function B(z){let ee=z;do z=ee,ee=z.replace(/[^\n]\x08/gm,"");while(ee.length<z.length);return z}function V(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const ee=z.match(/^(.*)\r+/m)[1];let X=z.match(/\r+(.*)$/m)[1];X=X+ee.slice(X.length,ee.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return z}const j="\b".charCodeAt(0),W="\r".charCodeAt(0);function O(z){return!z.buffer.includes(j)&&!z.buffer.includes(W)?z:w.$Ed.fromString(V(B(E.decode(z.buffer))))}}),define(Ae[7],Re([1,0,18,9,49,28,67,15,16,2,36,20,38,97,75]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$){"use strict";var h,t,i,c,g,k,b,n,a,s,o,y,m,I,E,r,d,v;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$LL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.TestRunProfileKind=e.TestResultState=e.$sL=e.$rL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$qL=e.$pL=e.$oL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$nL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.ColorThemeKind=e.$hL=e.$gL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$fL=e.DebugConsoleMode=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$_K=e.$$K=e.FileChangeType=e.$0K=e.$9K=e.$8K=e.$7K=e.InlineCompletionTriggerKind=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.ConfigurationTarget=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$JK=e.ViewBadge=e.ProgressLocation=e.$IK=e.$HK=e.TaskScope=e.ShellQuoting=e.$GK=e.$FK=e.$EK=e.TaskPanelKind=e.TaskRevealKind=e.$DK=e.TerminalLocation=e.$CK=e.$BK=e.$AK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$zK=e.$yK=e.$xK=e.$wK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$vK=e.StatusBarAlignment=e.ViewColumn=e.$uK=e.$tK=e.$sK=e.$rK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$qK=e.$pK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.LanguageStatusSeverity=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.CodeActionTriggerKind=e.$cK=e.$bK=e.SymbolTag=e.SymbolKind=e.$aK=e.DocumentHighlightKind=e.$_J=e.$$J=e.$0J=e.$9J=e.DiagnosticSeverity=e.DiagnosticTag=e.$8J=e.$7J=e.FileEditType=e.$6J=e.$5J=e.$4J=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function R(U){return Object.assign(U,{apply:function(...re){if(re.length===0)return Reflect.construct(U,[]);{const Se=re.length===1?[]:re[1];return Reflect.construct(U,Se,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(U,[]);{const[Se,...Je]=re;return Reflect.construct(U,Je,Se.constructor)}}})}var B;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(B||(e.TerminalOutputAnchor=B={}));var V;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let j=h=class{static from(...T){let re=T;return new h(function(){if(re){for(const Se of re)Se&&typeof Se.dispose=="function"&&Se.dispose();re=void 0}})}#e;constructor(T){this.#e=T}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$WJ=j,e.$WJ=j=h=Ke([R],j);let W=t=class{static Min(...T){if(T.length===0)throw new TypeError;let re=T[0];for(let Se=1;Se<T.length;Se++){const Je=T[Se];Je.isBefore(re)&&(re=Je)}return re}static Max(...T){if(T.length===0)throw new TypeError;let re=T[0];for(let Se=1;Se<T.length;Se++){const Je=T[Se];Je.isAfter(re)&&(re=Je)}return re}static isPosition(T){if(!T)return!1;if(T instanceof t)return!0;const{line:re,character:Se}=T;return typeof re=="number"&&typeof Se=="number"}static of(T){if(T instanceof t)return T;if(this.isPosition(T))return new t(T.line,T.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(T,re){if(T<0)throw(0,F.$5)("line must be non-negative");if(re<0)throw(0,F.$5)("character must be non-negative");this.c=T,this.e=re}isBefore(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<T.e}isBeforeOrEqual(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<=T.e}isAfter(T){return!this.isBeforeOrEqual(T)}isAfterOrEqual(T){return!this.isBefore(T)}isEqual(T){return this.c===T.c&&this.e===T.e}compareTo(T){return this.c<T.c?-1:this.c>T.line?1:this.e<T.e?-1:this.e>T.e?1:0}translate(T,re=0){if(T===null||re===null)throw(0,F.$5)();let Se;return typeof T>"u"?Se=0:typeof T=="number"?Se=T:(Se=typeof T.lineDelta=="number"?T.lineDelta:0,re=typeof T.characterDelta=="number"?T.characterDelta:0),Se===0&&re===0?this:new t(this.line+Se,this.character+re)}with(T,re=this.character){if(T===null||re===null)throw(0,F.$5)();let Se;return typeof T>"u"?Se=this.line:typeof T=="number"?Se=T:(Se=typeof T.line=="number"?T.line:this.line,re=typeof T.character=="number"?T.character:this.character),Se===this.line&&re===this.character?this:new t(Se,re)}toJSON(){return{line:this.line,character:this.character}}};e.$XJ=W,e.$XJ=W=t=Ke([R],W);let O=i=class{static isRange(T){return T instanceof i?!0:T?W.isPosition(T.start)&&W.isPosition(T.end):!1}static of(T){if(T instanceof i)return T;if(this.isRange(T))return new i(T.start,T.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(T,re,Se,Je){let Xe,ot;if(typeof T=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"?(Xe=new W(T,re),ot=new W(Se,Je)):W.isPosition(T)&&W.isPosition(re)&&(Xe=W.of(T),ot=W.of(re)),!Xe||!ot)throw new Error("Invalid arguments");Xe.isBefore(ot)?(this.c=Xe,this.e=ot):(this.c=ot,this.e=Xe)}contains(T){return i.isRange(T)?this.contains(T.start)&&this.contains(T.end):W.isPosition(T)?!(W.of(T).isBefore(this.c)||this.e.isBefore(T)):!1}isEqual(T){return this.c.isEqual(T.c)&&this.e.isEqual(T.e)}intersection(T){const re=W.Max(T.start,this.c),Se=W.Min(T.end,this.e);if(!re.isAfter(Se))return new i(re,Se)}union(T){if(this.contains(T))return this;if(T.contains(this))return T;const re=W.Min(T.start,this.c),Se=W.Max(T.end,this.end);return new i(re,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(T,re=this.end){if(T===null||re===null)throw(0,F.$5)();let Se;return T?W.isPosition(T)?Se=T:(Se=T.start||this.start,re=T.end||this.end):Se=this.start,Se.isEqual(this.c)&&re.isEqual(this.end)?this:new i(Se,re)}toJSON(){return[this.start,this.end]}};e.$YJ=O,e.$YJ=O=i=Ke([R],O);let z=c=class extends O{static isSelection(T){return T instanceof c?!0:T?O.isRange(T)&&W.isPosition(T.anchor)&&W.isPosition(T.active)&&typeof T.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(T,re,Se,Je){let Xe,ot;if(typeof T=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"?(Xe=new W(T,re),ot=new W(Se,Je)):W.isPosition(T)&&W.isPosition(re)&&(Xe=W.of(T),ot=W.of(re)),!Xe||!ot)throw new Error("Invalid arguments");super(Xe,ot),this.f=Xe,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$ZJ=z,e.$ZJ=z=c=Ke([R],z);const ee=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,F.$5)("connectionToken")};class X{static isResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.host=="string"&&typeof T.port=="number"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,re,Se){if(typeof T!="string"||T.length===0)throw(0,F.$5)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,F.$5)("port");typeof Se<"u"&&ee(Se),this.host=T,this.port=Math.round(re),this.connectionToken=Se}}e.$1J=X;class Ee{static isManagedResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.makeConnection=="function"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,re){this.makeConnection=T,this.connectionToken=re,typeof re<"u"&&ee(re)}}e.$2J=Ee;class ke extends Error{static NotAvailable(T,re){return new ke(T,p.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(T){return new ke(T,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(T,re=p.RemoteAuthorityResolverErrorCode.Unknown,Se){super(T),this._message=T,this._code=re,this._detail=Se,Object.setPrototypeOf(this,ke.prototype)}}e.$3J=ke;var Pe;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var Z;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(Z||(e.EnvironmentVariableMutatorType=Z={}));let ue=g=class{static isTextEdit(T){return T instanceof g?!0:T?O.isRange(T)&&typeof T.newText=="string":!1}static replace(T,re){return new g(T,re)}static insert(T,re){return g.replace(new O(T,T),re)}static delete(T){return g.replace(T,"")}static setEndOfLine(T){const re=new g(new O(new W(0,0),new W(0,0)),"");return re.newEol=T,re}get range(){return this.c}set range(T){if(T&&!O.isRange(T))throw(0,F.$5)("range");this.c=T}get newText(){return this.e||""}set newText(T){if(T&&typeof T!="string")throw(0,F.$5)("newText");this.e=T}get newEol(){return this.f}set newEol(T){if(T&&typeof T!="number")throw(0,F.$5)("newEol");this.f=T}constructor(T,re){this.c=T,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$4J=ue,e.$4J=ue=g=Ke([R],ue);let ye=k=class{static isNotebookCellEdit(T){return T instanceof k?!0:T?Zt.isNotebookRange(T)&&Array.isArray(T.newCells):!1}static replaceCells(T,re){return new k(T,re)}static insertCells(T,re){return new k(new Zt(T,T),re)}static deleteCells(T){return new k(T,[])}static updateCellMetadata(T,re){const Se=new k(new Zt(T,T),[]);return Se.newCellMetadata=re,Se}static updateNotebookMetadata(T){const re=new k(new Zt(0,0),[]);return re.newNotebookMetadata=T,re}constructor(T,re){this.range=T,this.newCells=re}};e.$5J=ye,e.$5J=ye=k=Ke([R],ye);class ce{static isSnippetTextEdit(T){return T instanceof ce?!0:T?O.isRange(T.range)&&N.isSnippetString(T.snippet):!1}static replace(T,re){return new ce(T,re)}static insert(T,re){return ce.replace(new O(T,T),re)}constructor(T,re){this.range=T,this.snippet=re}}e.$6J=ce;var $e;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(T,re,Se,Je){this.c.push({_type:1,from:T,to:re,options:Se,metadata:Je})}createFile(T,re,Se){this.c.push({_type:1,from:void 0,to:T,options:re,metadata:Se})}deleteFile(T,re,Se){this.c.push({_type:1,from:T,to:void 0,options:re,metadata:Se})}e(T,re,Se){this.c.push({_type:3,metadata:Se,uri:T,edit:{editType:5,metadata:re},notebookMetadata:re})}f(T,re,Se,Je){const Xe=re.start,ot=re.end;(Xe!==ot||Se.length>0)&&this.c.push({_type:5,uri:T,index:Xe,count:ot-Xe,cells:Se,metadata:Je})}g(T,re,Se,Je){this.c.push({_type:3,metadata:Je,uri:T,edit:{editType:3,index:re,metadata:Se}})}replace(T,re,Se,Je){this.c.push({_type:2,uri:T,edit:new ue(re,Se),metadata:Je})}insert(T,re,Se,Je){this.replace(T,new O(re,re),Se,Je)}delete(T,re,Se){this.replace(T,re,"",Se)}has(T){return this.c.some(re=>re._type===2&&re.uri.toString()===T.toString())}set(T,re){if(re)for(const Se of re){if(!Se)continue;let Je,Xe;Array.isArray(Se)?(Je=Se[0],Xe=Se[1]):Je=Se,ye.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(T,Je.range.start,Je.newCellMetadata,Xe):Je.newNotebookMetadata?this.e(T,Je.newNotebookMetadata,Xe):this.f(T,Je.range,Je.newCells,Xe):ce.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:T,range:Je.range,edit:Je.snippet,metadata:Xe}):this.c.push({_type:2,uri:T,edit:Je,metadata:Xe})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===T.toString()&&(this.c[Se]=void 0);break}}(0,w.$Fb)(this.c)}}get(T){const re=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===T.toString()&&re.push(Se.edit);return re}entries(){const T=new L.$yi;for(const re of this.c)if(re._type===2){let Se=T.get(re.uri);Se||(Se=[re.uri,[]],T.set(re.uri,Se)),Se[1].push(re.edit)}return[...T.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$7J=ie,e.$7J=ie=Ke([R],ie);let N=b=class{static isSnippetString(T){return T instanceof b?!0:T?typeof T.value=="string":!1}static c(T){return T.replace(/\$|}|\\/g,"\\$&")}constructor(T){this.e=1,this.value=T||""}appendText(T){return this.value+=b.c(T),this}appendTabstop(T=this.e++){return this.value+="$",this.value+=T,this}appendPlaceholder(T,re=this.e++){if(typeof T=="function"){const Se=new b;Se.e=this.e,T(Se),this.e=Se.e,T=Se.value}else T=b.c(T);return this.value+="${",this.value+=re,this.value+=":",this.value+=T,this.value+="}",this}appendChoice(T,re=this.e++){const Se=T.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(T,re){if(typeof re=="function"){const Se=new b;Se.e=this.e,re(Se),this.e=Se.e,re=Se.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=T,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$8J=N,e.$8J=N=b=Ke([R],N);var q;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var le;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(le||(e.DiagnosticSeverity=le={}));let we=n=class{static isLocation(T){return T instanceof n?!0:T?O.isRange(T.range)&&f.URI.isUri(T.uri):!1}constructor(T,re){if(this.uri=T,re)if(O.isRange(re))this.range=O.of(re);else if(W.isPosition(re))this.range=new O(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$9J=we,e.$9J=we=n=Ke([R],we);let ve=class{static is(T){return T?typeof T.message=="string"&&T.location&&O.isRange(T.location.range)&&f.URI.isUri(T.location.uri):!1}constructor(T,re){this.location=T,this.message=re}static isEqual(T,re){return T===re?!0:!T||!re?!1:T.message===re.message&&T.location.range.isEqual(re.location.range)&&T.location.uri.toString()===re.location.uri.toString()}};e.$0J=ve,e.$0J=ve=Ke([R],ve);let me=class{constructor(T,re,Se=le.Error){if(!O.isRange(T))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=T,this.message=re,this.severity=Se}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(T,re){return T===re?!0:!T||!re?!1:T.message===re.message&&T.severity===re.severity&&T.code===re.code&&T.severity===re.severity&&T.source===re.source&&T.range.isEqual(re.range)&&(0,w.$sb)(T.tags,re.tags)&&(0,w.$sb)(T.relatedInformation,re.relatedInformation,ve.isEqual)}};e.$$J=me,e.$$J=me=Ke([R],me);let De=class{constructor(T,re){if(!T)throw new Error("Illegal argument, contents must be defined");Array.isArray(T)?this.contents=T:this.contents=[T],this.range=re}};e.$_J=De,e.$_J=De=Ke([R],De);var ne;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(ne||(e.DocumentHighlightKind=ne={}));let he=class{constructor(T,re=ne.Text){this.range=T,this.kind=re}toJSON(){return{range:this.range,kind:ne[this.kind]}}};e.$aK=he,e.$aK=he=Ke([R],he);var se;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(se||(e.SymbolKind=se={}));var oe;(function(U){U[U.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let fe=a=class{static validate(T){if(!T.name)throw new Error("name must not be falsy")}constructor(T,re,Se,Je,Xe){this.name=T,this.kind=re,this.containerName=Xe,typeof Se=="string"&&(this.containerName=Se),Je instanceof we?this.location=Je:Se instanceof O&&(this.location=new we(Je,Se)),a.validate(this)}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};e.$bK=fe,e.$bK=fe=a=Ke([R],fe);let Ie=s=class{static validate(T){if(!T.name)throw new Error("name must not be falsy");if(!T.range.contains(T.selectionRange))throw new Error("selectionRange must be contained in fullRange");T.children?.forEach(s.validate)}constructor(T,re,Se,Je,Xe){this.name=T,this.detail=re,this.kind=Se,this.range=Je,this.selectionRange=Xe,this.children=[],s.validate(this)}};e.$cK=Ie,e.$cK=Ie=s=Ke([R],Ie);var M;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(M||(e.CodeActionTriggerKind=M={}));let K=class{constructor(T,re){this.title=T,this.kind=re}};e.$dK=K,e.$dK=K=Ke([R],K);let G=class{static{o=this}static{this.c="."}constructor(T){this.value=T}append(T){return new o(this.value?this.value+o.c+T:T)}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+o.c)}};e.$eK=G,e.$eK=G=o=Ke([R],G);class Y extends G{constructor(T){super(T),this.value=T}}e.$fK=Y,G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let J=class{constructor(T,re){if(this.range=T,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$gK=J,e.$gK=J=Ke([R],J);class x{constructor(T,re,Se,Je,Xe,ot){this.kind=T,this.name=re,this.detail=Se,this.uri=Je,this.range=Xe,this.selectionRange=ot}}e.$hK=x;class ae{constructor(T,re){this.fromRanges=re,this.from=T}}e.$iK=ae;class Le{constructor(T,re){this.fromRanges=re,this.to=T}}e.$jK=Le;var Ue;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ue||(e.LanguageStatusSeverity=Ue={}));let Ye=class{constructor(T,re){this.range=T,this.command=re}get isResolved(){return!!this.command}};e.$kK=Ye,e.$kK=Ye=Ke([R],Ye);let He=y=class{#e;static isMarkdownString(T){return T instanceof y?!0:T&&T.appendCodeblock&&T.appendMarkdown&&T.appendText&&T.value!==void 0}constructor(T,re=!1){this.#e=new C.$Wj(T,{supportThemeIcons:re})}get value(){return this.#e.value}set value(T){this.#e.value=T}get isTrusted(){return this.#e.isTrusted}set isTrusted(T){this.#e.isTrusted=T}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(T){this.#e.supportThemeIcons=T}get supportHtml(){return this.#e.supportHtml}set supportHtml(T){this.#e.supportHtml=T}get baseUri(){return this.#e.baseUri}set baseUri(T){this.#e.baseUri=T}appendText(T){return this.#e.appendText(T),this}appendMarkdown(T){return this.#e.appendMarkdown(T),this}appendCodeblock(T,re){return this.#e.appendCodeblock(re??"",T),this}};e.$lK=He,e.$lK=He=y=Ke([R],He);let et=class{constructor(T,re){this.label=T,this.documentation=re}};e.$mK=et,e.$mK=et=Ke([R],et);let Ze=class{constructor(T,re){this.label=T,this.documentation=re,this.parameters=[]}};e.$nK=Ze,e.$nK=Ze=Ke([R],Ze);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$oK=_e,e.$oK=_e=Ke([R],_e);var it;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var tt;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let Ne=class{constructor(T){this.value=T}};e.$pK=Ne,e.$pK=Ne=Ke([R],Ne);let st=class{constructor(T,re,Se){this.position=T,this.label=re,this.kind=Se}};e.$qK=st,e.$qK=st=Ke([R],st);var _;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_||(e.CompletionTriggerKind=_={}));var Q;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Q||(e.CompletionItemKind=Q={}));var pe;(function(U){U[U.Deprecated=1]="Deprecated"})(pe||(e.CompletionItemTag=pe={}));let je=class{constructor(T,re){this.label=T,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&Q[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$rK=je,e.$rK=je=Ke([R],je);let ze=class{constructor(T=[],re=!1){this.items=T,this.isIncomplete=re}};e.$sK=ze,e.$sK=ze=Ke([R],ze);let Qe=class{constructor(T,re,Se){this.insertText=T,this.range=re,this.command=Se}};e.$tK=Qe,e.$tK=Qe=Ke([R],Qe);let nt=class{constructor(T){this.commands=void 0,this.suppressSuggestions=void 0,this.items=T}};e.$uK=nt,e.$uK=nt=Ke([R],nt);var gt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(gt||(e.ViewColumn=gt={}));var vt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(vt||(e.StatusBarAlignment=vt={}));function Mt(U,T){return`${D.$Ul.toKey(U)}.${T}`}e.$vK=Mt;var Qt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var Vt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Vt||(e.TextDocumentSaveReason=Vt={}));var wt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(wt||(e.TextEditorRevealType=wt={}));var Tt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Ot;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(Ot||(e.TextDocumentChangeReason=Ot={}));var Jt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Jt||(e.DecorationRangeBehavior=Jt={})),function(U){function T(re){switch(re){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=T}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));let Pt=class{constructor(T,re){if(re&&!f.URI.isUri(re))throw(0,F.$5)("target");if(!O.isRange(T)||T.isEmpty)throw(0,F.$5)("range");this.range=T,this.target=re}};e.$wK=Pt,e.$wK=Pt=Ke([R],Pt);let At=class{constructor(T,re,Se,Je){this.red=T,this.green=re,this.blue=Se,this.alpha=Je}};e.$xK=At,e.$xK=At=Ke([R],At);let zt=class{constructor(T,re){if(re&&!(re instanceof At))throw(0,F.$5)("color");if(!O.isRange(T)||T.isEmpty)throw(0,F.$5)("range");this.range=T,this.color=re}};e.$yK=zt,e.$yK=zt=Ke([R],zt);let jt=class{constructor(T){if(!T||typeof T!="string")throw(0,F.$5)("label");this.label=T}};e.$zK=jt,e.$zK=jt=Ke([R],jt);var qt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var Bt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Bt||(e.SourceControlInputBoxValidationType=Bt={}));var at;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(at||(e.TerminalExitReason=at={}));class ut{constructor(T,re,Se){if(this.startIndex=T,this.length=re,this.tooltip=Se,typeof T!="number"||T<0)throw(0,F.$5)("startIndex");if(typeof re!="number"||re<1)throw(0,F.$5)("length");if(Se!==void 0&&typeof Se!="string")throw(0,F.$5)("tooltip")}}e.$AK=ut;class Ht{constructor(T){this.uri=T}}e.$BK=Ht;class Ct{constructor(T){this.terminalCommand=T}}e.$CK=Ct;var kt;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class ht{constructor(T){if(this.options=T,typeof T!="object")throw(0,F.$5)("options")}}e.$DK=ht;var St;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(St||(e.TaskRevealKind=St={}));var Lt;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(Lt||(e.TaskPanelKind=Lt={}));let Et=class{static{m=this}static{this.Clean=new m("clean","Clean")}static{this.Build=new m("build","Build")}static{this.Rebuild=new m("rebuild","Rebuild")}static{this.Test=new m("test","Test")}static from(T){switch(T){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}constructor(T,re){if(this.label=re,typeof T!="string"||typeof re!="string")throw(0,F.$5)("name");this.c=T}get id(){return this.c}};e.$EK=Et,e.$EK=Et=m=Ke([R],Et);function qe(U){let T="";for(let re=0;re<U.length;re++)T+=U[re].replace(/,/g,",,")+",";return T}let Nt=class{constructor(T,re,Se){if(typeof T!="string")throw(0,F.$5)("process");this.e=[],this.c=T,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=Se):this.f=re)}get process(){return this.c}set process(T){if(typeof T!="string")throw(0,F.$5)("process");this.c=T}get args(){return this.e}set args(T){Array.isArray(T)||(T=[]),this.e=T}get options(){return this.f}set options(T){this.f=T}computeId(){const T=[];if(T.push("process"),this.c!==void 0&&T.push(this.c),this.e&&this.e.length>0)for(const re of this.e)T.push(re);return qe(T)}};e.$FK=Nt,e.$FK=Nt=Ke([R],Nt);let Ce=class{constructor(T,re,Se){if(this.f=[],Array.isArray(re)){if(!T)throw(0,F.$5)("command can't be undefined or null");if(typeof T!="string"&&typeof T.value!="string")throw(0,F.$5)("command");this.e=T,this.f=re,this.g=Se}else{if(typeof T!="string")throw(0,F.$5)("commandLine");this.c=T,this.g=re}}get commandLine(){return this.c}set commandLine(T){if(typeof T!="string")throw(0,F.$5)("commandLine");this.c=T}get command(){return this.e?this.e:""}set command(T){if(typeof T!="string"&&typeof T.value!="string")throw(0,F.$5)("command");this.e=T}get args(){return this.f}set args(T){this.f=T||[]}get options(){return this.g}set options(T){this.g=T}computeId(){const T=[];if(T.push("shell"),this.c!==void 0&&T.push(this.c),this.e!==void 0&&T.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)T.push(typeof re=="string"?re:re.value);return qe(T)}};e.$GK=Ce,e.$GK=Ce=Ke([R],Ce);var Fe;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Fe||(e.ShellQuoting=Fe={}));var ge;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(ge||(e.TaskScope=ge={}));class H{constructor(T){this.c=T}computeId(){return"customExecution"+(0,P.$3f)()}set callback(T){this.c=T}get callback(){return this.c}}e.$HK=H;let Me=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(T,re,Se,Je,Xe,ot){this.j=!1,this.k=this.definition=T;let lt;typeof re=="string"?(this.m=this.name=re,this.t=this.source=Se,this.execution=Je,lt=Xe,this.j=!0):re===ge.Global||re===ge.Workspace?(this.target=re,this.m=this.name=Se,this.t=this.source=Je,this.execution=Xe,lt=ot):(this.target=re,this.m=this.name=Se,this.t=this.source=Je,this.execution=Xe,lt=ot),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(T){this.h=T}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Nt?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof Ce?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof H?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,P.$3f)()}}get definition(){return this.k}set definition(T){if(T==null)throw(0,F.$5)("Kind can't be undefined or null");this.y(),this.k=T}get scope(){return this.l}set target(T){this.y(),this.l=T}get name(){return this.m}set name(T){if(typeof T!="string")throw(0,F.$5)("name");this.y(),this.m=T}get execution(){return this.n}set execution(T){T===null&&(T=void 0),this.y(),this.n=T;const re=this.k.type;(I.g===re||I.e===re||I.f===re||I.c===re)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(T){if(Array.isArray(T))this.y(),this.o=T,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(T){T!==!0&&T!==!1&&(T=!1),this.y(),this.r=T}get source(){return this.t}set source(T){if(typeof T!="string"||T.length===0)throw(0,F.$5)("source must be a string of length > 0");this.y(),this.t=T}get group(){return this.u}set group(T){T===null&&(T=void 0),this.y(),this.u=T}get detail(){return this.x}set detail(T){T===null&&(T=void 0),this.x=T}get presentationOptions(){return this.v}set presentationOptions(T){T==null&&(T=Object.create(null)),this.y(),this.v=T}get runOptions(){return this.w}set runOptions(T){T==null&&(T=Object.create(null)),this.y(),this.w=T}};e.$IK=Me,e.$IK=Me=I=Ke([R],Me);var Be;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(Be||(e.ProgressLocation=Be={}));var Ge;(function(U){function T(re){const Se=re;return(0,S.$mf)(Se.value)?Se.tooltip&&!(0,S.$if)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}U.isViewBadge=T})(Ge||(e.ViewBadge=Ge={}));let We=E=class{static isTreeItem(T,re){const Se=T;if(Se.checkboxState!==void 0){const Je=(0,S.$mf)(Se.checkboxState)?Se.checkboxState:(0,S.$kf)(Se.checkboxState)&&(0,S.$mf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Xe=!(0,S.$mf)(Se.checkboxState)&&(0,S.$kf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==pt.Checked&&Je!==pt.Unchecked||Xe!==void 0&&!(0,S.$if)(Xe))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(T instanceof E)return!0;if(Se.label!==void 0&&!(0,S.$if)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,S.$if)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,S.$if)(Se.iconPath)&&!f.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,S.$if)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,S.$if)(Je.light)&&!f.URI.isUri(Je.light)&&!(0,S.$if)(Je.dark)&&!f.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,S.$if)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!f.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,S.$if)(Se.tooltip)&&!(Se.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<xe.None&&Se.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,S.$if)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(T,re=xe.None){this.collapsibleState=re,f.URI.isUri(T)?this.resourceUri=T:this.label=T}};e.$JK=We,e.$JK=We=E=Ke([R],We);var xe;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var pt;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(pt||(e.TreeItemCheckboxState=pt={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(T){this.value=T}};e.$KK=bt,e.$KK=bt=Ke([R],bt);class dt extends bt{}e.$LK=dt;class ft extends dt{#e;constructor(T){super(""),this.#e=T}asFile(){return this.#e}}e.$MK=ft;class mt{constructor(T,re,Se,Je){this.name=T,this.uri=re,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$NK=mt;let gi=class{#e=new Map;constructor(T){for(const[re,Se]of T??[]){const Je=this.#e.get(this.#t(re));Je?Je.push(Se):this.#e.set(this.#t(re),[Se])}}get(T){return this.#e.get(this.#t(T))?.[0]}set(T,re){this.#e.set(this.#t(T),[re])}forEach(T,re){for(const[Se,Je]of this.#e)for(const Xe of Je)T.call(re,Xe,Se,this)}*[Symbol.iterator](){for(const[T,re]of this.#e)for(const Se of re)yield[T,Se]}#t(T){return T.toLowerCase()}};e.$OK=gi,e.$OK=gi=Ke([R],gi);let Kt=class{constructor(T){this.insertText=T}};e.$PK=Kt,e.$PK=Kt=Ke([R],Kt);let Ei=class{constructor(T,re){this.label=re,this.insertText=T}};e.$QK=Ei,e.$QK=Ei=Ke([R],Ei);let Wt=class{constructor(T,re){this.id=T,this.color=re}static isThemeIcon(T){return typeof T.id!="string"?(console.log("INVALID ThemeIcon, invalid id",T.id),!1):!0}};e.$RK=Wt,e.$RK=Wt=Ke([R],Wt),Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let mi=class{constructor(T){this.id=T}};e.$SK=mi,e.$SK=mi=Ke([R],mi);var It;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(It||(e.ConfigurationTarget=It={}));let ki=class{get base(){return this.c}set base(T){this.c=T,this.e=f.URI.file(T)}get baseUri(){return this.e}set baseUri(T){this.e=T,this.c=T.fsPath}constructor(T,re){if(typeof T!="string"&&(!T||!f.URI.isUri(T)&&!f.URI.isUri(T.uri)))throw(0,F.$5)("base");if(typeof re!="string")throw(0,F.$5)("pattern");typeof T=="string"?this.baseUri=f.URI.file(T):f.URI.isUri(T)?this.baseUri=T:this.baseUri=T.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$TK=ki,e.$TK=ki=Ke([R],ki);const Vi=new WeakMap;function Dt(U,T){Vi.set(U,T)}e.$UK=Dt;let ti=class{constructor(T,re,Se,Je){this.enabled=typeof T=="boolean"?T:!0,typeof re=="string"&&(this.condition=re),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Vi.get(this)??(0,P.$3f)()),this.c}};e.$VK=ti,e.$VK=ti=Ke([R],ti);let $i=class extends ti{constructor(T,re,Se,Je,Xe){if(super(re,Se,Je,Xe),T===null)throw(0,F.$5)("location");this.location=T}};e.$WK=$i,e.$WK=$i=Ke([R],$i);let si=class extends ti{constructor(T,re,Se,Je,Xe){super(re,Se,Je,Xe),this.functionName=T}};e.$XK=si,e.$XK=si=Ke([R],si);let Di=class extends ti{constructor(T,re,Se,Je,Xe,ot,lt){if(super(Je,Xe,ot,lt),!re)throw(0,F.$5)("dataId");this.label=T,this.dataId=re,this.canPersist=Se}};e.$YK=Di,e.$YK=Di=Ke([R],Di);let Si=class{constructor(T,re,Se){this.command=T,this.args=re||[],this.options=Se}};e.$ZK=Si,e.$ZK=Si=Ke([R],Si);let Rt=class{constructor(T,re){this.port=T,this.host=re}};e.$1K=Rt,e.$1K=Rt=Ke([R],Rt);let pi=class{constructor(T){this.path=T}};e.$2K=pi,e.$2K=pi=Ke([R],pi);let Ii=class{constructor(T){this.implementation=T}};e.$3K=Ii,e.$3K=Ii=Ke([R],Ii);let oi=class{constructor(T,re,Se){this.session=T,this.threadId=re,this.frameId=Se}};e.$4K=oi,e.$4K=oi=Ke([R],oi);let ai=class{constructor(T,re){this.session=T,this.threadId=re}};e.$5K=ai,e.$5K=ai=Ke([R],ai);let ct=class{constructor(T,re){this.range=T,this.expression=re}};e.$6K=ct,e.$6K=ct=Ke([R],ct);var qi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let Xt=class{constructor(T,re){this.range=T,this.text=re}};e.$7K=Xt,e.$7K=Xt=Ke([R],Xt);let ii=class{constructor(T,re,Se=!0){this.range=T,this.variableName=re,this.caseSensitiveLookup=Se}};e.$8K=ii,e.$8K=ii=Ke([R],ii);let bi=class{constructor(T,re){this.range=T,this.expression=re}};e.$9K=bi,e.$9K=bi=Ke([R],bi);let Ci=class{constructor(T,re){this.frameId=T,this.stoppedLocation=re}};e.$0K=Ci,e.$0K=Ci=Ke([R],Ci);var Ki;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Pi=r=class extends Error{static FileExists(T){return new r(T,u.FileSystemProviderErrorCode.FileExists,r.FileExists)}static FileNotFound(T){return new r(T,u.FileSystemProviderErrorCode.FileNotFound,r.FileNotFound)}static FileNotADirectory(T){return new r(T,u.FileSystemProviderErrorCode.FileNotADirectory,r.FileNotADirectory)}static FileIsADirectory(T){return new r(T,u.FileSystemProviderErrorCode.FileIsADirectory,r.FileIsADirectory)}static NoPermissions(T){return new r(T,u.FileSystemProviderErrorCode.NoPermissions,r.NoPermissions)}static Unavailable(T){return new r(T,u.FileSystemProviderErrorCode.Unavailable,r.Unavailable)}constructor(T,re=u.FileSystemProviderErrorCode.Unknown,Se){super(f.URI.isUri(T)?T.toString(!0):T),this.code=Se?.name??"Unknown",(0,u.$gk)(this,re),Object.setPrototypeOf(this,r.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$$K=Pi,e.$$K=Pi=r=Ke([R],Pi);let vi=class{constructor(T,re,Se){this.start=T,this.end=re,this.kind=Se}};e.$_K=vi,e.$_K=vi=Ke([R],vi);var Ji;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Ji||(e.FoldingRangeKind=Ji={}));var Ai;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ci;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var Hi;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Hi||(e.CommentState=Hi={}));var wi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ri{constructor(T,re=[]){this.tokenTypes=T,this.tokenModifiers=re}}e.$aL=Ri;function cn(U){return typeof U>"u"||(0,S.$jf)(U)}class Fi{constructor(T){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,T){this.l=!0;for(let re=0,Se=T.tokenTypes.length;re<Se;re++)this.j.set(T.tokenTypes[re],re);for(let re=0,Se=T.tokenModifiers.length;re<Se;re++)this.k.set(T.tokenModifiers[re],re)}}push(T,re,Se,Je,Xe){if(typeof T=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof Xe=="number"||typeof Xe>"u"))return typeof Xe>"u"&&(Xe=0),this.n(T,re,Se,Je,Xe);if(O.isRange(T)&&typeof re=="string"&&cn(Se))return this.m(T,re,Se);throw(0,F.$5)()}m(T,re,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(T.start.line!==T.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(re))throw new Error("`tokenType` is not in the provided legend");const Je=T.start.line,Xe=T.start.character,ot=T.end.character-T.start.character,lt=this.j.get(re);let Ut=0;if(Se)for(const Yt of Se){if(!this.k.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(Yt);Ut|=1<<xt>>>0}this.n(Je,Xe,ot,lt,Ut)}n(T,re,Se,Je,Xe){if(this.f&&(T<this.c||T===this.c&&re<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Yt=0,xt=0;for(let ei=0;ei<Ut;ei++){let ri=this.g[5*ei],Bi=this.g[5*ei+1];ri===0?(ri=Yt,Bi+=xt):ri+=Yt,this.g[5*ei]=ri,this.g[5*ei+1]=Bi,Yt=ri,xt=Bi}}let ot=T,lt=re;this.f&&this.h>0&&(ot-=this.c,ot===0&&(lt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=lt,this.g[this.h++]=Se,this.g[this.h++]=Je,this.g[this.h++]=Xe,this.c=T,this.e=re}static o(T){const re=[],Se=T.length/5|0;for(let lt=0;lt<Se;lt++)re[lt]=lt;re.sort((lt,Ut)=>{const Yt=T[5*lt],xt=T[5*Ut];if(Yt===xt){const ei=T[5*lt+1],ri=T[5*Ut+1];return ei-ri}return Yt-xt});const Je=new Uint32Array(T.length);let Xe=0,ot=0;for(let lt=0;lt<Se;lt++){const Ut=5*re[lt],Yt=T[Ut+0],xt=T[Ut+1],ei=T[Ut+2],ri=T[Ut+3],Bi=T[Ut+4],wn=Yt-Xe,Fn=wn===0?xt-ot:xt,Wi=5*lt;Je[Wi+0]=wn,Je[Wi+1]=Fn,Je[Wi+2]=ei,Je[Wi+3]=ri,Je[Wi+4]=Bi,Xe=Yt,ot=xt}return Je}build(T){return this.f?new ni(new Uint32Array(this.g),T):new ni(Fi.o(this.g),T)}}e.$bL=Fi;class ni{constructor(T,re){this.resultId=re,this.data=T}}e.$cL=ni;class un{constructor(T,re,Se){this.start=T,this.deleteCount=re,this.data=Se}}e.$dL=un;class ln{constructor(T,re){this.resultId=re,this.edits=T}}e.$eL=ln;var Gi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new Wt("arrow-left")}}constructor(){}};e.$fL=fi,e.$fL=fi=Ke([R],fi);var Yi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var Qi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Qi||(e.InputBoxValidationSeverity=Qi={}));var ui;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(ui||(e.ExtensionKind=ui={}));class Xi{static validate(T){if(typeof T.badge=="string"){let re=(0,l.$Ve)(T.badge,0);if(re<T.badge.length&&(re+=(0,l.$Ve)(T.badge,re)),T.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(T.badge&&!Wt.isThemeIcon(T.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!T.color&&!T.badge&&!T.tooltip)throw new Error("The decoration is empty");return!0}constructor(T,re,Se){this.badge=T,this.tooltip=re,this.color=Se}}e.$gL=Xi;let Mi=class{constructor(T){this.kind=T}};e.$hL=Mi,e.$hL=Mi=Ke([R],Mi);var Zi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(Zi||(e.ColorThemeKind=Zi={}));class Zt{static isNotebookRange(T){return T instanceof Zt?!0:T?typeof T.start=="number"&&typeof T.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(T,re){if(T<0)throw(0,F.$5)("start must be positive");if(re<0)throw(0,F.$5)("end must be positive");T<=re?(this.c=T,this.e=re):(this.c=re,this.e=T)}with(T){let re=this.c,Se=this.e;return T.start!==void 0&&(re=T.start),T.end!==void 0&&(Se=T.end),re===this.c&&Se===this.e?this:new Zt(re,Se)}}e.$iL=Zt;class yi{static validate(T){if(typeof T.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof T.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof T.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(T){return Array.isArray(T)&&T.every(re=>yi.isNotebookCellData(re))}static isNotebookCellData(T){return!0}constructor(T,re,Se,Je,Xe,ot,lt){this.kind=T,this.value=re,this.languageId=Se,this.mime=Je,this.outputs=Xe??[],this.metadata=ot,this.executionSummary=lt,yi.validate(this)}}e.$jL=yi;class hn{constructor(T){this.cells=T}}e.$kL=hn;class Gt{static isNotebookCellOutputItem(T){return T instanceof Gt?!0:T?typeof T.mime=="string"&&T.data instanceof Uint8Array:!1}static error(T){const re={name:T.name,message:T.message,stack:T.stack};return Gt.json(re,"application/vnd.code.notebook.error")}static stdout(T){return Gt.text(T,"application/vnd.code.notebook.stdout")}static stderr(T){return Gt.text(T,"application/vnd.code.notebook.stderr")}static bytes(T,re="application/octet-stream"){return new Gt(T,re)}static#e=new TextEncoder;static text(T,re=A.$Fr.text){const Se=Gt.#e.encode(String(T));return new Gt(Se,re)}static json(T,re="text/x-json"){const Se=JSON.stringify(T,void 0,"	");return Gt.text(Se,re)}constructor(T,re){this.data=T,this.mime=re;const Se=(0,A.$Jr)(re,!0);if(!Se)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$lL=Gt;class li{static isNotebookCellOutput(T){return T instanceof li?!0:!T||typeof T!="object"?!1:typeof T.id=="string"&&Array.isArray(T.items)}static ensureUniqueMimeTypes(T,re=!1){const Se=new Set,Je=new Set;for(let Xe=0;Xe<T.length;Xe++){const ot=T[Xe],lt=(0,A.$Jr)(ot.mime);if(!Se.has(lt)||(0,$.$2H)(lt)){Se.add(lt);continue}Je.add(Xe),re&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Je.size===0?T:T.filter((Xe,ot)=>!Je.has(ot))}constructor(T,re,Se){this.items=li.ensureUniqueMimeTypes(T,!0),typeof re=="string"?(this.id=re,this.metadata=Se):(this.id=(0,P.$3f)(),this.metadata=re??Se)}}e.$mL=li;var Ti;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Ti||(e.NotebookCellKind=Ti={}));var Oe;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(Oe||(e.NotebookCellExecutionState=Oe={}));var _t;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(_t||(e.NotebookCellStatusBarAlignment=_t={}));var Li;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Li||(e.NotebookEditorRevealType=Li={}));class $t{constructor(T,re){this.text=T,this.alignment=re}}e.$nL=$t;var _i;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(_i||(e.NotebookControllerAffinity=_i={}));var xi;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class en{constructor(T,re=[]){this.uri=T,this.provides=(0,w.$Zb)(re)}}e.$oL=en;class dn{constructor(T){this.label=T}}e.$pL=dn;let hi=class{constructor(T,re){this.label=T,this.timestamp=re}};e.$qL=hi,e.$qL=hi=Ke([R],hi);var tn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(T,re){this.ranges=T,this.wordPattern=re}}e.$rL=sn;class fn{constructor(T){this.c=T}get autoForwardAction(){return this.c}}e.$sL=fn;var on;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Oi=class{constructor(T=void 0,re=void 0,Se=void 0,Je=!1){this.include=T,this.exclude=re,this.profile=Se,this.continuous=Je}};e.$tL=Oi,e.$tL=Oi=Ke([R],Oi);let zi=d=class{static diff(T,re,Se){const Je=new d(T);return Je.expectedOutput=re,Je.actualOutput=Se,Je}constructor(T){this.message=T}};e.$uL=zi,e.$uL=zi=d=Ke([R],zi);let Ni=class{constructor(T){this.id=T}};e.$vL=Ni,e.$vL=Ni=Ke([R],Ni);let di=class{constructor(T,re){this.covered=T,this.total=re}};e.$wL=di,e.$wL=di=Ke([R],di);let Ui=v=class{static fromDetails(T,re){const Se=new di(0,0),Je=new di(0,0),Xe=new di(0,0);for(const lt of re)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const Ut of lt.branches)Je.total+=1,Je.covered+=Ut.executionCount>0?1:0}else Xe.total+=1,Xe.covered+=lt.executionCount>0?1:0;const ot=new v(T,Se,Je.total>0?Je:void 0,Xe.total>0?Xe:void 0);return ot.detailedCoverage=re,ot}constructor(T,re,Se,Je){this.uri=T,this.statementCoverage=re,this.branchCoverage=Se,this.functionCoverage=Je}};e.$xL=Ui,e.$xL=Ui=v=Ke([R],Ui);let ji=class{constructor(T,re,Se=[]){this.executionCount=T,this.location=re,this.branches=Se}};e.$yL=ji,e.$yL=ji=Ke([R],ji);let te=class{constructor(T,re){this.executionCount=T,this.location=re}};e.$zL=te,e.$zL=te=Ke([R],te);let de=class{constructor(T,re){this.executionCount=T,this.location=re}};e.$AL=de,e.$AL=de=Ke([R],de);var Te;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Te||(e.ExternalUriOpenerPriority=Te={}));var rt;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(rt||(e.WorkspaceTrustState=rt={}));var yt;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(yt||(e.PortAutoForwardAction=yt={}));class Ft{constructor(T,re,Se,Je,Xe,ot){this.kind=T,this.name=re,this.detail=Se,this.uri=Je,this.range=Xe,this.selectionRange=ot}}e.$BL=Ft;class yn{constructor(T){this.uri=T}}e.$CL=yn;class En{constructor(T,re){this.original=T,this.modified=re}}e.$DL=En;class kn{constructor(T,re,Se,Je){this.base=T,this.input1=re,this.input2=Se,this.result=Je}}e.$EL=kn;class Dn{constructor(T,re){this.uri=T,this.viewType=re}}e.$FL=Dn;class Sn{constructor(T){this.viewType=T}}e.$GL=Sn;class In{constructor(T,re){this.uri=T,this.notebookType=re}}e.$HL=In;class Cn{constructor(T,re,Se){this.original=T,this.modified=re,this.notebookType=Se}}e.$IL=Cn;class Pn{constructor(){}}e.$JL=Pn;class An{constructor(T,re){this.uri=T,this.inputBoxUri=re}}e.$KL=An;var gn;(function(U){U[U.Up=1]="Up",U[U.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var pn;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(pn||(e.ChatMessageRole=pn={}));var bn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(bn||(e.ChatVariableLevel=bn={}));class Rn{constructor(T,re){this.role=T,this.content=re}}e.$LL=Rn;var vn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(vn||(e.RelatedInformationType=vn={}))}),define(Ae[101],Re([1,0,50,12,15,277,137,7,18]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=e.$ZL=e.$YL=void 0;const f=new Map;function P($,h){h?f.set($,h):f.delete($)}e.$YL=P;function D($){return f.get($)}class u extends L.$Ku{constructor(h,t,i,c,g,k,b,n){super(t,i,c,g),this.c=h,this.m=k,this.q=b,this.notebook=n,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(h){return(0,S.$sb)(this.f,h)}get document(){if(!this.a){const h=this;this.a={get uri(){return h.d},get fileName(){return h.d.fsPath},get isUntitled(){return h.d.scheme===F.Schemas.untitled},get languageId(){return h.m},get version(){return h.h},get isClosed(){return h.b},get isDirty(){return h.q},save(){return h.r()},getText(t){return t?h.s(t):h.getText()},get eol(){return h.g===`
`?l.EndOfLine.LF:l.EndOfLine.CRLF},get lineCount(){return h.f.length},lineAt(t){return h.t(t)},offsetAt(t){return h.u(t)},positionAt(t){return h.v(t)},validateRange(t){return h.w(t)},validatePosition(t){return h.x(t)},getWordRangeAtPosition(t,i){return h.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(h){(0,w.ok)(!this.b),this.m=h}_acceptIsDirty(h){(0,w.ok)(!this.b),this.q=h}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(h){const t=this.w(h);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,c=t.start.line,g=t.end.line,k=[];k.push(this.f[c].substring(t.start.character));for(let b=c+1;b<g;b++)k.push(this.f[b]);return k.push(this.f[g].substring(0,t.end.character)),k.join(i)}t(h){let t;if(h instanceof l.$XJ?t=h.line:typeof h=="number"&&(t=h),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new p(t,this.f[t],t===this.f.length-1)}u(h){return h=this.x(h),this.l(),this.j.getPrefixSum(h.line-1)+h.character}v(h){h=Math.floor(h),h=Math.max(0,h),this.l();const t=this.j.getIndexOf(h),i=this.f[t.index].length;return new l.$XJ(t.index,Math.min(t.remainder,i))}w(h){if(!(h instanceof l.$YJ))throw new Error("Invalid argument");const t=this.x(h.start),i=this.x(h.end);return t===h.start&&i===h.end?h:new l.$YJ(t.line,t.character,i.line,i.character)}x(h){if(!(h instanceof l.$XJ))throw new Error("Invalid argument");if(this.f.length===0)return h.with(0,0);let{line:t,character:i}=h,c=!1;if(t<0)t=0,i=0,c=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,c=!0;else{const g=this.f[t].length;i<0?(i=0,c=!0):i>g&&(i=g,c=!0)}return c?new l.$XJ(t,i):h}y(h,t){const i=this.x(h);if(!t)t=D(this.m);else if((0,C.$ye)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,A.$Xr)(i.character+1,(0,A.$Vr)(t),this.f[i.line],0);if(c)return new l.$YJ(i.line,c.startColumn-1,i.line,c.endColumn-1)}}e.$ZL=u;class p{constructor(h,t,i){this.a=h,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new l.$YJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new l.$YJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$1L=p}),define(Ae[197],Re([1,0,7,17,5]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;let L=class{constructor(l){this.a=new w.$hL(w.ColorThemeKind.Dark),this.b=new C.$ed}get activeColorTheme(){return this.a}$onColorThemeChange(l){let S;switch(l){case"light":S=w.ColorThemeKind.Light;break;case"hcDark":S=w.ColorThemeKind.HighContrast;break;case"hcLight":S=w.ColorThemeKind.HighContrastLight;break;default:S=w.ColorThemeKind.Dark}this.a=new w.$hL(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$mcc=L,e.$mcc=L=Ke([Ve(0,F.$WL)],L)}),define(Ae[198],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6H=e.CellExecutionUpdateType=void 0;var F;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$6H=(0,w.$Ah)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HI=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(L){L.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class C{static fromExtHostTestItem(A,l,S=A.parent){if(A._isRoot)return new C([l]);const f=[A.id];for(let P=S;P&&P.id!==l;P=P.parent)f.push(P.id);return f.push(l),new C(f.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const l=A.indexOf("\0");return l===-1?A:A.slice(0,l)}static fromString(A){return new C(A.split("\0"))}static join(A,l){return new C([...A.path,l])}static joinToString(A,l){return A.toString()+"\0"+l}static parentId(A){const l=A.lastIndexOf("\0");return l===-1?void 0:A.slice(0,l)}static localId(A){const l=A.lastIndexOf("\0");return l===-1?A:A.slice(l+1)}static isChild(A,l){return l.startsWith(A)&&l[A.length]==="\0"}static compare(A,l){return A===l?0:C.isChild(A,l)?2:C.isChild(l,A)?3:1}constructor(A,l=A.length){if(this.path=A,this.d=l,A.length===0||l<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let l=0;l<A.d&&l<this.d;l++)if(A.path[l]!==this.path[l])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$HI=C}),define(Ae[56],Re([1,0,2,44,45]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$NI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$MI=e.$LI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$KI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$JI=e.$II=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(E){E[E.Unset=0]="Unset",E[E.Queued=1]="Queued",E[E.Running=2]="Running",E[E.Passed=3]="Passed",E[E.Failed=4]="Failed",E[E.Skipped=5]="Skipped",E[E.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var A;(function(E){E[E.Run=1]="Run",E[E.Debug=2]="Debug",E[E.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var l;(function(E){E[E.Run=2]="Run",E[E.Debug=4]="Debug",E[E.Coverage=8]="Coverage",E[E.HasNonDefaultProfile=16]="HasNonDefaultProfile",E[E.HasConfigurable=32]="HasConfigurable",E[E.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.$II=[2,4,8,16,32,64];const S=E=>"runId"in E;e.$JI=S;var f;(function(E){E.serialize=r=>({range:r.range.toJSON(),uri:r.uri.toJSON()}),E.deserialize=r=>({range:F.$is.lift(r.range),uri:w.URI.revive(r.uri)})})(f||(e.IRichLocation=f={}));var P;(function(E){E[E.Error=0]="Error",E[E.Output=1]="Output"})(P||(e.TestMessageType=P={}));var D;(function(E){E.serialize=r=>({message:r.message,type:0,expected:r.expected,actual:r.actual,contextValue:r.contextValue,location:r.location&&f.serialize(r.location)}),E.deserialize=r=>({message:r.message,type:0,expected:r.expected,actual:r.actual,contextValue:r.contextValue,location:r.location&&f.deserialize(r.location)})})(D||(e.ITestErrorMessage=D={}));const u=(E,r)=>`${r?"s":"e"}${E}`;e.$KI=u;var p;(function(E){E.serialize=r=>({message:r.message,type:1,offset:r.offset,length:r.length,location:r.location&&f.serialize(r.location)}),E.deserialize=r=>({message:r.message,type:1,offset:r.offset,length:r.length,location:r.location&&f.deserialize(r.location)})})(p||(e.ITestOutputMessage=p={}));var $;(function(E){E.serialize=r=>r.type===0?D.serialize(r):p.serialize(r),E.deserialize=r=>r.type===0?D.deserialize(r):p.deserialize(r)})($||(e.ITestMessage=$={}));var h;(function(E){E.serializeWithoutMessages=r=>({state:r.state,duration:r.duration,messages:[]}),E.serialize=r=>({state:r.state,duration:r.duration,messages:r.messages.map($.serialize)}),E.deserialize=r=>({state:r.state,duration:r.duration,messages:r.messages.map($.deserialize)})})(h||(e.ITestTaskState=h={}));const t="\0",i=(E,r)=>E+t+r;e.$LI=i;const c=E=>{const r=E.indexOf(t);return{ctrlId:E.slice(0,r),tagId:E.slice(r+1)}};e.$MI=c;var g;(function(E){E.serialize=r=>({extId:r.extId,label:r.label,tags:r.tags,busy:r.busy,children:void 0,uri:r.uri?.toJSON(),range:r.range?.toJSON()||null,description:r.description,error:r.error,sortText:r.sortText}),E.deserialize=r=>({extId:r.extId,label:r.label,tags:r.tags,busy:r.busy,children:void 0,uri:r.uri?w.URI.revive(r.uri):void 0,range:r.range?F.$is.lift(r.range):null,description:r.description,error:r.error,sortText:r.sortText})})(g||(e.ITestItem=g={}));var k;(function(E){E[E.NotExpandable=0]="NotExpandable",E[E.Expandable=1]="Expandable",E[E.BusyExpanding=2]="BusyExpanding",E[E.Expanded=3]="Expanded"})(k||(e.TestItemExpandState=k={}));var b;(function(E){E.serialize=r=>({expand:r.expand,item:g.serialize(r.item)}),E.deserialize=r=>({controllerId:C.$HI.root(r.item.extId),expand:r.expand,item:g.deserialize(r.item)})})(b||(e.InternalTestItem=b={}));var n;(function(E){E.serialize=r=>{let d;return r.item&&(d={},r.item.label!==void 0&&(d.label=r.item.label),r.item.tags!==void 0&&(d.tags=r.item.tags),r.item.busy!==void 0&&(d.busy=r.item.busy),r.item.uri!==void 0&&(d.uri=r.item.uri?.toJSON()),r.item.range!==void 0&&(d.range=r.item.range?.toJSON()),r.item.description!==void 0&&(d.description=r.item.description),r.item.error!==void 0&&(d.error=r.item.error),r.item.sortText!==void 0&&(d.sortText=r.item.sortText)),{extId:r.extId,expand:r.expand,item:d}},E.deserialize=r=>{let d;return r.item&&(d={},r.item.label!==void 0&&(d.label=r.item.label),r.item.tags!==void 0&&(d.tags=r.item.tags),r.item.busy!==void 0&&(d.busy=r.item.busy),r.item.range!==void 0&&(d.range=r.item.range?F.$is.lift(r.item.range):null),r.item.description!==void 0&&(d.description=r.item.description),r.item.error!==void 0&&(d.error=r.item.error),r.item.sortText!==void 0&&(d.sortText=r.item.sortText)),{extId:r.extId,expand:r.expand,item:d}}})(n||(e.ITestItemUpdate=n={}));const a=(E,r)=>{r.expand!==void 0&&(E.expand=r.expand),r.item!==void 0&&(E.item=E.item?Object.assign(E.item,r.item):r.item)};e.$NI=a;var s;(function(E){E.serializeWithoutMessages=r=>({...b.serialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(h.serializeWithoutMessages)}),E.serialize=r=>({...b.serialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(h.serialize)}),E.deserialize=r=>({...b.deserialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(h.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var o;(function(E){E[E.Function=0]="Function",E[E.Statement=1]="Statement"})(o||(e.DetailType=o={}));var y;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.DocumentSynced=2]="DocumentSynced",E[E.Remove=3]="Remove",E[E.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",E[E.Retire=5]="Retire",E[E.AddTag=6]="AddTag",E[E.RemoveTag=7]="RemoveTag"})(y||(e.TestDiffOpType=y={}));var m;(function(E){E.deserialize=r=>r.op===0?{op:r.op,item:b.deserialize(r.item)}:r.op===1?{op:r.op,item:n.deserialize(r.item)}:r.op===2?{op:r.op,uri:w.URI.revive(r.uri),docv:r.docv}:r,E.serialize=r=>r.op===0?{op:r.op,item:b.serialize(r.item)}:r.op===1?{op:r.op,item:n.serialize(r.item)}:r})(m||(e.TestsDiffOp=m={}));class I{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(r){const d=this.p();for(const v of r)switch(v.op){case 0:this.k(b.deserialize(v.item),d);break;case 1:this.l(n.deserialize(v.item),d);break;case 3:this.m(v.itemId,d);break;case 5:this.o(v.itemId);break;case 4:this.updatePendingRoots(v.amount);break;case 6:this.d.set(v.tag.id,v.tag);break;case 7:this.d.delete(v.id);break}d.complete?.()}k(r,d){const v=C.$HI.parentId(r.item.extId)?.toString();let R;if(!v)R=this.q(r),this.g.add(R),this.f.set(r.item.extId,R);else if(this.f.has(v)){const B=this.f.get(v);B.children.add(r.item.extId),R=this.q(r,B),this.f.set(r.item.extId,R)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(r)}`);return}return d.add?.(R),r.expand===2&&this.h++,R}l(r,d){const v=this.f.get(r.extId);if(v)return r.expand!==void 0&&(v.expand===2&&this.h--,r.expand===2&&this.h++),(0,e.$NI)(v,r),d.update?.(v),v}m(r,d){const v=this.f.get(r);if(!v)return;const R=C.$HI.parentId(v.item.extId)?.toString();R?this.f.get(R).children.delete(v.item.extId):this.g.delete(v);const B=[[r]];for(;B.length;)for(const V of B.pop()){const j=this.f.get(V);j&&(B.push(j.children),this.f.delete(V),d.remove?.(j,j!==v),j.expand===2&&this.h--)}}o(r){}updatePendingRoots(r){this.j+=r}p(){return{}}}e.$OI=I}),define(Ae[76],Re([1,0,13,5,6,50,56,45]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.TestItemEventOp=void 0;var S;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(S||(e.TestItemEventOp=S={}));const f=(c,g)=>c===g,D=Object.entries({range:(c,g)=>c===g?!0:!c||!g?!1:c.equalsRange(g),busy:f,label:f,description:f,error:f,sortText:f,tags:(c,g)=>!(c.length!==g.length||c.some(k=>!g.includes(k)))}),u=(c,g)=>{let k;for(const[b,n]of D)n(c[b],g[b])||(k?k[b]=g[b]:k={[b]:g[b]});return k};class p extends C.$jc{get root(){return this.s.root}constructor(g){super(),this.s=g,this.f=this.B(new w.$Rg(()=>this.flushDiff(),200)),this.g=this.B(new F.$ed),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(g){this.h=g;for(const k of this.tree.values())this.I(k)}get resolveHandler(){return this.h}collectDiff(){const g=this.m;return this.m=[],g}pushDiff(g){switch(g.op){case 2:{for(const k of this.m)if(k.op===2&&k.uri===g.uri){k.docv=g.docv;return}break}case 1:{const k=this.m[this.m.length-1];if(k){if(k.op===1&&k.item.extId===g.item.extId){(0,A.$NI)(k.item,g.item);return}if(k.op===0&&k.item.item.extId===g.item.extId){(0,A.$NI)(k.item,g.item);return}}break}}this.m.push(g),this.f.isScheduled()||this.f.schedule()}expand(g,k){const b=this.tree.get(g);if(b){if((b.expandLevels===void 0||k>b.expandLevels)&&(b.expandLevels=k),b.expand===1){const n=this.L(b);return n.isOpen()?this.J(b,k-1):n.wait().then(()=>this.J(b,k-1))}else if(b.expand===3)return b.resolveBarrier?.isOpen()===!1?b.resolveBarrier.wait().then(()=>this.J(b,k-1)):this.J(b,k-1)}}dispose(){for(const g of this.tree.values())this.s.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(g,k){switch(k.op){case 3:this.N(l.$HI.joinToString(g.fullId,k.id));break;case 0:this.y(k.item,g);break;case 5:for(const b of k.ops)this.u(g,b);break;case 1:this.z(k.new,k.old,g.fullId.toString());break;case 2:this.I(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:k.update}});break;case 6:this.w(g.actual.uri);break;default:(0,L.$uc)(k)}}w(g){g&&this.pushDiff({op:2,uri:g,docv:this.s.getDocumentVersion(g)})}y(g,k){const b=l.$HI.fromExtHostTestItem(g,this.root.id,k?.actual),n=this.s.getApiFor(g);n.parent&&n.parent!==k?.actual&&this.s.getChildren(n.parent).delete(g.id);let a=this.tree.get(b.toString());if(!a){a={fullId:b,actual:g,expandLevels:k?.expandLevels?k.expandLevels-1:void 0,expand:0},g.tags.forEach(this.C,this),this.tree.set(a.fullId.toString(),a),this.F(g,k),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:a.expand,item:this.s.toITestItem(g)}}),this.H(g,a,k);return}if(a.actual===g){this.G(g,a,k);return}if(a.actual.uri?.toString()!==g.uri?.toString())return this.N(b.toString()),this.y(g,k);const s=this.s.getChildren(a.actual),o=a.actual,y=u(this.s.toITestItem(o),this.s.toITestItem(g));this.s.getApiFor(o).listener=void 0,a.actual=g,a.expand=0,y&&(y.hasOwnProperty("tags")&&(this.z(g.tags,o.tags,b.toString()),delete y.tags),this.u(a,{op:4,update:y})),this.H(g,a,k);for(const[m,I]of s)this.s.getChildren(g).get(I.id)||this.N(l.$HI.joinToString(b,I.id));this.w(a.actual.uri)}z(g,k,b){const n=new Set(k.map(a=>a.id));for(const a of g)n.delete(a.id)||this.C(a);this.pushDiff({op:1,item:{extId:b,item:{tags:g.map(a=>(0,A.$LI)(this.s.controllerId,a.id))}}}),n.forEach(this.D,this)}C(g){const k=this.j.get(g.id);k?k.refCount++:(this.j.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$LI)(this.s.controllerId,g.id)}}))}D(g){const k=this.j.get(g);k&&!--k.refCount&&(this.j.delete(g),this.pushDiff({op:7,id:(0,A.$LI)(this.s.controllerId,g)}))}F(g,k){this.s.getApiFor(g).parent=k&&k.actual!==this.root?k.actual:void 0}G(g,k,b){this.F(g,b);const n=this.s.getApiFor(g);n.parent=b?.actual,n.listener=a=>this.u(k,a),this.I(k)}H(g,k,b){this.G(g,k,b);for(const[n,a]of this.s.getChildren(g))this.y(a,k)}I(g){let k;this.h?g.resolveBarrier?k=g.resolveBarrier.isOpen()?3:2:k=g.actual.canResolveChildren?1:0:k=0,k!==g.expand&&(g.expand=k,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:k}}),k===1&&g.expandLevels!==void 0&&this.L(g))}J(g,k){if(k<0)return;const b=[];for(const[n,a]of this.s.getChildren(g.actual)){const s=this.expand(l.$HI.joinToString(g.fullId,a.id),k);(0,w.$sg)(s)&&b.push(s)}if(b.length)return Promise.all(b).then(()=>{})}L(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this.h){const a=new w.$Eg;return a.open(),a}g.expand=2,this.M(g);const k=g.resolveBarrier=new w.$Eg,b=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,a)};let n;try{n=this.h(g.actual===this.root?void 0:g.actual)}catch(a){b(a)}return(0,w.$sg)(n)?n.catch(b).then(()=>{k.open(),this.I(g)}):(k.open(),this.I(g)),g.resolveBarrier}M(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}N(g){const k=this.tree.get(g);if(!k)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const b=[k];for(;b.length;){const n=b.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const a of n.actual.tags)this.D(a.id);this.tree.delete(n.fullId.toString());for(const[a,s]of this.s.getChildren(n.actual))b.push(this.tree.get(l.$HI.joinToString(n.fullId,s.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.g.fire(g)}}e.$ML=p;class $ extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.$NL=$;class h extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$OL=h;class t extends Error{constructor(g,k,b){super(`TestItem with ID "${g}" is from controller "${k}" and cannot be added as a child of an item from controller "${b}".`)}}e.$PL=t;const i=(c,g,k)=>{let b=new Map;return{get size(){return b.size},forEach(n,a){for(const s of b.values())n.call(a,s,this)},[Symbol.iterator](){return b.entries()},replace(n){const a=new Map,s=new Set(b.keys()),o={op:5,ops:[]};for(const y of n){if(!(y instanceof k))throw new h(y.id);const m=g(y).controllerId;if(m!==c.controllerId)throw new t(y.id,m,c.controllerId);if(a.has(y.id))throw new $(y.id);a.set(y.id,y),s.delete(y.id),o.ops.push({op:0,item:y})}for(const y of s.keys())o.ops.push({op:3,id:y});c.listener?.(o),b=a},add(n){if(!(n instanceof k))throw new h(n.id);b.set(n.id,n),c.listener?.({op:0,item:n})},delete(n){b.delete(n)&&c.listener?.({op:3,id:n})},get(n){return b.get(n)},toJSON(){return Array.from(b.values())}}};e.$QL=i}),define(Ae[102],Re([1,0,76]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SL=e.$RL=void 0;const F=new WeakMap,C=(A,l)=>{const S={controllerId:l};return F.set(A,S),S};e.$RL=C;const L=A=>{const l=F.get(A);if(!l)throw new w.$OL(A?.id||"<unknown>");return l};e.$SL=L}),define(Ae[77],Re([1,0,12,2]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mob=e.$Lob=e.$Kob=e.$Job=e.$Iob=void 0,e.$Iob="vscode-cdn.net",e.$Job=`vscode-resource.${e.$Iob}`,e.$Kob=`'self' https://*.${e.$Iob}`;function C(l,S){return l.scheme===w.Schemas.http||l.scheme===w.Schemas.https?l:(S&&S.authority&&S.isRemote&&l.scheme===w.Schemas.file&&(l=F.URI.from({scheme:w.Schemas.vscodeRemote,authority:S.authority,path:l.path})),F.URI.from({scheme:w.Schemas.https,authority:`${l.scheme}+${L(l.authority)}.${e.$Job}`,path:l.path,fragment:l.fragment,query:l.query}))}e.$Lob=C;function L(l){return l.replace(/./g,S=>{const f=S.charCodeAt(0);return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57?S:"-"+f.toString(16).padStart(4,"0")})}function A(l){return l.replace(/-([0-9a-f]{4})/g,(S,f)=>String.fromCharCode(parseInt(f,16)))}e.$Mob=A}),define(Ae[199],Re([1,0,5,6,77]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=void 0;class L{constructor(l,S,f){this.d=l,this.e=S,this.f=f,this.a=0,this.b=new F.$ic,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const P=S.getVisibleTextEditors();for(const D of this.c.values())P.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(l=>l.inset.dispose()),this.b.dispose()}createWebviewEditorInset(l,S,f,P,D){let u;for(const g of this.e.getVisibleTextEditors(!0))if(g.value===l){u=g;break}if(!u)throw new Error("not a visible editor");const p=this,$=this.a++,h=new w.$ed,t=new w.$ed,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(g){return(0,C.$Lob)(g,p.f)}get cspSource(){return C.$Kob}set options(g){this.b=g,p.d.$setOptions($,g)}get options(){return this.b}set html(g){this.a=g,p.d.$setHtml($,g)}get html(){return this.a}get onDidReceiveMessage(){return h.event}postMessage(g){return p.d.$postMessage($,g)}},c=new class{constructor(){this.editor=l,this.line=S,this.height=f,this.webview=i,this.onDidDispose=t.event}dispose(){p.c.has($)&&(p.c.delete($),p.d.$disposeEditorInset($),t.fire(),t.dispose(),h.dispose())}};return this.d.$createEditorInset($,u.id,u.value.document.uri,S+1,f,P||{},D.identifier,D.extensionLocation),this.c.set($,{editor:l,inset:c,onDidReceiveMessage:h}),c}$onDidDispose(l){const S=this.c.get(l);S&&S.inset.dispose()}$onDidReceiveMessage(l,S){this.c.get(l)?.onDidReceiveMessage.fire(S)}}e.$Wbc=L}),define(Ae[200],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JM=e.VariableKind=e.$IM=void 0,e.$IM=(0,w.$Ah)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class C extends Error{constructor(A,l){super(l),this.variable=A}}e.$JM=C}),define(Ae[201],Re([1,0,19,74,16,24,22,90,166,200,15]),function(be,e,w,F,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,$,h,t){this.h=new Map,this.a=p,this.b=$,this.g=h,t&&(this.c=t.then(i=>this.i(i)))}i(p){if(A.$i){const $=Object.create(null);return Object.keys(p).forEach(h=>{$[h.toLowerCase()]=p[h]}),$}return p}resolveWithEnvironment(p,$,h){return this.l({env:this.i(p),userHome:void 0},$?$.uri:void 0,h)}async resolveAsync(p,$){const h={env:await this.c,userHome:await this.g};return this.l(h,p?p.uri:void 0,$)}async j(p,$,h,t){const i=L.$Um($);A.$i&&i.windows?Object.keys(i.windows).forEach(g=>i[g]=i.windows[g]):A.$j&&i.osx?Object.keys(i.osx).forEach(g=>i[g]=i.osx[g]):A.$k&&i.linux&&Object.keys(i.linux).forEach(g=>i[g]=i.linux[g]),delete i.windows,delete i.osx,delete i.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,p?p.uri:void 0,i,h,t)}async resolveAnyAsync(p,$,h){return this.j(p,$,h)}async resolveAnyMap(p,$,h){const t=new Map;return{newConfig:await this.j(p,$,h,t),resolvedVariables:t}}resolveWithInteractionReplace(p,$,h,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,$,h,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,$){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,$)}async l(p,$,h,t,i){if(C.$if(h))return this.m(p,$,h,t,i);if(Array.isArray(h))return Promise.all(h.map(c=>this.l(p,$,c,t,i)));if(C.$kf(h)){const c=Object.create(null),g=await Promise.all(Object.keys(h).map(async k=>[await this.m(p,$,k,t,i),await this.l(p,$,h[k],t,i)]));for(const[k,b]of g)c[k]=b;return c}return h}m(p,$,h,t,i){return(0,P.$De)(h,D.VARIABLE_REGEXP,async(c,g)=>{if(g.includes(D.VARIABLE_LHS))return c;let k=await this.o(p,c,g,$,t);return i?.set(g,k),k!==c&&C.$if(k)&&k.match(D.VARIABLE_REGEXP)&&(k=await this.m(p,$,k,t,i)),k})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,$,h,t,i){let c;const g=h.split(":");g.length>1&&(h=g[0],c=g[1]);const k=a=>{const s=this.a.getFilePath();if(s)return(0,l.$dA)(s);throw new f.$JM(a,(0,S.localize)(0,null,$))},b=a=>{const s=k(a);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,l.$dA)(o)}throw new f.$JM(a,(0,S.localize)(1,null,$,w.$_d(s)))},n=a=>{if(c){const s=this.a.getFolderUri(c);if(s)return s;throw new f.$JM(a,(0,S.localize)(2,null,$,c))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new f.$JM(a,(0,S.localize)(3,null,$)):new f.$JM(a,(0,S.localize)(4,null,$))};switch(h){case"env":if(c){if(p.env){const a=p.env[A.$i?c.toLowerCase():c];if(C.$if(a))return a}return""}throw new f.$JM(f.VariableKind.Env,(0,S.localize)(5,null,$));case"config":if(c){const a=this.a.getConfigurationValue(t,c);if(C.$rf(a))throw new f.$JM(f.VariableKind.Config,(0,S.localize)(6,null,$,c));if(C.$kf(a))throw new f.$JM(f.VariableKind.Config,(0,S.localize)(7,null,$,c));return a}throw new f.$JM(f.VariableKind.Config,(0,S.localize)(8,null,$));case"command":return this.p(f.VariableKind.Command,$,c,i,"command");case"input":return this.p(f.VariableKind.Input,$,c,i,"input");case"extensionInstallFolder":if(c){const a=await this.a.getExtension(c);if(!a)throw new f.$JM(f.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,$,c));return this.n(a.extensionLocation)}throw new f.$JM(f.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,$));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,l.$dA)(this.n(n(f.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,l.$dA)(this.n(n(f.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,l.$dA)(w.$_d(this.n(n(f.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new f.$JM(f.VariableKind.UserHome,(0,S.localize)(11,null,$))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new f.$JM(f.VariableKind.LineNumber,(0,S.localize)(12,null,$))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new f.$JM(f.VariableKind.SelectedText,(0,S.localize)(13,null,$))}case"file":return k(f.VariableKind.File);case"fileWorkspaceFolder":return b(f.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?w.$0d(this.n(n(f.VariableKind.RelativeFile)),k(f.VariableKind.RelativeFile)):k(f.VariableKind.RelativeFile);case"relativeFileDirname":{const a=w.$$d(k(f.VariableKind.RelativeFileDirname));if(t||c){const s=w.$0d(this.n(n(f.VariableKind.RelativeFileDirname)),a);return s.length===0?".":s}return a}case"fileDirname":return w.$$d(k(f.VariableKind.FileDirname));case"fileExtname":return w.$ae(k(f.VariableKind.FileExtname));case"fileBasename":return w.$_d(k(f.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=w.$_d(k(f.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-w.$ae(a).length)}case"fileDirnameBasename":return w.$_d(w.$$d(k(f.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||$}case"execInstallFolder":{const a=this.a.getAppRoot();return a||$}case"pathSeparator":return w.sep;default:try{const a=c?`${h}:${c}`:h;return this.p(f.VariableKind.Unknown,$,a,i,void 0)}catch{return $}}}}p(p,$,h,t,i){if(h&&t){const c=i===void 0?t[h]:t[i+":"+h];if(typeof c=="string")return c;throw new f.$JM(p,(0,S.localize)(14,null,$))}return $}}e.$XM=D}),define(Ae[103],Re([1,0,4,99]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6C=e.$5C=e.OpenEditorContext=e.GroupsOrder=e.$4C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$3C=void 0,e.$3C=(0,w.$Ah)("editorGroupsService");var C;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var L;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var l;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EVEN=1]="EVEN",$[$.TOGGLE=2]="TOGGLE"})(l||(e.GroupsArrangement=l={}));var S;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(S||(e.MergeGroupMode=S={}));function f($){const h=$;return(0,F.$SE)(h?.editor)&&(0,F.$SE)(h?.replacement)}e.$4C=f;var P;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var D;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function u($){const h=$;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.$5C=u;function p($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$6C=p}),define(Ae[202],Re([1,0,4,103]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0C=e.$9C=e.$8C=e.$7C=void 0,e.$7C=(0,w.$Ah)("editorService"),e.$8C=-1,e.$9C=-2;function C(L){const A=L;return typeof L=="number"||(0,F.$5C)(A)}e.$0C=C}),define(Ae[8],Re([1,0,18,25,123,203,49,28,117,68,67,24,16,2,44,78,94,102,99,75,45,56,202,7]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t,i,c,g,k,b,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$VL=e.$UL=e.MarkdownString=e.$TL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Ce){function Fe(H){const{selectionStartLineNumber:Me,selectionStartColumn:Be,positionLineNumber:Ge,positionColumn:We}=H,xe=new a.$XJ(Me-1,Be-1),pt=new a.$XJ(Ge-1,We-1);return new a.$ZJ(xe,pt)}Ce.to=Fe;function ge(H){const{anchor:Me,active:Be}=H;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ce.from=ge})(s||(e.Selection=s={}));var o;(function(Ce){function Fe(H){if(!H)return;const{start:Me,end:Be}=H;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ce.from=Fe;function ge(H){if(!H)return;const{startLineNumber:Me,startColumn:Be,endLineNumber:Ge,endColumn:We}=H;return new a.$YJ(Me-1,Be-1,Ge-1,We-1)}Ce.to=ge})(o||(e.Range=o={}));var y;(function(Ce){function Fe(ge){switch(ge){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Ce.to=Fe})(y||(e.TokenType=y={}));var m;(function(Ce){function Fe(H){return new a.$XJ(H.lineNumber-1,H.column-1)}Ce.to=Fe;function ge(H){return{lineNumber:H.line+1,column:H.character+1}}Ce.from=ge})(m||(e.Position=m={}));var I;(function(Ce){function Fe(Me,Be,Ge){return(0,w.$Eb)((0,w.$Zb)(Me).map(We=>ge(We,Be,Ge)))}Ce.from=Fe;function ge(Me,Be,Ge){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Ge?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:H(Me.scheme,Be),pattern:st.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Ge?.isBuiltin}}function H(Me,Be){return Be&&typeof Me=="string"?Be.transformOutgoingScheme(Me):Me}})(I||(e.DocumentSelector=I={}));var E;(function(Ce){function Fe(H){switch(H){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Ce.from=Fe;function ge(H){switch(H){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Ce.to=ge})(E||(e.DiagnosticTag=E={}));var r;(function(Ce){function Fe(H){let Me;return H.code&&((0,u.$if)(H.code)||(0,u.$mf)(H.code)?Me=String(H.code):Me={value:String(H.code.value),target:H.code.target}),{...o.from(H.range),message:H.message,source:H.source,code:Me,severity:v.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(d.from),tags:Array.isArray(H.tags)?(0,w.$Eb)(H.tags.map(E.from)):void 0}}Ce.from=Fe;function ge(H){const Me=new a.$$J(o.to(H),H.message,v.to(H.severity));return Me.source=H.source,Me.code=(0,u.$if)(H.code)?H.code:H.code?.value,Me.relatedInformation=H.relatedInformation&&H.relatedInformation.map(d.to),Me.tags=H.tags&&(0,w.$Eb)(H.tags.map(E.to)),Me}Ce.to=ge})(r||(e.Diagnostic=r={}));var d;(function(Ce){function Fe(H){return{...o.from(H.location.range),message:H.message,resource:H.location.uri}}Ce.from=Fe;function ge(H){return new a.$0J(new a.$9J(H.resource,o.to(H)),H.message)}Ce.to=ge})(d||(e.DiagnosticRelatedInformation=d={}));var v;(function(Ce){function Fe(H){switch(H){case a.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Fe;function ge(H){switch(H){case t.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Ce.to=ge})(v||(e.DiagnosticSeverity=v={}));var R;(function(Ce){function Fe(H){return typeof H=="number"&&H>=a.ViewColumn.One?H-1:H===a.ViewColumn.Beside?n.$9C:n.$8C}Ce.from=Fe;function ge(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=ge})(R||(e.ViewColumn=R={}));function B(Ce){return typeof Ce.range<"u"}function V(Ce){return Ce.length===0?!0:!!B(Ce[0])}e.$TL=V;var j;(function(Ce){function Fe(We){return We.map(Ce.from)}Ce.fromMany=Fe;function ge(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function H(We){let xe;if(ge(We)){const{language:ft,value:mt}=We;xe={value:"```"+ft+`
`+mt+"\n```\n"}}else a.$lK.isMarkdownString(We)?xe={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?xe={value:We}:xe={value:""};const pt=Object.create(null);xe.uris=pt;const bt=ft=>{try{let mt=p.URI.parse(ft,!0);mt=mt.with({query:Me(mt.query,pt)}),pt[ft]=mt}catch{}return""},dt=new S.marked.Renderer;return dt.link=bt,dt.image=ft=>typeof ft=="string"?bt(A.$4j(ft).href):"",(0,S.marked)(xe.value,{renderer:dt}),xe}Ce.from=H;function Me(We,xe){if(!We)return We;let pt;try{pt=(0,f.$9g)(We)}catch{}if(!pt)return We;let bt=!1;return pt=(0,D.$Wm)(pt,dt=>{if(p.URI.isUri(dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return xe[ft]=dt,bt=!0,ft}else return}),bt?JSON.stringify(pt):We}function Be(We){const xe=new a.$lK(We.value,We.supportThemeIcons);return xe.isTrusted=We.isTrusted,xe.supportHtml=We.supportHtml,xe.baseUri=We.baseUri?p.URI.from(We.baseUri):void 0,xe}Ce.to=Be;function Ge(We){if(We)return typeof We=="string"?We:Ce.from(We)}Ce.fromStrict=Ge})(j||(e.MarkdownString=j={}));function W(Ce){return V(Ce)?Ce.map(Fe=>({range:o.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?j.fromMany(Fe.hoverMessage):Fe.hoverMessage?j.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Ce.map(Fe=>({range:o.from(Fe)}))}e.$UL=W;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?p.URI.file(Ce):Ce}e.$VL=O;var z;(function(Ce){function Fe(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?O(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ce.from=Fe})(z||(e.ThemableDecorationAttachmentRenderOptions=z={}));var ee;(function(Ce){function Fe(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?O(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?z.from(ge.before):void 0,after:ge.after?z.from(ge.after):void 0}}Ce.from=Fe})(ee||(e.ThemableDecorationRenderOptions=ee={}));var X;(function(Ce){function Fe(ge){if(typeof ge>"u")return ge;switch(ge){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Fe})(X||(e.DecorationRangeBehavior=X={}));var Ee;(function(Ce){function Fe(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?X.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?ee.from(ge.light):void 0,dark:ge.dark?ee.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?O(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?z.from(ge.before):void 0,after:ge.after?z.from(ge.after):void 0}}Ce.from=Fe})(Ee||(e.DecorationRenderOptions=Ee={}));var ke;(function(Ce){function Fe(H){return{text:H.newText,eol:H.newEol&&Ze.from(H.newEol),range:o.from(H.range)}}Ce.from=Fe;function ge(H){const Me=new a.$4J(o.to(H.range),H.text);return Me.newEol=typeof H.eol>"u"?void 0:Ze.to(H.eol),Me}Ce.to=ge})(ke||(e.TextEdit=ke={}));var Pe;(function(Ce){function Fe(H,Me){const Be={edits:[]};if(H instanceof a.$7J){const Ge=new l.$zi;for(const We of H._allEntries())We._type===1&&p.URI.isUri(We.to)&&We.from===void 0&&Ge.add(We.to);for(const We of H._allEntries())if(We._type===1){let xe;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?xe={type:"base64",value:(0,F.$Yd)(F.$Ed.wrap(We.options.contents))}:xe={type:"dataTransferItem",id:We.options.contents._itemId}),Be.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:xe},metadata:We.metadata})}else We._type===2?Be.edits.push({resource:We.uri,textEdit:ke.from(We.edit),versionId:Ge.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Be.edits.push({resource:We.uri,textEdit:{range:o.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ge.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Be.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Be.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(gt.from)}})}return Be}Ce.from=Fe;function ge(H){const Me=new a.$7J,Be=new l.$yi;for(const Ge of H.edits)if(Ge.textEdit){const We=Ge,xe=p.URI.revive(We.resource),pt=o.to(We.textEdit.range),bt=We.textEdit.text,dt=We.textEdit.insertAsSnippet;let ft;dt?ft=a.$6J.replace(pt,new a.$8J(bt)):ft=a.$4J.replace(pt,bt);const mt=Be.get(xe);mt?mt.push(ft):Be.set(xe,[ft])}else Me.renameFile(p.URI.revive(Ge.oldResource),p.URI.revive(Ge.newResource),Ge.options);for(const[Ge,We]of Be)Me.set(Ge,We);return Me}Ce.to=ge})(Pe||(e.WorkspaceEdit=Pe={}));var Z;(function(Ce){const Fe=Object.create(null);Fe[a.SymbolKind.File]=0,Fe[a.SymbolKind.Module]=1,Fe[a.SymbolKind.Namespace]=2,Fe[a.SymbolKind.Package]=3,Fe[a.SymbolKind.Class]=4,Fe[a.SymbolKind.Method]=5,Fe[a.SymbolKind.Property]=6,Fe[a.SymbolKind.Field]=7,Fe[a.SymbolKind.Constructor]=8,Fe[a.SymbolKind.Enum]=9,Fe[a.SymbolKind.Interface]=10,Fe[a.SymbolKind.Function]=11,Fe[a.SymbolKind.Variable]=12,Fe[a.SymbolKind.Constant]=13,Fe[a.SymbolKind.String]=14,Fe[a.SymbolKind.Number]=15,Fe[a.SymbolKind.Boolean]=16,Fe[a.SymbolKind.Array]=17,Fe[a.SymbolKind.Object]=18,Fe[a.SymbolKind.Key]=19,Fe[a.SymbolKind.Null]=20,Fe[a.SymbolKind.EnumMember]=21,Fe[a.SymbolKind.Struct]=22,Fe[a.SymbolKind.Event]=23,Fe[a.SymbolKind.Operator]=24,Fe[a.SymbolKind.TypeParameter]=25;function ge(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}Ce.from=ge;function H(Me){for(const Be in Fe)if(Fe[Be]===Me)return Number(Be);return a.SymbolKind.Property}Ce.to=H})(Z||(e.SymbolKind=Z={}));var ue;(function(Ce){function Fe(H){switch(H){case a.SymbolTag.Deprecated:return 1}}Ce.from=Fe;function ge(H){switch(H){case 1:return a.SymbolTag.Deprecated}}Ce.to=ge})(ue||(e.SymbolTag=ue={}));var ye;(function(Ce){function Fe(H){return{name:H.name,kind:Z.from(H.kind),tags:H.tags&&H.tags.map(ue.from),containerName:H.containerName,location:q.from(H.location)}}Ce.from=Fe;function ge(H){const Me=new a.$bK(H.name,Z.to(H.kind),H.containerName,q.to(H.location));return Me.tags=H.tags&&H.tags.map(ue.to),Me}Ce.to=ge})(ye||(e.WorkspaceSymbol=ye={}));var ce;(function(Ce){function Fe(H){const Me={name:H.name||"!!MISSING: name!!",detail:H.detail,range:o.from(H.range),selectionRange:o.from(H.selectionRange),kind:Z.from(H.kind),tags:H.tags?.map(ue.from)??[]};return H.children&&(Me.children=H.children.map(Fe)),Me}Ce.from=Fe;function ge(H){const Me=new a.$cK(H.name,H.detail,Z.to(H.kind),o.to(H.range),o.to(H.selectionRange));return(0,w.$Ib)(H.tags)&&(Me.tags=H.tags.map(ue.to)),H.children&&(Me.children=H.children.map(ge)),Me}Ce.to=ge})(ce||(e.DocumentSymbol=ce={}));var $e;(function(Ce){function Fe(H){const Me=new a.$hK(Z.to(H.kind),H.name,H.detail||"",p.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Fe;function ge(H,Me,Be){if(Me=Me??H._sessionId,Be=Be??H._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,name:H.name,detail:H.detail,kind:Z.from(H.kind),uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(ue.from)}}Ce.from=ge})($e||(e.CallHierarchyItem=$e={}));var ie;(function(Ce){function Fe(ge){return new a.$iK($e.to(ge.from),ge.fromRanges.map(H=>o.to(H)))}Ce.to=Fe})(ie||(e.CallHierarchyIncomingCall=ie={}));var N;(function(Ce){function Fe(ge){return new a.$jK($e.to(ge.to),ge.fromRanges.map(H=>o.to(H)))}Ce.to=Fe})(N||(e.CallHierarchyOutgoingCall=N={}));var q;(function(Ce){function Fe(H){return{range:H.range&&o.from(H.range),uri:H.uri}}Ce.from=Fe;function ge(H){return new a.$9J(p.URI.revive(H.uri),o.to(H.range))}Ce.to=ge})(q||(e.location=q={}));var le;(function(Ce){function Fe(H){const Me=H,Be=H;return{originSelectionRange:Me.originSelectionRange?o.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Be.uri,range:o.from(Me.targetRange?Me.targetRange:Be.range),targetSelectionRange:Me.targetSelectionRange?o.from(Me.targetSelectionRange):void 0}}Ce.from=Fe;function ge(H){return{targetUri:p.URI.revive(H.uri),targetRange:o.to(H.range),targetSelectionRange:H.targetSelectionRange?o.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?o.to(H.originSelectionRange):void 0}}Ce.to=ge})(le||(e.DefinitionLink=le={}));var we;(function(Ce){function Fe(H){return{range:o.from(H.range),contents:j.fromMany(H.contents)}}Ce.from=Fe;function ge(H){return new a.$_J(H.contents.map(j.to),o.to(H.range))}Ce.to=ge})(we||(e.Hover=we={}));var ve;(function(Ce){function Fe(H){return{range:o.from(H.range),expression:H.expression}}Ce.from=Fe;function ge(H){return new a.$6K(o.to(H.range),H.expression)}Ce.to=ge})(ve||(e.EvaluatableExpression=ve={}));var me;(function(Ce){function Fe(H){if(H instanceof a.$7K)return{type:"text",range:o.from(H.range),text:H.text};if(H instanceof a.$8K)return{type:"variable",range:o.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof a.$9K)return{type:"expression",range:o.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Fe;function ge(H){switch(H.type){case"text":return{range:o.to(H.range),text:H.text};case"variable":return{range:o.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:o.to(H.range),expression:H.expression}}}Ce.to=ge})(me||(e.InlineValue=me={}));var De;(function(Ce){function Fe(H){return{frameId:H.frameId,stoppedLocation:o.from(H.stoppedLocation)}}Ce.from=Fe;function ge(H){return new a.$0K(H.frameId,o.to(H.stoppedLocation))}Ce.to=ge})(De||(e.InlineValueContext=De={}));var ne;(function(Ce){function Fe(H){return{range:o.from(H.range),kind:H.kind}}Ce.from=Fe;function ge(H){return new a.$aK(o.to(H.range),H.kind)}Ce.to=ge})(ne||(e.DocumentHighlight=ne={}));var he;(function(Ce){function Fe(ge){switch(ge){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Ce.to=Fe})(he||(e.CompletionTriggerKind=he={}));var se;(function(Ce){function Fe(ge){return{triggerKind:he.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ce.to=Fe})(se||(e.CompletionContext=se={}));var oe;(function(Ce){function Fe(H){switch(H){case a.CompletionItemTag.Deprecated:return 1}}Ce.from=Fe;function ge(H){switch(H){case 1:return a.CompletionItemTag.Deprecated}}Ce.to=ge})(oe||(e.CompletionItemTag=oe={}));var fe;(function(Ce){const Fe=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ge(Be){return Fe.get(Be)??9}Ce.from=ge;const H=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Me(Be){return H.get(Be)??a.CompletionItemKind.Property}Ce.to=Me})(fe||(e.CompletionItemKind=fe={}));var Ie;(function(Ce){function Fe(ge,H){const Me=new a.$rK(ge.label);return Me.insertText=ge.insertText,Me.kind=fe.to(ge.kind),Me.tags=ge.tags?.map(oe.to),Me.detail=ge.detail,Me.documentation=A.$Yj(ge.documentation)?j.to(ge.documentation):ge.documentation,Me.sortText=ge.sortText,Me.filterText=ge.filterText,Me.preselect=ge.preselect,Me.commitCharacters=ge.commitCharacters,$.$is.isIRange(ge.range)?Me.range=o.to(ge.range):typeof ge.range=="object"&&(Me.range={inserting:o.to(ge.range.insert),replacing:o.to(ge.range.replace)}),Me.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Me.insertText=new a.$8J(ge.insertText):(Me.insertText=ge.insertText,Me.textEdit=Me.range instanceof a.$YJ?new a.$4J(Me.range,Me.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Me.additionalTextEdits=ge.additionalTextEdits.map(Be=>ke.to(Be))),Me.command=H&&ge.command?H.fromInternal(ge.command):void 0,Me}Ce.to=Fe})(Ie||(e.CompletionItem=Ie={}));var M;(function(Ce){function Fe(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:j.fromStrict(H.documentation)}}Ce.from=Fe;function ge(H){return{label:H.label,documentation:A.$Yj(H.documentation)?j.to(H.documentation):H.documentation}}Ce.to=ge})(M||(e.ParameterInformation=M={}));var K;(function(Ce){function Fe(H){return{label:H.label,documentation:j.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(M.from):[],activeParameter:H.activeParameter}}Ce.from=Fe;function ge(H){return{label:H.label,documentation:A.$Yj(H.documentation)?j.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(M.to):[],activeParameter:H.activeParameter}}Ce.to=ge})(K||(e.SignatureInformation=K={}));var G;(function(Ce){function Fe(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.from):[]}}Ce.from=Fe;function ge(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.to):[]}}Ce.to=ge})(G||(e.SignatureHelp=G={}));var Y;(function(Ce){function Fe(ge,H){const Me=new a.$qK(m.to(H.position),typeof H.label=="string"?H.label:H.label.map(J.to.bind(void 0,ge)),H.kind&&x.to(H.kind));return Me.textEdits=H.textEdits&&H.textEdits.map(ke.to),Me.tooltip=A.$Yj(H.tooltip)?j.to(H.tooltip):H.tooltip,Me.paddingLeft=H.paddingLeft,Me.paddingRight=H.paddingRight,Me}Ce.to=Fe})(Y||(e.InlayHint=Y={}));var J;(function(Ce){function Fe(ge,H){const Me=new a.$pK(H.label);return Me.tooltip=A.$Yj(H.tooltip)?j.to(H.tooltip):H.tooltip,h.Command.is(H.command)&&(Me.command=ge.fromInternal(H.command)),H.location&&(Me.location=q.to(H.location)),Me}Ce.to=Fe})(J||(e.InlayHintLabelPart=J={}));var x;(function(Ce){function Fe(H){return H}Ce.from=Fe;function ge(H){return H}Ce.to=ge})(x||(e.InlayHintKind=x={}));var ae;(function(Ce){function Fe(H){return{range:o.from(H.range),url:H.target,tooltip:H.tooltip}}Ce.from=Fe;function ge(H){let Me;if(H.url)try{Me=typeof H.url=="string"?p.URI.parse(H.url,!0):p.URI.revive(H.url)}catch{}return new a.$wK(o.to(H.range),Me)}Ce.to=ge})(ae||(e.DocumentLink=ae={}));var Le;(function(Ce){function Fe(H){const Me=new a.$zK(H.label);return H.textEdit&&(Me.textEdit=ke.to(H.textEdit)),H.additionalTextEdits&&(Me.additionalTextEdits=H.additionalTextEdits.map(Be=>ke.to(Be))),Me}Ce.to=Fe;function ge(H){return{label:H.label,textEdit:H.textEdit?ke.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Me=>ke.from(Me)):void 0}}Ce.from=ge})(Le||(e.ColorPresentation=Le={}));var Ue;(function(Ce){function Fe(H){return new a.$xK(H[0],H[1],H[2],H[3])}Ce.to=Fe;function ge(H){return[H.red,H.green,H.blue,H.alpha]}Ce.from=ge})(Ue||(e.Color=Ue={}));var Ye;(function(Ce){function Fe(H){return{range:o.from(H.range)}}Ce.from=Fe;function ge(H){return new a.$gK(o.to(H.range))}Ce.to=ge})(Ye||(e.SelectionRange=Ye={}));var He;(function(Ce){function Fe(ge){switch(ge){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Ce.to=Fe})(He||(e.TextDocumentSaveReason=He={}));var et;(function(Ce){function Fe(H){switch(H){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Fe;function ge(H){switch(H){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Ce.to=ge})(et||(e.TextEditorLineNumbersStyle=et={}));var Ze;(function(Ce){function Fe(H){if(H===a.EndOfLine.CRLF)return 1;if(H===a.EndOfLine.LF)return 0}Ce.from=Fe;function ge(H){if(H===1)return a.EndOfLine.CRLF;if(H===0)return a.EndOfLine.LF}Ce.to=ge})(Ze||(e.EndOfLine=Ze={}));var _e;(function(Ce){function Fe(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Fe})(_e||(e.ProgressLocation=_e={}));var it;(function(Ce){function Fe(H){const Me={start:H.start+1,end:H.end+1};return H.kind&&(Me.kind=tt.from(H.kind)),Me}Ce.from=Fe;function ge(H){const Me={start:H.start-1,end:H.end-1};return H.kind&&(Me.kind=tt.to(H.kind)),Me}Ce.to=ge})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Fe(H){if(H)switch(H){case a.FoldingRangeKind.Comment:return h.$0s.Comment;case a.FoldingRangeKind.Imports:return h.$0s.Imports;case a.FoldingRangeKind.Region:return h.$0s.Region}}Ce.from=Fe;function ge(H){if(H)switch(H.value){case h.$0s.Comment.value:return a.FoldingRangeKind.Comment;case h.$0s.Imports.value:return a.FoldingRangeKind.Imports;case h.$0s.Region.value:return a.FoldingRangeKind.Region}}Ce.to=ge})(tt||(e.FoldingRangeKind=tt={}));var Ne;(function(Ce){function Fe(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?o.from(ge.selection):void 0,override:typeof ge.override=="boolean"?c.$FE.id:void 0}}Ce.from=Fe})(Ne||(e.TextEditorOpenOptions=Ne={}));var st;(function(Ce){function Fe(Be){return Be instanceof a.$TK?Be.toJSON():typeof Be=="string"?Be:ge(Be)||H(Be)?new a.$TK(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ce.from=Fe;function ge(Be){const Ge=Be;return Ge?p.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function H(Be){const Ge=Be;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Me(Be){return typeof Be=="string"?Be:new a.$TK(p.URI.revive(Be.baseUri),Be.pattern)}Ce.to=Me})(st||(e.GlobPattern=st={}));var _;(function(Ce){function Fe(ge){if(ge){if(Array.isArray(ge))return ge.map(Fe);if(typeof ge=="string")return ge;{const H=ge;return{language:H.language,scheme:H.scheme,pattern:st.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ce.from=Fe})(_||(e.LanguageSelector=_={}));var Q;(function(Ce){function Fe(H){return!!H&&typeof H=="object"&&"selections"in H&&Array.isArray(H.selections)&&H.selections.every(Me=>Me instanceof a.$ZJ)&&"related"in H&&Array.isArray(H.related)&&H.related.every(Me=>Me&&typeof Me=="object"&&p.URI.isUri(Me.uri)&&Me.range instanceof a.$YJ)}Ce.is=Fe;function ge(H){return{selections:H.selections.map(Me=>s.from(Me)),related:H.related.map(Me=>({uri:p.URI.from(Me.uri),range:o.from(Me.range)}))}}Ce.from=ge})(Q||(e.MappedEditsContext=Q={}));var pe;(function(Ce){function Fe(H){return{start:H.start,end:H.end}}Ce.from=Fe;function ge(H){return new a.$iL(H.start,H.end)}Ce.to=ge})(pe||(e.NotebookRange=pe={}));var je;(function(Ce){function Fe(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ce.to=Fe;function ge(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ce.from=ge})(je||(e.NotebookCellExecutionSummary=je={}));var ze;(function(Ce){function Fe(ge){if(ge===g.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(ge===g.NotebookCellExecutionState.Pending)return;if(ge===g.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ce.to=Fe})(ze||(e.NotebookCellExecutionState=ze={}));var Qe;(function(Ce){function Fe(H){switch(H){case a.NotebookCellKind.Markup:return g.CellKind.Markup;case a.NotebookCellKind.Code:default:return g.CellKind.Code}}Ce.from=Fe;function ge(H){switch(H){case g.CellKind.Markup:return a.NotebookCellKind.Markup;case g.CellKind.Code:default:return a.NotebookCellKind.Code}}Ce.to=ge})(Qe||(e.NotebookCellKind=Qe={}));var nt;(function(Ce){function Fe(H){const Me={metadata:H.metadata??Object.create(null),cells:[]};for(const Be of H.cells)a.$jL.validate(Be),Me.cells.push(gt.from(Be));return Me}Ce.from=Fe;function ge(H){const Me=new a.$kL(H.cells.map(gt.to));return(0,u.$vf)(H.metadata)||(Me.metadata=H.metadata),Me}Ce.to=ge})(nt||(e.NotebookData=nt={}));var gt;(function(Ce){function Fe(H){return{cellKind:Qe.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:je.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Mt.from):[]}}Ce.from=Fe;function ge(H){return new a.$jL(Qe.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Mt.to):void 0,H.metadata,H.internalMetadata?je.to(H.internalMetadata):void 0)}Ce.to=ge})(gt||(e.NotebookCellData=gt={}));var vt;(function(Ce){function Fe(H){return{mime:H.mime,valueBytes:F.$Ed.wrap(H.data)}}Ce.from=Fe;function ge(H){return new a.$lL(H.valueBytes.buffer,H.mime)}Ce.to=ge})(vt||(e.NotebookCellOutputItem=vt={}));var Mt;(function(Ce){function Fe(H){return{outputId:H.id,items:H.items.map(vt.from),metadata:H.metadata}}Ce.from=Fe;function ge(H){const Me=H.items.map(vt.to);return new a.$mL(Me,H.outputId,H.metadata)}Ce.to=ge})(Mt||(e.NotebookCellOutput=Mt={}));var Qt;(function(Ce){function Fe(Me){return H(Me)?{include:st.from(Me.include)??void 0,exclude:st.from(Me.exclude)??void 0}:st.from(Me)??void 0}Ce.from=Fe;function ge(Me){return H(Me)?{include:st.to(Me.include),exclude:st.to(Me.exclude)}:st.to(Me)}Ce.to=ge;function H(Me){const Be=Me;return Be?!(0,u.$rf)(Be.include)&&!(0,u.$rf)(Be.exclude):!1}})(Qt||(e.NotebookExclusiveDocumentPattern=Qt={}));var Vt;(function(Ce){function Fe(ge,H,Me){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Be,Me),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ce.from=Fe})(Vt||(e.NotebookStatusBarItem=Vt={}));var wt;(function(Ce){function Fe(ge,H,Me){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:H.toInternal(Be,Me),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ce.from=Fe})(wt||(e.NotebookKernelSourceAction=wt={}));var Tt;(function(Ce){function Fe(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ce.from=Fe})(Tt||(e.NotebookDocumentContentOptions=Tt={}));var Ot;(function(Ce){function Fe(H){return{uri:H.uri,provides:H.provides}}Ce.from=Fe;function ge(H){return new a.$oL(p.URI.revive(H.uri),H.provides)}Ce.to=ge})(Ot||(e.NotebookRendererScript=Ot={}));var Jt;(function(Ce){function Fe(H){return{message:j.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:o.from(H.location.range),uri:H.location.uri}}}Ce.from=Fe;function ge(H){const Me=new a.$uL(typeof H.message=="string"?H.message:j.to(H.message));return Me.actualOutput=H.actual,Me.expectedOutput=H.expected,Me.contextValue=H.contextValue,Me.location=H.location?q.to(H.location):void 0,Me}Ce.to=ge})(Jt||(e.TestMessage=Jt={}));var Pt;(function(Ce){Ce.namespace=b.$LI,Ce.denamespace=b.$MI})(Pt||(e.TestTag=Pt={}));var At;(function(Ce){function Fe(H){const Me=(0,i.$SL)(H).controllerId;return{extId:k.$HI.fromExtHostTestItem(H,Me).toString(),label:H.label,uri:p.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(Be=>Pt.namespace(Me,Be.id)),range:$.$is.lift(o.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&j.fromStrict(H.error)||null}}Ce.from=Fe;function ge(H){return{parent:void 0,error:void 0,id:k.$HI.fromString(H.extId).localId,label:H.label,uri:p.URI.revive(H.uri),tags:(H.tags||[]).map(Me=>{const{tagId:Be}=Pt.denamespace(Me);return new a.$vL(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ce.toPlain=ge})(At||(e.TestItem=At={})),function(Ce){function Fe(H){return{id:H.id}}Ce.from=Fe;function ge(H){return new a.$vL(H.id)}Ce.to=ge}(Pt||(e.TestTag=Pt={}));var zt;(function(Ce){const Fe=(H,Me)=>{const Be=[];for(const[We,xe]of Me)k.$HI.compare(xe.item.extId,We)===2&&(Me.delete(We),Be.push(xe));const Ge={...At.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(xe=>xe.type===0).map(Jt.to)})),children:Be.map(We=>Fe(We,Me))};for(const We of Ge.children)We.parent=Ge;return Ge};function ge(H){const Me=[],Be=new Map;for(const Ge of H.items){Be.set(Ge.item.extId,Ge);const We=k.$HI.root(Ge.item.extId);H.request.targets.some(xe=>xe.controllerId===We&&xe.testIds.includes(Ge.item.extId))&&Me.push(Ge)}return{completedAt:H.completedAt,results:Me.map(Ge=>Fe(Ge,Be))}}Ce.to=ge})(zt||(e.TestResults=zt={}));var jt;(function(Ce){function Fe(Be){return{covered:Be.covered,total:Be.covered}}function ge(Be){return"line"in Be?m.from(Be):o.from(Be)}function H(Be){return"branches"in Be?{count:Be.executionCount,location:ge(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&ge(Ge.location)})):void 0}:{type:0,count:Be.executionCount,location:ge(Be.location)}}Ce.fromDetailed=H;function Me(Be){return{uri:Be.uri,statement:Fe(Be.statementCoverage),branch:Be.branchCoverage&&Fe(Be.branchCoverage),function:Be.functionCoverage&&Fe(Be.functionCoverage),details:Be.detailedCoverage?.map(H)}}Ce.fromFile=Me})(jt||(e.TestCoverage=jt={}));var qt;(function(Ce){function Fe(ge){switch(ge){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Ce.to=Fe})(qt||(e.CodeActionTriggerKind=qt={}));var Bt;(function(Ce){function Fe(H){const Me=new a.$BL(Z.to(H.kind),H.name,H.detail||"",p.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Fe;function ge(H,Me,Be){if(Me=Me??H._sessionId,Be=Be??H._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,kind:Z.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(ue.from)}}Ce.from=ge})(Bt||(e.TypeHierarchyItem=Bt={}));var at;(function(Ce){function Fe(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}Ce.from=Fe})(at||(e.ViewBadge=at={}));var ut;(function(Ce){function Fe(Be,Ge,We){const xe=Ge.fileData;return xe?new a.$MK(new a.$NK(xe.name,p.URI.revive(xe.uri),xe.id,(0,L.$bb)(()=>We(xe.id)))):Be===P.$Fr.uriList&&Ge.uriListData?new a.$LK(Me(Ge.uriListData)):new a.$LK(Ge.asString)}Ce.to=Fe;async function ge(Be,Ge){const We=await Ge.asString();if(Be===P.$Fr.uriList)return{asString:We,fileData:void 0,uriListData:H(We)};const xe=Ge.asFile();return{asString:We,fileData:xe?{name:xe.name,uri:xe.uri,id:xe._itemId??xe.id}:void 0}}Ce.from=ge;function H(Be){return C.$Rs.split(Be).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return p.URI.parse(Ge)}catch{}return Ge})}function Me(Be){return C.$Rs.create(Be.map(Ge=>typeof Ge=="string"?Ge:p.URI.revive(Ge)))}})(ut||(e.DataTransferItem=ut={}));var Ht;(function(Ce){function Fe(H,Me){const Be=H.items.map(([Ge,We])=>[Ge,ut.to(Ge,We,Me)]);return new a.$OK(Be)}Ce.toDataTransfer=Fe;async function ge(H){const Me={items:[]},Be=[];for(const[Ge,We]of H)Be.push((async()=>{Me.items.push([Ge,await ut.from(Ge,We)])})());return await Promise.all(Be),Me}Ce.from=ge})(Ht||(e.DataTransfer=Ht={}));var Ct;(function(Ce){function Fe(H){return{message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.to=Fe;function ge(H){return{kind:"reply",message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.from=ge})(Ct||(e.ChatReplyFollowup=Ct={}));var kt;(function(Ce){function Fe(ge){return typeof ge=="string"?{title:ge,message:ge,kind:"reply"}:"commandId"in ge?{kind:"command",title:ge.title??"",commandId:ge.commandId??"",when:ge.when??"",args:ge.args}:Ct.from(ge)}Ce.from=Fe})(kt||(e.ChatFollowup=kt={}));var ht;(function(Ce){function Fe(H){const Me=new a.$LL(St.to(H.role),H.content);return Me.name=H.name,Me}Ce.to=Fe;function ge(H){return{role:St.from(H.role),content:H.content,name:H.name}}Ce.from=ge})(ht||(e.ChatMessage=ht={}));var St;(function(Ce){function Fe(H){switch(H){case 0:return a.ChatMessageRole.System;case 1:return a.ChatMessageRole.User;case 2:return a.ChatMessageRole.Assistant;case 3:return a.ChatMessageRole.Function}}Ce.to=Fe;function ge(H){switch(H){case a.ChatMessageRole.System:return 0;case a.ChatMessageRole.Assistant:return 2;case a.ChatMessageRole.Function:return 3;case a.ChatMessageRole.User:default:return 1}}Ce.from=ge})(St||(e.ChatMessageRole=St={}));var Lt;(function(Ce){function Fe(H){return{level:Et.to(H.level),value:H.value,description:H.description}}Ce.to=Fe;function ge(H){return{level:Et.from(H.level),value:H.value,description:H.description}}Ce.from=ge})(Lt||(e.ChatVariable=Lt={}));var Et;(function(Ce){function Fe(H){switch(H){case"short":return a.ChatVariableLevel.Short;case"medium":return a.ChatVariableLevel.Medium;case"full":default:return a.ChatVariableLevel.Full}}Ce.to=Fe;function ge(H){switch(H){case a.ChatVariableLevel.Short:return"short";case a.ChatVariableLevel.Medium:return"medium";case a.ChatVariableLevel.Full:default:return"full"}}Ce.from=ge})(Et||(e.ChatVariableLevel=Et={}));var qe;(function(Ce){function Fe(ge){switch(ge){case 1:return a.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return a.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return a.InteractiveEditorResponseFeedbackKind.Undone;case 3:return a.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Fe})(qe||(e.InteractiveEditorResponseFeedbackKind=qe={}));var Nt;(function(Ce){function Fe(ge,H,Me){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand}:"uri"in ge?{uri:ge.uri}:H.toInternal(ge,Me)}Ce.from=Fe})(Nt||(e.TerminalQuickFix=Nt={}))}),define(Ae[204],Re([1,0,2,9,7,8,174]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=void 0;class l{constructor(f,P,D,u={timeout:1500,errors:3}){this.c=f,this.d=P,this.f=D,this.g=u,this.a=new A.$sc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(f){return(P,D,u)=>{const $={dispose:this.a.push([P,D,f])};return Array.isArray(u)&&u.push($),$}}async $participateInSave(f,P){const D=w.URI.revive(f);let u=!1;const p=setTimeout(()=>u=!0,this.g.timeout),$=[];try{for(const h of[...this.a]){if(u)break;const t=this.d.getDocument(D),i=await this.h(h,{document:t,reason:L.TextDocumentSaveReason.to(P)});$.push(i)}}finally{clearTimeout(p)}return $}h([f,P,D],u){const p=this.b.get(f);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(D,f,P,u).then(()=>!0,$=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error($),!($ instanceof Error)||$.message!=="concurrent_edits"){const h=this.b.get(f);this.b.set(f,h?h+1:1),typeof h=="number"&&h>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(f,P,D,u){const p=[],$=Date.now(),{document:h,reason:t}=u,{version:i}=h,c=Object.freeze({document:h,reason:t,waitUntil(g){if(Object.isFrozen(p))throw(0,F.$6)("waitUntil can not be called async");p.push(Promise.resolve(g))}});try{P.apply(D,[c])}catch(g){return Promise.reject(g)}return Object.freeze(p),new Promise((g,k)=>{const b=setTimeout(()=>k(new Error("timeout")),this.g.timeout);return Promise.all(p).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' finished after ${Date.now()-$}ms`),clearTimeout(b),g(n)}).catch(n=>{clearTimeout(b),k(n)})}).then(g=>{const k={edits:[]};for(const b of g)if(Array.isArray(b)&&b.every(n=>n instanceof C.$4J))for(const{newText:n,newEol:a,range:s}of b)k.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:s&&L.Range.from(s),text:n,eol:a&&L.EndOfLine.from(a)}});if(k.edits.length!==0)return i===h.version?this.f.$tryApplyWorkspaceEdit(k):Promise.reject(new Error("concurrent_edits"))})}}e.$8ac=l}),define(Ae[205],Re([1,0,12,2,8,7,75]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=void 0;class l{constructor(D,u,p,$){this.start=D,this.deletedCount=u,this.deletedItems=p,this.items=$}asApiEvent(){return{range:new L.$iL(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(D,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,u,p){this.notebook=D,this.h=u,this.j=p,this.handle=p.handle,this.uri=F.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return D.g},set mime($){D.g=$},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(p)}return this.f}setOutputs(D){this.a=D.map(C.NotebookCellOutput.to)}setOutputItems(D,u,p){const $=p.map(C.NotebookCellOutputItem.to),h=this.a.find(t=>t.id===D);if(h&&(u||(h.items.length=0),h.items.push(...$),h.items.length>1&&h.items.every(t=>A.$2H(t.mime)))){const t=new Map,i=[];h.items.forEach(c=>{let g;t.has(c.mime)?g=t.get(c.mime):(g=[],t.set(c.mime,g),i.push(c.mime)),g.push(c.data)}),h.items.length=0,i.forEach(c=>{const g=A.$3H(t.get(c));h.items.push({mime:c,data:g.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$icc=S;class f{static{this.a=0}constructor(D,u,p,$,h){this.k=D,this.l=u,this.m=p,this.uri=$,this.handle=f.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=h.viewType,this.f=Object.freeze(h.metadata??Object.create(null)),this.r([[0,0,h.cells]],!0,void 0),this.g=h.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,u={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===w.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(p){return p=D.n(p),D.b[p].apiCell},getCells(p){return(p?D.p(p):D.b).map(h=>h.apiCell)},save(){return D.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,u,p){this.g=D.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:p});const $={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},h=[];for(const i of D.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,$.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,$.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),h.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),h.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),h.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),h.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),h.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<h.length;i++){const c=h[i],g=t.get(c.cell);if(g===void 0){const k=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,k-1)}else $.cellChanges[g]={...$.cellChanges[g],...c}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let u=D.start|0,p=D.end|0;return u<0&&(u=0),p>this.b.length&&(p=this.b.length),D.with({start:u,end:p})}p(D){D=this.o(D);const u=[];for(let p=D.start;p<D.end;p++)u.push(this.b[p]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,u,p){if(this.j)return;const $=[],h=[],t=[];if(D.reverse().forEach(i=>{const g=i[2].map(n=>{const a=new S(this,this.l,n);return u||h.push(S.asModelAddData(this.apiNotebook,n)),a}),k=new l(i[0],i[1],[],g),b=this.b.splice(i[0],i[1],...g);for(const n of b)t.push(n.uri),k.deletedItems.push(n.apiCell);$.push(k)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:t}),p)for(const i of $)p.push(i.asApiEvent())}s(D,u,p,$){const h=this.b.splice(D,u);this.b.splice(p,0,...h);const t=[new l(D,u,h.map(i=>i.apiCell),[]),new l(p,0,[],h)];for(const i of t)$.push(i.asApiEvent())}t(D,u){this.b[D].setOutputs(u)}u(D,u,p,$){this.b[D].setOutputItems(u,p,$)}v(D,u){const p=this.b[D];p.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(p.uri,u)}w(D,u){const p=this.b[D];p.apiCell.mime=u}x(D,u){this.b[D].setMetadata(u)}y(D,u){this.b[D].setInternalMetadata(u)}getCellFromApiCell(D){return this.b.find(u=>u.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(u=>u.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$jcc=f}),define(Ae[206],Re([1,0,5,2,8,7]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=void 0;class A{constructor(S,f,P,D={timeout:1500,errors:3}){this.b=S,this.c=f,this.d=P,this.f=D,this.a=new w.$gd}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(f,P,D)=>{const u=function($){f.call(P,$)};return u.extension=S,this.a.event(u,void 0,D)}}async $participateInSave(S,f,P){const D=F.URI.revive(S),u=this.c.getNotebookDocument(D);if(!u)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:C.TextDocumentSaveReason.to(f)},P,async(h,t)=>{const i=Date.now(),c=await await Promise.resolve(h);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&c&&(c instanceof L.$7J?p.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(p.length===0)return!0;const $={edits:[]};for(const h of p){const{edits:t}=C.WorkspaceEdit.from(h);$.edits=$.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit($)}}e.$Jcc=A}),define(Ae[104],Re([1,0,9,8,7]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(l,S,f,P,D,u){this.id=l,this.f=S,this.notebookData=f,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=P,this.c=u}get apiEditor(){if(!this.e){const l=this;this.e={get notebook(){return l.notebookData.apiNotebook},get selection(){return l.a[0]},set selection(S){this.selections=[S]},get selections(){return l.a},set selections(S){if(!Array.isArray(S)||!S.every(C.$iL.isNotebookRange))throw(0,w.$5)("selections");l.a=S,l.g(S)},get visibleRanges(){return l.b},revealRange(S,f){l.f.$tryRevealRange(l.id,F.NotebookRange.from(S),f??C.NotebookEditorRevealType.Default)},get viewColumn(){return l.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(l){this.d=l}_acceptVisibleRanges(l){this.b=l}_acceptSelections(l){this.a=l}g(l){this.f.$trySetSelections(this.id,l.map(F.NotebookRange.from))}_acceptViewColumn(l){this.c=l}}e.$kcc=L}),define(Ae[207],Re([1,0,9,5,14,8]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;let A=class{constructor(S,f){this.c=S,this.d=f,this.a=new F.$ed({onListenerError:w.$Z}),this.b=new F.$ed({onListenerError:w.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(S,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",S,f);const P=this.d.getEditorById(S);f.visibleRanges&&P._acceptVisibleRanges(f.visibleRanges.ranges.map(L.NotebookRange.to)),f.selections&&P._acceptSelections(f.selections.selections.map(L.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(S){for(const f in S)this.d.getEditorById(f)._acceptViewColumn(L.ViewColumn.to(S[f]))}};e.$Ccc=A,e.$Ccc=A=Ke([Ve(0,C.$4i)],A)}),define(Ae[208],Re([1,0,8,72,153,21,64,9]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=void 0;class S{constructor(u){this.b=0,this.c=new Map,this.a=u}async withProgress(u,p,$){const h=this.b++,{title:t,location:i,cancellable:c}=p,g={label:(0,C.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this.a.$startProgress(h,{location:w.ProgressLocation.from(i),title:t,source:g,cancellable:c},u.isUnderDevelopment?void 0:u.identifier.value).catch(l.$Z),this.d(h,$,!!c)}d(u,p,$){let h;$&&(h=new L.$od,this.c.set(u,h));const t=c=>{this.a.$progressEnd(c),this.c.delete(c),h?.dispose()};let i;try{i=p(new P(this.a,u),$&&h?h.token:L.CancellationToken.None)}catch(c){throw t(u),c}return i.then(c=>t(u),c=>t(u)),i}$acceptProgressCanceled(u){const p=this.c.get(u);p&&(p.cancel(),this.c.delete(u))}}e.$Gbc=S;function f(D,u){return D.message=u.message,typeof u.increment=="number"&&(typeof D.increment=="number"?D.increment+=u.increment:D.increment=u.increment),D}class P extends F.$2u{constructor(u,p){super($=>this.throttledReport($)),this.f=u,this.g=p}throttledReport(u){this.f.$progressReport(this.g,u)}}Ke([(0,A.$7g)(100,(D,u)=>f(D,u),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Ae[105],Re([1,0,44,102,45,76,56,8,2]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=e.$0L=e.$9L=void 0;const f=(g,k,b,n)=>{let a=k;return{enumerable:!0,configurable:!1,get(){return a},set(s){if(!b(a,s)){const o=a;a=s,g.listener?.(n(s,o))}}}},P=(g,k)=>g===k,D={range:(g,k)=>g===k?!0:!g||!k?!1:g.isEqual(k),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(g,k)=>!(g.length!==k.length||g.some(b=>!k.find(n=>b.id===n.id)))},u=g=>k=>({op:4,update:g(k)}),p=(g,k)=>({range:(()=>{let b;const n=u(a=>({range:w.$is.lift(l.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return b},set(a){g.listener?.({op:6}),D.range(b,a)||(b=a,g.listener?.(n(a)))}}})(),label:f(g,k,D.label,u(b=>({label:b}))),description:f(g,void 0,D.description,u(b=>({description:b}))),sortText:f(g,void 0,D.sortText,u(b=>({sortText:b}))),canResolveChildren:f(g,!1,D.canResolveChildren,b=>({op:2,state:b})),busy:f(g,!1,D.busy,u(b=>({busy:b}))),error:f(g,void 0,D.error,u(b=>({error:l.MarkdownString.fromStrict(b)||null}))),tags:f(g,[],D.tags,(b,n)=>({op:1,new:b.map(l.TestTag.from),old:n.map(l.TestTag.from)}))}),$=g=>{const k=C.$HI.fromString(g.extId),b=new t(k.controllerId,k.localId,g.label,S.URI.revive(g.uri)||void 0);return b.range=l.Range.to(g.range||void 0),b.description=g.description||void 0,b.sortText=g.sortText||void 0,b.tags=g.tags.map(n=>l.TestTag.to({id:(0,A.$MI)(n).tagId})),b},h=g=>{let k;for(const b of g.tests){const n=$(b.item);(0,F.$SL)(n).parent=k,k=n}return k};e.$9L=h;class t{constructor(k,b,n,a){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const s=(0,F.$RL)(this,k);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof i?void 0:s.parent}},children:{value:(0,L.$QL)(s,F.$SL,t),enumerable:!0,writable:!1},...p(s,n)})}}e.$0L=t;class i extends t{constructor(k,b){super(k,k,b,void 0),this._isRoot=!0}}e.$$L=i;class c extends L.$ML{constructor(k,b,n){super({controllerId:k,getDocumentVersion:a=>a&&n.getDocument(a)?.version,getApiFor:F.$SL,getChildren:a=>a.children,root:new i(k,b),toITestItem:l.TestItem.from})}}e.$_L=c}),define(Ae[106],Re([1,0,50,9,88,8,7]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=e.$4L=void 0;class l{static{this.c=new C.$2L("TextEditorDecorationType")}constructor(u,p,$){const h=l.c.nextId();u.$registerTextEditorDecorationType(p.identifier,h,L.DecorationRenderOptions.from($)),this.value=Object.freeze({key:h,dispose(){u.$removeTextEditorDecorationType(h)}})}}e.$4L=l;class S{constructor(u,p){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,p){this.k();let $=null;if(u instanceof A.$XJ)$=new A.$YJ(u,u);else if(u instanceof A.$YJ)$=u;else throw new Error("Unrecognized location");this.l($,p,!1)}insert(u,p){this.k(),this.l(new A.$YJ(u,u),p,!0)}delete(u){this.k();let p=null;if(u instanceof A.$YJ)p=u;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(u,p,$){const h=this.c.validateRange(u);this.g.push({range:h,text:p,forceMoveMarkers:$})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,F.$5)("endOfLine");this.h=u}}class f{constructor(u,p,$,h){this.c=u,this.d=p,this._accept($),this.e=h;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.insertSpaces,this.j=u.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(u.lineNumbers)}l(u){if(u==="auto")return"auto";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}m(u){const p=this.l(u);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}o(u){const p=this.n(u);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(u){return u==="auto"?"auto":u==="false"?!1:!!u}q(u){const p=this.p(u);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(u){this.j!==u&&(this.j=u,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}t(u){this.k!==u&&(this.k=u,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(u)})))}assign(u){const p={};let $=!1;if(typeof u.tabSize<"u"){const h=this.l(u.tabSize);h==="auto"?($=!0,p.tabSize=h):typeof h=="number"&&this.f!==h&&(this.f=h,$=!0,p.tabSize=h)}if(typeof u.indentSize<"u"){const h=this.n(u.indentSize);h==="tabSize"?($=!0,p.indentSize=h):typeof h=="number"&&this.g!==h&&(this.g=h,$=!0,p.indentSize=h)}if(typeof u.insertSpaces<"u"){const h=this.p(u.insertSpaces);h==="auto"?($=!0,p.insertSpaces=h):this.h!==h&&(this.h=h,$=!0,p.insertSpaces=h)}typeof u.cursorStyle<"u"&&this.j!==u.cursorStyle&&(this.j=u.cursorStyle,$=!0,p.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.k!==u.lineNumbers&&(this.k=u.lineNumbers,$=!0,p.lineNumbers=L.TextEditorLineNumbersStyle.from(u.lineNumbers)),$&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(u,p){p.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn($)})}}e.$5L=f;class P{constructor(u,p,$,h,t,i,c,g){this.id=u,this.j=p,this.k=$,this.g=!1,this.h=new Set,this.c=t,this.d=new f(this.j,this.id,i,$),this.e=c,this.f=g;const k=this;this.value=Object.freeze({get document(){return h.value},set document(b){throw new F.$7("document")},get selection(){return k.c&&k.c[0]},set selection(b){if(!(b instanceof A.$ZJ))throw(0,F.$5)("selection");k.c=[b],k.l()},get selections(){return k.c},set selections(b){if(!Array.isArray(b)||b.some(n=>!(n instanceof A.$ZJ)))throw(0,F.$5)("selections");k.c=b,k.l()},get visibleRanges(){return k.e},set visibleRanges(b){throw new F.$7("visibleRanges")},get options(){return k.d.value},set options(b){k.g||k.d.assign(b)},get viewColumn(){return k.f},set viewColumn(b){throw new F.$7("viewColumn")},edit(b,n={undoStopBefore:!0,undoStopAfter:!0}){if(k.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new S(h.value,n);return b(a),k.m(a)},insertSnippet(b,n,a={undoStopBefore:!0,undoStopAfter:!0}){if(k.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!n||Array.isArray(n)&&n.length===0)s=k.c.map(o=>L.Range.from(o));else if(n instanceof A.$XJ){const{lineNumber:o,column:y}=L.Position.from(n);s=[{startLineNumber:o,startColumn:y,endLineNumber:o,endColumn:y}]}else if(n instanceof A.$YJ)s=[L.Range.from(n)];else{s=[];for(const o of n)if(o instanceof A.$YJ)s.push(L.Range.from(o));else{const{lineNumber:y,column:m}=L.Position.from(o);s.push({startLineNumber:y,startColumn:m,endLineNumber:y,endColumn:m})}}return p.$tryInsertSnippet(u,h.value.version,b.value,s,a)},setDecorations(b,n){const a=n.length===0;a&&!k.h.has(b.key)||(a?k.h.delete(b.key):k.h.add(b.key),k.n(()=>{if(L.$TL(n))return p.$trySetDecorations(u,b.key,L.$UL(n));{const s=new Array(4*n.length);for(let o=0,y=n.length;o<y;o++){const m=n[o];s[4*o]=m.start.line+1,s[4*o+1]=m.start.character+1,s[4*o+2]=m.end.line+1,s[4*o+3]=m.end.character+1}return p.$trySetDecorationsFast(u,b.key,s)}}))},revealRange(b,n){k.n(()=>p.$tryRevealRange(u,L.Range.from(b),n||A.TextEditorRevealType.Default))},show(b){p.$tryShowEditor(u,L.ViewColumn.from(b))},hide(){p.$tryHideEditor(u)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,w.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,w.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,w.ok)(!this.g),this.f=u}_acceptSelections(u){(0,w.ok)(!this.g),this.c=u}async l(){const u=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const p=u.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const $=p.edits.map(t=>t.range);$.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=$.length-1;t<i;t++){const c=$[t].end;if($[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=p.edits.map(t=>({range:L.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,h,{setEndOfLine:typeof p.setEndOfLine=="number"?L.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$6L=P}),define(Ae[209],Re([1,0,4,172]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=void 0,e.$_I=(0,w.$Bh)(F.$Hh)}),define(Ae[107],Re([1,0,20,5,19,6]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j3b=e.$i3b=e.$h3b=e.$g3b=e.$f3b=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.$f3b=A;class l{static isHostExtension(t,i,c){if(i.getExtensionDescription(t))return!1;const g=c.getExtensionDescription(t);return g?!!((g.main||g.browser)&&g.api==="none"):!1}constructor(t,i){this.h=t,this.c=new F.$ed,this.onDidChange=this.c.event,this.d=i,this.j()}j(){this.d.sort(p),this.e=new w.$Wl,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const i=this.h.readActivationEvents(t);if(Array.isArray(i))for(let c of i)c==="onUri"&&(c=`onUri:${w.$Ul.toKey(t.identifier)}`),this.g.has(c)||this.g.set(c,[]),this.g.get(c).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,i){this.d=$(this.d,i),this.d=this.d.concat(t);const c=l.k(this.d);return this.d=$(this.d,c.map(g=>g.identifier)),this.j(),this.c.fire(void 0),new A(c)}static k(t){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,a){this.addNode(n),this.addNode(a),this.c.has(n)?this.c.get(n).push(a):this.c.set(n,[a])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,a){const s=i.getArcs(n);for(let o=0;o<s.length;o++)if(!a.has(s[o]))return!1;return!0}getNodes(){return this.e}},c=new w.$Wl;for(const n of t)if(c.set(n.identifier,n),n.extensionDependencies)for(const a of n.extensionDependencies)i.addArc(w.$Ul.toKey(n.identifier),w.$Ul.toKey(a));const g=new Set;i.getNodes().filter(n=>i.getArcs(n).length===0).forEach(n=>g.add(n));const k=i.getNodes().filter(n=>!g.has(n));let b;do{b=!1;for(let n=0;n<k.length;n++){const a=k[n];i.hasOnlyGoodArcs(a,g)&&(k.splice(n,1),n--,g.add(a),b=!0)}}while(b);return k.map(n=>c.get(n))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const i=this.g.get(t);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const i=this.e.get(t);return i||void 0}getExtensionDescriptionByUUID(t){for(const i of this.f)if(i.uuid===t)return i}getExtensionDescriptionByIdOrUUID(t,i){return this.getExtensionDescription(t)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$g3b=l,e.$h3b={readActivationEvents:h=>h.activationEvents};class S{constructor(t){this.d=new D,this.c=new l(t,[])}async acquireLock(t){const i=await this.d.acquire(t);return new f(this,i)}deltaExtensions(t,i,c){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,c)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,i){return this.c.getExtensionDescriptionByIdOrUUID(t,i)}}e.$i3b=S;class f extends L.$jc{constructor(t,i){super(),this.f=t,this.c=!1,this.B(i)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$j3b=f;class P{constructor(t){this.name=t,this.promise=new Promise((i,c)=>{this.c=i})}resolve(t){this.c(t)}}class D{constructor(){this.c=[],this.d=!1}async acquire(t){const i=new P(t);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let i=!0;const c=setTimeout(()=>{i&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),g=()=>{i&&(clearTimeout(c),i=!1,this.d=!1,this.e())};t.resolve((0,L.$hc)(g))}}var u;(function(h){h[h.Builtin=0]="Builtin",h[h.User=1]="User",h[h.Dev=2]="Dev"})(u||(u={}));function p(h,t){const i=h.isBuiltin?0:h.isUnderDevelopment?2:1,c=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(i!==c)return i-c;const g=C.$5d.basename(h.extensionLocation.path),k=C.$5d.basename(t.extensionLocation.path);return g<k?-1:g>k?1:0}function $(h,t){const i=new w.$Vl(t);return h.filter(c=>!i.has(c.identifier))}}),define(Ae[79],Re([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$4l=e.$3l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(F||(e.UIKind=F={}));var C;(function(f){f[f.VersionMismatch=55]="VersionMismatch",f[f.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var L;(function(f){f[f.Initialized=0]="Initialized",f[f.Ready=1]="Ready",f[f.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(f){const P=w.$Ed.alloc(1);switch(f){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$3l=A;function l(f,P){if(f.byteLength!==1)return!1;switch(f.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$4l=l;var S;(function(f){f.Start="START_NATIVE_LOG",f.End="END_NATIVE_LOG"})(S||(e.NativeLogMarkers=S={}))}),define(Ae[57],Re([1,0,4,5,14,27,79,51,52,24,2,6,155]),function(be,e,w,F,C,L,A,l,S,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=e.$cM=e.$bM=void 0;let p=class extends D.$jc{constructor(i,c){super(),this.s=i,this.t=c,this.a=this.B(new F.$ed),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$ed),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=P.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=c.createLogger(this.m,{id:S.$do,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(g=>{(0,C.$6i)(g)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,c,g){const k=this.getTelemetryDetails(),b=new $(c,g,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:k.isUsageEnabled,isErrorsEnabled:k.isErrorsEnabled}),n=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...n,b]),b.apiTelemetryLogger}$initializeTelemetryLevel(i,c,g){this.f=i,this.g=c,this.c=g??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const c=Object.create(null);switch(c["common.extname"]=`${i.publisher}.${i.name}`,c["common.extversion"]=i.version,c["common.vscodemachineid"]=this.s.telemetryInfo.machineId,c["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,c["common.vscodeversion"]=this.s.version,c["common.isnewappinstall"]=h(this.s.telemetryInfo.firstSessionDate),c["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:c["common.uikind"]="web";break;case A.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,l.$Ok)((0,S.$ko)(this.s.remote.authority)),c}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const c=this.getTelemetryDetails();this.r.forEach((g,k)=>{const b=g.filter(n=>!n.isDisposed);b.length===0?this.r.delete(k):this.r.set(k,b)}),this.r.forEach(g=>{for(const k of g)k.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,c){const k=this.r.get(i.value)?.filter(n=>!n.isDisposed);if(!k)return this.r.delete(i.value),!1;let b=!1;for(const n of k)n.ignoreUnhandledExtHostErrors||(n.logError(c),b=!0);return b}};e.$bM=p,e.$bM=p=Ke([Ve(0,L.$aM),Ve(1,C.$5i)],p);class ${static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,c,g,k,b,n,a){this.g=g,this.h=k,this.i=b,this.j=n,this.a=new F.$ed,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(i,c){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let c="properties"in i?i.properties??{}:i;return c=(0,S.$no)(c,[]),this.c&&(c=(0,f.$Xm)(c,this.c)),this.b||(c=(0,f.$Xm)(c,this.j)),"properties"in i?i.properties=c:i=c,i}k(i,c){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(i,c),this.h.trace(i,c))}logUsage(i,c){this.d.isUsageEnabled&&this.k(i,c)}logError(i,c){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,c);else{const g={name:i.name,message:i.message,stack:i.stack,cause:i.cause},k=(0,S.$no)(g,[]),b=new Error(k.message,{cause:k.cause});b.stack=k.stack,b.name=k.name,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f.sendErrorData(b,c),this.h.trace("exception",c)}}get apiTelemetryLogger(){if(!this.e){const i=this,c={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$cM=$;function h(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$dM=h,e.$eM=(0,w.$Ah)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,181,98,20,4]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TF=e.$SF=e.$RF=e.ActivationKind=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.ExtensionHostStartup=e.$LF=e.$KF=e.$JF=e.$IF=void 0,e.$IF=Object.freeze({identifier:new A.$Ul("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$JF="extensions.webWorker",e.$KF=(0,l.$Ah)("extensionService");class S{constructor(b){this.dependency=b}}e.$LF=S;var f;(function(k){k[k.EagerAutoStart=1]="EagerAutoStart",k[k.EagerManualStart=2]="EagerManualStart",k[k.Lazy=3]="Lazy"})(f||(e.ExtensionHostStartup=f={}));class P{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:L.$zF.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(b,n){const a=[],s=[],o=[],y=[],m=D(this.c),I=D(b),E=(B,V)=>B.extensionLocation.toString()===V.extensionLocation.toString()||B.isBuiltin===V.isBuiltin||B.isUserBuiltin===V.isUserBuiltin||B.isUnderDevelopment===V.isUnderDevelopment;for(const B of this.c){const V=I.get(B.identifier);if(!V){a.push(B.identifier),m.delete(B.identifier);continue}if(!E(B,V)){a.push(B.identifier),m.delete(B.identifier);continue}}for(const B of b){const V=m.get(B.identifier);if(!V){s.push(B);continue}if(!E(V,B)){a.push(V.identifier),m.delete(V.identifier);continue}}const r=new A.$Vl(this.d),d=new A.$Vl(n);for(const B of this.d)d.has(B)||o.push(B);for(const B of n)r.has(B)||y.push(B);const v=L.$zF.createActivationEventsMap(s),R={toRemove:a,toAdd:s,addActivationEvents:v,myToRemove:o,myToAdd:y};return this.delta(R),R}delta(b){const{toRemove:n,toAdd:a,myToRemove:s,myToAdd:o}=b,y=new A.$Vl(n),m=new A.$Vl(s);for(let I=0;I<this.c.length;I++)y.has(this.c[I].identifier)&&(this.c.splice(I,1),I--);for(let I=0;I<this.d.length;I++)m.has(this.d[I])&&(this.d.splice(I,1),I--);for(const I of a)this.c.push(I);for(const I of o)this.d.push(I)}containsExtension(b){for(const n of this.d)if(A.$Ul.equals(n,b))return!0;return!1}}e.$MF=P;function D(k){const b=new A.$Wl;for(const n of k)b.set(n.identifier,n);return b}function u(k,b){return k.enabledApiProposals?k.enabledApiProposals.includes(b):!1}e.$NF=u;function p(k,b){if(!u(k,b))throw new Error(`Extension '${k.identifier.value}' CANNOT use API proposal: ${b}.
Its package.json#enabledApiProposals-property declares: ${k.enabledApiProposals?.join(", ")??"[]"} but NOT ${b}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${k.identifier.value}`)}e.$OF=p;class ${constructor(b,n,a,s){this.codeLoadingTime=b,this.activateCallTime=n,this.activateResolvedTime=a,this.activationReason=s}}e.$PF=$;class h{constructor(b,n){this.description=b,this.value=n}}e.$QF=h;var t;(function(k){k[k.Normal=0]="Normal",k[k.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(k){return{type:k.isBuiltin?0:1,isBuiltin:k.isBuiltin||k.isUserBuiltin,identifier:{id:(0,C.$to)(k.publisher,k.name),uuid:k.uuid},manifest:k,location:k.extensionLocation,targetPlatform:k.targetPlatform,validations:[],isValid:!0}}e.$RF=i;function c(k,b){return{identifier:new A.$Ul((0,C.$ro)(k.manifest.publisher,k.manifest.name)),isBuiltin:k.type===0,isUserBuiltin:k.type===1&&k.isBuiltin,isUnderDevelopment:!!b,extensionLocation:k.location,...k.manifest,uuid:k.identifier.uuid,targetPlatform:k.targetPlatform}}e.$SF=c;class g{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(b){return Promise.resolve(void 0)}activationEventIsDone(b){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(b,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$TF=g}),define(Ae[210],Re([1,0,9,107,20,26,14,13]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bbc=e.$abc=e.$_ac=e.$$ac=e.$0ac=e.$9ac=void 0;class S{static{this.NONE=new S(!1,-1,-1,-1)}constructor(i,c,g,k){this.startup=i,this.codeLoadingTime=c,this.activateCallTime=g,this.activateResolvedTime=k}}e.$9ac=S;class f{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,c){return i===-1||c===-1?-1:c-i}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$0ac=f;class P{constructor(i,c,g,k,b,n){this.activationFailed=i,this.activationFailedError=c,this.activationTimes=g,this.module=k,this.exports=b,this.subscriptions=n}}e.$$ac=P;class D extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$_ac=D;class u extends P{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$abc=u;class p extends P{constructor(i){super(!0,i,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let $=class{constructor(i,c,g,k){this.g=k,this.a=i,this.b=c,this.c=g,this.d=new C.$Wl,this.f=Object.create(null)}dispose(){for(const[i,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const i=[];for(const[c,g]of this.d)i.push(g.wait());await Promise.all(i)}isActivated(i){const c=this.d.get(i);return!!(c&&c.value)}getActivatedExtension(i){const c=this.d.get(i);if(!c||!c.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return c.value}async activateByEvent(i,c){if(this.f[i])return;const g=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(g.map(k=>({id:k.identifier,reason:{startup:c,extensionId:k.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,c){const g=this.a.getExtensionDescription(i);if(!g)throw new Error(`Extension '${i}' is not known`);return this.h([{id:g.identifier,reason:c}])}async h(i){const c=i.filter(g=>!this.isActivated(g.id)).map(g=>this.j(g));await Promise.all(c.map(g=>g.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const c=this.a.getExtensionDescription(i.id);if(!c){const b=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new p(b));return this.c.onExtensionActivationError(i.id,b,new L.$LF(i.id.value)),n}const g=[],k=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const b of k){if(this.m(b))continue;const n=this.d.get(b);if(n){g.push(n);continue}if(this.l(b)){g.push(this.j({id:this.b.getExtensionDescription(b).identifier,reason:i.reason}));continue}const a=this.a.getExtensionDescription(b);if(a){if(!a.main&&!a.browser)continue;g.push(this.j({id:a.identifier,reason:i.reason}));continue}const s=c.displayName||c.identifier.value,o=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${b}'`),y=this.k(i,c.displayName,[],new p(o));return this.c.onExtensionActivationError(c.identifier,o,new L.$LF(b)),y}return this.k(i,c.displayName,g,null)}k(i,c,g,k){const b=new h(i.id,c,i.reason,g,k,this.c,this.g);return this.d.set(i.id,b),b}l(i){return F.$g3b.isHostExtension(i,this.a,this.b)}m(i){const c=this.b.getExtensionDescription(i);return c?!c.main&&!c.browser:!1}};e.$bbc=$,e.$bbc=$=Ke([Ve(3,A.$4i)],$);let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,c,g,k,b,n,a){this.c=i,this.d=c,this.f=g,this.g=k,this.h=b,this.j=n,this.k=a,this.a=new l.$Eg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const c=this.g[i];if(c.value&&!c.value.activationFailed){this.g.splice(i,1),i--;continue}if(c.value&&c.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);g.detail=c.value.activationFailedError,this.h=new p(g),this.j.onExtensionActivationError(this.c,g,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const c=new Error;if(i&&i.name&&(c.name=i.name),i&&i.message?c.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(c.stack=i.stack),this.h=new p(c),this.b&&w.$2(i))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};h=Ke([Ve(6,A.$4i)],h)}),define(Ae[211],Re([1,0,157,23,2,5,6,193,13,7,16,18,8,49,21,126,26]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbc=void 0;function i(k,b){if((0,P.$if)(k))return{label:k};if(k&&typeof k=="object"&&typeof k.label=="string"){let n;return Array.isArray(k.highlights)&&(n=k.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),n=n.length?n:void 0),{label:k.label,highlights:n}}}class c extends A.$jc{constructor(b,n,a){super(),this.f=b,this.g=n,this.h=a,this.a=new Map,this.b=new h.$a7;function s(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:o=>s(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(y=>s(y)?this.r(y):y):o})}registerTreeDataProvider(b,n,a){const s=this.createTreeView(b,{treeDataProvider:n},a);return{dispose:()=>s.dispose()}}createTreeView(b,n,a){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=n.dragAndDropController?.dropMimeTypes??[],o=n.dragAndDropController?.dragMimeTypes??[],y=!!n.dragAndDropController?.handleDrag,m=!!n.dragAndDropController?.handleDrop,I=this.m(b,n,a),E={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:s,dragMimeTypes:o,hasHandleDrag:y,hasHandleDrop:m,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},r=this.f.$registerTreeViewDataProvider(b,E),d={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$OF)(a,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$OF)(a,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(v){(0,p.$Yj)(v)&&(0,t.$OF)(a,"treeViewMarkdownMessage"),I.message=v},get title(){return I.title},set title(v){I.title=v},get description(){return I.description},set description(v){I.description=v},get badge(){return I.badge},set badge(v){v!==void 0&&f.ViewBadge.isViewBadge(v)?I.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(I.badge=void 0)},reveal:(v,R)=>I.reveal(v,R),dispose:async()=>{await r,this.a.delete(b),I.dispose()}};return this.B(d),d}$getChildren(b,n){const a=this.a.get(b);return a?a.getChildren(n):Promise.reject(new l.$_E(b))}async $handleDrop(b,n,a,s,o,y,m,I){const E=this.a.get(b);if(!E)return Promise.reject(new l.$_E(b));const r=u.DataTransfer.toDataTransfer(a,async d=>(await this.f.$resolveDropFileData(b,n,d)).buffer);return m===b&&I&&await this.j(r,E,I,o,y),E.onDrop(r,s,o)}async j(b,n,a,s,o){const y=this.b.removeDragOperationTransfer(o);if(y)(await y)?.forEach((m,I)=>{m&&b.set(I,m)});else if(o&&n.handleDrag){const m=n.handleDrag(a,b,s);this.b.addDragOperationTransfer(o,m),await m}return b}async $handleDrag(b,n,a,s){const o=this.a.get(b);if(!o)return Promise.reject(new l.$_E(b));const y=await this.j(new f.$OK,o,n,s,a);if(!(!y||s.isCancellationRequested))return u.DataTransfer.from(y)}async $hasResolve(b){const n=this.a.get(b);if(!n)throw new l.$_E(b);return n.hasResolve}$resolve(b,n,a){const s=this.a.get(b);if(!s)throw new l.$_E(b);return s.resolveTreeItem(n,a)}$setExpanded(b,n,a){const s=this.a.get(b);if(!s)throw new l.$_E(b);s.setExpanded(n,a)}$setSelectionAndFocus(b,n,a){const s=this.a.get(b);if(!s)throw new l.$_E(b);s.setSelectionAndFocus(n,a)}$setVisible(b,n){const a=this.a.get(b);if(!a){if(!n)return;throw new l.$_E(b)}a.setVisible(n)}$changeCheckboxState(b,n){const a=this.a.get(b);if(!a)throw new l.$_E(b);a.setCheckboxState(n)}m(b,n,a){const s=this.B(new g(b,n,this.f,this.g.converter,this.h,a));return this.a.set(b,s),s}r(b){const n=this.a.get(b.$treeViewId);return n&&"$treeItemHandle"in b?n.getExtensionElement(b.$treeItemHandle):n&&"$focusedTreeItem"in b&&b.$focusedTreeItem?n.focusedElement:null}}e.$Nbc=c;class g extends A.$jc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(b=>this.getExtensionElement(b)).filter(b=>!(0,P.$rf)(b))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(b,n,a,s,o,y){if(super(),this.I=b,this.J=a,this.L=s,this.M=o,this.N=y,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$ed),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$ed),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$ed),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$ed),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$ed),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$ed),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$ed),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new $.$od,y.contributes&&y.contributes.views)for(const r in y.contributes.views)for(const d of y.contributes.views[r])d.id===b&&(this.P=d.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(r=>this.F.fire({message:!1,element:r})));let m,I;const E=L.Event.debounce(this.F.event,(r,d)=>(r||(r={message:!1,elements:[]}),d.element!==!1&&(m||(m=new Promise(v=>I=v),this.G=this.G.then(()=>m)),Array.isArray(d.element)?r.elements.push(...d.element):r.elements.push(d.element)),d.message&&(r.message=!0),r),200,!0);this.B(E(({message:r,elements:d})=>{d.length&&(this.H=this.H.then(()=>{const v=I;return m=null,this.$(d).then(()=>v())})),r&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(b){const n=b?this.getExtensionElement(b):void 0;if(b&&!n)return this.M.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let a=this.X(b);return a||(a=await this.Y(n)),a?a.map(s=>s.item):void 0}getExtensionElement(b){return this.j.get(b)}reveal(b,n){n=n||{select:!0,focus:!1};const a=(0,P.$rf)(n.select)?!0:n.select,s=(0,P.$rf)(n.focus)?!1:n.focus,o=(0,P.$rf)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.G.then(()=>this.S(b)).then(y=>this.W(b,y[y.length-1]).then(m=>this.J.$reveal(this.I,{item:m.item,parentChain:y.map(I=>I.item)},{select:a,focus:s,expand:o})),y=>this.M.error(y)):this.J.$reveal(this.I,void 0,{select:a,focus:s,expand:o})}get message(){return this.O}set message(b){this.O=b,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(b){this.P=b,this.J.$setTitle(this.I,b,this.Q)}get description(){return this.Q}set description(b){this.Q=b,this.J.$setTitle(this.I,this.P,b)}get badge(){return this.R}set badge(b){this.R?.value===b?.value&&this.R?.tooltip===b?.tooltip||(this.R=u.ViewBadge.from(b),this.J.$setBadge(this.I,b))}setExpanded(b,n){const a=this.getExtensionElement(b);a&&(n?this.u.fire(Object.freeze({element:a})):this.w.fire(Object.freeze({element:a})))}setSelectionAndFocus(b,n){const a=!(0,D.$sb)(this.s,b);this.s=b;const s=this.t!==n;this.t=n,a&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(b){b!==this.r&&(this.r=b,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(b){const n=(await Promise.all(b.map(async a=>{const s=this.getExtensionElement(a.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:a.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(a=>a!==void 0);n.forEach(a=>{a.treeItem.checkboxState=a.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(a=>[a.extensionItem,a.newState])})}async handleDrag(b,n,a){const s=[];for(const o of b){const y=this.getExtensionElement(o);y&&s.push(y)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,n,a),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(b,n,a){const s=n?this.getExtensionElement(n):void 0;if(!(!s&&n||!this.g?.handleDrop))return(0,S.$yg)(()=>this.g?.handleDrop?this.g.handleDrop(s,b,a):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(b,n){if(!this.f.resolveTreeItem)return;const a=this.j.get(b);if(a){const s=this.m.get(a);if(s){const o=await this.f.resolveTreeItem(s.extensionItem,a,n)??s.extensionItem;return this.hb(o),s.item.tooltip=this.eb(o.tooltip),s.item.command=this.fb(s.disposableStore,o.command),s.item}}}S(b){return this.U(b).then(n=>n?this.S(n).then(a=>this.W(n,a[a.length-1]).then(s=>(a.push(s),a))):Promise.resolve([]))}U(b){const n=this.m.get(b);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,S.$yg)(()=>this.f.getParent(b))}W(b,n){const a=this.m.get(b);return a?Promise.resolve(a):(0,S.$yg)(()=>this.f.getTreeItem(b)).then(s=>this.kb(b,s,n,!0)).then(s=>this.getChildren(n?n.item.handle:void 0).then(()=>{const o=this.getExtensionElement(s);if(o){const y=this.m.get(o);if(y)return Promise.resolve(y)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(b){if(b){let n;if(typeof b=="string"){const a=this.getExtensionElement(b);n=a?this.m.get(a):void 0}else n=b;return n&&n.children||void 0}return this.h}async Y(b){this.rb(b);const n=new $.$od(this.Z.token);try{const a=b?this.m.get(b):void 0,s=await this.f.getChildren(b);if(n.token.isCancellationRequested)return;const o=await Promise.all((0,D.$Eb)(s||[]).map(async y=>{const m=await this.f.getTreeItem(y);return m&&!n.token.isCancellationRequested?this.db(y,m,a):null}));return n.token.isCancellationRequested?void 0:(0,D.$Eb)(o)}finally{n.dispose()}}$(b){if(b.some(a=>!a))return this.Z.dispose(!0),this.Z=new $.$od,this.tb(),this.J.$refresh(this.I);{const a=this.ab(b);if(a.length)return this.bb(a)}return Promise.resolve(void 0)}ab(b){const n=new Set,a=b.map(o=>this.m.get(o));for(const o of a)if(o&&!n.has(o.item.handle)){let y=o;for(;y&&y.parent&&a.findIndex(m=>y&&y.parent&&m&&m.item.handle===y.parent.item.handle)===-1;){const m=this.j.get(y.parent.item.handle);y=m?this.m.get(m):void 0}y&&!y.parent&&n.add(o.item.handle)}const s=[];return n.forEach(o=>{const y=this.j.get(o);if(y){const m=this.m.get(y);m&&(!m.parent||!n.has(m.parent.item.handle))&&s.push(o)}}),s}bb(b){const n={};return Promise.all(b.map(a=>this.cb(a).then(s=>{s&&(n[a]=s.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(b){const n=this.getExtensionElement(b);if(n){const a=this.m.get(n);if(a)return this.rb(n),(0,S.$yg)(()=>this.f.getTreeItem(n)).then(s=>{if(s){const o=this.ib(n,s,a.parent);return this.pb(n,o,a,a.parent),a.dispose(),o}return null})}return Promise.resolve(null)}db(b,n,a){const s=this.ib(b,n,a);if(n.id&&this.j.has(s.item.handle))throw new Error((0,w.localize)(0,null,n.id));return this.ob(b,s),this.qb(s,a),s}eb(b){return f.$lK.isMarkdownString(b)?u.MarkdownString.from(b):b}fb(b,n){return n?{...this.L.toInternal(n,b),originalId:n.command}:void 0}gb(b){if(b.checkboxState===void 0)return;let n,a,s;return typeof b.checkboxState=="number"?n=b.checkboxState:(n=b.checkboxState.state,a=b.checkboxState.tooltip,s=b.checkboxState.accessibilityInformation),{isChecked:n===f.TreeItemCheckboxState.Checked,tooltip:a,accessibilityInformation:s}}hb(b){if(!f.$JK.isTreeItem(b,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(b,n,a){this.hb(n);const s=this.B(new A.$ic),o=this.kb(b,n,a),y=this.lb(n);return{item:{handle:o,parentHandle:a?a.item.handle:void 0,label:i(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(s,n.command),contextValue:n.contextValue,icon:y,iconDark:this.mb(n)||y,themeIcon:this.jb(n),collapsibleState:(0,P.$rf)(n.collapsibleState)?f.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:a,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(b){return b.iconPath instanceof f.$RK?b.iconPath:void 0}kb(b,{id:n,label:a,resourceUri:s},o,y){if(n)return`${g.b}/${n}`;const m=i(a,this.N),I=o?o.item.handle:g.a;let E=m?m.label:s?(0,F.$eg)(s):"";E=E.indexOf("/")!==-1?E.replace("/","//"):E;const r=this.m.has(b)?this.m.get(b).item.handle:void 0,d=this.X(o)||[];let v,R=0;do{if(v=`${I}/${R}:${E}`,y||!this.j.has(v)||r===v)break;R++}while(R<=d.length);return v}lb(b){if(b.iconPath&&!(b.iconPath instanceof f.$RK))return typeof b.iconPath=="string"||C.URI.isUri(b.iconPath)?this.nb(b.iconPath):this.nb(b.iconPath.light)}mb(b){if(b.iconPath&&!(b.iconPath instanceof f.$RK)&&b.iconPath.dark)return this.nb(b.iconPath.dark)}nb(b){return C.URI.isUri(b)?b:C.URI.file(b)}ob(b,n){this.j.set(n.item.handle,b),this.m.set(b,n)}pb(b,n,a,s){this.j.delete(n.item.handle),this.m.delete(b),n.item.handle!==a.item.handle&&this.j.delete(a.item.handle),this.ob(b,n);const o=this.X(s)||[],y=o.filter(m=>m.item.handle===a.item.handle)[0];y&&o.splice(o.indexOf(y),1,n)}qb(b,n){n?(n.children||(n.children=[]),n.children.push(b)):(this.h||(this.h=[]),this.h.push(b))}rb(b){if(b){const n=this.m.get(b);if(n){if(n.children)for(const a of n.children){const s=this.j.get(a.item.handle);s&&this.sb(s)}n.children=void 0}}else this.tb()}sb(b){const n=this.m.get(b);if(n){if(n.children)for(const a of n.children){const s=this.j.get(a.item.handle);s&&this.sb(s)}this.m.delete(b),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(b=>b.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[212],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalContextMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalContextMenu.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[213],Re([1,0,167,9,29,92,73,30,20,212,177,98]),function(be,e,w,F,C,L,A,l,S,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=void 0;const u=l.$7m.as(A.$8m.JSONContribution);class p{constructor(b,n,a){this.a=b,this.b=n,this.c=a}d(b,n){this.a({type:b,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(b){this.d(C.default.Error,b)}warn(b){this.d(C.default.Warning,b)}info(b){this.d(C.default.Info,b)}}e.$UF=p;class ${static a(b){const n=new S.$Vl;for(let a=0,s=b.length;a<s;a++)n.add(b[a].description.identifier);return n}static compute(b,n){if(!b||!b.length)return new $(n,[]);if(!n||!n.length)return new $([],b);const a=this.a(b),s=this.a(n),o=n.filter(m=>!a.has(m.description.identifier)),y=b.filter(m=>!s.has(m.description.identifier));return new $(o,y)}constructor(b,n){this.added=b,this.removed=n}}e.$VF=$;class h{constructor(b,n){this.name=b,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(b){if(this.a!==null)throw new Error("Handler already set!");this.a=b,this.d()}acceptUsers(b){this.c=$.compute(this.b,b),this.b=b,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(b){(0,F.$Y)(b)}}}e.$WF=h;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$XF={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.$Tl},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Ln}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Ln}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)},pricing:{type:"string",markdownDescription:w.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(b){if(this.a.has(b.extensionPoint))throw new Error("Duplicate extension point: "+b.extensionPoint);const n=new h(b.extensionPoint,b.defaultExtensionKind);return this.a.set(b.extensionPoint,n),b.activationEventsGenerator&&D.$zF.register(b.extensionPoint,b.activationEventsGenerator),e.$XF.properties.contributes.properties[b.extensionPoint]=b.jsonSchema,u.registerSchema(i,e.$XF),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$YF=c;const g={ExtensionsRegistry:"ExtensionsRegistry"};l.$7m.add(g.ExtensionsRegistry,new c),e.$ZF=l.$7m.as(g.ExtensionsRegistry),u.registerSchema(i,e.$XF),u.registerSchema(P.$kj,{properties:{extensionEnabledApiProposals:{description:w.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}}]}}}})}),define(Ae[214],Re([1,0,164,16,24,213,32,5]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9F=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var f;(function(u){function p($,h,t){if(!$)return;const i=F.$if($.type)?$.type:void 0;if(!i||i.length===0){t.error(w.localize(3,null));return}const c=[];if(Array.isArray($.required))for(const g of $.required)F.$if(g)&&c.push(g);return{extensionId:h.value,taskType:i,required:c,properties:$.properties?C.$Um($.properties):{},when:$.when?A.$Hi.deserialize($.when):void 0}}u.from=p})(f||(f={}));const P=L.$ZF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,p)=>{for(const $ of u)$.type&&p.push(`onTaskType:${$.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:S}});class D{constructor(){this.d=new l.$ed,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,$)=>{P.setHandler((h,t)=>{this.c=void 0;try{for(const i of t.removed){const c=i.value;for(const g of c)this.a&&g.type&&this.a[g.type]&&delete this.a[g.type]}for(const i of t.added){const c=i.value;for(const g of c){const k=f.from(g,i.description.identifier,i.collector);k&&(this.a[k.taskType]=k)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const $ of this.all()){const h={type:"object",additionalProperties:!1};$.required.length>0&&(h.required=$.required.slice(0)),$.properties!==void 0?h.properties=C.$Um($.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[$.taskType]},p.push(h)}this.c={oneOf:p}}return this.c}}e.$9F=new D}),define(Ae[215],Re([1,0,165,16,23,24,32,214]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$gG=e.JsonSchemaVersion=e.ExecutionEngine=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$aG=e.ShellQuoting=e.$_F=e.$$F=e.$0F=void 0,e.$0F="settings",e.$$F=new A.$1i("taskRunning",!1,w.localize(0,null)),e.$_F={value:w.localize(1,null),original:"Tasks"};var S;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(S||(e.ShellQuoting=S={})),e.$aG="$customized",function(O){function z(ee){if(!ee)return O.Strong;switch(ee.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=z}(S||(e.ShellQuoting=S={}));var f;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(f||(e.CommandOptions=f={}));var P;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(P||(e.RevealKind=P={})),function(O){function z(ee){switch(ee.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=z}(P||(e.RevealKind=P={}));var D;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(O){function z(ee){switch(ee.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=z}(D||(e.RevealProblemKind=D={}));var u;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(u||(e.PanelKind=u={})),function(O){function z(ee){switch(ee.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=z}(u||(e.PanelKind=u={}));var p;(function(O){O.defaults={echo:!0,reveal:P.Always,revealProblems:D.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var $;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})($||(e.RuntimeType=$={})),function(O){function z(X){switch(X.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=z;function ee(X){switch(X){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=ee}($||(e.RuntimeType=$={}));var h;(function(O){function z(ee){return F.$if(ee)?ee:ee.value}O.value=z})(h||(e.CommandString=h={}));var t;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function z(X){return X===O.Clean._id||X===O.Build._id||X===O.Rebuild._id||X===O.Test._id}O.is=z;function ee(X){if(X!==void 0)return F.$if(X)?z(X)?{_id:X,isDefault:!1}:void 0:X}O.from=ee})(t||(e.TaskGroup=t={}));var i;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var c;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function z(ee){switch(ee){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=z})(c||(e.TaskSourceKind=c={}));var g;(function(O){O.parallel="parallel",O.sequence="sequence"})(g||(e.DependsOrder=g={}));var k;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(k||(e.RunOnOptions=k={}));var b;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:k.default,instanceLimit:1}})(b||(e.RunOptions=b={}));class n{constructor(z,ee,X,Ee,ke,Pe){this._label="",this._id=z,ee&&(this._label=ee),X&&(this.type=X),this.runOptions=Ee,this.configurationProperties=ke,this._source=Pe}getDefinition(z){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,ee=!1){if(z===void 0)return!1;if(F.$if(z))return z===this._label||z===this.configurationProperties.identifier||ee&&z===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$bG=n;class a extends n{constructor(z,ee,X,Ee,ke,Pe,Z,ue){super(z,X,void 0,Z,ue,ee),this.command={},this._source=ee,this.hasDefinedMatchers=Pe,ke&&(this.command=ke)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let ee;switch(this.command?this.command.runtime:void 0){case $.Shell:ee="shell";break;case $.Process:ee="process";break;case $.CustomExecution:ee="customExecution";break;case void 0:ee="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ee,_key:this._id,id:this._id}}}static is(z){return z instanceof a}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$0F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let ee=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ee+=this._source.kind);const X={type:e.$aG,folder:z,id:ee};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$eg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new a(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$cG=a;class s extends n{constructor(z,ee,X,Ee,ke,Pe,Z){super(z,X,Ee,Pe,Z,ee),this._source=ee,this.configures=ke}static is(z){return z instanceof s}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$eg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$0F:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let ee=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ee+=this._source.kind);const X={type:e.$aG,folder:z,id:ee};return JSON.stringify(X)}}e.$dG=s;class o extends n{constructor(z,ee,X,Ee,ke,Pe,Z,ue,ye){super(z,X,Ee,ue,ye,ee),this.defines=ke,this.hasDefinedMatchers=Z,this.command=Pe,this.icon=ye.icon,this.hide=ye.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof o}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new o(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$eG=o;class y extends n{constructor(z,ee,X,Ee,ke,Pe){super(z,X,Ee,ke,Pe,ee),this._source=ee}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new y(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$fG=y;var m;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(m||(e.ExecutionEngine=m={})),function(O){O._default=O.Terminal}(m||(e.ExecutionEngine=m={}));var I;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class E{constructor(z){this.c=new Map;for(let ee=0;ee<z.length;ee++)this.c.set(z[ee].uri.toString(),ee)}compare(z,ee){const X=z.getWorkspaceFolder(),Ee=ee.getWorkspaceFolder();if(X&&Ee){let ke=this.c.get(X.uri.toString());ke=ke===void 0?0:ke+1;let Pe=this.c.get(Ee.uri.toString());return Pe=Pe===void 0?0:Pe+1,ke===Pe?z._label.localeCompare(ee._label):ke-Pe}else return!X&&Ee?-1:X&&!Ee?1:0}}e.$gG=E;var r;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(r||(e.TaskEventKind=r={}));var d;(function(O){O.SingleRun="singleRun",O.Background="background"})(d||(e.TaskRunType=d={}));var v;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var R;(function(O){function z(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function ee(ue,ye,ce){return{...z(ue),kind:"start",terminalId:ye,resolvedVariables:ce}}O.start=ee;function X(ue,ye,ce){return{...z(ue),kind:"processStarted",terminalId:ye,processId:ce}}O.processStarted=X;function Ee(ue,ye,ce){return{...z(ue),kind:"processEnded",terminalId:ye,exitCode:ce}}O.processEnded=Ee;function ke(ue,ye,ce){return{...z(ue),kind:"terminated",exitReason:ce,terminalId:ye}}O.terminated=ke;function Pe(ue,ye,ce){return{...z(ye),kind:ue,terminalId:ce}}O.general=Pe;function Z(){return{kind:"changed"}}O.changed=Z})(R||(e.TaskEvent=R={}));var B;(function(O){function z(X){const Ee=Object.keys(X).sort();let ke="";for(const Pe of Ee){let Z=X[Pe];Z instanceof Object?Z=z(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),ke+=Pe+","+Z+","}return ke}function ee(X){const ke={_key:z(X),type:X.taskType};return Object.assign(ke,X),ke}O.create=ee})(B||(e.KeyedTaskIdentifier=B={}));var V;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(V||(e.TaskSettingId=V={}));var j;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var W;(function(O){function z(ee,X){const Ee=l.$9F.get(ee.type);if(Ee===void 0){const ue=L.$Um(ee);return delete ue._key,B.create(ue)}const ke=Object.create(null);ke.type=Ee.taskType;const Pe=new Set;Ee.required.forEach(ue=>Pe.add(ue));const Z=Ee.properties;for(const ue of Object.keys(Z)){const ye=ee[ue];if(ye!=null)ke[ue]=ye;else if(Pe.has(ue)){const ce=Z[ue];if(ce.default!==void 0)ke[ue]=L.$Um(ce.default);else switch(ce.type){case"boolean":ke[ue]=!1;break;case"number":case"integer":ke[ue]=0;break;case"string":ke[ue]="";break;default:X.error(w.localize(2,null,JSON.stringify(ee,void 0,0),ue));return}}}return B.create(ke)}O.createTaskIdentifier=z})(W||(e.TaskDefinition=W={}))}),define(Ae[216],Re([1,0,9]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l3b=e.$k3b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,l)=>{this.b=A,this.d=l,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,w.$Y)(A))}then(A,l){return this.j().then(A,l)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$k3b=F;class C extends F{constructor(){super(),this.h=!0,this.i=new w.$3}}e.$l3b=C}),define(Ae[46],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bA=e.$aA=e.$_z=e.$$z=void 0;class w{static{this.count=0}constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++w.count}}e.$$z=w;const F=[];function C(l){const S=new w(l);return F[S.nid]=S,S}e.$_z=C;function L(l){return F[l].sid}e.$aA=L;class A{constructor(S){this.value=S}}e.$bA=A}),define(Ae[3],Re([1,0,46]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VJ=e.$UJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$TJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var C;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var L;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var l;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(l||(e.WebviewMessageArrayBufferViewType=l={}));var S;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(S||(e.CellOutputKind=S={}));var f;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(f||(e.NotebookEditorRevealType=f={}));var P;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class D{static{this.a=0}static mixin(t){return t._id=D.a++,t}}e.$TJ=D;var u;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var p;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var $;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$UJ={MainThreadAuthentication:(0,w.$_z)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$_z)("MainThreadBulkEdits"),MainThreadChatProvider:(0,w.$_z)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,w.$_z)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,w.$_z)("MainThreadChatVariables"),MainThreadClipboard:(0,w.$_z)("MainThreadClipboard"),MainThreadCommands:(0,w.$_z)("MainThreadCommands"),MainThreadComments:(0,w.$_z)("MainThreadComments"),MainThreadConfiguration:(0,w.$_z)("MainThreadConfiguration"),MainThreadConsole:(0,w.$_z)("MainThreadConsole"),MainThreadDebugService:(0,w.$_z)("MainThreadDebugService"),MainThreadDecorations:(0,w.$_z)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$_z)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$_z)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$_z)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$_z)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$_z)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$_z)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$_z)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$_z)("MainThreadErrors"),MainThreadTreeViews:(0,w.$_z)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$_z)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$_z)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$_z)("MainThreadLanguages"),MainThreadLogger:(0,w.$_z)("MainThreadLogger"),MainThreadMessageService:(0,w.$_z)("MainThreadMessageService"),MainThreadOutputService:(0,w.$_z)("MainThreadOutputService"),MainThreadProgress:(0,w.$_z)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$_z)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$_z)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$_z)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$_z)("MainThreadSecretState"),MainThreadStorage:(0,w.$_z)("MainThreadStorage"),MainThreadTelemetry:(0,w.$_z)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$_z)("MainThreadTerminalService"),MainThreadWebviews:(0,w.$_z)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$_z)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$_z)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$_z)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$_z)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$_z)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$_z)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$_z)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$_z)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.$_z)("MainThreadExtensionService"),MainThreadSCM:(0,w.$_z)("MainThreadSCM"),MainThreadSearch:(0,w.$_z)("MainThreadSearch"),MainThreadShare:(0,w.$_z)("MainThreadShare"),MainThreadTask:(0,w.$_z)("MainThreadTask"),MainThreadWindow:(0,w.$_z)("MainThreadWindow"),MainThreadLabelService:(0,w.$_z)("MainThreadLabelService"),MainThreadNotebook:(0,w.$_z)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$_z)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$_z)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$_z)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$_z)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$_z)("MainThreadInteractive"),MainThreadChat:(0,w.$_z)("MainThreadChat"),MainThreadInlineChat:(0,w.$_z)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.$_z)("MainThreadTheming"),MainThreadTunnelService:(0,w.$_z)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$_z)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$_z)("MainThreadTimeline"),MainThreadTesting:(0,w.$_z)("MainThreadTesting"),MainThreadLocalization:(0,w.$_z)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$_z)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$_z)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,w.$_z)("MainThreadIssueReporter")},e.$VJ={ExtHostCommands:(0,w.$_z)("ExtHostCommands"),ExtHostConfiguration:(0,w.$_z)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$_z)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$_z)("ExtHostDebugService"),ExtHostDecorations:(0,w.$_z)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$_z)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$_z)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$_z)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$_z)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$_z)("ExtHostEditors"),ExtHostTreeViews:(0,w.$_z)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$_z)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$_z)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$_z)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$_z)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$_z)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$_z)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$_z)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$_z)("ExtHostStatusBar"),ExtHostShare:(0,w.$_z)("ExtHostShare"),ExtHostExtensionService:(0,w.$_z)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$_z)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$_z)("ExtHostTerminalService"),ExtHostSCM:(0,w.$_z)("ExtHostSCM"),ExtHostSearch:(0,w.$_z)("ExtHostSearch"),ExtHostTask:(0,w.$_z)("ExtHostTask"),ExtHostWorkspace:(0,w.$_z)("ExtHostWorkspace"),ExtHostWindow:(0,w.$_z)("ExtHostWindow"),ExtHostWebviews:(0,w.$_z)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$_z)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$_z)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$_z)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$_z)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$_z)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$_z)("ExtHostProgress"),ExtHostComments:(0,w.$_z)("ExtHostComments"),ExtHostSecretState:(0,w.$_z)("ExtHostSecretState"),ExtHostStorage:(0,w.$_z)("ExtHostStorage"),ExtHostUrls:(0,w.$_z)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$_z)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$_z)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$_z)("ExtHostOutputService"),ExtHosLabelService:(0,w.$_z)("ExtHostLabelService"),ExtHostNotebook:(0,w.$_z)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$_z)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$_z)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$_z)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$_z)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$_z)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$_z)("ExtHostInteractive"),ExtHostInlineChat:(0,w.$_z)("ExtHostInlineChatShape"),ExtHostChat:(0,w.$_z)("ExtHostChat"),ExtHostChatSlashCommands:(0,w.$_z)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,w.$_z)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.$_z)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,w.$_z)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$_z)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$_z)("ExtHostTheming"),ExtHostTunnelService:(0,w.$_z)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$_z)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$_z)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$_z)("ExtHostTimeline"),ExtHostTesting:(0,w.$_z)("ExtHostTesting"),ExtHostTelemetry:(0,w.$_z)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$_z)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.$_z)("ExtHostIssueReporter")}}),define(Ae[217],Re([1,0,3,7]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$UJ.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,l,S){if(this.a.size===0)throw new Error("No related information providers registered");const f=this.a.get(A);if(!f)throw new Error("related information provider not found");return await f.provideRelatedInformation(l,S)??[]}getRelatedInformation(A,l,S){return this.c.$getAiRelatedInformation(l,S)}registerRelatedInformationProvider(A,l,S){const f=this.b;return this.b++,this.a.set(f,S),this.c.$registerAiRelatedInformationProvider(f,l),new F.$WJ(()=>{this.c.$unregisterAiRelatedInformationProvider(f),this.a.delete(f)})}}e.$Pcc=C}),define(Ae[80],Re([1,0,4,14,3,17]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=e.$Sac=e.$Rac=void 0,e.$Rac=(0,w.$Ah)("IExtHostApiDeprecationService");let A=class{constructor(S,f){this.c=f,this.a=new Set,this.b=S.getProxy(C.$UJ.MainThreadTelemetry)}report(S,f,P){const D=this.d(S,f);this.a.has(D)||(this.a.add(D),f.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:f.identifier.value,apiId:S}))}d(S,f){return`${S}-${f.identifier.value}`}};e.$Sac=A,e.$Sac=A=Ke([Ve(0,L.$WL),Ve(1,F.$4i)],A),e.$Tac=Object.freeze(new class{report(l,S,f){}})}),define(Ae[218],Re([1,0,5,3,7,20]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;class A{constructor(f){this.b=new Map,this.c=[],this.d=new w.$ed,this.onDidChangeSessions=this.d.event,this.f=new l,this.g=new l,this.a=f.getProxy(F.$UJ.MainThreadAuthentication)}$setProviders(f){return this.c=f,Promise.resolve()}async getSession(f,P,D,u={}){const p=L.$Ul.toKey(f.identifier),$=[...D].sort().join(" ");return await this.f.getOrCreate(`${p} ${P} ${$}`,async()=>{await this.a.$ensureProvider(P);const h=f.displayName||f.name;return this.a.$getSession(P,D,p,h,u)})}async getSessions(f,P,D){const u=L.$Ul.toKey(f.identifier),p=[...D].sort().join(" ");return await this.g.getOrCreate(`${u} ${p}`,async()=>{await this.a.$ensureProvider(P);const $=f.displayName||f.name;return this.a.$getSessions(P,D,u,$)})}async removeSession(f,P){const D=this.b.get(f);return D?D.provider.removeSession(P):this.a.$removeSession(f,P)}registerAuthenticationProvider(f,P,D,u){if(this.b.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this.b.set(f,{label:P,provider:D,options:u??{supportsMultipleAccounts:!1}}),this.c.find($=>$.id===f)||this.c.push({id:f,label:P});const p=D.onDidChangeSessions($=>{this.a.$sendDidChangeSessions(f,{added:$.added??[],changed:$.changed??[],removed:$.removed??[]})});return this.a.$registerAuthenticationProvider(f,P,u?.supportsMultipleAccounts??!1),new C.$WJ(()=>{p.dispose(),this.b.delete(f);const $=this.c.findIndex(h=>h.id===f);$>-1&&this.c.splice($),this.a.$unregisterAuthenticationProvider(f)})}$createSession(f,P,D){const u=this.b.get(f);if(u)return Promise.resolve(u.provider.createSession(P,D));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$removeSession(f,P){const D=this.b.get(f);if(D)return Promise.resolve(D.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$getSessions(f,P){const D=this.b.get(f);if(D)return Promise.resolve(D.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,P){return this.d.fire({provider:{id:f,label:P}}),Promise.resolve()}}e.$ncc=A;class l{constructor(){this.a=new Map}getOrCreate(f,P){const D=this.a.get(f);if(D)return D;const u=P().finally(()=>this.a.delete(f));return this.a.set(f,u),u}}}),define(Ae[219],Re([1,0,3,17,8]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;let L=class{constructor(l,S){this.a=l.getProxy(w.$UJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:f=>S.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(l,S,f){const P=C.WorkspaceEdit.from(l,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,f?.isRefactoring??!1)}};e.$tcc=L,e.$tcc=L=Ke([Ve(0,F.$WL)],L)}),define(Ae[220],Re([1,0,13,5,66,6,58,147,3,8]),function(be,e,w,F,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class P{static{this.a=0}constructor(p,$){this.extension=p,this.provider=$,this.handle=P.a++}}class D{static{this.a=0}constructor(p,$){this.h=$,this.b=new Map,this.d=new Map,this.e=new F.$ed,this.onDidPerformUserAction=this.e.event,this.g=p.getProxy(S.$UJ.MainThreadChat)}registerChatProvider(p,$,h){const t=new P(p,h);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,$),(0,L.$hc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(p,$){const h=C.Iterable.find(this.d.keys(),t=>this.d.get(t)===p)??0;typeof h=="number"&&this.g.$transferChatSession(h,$)}addChatRequest(p){this.g.$addRequest(p)}sendInteractiveRequestToProvider(p,$){this.g.$sendRequestToProvider(p,$)}async $prepareChat(p,$,h){const t=this.b.get(p);if(!t)return;const i=await t.provider.prepareSession($,h);if(!i)return;const c=D.a++;return this.d.set(c,i),{id:c,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $resolveRequest(p,$,h,t){const i=this.b.get(p);if(!i)return;const c=this.d.get($);if(!c||!i.provider.resolveRequest)return;const g=await i.provider.resolveRequest(c,h,t);if(g)return{message:typeof g.message=="string"?g.message:f.ChatReplyFollowup.from(g.message)}}async $provideWelcomeMessage(p,$){const h=this.b.get(p);if(!h||!h.provider.provideWelcomeMessage)return;const t=await h.provider.provideWelcomeMessage($);if(t)return t.map(i=>typeof i=="string"?i:i.map(c=>f.ChatReplyFollowup.from(c)))}async $provideFollowups(p,$,h){const t=this.b.get(p);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,h))?.map(g=>f.ChatFollowup.from(g))}$removeRequest(p,$,h){const t=this.b.get(p);if(!t)return;const i=this.d.get($);i&&t.provider.removeRequest&&t.provider.removeRequest(i,h)}async $provideReply(p,$,h,t){const i=this.b.get(p);if(!i)return;const c=this.d.get($);if(!c)return;const g={session:c,message:typeof h.message=="string"?h.message:f.ChatReplyFollowup.to(h.message),variables:{}};if(h.variables)for(const o of Object.keys(h.variables))g.variables[o]=h.variables[o].map(f.ChatVariable.to);const k=A.$ad.create(!1);let b;const n={report:o=>{if(!t.isCancellationRequested)if(typeof b>"u"&&(b=k.elapsed()),"responseId"in o)this.g.$acceptResponseProgress(p,$,{requestId:o.responseId});else if("placeholder"in o&&"resolvedContent"in o){const y=Promise.all([this.g.$acceptResponseProgress(p,$,{placeholder:o.placeholder}),o.resolvedContent]);(0,w.$ug)(y,t).then(m=>{if(!m)return;const[I,E]=m;this.g.$acceptResponseProgress(p,$,E,I??void 0)})}else"content"in o?this.g.$acceptResponseProgress(p,$,{content:typeof o.content=="string"?o.content:f.MarkdownString.from(o.content)}):this.g.$acceptResponseProgress(p,$,o)}};let a;try{a=await i.provider.provideResponseWithProgress(g,n,t),a||(a={errorDetails:{message:(0,l.localize)(0,null)}})}catch(o){a={errorDetails:{message:(0,l.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(c.saveState&&this.d.has($)){const o=c.saveState();this.g.$acceptChatState($,o)}}catch(o){this.h.warn(o)}const s={firstProgress:b??0,totalElapsed:k.elapsed()};return{errorDetails:a.errorDetails,timings:s}}async $provideSlashCommands(p,$,h){const t=this.b.get(p);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,h))?.map(g=>({...g,kind:f.CompletionItemKind.from(g.kind)}))}$releaseSession(p){this.d.delete(p)}async $onDidPerformUserAction(p){this.e.fire(p)}}e.$Hcc=D}),define(Ae[221],Re([1,0,6,3,8,72,20]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class l{static{this.a=1}constructor(f,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$Wl,this.b=f.getProxy(F.$UJ.MainThreadChatProvider)}registerProvider(f,P,D,u){const p=l.a++;return this.c.set(p,{extension:f,provider:D}),this.b.$registerProvider(p,P,{extension:f,displayName:u.name??f.value}),(0,w.$hc)(()=>{this.b.$unregisterProvider(p),this.c.delete(p)})}async $provideChatResponse(f,P,D,u,p){const $=this.c.get(f);if(!$)return;const h=new L.$2u(async t=>{if(p.isCancellationRequested){this.d.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:t.index,part:t.part})},{async:!0});return $.provider.provideChatResponse(D.map(C.ChatMessage.to),u,h,p)}allowListExtensionWhile(f,P){this.f.set(f,P),P.finally(()=>this.f.delete(f))}async requestChatResponseProvider(f,P){if(!this.f.has(f))throw new Error("Extension is NOT allowed to make chat requests");const D=this;return{get isRevoked(){return!D.f.has(f)},async makeRequest(u,p,$,h){if(!D.f.has(f))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;D.e.set(t,$);try{await D.b.$fetchResponse(f,P,t,u.map(C.ChatMessage.from),p,h)}finally{D.e.delete(t)}}}}async $handleResponseFragment(f,P){this.e.get(f)?.report(P)}}e.$Mcc=l}),define(Ae[222],Re([1,0,6,3,7,8,72,13]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;class S{static{this.a=0}constructor(D,u,p){this.d=u,this.e=p,this.b=new Map,this.c=D.getProxy(F.$UJ.MainThreadChatSlashCommands)}registerCommand(D,u,p,$){const h=S.a++;return this.b.set(h,{extension:D,command:p}),this.c.$registerCommand(h,u,$.description),(0,w.$hc)(()=>{this.c.$unregisterCommand(h),this.b.delete(h)})}async $executeCommand(D,u,p,$,h){const t=this.b.get(D);if(!t){this.e.warn(`[CHAT](${D}) CANNOT execute command because the command is not registered`);return}let i=!1;function c(){if(i)throw new Error("Only valid while executing the command")}const g=new l.$1g;h.onCancellationRequested(()=>g.complete()),setTimeout(()=>g.complete(),3*1e3),this.d.allowListExtensionWhile(t.extension,g.p);const k=t.command({role:C.ChatMessageRole.User,content:p},{history:$.history.map(L.ChatMessage.to)},new A.$2u(b=>{c(),this.c.$handleProgressChunk(u,{content:f(b.message)?b.message:b.message.value})}),h);try{return await(0,l.$ug)(Promise.resolve(k).then(b=>{if(b&&"followUp"in b)return{followUp:b?.followUp?.map(a=>L.ChatFollowup.from(a))}}),h)}finally{i=!0,g.complete()}}}e.$Ncc=S;function f(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Ae[223],Re([1,0,6,3,9,8]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=void 0;class A{static{this.a=0}constructor(S){this.b=new Map,this.c=S.getProxy(F.$UJ.MainThreadChatVariables)}async $resolveVariable(S,f,P){const D=this.b.get(S);if(D)try{const u=await D.resolver.resolve(D.data.name,{message:f},P);if(u)return u.map(L.ChatVariable.from)}catch(u){(0,C.$Z)(u)}}registerVariableResolver(S,f,P,D){const u=A.a++;return this.b.set(u,{extension:S.identifier,data:{name:f,description:P},resolver:D}),this.c.$registerVariable(u,{name:f,description:P}),(0,w.$hc)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$Occ=A}),define(Ae[224],Re([1,0,3]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=void 0;class F{constructor(L){const A=L.getProxy(w.$UJ.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(l){return A.$writeText(l)}})}}e.$Wac=F}),define(Ae[31],Re([1,0,16,7,8,24,3,18,14,68,44,278,2,6,4,17,105,25,46,41,58,52,57]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t,i,c,g,k,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=void 0;let a=class{#e;#t;#i;constructor(E,r,d){this.b=new Map,this.c=new Map,this.#e=E.getProxy(A.$UJ.MainThreadCommands),this.d=r,this.#i=d,this.#t=E.getProxy(A.$UJ.MainThreadTelemetry),this.converter=new s(this,v=>{const R=this.c.get(v);return R?.result===y.Void?R:void 0},r),this.f=[{processArgument(v){return(0,f.$0g)(v)}},{processArgument(v){return(0,L.$Wm)(v,function(R){if(P.$is.isIRange(R))return C.Range.to(R);if(D.$hs.isIPosition(R))return C.Position.to(R);if(P.$is.isIRange(R.range)&&u.URI.isUri(R.uri))return C.location.to(R);if(R instanceof i.$Ed)return R.buffer.buffer;if(!Array.isArray(R))return R})}}]}registerArgumentProcessor(E){this.f.push(E)}registerApiCommand(E){const r=this.registerCommand(!1,E.id,async(...d)=>{const v=E.args.map((B,V)=>{if(!B.validate(d[V]))throw new Error(`Invalid argument '${B.name}' when running '${E.id}', received: ${d[V]}`);return B.convert(d[V])}),R=await this.executeCommand(E.internalId,...v);return E.result.convert(R,d,this.converter)},void 0,{description:E.description,args:E.args,returns:E.result.description});return this.c.set(E.id,E),new F.$WJ(()=>{r.dispose(),this.c.delete(E.id)})}registerCommand(E,r,d,v,R,B){if(this.d.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this.b.has(r))throw new Error(`command '${r}' already exists`);return this.b.set(r,{callback:d,thisArg:v,description:R,extension:B}),E&&this.#e.$registerCommand(r),new F.$WJ(()=>{this.b.delete(r)&&E&&this.#e.$unregisterCommand(r)})}executeCommand(E,...r){return this.d.trace("ExtHostCommands#executeCommand",E),this.g(E,r,!0)}async g(E,r,d){if(this.b.has(E))return this.#e.$fireCommandActivationEvent(E),this.h(E,r,!1);{let v=!1;const R=(0,L.$Wm)(r,function(B){if(B instanceof F.$XJ)return C.Position.from(B);if(B instanceof F.$YJ)return C.Range.from(B);if(B instanceof F.$9J)return C.location.from(B);if(F.$iL.isNotebookRange(B))return C.NotebookRange.from(B);if(B instanceof ArrayBuffer)return v=!0,i.$Ed.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return v=!0,i.$Ed.wrap(B);if(B instanceof i.$Ed)return v=!0,B;if(!Array.isArray(B))return B});try{const B=await this.#e.$executeCommand(E,v?new c.$bA(R):R,d);return(0,f.$0g)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(E,r,!1);throw B}}}async h(E,r,d){const v=this.b.get(E);if(!v)throw new Error("Unknown command");const{callback:R,thisArg:B,description:V}=v;if(V)for(let W=0;W<V.args.length;W++)try{(0,w.$zf)(r[W],V.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${E}' failed. Illegal argument '${V.args[W].name}' - ${V.args[W].description}`)}const j=k.$ad.create();try{return await R.apply(B,r)}catch(W){if(E===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...r);O&&(E=O.command)}if(this.d.error(W,E,v.extension?.identifier),!d)throw W;if(v.extension?.identifier){const O=this.#i.onExtensionError(v.extension.identifier,W);this.d.trace("forwarded error to extension?",O,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,g.$li)(W)),this.id=E,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,E,j.elapsed())}}j(E,r,d){E.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:E.extension.identifier.value,id:new b.$$n(r),duration:d})}$executeContributedCommand(E,...r){this.d.trace("ExtHostCommands#$executeContributedCommand",E);const d=this.b.get(E);return d?(r=r.map(v=>this.f.reduce((R,B)=>B.processArgument(R,d.extension?.identifier),v)),this.h(E,r,!0)):Promise.reject(new Error(`Contributed command '${E}' does not exist.`))}getCommands(E=!1){return this.d.trace("ExtHostCommands#getCommands",E),this.#e.$getCommands().then(r=>(E&&(r=r.filter(d=>d[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const E=Object.create(null);for(const[r,d]of this.b){const{description:v}=d;v&&(E[r]=v)}return Promise.resolve(E)}};e.$fM=a,e.$fM=a=Ke([Ve(0,h.$WL),Ve(1,S.$4i),Ve(2,n.$eM)],a),e.$gM=(0,$.$Ah)("IExtHostCommands");class s{constructor(E,r,d){this.d=E,this.f=r,this.g=d,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(E,r){if(!E)return;const d={$ident:void 0,id:E.command,title:E.title,tooltip:E.tooltip};if(!E.command)return d;const v=this.f(E.command);if(v)d.id=v.internalId,d.arguments=v.args.map((R,B)=>R.convert(E.arguments&&E.arguments[B]));else if((0,l.$Ib)(E.arguments)){const R=`${E.command}/${++this.c}`;this.b.set(R,E),r.add((0,p.$hc)(()=>{this.b.delete(R),this.g.trace("CommandsConverter#DISPOSE",R)})),d.$ident=R,d.id=this.delegatingCommandId,d.arguments=[R],this.g.trace("CommandsConverter#CREATE",E.command,R)}return d}fromInternal(E){return typeof E.$ident=="string"?this.b.get(E.$ident):{command:E.id,title:E.title,arguments:E.arguments}}getActualCommand(...E){return this.b.get(E[0])}h(...E){const r=this.getActualCommand(...E);return this.g.trace("CommandsConverter#EXECUTE",E[0],r?r.command:"MISSING"),r?this.d.executeCommand(r.command,...r.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${E[0]}`)}}e.$hM=s;class o{static{this.Uri=new o("uri","Uri of a text document",E=>u.URI.isUri(E),E=>E)}static{this.Position=new o("position","A position in a text document",E=>F.$XJ.isPosition(E),C.Position.from)}static{this.Range=new o("range","A range in a text document",E=>F.$YJ.isRange(E),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",E=>F.$ZJ.isSelection(E),C.Selection.from)}static{this.Number=new o("number","",E=>typeof E=="number",E=>E)}static{this.String=new o("string","",E=>typeof E=="string",E=>E)}static{this.StringArray=o.Arr(o.String)}static Arr(E){return new o(`${E.name}_array`,`Array of ${E.name}, ${E.description}`,r=>Array.isArray(r)&&r.every(d=>E.validate(d)),r=>r.map(d=>E.convert(d)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",E=>E instanceof F.$hK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",E=>E instanceof F.$BL,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",E=>E instanceof t.$0L,C.TestItem.from)}constructor(E,r,d,v){this.name=E,this.description=r,this.validate=d,this.convert=v}optional(){return new o(this.name,`(optional) ${this.description}`,E=>E==null||this.validate(E),E=>E===void 0?void 0:E===null?null:this.convert(E))}with(E,r){return new o(E??this.name,r??this.description,this.validate,this.convert)}}e.$iM=o;class y{static{this.Void=new y("no result",E=>E)}constructor(E,r){this.description=E,this.convert=r}}e.$jM=y;class m{constructor(E,r,d,v,R){this.id=E,this.internalId=r,this.description=d,this.args=v,this.result=R}}e.$kM=m}),define(Ae[225],Re([1,0,18,12,2,78,91,32,95,31,8,7]),function(be,e,w,F,C,L,A,l,S,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=void 0;const u=[new f.$kM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$iM.Uri,f.$iM.Position],new f.$jM("A promise that resolves to an array of DocumentHighlight-instances.",$(P.DocumentHighlight.to))),new f.$kM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$iM.Uri],new f.$jM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,w.$Hb)(t))return;class c extends D.$bK{static to(k){const b=new c(k.name,P.SymbolKind.to(k.kind),k.containerName||"",new D.$9J(i[0],P.Range.to(k.range)));return b.detail=k.detail,b.range=b.location.range,b.selectionRange=P.Range.to(k.selectionRange),b.children=k.children?k.children.map(c.to):[],b}}return t.map(c.to)})),new f.$kM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$iM.Uri,new f.$iM("options","Formatting options",t=>!0,t=>t)],new f.$jM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new f.$kM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$iM.Uri,f.$iM.Range,new f.$iM("options","Formatting options",t=>!0,t=>t)],new f.$jM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new f.$kM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$iM.Uri,f.$iM.Position,new f.$iM("ch","Trigger character",t=>typeof t=="string",t=>t),new f.$iM("options","Formatting options",t=>!0,t=>t)],new f.$jM("A promise that resolves to an array of TextEdits.",$(P.TextEdit.to))),new f.$kM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$iM.Uri,f.$iM.Position],new f.$jM("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.$kM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$iM.Uri,f.$iM.Position],new f.$jM("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.$kM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$iM.Uri,f.$iM.Position],new f.$jM("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.$kM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$iM.Uri,f.$iM.Position],new f.$jM("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.$kM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$iM.Uri,f.$iM.Position],new f.$jM("A promise that resolves to an array of Location-instances.",$(P.location.to))),new f.$kM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$iM.Uri,f.$iM.Position],new f.$jM("A promise that resolves to an array of Hover-instances.",$(P.Hover.to))),new f.$kM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$iM.Uri,new f.$iM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>D.$XJ.isPosition(i)),t=>t.map(P.Position.from))],new f.$jM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let c;for(const g of i.reverse())c=new D.$gK(P.Range.to(g),c);return c}))),new f.$kM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$iM.String.with("query","Search string")],new f.$jM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new f.$kM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$iM.Uri,f.$iM.Position],new f.$jM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new f.$kM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$iM.CallHierarchyItem],new f.$jM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new f.$kM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$iM.CallHierarchyItem],new f.$jM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new f.$kM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$iM.Uri,f.$iM.Position],new f.$jM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new f.$kM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$iM.Uri,f.$iM.Position,f.$iM.String.with("newName","The new symbol name")],new f.$jM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new f.$kM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$iM.Uri,f.$iM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$jM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new f.$kM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$iM.Uri],new f.$jM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$aL(t.tokenTypes,t.tokenModifiers)})),new f.$kM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$iM.Uri],new f.$jM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$l0)(t);if(i.type==="full")return new D.$cL(i.data,void 0)})),new f.$kM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$iM.Uri,f.$iM.Range.optional()],new f.$jM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$aL(t.tokenTypes,t.tokenModifiers)})),new f.$kM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$iM.Uri,f.$iM.Range],new f.$jM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$l0)(t);if(i.type==="full")return new D.$cL(i.data,void 0)})),new f.$kM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$iM.Uri,f.$iM.Position,f.$iM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$iM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$jM("A promise that resolves to a CompletionList-instance.",(t,i,c)=>{if(!t)return new D.$sK([]);const g=t.suggestions.map(k=>P.CompletionItem.to(k,c));return new D.$sK(g,t.incomplete)})),new f.$kM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$iM.Uri,f.$iM.Position,f.$iM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$jM("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new f.$kM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$iM.Uri,f.$iM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$jM("A promise that resolves to an array of CodeLens-instances.",(t,i,c)=>$(g=>new D.$kK(P.Range.to(g.range),g.command&&c.fromInternal(g.command)))(t))),new f.$kM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$iM.Uri,new f.$iM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.$YJ.isRange(t),t=>D.$ZJ.isSelection(t)?P.Selection.from(t):P.Range.from(t)),f.$iM.String.with("kind","Code action kind to return code actions for").optional(),f.$iM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$jM("A promise that resolves to an array of Command-instances.",(t,i,c)=>$(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(g.command)}else{const k=new D.$dK(g.title,g.kind?new D.$eK(g.kind):void 0);return g.edit&&(k.edit=P.WorkspaceEdit.to(g.edit)),g.command&&(k.command=c.fromInternal(g.command)),k.isPreferred=g.isPreferred,k}})(t))),new f.$kM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$iM.Uri],new f.$jM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new D.$yK(P.Range.to(i.range),P.Color.to(i.color))):[])),new f.$kM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$iM("color","The color to show and insert",t=>t instanceof D.$xK,P.Color.from),new f.$iM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new f.$jM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new f.$kM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$iM.Uri,f.$iM.Range],new f.$jM("A promise that resolves to an array of Inlay objects",(t,i,c)=>t.map(P.InlayHint.to.bind(void 0,c)))),new f.$kM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$iM.Uri],new f.$jM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(P.FoldingRange.to)})),new f.$kM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$jM("A promise that resolves to an array of NotebookContentProvider static info objects.",$(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new f.$kM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$iM.Uri,f.$iM.Range,new f.$iM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof D.$YJ,t=>P.InlineValueContext.from(t))],new f.$jM("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new f.$kM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$iM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,S.$FT)(t,F.Schemas.http,F.Schemas.https),t=>t),new f.$iM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),f.$iM.String.with("label","").optional()],f.$jM.Void),new f.$kM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$iM.Uri.with("resource","Resource to open"),f.$iM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new f.$iM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],f.$jM.Void),new f.$kM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$iM.Uri.with("left","Left-hand side resource of the diff editor"),f.$iM.Uri.with("right","Right-hand side resource of the diff editor"),f.$iM.String.with("title","Human readable title for the diff editor").optional(),new f.$iM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],f.$jM.Void),new f.$kM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$iM.Uri,f.$iM.Position],new f.$jM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$kM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$iM.TypeHierarchyItem],new f.$jM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$kM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$iM.TypeHierarchyItem],new f.$jM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$kM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$iM.TestItem],f.$jM.Void),new f.$kM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$iM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$jM.Void),new f.$kM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$iM.String.with("name","The context key name"),new f.$iM("value","The context key value",()=>!0,t=>t)],f.$jM.Void),new f.$kM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$iM.Uri,f.$iM.StringArray,new f.$iM("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new f.$jM("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class p{static register(i){u.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",l.$Ii)}}e.$Vac=p;function $(t){return i=>{if(Array.isArray(i))return i.map(t)}}function h(t){if(!Array.isArray(t))return;const i=[];for(const c of t)L.$6s(c)?i.push(P.DefinitionLink.to(c)):i.push(P.location.to(c));return i}}),define(Ae[226],Re([1,0,13,64,5,6,2,78,20,8,7,3,26]),function(be,e,w,F,C,L,A,l,S,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=void 0;function p($,h,t){const i=$.getProxy(D.$UJ.MainThreadComments);class c{static{this.a=0}constructor(){this.b=new Map,this.c=new S.$Wl,h.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===6){const I=this.b.get(m.handle);return I?I.value:m}else if(m&&m.$mid===7){const I=this.b.get(m.commentControlHandle);if(!I)return m;const E=I.getCommentThread(m.commentThreadHandle);return E?E.value:m}else if(m&&(m.$mid===9||m.$mid===8)){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const E=I.getCommentThread(m.thread.commentThreadHandle);return E?m.$mid===8?E.value:{thread:E.value,text:m.text}:m}else if(m&&m.$mid===10){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const E=I.getCommentThread(m.thread.commentThreadHandle);if(!E)return m;const r=m.commentUniqueId,d=E.getCommentByUniqueId(r);return d||m}else if(m&&m.$mid===11){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const E=I.getCommentThread(m.thread.commentThreadHandle);if(!E)return m;const r=m.text,d=m.commentUniqueId,v=E.getCommentByUniqueId(d);return v?(typeof v.body=="string"?v.body=r:v.body=new P.$lK(r),v):m}return m}})}createCommentController(m,I,E){const r=c.a++,d=new k(m,r,I,E);this.b.set(d.handle,d);const v=this.c.get(m.identifier)||[];return v.push(d),this.c.set(m.identifier,v),d.value}$createCommentThreadTemplate(m,I,E){const r=this.b.get(m);r&&r.$createCommentThreadTemplate(I,E)}async $updateCommentThreadTemplate(m,I,E){const r=this.b.get(m);r&&r.$updateCommentThreadTemplate(I,E)}$deleteCommentThread(m,I){this.b.get(m)?.$deleteCommentThread(I)}$provideCommentingRanges(m,I,E){const r=this.b.get(m);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const d=t.getDocument(A.URI.revive(I));return(0,w.$yg)(async()=>{const v=await r.commentingRangeProvider.provideCommentingRanges(d,E);let R;return Array.isArray(v)?R={ranges:v,fileComments:!1}:v?R={ranges:v.ranges||[],fileComments:v.fileComments||!1}:R=v??void 0,R}).then(v=>{let R;return v&&(R={ranges:v.ranges.map(B=>f.Range.from(B)),fileComments:v.fileComments}),R})}$toggleReaction(m,I,E,r,d){const v=this.b.get(m);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,w.$yg)(()=>{const R=v.getCommentThread(I);if(R){const B=R.getCommentByUniqueId(r.uniqueIdInThread);if(v!==void 0&&B&&v.reactionHandler)return v.reactionHandler(B,a(d))}return Promise.resolve(void 0)})}}class g{static{this.a=0}set threadId(m){this.n=m}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(m){(m===void 0!=(this.p===void 0)||!m||!this.p||!m.isEqual(this.p))&&(this.p=m,this.b.range=m,this.c.fire())}get range(){return this.p}set canReply(m){this.d!==m&&(this.d=m,this.b.canReply=m,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(m){this.e=m,this.b.label=m,this.c.fire()}get contextValue(){return this.f}set contextValue(m){this.f=m,this.b.contextValue=m,this.c.fire()}get comments(){return this.q}set comments(m){this.q=m,this.b.comments=m,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(m){this.g=m,this.b.collapsibleState=m,this.c.fire()}get state(){return this.h}set state(m){this.h=m,this.b.state=m,this.c.fire()}get isDisposed(){return this.j}constructor(m,I,E,r,d,v,R,B){this.m=I,this.n=E,this.o=r,this.p=d,this.q=v,this.extensionDescription=R,this.r=B,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$ed,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$kc,this.l.value=new L.$ic,this.n===void 0&&(this.n=`${m}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,f.Range.from(this.p),R.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(j){V.range=j},get comments(){return V.comments},set comments(j){V.comments=j},get collapsibleState(){return V.collapsibleState},set collapsibleState(j){V.collapsibleState=j},get canReply(){return V.canReply},set canReply(j){V.canReply=j},get contextValue(){return V.contextValue},set contextValue(j){V.contextValue=j},get label(){return V.label},set label(j){V.label=j},get state(){return V.state},set state(j){V.state=j},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$ic);const m=E=>Object.prototype.hasOwnProperty.call(this.b,E),I={};m("range")&&(I.range=f.Range.from(this.p)),m("label")&&(I.label=this.label),m("contextValue")&&(I.contextValue=this.contextValue??null),m("comments")&&(I.comments=this.q.map(E=>b(this,E,this.k,this.extensionDescription))),m("collapsibleState")&&(I.collapseState=s(this.g)),m("canReply")&&(I.canReply=this.canReply),m("state")&&(I.state=o(this.h)),m("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(m){for(const I of this.k){const E=I[0],r=I[1];if(m===r)return E}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(m=>m.dispose())}}Ke([(0,F.$6g)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class k{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(m){this.b=m,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(m){this.c=m,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this.d}set options(m){this.d=m,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(m,I,E,r){this.f=m,this.g=I,this.h=E,this.i=r,this.a=new Map,i.$registerCommentController(this.handle,E,r);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(v){d.options=v},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(v){d.commentingRangeProvider=v},get reactionHandler(){return d.reactionHandler},set reactionHandler(v){d.reactionHandler=v},createCommentThread(v,R,B){return d.createCommentThread(v,R,B).value},dispose:()=>{d.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(m,I,E){I===void 0&&(0,u.$OF)(this.f,"fileComments");const r=new g(this.id,this.handle,void 0,m,I,E,this.f,!1);return this.a.set(r.handle,r),r}$createCommentThreadTemplate(m,I){const E=new g(this.id,this.handle,void 0,A.URI.revive(m),f.Range.to(I),[],this.f,!0);return E.collapsibleState=l.CommentThreadCollapsibleState.Expanded,this.a.set(E.handle,E),E}$updateCommentThreadTemplate(m,I){const E=this.a.get(m);E&&(E.range=f.Range.to(I))}$deleteCommentThread(m){this.a.get(m)?.dispose(),this.a.delete(m)}getCommentThread(m){return this.a.get(m)}dispose(){this.a.forEach(m=>{m.dispose()}),this.e.forEach(m=>m.dispose())}}function b(y,m,I,E){let r=I.get(m);return r||(r=++y.commentHandle,I.set(m,r)),m.state!==void 0&&(0,u.$OF)(E,"commentsDraftState"),{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:r,body:typeof m.body=="string"?m.body:f.MarkdownString.from(m.body),userName:m.author.name,userIconPath:m.author.iconPath,label:m.label,commentReactions:m.reactions?m.reactions.map(d=>n(d)):void 0,state:m.state,timestamp:m.timestamp?.toJSON()}}function n(y){return{label:y.label,iconPath:y.iconPath?f.$VL(y.iconPath):void 0,count:y.count,hasReacted:y.authorHasReacted}}function a(y){return{label:y.label||"",count:y.count||0,iconPath:y.iconPath?A.URI.revive(y.iconPath):"",authorHasReacted:y.hasReacted||!1}}function s(y){if(y!==void 0)switch(y){case P.CommentThreadCollapsibleState.Expanded:return l.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return l.CommentThreadCollapsibleState.Collapsed}return l.CommentThreadCollapsibleState.Collapsed}function o(y){if(y!==void 0)switch(y){case P.CommentThreadState.Unresolved:return l.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return l.CommentThreadState.Resolved}return l.CommentThreadState.Unresolved}return new c}e.$Xac=p}),define(Ae[227],Re([1,0,24,3,27,17]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=void 0;let A=class{constructor(P,D){this.a=P.getProxy(F.$UJ.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,D){const u=this,p=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){u.e(P,D,p,arguments)}})}e(P,D,u,p){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:S(p,this.b)}),this.c&&this.f(P,u,p)}};e.$Tcc=A,e.$Tcc=A=Ke([Ve(0,L.$WL),Ve(1,C.$aM)],A);const l=1e5;function S(f,P){const D=[];if(f.length)for(let u=0;u<f.length;u++){let p=f[u];if(typeof p>"u")p="undefined";else if(p instanceof Error){const $=p;$.stack?p=$.stack:p=$.toString()}D.push(p)}if(P){const u=new Error().stack;u&&D.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,w.$Zm)(D);return u.length>l?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ae[108],Re([1,0,2,3,7,4,17,14,18,15,19,26]),function(be,e,w,F,C,L,A,l,S,f,P,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=void 0;let p=class{static{u=this}static{this.c=0}static{this.d=250}constructor(h,t){this.h=t,this.f=new Map,this.g=h.getProxy(F.$UJ.MainThreadDecorations)}registerFileDecorationProvider(h,t){const i=u.c++;this.f.set(i,{provider:h,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const c=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(g=>{if(!g){this.g.$onDidChange(i,null);return}const k=(0,S.$Zb)(g);if(k.length<=u.d){this.g.$onDidChange(i,k);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,k.length);const b=k.map(s=>({uri:s,rank:(0,f.$qe)(s.path,"/")})),n=(0,S.$xb)(b,(s,o)=>s.rank-o.rank||(0,f.$Ee)(s.uri.path,o.uri.path)),a=[];e:for(const s of n){let o;for(const y of s){const m=(0,P.$$d)(y.uri.path);if(o!==m&&(o=m,a.push(y.uri)>=u.d))break e}}this.g.$onDidChange(i,a)});return new C.$WJ(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(h,t,i){if(!this.f.has(h))return Object.create(null);const c=Object.create(null),{provider:g,extensionDescription:k}=this.f.get(h);return await Promise.all(t.map(async b=>{try{const{uri:n,id:a}=b,s=await Promise.resolve(g.provideFileDecoration(w.URI.revive(n),i));if(!s)return;try{C.$gL.validate(s),s.badge&&typeof s.badge!="string"&&(0,D.$OF)(k,"codiconDecoration"),c[a]=[s.propagate,s.tooltip,s.badge,s.color]}catch(o){this.h.warn(`INVALID decoration from extension '${k.identifier.value}': ${o}`)}}catch(n){this.h.error(n)}})),c}};e.$Ybc=p,e.$Ybc=p=u=Ke([Ve(0,A.$WL),Ve(1,l.$4i)],p),e.$Zbc=(0,L.$Ah)("IExtHostDecorations")}),define(Ae[228],Re([1,0,148,94,2,3,7,8,5,14,28,39]),function(be,e,w,F,C,L,A,l,S,f,P,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qac=e.$Pac=void 0;class p{#e;#t;#i;constructor(t,i,c,g,k,b,n,a){this.d=t,this.e=i,this.f=c,this.g=g,this.h=k,this.c=!1,this.f=Math.max(g,c),this.#i=new P.$yi(s=>b.getComparisonKey(s)),this.#e=n,this.#t=a}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let c=[];if(C.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),c=[t]}else if(Array.isArray(t)){c=[];let b;t=[...t].sort(p.k);for(const n of t){const[a,s]=n;if((!b||a.toString()!==b.toString())&&(b&&this.#i.get(b).length===0&&this.#i.delete(b),b=a,c.push(a),this.#i.set(a,[])),s)this.#i.get(a)?.push(...s);else{const o=this.#i.get(a);o&&(o.length=0)}}}if(this.#t.fire(c),!this.#e)return;const g=[];let k=0;for(const b of c){let n=[];const a=this.#i.get(b);if(a)if(a.length>this.g){n=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const y of a)if(y.severity===s[o]&&n.push({...l.Diagnostic.from(y),modelVersionId:this.h(b)})===this.g)break e;n.push({severity:F.MarkerSeverity.Info,message:(0,w.localize)(0,null,a.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=a.map(s=>({...l.Diagnostic.from(s),modelVersionId:this.h(b)}));if(g.push([b,n]),k+=n.length,k>this.f)break}this.#e.$changeMany(this.e,g)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[c,g]of this)t.call(i,c,g,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$Pac=p;let $=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(t){const i=new P.$yi;for(const c of t)i.set(c,c);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,c,g){this.j=i,this.k=c,this.l=g,this.g=new Map,this.h=new S.$id({merge:k=>k.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.h.event,u._mapper),this.f=t.getProxy(L.$UJ.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:c,f:g,h:k,j:b,k:n,l:a}=this,s=new class{$changeMany(m,I){g.$changeMany(m,I),b.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,m,I.length===0?"CLEARING":I)}$clear(m){g.$clear(m),b.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,m)}dispose(){g.dispose()}};let o;if(!i)i="_generated_diagnostic_collection_name_#"+u.c++,o=i;else if(!c.has(i))o=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do o=i+u.c++;while(c.has(o))}return new class extends p{constructor(){super(i,o,u.e,u.d,m=>a.getDocument(m)?.version,n.extUri,s,k),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,c=[];for(const g of this.g.values())g.forEach((k,b)=>{let n=i.get(k.toString());typeof n>"u"&&(n=c.length,i.set(k.toString(),n),c.push([k,[]])),c[n][1]=c[n][1].concat(...b)});return c}}m(t){let i=[];for(const c of this.g.values())c.has(t)&&(i=i.concat(c.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",c=new p(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,g=>{},this.k.extUri,void 0,this.h);this.g.set(i,c),this.n=c}for(const[i,c]of t)this.n.set(C.URI.revive(i),c.map(l.Diagnostic.to))}};e.$Qac=$,e.$Qac=$=u=Ke([Ve(1,f.$4i),Ve(2,D.$Oac)],$)}),define(Ae[229],Re([1,0,2,3,26]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ac=void 0;class L{constructor(l){this.a=l.getProxy(F.$UJ.MainThreadDialogs)}showOpenDialog(l,S){return S?.allowUIResources&&(0,C.$OF)(l,"showLocal"),this.a.$showOpenDialog(S).then(f=>f?f.map(P=>w.URI.revive(P)):void 0)}showSaveDialog(l){return this.a.$showSaveDialog(l).then(S=>S?w.URI.revive(S):void 0)}}e.$6ac=L}),define(Ae[230],Re([1,0,9,2,7,3,12,21,15]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ac=void 0;class f{static{this.a=0}constructor(D,u,p){this.d=u,this.e=p,this.b=new Map,this.c=D.getProxy(L.$UJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,u){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const p=f.a++;this.b.set(p,u),this.c.$registerTextContentProvider(p,D);let $;return typeof u.onDidChange=="function"&&($=u.onDidChange(h=>{if(h.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this.d.getDocument(h)&&this.$provideTextDocumentContent(p,h).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(h);if(!i)return;const c=(0,S.$ze)(t);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(h,t)},w.$Y)})),new C.$WJ(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(D,u){const p=this.b.get(D);return p?Promise.resolve(p.provideTextDocumentContent(F.URI.revive(u),l.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$7ac=f}),define(Ae[231],Re([1,0,5,6,2,3,101,8,16,24,7,9]),function(be,e,w,F,C,L,A,l,S,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mac=void 0;class u{constructor($,h){this.a=new w.$ed({onListenerError:D.$Z}),this.b=new w.$ed({onListenerError:D.$Z}),this.c=new w.$ed({onListenerError:D.$Z}),this.d=new w.$ed({onListenerError:D.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$ic,this.h=new Map,this.f=$.getProxy(L.$UJ.MainThreadDocuments),this.g=h,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const h=this.g.getDocument($);if(h)return h}getDocument($){const h=this.getDocumentData($);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return h.document}ensureDocumentData($){const h=this.g.getDocument($);if(h)return Promise.resolve(h);let t=this.h.get($.toString());return t||(t=this.f.$tryOpenDocument($).then(i=>{this.h.delete($.toString());const c=C.URI.revive(i);return(0,S.$tf)(this.g.getDocument(c))},i=>(this.h.delete($.toString()),Promise.reject(i))),this.h.set($.toString(),t)),t}createDocumentData($){return this.f.$tryCreateDocument($).then(h=>C.URI.revive(h))}$acceptModelLanguageChanged($,h){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(h),this.a.fire(i.document)}$acceptModelSaved($){const h=C.URI.revive($),t=this.g.getDocument(h);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(t.document)}$acceptDirtyStateChanged($,h){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(h),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,h,t){const i=C.URI.revive($),c=this.g.getDocument(i);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(h);let g;h.isUndoing?g=P.TextDocumentChangeReason.Undo:h.isRedoing&&(g=P.TextDocumentChangeReason.Redo),this.c.fire((0,f.$Vm)({document:c.document,contentChanges:h.changes.map(k=>({range:l.Range.to(k.range),rangeOffset:k.rangeOffset,rangeLength:k.rangeLength,text:k.text})),reason:g}))}setWordDefinitionFor($,h){(0,A.$YL)($,h)}}e.$Mac=u}),define(Ae[59],Re([1,0,50,5,6,2,4,3,101,17,106,8,14,28,12,66,65]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$7L=void 0;class i{constructor(k){this.value=k,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(k,b){this.h=k,this.i=b,this.a=null,this.b=new Map,this.c=new p.$yi,this.d=new F.$ed,this.e=new F.$ed,this.f=new F.$ed,this.g=new F.$ed,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(k){this.acceptDocumentsAndEditorsDelta(k)}acceptDocumentsAndEditorsDelta(k){const b=[],n=[],a=[];if(k.removedDocuments)for(const s of k.removedDocuments){const o=L.URI.revive(s),y=this.c.get(o);y?.unref()&&(this.c.delete(o),b.push(y.value))}if(k.addedDocuments)for(const s of k.addedDocuments){const o=L.URI.revive(s.uri);let y=this.c.get(o);if(y&&o.scheme!==$.Schemas.vscodeNotebookCell&&o.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);y||(y=new i(new S.$ZL(this.h.getProxy(l.$UJ.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(o,y),n.push(y.value)),y.ref()}if(k.removedEditors)for(const s of k.removedEditors){const o=this.b.get(s);this.b.delete(s),o&&a.push(o)}if(k.addedEditors)for(const s of k.addedEditors){const o=L.URI.revive(s.documentUri);w.ok(this.c.has(o),`document '${o}' does not exist`),w.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const y=this.c.get(o).value,m=new P.$6L(s.id,this.h.getProxy(l.$UJ.MainThreadTextEditors),this.i,new t.$T(()=>y.document),s.selections.map(D.Selection.to),s.options,s.visibleRanges.map(I=>D.Range.to(I)),typeof s.editorPosition=="number"?D.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,m)}k.newActiveEditor!==void 0&&(w.ok(k.newActiveEditor===null||this.b.has(k.newActiveEditor),`active editor '${k.newActiveEditor}' does not exist`),this.a=k.newActiveEditor),(0,C.$ec)(b),(0,C.$ec)(a),k.removedDocuments&&this.e.fire(b),k.addedDocuments&&this.d.fire(n),(k.removedEditors||k.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),k.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(k){return this.c.get(k)?.value}allDocuments(){return h.Iterable.map(this.c.values(),k=>k.value)}getEditor(k){return this.b.get(k)}activeEditor(k){if(!this.a)return;const b=this.b.get(this.a);return k?b:b?.value}allEditors(){return[...this.b.values()]}};e.$7L=c,e.$7L=c=Ke([Ve(0,f.$WL),Ve(1,u.$4i)],c),e.$8L=(0,A.$Ah)("IExtHostDocumentsAndEditors")}),define(Ae[60],Re([1,0,8,3,2,5,4,7,17,16,100]),function(be,e,w,F,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=e.$4bc=void 0,e.$4bc=(0,A.$Ah)("IExtHostEditorTabs");class D{constructor(t,i,c){this.e=c,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new l.$CL(C.URI.revive(this.b.input.uri));case 2:return new l.$DL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new l.$EL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new l.$FL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new l.$GL(this.b.input.viewType);case 4:return new l.$HL(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new l.$IL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new l.$JL;case 9:return new l.$KL(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class u{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const c of t.tabs)c.isActive&&(this.d=c.id),this.c.push(new D(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return w.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(c=>c.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(c=>c.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const c=new D(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,c),t.tabDto.isActive&&(this.d=c.tabId),c}else if(t.kind===1){const c=this.c.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,c),c}const i=this.c.find(c=>c.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let p=class{constructor(t){this.b=new L.$ed,this.c=new L.$ed,this.e=[],this.a=t.getProxy(F.$UJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(c=>c.apiObject))},get activeTabGroup(){const c=t.d;return(0,f.$tf)(t.e.find(k=>k.groupId===c)?.apiObject)},close:async(c,g)=>{const k=Array.isArray(c)?c:[c];return k.length?$(k[0])?this.j(k,g):this.i(k,g):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(s=>s.groupId)),c=new Set(t.map(s=>s.groupId)),g=(0,P.$J)(i,c),k=this.e.filter(s=>g.removed.includes(s.groupId)).map(s=>s.apiObject),b=[],n=[];this.e=t.map(s=>{const o=new u(s,()=>this.d);return g.added.includes(o.groupId)?b.push(o.apiObject):n.push(o.apiObject),o});const a=(0,f.$tf)(t.find(s=>s.isActive===!0)?.groupId);a!==void 0&&this.d!==a&&(this.d=a),this.c.fire(Object.freeze({opened:b,closed:k,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(g=>g.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const c=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(t){for(const i of this.e)for(const c of i.tabs)if(c.apiObject===t)return c}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const c=[];for(const g of t){const k=this.g(g);if(!k)throw new Error("Tab close: Invalid tab not found!");c.push(k.tabId)}return this.a.$closeTab(c,i)}async j(t,i){const c=[];for(const g of t){const k=this.h(g);if(!k)throw new Error("Group close: Invalid group not found!");c.push(k.groupId)}return this.a.$closeGroup(c,i)}};e.$5bc=p,e.$5bc=p=Ke([Ve(0,S.$WL)],p);function $(h){return h.tabs!==void 0}}),define(Ae[232],Re([1,0,3,7]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$UJ.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,l,S){if(this.a.size===0)throw new Error("No embedding vector providers registered");const f=this.a.get(A);if(!f)throw new Error("Embedding vector provider not found");const P=await f.provideEmbeddingVector(l,S);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,l,S){const f=this.b;return this.b++,this.a.set(f,S),this.c.$registerAiEmbeddingVectorProvider(l,f),new F.$WJ(()=>{this.c.$unregisterAiEmbeddingVectorProvider(f),this.a.delete(f)})}}e.$Qcc=C}),define(Ae[233],Re([1,0,2,3,6,7,8,279,15,25,26,49]),function(be,e,w,F,C,L,A,l,S,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=void 0;class u{constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const t=this.a.indexOf(h);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),t=[];let i,c,g=14,k=14;for(const b of h){let n=i?(0,S.$Ne)(i,b):0;for(n===0?c=1:c=k;n<b.length;n++)n+1===b.length?(g=k,k=9):k+=1,t.push([c,b.toUpperCase().charCodeAt(n),k]),t.push([c,b.toLowerCase().charCodeAt(n),k]),c=k;i=b,k=g}t.push([9,58,10]),t.push([10,47,12]),this.b=new l.$oY(t)}}provideDocumentLinks(h){this.c();const t=[],i=l.$pY.computeLinks({getLineContent(c){return h.lineAt(c-1).text},getLineCount(){return h.lineCount}},this.b);for(const c of i){const g=A.DocumentLink.to(c);g.target&&t.push(g)}return t}}class p{constructor(h,t){this.i=t,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(F.$UJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,t,i,c={}){if(p.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const g=this.h++;this.b.add(t),this.d.add(t),this.c.set(g,i);let k=2;c.isCaseSensitive&&(k+=1024),c.isReadonly&&(k+=2048),typeof i.copy=="function"&&(k+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.$OF)(h,"fsChunks"),k+=4);let b;c.isReadonly&&(0,D.$Yj)(c.isReadonly)&&((0,P.$OF)(h,"readonlyMessage"),b={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(g,t,k,b).catch(a=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${t}`),console.error(a)});const n=i.onDidChangeFile(a=>{const s=[];for(const o of a){const{uri:y,type:m}=o;if(y.scheme!==t)continue;let I;switch(m){case L.FileChangeType.Changed:I=0;break;case L.FileChangeType.Created:I=1;break;case L.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:y,type:I})}this.a.$onFileSystemChange(g,s)});return(0,C.$hc)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(g),this.a.$unregisterProvider(g)})}static j(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static k(h){const{type:t,ctime:i,mtime:c,size:g,permissions:k}=h;return{type:t,ctime:i,mtime:c,size:g,permissions:k}}$stat(h,t){return Promise.resolve(this.l(h).stat(w.URI.revive(t))).then(i=>p.k(i))}$readdir(h,t){return Promise.resolve(this.l(h).readDirectory(w.URI.revive(t)))}$readFile(h,t){return Promise.resolve(this.l(h).readFile(w.URI.revive(t))).then(i=>f.$Ed.wrap(i))}$writeFile(h,t,i,c){return Promise.resolve(this.l(h).writeFile(w.URI.revive(t),i.buffer,c))}$delete(h,t,i){return Promise.resolve(this.l(h).delete(w.URI.revive(t),i))}$rename(h,t,i,c){return Promise.resolve(this.l(h).rename(w.URI.revive(t),w.URI.revive(i),c))}$copy(h,t,i,c){const g=this.l(h);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(w.URI.revive(t),w.URI.revive(i),c))}$mkdir(h,t){return Promise.resolve(this.l(h).createDirectory(w.URI.revive(t)))}$watch(h,t,i,c){const g=this.l(h).watch(w.URI.revive(i),c);this.f.set(t,g)}$unwatch(h,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(h,t,i){const c=this.l(h);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(w.URI.revive(t),i))}$close(h,t){const i=this.l(h);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(h,t,i,c){const g=this.l(h);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const k=f.$Ed.alloc(c);return Promise.resolve(g.read(t,i,k.buffer,0,c)).then(b=>k.slice(0,b))}$write(h,t,i,c){const g=this.l(h);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(t,i,c.buffer,0,c.byteLength))}l(h){const t=this.c.get(h);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$Abc=p}),define(Ae[61],Re([1,0,3,38,7,25,4,17,39,6,13,23,12]),function(be,e,w,F,C,L,A,l,S,f,P,D,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=e.$gbc=void 0;let $=p=class{constructor(t,i){this.b=new Map,this.c=new P.$Og,this.a=t.getProxy(w.$UJ.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(g){try{let k;const b=c.b.get(g.scheme);return b?(await c.a.$ensureActivation(g.scheme),k=await b.impl.stat(g)):k=await c.a.$stat(g),{type:k.type,ctime:k.ctime,mtime:k.mtime,size:k.size,permissions:k.permissions===F.FilePermission.Readonly?1:void 0}}catch(k){p.e(k)}},async readDirectory(g){try{const k=c.b.get(g.scheme);return k?(await c.a.$ensureActivation(g.scheme),(await k.impl.readDirectory(g)).slice()):await c.a.$readdir(g)}catch(k){return p.e(k)}},async createDirectory(g){try{const k=c.b.get(g.scheme);return k&&!k.isReadonly?(await c.a.$ensureActivation(g.scheme),await c.d(k.impl,k.extUri,g)):await c.a.$mkdir(g)}catch(k){return p.e(k)}},async readFile(g){try{const k=c.b.get(g.scheme);return k?(await c.a.$ensureActivation(g.scheme),(await k.impl.readFile(g)).slice()):(await c.a.$readFile(g)).buffer}catch(k){return p.e(k)}},async writeFile(g,k){try{const b=c.b.get(g.scheme);return b&&!b.isReadonly?(await c.a.$ensureActivation(g.scheme),await c.d(b.impl,b.extUri,b.extUri.dirname(g)),await c.c.queueFor(g).queue(()=>Promise.resolve(b.impl.writeFile(g,k,{create:!0,overwrite:!0})))):await c.a.$writeFile(g,L.$Ed.wrap(k))}catch(b){return p.e(b)}},async delete(g,k){try{const b=c.b.get(g.scheme);return b&&!b.isReadonly?(await c.a.$ensureActivation(g.scheme),await b.impl.delete(g,{recursive:!1,...k})):await c.a.$delete(g,{recursive:!1,useTrash:!1,atomic:!1,...k})}catch(b){return p.e(b)}},async rename(g,k,b){try{return await c.a.$rename(g,k,{overwrite:!1,...b})}catch(n){return p.e(n)}},async copy(g,k,b){try{return await c.a.$copy(g,k,{overwrite:!1,...b})}catch(n){return p.e(n)}},isWritableFileSystem(g){const k=i.getCapabilities(g);if(typeof k=="number")return!(k&2048)}})}async d(t,i,c){const g=[];for(;!i.isEqual(c,i.dirname(c));)try{if(!((await t.stat(c)).type&F.FileType.Directory))throw C.$$K.FileExists(`Unable to create folder '${c.scheme===u.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(k){if(F.$hk(k)!==F.FileSystemProviderErrorCode.FileNotFound)throw k;g.push(i.basename(c)),c=i.dirname(c)}for(let k=g.length-1;k>=0;k--){c=i.joinPath(c,g[k]);try{await t.createDirectory(c)}catch(b){if(F.$hk(b)!==F.FileSystemProviderErrorCode.FileExists)throw b}}}static e(t){if(t instanceof C.$$K)throw t;if(t instanceof F.$dk)switch(t.code){case F.FileSystemProviderErrorCode.FileExists:throw C.$$K.FileExists(t.message);case F.FileSystemProviderErrorCode.FileNotFound:throw C.$$K.FileNotFound(t.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw C.$$K.FileNotADirectory(t.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw C.$$K.FileIsADirectory(t.message);case F.FileSystemProviderErrorCode.NoPermissions:throw C.$$K.NoPermissions(t.message);case F.FileSystemProviderErrorCode.Unavailable:throw C.$$K.Unavailable(t.message);default:throw new C.$$K(t.message,t.name)}if(!(t instanceof Error))throw new C.$$K(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$$K.Unavailable(t.message);switch(t.name){case F.FileSystemProviderErrorCode.FileExists:throw C.$$K.FileExists(t.message);case F.FileSystemProviderErrorCode.FileNotFound:throw C.$$K.FileNotFound(t.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw C.$$K.FileNotADirectory(t.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw C.$$K.FileIsADirectory(t.message);case F.FileSystemProviderErrorCode.NoPermissions:throw C.$$K.NoPermissions(t.message);case F.FileSystemProviderErrorCode.Unavailable:throw C.$$K.Unavailable(t.message);default:throw new C.$$K(t.message,t.name)}}addFileSystemProvider(t,i,c){return this.b.set(t,{impl:i,extUri:c?.isCaseSensitive?D.$0f:D.$_f,isReadonly:!!c?.isReadonly}),(0,f.$hc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??D.$0f}};e.$gbc=$,e.$gbc=$=p=Ke([Ve(0,l.$WL),Ve(1,S.$Oac)],$),e.$hbc=(0,A.$Ah)("IExtHostConsumerFileSystem")}),define(Ae[234],Re([1,0,5,37,2,3,8,7]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=void 0;class S{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(D,u,p,$,h,t,i,c){this.a=new w.$ed,this.b=new w.$ed,this.c=new w.$ed;const g=this.h(D,p,h);this.g=0,t&&(this.g+=1),i&&(this.g+=2),c&&(this.g+=4);const k=(0,F.$qj)(h),b=typeof h=="string",n=$(a=>{if(!t)for(const s of a.created){const o=C.URI.revive(s);k(o.fsPath)&&(!b||u.getWorkspaceFolder(o))&&this.a.fire(o)}if(!i)for(const s of a.changed){const o=C.URI.revive(s);k(o.fsPath)&&(!b||u.getWorkspaceFolder(o))&&this.b.fire(o)}if(!c)for(const s of a.deleted){const o=C.URI.revive(s);k(o.fsPath)&&(!b||u.getWorkspaceFolder(o))&&this.c.fire(o)}});this.d=l.$WJ.from(g,this.a,this.b,this.c,n)}h(D,u,p){const $=l.$WJ.from();if(typeof p=="string")return $;const h=D.getProxy(L.$UJ.MainThreadFileSystem);let t=!1;(p.pattern.includes(F.$mj)||p.pattern.includes(F.$nj))&&(t=!0);const i=Math.random();return h.$watch(u.identifier.value,i,p.baseUri,{recursive:t,excludes:[]}),l.$WJ.from({dispose:()=>h.$unwatch(i)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class f{constructor(D,u,p){this.j=D,this.k=u,this.l=p,this.a=new w.$ed,this.b=new w.$ed,this.c=new w.$ed,this.d=new w.$ed,this.g=new w.$gd,this.h=new w.$gd,this.i=new w.$gd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,u,p,$,h,t){return new S(this.j,D,u,this.a.event,A.GlobPattern.from(p),$,h,t)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,u){switch(D){case 2:this.b.fire(Object.freeze({files:u.map(p=>({oldUri:C.URI.revive(p.source),newUri:C.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:u.map(p=>C.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:u.map(p=>C.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,u){return(p,$,h)=>{const t=function(c){p.call($,c)};return t.extension=D,u.event(t,void 0,h)}}async $onWillRunFileOperation(D,u,p,$){switch(D){case 2:return await this.n(this.g,{files:u.map(h=>({oldUri:C.URI.revive(h.source),newUri:C.URI.revive(h.target)}))},p,$);case 1:return await this.n(this.i,{files:u.map(h=>C.URI.revive(h.target))},p,$);case 0:case 3:return await this.n(this.h,{files:u.map(h=>C.URI.revive(h.target))},p,$)}}async n(D,u,p,$){const h=new Set,t=[];if(await D.fireAsync(u,$,async(c,g)=>{const k=Date.now(),b=await Promise.resolve(c);b instanceof l.$7J&&(t.push([g.extension,b]),h.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-k>p&&this.k.warn("SLOW file-participant",g.extension.identifier)}),$.isCancellationRequested||t.length===0)return;const i={edits:[]};for(const[,c]of t){const{edits:g}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:k=>this.l.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(g)}return{edit:i,extensionNames:Array.from(h)}}}e.$Bbc=f}),define(Ae[235],Re([1,0,6,2,3,8,7,31]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;class S{static{this.a=0}constructor(u,p){this.extension=u,this.provider=p,this.handle=S.a++}}class f{constructor(u){this.session=u,this.responses=[]}}class P{static{this.a=0}constructor(u,p,$,h){this.f=$,this.g=h,this.b=new Map,this.d=new Map,this.e=u.getProxy(C.$UJ.MainThreadInlineChat),p.registerApiCommand(new l.$kM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new l.$iM("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?L.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?L.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?L.Position.from(t.position):void 0}})],l.$jM.Void))}registerProvider(u,p,$){const h=new S(u,p);return this.b.set(h.handle,h),this.e.$registerInteractiveEditorProvider(h.handle,$.label,u.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,w.$hc)(()=>{this.e.$unregisterInteractiveEditorProvider(h.handle),this.b.delete(h.handle)})}async $prepareSession(u,p,$,h){const t=this.b.get(u);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(F.URI.revive(p)),c=L.Selection.to($),g=await t.provider.prepareInteractiveEditorSession({document:i,selection:c},h);if(!g)return;if(g.wholeRange&&!g.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const k=P.a++;return this.d.set(k,new f(g)),{id:k,placeholder:g.placeholder,slashCommands:g.slashCommands?.map(b=>({command:b.command,detail:b.detail,refer:b.refer,executeImmediately:b.executeImmediately})),wholeRange:L.Range.from(g.wholeRange),message:g.message}}async $provideResponse(u,p,$,h){const t=this.b.get(u);if(!t)return;const i=this.d.get(p.id);if(!i)return;const c={prompt:$.prompt,selection:L.Selection.to($.selection),wholeRange:L.Range.to($.wholeRange),attempt:$.attempt,live:$.live};let g=!1;const k={report:a=>{if(!$.live)throw new Error("Progress reporting is only supported for live sessions");g||h.isCancellationRequested||!a.message&&!a.edits||this.e.$handleProgressChunk($.requestId,{message:a.message,edits:a.edits?.map(L.TextEdit.from)})}},b=t.provider.provideInteractiveEditorResponse(i.session,c,k,h);Promise.resolve(b).finally(()=>g=!0);const n=await b;if(n){const a=i.responses.push(n)-1,s={wholeRange:L.Range.from(n.wholeRange),placeholder:n.placeholder};if(P.h(n))return{...s,id:a,type:"message",message:L.MarkdownString.from(n.contents)};const{edits:o}=n;if(o instanceof A.$7J)return{...s,id:a,type:"bulkEdit",edits:L.WorkspaceEdit.from(o)};if(Array.isArray(o))return{...s,id:a,type:"editorEdit",edits:o.map(L.TextEdit.from)}}}$handleFeedback(u,p,$,h){const t=this.b.get(u),i=this.d.get(p),c=i?.responses[$];if(t&&c){const g=L.InteractiveEditorResponseFeedbackKind.to(h);t.provider.handleInteractiveEditorResponseFeedback?.(i.session,c,g)}}$releaseSession(u,p){}static h(u){return typeof u=="object"&&typeof u.contents=="object"}}e.$Icc=P}),define(Ae[236],Re([1,0,2,31]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class C{constructor(A,l,S,f,P){this.a=l,this.b=S,this.c=f;const D=new F.$kM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$iM("showOptions","Show Options",u=>!0,u=>u),new F.$iM("resource","Interactive resource Uri",u=>!0,u=>u),new F.$iM("controllerId","Notebook controller Id",u=>!0,u=>u),new F.$iM("title","Interactive editor title",u=>!0,u=>u)],new F.$jM("Notebook and input URI",u=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const p=this.a.getEditorById(u.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:w.URI.revive(u.notebookUri),inputUri:w.URI.revive(u.inputUri),notebookEditor:p.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:w.URI.revive(u.notebookUri),inputUri:w.URI.revive(u.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(A,l,S,f){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:l,lines:[""],languageId:S,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(w.URI.revive(f))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,l){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Ecc=C}),define(Ae[237],Re([1,0,3,7]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(w.$UJ.MainThreadIssueReporter)}async $getIssueReporterUri(A,l){if(this.a.size===0)throw new Error("No issue request handlers registered");const S=this.a.get(A);if(!S)throw new Error("Issue request handler not found");const f=await S.handleIssueUrlRequest();if(!f)throw new Error("Issue request handler returned no result");return f}registerIssueUriRequestHandler(A,l){const S=A.identifier.value;return this.a.set(S,l),this.b.$registerIssueUriRequestHandler(S),new F.$WJ(()=>{this.b.$unregisterIssueUriRequestHandler(S),this.a.delete(S)})}}e.$Kcc=C}),define(Ae[238],Re([1,0,6,3]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(F.$UJ.MainThreadLabelService)}$registerResourceLabelFormatter(A){const l=this.b++;return this.a.$registerResourceLabelFormatter(l,A),(0,w.$hc)(()=>{this.a.$unregisterResourceLabelFormatter(l)})}}e.$Xbc=C}),define(Ae[239],Re([1,0,2,24,8,7,78,3,15,44,18,16,280,21,20,6,91,88,54,58,9,13,26,150]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t,i,c,g,k,b,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uac=void 0;class s{constructor(M,K){this.d=M,this.e=K}async provideDocumentSymbols(M,K){const G=this.d.getDocument(M),Y=await this.e.provideDocumentSymbols(G,K);if(!(0,P.$Hb)(Y))return Y[0]instanceof L.$cK?Y.map(C.DocumentSymbol.from):s.f(Y)}static f(M){M=M.slice(0).sort((Y,J)=>{let x=Y.location.range.start.compareTo(J.location.range.start);return x===0&&(x=J.location.range.end.compareTo(Y.location.range.end)),x});const K=[],G=[];for(const Y of M){const J={name:Y.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Y.kind),tags:Y.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:Y.containerName,range:C.Range.from(Y.location.range),selectionRange:C.Range.from(Y.location.range),children:[]};for(;;){if(G.length===0){G.push(J),K.push(J);break}const x=G[G.length-1];if(f.$is.containsRange(x.range,J.range)&&!f.$is.equalsRange(x.range,J.range)){x.children?.push(J),G.push(J);break}G.pop()}}return K}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(M,K,G){this.g=M,this.h=K,this.j=G,this.e=new c.$Lac("CodeLens"),this.f=new Map}async provideCodeLenses(M,K){const G=this.g.getDocument(M),Y=await this.j.provideCodeLenses(G,K);if(!Y||K.isCancellationRequested)return;const J=this.e.add(Y),x=new h.$ic;this.f.set(J,x);const ae={cacheId:J,lenses:[]};for(let Le=0;Le<Y.length;Le++)ae.lenses.push({cacheId:[J,Le],range:C.Range.from(Y[Le].range),command:this.h.toInternal(Y[Le].command,x)});return ae}async resolveCodeLens(M,K){const G=M.cacheId&&this.e.get(...M.cacheId);if(!G)return;let Y;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?Y=G:Y=await this.j.resolveCodeLens(G,K),Y||(Y=G),K.isCancellationRequested)return;const J=M.cacheId&&this.f.get(M.cacheId[0]);if(J)return M.command=this.h.toInternal(Y.command??o.d,J),M}releaseCodeLenses(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}}function y(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class m{constructor(M,K){this.d=M,this.e=K}async provideDefinition(M,K,G){const Y=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideDefinition(Y,J,G);return y(x)}}class I{constructor(M,K){this.d=M,this.e=K}async provideDeclaration(M,K,G){const Y=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideDeclaration(Y,J,G);return y(x)}}class E{constructor(M,K){this.d=M,this.e=K}async provideImplementation(M,K,G){const Y=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideImplementation(Y,J,G);return y(x)}}class r{constructor(M,K){this.d=M,this.e=K}async provideTypeDefinition(M,K,G){const Y=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideTypeDefinition(Y,J,G);return y(x)}}class d{constructor(M,K){this.d=M,this.e=K}async provideHover(M,K,G){const Y=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideHover(Y,J,G);if(!(!x||(0,P.$Hb)(x.contents)))return x.range||(x.range=Y.getWordRangeAtPosition(J)),x.range||(x.range=new L.$YJ(J,J)),C.Hover.from(x)}}class v{constructor(M,K){this.d=M,this.e=K}async provideEvaluatableExpression(M,K,G){const Y=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideEvaluatableExpression(Y,J,G);if(x)return C.EvaluatableExpression.from(x)}}class R{constructor(M,K){this.d=M,this.e=K}async provideInlineValues(M,K,G,Y){const J=this.d.getDocument(M),x=await this.e.provideInlineValues(J,C.Range.to(K),C.InlineValueContext.to(G),Y);if(Array.isArray(x))return x.map(ae=>C.InlineValue.from(ae))}}class B{constructor(M,K){this.d=M,this.e=K}async provideDocumentHighlights(M,K,G){const Y=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideDocumentHighlights(Y,J,G);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class V{constructor(M,K){this.d=M,this.e=K}async provideLinkedEditingRanges(M,K,G){const Y=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideLinkedEditingRanges(Y,J,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,P.$Eb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class j{constructor(M,K){this.d=M,this.e=K}async provideReferences(M,K,G,Y){const J=this.d.getDocument(M),x=C.Position.to(K),ae=await this.e.provideReferences(J,x,G,Y);if(Array.isArray(ae))return ae.map(C.location.from)}}class W{static{this.d=1e3}constructor(M,K,G,Y,J,x,ae){this.h=M,this.j=K,this.k=G,this.l=Y,this.m=J,this.n=x,this.o=ae,this.e=new c.$Lac("CodeAction"),this.f=new Map,this.g=new L.$eK("notebook")}async provideCodeActions(M,K,G,Y){const J=this.h.getDocument(M),x=u.$ks.isISelection(K)?C.Selection.to(K):C.Range.to(K),ae=[];for(const Ze of this.k.getDiagnostics(M))if(x.intersection(Ze.range)&&ae.push(Ze)>W.d)break;const Le={diagnostics:ae,only:G.only?new L.$eK(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},Ue=await this.l.provideCodeActions(J,x,Le,Y);if(!(0,P.$Ib)(Ue)||Y.isCancellationRequested)return;const Ye=this.e.add(Ue),He=new h.$ic;this.f.set(Ye,He);const et=[];for(let Ze=0;Ze<Ue.length;Ze++){const _e=Ue[Ze];if(_e)if(W.p(_e))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:_e.title,command:this.j.toInternal(_e,He)});else{if(Le.triggerKind!==L.CodeActionTriggerKind.Invoke&&_e.kind&&this.g.contains(_e.kind))continue;Le.only&&(_e.kind?Le.only.contains(_e.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[Ye,Ze],title:_e.title,command:_e.command&&this.j.toInternal(_e.command,He),diagnostics:_e.diagnostics&&_e.diagnostics.map(C.Diagnostic.from),edit:_e.edit&&C.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})}}return{cacheId:Ye,actions:et}}async resolveCodeAction(M,K){const[G,Y]=M,J=this.e.get(G,Y);if(!J||W.p(J))return{};if(!this.l.resolveCodeAction)return{};const x=await this.l.resolveCodeAction(J,K)??J;let ae;x.edit&&(ae=C.WorkspaceEdit.from(x.edit,void 0));let Le;if(x.command){const Ue=this.f.get(G);Ue&&(Le=this.j.toInternal(x.command,Ue))}return{edit:ae,command:Le}}releaseCodeActions(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}static p(M){return typeof M.command=="string"&&typeof M.title=="string"}}class O{static toInternalProviderId(M,K){return M+"."+K}constructor(M,K,G,Y,J){this.d=M,this.e=K,this.f=G,this.g=Y,this.h=J}async prepareDocumentPaste(M,K,G,Y){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(M),x=K.map(Ue=>C.Range.to(Ue)),ae=C.DataTransfer.toDataTransfer(G,()=>{throw new k.$9});if(await this.f.prepareDocumentPaste(J,x,ae,Y),Y.isCancellationRequested)return;const Le=Array.from(ae).filter(([,Ue])=>!(Ue instanceof L.$LK));return C.DataTransfer.from(Le)}async providePasteEdits(M,K,G,Y,J){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(K),ae=G.map(Ye=>C.Range.to(Ye)),Le=C.DataTransfer.toDataTransfer(Y,async Ye=>(await this.d.$resolvePasteFileData(this.g,M,Ye)).buffer),Ue=await this.f.provideDocumentPasteEdits(x,ae,Le,J);if(Ue)return{label:Ue.label??(0,a.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:O.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class z{constructor(M,K){this.d=M,this.e=K}async provideDocumentFormattingEdits(M,K,G){const Y=this.d.getDocument(M),J=await this.e.provideDocumentFormattingEdits(Y,K,G);if(Array.isArray(J))return J.map(C.TextEdit.from)}}class ee{constructor(M,K){this.d=M,this.e=K}async provideDocumentRangeFormattingEdits(M,K,G,Y){const J=this.d.getDocument(M),x=C.Range.to(K),ae=await this.e.provideDocumentRangeFormattingEdits(J,x,G,Y);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(M,K,G,Y){(0,D.$sf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const J=this.d.getDocument(M),x=K.map(C.Range.to),ae=await this.e.provideDocumentRangesFormattingEdits(J,x,G,Y);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}}class X{constructor(M,K){this.d=M,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,K,G,Y,J){const x=this.d.getDocument(M),ae=C.Position.to(K),Le=await this.e.provideOnTypeFormattingEdits(x,ae,G,Y,J);if(Array.isArray(Le))return Le.map(C.TextEdit.from)}}class Ee{constructor(M,K){this.e=M,this.f=K,this.d=new c.$Lac("WorkspaceSymbols")}async provideWorkspaceSymbols(M,K){const G=await this.e.provideWorkspaceSymbols(M,K);if(!(0,P.$Ib)(G))return{symbols:[]};const Y=this.d.add(G),J={cacheId:Y,symbols:[]};for(let x=0;x<G.length;x++){const ae=G[x];if(!ae||!ae.name){this.f.warn("INVALID SymbolInformation",ae);continue}J.symbols.push({...C.WorkspaceSymbol.from(ae),cacheId:[Y,x]})}return J}async resolveWorkspaceSymbol(M,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const G=this.d.get(...M.cacheId);if(G){const Y=await this.e.resolveWorkspaceSymbol(G,K);return Y&&(0,F.$Xm)(M,C.WorkspaceSymbol.from(Y),!0)}}releaseWorkspaceSymbols(M){this.d.delete(M)}}class ke{static supportsResolving(M){return typeof M.prepareRename=="function"}constructor(M,K,G){this.d=M,this.e=K,this.f=G}async provideRenameEdits(M,K,G,Y){const J=this.d.getDocument(M),x=C.Position.to(K);try{const ae=await this.e.provideRenameEdits(J,x,G,Y);return ae?C.WorkspaceEdit.from(ae):void 0}catch(ae){const Le=ke.g(ae);return Le?{rejectReason:Le,edits:void 0}:Promise.reject(ae)}}async resolveRenameLocation(M,K,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Y=this.d.getDocument(M),J=C.Position.to(K);try{const x=await this.e.prepareRename(Y,J,G);let ae,Le;if(L.$YJ.isRange(x)?(ae=x,Le=Y.getText(x)):(0,D.$kf)(x)&&(ae=x.range,Le=x.placeholder),!ae||!Le)return;if(ae.start.line>J.line||ae.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ae),text:Le}}catch(x){const ae=ke.g(x);return ae?{rejectReason:ae,range:void 0,text:void 0}:Promise.reject(x)}}static g(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class Pe{constructor(M,K){this.resultId=M,this.tokens=K}}class Z{constructor(M,K){this.f=M,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(M,K,G){const Y=this.f.getDocument(M),J=K!==0?this.d.get(K):null;let x=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Y,J.resultId,G):await this.g.provideDocumentSemanticTokens(Y,G);return J&&this.d.delete(K),x?(x=Z.h(x),this.o(Z.n(J,x),x)):null}async releaseDocumentSemanticColoring(M){this.d.delete(M)}static h(M){return Z.j(M)?Z.k(M)?M:new L.$cL(new Uint32Array(M.data),M.resultId):Z.l(M)?Z.m(M)?M:new L.$eL(M.edits.map(K=>new L.$dL(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),M.resultId):M}static j(M){return M&&!!M.data}static k(M){return M.data instanceof Uint32Array}static l(M){return M&&Array.isArray(M.edits)}static m(M){for(const K of M.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(M,K){if(!Z.j(K)||!M||!M.tokens)return K;const G=M.tokens,Y=G.length,J=K.data,x=J.length;let ae=0;const Le=Math.min(Y,x);for(;ae<Le&&G[ae]===J[ae];)ae++;if(ae===Y&&ae===x)return new L.$eL([],K.resultId);let Ue=0;const Ye=Le-ae;for(;Ue<Ye&&G[Y-Ue-1]===J[x-Ue-1];)Ue++;return new L.$eL([{start:ae,deleteCount:Y-ae-Ue,data:J.subarray(ae,x-Ue)}],K.resultId)}o(M,K){if(Z.j(M)){const G=this.e++;return this.d.set(G,new Pe(M.resultId,M.data)),(0,t.$k0)({id:G,type:"full",data:M.data})}if(Z.l(M)){const G=this.e++;return Z.j(K)?this.d.set(G,new Pe(K.resultId,K.data)):this.d.set(G,new Pe(M.resultId)),(0,t.$k0)({id:G,type:"delta",deltas:(M.edits||[]).map(Y=>({start:Y.start,deleteCount:Y.deleteCount,data:Y.data}))})}return null}}class ue{constructor(M,K){this.d=M,this.e=K}async provideDocumentRangeSemanticTokens(M,K,G){const Y=this.d.getDocument(M),J=await this.e.provideDocumentRangeSemanticTokens(Y,C.Range.to(K),G);return J?this.f(J):null}f(M){return(0,t.$k0)({id:0,type:"full",data:M.data})}}class ye{static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}constructor(M,K,G,Y,J){this.f=M,this.g=K,this.h=G,this.j=Y,this.k=J,this.d=new c.$Lac("CompletionItem"),this.e=new Map}async provideCompletionItems(M,K,G,Y){const J=this.f.getDocument(M),x=C.Position.to(K),ae=J.getWordRangeAtPosition(x)||new L.$YJ(x,x),Le=ae.with({end:x}),Ue=new g.$ad,Ye=await this.h.provideCompletionItems(J,x,Y,C.CompletionContext.to(G));if(!Ye||Y.isCancellationRequested)return;const He=Array.isArray(Ye)?new L.$sK(Ye):Ye,et=ye.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),Ze=new h.$ic;this.e.set(et,Ze);const _e=[],it={x:et,b:_e,a:{replace:C.Range.from(ae),insert:C.Range.from(Le)},c:He.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<He.items.length;tt++){const Ne=He.items[tt],st=this.l(Ne,[et,tt],Le,ae);_e.push(st)}return it}async resolveCompletionItem(M,K){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...M);if(!G)return;const Y=this.l(G,M),J=await this.h.resolveCompletionItem(G,K);if(!J)return;const x=this.l(J,M);return(Y.h!==x.h||Y.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Y.n!==x.n||Y.o!==x.o||!(0,F.$Ym)(Y.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Y,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,K,G,Y){const J=this.e.get(K[0]);if(!J)throw Error("DisposableStore is missing...");const x=this.g.toInternal(M.command,J),ae={x:K,a:M.label,b:M.kind!==void 0?C.CompletionItemKind.from(M.kind):void 0,m:M.tags&&M.tags.map(C.CompletionItemTag.from),c:M.detail,d:typeof M.documentation>"u"?void 0:C.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters?.join(""),l:M.additionalTextEdits&&M.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};M.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=M.textEdit.newText):typeof M.insertText=="string"?ae.h=M.insertText:M.insertText instanceof L.$8J&&(ae.h=M.insertText.value,ae.i|=4);let Le;return M.textEdit?Le=M.textEdit.range:M.range&&(Le=M.range),L.$YJ.isRange(Le)?ae.j=C.Range.from(Le):Le&&(!G?.isEqual(Le.inserting)||!Y?.isEqual(Le.replacing))&&(ae.j={insert:C.Range.from(Le.inserting),replace:C.Range.from(Le.replacing)}),ae}}class ce{async provideInlineCompletions(M,K,G,Y){}disposeCompletions(M){}handleDidShowCompletionItem(M,K,G){}handlePartialAccept(M,K,G){}}class $e extends ce{constructor(M,K,G,Y){super(),this.f=M,this.g=K,this.h=G,this.j=Y,this.d=new ie,this.e=(0,n.$NF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$NF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(M,K,G,Y){const J=this.g.getDocument(M),x=C.Position.to(K),ae=await this.h.provideInlineCompletionItems(J,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Y);if(!ae||Y.isCancellationRequested)return;const Le=Array.isArray(ae)?ae:ae.items,Ue=this.e?Array.isArray(ae)?[]:ae.commands||[]:[],Ye=this.e&&!Array.isArray(ae)?ae.enableForwardStability:void 0;let He;return{pid:this.d.createReferenceId({dispose(){He?.dispose()},items:Le}),items:Le.map((Ze,_e)=>{let it;Ze.command&&(He||(He=new h.$ic),it=this.j.toInternal(Ze.command,He));const tt=Ze.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ze.filterText,range:Ze.range?C.Range.from(Ze.range):void 0,command:it,idx:_e,completeBracketPairs:this.e?Ze.completeBracketPairs:!1}}),commands:Ue.map(Ze=>(He||(He=new h.$ic),this.j.toInternal(Ze,He))),suppressSuggestions:!1,enableForwardStability:Ye}}disposeCompletions(M){this.d.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,K,G){const Y=this.d.get(M)?.items[K];Y&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Y,G)}handlePartialAccept(M,K,G){const Y=this.d.get(M)?.items[K];Y&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Y,G)}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(M){const K=this.e++;return this.d.set(K,M),K}disposeReferenceId(M){const K=this.d.get(M);return this.d.delete(M),K}get(M){return this.d.get(M)}}class N{constructor(M,K){this.e=M,this.f=K,this.d=new c.$Lac("SignatureHelp")}async provideSignatureHelp(M,K,G,Y){const J=this.e.getDocument(M),x=C.Position.to(K),ae=this.g(G),Le=await this.f.provideSignatureHelp(J,x,Y,ae);if(Le){const Ue=this.d.add([Le]);return{...C.SignatureHelp.from(Le),id:Ue}}}g(M){let K;if(M.activeSignatureHelp){const G=C.SignatureHelp.to(M.activeSignatureHelp),Y=this.d.get(M.activeSignatureHelp.id,0);Y?(K=Y,K.activeSignature=G.activeSignature,K.activeParameter=G.activeParameter):K=G}return{...M,activeSignatureHelp:K}}releaseSignatureHelp(M){this.d.delete(M)}}class q{constructor(M,K,G,Y,J){this.f=M,this.g=K,this.h=G,this.j=Y,this.k=J,this.d=new c.$Lac("InlayHints"),this.e=new Map}async provideInlayHints(M,K,G){const Y=this.f.getDocument(M),J=C.Range.to(K),x=await this.h.provideInlayHints(Y,J,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${K}`);return}if(G.isCancellationRequested)return;const ae=this.d.add(x);this.e.set(ae,new h.$ic);const Le={hints:[],cacheId:ae};for(let Ue=0;Ue<x.length;Ue++)this.l(x[Ue],J)&&Le.hints.push(this.m(x[Ue],[ae,Ue]));return this.j.trace(`[InlayHints] ${Le.hints.length} inlay hints from '${this.k.identifier.value}' for ${K}`),Le}async resolveInlayHint(M,K){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...M);if(!G)return;const Y=await this.h.resolveInlayHint(G,K);if(Y&&this.l(Y))return this.m(Y,M)}releaseHints(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,K){return M.label.length===0||Array.isArray(M.label)&&M.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(K&&!K.contains(M.position))}m(M,K){const G=this.e.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const Y={label:"",cacheId:K,tooltip:C.MarkdownString.fromStrict(M.tooltip),position:C.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(C.TextEdit.from),kind:M.kind&&C.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?Y.label=M.label:Y.label=M.label.map(J=>{const x={label:J.value};return x.tooltip=C.MarkdownString.fromStrict(J.tooltip),L.$9J.isLocation(J.location)&&(x.location=C.location.from(J.location)),J.command&&(x.command=this.g.toInternal(J.command,G)),x}),Y}}class le{constructor(M,K){this.e=M,this.f=K,this.d=new c.$Lac("DocumentLink")}async provideLinks(M,K){const G=this.e.getDocument(M),Y=await this.f.provideDocumentLinks(G,K);if(!(!Array.isArray(Y)||Y.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Y.filter(le.g).map(C.DocumentLink.from)};{const J=this.d.add(Y),x={links:[],cacheId:J};for(let ae=0;ae<Y.length;ae++){if(!le.g(Y[ae]))continue;const Le=C.DocumentLink.from(Y[ae]);Le.cacheId=[J,ae],x.links.push(Le)}return x}}}static g(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,K){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...M);if(!G)return;const Y=await this.f.resolveDocumentLink(G,K);if(!(!Y||!le.g(Y)))return C.DocumentLink.from(Y)}releaseLinks(M){this.d.delete(M)}}class we{constructor(M,K){this.d=M,this.e=K}async provideColors(M,K){const G=this.d.getDocument(M),Y=await this.e.provideDocumentColors(G,K);return Array.isArray(Y)?Y.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(M,K,G){const Y=this.d.getDocument(M),J=C.Range.to(K.range),x=C.Color.to(K.color),ae=await this.e.provideColorPresentations(x,{document:Y,range:J},G);if(Array.isArray(ae))return ae.map(C.ColorPresentation.from)}}class ve{constructor(M,K){this.d=M,this.e=K}async provideFoldingRanges(M,K,G){const Y=this.d.getDocument(M),J=await this.e.provideFoldingRanges(Y,K,G);if(Array.isArray(J))return J.map(C.FoldingRange.from)}}class me{constructor(M,K,G){this.d=M,this.e=K,this.f=G}async provideSelectionRanges(M,K,G){const Y=this.d.getDocument(M),J=K.map(C.Position.to),x=await this.e.provideSelectionRanges(Y,J,G);if(!(0,P.$Ib)(x))return[];if(x.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ae=[];for(let Le=0;Le<J.length;Le++){const Ue=[];ae.push(Ue);let Ye=J[Le],He=x[Le];for(;;){if(!He.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(C.SelectionRange.from(He)),!He.parent)break;Ye=He.range,He=He.parent}}return ae}}class De{constructor(M,K){this.f=M,this.g=K,this.d=new i.$2L(""),this.e=new Map}async prepareSession(M,K,G){const Y=this.f.getDocument(M),J=C.Position.to(K),x=await this.g.prepareCallHierarchy(Y,J,G);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Le=>this.h(ae,Le)):[this.h(ae,x)]}async provideCallsTo(M,K,G){const Y=this.j(M,K);if(!Y)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(Y,G);if(J)return J.map(x=>({from:this.h(M,x.from),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}async provideCallsFrom(M,K,G){const Y=this.j(M,K);if(!Y)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(Y,G);if(J)return J.map(x=>({to:this.h(M,x.to),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}releaseSession(M){this.e.delete(M)}h(M,K){const G=this.e.get(M),Y=C.CallHierarchyItem.from(K,M,G.size.toString(36));return G.set(Y._itemId,K),Y}j(M,K){return this.e.get(M)?.get(K)}}class ne{constructor(M,K){this.f=M,this.g=K,this.d=new i.$2L(""),this.e=new Map}async prepareSession(M,K,G){const Y=this.f.getDocument(M),J=C.Position.to(K),x=await this.g.prepareTypeHierarchy(Y,J,G);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Le=>this.h(ae,Le)):[this.h(ae,x)]}async provideSupertypes(M,K,G){const Y=this.j(M,K);if(!Y)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(Y,G);if(J)return J.map(x=>this.h(M,x))}async provideSubtypes(M,K,G){const Y=this.j(M,K);if(!Y)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(Y,G);if(J)return J.map(x=>this.h(M,x))}releaseSession(M){this.e.delete(M)}h(M,K){const G=this.e.get(M),Y=C.TypeHierarchyItem.from(K,M,G.size.toString(36));return G.set(Y._itemId,K),Y}j(M,K){return this.e.get(M)?.get(K)}}class he{static toInternalProviderId(M,K){return M+"."+K}constructor(M,K,G,Y,J){this.d=M,this.e=K,this.f=G,this.g=Y,this.h=J}async provideDocumentOnDropEdits(M,K,G,Y,J){const x=this.e.getDocument(K),ae=C.Position.to(G),Le=C.DataTransfer.toDataTransfer(Y,async Ye=>(await this.d.$resolveDocumentOnDropFileData(this.g,M,Ye)).buffer),Ue=await this.f.provideDocumentDropEdits(x,ae,Le,J);if(Ue)return{label:Ue.label??(0,a.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:he.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class se{constructor(M,K){this.d=M,this.e=K}async provideMappedEdits(M,K,G,Y){const J=w.URI.revive(M),x=this.d.getDocument(J),ae={selections:G.selections.map(Ue=>C.Selection.to(Ue)),related:G.related.map(Ue=>({uri:w.URI.revive(Ue.uri),range:C.Range.to(Ue.range)}))},Le=await this.e.provideMappedEdits(x,K,ae,Y);return Le?C.WorkspaceEdit.from(Le):null}}class oe{constructor(M,K){this.adapter=M,this.extension=K}}class fe{static{this.d=0}constructor(M,K,G,Y,J,x,ae,Le){this.g=K,this.h=G,this.j=Y,this.k=J,this.l=x,this.m=ae,this.n=Le,this.f=new Map,this.e=M.getProxy(l.$UJ.MainThreadLanguageFeatures)}o(M,K){return C.DocumentSelector.from(M,this.g,K)}p(M){return new L.$WJ(()=>{this.f.delete(M),this.e.$unregister(M)})}q(){return fe.d++}async t(M,K,G,Y,J,x=!1){const ae=this.f.get(M);if(!ae||!(ae.adapter instanceof K))return Y;const Le=Date.now();x||this.l.trace(`[${ae.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ue=G(ae.adapter,ae.extension);return Promise.resolve(Ue).catch(Ye=>{(0,k.$2)(Ye)||(this.l.error(`[${ae.extension.identifier.value}] provider FAILED`),this.l.error(Ye),this.n.onExtensionError(ae.extension.identifier,Ye))}).finally(()=>{x||this.l.trace(`[${ae.extension.identifier.value}] provider DONE after ${Date.now()-Le}ms`)}),p.CancellationToken.isCancellationToken(J)?(0,b.$vg)(Ue,J):Ue}u(M,K){const G=this.q();return this.f.set(G,new oe(M,K)),G}static w(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,K,G,Y){const J=this.u(new s(this.h,G),M),x=Y&&Y.label||fe.w(M);return this.e.$registerDocumentSymbolProvider(J,this.o(K,M),x),this.p(J)}$provideDocumentSymbols(M,K,G){return this.t(M,s,Y=>Y.provideDocumentSymbols(w.URI.revive(K),G),void 0,G)}registerCodeLensProvider(M,K,G){const Y=this.q(),J=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Y,new oe(new o(this.h,this.j.converter,G),M)),this.e.$registerCodeLensSupport(Y,this.o(K,M),J);let x=this.p(Y);if(J!==void 0){const ae=G.onDidChangeCodeLenses(Le=>this.e.$emitCodeLensEvent(J));x=L.$WJ.from(x,ae)}return x}$provideCodeLenses(M,K,G){return this.t(M,o,Y=>Y.provideCodeLenses(w.URI.revive(K),G),void 0,G)}$resolveCodeLens(M,K,G){return this.t(M,o,Y=>Y.resolveCodeLens(K,G),void 0,void 0)}$releaseCodeLenses(M,K){this.t(M,o,G=>Promise.resolve(G.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(M,K,G){const Y=this.u(new m(this.h,G),M);return this.e.$registerDefinitionSupport(Y,this.o(K,M)),this.p(Y)}$provideDefinition(M,K,G,Y){return this.t(M,m,J=>J.provideDefinition(w.URI.revive(K),G,Y),[],Y)}registerDeclarationProvider(M,K,G){const Y=this.u(new I(this.h,G),M);return this.e.$registerDeclarationSupport(Y,this.o(K,M)),this.p(Y)}$provideDeclaration(M,K,G,Y){return this.t(M,I,J=>J.provideDeclaration(w.URI.revive(K),G,Y),[],Y)}registerImplementationProvider(M,K,G){const Y=this.u(new E(this.h,G),M);return this.e.$registerImplementationSupport(Y,this.o(K,M)),this.p(Y)}$provideImplementation(M,K,G,Y){return this.t(M,E,J=>J.provideImplementation(w.URI.revive(K),G,Y),[],Y)}registerTypeDefinitionProvider(M,K,G){const Y=this.u(new r(this.h,G),M);return this.e.$registerTypeDefinitionSupport(Y,this.o(K,M)),this.p(Y)}$provideTypeDefinition(M,K,G,Y){return this.t(M,r,J=>J.provideTypeDefinition(w.URI.revive(K),G,Y),[],Y)}registerHoverProvider(M,K,G,Y){const J=this.u(new d(this.h,G),M);return this.e.$registerHoverProvider(J,this.o(K,M)),this.p(J)}$provideHover(M,K,G,Y){return this.t(M,d,J=>J.provideHover(w.URI.revive(K),G,Y),void 0,Y)}registerEvaluatableExpressionProvider(M,K,G,Y){const J=this.u(new v(this.h,G),M);return this.e.$registerEvaluatableExpressionProvider(J,this.o(K,M)),this.p(J)}$provideEvaluatableExpression(M,K,G,Y){return this.t(M,v,J=>J.provideEvaluatableExpression(w.URI.revive(K),G,Y),void 0,Y)}registerInlineValuesProvider(M,K,G,Y){const J=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.u(new R(this.h,G),M);this.e.$registerInlineValuesProvider(x,this.o(K,M),J);let ae=this.p(x);if(J!==void 0){const Le=G.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(J));ae=L.$WJ.from(ae,Le)}return ae}$provideInlineValues(M,K,G,Y,J){return this.t(M,R,x=>x.provideInlineValues(w.URI.revive(K),G,Y,J),void 0,J)}registerDocumentHighlightProvider(M,K,G){const Y=this.u(new B(this.h,G),M);return this.e.$registerDocumentHighlightProvider(Y,this.o(K,M)),this.p(Y)}$provideDocumentHighlights(M,K,G,Y){return this.t(M,B,J=>J.provideDocumentHighlights(w.URI.revive(K),G,Y),void 0,Y)}registerLinkedEditingRangeProvider(M,K,G){const Y=this.u(new V(this.h,G),M);return this.e.$registerLinkedEditingRangeProvider(Y,this.o(K,M)),this.p(Y)}$provideLinkedEditingRanges(M,K,G,Y){return this.t(M,V,async J=>{const x=await J.provideLinkedEditingRanges(w.URI.revive(K),G,Y);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?fe.y(x.wordPattern):void 0}},void 0,Y)}registerReferenceProvider(M,K,G){const Y=this.u(new j(this.h,G),M);return this.e.$registerReferenceSupport(Y,this.o(K,M)),this.p(Y)}$provideReferences(M,K,G,Y,J){return this.t(M,j,x=>x.provideReferences(w.URI.revive(K),G,Y,J),void 0,J)}registerCodeActionProvider(M,K,G,Y){const J=new h.$ic,x=this.u(new W(this.h,this.j.converter,this.k,G,this.l,M,this.m),M);return this.e.$registerQuickFixSupport(x,this.o(K,M),{providedKinds:Y?.providedCodeActionKinds?.map(ae=>ae.value),documentation:Y?.documentation?.map(ae=>({kind:ae.kind.value,command:this.j.converter.toInternal(ae.command,J)}))},fe.w(M),!!G.resolveCodeAction),J.add(this.p(x)),J}$provideCodeActions(M,K,G,Y,J){return this.t(M,W,x=>x.provideCodeActions(w.URI.revive(K),G,Y,J),void 0,J)}$resolveCodeAction(M,K,G){return this.t(M,W,Y=>Y.resolveCodeAction(K,G),{},void 0)}$releaseCodeActions(M,K){this.t(M,W,G=>Promise.resolve(G.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(M,K,G){const Y=this.u(new z(this.h,G),M);return this.e.$registerDocumentFormattingSupport(Y,this.o(K,M),M.identifier,M.displayName||M.name),this.p(Y)}$provideDocumentFormattingEdits(M,K,G,Y){return this.t(M,z,J=>J.provideDocumentFormattingEdits(w.URI.revive(K),G,Y),void 0,Y)}registerDocumentRangeFormattingEditProvider(M,K,G){const Y=typeof G.provideDocumentRangesFormattingEdits=="function",J=this.u(new ee(this.h,G),M);return this.e.$registerRangeFormattingSupport(J,this.o(K,M),M.identifier,M.displayName||M.name,Y),this.p(J)}$provideDocumentRangeFormattingEdits(M,K,G,Y,J){return this.t(M,ee,x=>x.provideDocumentRangeFormattingEdits(w.URI.revive(K),G,Y,J),void 0,J)}$provideDocumentRangesFormattingEdits(M,K,G,Y,J){return this.t(M,ee,x=>x.provideDocumentRangesFormattingEdits(w.URI.revive(K),G,Y,J),void 0,J)}registerOnTypeFormattingEditProvider(M,K,G,Y){const J=this.u(new X(this.h,G),M);return this.e.$registerOnTypeFormattingSupport(J,this.o(K,M),Y,M.identifier),this.p(J)}$provideOnTypeFormattingEdits(M,K,G,Y,J,x){return this.t(M,X,ae=>ae.provideOnTypeFormattingEdits(w.URI.revive(K),G,Y,J,x),void 0,x)}registerWorkspaceSymbolProvider(M,K){const G=this.u(new Ee(K,this.l),M);return this.e.$registerNavigateTypeSupport(G,typeof K.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(M,K,G){return this.t(M,Ee,Y=>Y.provideWorkspaceSymbols(K,G),{symbols:[]},G)}$resolveWorkspaceSymbol(M,K,G){return this.t(M,Ee,Y=>Y.resolveWorkspaceSymbol(K,G),void 0,void 0)}$releaseWorkspaceSymbols(M,K){this.t(M,Ee,G=>G.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(M,K,G){const Y=this.u(new ke(this.h,G,this.l),M);return this.e.$registerRenameSupport(Y,this.o(K,M),ke.supportsResolving(G)),this.p(Y)}$provideRenameEdits(M,K,G,Y,J){return this.t(M,ke,x=>x.provideRenameEdits(w.URI.revive(K),G,Y,J),void 0,J)}$resolveRenameLocation(M,K,G,Y){return this.t(M,ke,J=>J.resolveRenameLocation(w.URI.revive(K),G,Y),void 0,Y)}registerDocumentSemanticTokensProvider(M,K,G,Y){const J=this.u(new Z(this.h,G),M),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o(K,M),Y,x);let ae=this.p(J);if(x){const Le=G.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(x));ae=L.$WJ.from(ae,Le)}return ae}$provideDocumentSemanticTokens(M,K,G,Y){return this.t(M,Z,J=>J.provideDocumentSemanticTokens(w.URI.revive(K),G,Y),null,Y)}$releaseDocumentSemanticTokens(M,K){this.t(M,Z,G=>G.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,K,G,Y){const J=this.u(new ue(this.h,G),M);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o(K,M),Y),this.p(J)}$provideDocumentRangeSemanticTokens(M,K,G,Y){return this.t(M,ue,J=>J.provideDocumentRangeSemanticTokens(w.URI.revive(K),G,Y),null,Y)}registerCompletionItemProvider(M,K,G,Y){const J=this.u(new ye(this.h,this.j.converter,G,this.m,M),M);return this.e.$registerCompletionsProvider(J,this.o(K,M),Y,ye.supportsResolving(G),M.identifier),this.p(J)}$provideCompletionItems(M,K,G,Y,J){return this.t(M,ye,x=>x.provideCompletionItems(w.URI.revive(K),G,Y,J),void 0,J)}$resolveCompletionItem(M,K,G){return this.t(M,ye,Y=>Y.resolveCompletionItem(K,G),void 0,G)}$releaseCompletionItems(M,K){this.t(M,ye,G=>G.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(M,K,G,Y){const J=new $e(M,this.h,G,this.j.converter),x=this.u(J,M);return this.e.$registerInlineCompletionsSupport(x,this.o(K,M),J.supportsHandleEvents,$.$Ul.toKey(M.identifier.value),Y?.yieldTo?.map(ae=>$.$Ul.toKey(ae))||[]),this.p(x)}$provideInlineCompletions(M,K,G,Y,J){return this.t(M,ce,x=>x.provideInlineCompletions(w.URI.revive(K),G,Y,J),void 0,J)}$handleInlineCompletionDidShow(M,K,G,Y){this.t(M,ce,async J=>{J.handleDidShowCompletionItem(K,G,Y)},void 0,void 0)}$handleInlineCompletionPartialAccept(M,K,G,Y){this.t(M,ce,async J=>{J.handlePartialAccept(K,G,Y)},void 0,void 0)}$freeInlineCompletionsList(M,K){this.t(M,ce,async G=>{G.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(M,K,G,Y){const J=Array.isArray(Y)?{triggerCharacters:Y,retriggerCharacters:[]}:Y,x=this.u(new N(this.h,G),M);return this.e.$registerSignatureHelpProvider(x,this.o(K,M),J),this.p(x)}$provideSignatureHelp(M,K,G,Y,J){return this.t(M,N,x=>x.provideSignatureHelp(w.URI.revive(K),G,Y,J),void 0,J)}$releaseSignatureHelp(M,K){this.t(M,N,G=>G.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(M,K,G){const Y=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,J=this.u(new q(this.h,this.j.converter,G,this.l,M),M);this.e.$registerInlayHintsProvider(J,this.o(K,M),typeof G.resolveInlayHint=="function",Y,fe.w(M));let x=this.p(J);if(Y!==void 0){const ae=G.onDidChangeInlayHints(Le=>this.e.$emitInlayHintsEvent(Y));x=L.$WJ.from(x,ae)}return x}$provideInlayHints(M,K,G,Y){return this.t(M,q,J=>J.provideInlayHints(w.URI.revive(K),G,Y),void 0,Y)}$resolveInlayHint(M,K,G){return this.t(M,q,Y=>Y.resolveInlayHint(K,G),void 0,G)}$releaseInlayHints(M,K){this.t(M,q,G=>G.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(M,K,G){const Y=this.u(new le(this.h,G),M);return this.e.$registerDocumentLinkProvider(Y,this.o(K,M),typeof G.resolveDocumentLink=="function"),this.p(Y)}$provideDocumentLinks(M,K,G){return this.t(M,le,Y=>Y.provideLinks(w.URI.revive(K),G),void 0,G,K.scheme==="output")}$resolveDocumentLink(M,K,G){return this.t(M,le,Y=>Y.resolveLink(K,G),void 0,void 0,!0)}$releaseDocumentLinks(M,K){this.t(M,le,G=>G.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(M,K,G){const Y=this.u(new we(this.h,G),M);return this.e.$registerDocumentColorProvider(Y,this.o(K,M)),this.p(Y)}$provideDocumentColors(M,K,G){return this.t(M,we,Y=>Y.provideColors(w.URI.revive(K),G),[],G)}$provideColorPresentations(M,K,G,Y){return this.t(M,we,J=>J.provideColorPresentations(w.URI.revive(K),G,Y),void 0,Y)}registerFoldingRangeProvider(M,K,G){const Y=this.q(),J=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Y,new oe(new ve(this.h,G),M)),this.e.$registerFoldingRangeProvider(Y,this.o(K,M),M.identifier,J);let x=this.p(Y);if(J!==void 0){const ae=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));x=L.$WJ.from(x,ae)}return x}$provideFoldingRanges(M,K,G,Y){return this.t(M,ve,J=>J.provideFoldingRanges(w.URI.revive(K),G,Y),void 0,Y)}registerSelectionRangeProvider(M,K,G){const Y=this.u(new me(this.h,G,this.l),M);return this.e.$registerSelectionRangeProvider(Y,this.o(K,M)),this.p(Y)}$provideSelectionRanges(M,K,G,Y){return this.t(M,me,J=>J.provideSelectionRanges(w.URI.revive(K),G,Y),[],Y)}registerCallHierarchyProvider(M,K,G){const Y=this.u(new De(this.h,G),M);return this.e.$registerCallHierarchyProvider(Y,this.o(K,M)),this.p(Y)}$prepareCallHierarchy(M,K,G,Y){return this.t(M,De,J=>Promise.resolve(J.prepareSession(w.URI.revive(K),G,Y)),void 0,Y)}$provideCallHierarchyIncomingCalls(M,K,G,Y){return this.t(M,De,J=>J.provideCallsTo(K,G,Y),void 0,Y)}$provideCallHierarchyOutgoingCalls(M,K,G,Y){return this.t(M,De,J=>J.provideCallsFrom(K,G,Y),void 0,Y)}$releaseCallHierarchy(M,K){this.t(M,De,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(M,K,G){const Y=this.u(new ne(this.h,G),M);return this.e.$registerTypeHierarchyProvider(Y,this.o(K,M)),this.p(Y)}$prepareTypeHierarchy(M,K,G,Y){return this.t(M,ne,J=>Promise.resolve(J.prepareSession(w.URI.revive(K),G,Y)),void 0,Y)}$provideTypeHierarchySupertypes(M,K,G,Y){return this.t(M,ne,J=>J.provideSupertypes(K,G,Y),void 0,Y)}$provideTypeHierarchySubtypes(M,K,G,Y){return this.t(M,ne,J=>J.provideSubtypes(K,G,Y),void 0,Y)}$releaseTypeHierarchy(M,K){this.t(M,ne,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(M,K,G,Y){const J=this.q();this.f.set(J,new oe(new he(this.e,this.h,G,J,M),M));const x=(0,n.$NF)(M,"dropMetadata")&&Y?he.toInternalProviderId(M.identifier.value,Y.id):void 0;return this.e.$registerDocumentOnDropEditProvider(J,this.o(K,M),x,(0,n.$NF)(M,"dropMetadata")?Y:void 0),this.p(J)}$provideDocumentOnDropEdits(M,K,G,Y,J,x){return this.t(M,he,ae=>Promise.resolve(ae.provideDocumentOnDropEdits(K,w.URI.revive(G),Y,J,x)),void 0,void 0)}registerMappedEditsProvider(M,K,G){const Y=this.u(new se(this.h,G),M);return this.e.$registerMappedEditsProvider(Y,this.o(K,M)),this.p(Y)}$provideMappedEdits(M,K,G,Y,J){return this.t(M,se,x=>Promise.resolve(x.provideMappedEdits(K,G,Y,J)),null,J)}registerDocumentPasteEditProvider(M,K,G,Y){const J=this.q();this.f.set(J,new oe(new O(this.e,this.h,G,J,M),M));const x=O.toInternalProviderId(M.identifier.value,Y.id);return this.e.$registerPasteEditProvider(J,this.o(K,M),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:Y.copyMimeTypes,pasteMimeTypes:Y.pasteMimeTypes}),this.p(J)}$prepareDocumentPaste(M,K,G,Y,J){return this.t(M,O,x=>x.prepareDocumentPaste(w.URI.revive(K),G,Y,J),void 0,J)}$providePasteEdits(M,K,G,Y,J,x){return this.t(M,O,ae=>ae.providePasteEdits(K,w.URI.revive(G),Y,J,x),void 0,x)}static y(M){return{pattern:M.source,flags:M.flags}}static z(M){return{decreaseIndentPattern:fe.y(M.decreaseIndentPattern),increaseIndentPattern:fe.y(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?fe.y(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?fe.y(M.unIndentedLinePattern):void 0}}static B(M){return{beforeText:fe.y(M.beforeText),afterText:M.afterText?fe.y(M.afterText):void 0,previousLineText:M.previousLineText?fe.y(M.previousLineText):void 0,action:M.action}}static C(M){return M.map(fe.B)}setLanguageConfiguration(M,K,G){const{wordPattern:Y}=G;if(Y&&(0,S.$ye)(Y))throw new Error(`Invalid language configuration: wordPattern '${Y}' is not allowed to match the empty string.`);Y?this.h.setWordDefinitionFor(K,Y):this.h.setWordDefinitionFor(K,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",M,"Do not use."),G.autoClosingPairs&&(0,n.$OF)(M,"languageConfigurationAutoClosingPairs");const J=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?fe.y(G.wordPattern):void 0,indentationRules:G.indentationRules?fe.z(G.indentationRules):void 0,onEnterRules:G.onEnterRules?fe.C(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs};return this.e.$setLanguageConfiguration(J,K,x),this.p(J)}$setWordDefinitions(M){for(const K of M)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$Uac=fe}),define(Ae[240],Re([1,0,3,8,7,29,13,6]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=void 0;class S{constructor(P,D,u,p){this.c=D,this.d=u,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(w.$UJ.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,D){await this.a.$changeLanguage(P,D);const u=this.c.getDocumentData(P);if(!u)throw new Error(`document '${P.toString()}' NOT found`);return u.document}async tokenAtPosition(P,D){const u=P.version,p=F.Position.from(D),$=await this.a.$tokensAtPosition(P.uri,p),h={type:C.StandardTokenType.Other,range:P.getWordRangeAtPosition(D)??new C.$YJ(D.line,D.character,D.line,D.character)};if(!$)return h;const t={range:F.Range.to($.range),type:F.TokenType.to($.type)};return!t.range.contains(D)||u!==P.version?h:t}createLanguageStatusItem(P,D,u){const p=this.f++,$=this.a,h=this.g,t=`${P.identifier.value}/${D}`;if(h.has(t))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);h.add(t);const i={selector:u,id:D,name:P.displayName??P.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const g=new l.$ic,k=()=>{if(c?.dispose(),!h.has(t)){console.warn(`LanguageStatusItem (${D}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$Hg)(()=>{g.clear(),this.a.$setLanguageStatus(p,{id:t,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:F.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===C.LanguageStatusSeverity.Error?L.default.Error:i.severity===C.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this.d.toInternal(i.command,g),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},b={dispose(){g.dispose(),c?.dispose(),$.$removeLanguageStatus(p),h.delete(t)},get id(){return i.id},get name(){return i.name},set name(n){i.name=n,k()},get selector(){return i.selector},set selector(n){i.selector=n,k()},get text(){return i.text},set text(n){i.text=n,k()},get detail(){return i.detail},set detail(n){i.detail=n,k()},get severity(){return i.severity},set severity(n){i.severity=n,k()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(n){i.accessibilityInformation=n,k()},get command(){return i.command},set command(n){i.command=n,k()},get busy(){return i.busy},set busy(n){i.busy=n,k()}};return k(),b}}e.$Cbc=S}),define(Ae[81],Re([1,0,22,15,2,4,14,3,27,17]),function(be,e,w,F,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sbc=e.$rbc=void 0;let P=class{constructor(u,p,$){this.f=$,this.d=new Map,this.a=p.getProxy(l.$UJ.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===w.$f}getMessage(u,p){const{message:$,args:h,comment:t}=p;if(this.c)return(0,F.$ne)($,h??{});let i=$;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.d.get(u)?.contents[i];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,F.$ne)(c??$,h??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let p;const $=await this.g(u);if(!$){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const h=await this.a.$fetchBundleContents($),t=JSON.parse(h);p=u.isBuiltin?t.contents?.bundle:t}catch(h){this.f.error(`Failed to load translations for ${u.identifier.value} from ${$}: ${h.message}`);return}p&&this.d.set(u.identifier.value,{contents:p,uri:$})}async g(u){if(u.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return C.URI.revive(p)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$rbc=P,e.$rbc=P=Ke([Ve(0,S.$aM),Ve(1,f.$WL),Ve(2,A.$4i)],P),e.$sbc=(0,L.$Ah)("IExtHostLocalizationService")}),define(Ae[241],Re([1,0,14,3,27,17,2,68]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;let S=class extends w.$cj{constructor(D,u){super(u.logLevel,u.logsLocation,u.loggers.map(p=>(0,l.$0g)(p))),this.r=D.getProxy(F.$UJ.MainThreadLogger)}$setLogLevel(D,u){u?this.setLogLevel(A.URI.revive(u),D):this.setLogLevel(D)}setVisibility(D,u){super.setVisibility(D,u),this.r.$setVisibility(D,u)}s(D,u,p){return new f(this.r,D,u,p)}};e.$Scc=S,e.$Scc=S=Ke([Ve(0,L.$WL),Ve(1,C.$aM)],S);class f extends w.$0i{constructor(D,u,p,$){super($?.logLevel==="always"),this.r=D,this.s=u,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(u,$).then(()=>{this.u(this.n),this.m=!0})}g(D,u){const p=[[D,u]];this.m?this.u(p):this.n.push(...p)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,25]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ubc=e.$tbc=void 0,e.$tbc=(0,F.$Ah)("IExtHostManagedSockets");let l=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(w.$UJ.MainThreadManagedSockets)}setFactory(D,u){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new S(D,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const u=++this.b,p=await this.c.makeConnection(),$=new C.$ic;return this.d.set(u,new f(u,p,$)),$.add((0,C.$hc)(()=>this.d.delete(u))),$.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),$.dispose()})),$.add(p.onDidClose(h=>{this.a.$onDidManagedSocketClose(u,h?.stack??h?.message),$.dispose()})),$.add(p.onDidReceiveMessage(h=>this.a.$onDidManagedSocketHaveData(u,A.$Ed.wrap(h)))),u}$remoteSocketWrite(D,u){this.d.get(D)?.actual.send(u.buffer)}$remoteSocketEnd(D){const u=this.d.get(D);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$ubc=l,e.$ubc=l=Ke([Ve(0,L.$WL)],l);class S{constructor(D,u){this.socketFactoryId=D,this.makeConnection=u}}class f extends C.$jc{constructor(D,u,p){super(),this.socketId=D,this.actual=u,this.B(p)}}}),define(Ae[242],Re([1,0,3,14,26]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=void 0;function L(l){return l&&l.title}let A=class{constructor(S,f){this.b=f,this.a=S.getProxy(w.$UJ.MainThreadMessageService)}showMessage(S,f,P,D,u){const p={source:{identifier:S.identifier,label:S.displayName||S.name}};let $;typeof D=="string"||L(D)?$=[D,...u]:(p.modal=D?.modal,p.useCustom=D?.useCustom,p.detail=D?.detail,$=u),p.useCustom&&(0,C.$OF)(S,"resolvers");const h=[];for(let t=0;t<$.length;t++){const i=$[t];if(typeof i=="string")h.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:c,isCloseAffordance:g}=i;h.push({title:c,isCloseAffordance:!!g,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(f,P,p,h).then(t=>{if(typeof t=="number")return $[t]})}};e.$Dbc=A,e.$Dbc=A=Ke([Ve(1,F.$4i)],A)}),define(Ae[243],Re([1,0,152,25,5,6,28,15,16,2,38,54,3,31,8,7,46,205,104,9,24,12]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t,i,c,g,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;class n{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,o,y,m,I){this.q=y,this.r=m,this.s=I,this.f=new Map,this.g=new A.$yi,this.h=new Map,this.j=new C.$ed({onListenerError:g.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$ed({onListenerError:g.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$ed({onListenerError:g.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$ed({onListenerError:g.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$Lac("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=s.getProxy(u.$UJ.MainThreadNotebook),this.c=s.getProxy(u.$UJ.MainThreadNotebookDocuments),this.d=s.getProxy(u.$UJ.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===13){const r=E.notebookEditor?.notebookUri,d=E.cell.handle,R=this.g.get(r)?.getCell(d);if(R)return R.apiCell}if(E&&E.$mid===14){const r=E.uri,d=this.g.get(r);if(d)return d.apiNotebook}return E}}),n.A(o)}getEditorById(s){const o=this.h.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(s){for(const[o,y]of this.h)if(y.apiEditor===s)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,o){const y=this.g.get(s);if(!y&&!o)throw new Error(`NO notebook document for '${s}'`);return y}static t(s,o){if(!o)return;const y=o.filenamePattern.map(m=>$.NotebookExclusiveDocumentPattern.from(m)).filter(m=>m!==void 0);if(o.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:y,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,y){const m=n.a++,I=typeof y.onDidChangeCellStatusBarItems=="function"?n.a++:void 0;this.f.set(m,y),this.b.$registerNotebookCellStatusBarItemProvider(m,I,o);let E;return I!==void 0&&(E=y.onDidChangeCellStatusBarItems(r=>this.b.$emitCellStatusBarEvent(I))),new h.$WJ(()=>{this.f.delete(m),this.b.$unregisterNotebookCellStatusBarItemProvider(m,I),E?.dispose()})}async createNotebookDocument(s){const o=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&$.NotebookData.from(s.content)});return f.URI.revive(o)}async openNotebookDocument(s){const o=this.g.get(s);if(o)return o.apiNotebook;const y=await this.c.$tryOpenNotebook(s),m=this.g.get(f.URI.revive(y));return(0,S.$tf)(m?.apiNotebook)}async showNotebookDocument(s,o){f.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let y;typeof o=="object"?y={position:$.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map($.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:y={preserveFocus:!1};const m=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,y),I=m&&this.h.get(m)?.apiEditor;if(I)return I;throw m?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,y,m){const I=this.f.get(s),E=f.URI.revive(o),r=this.g.get(E);if(!r||!I)return;const d=r.getCellFromIndex(y);if(!d)return;const v=await I.provideCellStatusBarItems(d.apiCell,m);if(!v)return;const R=new L.$ic,B=this.p.add([R]),j=(Array.isArray(v)?v:[v]).map(W=>$.NotebookStatusBarItem.from(W,this.i,R));return{cacheId:B,items:j}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,o,y,m,I){if((0,l.$le)(o))throw new Error("viewType cannot be empty or just whitespace");const E=this.u++;return this.w.set(E,{viewType:o,serializer:y,options:m}),this.b.$registerNotebookSerializer(E,{id:s.identifier,location:s.extensionLocation},o,$.NotebookDocumentContentOptions.from(m),n.t(s,I)),(0,L.$hc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(s,o,y){const m=this.w.get(s);if(!m)throw new Error("NO serializer found");const I=await m.serializer.deserializeNotebook(o.buffer,y);return new t.$bA($.NotebookData.from(I))}async $notebookToData(s,o,y){const m=this.w.get(s);if(!m)throw new Error("NO serializer found");const I=await m.serializer.serializeNotebook($.NotebookData.to(o.value),y);return F.$Ed.wrap(I)}async $saveNotebook(s,o,y,m,I){const E=f.URI.revive(o),r=this.w.get(s);if(!r)throw new Error("NO serializer found");const d=this.g.get(E);if(!d)throw new Error("Document NOT found");if(d.versionId!==y)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new P.$mk((0,w.localize)(0,null,this.y(E)),6);await this.x(E,m);const v={metadata:(0,k.$3m)(d.apiNotebook.metadata,W=>!(r.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of d.apiNotebook.getCells()){const O=new h.$jL(W.kind,W.document.getText(),W.document.languageId,W.mime,r.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);O.metadata=(0,k.$3m)(W.metadata,z=>!(r.options?.transientCellMetadata??{})[z]),v.cells.push(O)}const R=await r.serializer.serializeNotebook(v,I);await this.s.value.writeFile(E,R);const B=this.s.getFileSystemProviderExtUri(E.scheme),V=await this.s.value.stat(E);return{name:B.basename(E),isFile:(V.type&P.FileType.File)!==0,isDirectory:(V.type&P.FileType.Directory)!==0,isSymbolicLink:(V.type&P.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((V.permissions??0)&P.FilePermission.Locked),etag:P.$xk({mtime:V.mtime,size:V.size}),children:void 0}}async x(s,o){const y=await this.s.value.stat(s);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==P.$wk&&typeof y.mtime=="number"&&typeof y.size=="number"&&o.mtime<y.mtime&&o.etag!==P.$xk({mtime:o.mtime,size:y.size}))throw new P.$mk((0,w.localize)(1,null),3,o)}y(s){return s.scheme===b.Schemas.file?s.fsPath:s.toString()}z(s,o,y){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const m=new c.$kcc(o,this.d,s,y.visibleRanges.map($.NotebookRange.to),y.selections.map($.NotebookRange.to),typeof y.viewColumn=="number"?$.ViewColumn.to(y.viewColumn):void 0);this.h.set(o,m)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const y of s.value.removedDocuments){const m=f.URI.revive(y),I=this.g.get(m);I&&(I.dispose(),this.g.delete(m),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(I.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===m.toString()&&this.h.delete(E.id)}if(s.value.addedDocuments){const y=[];for(const m of s.value.addedDocuments){const I=f.URI.revive(m.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const E=new i.$jcc(this.c,this.q,this.r,I,m);y.push(...m.cells.map(r=>i.$icc.asModelAddData(E.apiNotebook,r))),this.g.get(I)?.dispose(),this.g.set(I,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this.m.fire(E.apiNotebook)}}if(s.value.addedEditors)for(const y of s.value.addedEditors){if(this.h.has(y.id))return;const m=f.URI.revive(y.documentUri),I=this.g.get(m);I&&this.z(I,y.id,y)}const o=[];if(s.value.removedEditors)for(const y of s.value.removedEditors){const m=this.h.get(y);m&&(this.h.delete(y),this.k?.id===m.id&&(this.k=void 0),o.push(m))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(m=>this.h.get(m)).filter(m=>!!m);const y=new Set;this.l.forEach(m=>y.add(m.id));for(const m of this.h.values()){const I=y.has(m.id);m._acceptVisibility(I)}this.l=[...this.h.values()].map(m=>m).filter(m=>m.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(s){const o=p.$iM.String.with("notebookType","A notebook type"),y=new p.$kM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new p.$iM("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>F.$Ed.wrap(I))],new p.$jM("Notebook Data",I=>$.NotebookData.to(I.value))),m=new p.$kM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new p.$iM("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new t.$bA($.NotebookData.from(I)))],new p.$jM("Bytes",I=>I.buffer));s.registerApiCommand(y),s.registerApiCommand(m)}}e.$lcc=n}),define(Ae[244],Re([1,0,18,13,21,5,6,28,2,20,14,54,3,31,8,7,77,198,26,46]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t,i,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=void 0;let k=class{constructor(I,E,r,d,v){this.m=E,this.n=r,this.o=d,this.q=v,this.b=new l.$yi,this.c=new l.$yi,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new D.$Lac("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new L.$ed,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=I.getProxy(u.$UJ.MainThreadNotebookKernels);const R=new p.$kM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$iM("options","Select kernel options",B=>!0,B=>{if(B&&"notebookEditor"in B&&"id"in B){const V=this.n.getIdByEditor(B.notebookEditor);return{id:B.id,extension:B.extension,notebookEditorId:V}}else if(B&&"notebookEditor"in B){const V=this.n.getIdByEditor(B.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${B.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return B})],p.$jM.Void);this.o.registerApiCommand(R)}createNotebookController(I,E,r,d,v,R){for(const ye of this.j.values())if(ye.controller.id===E&&f.$Ul.equals(I.identifier,ye.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const B=this.k++,V=this;this.q.trace(`NotebookController[${B}], CREATED by ${I.identifier.value}, ${E}`);const j=()=>console.warn(`NO execute handler from notebook controller '${ee.id}' of extension: '${I.identifier}'`);let W=!1;const O=new L.$ed,z=new L.$ed,ee={id:y(I.identifier,E),notebookType:r,extensionId:I.identifier,extensionLocation:I.extensionLocation,label:d||I.identifier.value,preloads:R?R.map($.NotebookRendererScript.from):[]};let X=v??j,Ee;this.a.$addKernel(B,ee).catch(ye=>{console.log(ye),W=!0});let ke=0;const Pe=()=>{if(W)return;const ye=++ke;Promise.resolve().then(()=>{ye===ke&&this.a.$updateKernel(B,ee)})},Z=new l.$yi,ue={get id(){return E},get notebookType(){return ee.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return ee.label},set label(ye){ee.label=ye??I.displayName??I.name,Pe()},get detail(){return ee.detail??""},set detail(ye){ee.detail=ye,Pe()},get description(){return ee.description??""},set description(ye){ee.description=ye,Pe()},get supportedLanguages(){return ee.supportedLanguages},set supportedLanguages(ye){ee.supportedLanguages=ye,Pe()},get supportsExecutionOrder(){return ee.supportsExecutionOrder??!1},set supportsExecutionOrder(ye){ee.supportsExecutionOrder=ye,Pe()},get rendererScripts(){return ee.preloads?ee.preloads.map($.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(ye){X=ye??j},get interruptHandler(){return Ee},set interruptHandler(ye){Ee=ye,ee.supportsInterrupt=!!ye,Pe()},createNotebookCellExecution(ye){if(W)throw new Error("notebook controller is DISPOSED");if(!Z.has(ye.notebook.uri))throw V.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ye.notebook.uri.toString()}`);return V._createNotebookCellExecution(ye,y(I.identifier,this.id))},createNotebookExecution(ye){if((0,c.$OF)(I,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!Z.has(ye.uri))throw V.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ye.uri.toString()}`);return V._createNotebookExecution(ye,y(I.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${B}], DISPOSED`),W=!0,this.j.delete(B),O.dispose(),z.dispose(),this.a.$removeKernel(B))},updateNotebookAffinity(ye,ce){ce===h.NotebookControllerAffinity2.Hidden&&(0,c.$OF)(I,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(B,ye.uri,ce)},onDidReceiveMessage:z.event,postMessage(ye,ce){return(0,c.$OF)(I,"notebookMessaging"),V.a.$postMessage(B,ce&&V.n.getIdByEditor(ce),ye)},asWebviewUri(ye){return(0,c.$OF)(I,"notebookMessaging"),(0,t.$Lob)(ye,V.m.remote)}};return this.j.set(B,{extensionId:I.identifier,controller:ue,onDidReceiveMessage:z,onDidChangeSelection:O,associatedNotebooks:Z}),ue}getIdByController(I){for(const[E,r]of this.j)if(r.controller===I)return y(r.extensionId,I.id);return null}createNotebookControllerDetectionTask(I,E){const r=this.f++,d=this;this.q.trace(`NotebookControllerDetectionTask[${r}], CREATED by ${I.identifier.value}`),this.a.$addKernelDetectionTask(r,E);const v={dispose:()=>{this.e.delete(r),d.a.$removeKernelDetectionTask(r)}};return this.e.set(r,v),v}registerKernelSourceActionProvider(I,E,r){const d=this.h++,v=typeof r.onDidChangeNotebookKernelSourceActions=="function"?d:void 0,R=this;this.g.set(d,r),this.q.trace(`NotebookKernelSourceActionProvider[${d}], CREATED by ${I.identifier.value}`),this.a.$addKernelSourceActionProvider(d,d,E);let B;return v!==void 0&&(B=r.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(v))),{dispose:()=>{this.g.delete(d),R.a.$removeKernelSourceActionProvider(d,d),B?.dispose()}}}async $provideKernelSourceActions(I,E){const r=this.g.get(I);if(r){const d=new A.$ic;return this.i.add([d]),(await r.provideNotebookKernelSourceActions(E)??[]).map(R=>$.NotebookKernelSourceAction.from(R,this.o.converter,d))}return[]}$acceptNotebookAssociation(I,E,r){const d=this.j.get(I);if(d){const v=this.n.getNotebookDocument(S.URI.revive(E));r?d.associatedNotebooks.set(v.uri,!0):d.associatedNotebooks.delete(v.uri),this.q.trace(`NotebookController[${I}] ASSOCIATE notebook`,v.uri.toString(),r),d.onDidChangeSelection.fire({selected:r,notebook:v.apiNotebook})}}async $executeCells(I,E,r){const d=this.j.get(I);if(!d)return;const v=this.n.getNotebookDocument(S.URI.revive(E)),R=[];for(const B of r){const V=v.getCell(B);V&&R.push(V.apiCell)}try{this.q.trace(`NotebookController[${I}] EXECUTE cells`,v.uri.toString(),R.length),await d.controller.executeHandler.call(d.controller,R,v.apiNotebook,d.controller)}catch(B){this.q.error(`NotebookController[${I}] execute cells FAILED`,B),console.error(B)}}async $cancelCells(I,E,r){const d=this.j.get(I);if(!d)return;const v=this.n.getNotebookDocument(S.URI.revive(E));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,v.apiNotebook);else for(const R of r){const B=v.getCell(R);B&&this.b.get(B.uri)?.cancel()}if(d.controller.interruptHandler){const R=this.c.get(v.uri);r.length&&Array.isArray(R)&&R.length&&R.forEach(B=>B.dispose())}}$acceptKernelMessageFromRenderer(I,E,r){const d=this.j.get(I);if(!d)return;const v=this.n.getEditorById(E);d.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:r}))}$cellExecutionChanged(I,E,r){const v=this.n.getNotebookDocument(S.URI.revive(I)).getCell(E);if(v){const R=r?$.NotebookCellExecutionState.to(r):h.NotebookCellExecutionState.Idle;R!==void 0&&this.l.fire({cell:v.apiCell,state:R})}}_createNotebookCellExecution(I,E){if(I.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this.n.getNotebookDocument(I.notebook.uri).getCellFromApiCell(I);if(!d)throw new Error("invalid cell");if(this.b.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const v=new n(E,d,this.a);this.b.set(d.uri,v);const R=v.onDidChangeState(()=>{v.state===b.Resolved&&(v.dispose(),R.dispose(),this.b.delete(d.uri))});return v.asApiObject()}_createNotebookExecution(I,E){const r=this.n.getNotebookDocument(I.uri),d=I.getCells().find(B=>{const V=r.getCellFromApiCell(B);return V&&this.b.has(V.uri)});if(d)throw new Error(`duplicate cell execution for ${d.document.uri}`);if(this.c.has(r.uri))throw new Error(`duplicate notebook execution for ${r.uri}`);const v=new s(E,r,this.a),R=v.onDidChangeState(()=>{v.state===a.Resolved&&(v.dispose(),R.dispose(),this.c.delete(r.uri))});return this.c.set(r.uri,[v,R]),v.asApiObject()}};e.$zcc=k,e.$zcc=k=Ke([Ve(4,P.$4i)],k);var b;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(b||(b={}));class n extends A.$jc{static{this.a=0}get state(){return this.f}constructor(I,E,r){super(),this.m=E,this.n=r,this.b=n.a++,this.c=new L.$ed,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new C.$od),this.h=new o(10,d=>this.s(d)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,I,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(I){await this.h.addItem(I)}async s(I){const E=Array.isArray(I)?I:[I];return this.n.$updateExecution(this.b,new g.$bA(E))}t(){if(this.f===b.Init)throw new Error("Must call start before modifying cell output");if(this.f===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(I){let E=this.m;if(I&&(E=this.m.notebook.getCellFromApiCell(I)),!E)throw new Error("INVALID cell");return E.handle}y(I){return I.map(E=>{const r=h.$mL.ensureUniqueMimeTypes(E.items,!0);return r===E.items?$.NotebookCellOutput.from(E):$.NotebookCellOutput.from({items:r,id:E.id,metadata:E.metadata})})}async z(I,E,r){const d=this.w(E),v=this.y((0,w.$Zb)(I));return this.r({editType:i.CellExecutionUpdateType.Output,cellHandle:d,append:r,outputs:v})}async C(I,E,r){return I=h.$mL.ensureUniqueMimeTypes((0,w.$Zb)(I),!0),this.r({editType:i.CellExecutionUpdateType.OutputItems,items:I.map($.NotebookCellOutputItem.from),outputId:E.id,append:r})}asApiObject(){const I=this;return Object.freeze({get token(){return I.g.token},get cell(){return I.m.apiCell},get executionOrder(){return I.j},set executionOrder(r){I.j=r,I.s([{editType:i.CellExecutionUpdateType.ExecutionState,executionOrder:I.j}])},start(r){if(I.f===b.Resolved||I.f===b.Started)throw new Error("Cannot call start again");I.f=b.Started,I.c.fire(),I.s({editType:i.CellExecutionUpdateType.ExecutionState,runStartTime:r})},end(r,d){if(I.f===b.Resolved)throw new Error("Cannot call resolve twice");I.f=b.Resolved,I.c.fire(),I.h.flush(),I.n.$completeExecution(I.b,new g.$bA({runEndTime:d,lastRunSuccess:r}))},clearOutput(r){return I.t(),I.z([],r,!1)},appendOutput(r,d){return I.t(),I.z(r,d,!0)},replaceOutput(r,d){return I.t(),I.z(r,d,!1)},appendOutputItems(r,d){return I.t(),I.C(r,d,!0)},replaceOutputItems(r,d){return I.t(),I.C(r,d,!1)}})}}var a;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(a||(a={}));class s extends A.$jc{static{this.a=0}get state(){return this.f}constructor(I,E,r){super(),this.h=E,this.j=r,this.b=s.a++,this.c=new L.$ed,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new C.$od),this.j.$createNotebookExecution(this.b,I,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===a.Resolved||this.f===a.Started)throw new Error("Cannot call start again");this.f=a.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===a.Resolved)throw new Error("Cannot call resolve twice");this.f=a.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor(I,E){this.e=I,this.f=E,this.a=[],this.b=Date.now()}addItem(I){return this.a.push(I),this.c||(this.c=new F.$1g,this.b=Date.now(),(0,F.$Gg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const I=this.c;this.c=void 0;const E=this.a;return this.a=[],this.f(E).finally(()=>I.complete())}}function y(m,I){return`${m.value}/${I}`}e.$Acc=y}),define(Ae[245],Re([1,0,5,3,104]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;class L{constructor(l,S){this.c=S,this.a=new Map,this.b=l.getProxy(F.$UJ.MainThreadNotebookRenderers)}$postRendererMessage(l,S,f){const P=this.c.getEditorById(l);this.a.get(S)?.fire({editor:P.apiEditor,message:f})}createRendererMessaging(l,S){if(!l.contributes?.notebookRenderer?.some(P=>P.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(P,D,u)=>this.d(S).event(P,D,u),postMessage:(P,D)=>{C.$kcc.apiEditorsToExtHost.has(P)&&([P,D]=[D,P]);const u=D&&C.$kcc.apiEditorsToExtHost.get(D);return this.b.$postMessage(u?.id,S,P)}}}d(l){let S=this.a.get(l);return S||(S=new w.$ed({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(l)}}),this.a.set(l,S),S)}}e.$Bcc=L}),define(Ae[246],Re([1,0,6,16,2,26,3]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;class l{constructor(f){this.b=new Map,this.a=f.getProxy(A.$UJ.MainThreadProfileContentHandlers)}registrProfileContentHandler(f,P,D){if((0,L.$OF)(f,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,D),this.a.$registerProfileContentHandler(P,D.name,D.description,f.identifier.value),(0,w.$hc)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(f,P,D,u){const p=this.b.get(f);if(!p)throw new Error(`Unknown handler with id: ${f}`);return p.saveProfile(P,D,u)}async $readProfile(f,P,D){const u=this.b.get(f);if(!u)throw new Error(`Unknown handler with id: ${f}`);return u.readProfile((0,F.$if)(P)?P:C.URI.revive(P),D)}}e.$Fcc=l}),define(Ae[247],Re([1,0,2,3,13,8]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=void 0;class A{static{this.a=0}constructor(S,f){this.d=f,this.c=new Map,this.b=S.getProxy(F.$UJ.MainThreadQuickDiff)}$provideOriginalResource(S,f,P){const D=w.URI.revive(f),u=this.c.get(S);return u?(0,C.$yg)(()=>u.provideOriginalResource(D,P)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(S,f,P,D){const u=A.a++;return this.c.set(u,f),this.b.$registerQuickDiffProvider(u,L.DocumentSelector.from(S,this.d),P,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Gcc=A}),define(Ae[248],Re([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=void 0;function $(h,t,i){const c=h.getProxy(L.$UJ.MainThreadQuickOpen);class g{constructor(I,E){this.e=new Map,this.f=0,this.a=I,this.b=E}showQuickPick(I,E,r,d=w.CancellationToken.None){this.c=void 0;const v=Promise.resolve(E),R=++this.f,B=c.$show(R,{title:r?.title,placeHolder:r?.placeHolder,matchOnDescription:r?.matchOnDescription,matchOnDetail:r?.matchOnDetail,ignoreFocusLost:r?.ignoreFocusOut,canPickMany:r?.canPickMany},d),V={},j=B.then(()=>V);return Promise.race([j,v]).then(W=>{if(W===V)return;const O=(0,u.$NF)(I,"quickPickItemTooltip");return v.then(z=>{const ee=[];for(let X=0;X<z.length;X++){const Ee=z[X];if(typeof Ee=="string")ee.push({label:Ee,handle:X});else if(Ee.kind===l.QuickPickItemKind.Separator)ee.push({type:"separator",label:Ee.label});else{Ee.tooltip&&!O&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const ke=Ee.iconPath?s(Ee.iconPath):void 0;ee.push({label:Ee.label,iconPath:ke?.iconPath,iconClass:ke?.iconClass,description:Ee.description,detail:Ee.detail,picked:Ee.picked,alwaysShow:Ee.alwaysShow,tooltip:O?p.MarkdownString.fromStrict(Ee.tooltip):void 0,handle:X})}}return r&&typeof r.onDidSelectItem=="function"&&(this.c=X=>{r.onDidSelectItem(z[X])}),c.$setItems(R,ee),B.then(X=>{if(typeof X=="number")return z[X];if(Array.isArray(X))return X.map(Ee=>z[Ee])})})}).then(void 0,W=>{if(!(0,S.$2)(W))return c.$setError(R,W),Promise.reject(W)})}$onItemSelected(I){this.c?.(I)}showInput(I,E=w.CancellationToken.None){return this.d=I?.validateInput,c.$input(I,typeof this.d=="function",E).then(void 0,r=>{if(!(0,S.$2)(r))return Promise.reject(r)})}async $validateInput(I){if(!this.d)return;const E=await this.d(I);if(!E||typeof E=="string")return E;let r;switch(E.severity){case l.InputBoxValidationSeverity.Info:r=P.default.Info;break;case l.InputBoxValidationSeverity.Warning:r=P.default.Warning;break;case l.InputBoxValidationSeverity.Error:r=P.default.Error;break;default:r=E.message?P.default.Error:P.default.Ignore;break}return{content:E.message,severity:r}}async showWorkspaceFolderPick(I,E=w.CancellationToken.None){const r=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!r)return;const d=await this.a.getWorkspaceFolders2();if(d)return d.find(v=>v.uri.toString()===r.uri.toString())}createQuickPick(I){const E=new o(I,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}createInputBox(I){const E=new y(I,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}$onDidChangeValue(I,E){this.e.get(I)?._fireDidChangeValue(E)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,E){const r=this.e.get(I);r instanceof o&&r._fireDidChangeActive(E)}$onDidChangeSelection(I,E){const r=this.e.get(I);r instanceof o&&r._fireDidChangeSelection(E)}$onDidTriggerButton(I,E){this.e.get(I)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(I,E,r){const d=this.e.get(I);d instanceof o&&d._fireDidTriggerItemButton(E,r)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class k{static{this.a=1}constructor(I,E){this.x=I,this.y=E,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$ed,this.q=new F.$ed,this.r=new F.$ed,this.s=new F.$ed,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((E,r)=>{const d=E===l.$fL.Back?-1:r;this.o.set(d,E)}),this.z({buttons:I.map((E,r)=>({...s(E.iconPath),tooltip:E.tooltip,handle:E===l.$fL.Back?-1:r}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const E=this.o.get(I);E&&this.r.fire(E)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$ec)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(I){if(!this.v){for(const E of Object.keys(I)){const r=I[E];this.u[E]=r===void 0?null:r}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function b(m){if(m instanceof l.$RK)return{id:m.id};const I=a(m),E=n(m);return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof E=="string"?A.URI.file(E):E}}function n(m){return typeof m=="object"&&"light"in m?m.light:m}function a(m){return typeof m=="object"&&"dark"in m?m.dark:m}function s(m){const I=b(m);let E,r;return"id"in I?r=D.ThemeIcon.asClassName(I):E=I,{iconPath:E,iconClass:r}}class o extends k{constructor(I,E){super(I.identifier,E),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$ed,this.L=[],this.M=new F.$ed,this.N=new F.$ed,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((d,v)=>{this.C.set(v,d),this.D.set(d,v)});const E=(0,u.$NF)(this.O,"quickPickItemTooltip"),r=[];for(let d=0;d<I.length;d++){const v=I[d];if(v.kind===l.QuickPickItemKind.Separator)r.push({type:"separator",label:v.label});else{v.tooltip&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const R=v.iconPath?s(v.iconPath):void 0;r.push({handle:d,label:v.label,iconPath:R?.iconPath,iconClass:R?.iconClass,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,tooltip:E?p.MarkdownString.fromStrict(v.tooltip):void 0,buttons:v.buttons?.map((B,V)=>({...s(B.iconPath),tooltip:B.tooltip,handle:V}))})}}this.z({items:r})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(E=>this.D.has(E)),this.z({activeItems:this.J.map(E=>this.D.get(E))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(E=>this.D.has(E)),this.z({selectedItems:this.L.map(E=>this.D.get(E))})}_fireDidChangeActive(I){const E=(0,f.$Eb)(I.map(r=>this.C.get(r)));this.J=E,this.K.fire(E)}_fireDidChangeSelection(I){const E=(0,f.$Eb)(I.map(r=>this.C.get(r)));this.L=E,this.M.fire(E)}_fireDidTriggerItemButton(I,E){const r=this.C.get(I);if(!r||!r.buttons||!r.buttons.length)return;const d=r.buttons[E];d&&this.N.fire({button:d,item:r})}}class y extends k{constructor(I,E){super(I.identifier,E),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:P.default.Error}):this.z({validationMessage:I.message,severity:I.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new g(t,i)}e.$Hbc=$}),define(Ae[249],Re([1,0,2,5,64,6,13,3,18,132,14,20,40,8,26,12]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=e.$Ibc=void 0;function i(E){if(E)return typeof E.iconPath=="string"?w.URI.file(E.iconPath):w.URI.isUri(E.iconPath)||u.ThemeIcon.isThemeIcon(E.iconPath)?E.iconPath:void 0}function c(E,r){if(!E.iconPath&&!r.iconPath)return 0;if(E.iconPath){if(!r.iconPath)return 1}else return-1;const d=typeof E.iconPath=="string"?E.iconPath:w.URI.isUri(E.iconPath)?E.iconPath.fsPath:E.iconPath.id,v=typeof r.iconPath=="string"?r.iconPath:w.URI.isUri(r.iconPath)?r.iconPath.fsPath:r.iconPath.id;return(0,f.$fq)(d,v)}function g(E,r){let d=0;if(E.strikeThrough!==r.strikeThrough)return E.strikeThrough?1:-1;if(E.faded!==r.faded)return E.faded?1:-1;if(E.tooltip!==r.tooltip)return(E.tooltip||"").localeCompare(r.tooltip||"");if(d=c(E,r),d!==0)return d;if(E.light&&r.light)d=c(E.light,r.light);else{if(E.light)return 1;if(r.light)return-1}if(d!==0)return d;if(E.dark&&r.dark)d=c(E.dark,r.dark);else{if(E.dark)return 1;if(r.dark)return-1}return d}function k(E,r){if(E.command!==r.command)return E.command<r.command?-1:1;if(E.title!==r.title)return E.title<r.title?-1:1;if(E.tooltip!==r.tooltip){if(E.tooltip!==void 0&&r.tooltip!==void 0)return E.tooltip<r.tooltip?-1:1;if(E.tooltip!==void 0)return 1;if(r.tooltip!==void 0)return-1}if(E.arguments===r.arguments)return 0;if(E.arguments)if(r.arguments){if(E.arguments.length!==r.arguments.length)return E.arguments.length-r.arguments.length}else return 1;else return-1;for(let d=0;d<E.arguments.length;d++){const v=E.arguments[d],R=r.arguments[d];if(v!==R)return v<R?-1:1}return 0}function b(E,r){let d=(0,f.$fq)(E.resourceUri.fsPath,r.resourceUri.fsPath,!0);if(d!==0)return d;if(E.command&&r.command)d=k(E.command,r.command);else{if(E.command)return 1;if(r.command)return-1}if(d!==0)return d;if(E.decorations&&r.decorations)d=g(E.decorations,r.decorations);else{if(E.decorations)return 1;if(r.decorations)return-1}return d}function n(E,r){for(let d=0;d<E.length;d++)if(E[d]!==r[d])return!1;return!0}function a(E,r){return E.command===r.command&&E.title===r.title&&E.tooltip===r.tooltip&&(E.arguments&&r.arguments?n(E.arguments,r.arguments):E.arguments===r.arguments)}function s(E,r){return(0,S.$sb)(E,r,a)}class o{#e;#t;get value(){return this.d}set value(r){r=r??"",this.#e.$setInputBoxValue(this.l,r),this.n(r)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(r){this.#e.$setInputBoxPlaceholder(this.l,r),this.f=r}get validateInput(){return(0,$.$OF)(this.k,"scmValidation"),this.g}set validateInput(r){if((0,$.$OF)(this.k,"scmValidation"),r&&typeof r!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=r,this.#e.$setValidationProviderIsEnabled(this.l,!!r)}get enabled(){return this.h}set enabled(r){r=!!r,this.h!==r&&(this.h=r,this.#e.$setInputBoxEnablement(this.l,r))}get visible(){return this.j}set visible(r){r=!!r,this.j!==r&&(this.j=r,this.#e.$setInputBoxVisibility(this.l,r))}get document(){return(0,$.$OF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(r,d,v,R,B){this.k=r,this.l=R,this.m=B,this.d="",this.e=new F.$ed,this.f="",this.h=!0,this.j=!0,this.#t=d,this.#e=v}showValidationMessage(r,d){(0,$.$OF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,r,d)}$onInputBoxValueChange(r){this.n(r)}n(r){this.d=r,this.e.fire(r)}}e.$Ibc=o;class y{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(r){this.v=r,this.q.$updateGroupLabel(this.t,this.handle,r)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(r){this.p=r,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(r){this.f=[...r],this.k.fire()}constructor(r,d,v,R,B){this.q=r,this.s=d,this.t=v,this.u=R,this.v=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$ed,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$ed,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=y.d++}getResourceState(r){return this.g.get(r)}$executeResourceCommand(r,d){const v=this.h.get(r);return v?(0,A.$yg)(()=>this.s.executeCommand(v.command,...v.arguments||[],d)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const r=[...this.f].sort(b),v=(0,S.$Ab)(this.o,r,b).map(V=>{const j=V.toInsert.map(W=>{const O=this.e++;this.g.set(O,W);const z=W.resourceUri;let ee;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const ie=new L.$ic;ee=this.s.converter.toInternal(W.command,ie),this.j.set(O,ie)}else this.h.set(O,W.command);const X=i(W.decorations),Ee=W.decorations&&i(W.decorations.light)||X,ke=W.decorations&&i(W.decorations.dark)||X,Pe=[Ee,ke],Z=W.decorations&&W.decorations.tooltip||"",ue=W.decorations&&!!W.decorations.strikeThrough,ye=W.decorations&&!!W.decorations.faded,ce=W.contextValue||"";return{rawResource:[O,z,Pe,Z,ue,ye,ce,ee],handle:O}});return{start:V.start,deleteCount:V.deleteCount,toInsert:j}}),R=v.map(({start:V,deleteCount:j,toInsert:W})=>[V,j,W.map(O=>O.rawResource)]),B=v.reverse();for(const{start:V,deleteCount:j,toInsert:W}of B){const O=W.map(ee=>ee.handle),z=this.n.splice(V,j,...O);for(const ee of z)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.o=r,R}dispose(){this.l=!0,this.m.fire()}}class m{static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(r){this.g!==r&&(this.g=r,this.#e.$updateSourceControl(this.t,{count:r}))}get quickDiffProvider(){return this.h}set quickDiffProvider(r){this.h=r;let d;(0,$.$NF)(this.u,"quickDiffProvider")&&(d=r?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!r,quickDiffLabel:d})}get commitTemplate(){return this.j}set commitTemplate(r){r!==this.j&&(this.j=r,this.#e.$updateSourceControl(this.t,{commitTemplate:r}))}get acceptInputCommand(){return this.l}set acceptInputCommand(r){this.k.value=new L.$ic,this.l=r;const d=this.v.converter.toInternal(r,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:d})}get actionButton(){return(0,$.$OF)(this.u,"scmActionButton"),this.n}set actionButton(r){(0,$.$OF)(this.u,"scmActionButton"),this.m.value=new L.$ic,this.n=r;const d=r!==void 0?{command:this.v.converter.toInternal(r.command,this.m.value),secondaryCommands:r.secondaryCommands?.map(v=>v.map(R=>this.v.converter.toInternal(R,this.m.value))),description:r.description,enabled:r.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:d??null})}get statusBarCommands(){return this.p}set statusBarCommands(r){if(this.p&&r&&s(this.p,r))return;this.o.value=new L.$ic,this.p=r;const d=(r||[]).map(v=>this.v.converter.toInternal(v,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:d})}get selected(){return this.q}constructor(r,d,v,R,B,V,j){this.u=r,this.v=R,this.w=B,this.x=V,this.y=j,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.$kc,this.l=void 0,this.m=new L.$kc,this.o=new L.$kc,this.p=void 0,this.q=!1,this.s=new F.$ed,this.onDidChangeSelection=this.s.event,this.t=m.d++,this.z=new Map,this.A=new Set,this.#e=v;const W=w.URI.from({scheme:h.Schemas.vscodeSourceControl,path:`${B}/scm${this.t}/input`,query:j?`rootUri=${encodeURIComponent(j.toString())}`:void 0});this.f=new o(r,d,this.#e,this.t,W),this.#e.$registerSourceControl(this.t,B,V,j,W)}createResourceGroup(r,d){const v=new y(this.#e,this.v,this.t,r,d),R=F.Event.once(v.onDidDispose)(()=>this.z.delete(v));return this.z.set(v,R),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const r=[],d=[];for(const[v,R]of this.z){R.dispose();const B=v.onDidUpdateResourceStates(()=>{this.A.add(v),this.eventuallyUpdateResourceStates()});F.Event.once(v.onDidDispose)(()=>{this.A.delete(v),B.dispose(),this.e.delete(v.handle),this.#e.$unregisterGroup(this.t,v.handle)}),r.push([v.handle,v.id,v.label,v.features]);const V=v._takeResourceStateSnapshot();V.length>0&&d.push([v.handle,V]),this.e.set(v.handle,v)}this.#e.$registerGroups(this.t,r,d),this.z.clear()}eventuallyUpdateResourceStates(){const r=[];this.A.forEach(d=>{const v=d._takeResourceStateSnapshot();v.length!==0&&r.push([d.handle,v])}),r.length>0&&this.#e.$spliceResourceStates(this.t,r),this.A.clear()}getResourceGroup(r){return this.e.get(r)}setSelectionState(r){this.q=r,this.s.fire(r)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(r=>r.dispose()),this.#e.$unregisterSourceControl(this.t)}}Ke([(0,C.$6g)(100)],m.prototype,"eventuallyAddResourceGroups",null),Ke([(0,C.$6g)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let I=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(r,d,v,R){this.l=d,this.m=v,this.n=R,this.g=new Map,this.h=new D.$Wl,this.j=new F.$ed,this.e=r.getProxy(l.$UJ.MainThreadSCM),this.f=r.getProxy(l.$UJ.MainThreadTelemetry),d.registerArgumentProcessor({processArgument:B=>{if(B&&B.$mid===3){const V=this.g.get(B.sourceControlHandle);if(!V)return B;const j=V.getResourceGroup(B.groupHandle);return j?j.getResourceState(B.handle):B}else if(B&&B.$mid===4){const V=this.g.get(B.sourceControlHandle);return V?V.getResourceGroup(B.groupHandle):B}else if(B&&B.$mid===5){const V=this.g.get(B.handle);return V||B}return B}})}createSourceControl(r,d,v,R){this.n.trace("ExtHostSCM#createSourceControl",r.identifier.value,d,v,R),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:r.identifier.value});const B=t.d++,V=new m(r,this.m,this.e,this.l,d,v,R);this.g.set(B,V);const j=this.h.get(r.identifier)||[];return j.push(V),this.h.set(r.identifier,j),V}getLastInputBox(r){this.n.trace("ExtHostSCM#getLastInputBox",r.identifier.value);const d=this.h.get(r.identifier),v=d&&d[d.length-1];return v&&v.inputBox}$provideOriginalResource(r,d,v){const R=w.URI.revive(d);this.n.trace("ExtHostSCM#$provideOriginalResource",r,R.toString());const B=this.g.get(r);return!B||!B.quickDiffProvider||!B.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$yg)(()=>B.quickDiffProvider.provideOriginalResource(R,v)).then(V=>V||null)}$onInputBoxValueChange(r,d){this.n.trace("ExtHostSCM#$onInputBoxValueChange",r);const v=this.g.get(r);return v&&v.inputBox.$onInputBoxValueChange(d),Promise.resolve(void 0)}$executeResourceCommand(r,d,v,R){this.n.trace("ExtHostSCM#$executeResourceCommand",r,d,v);const B=this.g.get(r);if(!B)return Promise.resolve(void 0);const V=B.getResourceGroup(d);return V?V.$executeResourceCommand(v,R):Promise.resolve(void 0)}$validateInput(r,d,v){this.n.trace("ExtHostSCM#$validateInput",r);const R=this.g.get(r);return!R||!R.inputBox.validateInput?Promise.resolve(void 0):(0,A.$yg)(()=>R.inputBox.validateInput(d,v)).then(B=>{if(!B)return Promise.resolve(void 0);const V=p.MarkdownString.fromStrict(B.message);return V?Promise.resolve([V,B.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(r){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",r),r!==void 0&&this.g.get(r)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=r,Promise.resolve(void 0)}};e.$Jbc=I,e.$Jbc=I=t=Ke([Ve(3,P.$4i)],I)}),define(Ae[83],Re([1,0,3,5,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=e.$obc=void 0;class L{constructor(l){this.b=new F.$ed,this.onDidChangePassword=this.b.event,this.a=l.getProxy(w.$UJ.MainThreadSecretState)}async $onDidChangePassword(l){this.b.fire(l)}get(l,S){return this.a.$getPassword(l,S)}store(l,S,f){return this.a.$setPassword(l,S,f)}delete(l,S){return this.a.$deletePassword(l,S)}}e.$obc=L,e.$pbc=(0,C.$Ah)("IExtHostSecretState")}),define(Ae[250],Re([1,0,3,8,2]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;class L{static{this.a=0}constructor(l,S){this.d=S,this.c=new Map,this.b=l.getProxy(w.$UJ.MainThreadShare)}async $provideShare(l,S,f){return await this.c.get(l)?.provideShare({selection:F.Range.to(S.selection),resourceUri:C.URI.revive(S.resourceUri)},f)??void 0}registerShareProvider(l,S){const f=L.a++;return this.c.set(f,S),this.b.$registerShareProvider(f,F.DocumentSelector.from(l,this.d),S.id,S.label,S.priority),{dispose:()=>{this.b.$unregisterShareProvider(f),this.c.delete(f)}}}}e.$Lcc=L}),define(Ae[251],Re([1,0,7,3,154,6,8,16]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=e.$Kbc=void 0;class S{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$SK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$SK("statusBarItem.warningForeground")]])}#e;#t;constructor(u,p,$,h,t,i=w.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new L.$ic,this.#e=u,this.#t=p,t&&h){this.c=(0,w.$vK)(h.identifier,t);const g=$.get(this.c);g&&(i=g.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,c=g.priority,this.j=!0,this.name=g.name,this.text=g.text,this.tooltip=g.tooltip,this.command=g.command,this.accessibilityInformation=g.accessibilityInformation)}else this.c=String(S.a++);this.e=h,this.f=t,this.g=i,this.h=this.u(c)}u(u){if((0,l.$mf)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!S.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new L.$ic,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let $=this.n;this.o&&($=S.b.get(this.o.id));const h=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,p,this.k,h,this.r?.internal,$,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Kbc=S;class f{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const p={message:u};return this.b.unshift(p),this.c(),new w.$WJ(()=>{const $=this.b.indexOf(p);$>=0&&(this.b.splice($,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(u,p){this.e=new Map,this.a=u.getProxy(F.$UJ.MainThreadStatusBar),this.b=p,this.c=new f(this)}$acceptStaticEntries(u){for(const p of u)this.e.set(p.entryId,p)}createStatusBarEntry(u,p,$,h){return new S(this.a,this.b,this.e,u,p,$,h)}setStatusBarMessage(u,p){const $=this.c.setMessage(u);let h;return typeof p=="number"?h=setTimeout(()=>$.dispose(),p):typeof p<"u"&&p.then(()=>$.dispose(),()=>$.dispose()),new w.$WJ(()=>{$.dispose(),clearTimeout(h)})}}e.$Lbc=P}),define(Ae[84],Re([1,0,3,5,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=e.$cbc=void 0;class L{constructor(l,S){this.c=S,this.b=new F.$ed,this.onDidChangeStorage=this.b.event,this.a=l.getProxy(w.$UJ.MainThreadStorage)}registerExtensionStorageKeysToSync(l,S){this.a.$registerExtensionStorageKeysToSync(l,S)}async initializeExtensionStorage(l,S,f){const P=await this.a.$initializeExtensionStorage(l,S);let D;return P&&(D=this.d(l,S,P)),D||f}setValue(l,S,f){return this.a.$setValue(l,S,f)}$acceptValue(l,S,f){const P=this.d(l,S,f);P&&this.b.fire({shared:l,key:S,value:P})}d(l,S,f){try{return JSON.parse(f)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${l}): ${P}`)}}}e.$cbc=L,e.$dbc=(0,C.$Ah)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,61,2]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=e.$ibc=void 0,e.$ibc=(0,w.$Ah)("IExtensionStoragePaths");let l=class{constructor(f,P,D){this.d=P,this.f=D,this.a=f.workspace??void 0,this.b=f.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(f){return A.URI.joinPath(this.b.workspaceStorageHome,f)}async h(){if(!this.a)return Promise.resolve(void 0);const f=this.a.id,P=await this.g(f);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(f){if(this.c)return A.URI.joinPath(this.c,f.identifier.value)}globalValue(f){return A.URI.joinPath(this.b.globalStorageHome,f.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$jbc=l,e.$jbc=l=Ke([Ve(0,F.$aM),Ve(1,C.$4i),Ve(2,L.$hbc)],l)}),define(Ae[62],Re([1,0,5,3,4,2,17,6,7,156,9,182,21,36,183,40,13,8,31]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=e.$mbc=e.$lbc=e.$kbc=void 0,e.$kbc=(0,C.$Ah)("IExtHostTerminalService");class g{constructor(r,d,v,R){this.k=r,this._id=d,this.l=v,this.m=R,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(V=>this.f=V);const B=this;this.value={get name(){return B.m||""},get processId(){return B.b},get creationOptions(){return B.l},get exitStatus(){return B.h},get state(){return B.i},get selection(){return B.j},sendText(V,j=!0){B.o(),B.k.$sendText(B._id,V,j)},show(V){B.o(),B.k.$show(B._id,V)},hide(){B.o(),B.k.$hide(B._id)},dispose(){B.a||(B.a=!0,B.k.$dispose(B._id))},get dimensions(){if(!(B.d===void 0||B.g===void 0))return{columns:B.d,rows:B.g}}}}async create(r,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:r.name,shellPath:r.shellPath??void 0,shellArgs:r.shellArgs??void 0,cwd:r.cwd??void 0,env:r.env??void 0,icon:y(r.iconPath)??void 0,color:h.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:r.message??void 0,strictEnv:r.strictEnv??void 0,hideFromUser:r.hideFromUser??void 0,isFeatureTerminal:d?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:d?.useShellEnvironment??void 0,location:d?.location||this.n(r.location,d?.resolvedExtHostIdentifier),isTransient:r.isTransient??void 0})}async createExtensionTerminal(r,d,v,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:v,color:h.ThemeColor.isThemeColor(R)?R.id:void 0,location:this.n(r,d),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(r,d){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in r?{viewColumn:i.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus}:void 0:r}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(r){this.m=r}setExitStatus(r,d){this.h=Object.freeze({code:r,reason:d})}setDimensions(r,d){return r===this.d&&d===this.g||r===0||d===0?!1:(this.d=r,this.g=d,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(r){this.j=r}_setProcessId(r){this.f?(this.f(r),this.f=void 0):this.b.then(d=>{d!==r&&(this.b=Promise.resolve(r))})}}e.$lbc=g;class k{get onProcessReady(){return this.b.event}constructor(r){this.g=r,this.id=0,this.shouldPersist=!1,this.a=new w.$ed,this.onProcessData=this.a.event,this.b=new w.$ed,this.d=new w.$ed,this.onDidChangeProperty=this.d.event,this.f=new w.$ed,this.onProcessExit=this.f.event}refreshProperty(r){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${r}`)}updateProperty(r,d){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${r}, value: ${d}`)}async start(){}shutdown(){this.g.close()}input(r){this.g.handleInput?.(r)}resize(r,d){this.g.setDimensions?.({columns:r,rows:d})}clearBuffer(){}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(r){this.g.onDidWrite(d=>this.a.fire(d)),this.g.onDidClose?.((d=void 0)=>{this.f.fire(d===void 0?void 0:d)}),this.g.onDidOverrideDimensions?.(d=>{d&&this.d.fire({type:"overrideDimensions",value:{cols:d.columns,rows:d.rows}})}),this.g.onDidChangeName?.(d=>{this.d.fire({type:"title",value:d})}),this.g.open(r||void 0),r&&this.g.setDimensions?.(r),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let b=1,n=class extends l.$jc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(r=>r.value)}constructor(r,d,v){super(),this.Q=d,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new l.$kc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$ed,this.onDidCloseTerminal=this.H.event,this.I=new w.$ed,this.onDidOpenTerminal=this.I.event,this.J=new w.$ed,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$ed,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$ed,this.onDidChangeTerminalState=this.M.event,this.N=new w.$ed,this.onDidChangeShell=this.N.event,this.O=new w.$ed({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$ed({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=v.getProxy(F.$UJ.MainThreadTerminalService),this.y=new $.$Dkb(this.a.$sendProcessData),this.a.$registerProcessSupport(r),this.B({dispose:()=>{for(const[R,B]of this.g)B.shutdown(!0)}})}getDefaultShell(r){return(r?this.u:this.s)?.path||""}getDefaultShellArgs(r){return(r?this.u:this.s)?.args||[]}createExtensionTerminal(r,d){const v=new g(this.a,(0,p.$3f)(),r,r.name),R=new k(r.pty);return v.createExtensionTerminal(r.location,this.R(r,d).resolvedExtHostIdentifier,y(r.iconPath),m(r.color)).then(B=>{const V=this.S(B,R);this.h[B]=V}),this.f.push(v),v.value}R(r,d){if(d=d||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const v=r.location.parentTerminal;if(v){const R=this.f.find(B=>B.value===v);R&&(d.resolvedExtHostIdentifier=R._id)}}else r.location&&typeof r.location!="object"?d.location=r.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(r,d){if(!this.W(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const R=new k(d),B=this.S(r,R);this.h[r]=B}async $acceptActiveTerminalChanged(r){const d=this.b;if(r===null){this.b=void 0,d!==this.b&&this.J.fire(this.b);return}const v=this.W(r);v&&(this.b=v,d!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(r,d){const v=this.W(r);v&&this.O.fire({terminal:v.value,data:d})}async $acceptTerminalDimensions(r,d,v){const R=this.W(r);R&&R.setDimensions(d,v)&&this.L.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptDidExecuteCommand(r,d){const v=this.W(r);v&&this.P.fire({terminal:v.value,...d})}async $acceptTerminalMaximumDimensions(r,d,v){this.g.get(r)?.resize(d,v)}async $acceptTerminalTitleChange(r,d){const v=this.W(r);v&&(v.name=d)}async $acceptTerminalClosed(r,d,v){const R=this.Y(this.f,r);if(R!==null){const B=this.f.splice(R,1)[0];B.setExitStatus(d,v),this.H.fire(B.value)}}$acceptTerminalOpened(r,d,v,R){if(d){const j=this.Y(this.f,d);if(j!==null){this.f[j]._id=r,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const B={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:L.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},V=new g(this.a,r,B,v);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(r,d){this.W(r)?._setProcessId(d)}async $startExtensionTerminal(r,d){const v=this.W(r);if(!v)return{message:(0,f.localize)(0,null,r)};v.isOpen||await new Promise(B=>{const V=this.onDidOpenTerminal(async j=>{j===v.value&&(V.dispose(),B())})});const R=this.g.get(r);R?R.startSendingEvents(d):this.j[r]={initialDimensions:d}}S(r,d){const v=new l.$ic;v.add(d.onProcessReady(B=>this.a.$sendProcessReady(r,B.pid,B.cwd,B.windowsPty))),v.add(d.onDidChangeProperty(B=>this.a.$sendProcessProperty(r,B))),this.y.startBuffering(r,d.onProcessData),v.add(d.onProcessExit(B=>this.U(r,B))),this.g.set(r,d);const R=this.j[r];return R&&d instanceof k&&(d.startSendingEvents(R.initialDimensions),delete this.j[r]),v}$acceptProcessAckDataEvent(r,d){this.g.get(r)?.acknowledgeDataEvent(d)}$acceptProcessInput(r,d){this.g.get(r)?.input(d)}$acceptTerminalInteraction(r){const d=this.W(r);d?.setInteractedWith()&&this.M.fire(d.value)}$acceptTerminalSelection(r,d){this.W(r)?.setSelection(d)}$acceptProcessResize(r,d,v){try{this.g.get(r)?.resize(d,v)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(r,d){this.g.get(r)?.shutdown(d)}$acceptProcessRequestInitialCwd(r){this.g.get(r)?.getInitialCwd().then(d=>this.a.$sendProcessProperty(r,{type:"initialCwd",value:d}))}$acceptProcessRequestCwd(r){this.g.get(r)?.getCwd().then(d=>this.a.$sendProcessProperty(r,{type:"cwd",value:d}))}$acceptProcessRequestLatency(r){return Promise.resolve(r)}registerLinkProvider(r){return this.z.add(r),this.z.size===1&&this.a.$startLinkProvider(),new S.$WJ(()=>{this.z.delete(r),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(r,d,v){if(this.C.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this.C.set(d,v),this.a.$registerProfileProvider(d,r.identifier.value),new S.$WJ(()=>{this.C.delete(d),this.a.$unregisterProfileProvider(d)})}registerTerminalQuickFixProvider(r,d,v){if(this.D.has(r))throw new Error(`Terminal quick fix provider "${r}" is already registered`);return this.D.set(r,v),this.a.$registerQuickFixProvider(r,d),new S.$WJ(()=>{this.D.delete(r),this.a.$unregisterQuickFixProvider(r)})}async $provideTerminalQuickFixes(r,d){const v=new u.$od().token;if(v.isCancellationRequested)return;const R=this.D.get(r);if(!R)return;const B=await R.provideTerminalQuickFixes(d,v);if(B===null||Array.isArray(B)&&B.length===0)return;const V=new l.$ic;if(this.w.value=V,!Array.isArray(B))return B?i.TerminalQuickFix.from(B,this.Q.converter,V):void 0;const j=[];for(const W of B){const O=i.TerminalQuickFix.from(W,this.Q.converter,V);O&&j.push(O)}return j}async $createContributedProfileTerminal(r,d){const v=new u.$od().token;let R=await this.C.get(r)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(R&&!("options"in R)&&(R={options:R}),!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,d);return}this.createTerminalFromOptions(R.options,d)}}async $provideLinks(r,d){const v=this.W(r);if(!v)return[];this.F.delete(r),this.G.get(r)?.dispose(!0);const B=new u.$od;this.G.set(r,B);const V=[],j={terminal:v.value,line:d},W=[];for(const ee of this.z)W.push(t.Promises.withAsyncBody(async X=>{B.token.onCancellationRequested(()=>X({provider:ee,links:[]}));const Ee=await ee.provideTerminalLinks(j,B.token)||[];B.token.isCancellationRequested||X({provider:ee,links:Ee})}));const O=await Promise.all(W);if(B.token.isCancellationRequested)return[];const z=new Map;for(const ee of O)ee&&ee.links.length>0&&V.push(...ee.links.map(X=>{const Ee={id:b++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return z.set(Ee.id,{provider:ee.provider,link:X}),Ee}));return this.F.set(r,z),V}$activateLink(r,d){const v=this.F.get(r)?.get(d);v&&v.provider.handleTerminalLink(v.link)}U(r,d){this.y.stopBuffering(r),this.g.delete(r),delete this.j[r];const v=this.h[r];v&&(v.dispose(),delete this.h[r]),this.a.$sendProcessExit(r,d)}W(r){return this.X(this.f,r)}X(r,d){const v=this.Y(r,d);return v!==null?r[v]:null}Y(r,d){const v=r.findIndex(R=>R._id===d);return v===-1?null:v}getEnvironmentVariableCollection(r){let d=this.n.get(r.identifier.value);return d||(d=new a,this.$(r.identifier.value,d)),d.getScopedEnvironmentVariableCollection(void 0)}Z(r,d){const v=(0,D.$$q)(d.map),R=(0,D.$_q)(d.descriptionMap);this.a.$setEnvironmentVariableCollection(r,d.persistent,v.length===0?void 0:v,R)}$initEnvironmentVariableCollections(r){r.forEach(d=>{const v=d[0],R=new a(d[1]);this.$(v,R)})}$acceptDefaultProfile(r,d){const v=this.s;this.s=r,this.u=d,v?.path!==r.path&&this.N.fire(r.path)}$(r,d){this.n.set(r,d),d.onDidChangeCollection(()=>{this.Z(r,d)})}};e.$mbc=n,e.$mbc=n=Ke([Ve(1,c.$gM),Ve(2,A.$WL)],n);class a{get persistent(){return this.b}set persistent(r){this.b=r,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(r){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new w.$ed,this.map=new Map(r)}getScopedEnvironmentVariableCollection(r){const d=this.h(r);let v=this.a.get(d);return v||(v=new s(this,r),this.a.set(d,v),v.onDidChangeCollection(()=>this.d.fire())),v}replace(r,d,v,R){this.f(r,{value:d,type:S.EnvironmentVariableMutatorType.Replace,options:v??{applyAtProcessCreation:!0},scope:R})}append(r,d,v,R){this.f(r,{value:d,type:S.EnvironmentVariableMutatorType.Append,options:v??{applyAtProcessCreation:!0},scope:R})}prepend(r,d,v,R){this.f(r,{value:d,type:S.EnvironmentVariableMutatorType.Prepend,options:v??{applyAtProcessCreation:!0},scope:R})}f(r,d){if(d.options&&d.options.applyAtProcessCreation===!1&&!d.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const v=this.g(r,d.scope),R=this.map.get(v),B=d.options?{applyAtProcessCreation:d.options.applyAtProcessCreation??!1,applyAtShellIntegration:d.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!R||R.value!==d.value||R.type!==d.type||R.options?.applyAtProcessCreation!==B.applyAtProcessCreation||R.options?.applyAtShellIntegration!==B.applyAtShellIntegration||R.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index){const V=this.g(r,d.scope),j={variable:r,...d,options:B};this.map.set(V,j),this.d.fire()}}get(r,d){const v=this.g(r,d),R=this.map.get(v);return R?I(R):void 0}g(r,d){const v=this.h(d);return v.length?`${r}:::${v}`:r}h(r){return this.i(r?.workspaceFolder)??""}i(r){return r?r.uri.toString():void 0}getVariableMap(r){const d=new Map;for(const[v,R]of this.map)this.h(R.scope)===this.h(r)&&d.set(R.variable,I(R));return d}delete(r,d){const v=this.g(r,d);this.map.delete(v),this.d.fire()}clear(r){if(r?.workspaceFolder){for(const[d,v]of this.map)v.scope?.workspaceFolder?.index===r.workspaceFolder.index&&this.map.delete(d);this.j(r)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(r,d){const v=this.h(d),R=this.descriptionMap.get(v);if(!R||R.description!==r){let B;typeof r=="string"?B=r:B=r?.value.split(`

`)[0];const V={description:B,scope:d};this.descriptionMap.set(v,V),this.d.fire()}}getDescription(r){const d=this.h(r);return this.descriptionMap.get(d)?.description}j(r){const d=this.h(r);this.descriptionMap.delete(d)}}class s{get persistent(){return this.b.persistent}set persistent(r){this.b.persistent=r}get onDidChangeCollection(){return this.a&&this.a.event}constructor(r,d){this.b=r,this.d=d,this.a=new w.$ed}getScoped(r){return this.b.getScopedEnvironmentVariableCollection(r)}replace(r,d,v){this.b.replace(r,d,v,this.d)}append(r,d,v){this.b.append(r,d,v,this.d)}prepend(r,d,v){this.b.prepend(r,d,v,this.d)}get(r){return this.b.get(r,this.d)}forEach(r,d){this.b.getVariableMap(this.d).forEach((v,R)=>r.call(d,R,v,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(r){this.b.delete(r,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(r){this.b.setDescription(r,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends n{constructor(r,d){super(!1,r,d)}createTerminal(r,d,v){throw new P.$0}createTerminalFromOptions(r,d){throw new P.$0}};e.$nbc=o,e.$nbc=o=Ke([Ve(0,c.$gM),Ve(1,A.$WL)],o);function y(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function m(E){return h.ThemeColor.isThemeColor(E)?E:void 0}function I(E){const r={...E};return delete r.scope,r.options=r.options??void 0,delete r.variable,r}}),define(Ae[252],Re([1,0,281,13,25,21,5,203,93,6,24,16,36,3,17,105,8,7,45,76,56,26]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t,i,c,g,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=e.$wcc=e.$vcc=e.$ucc=void 0;let n=class{constructor(j,W,O){this.k=O,this.d=new A.$ed,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=j.getProxy(p.$UJ.MainThreadTesting),this.j=new v(this.g),this.h=new y(this.g),W.registerArgumentProcessor({processArgument:z=>{switch(z?.$mid){case 15:{const ee=z,X=ee.tests[ee.tests.length-1].item.extId;return this.f.get(c.$HI.root(X))?.collection.tree.get(X)?.actual??(0,h.$9L)(z)}case 17:{const{extId:ee,message:X}=z;return{test:this.f.get(c.$HI.root(ee))?.collection.tree.get(ee)?.actual,message:t.TestMessage.to(X)}}default:return z}}}),W.registerCommand(!1,"testing.getExplorerSelection",async()=>{const z=await W.executeCommand("_testing.getExplorerSelection"),ee=X=>{const Ee=this.f.get(c.$HI.root(X));if(Ee)return c.$HI.isRoot(X)?Ee.controller:Ee.collection.tree.get(X)?.actual};return{include:z?.include.map(ee).filter(D.$qf)||[],exclude:z?.exclude.map(ee).filter(D.$qf)||[]}})}createTestController(j,W,O,z){if(this.f.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const ee=new f.$ic,X=ee.add(new h.$_L(W,O,this.k));X.root.label=O;const Ee=new Map,ke=this.g,Pe={items:X.root.children,get label(){return O},set label(ue){O=ue,X.root.label=ue,ke.$updateController(W,{label:O})},get refreshHandler(){return z},set refreshHandler(ue){z=ue,ke.$updateController(W,{canRefresh:!!ue})},get id(){return W},createRunProfile:(ue,ye,ce,$e,ie,N)=>{let q=(0,S.$oi)(ue);for(;Ee.has(q);)q++;return new R(this.g,Ee,W,q,ue,ye,ce,$e,ie,N)},createTestItem(ue,ye,ce){return new h.$0L(W,ue,ye,ce)},createTestRun:(ue,ye,ce=!0)=>this.h.createTestRun(j,W,X,ue,ye,ce),invalidateTestResults:ue=>{if(ue===void 0)this.g.$markTestRetired(void 0);else{const ye=ue instanceof Array?ue:[ue];this.g.$markTestRetired(ye.map(ce=>c.$HI.fromExtHostTestItem(ce,W).toString()))}},set resolveHandler(ue){X.resolveHandler=ue},get resolveHandler(){return X.resolveHandler},dispose:()=>{ee.dispose()}};ke.$registerTestController(W,O,!!z),ee.add((0,f.$hc)(()=>ke.$unregisterTestController(W)));const Z={controller:Pe,collection:X,profiles:Ee,extension:j};return this.f.set(W,Z),ee.add((0,f.$hc)(()=>this.f.delete(W))),ee.add(X.onDidGenerateDiff(ue=>ke.$publishDiff(W,ue.map(k.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.j.checkout()}async runTests(j,W=L.CancellationToken.None){const O=m(j);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.f.get(O.controllerId);if(!z)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(ee=>c.$HI.fromExtHostTestItem(ee,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:B[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:j.exclude?.map(ee=>ee.id)},W)}$syncTests(){for(const{collection:j}of this.f.values())j.flushDiff();return Promise.resolve()}$provideFileCoverage(j,W,O){return(0,w.$pb)(this.h.trackers,ee=>ee.id===j?ee.getCoverage(W):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(j,W,O,z){return(0,w.$pb)(this.h.trackers,X=>X.id===j?X.getCoverage(W):void 0)?.resolveFileCoverage(O,z)??Promise.resolve([])}$configureRunProfile(j,W){this.f.get(j)?.profiles.get(W)?.configureHandler?.()}async $refreshTests(j,W){await this.f.get(j)?.controller.refreshHandler?.(W)}$publishTestResults(j){this.results=Object.freeze(j.map(W=>(0,P.$Vm)(t.TestResults.to(W))).concat(this.results).sort((W,O)=>O.completedAt-W.completedAt).slice(0,32)),this.d.fire()}async $expandTest(j,W){const O=this.f.get(c.$HI.fromString(j).controllerId)?.collection;O&&(await O.expand(j,W<0?1/0:W),O.flushDiff())}$acceptDiff(j){this.j.applyDiff(j.map(k.TestsDiffOp.deserialize))}async $runControllerTests(j,W){return Promise.all(j.map(O=>this.l(O,!1,W)))}async $startContinuousRun(j,W){const O=new L.$od(W),z=await Promise.all(j.map(ee=>this.l(ee,!0,O.token)));return!W.isCancellationRequested&&!z.some(ee=>ee.error)&&await new Promise(ee=>W.onCancellationRequested(ee)),O.dispose(!0),z}async l(j,W,O){const z=this.f.get(j.controllerId);if(!z)return{};const{collection:ee,profiles:X,extension:Ee}=z,ke=X.get(j.profileId);if(!ke)return{};const Pe=j.testIds.map(ce=>ee.tree.get(ce)).filter(D.$qf),Z=j.excludeExtIds.map(ce=>z.collection.tree.get(ce)).filter(D.$qf).filter(ce=>Pe.some($e=>$e.fullId.compare(ce.fullId)===2));if(!Pe.length)return{};const ue=new i.$tL(Pe.some(ce=>ce.actual instanceof h.$$L)?void 0:Pe.map(ce=>ce.actual),Z.map(ce=>ce.actual),ke,W),ye=(0,k.$JI)(j)&&this.h.prepareForMainThreadTestRun(ue,I.fromInternal(j,z.collection),Ee,O);try{return await ke.runHandler(ue,O),{}}catch(ce){return{error:String(ce)}}finally{ye&&(ye.hasRunningTasks&&!O.isCancellationRequested&&await A.Event.toPromise(ye.onEnd),ye.dispose())}}$cancelExtensionTestRun(j){j===void 0?this.h.cancelAllRuns():this.h.cancelRunById(j)}};e.$ucc=n,e.$ucc=n=Ke([Ve(0,$.$WL)],n);const a=1e4;var s;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(s||(s={}));class o extends f.$jc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(j,W,O,z){super(),this.s=j,this.u=W,this.w=O,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$ed),this.onEnd=this.m.event,this.j=this.B(new L.$od(z));const ee=this.B(new F.$Rg(()=>this.y(),a));this.B(this.j.token.onCancellationRequested(()=>ee.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(j){return this.g.get(j)?.coverage}createRun(j){const W=this.s.id,O=this.s.controllerId,z=(0,u.$3f)(),ee=new E(this.u,W,z),X=Z=>(ue,...ye)=>{if(ke){console.warn(`Setting the state of test "${ue.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ue)&&(this.C(ue),Z(ue,...ye))},Ee=(Z,ue)=>{const ye=ue instanceof Array?ue.map(t.TestMessage.from):[t.TestMessage.from(ue)];if(ye.some(ce=>ce.contextValue!==void 0)&&(0,b.$OF)(this.w,"testMessageContextValue"),Z.uri&&Z.range){const ce={range:t.Range.from(Z.range),uri:Z.uri};for(const $e of ye)$e.location=$e.location||ce}this.u.$appendTestMessagesInRun(W,z,c.$HI.fromExtHostTestItem(Z,O).toString(),ye)};let ke=!1;const Pe={isPersisted:this.s.isPersisted,token:this.j.token,name:j,get coverageProvider(){return ee.coverageProvider},set coverageProvider(Z){ee.coverageProvider=Z},enqueued:X(Z=>{this.u.$updateTestStateInRun(W,z,c.$HI.fromExtHostTestItem(Z,O).toString(),1)}),skipped:X(Z=>{this.u.$updateTestStateInRun(W,z,c.$HI.fromExtHostTestItem(Z,O).toString(),5)}),started:X(Z=>{this.u.$updateTestStateInRun(W,z,c.$HI.fromExtHostTestItem(Z,O).toString(),2)}),errored:X((Z,ue,ye)=>{Ee(Z,ue),this.u.$updateTestStateInRun(W,z,c.$HI.fromExtHostTestItem(Z,O).toString(),6,ye)}),failed:X((Z,ue,ye)=>{Ee(Z,ue),this.u.$updateTestStateInRun(W,z,c.$HI.fromExtHostTestItem(Z,O).toString(),4,ye)}),passed:X((Z,ue)=>{this.u.$updateTestStateInRun(W,z,c.$HI.fromExtHostTestItem(Z,this.s.controllerId).toString(),3,ue)}),appendOutput:(Z,ue,ye)=>{ke||(ye&&(this.s.isIncluded(ye)?this.C(ye):ye=void 0),this.u.$appendOutputToRun(W,z,C.$Ed.fromString(Z),ue&&t.location.from(ue),ye&&c.$HI.fromExtHostTestItem(ye,O).toString()))},end:()=>{ke||(ke=!0,this.u.$finishedTestRunTask(W,z),this.g.delete(z),this.g.size||this.z())}};return this.g.set(z,{run:Pe,coverage:ee}),this.u.$startedTestRunTask(W,{id:z,name:j,running:!0}),Pe}y(){for(const{run:j}of this.g.values())j.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(j){if(!(j instanceof h.$0L))throw new g.$OL(j.id);if(this.h.has(c.$HI.fromExtHostTestItem(j,this.s.controllerId).toString()))return;const W=[],O=this.s.colllection.root;for(;;){const z=t.TestItem.from(j);if(W.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),j===O))break;j=j.parent||O}this.u.$addTestsToRun(this.s.controllerId,this.s.id,W)}dispose(){this.z(),super.dispose()}}class y{get trackers(){return this.d.values()}constructor(j){this.f=j,this.d=new Map}prepareForMainThreadTestRun(j,W,O,z){return this.g(j,W,O,z)}cancelRunById(j){for(const W of this.d.values())if(W.id===j){W.cancel();return}}cancelAllRuns(){for(const j of this.d.values())j.cancel()}createTestRun(j,W,O,z,ee,X){const Ee=this.d.get(z);if(Ee)return Ee.createRun(ee);const ke=I.fromPublic(W,O,z,X),Pe=m(z);this.f.$startedExtensionTestRun({controllerId:W,continuous:!!z.continuous,profile:Pe&&{group:B[Pe.kind],id:Pe.profileId},exclude:z.exclude?.map(ue=>c.$HI.fromExtHostTestItem(ue,O.root.id).toString())??[],id:ke.id,include:z.include?.map(ue=>c.$HI.fromExtHostTestItem(ue,O.root.id).toString())??[O.root.id],persist:X});const Z=this.g(z,ke,j);return A.Event.once(Z.onEnd)(()=>{this.f.$finishedExtensionTestRun(ke.id),Z.dispose()}),Z.createRun(ee)}g(j,W,O,z){const ee=new o(W,this.f,O,z);return this.d.set(j,ee),A.Event.once(ee.onEnd)(()=>this.d.delete(j)),ee}}e.$vcc=y;const m=V=>{if(V.profile){if(!(V.profile instanceof R))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class I{static fromPublic(j,W,O,z){return new I(j,(0,u.$3f)(),O.include?.map(ee=>c.$HI.fromExtHostTestItem(ee,j).toString())??[j],O.exclude?.map(ee=>c.$HI.fromExtHostTestItem(ee,j).toString())??[],z,W)}static fromInternal(j,W){return new I(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,W)}constructor(j,W,O,z,ee,X){this.controllerId=j,this.id=W,this.isPersisted=ee,this.colllection=X,this.d=O.map(Ee=>Ee+"\0"),this.f=z.map(Ee=>Ee+"\0")}isIncluded(j){const W=c.$HI.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const O of this.f)if(W===O||W.startsWith(O))return!1;for(const O of this.d)if(W===O||W.startsWith(O))return!0;return!1}}e.$wcc=I;class E{set coverageProvider(j){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");j&&(this.d=j,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(j,W,O){this.g=j,this.h=W,this.j=O}async provideFileCoverage(j){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(j))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(W){throw this.f=void 0,W}}async resolveFileCoverage(j,W){const O=await this.f;let z=O?.[j];return!this.d||!O||!z?[]:(z.detailedCoverage||(z=O[j]=await this.d.resolveFileCoverage?.(z,W)??z),z.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class r{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(j){this.j=j,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(j){this.d.add(j)}update(j){Object.assign(j.revived,t.TestItem.toPlain(j.item)),this.d.has(j)||this.f.add(j)}remove(j){if(this.d.has(j)){this.d.delete(j);return}this.f.delete(j);const W=c.$HI.parentId(j.item.extId);if(W&&this.h.has(W.toString())){this.h.add(j.item.extId);return}this.g.add(j)}getChangeEvent(){const{d:j,f:W,g:O}=this;return{get added(){return[...j].map(z=>z.revived)},get updated(){return[...W].map(z=>z.revived)},get removed(){return[...O].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class d extends k.$OI{constructor(){super(...arguments),this.s=new A.$ed,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(j){return this.f.get(j)}getMirroredTestDataByReference(j){return this.f.get(j.id)}q(j,W){return{...j,revived:t.TestItem.toPlain(j.item),depth:W?W.depth+1:0,children:new Set}}p(){return new r(this.s)}}class v{constructor(j){this.f=j}checkout(){this.d||(this.d=this.g());const j=this.d;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(W=>W.revived)},dispose:(0,l.$bb)(()=>{--j.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(j){return this.d?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.d?.tests.apply(j)}g(){const j=new d;return this.f.$subscribeToDiffs(),{observers:0,tests:j}}}class R{#e;#t;get label(){return this.f}set label(j){j!==this.f&&(this.f=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:j}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(j){j!==this.h&&(this.h=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:j}))}get isDefault(){return this.g}set isDefault(j){j!==this.g&&(this.g=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:j?t.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.d}set configureHandler(j){j!==this.d&&(this.d=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!j}))}constructor(j,W,O,z,ee,X,Ee,ke=!1,Pe=void 0,Z=!1){this.controllerId=O,this.profileId=z,this.f=ee,this.kind=X,this.runHandler=Ee,this.g=ke,this._tag=Pe,this.h=Z,this.#e=j,this.#t=W,W.set(z,this);const ue=B[X];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);this.#e.$publishTestRunProfile({profileId:z,controllerId:O,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:ee,group:ue,isDefault:ke,hasConfigurationHandler:!1,supportsContinuousRun:Z})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$xcc=R;const B={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[253],Re([1,0,18,9,5,3,106,8,7]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=void 0;class f{constructor(D,u){this.i=u,this.a=new C.$ed({onListenerError:F.$Z}),this.b=new C.$ed({onListenerError:F.$Z}),this.c=new C.$ed({onListenerError:F.$Z}),this.d=new C.$ed({onListenerError:F.$Z}),this.f=new C.$ed({onListenerError:F.$Z}),this.g=new C.$ed({onListenerError:F.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(L.$UJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const u=this.i.allEditors();return D?u:u.map(p=>p.value)}async showTextDocument(D,u,p){let $;typeof u=="number"?$={position:l.ViewColumn.from(u),preserveFocus:p}:typeof u=="object"?$={position:l.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?l.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:$={preserveFocus:!1};const h=await this.h.$tryShowTextDocument(D.uri,$),t=h&&this.i.getEditor(h);if(t)return t.value;throw h?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,u){return new A.$4L(this.h,D,u).value}$acceptEditorPropertiesChanged(D,u){const p=this.i.getEditor(D);if(!p)throw new Error("unknown text editor");if(u.options&&p._acceptOptions(u.options),u.selections){const $=u.selections.selections.map(l.Selection.to);p._acceptSelections($)}if(u.visibleRanges){const $=w.$Eb(u.visibleRanges.map(l.Range.to));p._acceptVisibleRanges($)}if(u.options&&this.b.fire({textEditor:p.value,options:{...u.options,lineNumbers:l.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const $=S.TextEditorSelectionChangeKind.fromValue(u.selections.source),h=u.selections.selections.map(l.Selection.to);this.a.fire({textEditor:p.value,selections:h,kind:$})}if(u.visibleRanges){const $=w.$Eb(u.visibleRanges.map(l.Range.to));this.c.fire({textEditor:p.value,visibleRanges:$})}}$acceptEditorPositionData(D){for(const u in D){const p=this.i.getEditor(u);if(!p)throw new Error("Unknown text editor");const $=l.ViewColumn.to(D[u]);p.value.viewColumn!==$&&(p._acceptViewColumn($),this.d.fire({textEditor:p.value,viewColumn:$}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.$Mbc=f}),define(Ae[254],Re([1,0,2,4,3,6,7,8,20,16]),function(be,e,w,F,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=e.$occ=void 0,e.$occ=(0,F.$Ah)("IExtHostTimeline");class P{constructor(p,$){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$UJ.MainThreadTimeline),$.registerArgumentProcessor({processArgument:(h,t)=>{if(h&&h.$mid===12)if(this.b.get(h.source)&&S.$Ul.equals(t,this.b.get(h.source)?.extension)){const i=h.uri===void 0?void 0:w.URI.revive(h.uri);return this.c.get(h.source)?.get(D(i))?.get(h.handle)}else return;return h}})}async $getTimeline(p,$,h,t){return this.b.get(p)?.provider.provideTimeline(w.URI.revive($),h,t)}registerTimelineProvider(p,$,h,t){const i=new L.$ic,c=this.d($.id,t,i).bind(this);let g;$.onDidChange&&(g=$.onDidChange(b=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:$.id}),this));const k=this.c;return this.f({...$,scheme:p,onDidChange:void 0,async provideTimeline(b,n,a){n?.resetCache&&(i.clear(),k.get($.id)?.clear());const s=await $.provideTimeline(b,n,a);if(s==null)return;const o=c(b,n);return{...s,source:$.id,items:s.items.map(o)}},dispose(){for(const b of k.values())b.get($.id)?.clear();g?.dispose(),i.dispose()}},h)}d(p,$,h){return(t,i)=>{let c;if(i?.cacheResults){let g=this.c.get(p);g===void 0&&(g=new Map,this.c.set(p,g));const k=D(t);c=g.get(k),c===void 0&&(c=new Map,g.set(k,c))}return g=>{const{iconPath:k,...b}=g,n=`${p}|${g.id??g.timestamp}`;c?.set(n,g);let a,s,o;g.iconPath&&(k instanceof A.$RK?o={id:k.id,color:k.color}:w.URI.isUri(k)?(a=k,s=k):{light:a,dark:s}=k);let y;return A.$lK.isMarkdownString(b.tooltip)?y=l.MarkdownString.from(b.tooltip):(0,f.$if)(b.tooltip)?y=b.tooltip:A.$lK.isMarkdownString(b.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=l.MarkdownString.from(b.detail)):(0,f.$if)(b.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=b.detail),{...b,id:b.id??void 0,handle:n,source:p,command:g.command?$.toInternal(g.command,h):void 0,icon:a,iconDark:s,themeIcon:o,tooltip:y,accessibilityInformation:g.accessibilityInformation}}}}f(p,$){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:$}),(0,L.$hc)(()=>{for(const t of this.c.values())t.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$pcc=P;function D(u){return u?.toString()}}),define(Ae[86],Re([1,0,21,5,6,158,4,14,185,3,27,17,7]),function(be,e,w,F,C,L,A,l,S,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fsb=e.$esb=e.TunnelDtoConverter=void 0;class p extends S.$4z{}var $;(function(t){function i(g){return{remoteAddress:g.remoteAddress,localAddress:g.localAddress,public:!!g.public,privacy:g.privacy??(g.public?S.TunnelPrivacyId.Public:S.TunnelPrivacyId.Private),protocol:g.protocol}}t.fromApiTunnel=i;function c(g){return{remoteAddress:{host:g.tunnelRemoteHost,port:g.tunnelRemotePort},localAddress:g.localAddress,public:g.privacy!==S.TunnelPrivacyId.ConstantPrivate&&g.privacy!==S.TunnelPrivacyId.ConstantPrivate,privacy:g.privacy,protocol:g.protocol}}t.fromServiceTunnel=c})($||(e.TunnelDtoConverter=$={})),e.$esb=(0,A.$Ah)("IExtHostTunnelService");let h=class extends C.$jc{constructor(i,c,g){super(),this.s=g,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$ed,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(f.$UJ.MainThreadTunnelService)}async openTunnel(i,c){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const g=await this.a.$openTunnel(c,i.displayName);if(g){const k=new p(g.remoteAddress,g.localAddress,()=>this.a.$closeTunnel(g.remoteAddress));return this.B(k),k}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,c){const g=this.u();return this.r.set(g,{selector:i,provider:c}),this.a.$registerPortsAttributesProvider(i,g),new u.$WJ(()=>{this.r.delete(g),this.a.$unregisterPortsAttributesProvider(g)})}async $providePortAttributes(i,c,g,k,b){const n=[];for(const s of i){const o=this.r.get(s);if(!o)return[];n.push(...await Promise.all(c.map(async y=>{let m;try{m=await o.provider.providePortAttributes({port:y,pid:g,commandLine:k},b)}catch{m=await o.provider.providePortAttributes(y,g,k,b)}return{providedAttributes:m,port:y}})))}const a=n.filter(s=>!!s.providedAttributes);return a.length>0?a.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(k,b)=>await i.provideTunnel(k,b,new w.$od().token)??void 0;const g=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(g),Promise.resolve((0,C.$hc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,c){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const g=i.tunnelFactory??(c?this.w(c):void 0);if(g){this.b=g;let k=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&k.length===0&&(k=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const b=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:k}:void 0;this.a.$setTunnelProvider(b)}}else this.b=void 0;return(0,C.$hc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,c){if(this.g.has(i.host)){const g=this.g.get(i.host);g.has(i.port)&&(c&&g.get(i.port).disposeListener.dispose(),await g.get(i.port).tunnel.dispose(),g.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,c){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const g=this.b(i,c);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),g!==void 0){const k=await g;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),k===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const b=this.B(k.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(k.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:k,disposeListener:b}),$.fromApiTunnel(k)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(g){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),g instanceof Error)return g.message}}async $applyCandidateFilter(i){const c=await Promise.all(i.map(k=>this.f(k.host,k.port,k.detail??""))),g=i.filter((k,b)=>c[b]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(k=>k.port).join(", ")} to ${g.map(k=>k.port).join(", ")}`),g}};e.$fsb=h,e.$fsb=h=Ke([Ve(0,D.$WL),Ve(1,P.$aM),Ve(2,l.$4i)],h)}),define(Ae[255],Re([1,0,6,12,2,3]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class A{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(S){this.c=new Map,this.b=S.getProxy(L.$UJ.MainThreadUriOpeners)}registerExternalUriOpener(S,f,P,D){if(this.c.has(f))throw new Error(`Opener with id '${f}' already registered`);const u=D.schemes.find(p=>!A.a.has(p));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(f,P),this.b.$registerUriOpener(f,D.schemes,S,D.label),(0,w.$hc)(()=>{this.c.delete(f),this.b.$unregisterUriOpener(f)})}async $canOpenUri(S,f,P){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener with id: ${S}`);const u=C.URI.revive(f);return D.canOpenExternalUri(u,P)}async $openUri(S,f,P){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener id: '${S}'`);return D.openExternalUri(C.URI.revive(f.resolvedUri),{sourceUri:C.URI.revive(f.sourceUri)},P)}}e.$ycc=A}),define(Ae[256],Re([1,0,3,2,6,9,20]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=void 0;class l{static{this.a=0}constructor(f){this.c=new A.$Vl,this.d=new Map,this.b=f.getProxy(w.$UJ.MainThreadUrls)}registerUriHandler(f,P){const D=f.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const u=l.a++;return this.c.add(D),this.d.set(u,P),this.b.$registerUriHandler(u,D,f.displayName||f.name),(0,C.$hc)(()=>{this.c.delete(D),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(f,P){const D=this.d.get(f);if(!D)return Promise.resolve(void 0);try{D.handleUri(F.URI.revive(P))}catch(u){(0,L.$Y)(u)}return Promise.resolve(void 0)}async createAppUri(f){return F.URI.revive(await this.b.$createAppUri(f))}}e.$Obc=l}),define(Ae[63],Re([1,0,5,6,12,24,2,170,192,77,3]),function(be,e,w,F,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=e.$Sbc=e.$Rbc=e.$Qbc=e.$Pbc=void 0;class D{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(k,b,n,a,s,o,y){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.$ed,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$ed,this._onDidDispose=this.#h.event,this.#e=k,this.#t=b,this.#r=n,this.#l=a,this.#u=s,this.#n=o,this.#c=u(o),this.#d=p(o),this.#i=y}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(k){return this.#a=!0,(0,f.$Lob)(k,this.#l)}get cspSource(){const k=this.#n.extensionLocation;if(k.scheme===C.Schemas.https||k.scheme===C.Schemas.http){let b=k.toString();return b.endsWith("/")||(b+="/"),b+" "+f.$Kob}return f.$Kob}get html(){return this.a(),this.#s}set html(k){this.a(),this.#s!==k&&(this.#s=k,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(k)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(k)))}get options(){return this.a(),this.#r}set options(k){this.a(),L.$Ym(this.#r,k)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,k)),this.#r=k}async postMessage(k){if(this.#o)return!1;const b=(0,S.$Ybb)(k,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,b.message,...b.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(k){if(!this.#d)return k;const b=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return k.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,s,o,y,m,I)=>{const E=A.URI.from({scheme:y||"file",path:decodeURIComponent(m)}),r=(0,f.$Lob)(E,{isRemote:b,authority:n}).toString();return`${s}${r}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,s,o,y,m,I)=>{const E=A.URI.from({scheme:y||"file",path:decodeURIComponent(m)}),r=(0,f.$Lob)(E,{isRemote:b,authority:n}).toString();return`${s}${r}${I}`})}}e.$Pbc=D;function u(g){try{const k=(0,l.$Co)((0,l.$Bo)(g.engines.vscode));return!!k&&k.majorBase>=1&&k.minorBase>=57}catch{return!1}}e.$Qbc=u;function p(g){try{const k=(0,l.$Co)((0,l.$Bo)(g.engines.vscode));return k?k.majorBase<1||k.majorBase===1&&k.minorBase<60:!1}catch{return!1}}class $ extends F.$jc{constructor(k,b,n,a,s){super(),this.c=b,this.f=n,this.g=a,this.h=s,this.b=new Map,this.a=k.getProxy(P.$UJ.MainThreadWebviews)}dispose(){super.dispose();for(const k of this.b.values())k.dispose();this.b.clear()}$onMessage(k,b,n){const a=this.j(k);if(a){const{message:s}=(0,S.$Zbb)(b,n.value);a._onMessageEmitter.fire(s)}}$onMissingCsp(k,b){this.g.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(k,b,n){const a=new D(k,this.a,i(b),this.c,this.f,n,this.h);this.b.set(k,a);const s=a._onDidDispose(()=>{s.dispose(),this.deleteWebview(k)});return a}deleteWebview(k){this.b.delete(k)}j(k){return this.b.get(k)}}e.$Rbc=$;function h(g){return{id:g.identifier,location:g.extensionLocation}}e.$Sbc=h;function t(g,k,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||c(g,k)}}e.$Tbc=t;function i(g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,enableForms:g.enableForms,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots?.map(k=>A.URI.from(k))}}function c(g,k){return[...(k?.getWorkspaceFolders()||[]).map(b=>b.uri),g.extensionLocation]}}),define(Ae[257],Re([1,0,21,93,6,12,23,2,8,63,54,3,7]),function(be,e,w,F,C,L,A,l,S,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;class p{constructor(a,s){this.document=a,this.b=s,this.a=1,this.c=new P.$Lac("custom documents")}addEdit(a){return this.c.add([a])}async undo(a,s){await this.f(a).undo(),s||this.disposeBackup()}async redo(a,s){await this.f(a).redo(),s||this.disposeBackup()}disposeEdits(a){for(const s of a)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const a=b(this.document.uri)+this.a++;return(0,A.$hg)(this.b,a)}updateBackup(a){this.d?.delete(),this.d=a}disposeBackup(){this.d?.delete(),this.d=void 0}f(a){const s=this.c.get(a,0);if(!s)throw new Error("No edit found");return s}}class ${constructor(){this.a=new Map}get(a,s){return this.a.get(this.b(a,s))}add(a,s,o){const y=this.b(a,s.uri);if(this.a.has(y))throw new Error(`Document already exists for viewType:${a} resource:${s.uri}`);const m=new p(s,o);return this.a.set(y,m),m}delete(a,s){const o=this.b(a,s.uri);this.a.delete(o)}b(a,s){return`${a}@@@${s}`}}var h;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(h||(h={}));class t{constructor(){this.a=new Map}addTextProvider(a,s,o){return this.b(0,a,s,o)}addCustomProvider(a,s,o){return this.b(1,a,s,o)}get(a){return this.a.get(a)}b(a,s,o,y){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:a,extension:o,provider:y}),new u.$WJ(()=>this.a.delete(s))}}class i{constructor(a,s,o,y,m){this.d=s,this.f=o,this.g=y,this.h=m,this.b=new t,this.c=new $,this.a=a.getProxy(D.$UJ.MainThreadCustomEditors)}registerCustomEditorProvider(a,s,o,y){const m=new C.$ic;return g(o)?(m.add(this.b.addTextProvider(s,a,o)),this.a.$registerTextEditorProvider((0,f.$Sbc)(a),s,y.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,f.$Qbc)(a))):(m.add(this.b.addCustomProvider(s,a,o)),c(o)&&m.add(o.onDidChangeCustomDocument(I=>{const E=this.i(s,I.document.uri);if(k(I)){const r=E.addEdit(I);this.a.$onDidEdit(I.document.uri,s,r,I.label)}else this.a.$onContentChange(I.document.uri,s)})),this.a.$registerCustomEditorProvider((0,f.$Sbc)(a),s,y.webviewOptions||{},!!y.supportsMultipleEditorsPerDocument,(0,f.$Qbc)(a))),u.$WJ.from(m,new u.$WJ(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(a,s,o,y,m){const I=this.b.get(s);if(!I)throw new Error(`No provider found for '${s}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${s}'`);const E=l.URI.revive(a),r=await I.provider.openCustomDocument(E,{backupId:o,untitledDocumentData:y?.buffer},m);let d;return c(I.provider)&&this.f&&(d=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(s,r,d),{editable:c(I.provider)}}async $disposeCustomDocument(a,s){const o=this.b.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${s}'`);const y=l.URI.revive(a),{document:m}=this.i(s,y);this.c.delete(s,m),m.dispose()}async $resolveCustomEditor(a,s,o,y,m,I){const E=this.b.get(o);if(!E)throw new Error(`No provider found for '${o}'`);const r=S.ViewColumn.to(m),d=this.g.createNewWebview(s,y.contentOptions,E.extension),v=this.h.createNewWebviewPanel(s,o,y.title,r,y.options,d,y.active),R=l.URI.revive(a);switch(E.type){case 1:{const{document:B}=this.i(o,R);return E.provider.resolveCustomEditor(B,v,I)}case 0:{const B=this.d.getDocument(R);return E.provider.resolveCustomTextEditor(B,v,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,s,o){this.i(s,a).disposeEdits(o)}async $onMoveCustomEditor(a,s,o){const y=this.b.get(o);if(!y)throw new Error(`No provider found for '${o}'`);if(!y.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const m=this.h.getWebviewPanel(a);if(!m)throw new Error("No webview found");const I=l.URI.revive(s),E=this.d.getDocument(I);await y.provider.moveCustomTextEditor(E,m,w.CancellationToken.None)}async $undo(a,s,o,y){return this.i(s,a).undo(o,y)}async $redo(a,s,o,y){return this.i(s,a).redo(o,y)}async $revert(a,s,o){const y=this.i(s,a);await this.j(s).revertCustomDocument(y.document,o),y.disposeBackup()}async $onSave(a,s,o){const y=this.i(s,a);await this.j(s).saveCustomDocument(y.document,o),y.disposeBackup()}async $onSaveAs(a,s,o,y){const m=this.i(s,a);return this.j(s).saveCustomDocumentAs(m.document,l.URI.revive(o),y)}async $backup(a,s,o){const y=this.i(s,a),I=await this.j(s).backupCustomDocument(y.document,{destination:y.getNewBackupUri()},o);return y.updateBackup(I),I.id}i(a,s){const o=this.c.get(a,l.URI.revive(s));if(!o)throw new Error("No custom document found");return o}j(a){const o=this.b.get(a)?.provider;if(!o||!c(o))throw new Error("Custom document is not editable");return o}}e.$scc=i;function c(n){return!!n.onDidChangeCustomDocument}function g(n){return typeof n.resolveCustomTextEditor=="function"}function k(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function b(n){const a=n.scheme===L.Schemas.file||n.scheme===L.Schemas.untitled?n.fsPath:n.toString();return(0,F.$oi)(a)+""}}),define(Ae[258],Re([1,0,5,6,2,36,8,63,3,7]),function(be,e,w,F,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class P extends F.$jc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor($,h,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new w.$ed),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$ed),this.onDidChangeViewState=this.#h.event,this.#e=$,this.#t=h,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title($){this.c(),this.#n!==$&&(this.#n=$,this.#t.$setTitle(this.#e,$))}get iconPath(){return this.c(),this.#s}set iconPath($){this.c(),this.#s!==$&&(this.#s=$,this.#t.$setIconPath(this.#e,C.URI.isUri($)?{light:$,dark:$}:$))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState($){this.#c||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(this.#a=$.active,this.#o=$.visible,this.#r=$.viewColumn,this.#h.fire({webviewPanel:this}))}reveal($,h){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof $>"u"?void 0:A.ViewColumn.from($),preserveFocus:!!h})}c(){if(this.#c)throw new Error("Webview is disposed")}}class D extends F.$jc{static c(){return(0,L.$3f)()}constructor($,h,t){super(),this.j=h,this.m=t,this.g=new Map,this.h=new Map,this.f=$.getProxy(S.$UJ.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach($=>$.dispose()),this.g.clear()}createWebviewPanel($,h,t,i,c={}){const g=typeof i=="object"?i.viewColumn:i,k={viewColumn:A.ViewColumn.from(g),preserveFocus:typeof i=="object"&&!!i.preserveFocus},b=(0,l.$Qbc)($),n=D.c();this.f.$createWebviewPanel((0,l.$Sbc)($),n,h,{title:t,panelOptions:u(c),webviewOptions:(0,l.$Tbc)($,this.m,c),serializeBuffersForPostMessage:b},k);const a=this.j.createNewWebview(n,c,$);return this.createNewWebviewPanel(n,h,t,g,c,a,!0)}$onDidChangeWebviewPanelViewStates($){const h=Object.keys($);h.sort((t,i)=>{const c=$[t],g=$[i];return c.active?1:g.active?-1:+c.visible-+g.visible});for(const t of h){const i=this.getWebviewPanel(t);if(!i)continue;const c=$[t];i._updateViewState({active:c.active,visible:c.visible,viewColumn:A.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.g.delete($),this.j.deleteWebview($)}registerWebviewPanelSerializer($,h,t){if(this.h.has(h))throw new Error(`Serializer for '${h}' already registered`);return this.h.set(h,{serializer:t,extension:$}),this.f.$registerSerializer(h,{serializeBuffersForPostMessage:(0,l.$Qbc)($)}),new f.$WJ(()=>{this.h.delete(h),this.f.$unregisterSerializer(h)})}async $deserializeWebviewPanel($,h,t,i){const c=this.h.get(h);if(!c)throw new Error(`No serializer found for '${h}'`);const{serializer:g,extension:k}=c,b=this.j.createNewWebview($,t.webviewOptions,k),n=this.createNewWebviewPanel($,h,t.title,i,t.panelOptions,b,t.active);await g.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel($,h,t,i,c,g,k){const b=new P($,this.f,g,{viewType:h,title:t,viewColumn:i,panelOptions:c,active:k});return this.g.set($,b),b}getWebviewPanel($){return this.g.get($)}}e.$rcc=D;function u(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Ae[259],Re([1,0,5,6,63,8,3,7]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;class S extends F.$jc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(D,u,p,$,h,t){super(),this.#u=!1,this.#a=this.B(new w.$ed),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new w.$ed),this.onDidDispose=this.#c.event,this.#i=p,this.#s=$,this.#e=D,this.#t=u,this.#l=h,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#r}set description(D){this.a(),this.#r!==D&&(this.#r=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#u||(this.#n=D,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(D){this.a(),!(D?.value===this.#o?.value&&D?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#u)throw new Error("Webview is disposed")}}class f{constructor(D,u){this.d=u,this.b=new Map,this.c=new Map,this.a=D.getProxy(A.$UJ.MainThreadWebviewViews)}registerWebviewViewProvider(D,u,p,$){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:p,extension:D}),this.a.$registerWebviewViewProvider((0,C.$Sbc)(D),u,{retainContextWhenHidden:$?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Qbc)(D)}),new l.$WJ(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(D,u,p,$,h){const t=this.b.get(u);if(!t)throw new Error(`No view provider found for '${u}'`);const{provider:i,extension:c}=t,g=this.d.createNewWebview(D,{},c),k=new S(D,this.a,u,p,g,!0);this.c.set(D,k),await i.resolveWebviewView(k,{state:$},h)}async $onDidChangeWebviewViewVisibility(D,u){this.e(D)._setVisible(u)}async $disposeWebviewView(D){const u=this.e(D);this.c.delete(D),u.dispose(),this.d.deleteWebview(D)}e(D){const u=this.c.get(D);if(!u)throw new Error("No webview found");return u}}e.$qcc=f}),define(Ae[109],Re([1,0,5,3,2,12,15,4,17,26]),function(be,e,w,F,C,L,A,l,S,f){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=e.$Ubc=void 0;let D=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(p){const $=this.d;return{get focused(){return $.focused},get active(){return(0,f.$OF)(p,"windowActivity"),$.active}}}constructor(p){this.c=new w.$ed,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=p.getProxy(F.$UJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:$,isActive:h})=>{this.onDidChangeWindowProperty("focused",$),this.onDidChangeWindowProperty("active",h)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,$){$!==this.d[p]&&(this.d={...this.d,[p]:$},this.c.fire(this.d))}openUri(p,$){let h;if(typeof p=="string"){h=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,A.$le)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,h,$)}async asExternalUri(p,$){if((0,A.$le)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this.b.$asExternalUri(p,$);return C.URI.from(h)}};e.$Ubc=D,e.$Ubc=D=P=Ke([Ve(0,S.$WL)],D),e.$Vbc=(0,l.$Ah)("IExtHostWindow")}),define(Ae[260],Re([1,0,227,27,17]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;let L=class extends w.$Tcc{constructor(l,S){super(l,S)}f(l,S,f){S.apply(console,f)}};e.$1ec=L,e.$1ec=L=Ke([Ve(0,C.$WL),Ve(1,F.$aM)],L)}),define(Ae[261],Re([1,0,13,25,21,9,5,6,133,216,46]),function(be,e,w,F,C,L,A,l,S,f,P){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$o3b=e.ResponsiveState=e.RequestInitiator=e.$n3b=e.$m3b=void 0;function u(v,R){try{return JSON.stringify(v,R)}catch{return"null"}}const p="$$ref$$",$={[p]:-1};class h{constructor(R,B){this.jsonString=R,this.referencedBuffers=B}}function t(v,R=null,B=!1){const V=[];return{jsonString:(B?u:JSON.stringify)(v,(W,O)=>{if(typeof O>"u")return $;if(typeof O=="object"){if(O instanceof F.$Ed){const z=V.push(O)-1;return{[p]:z}}if(R)return R(W,O)}return O}),referencedBuffers:V}}e.$m3b=t;function i(v,R,B){return JSON.parse(v,(V,j)=>{if(j){const W=j[p];if(typeof W=="number")return R[W];if(B&&j.$mid===1)return B.transformIncoming(j)}return j})}e.$n3b=i;function c(v,R){return JSON.stringify(v,R)}function g(v){return v?(R,B)=>B&&B.$mid===1?v.transformOutgoing(B):B:null}var k;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));var b;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(b||(e.ResponsiveState=b={}));const n=()=>{},a=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class o extends l.$jc{static{D=a}static{this.a=3*1e3}constructor(R,B=null,V=null){super(),this[D]=!0,this.b=this.B(new A.$ed),this.onDidChangeResponsiveState=this.b.event,this.c=R,this.f=B,this.g=V,this.h=g(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,W=P.$$z.count;j<W;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new w.$Rg(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(R=>{const B=this.w[R];delete this.w[R],B.resolveErr(L.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(R){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(R){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(R){this.y!==R&&(this.y=R,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(R){return this.g?(0,S.$Dm)(R,this.g):R}getProxy(R){const{nid:B,sid:V}=R;return this.s[B]||(this.s[B]=this.J(B,V)),this.s[B]}J(R,B){const V={get:(j,W)=>(typeof W=="string"&&!j[W]&&W.charCodeAt(0)===36&&(j[W]=(...O)=>this.U(R,W,O)),W===s?B:j[W])};return new Proxy(Object.create(null),V)}set(R,B){return this.m[R.nid]=B,B}assertRegistered(R){for(let B=0,V=R.length;B<V;B++){const j=R[B];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(R){if(this.j)return;const B=R.byteLength,V=m.read(R,0),j=V.readUInt8(),W=V.readUInt32();switch(j){case 1:case 2:{let{rpcId:O,method:z,args:ee}=E.deserializeRequestJSONArgs(V);this.g&&(ee=(0,S.$Dm)(ee,this.g)),this.M(B,W,O,z,ee,j===2);break}case 3:case 4:{let{rpcId:O,method:z,args:ee}=E.deserializeRequestMixedArgs(V);this.g&&(ee=(0,S.$Dm)(ee,this.g)),this.M(B,W,O,z,ee,j===4);break}case 5:{this.f?.logIncoming(B,W,0,"ack"),this.G(W);break}case 6:{this.N(B,W);break}case 7:{this.O(B,W,void 0);break}case 9:{let O=E.deserializeReplyOKJSON(V);this.g&&(O=(0,S.$Dm)(O,this.g)),this.O(B,W,O);break}case 10:{const O=E.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(B,W,O);break}case 8:{const O=E.deserializeReplyOKVSBuffer(V);this.O(B,W,O);break}case 11:{let O=E.deserializeReplyErrError(V);this.g&&(O=(0,S.$Dm)(O,this.g)),this.P(B,W,O);break}case 12:{this.P(B,W,void 0);break}default:console.error("received unexpected message"),console.error(R)}}M(R,B,V,j,W,O){this.f?.logIncoming(R,B,1,`receiveRequest ${(0,P.$aA)(V)}.${j}(`,W);const z=String(B);let ee,X;if(O){const ke=new C.$od;W.push(ke.token),ee=this.Q(V,j,W),X=()=>ke.cancel()}else ee=this.Q(V,j,W),X=n;this.u[z]=X;const Ee=E.serializeAcknowledged(B);this.f?.logOutgoing(Ee.byteLength,B,1,"ack"),this.c.send(Ee),ee.then(ke=>{delete this.u[z];const Pe=E.serializeReplyOK(B,ke,this.h);this.f?.logOutgoing(Pe.byteLength,B,1,"reply:",ke),this.c.send(Pe)},ke=>{delete this.u[z];const Pe=E.serializeReplyErr(B,ke);this.f?.logOutgoing(Pe.byteLength,B,1,"replyErr:",ke),this.c.send(Pe)})}N(R,B){this.f?.logIncoming(R,B,1,"receiveCancel");const V=String(B);this.u[V]?.()}O(R,B,V){this.f?.logIncoming(R,B,0,"receiveReply:",V);const j=String(B);if(!this.w.hasOwnProperty(j))return;const W=this.w[j];delete this.w[j],W.resolveOk(V)}P(R,B,V){this.f?.logIncoming(R,B,0,"receiveReplyErr:",V);const j=String(B);if(!this.w.hasOwnProperty(j))return;const W=this.w[j];delete this.w[j];let O;V&&(V.$isError?(O=new Error,O.name=V.name,O.message=V.message,O.stack=V.stack):O=V),W.resolveErr(O)}Q(R,B,V){try{return Promise.resolve(this.S(R,B,V))}catch(j){return Promise.reject(j)}}S(R,B,V){const j=this.m[R];if(!j)throw new Error("Unknown actor "+(0,P.$aA)(R));const W=j[B];if(typeof W!="function")throw new Error("Unknown method "+B+" on actor "+(0,P.$aA)(R));return W.apply(j,V)}U(R,B,V){if(this.j)return new f.$l3b;let j=null;if(V.length>0&&C.CancellationToken.isCancellationToken(V[V.length-1])&&(j=V.pop()),j&&j.isCancellationRequested)return Promise.reject(L.$4());const W=E.serializeRequestArguments(V,this.h),O=++this.t,z=String(O),ee=new f.$k3b,X=new l.$ic;j&&X.add(j.onCancellationRequested(()=>{const ke=E.serializeCancel(O);this.f?.logOutgoing(ke.byteLength,O,0,"cancel"),this.c.send(E.serializeCancel(O))})),this.w[z]=new y(ee,X),this.F(O);const Ee=E.serializeRequest(O,R,B,W,!!j);return this.f?.logOutgoing(Ee.byteLength,O,0,`request: ${(0,P.$aA)(R)}.${B}(`,V),this.c.send(Ee),ee}}e.$o3b=o;class y{constructor(R,B){this.a=R,this.b=B}resolveOk(R){this.a.resolveOk(R),this.b.dispose()}resolveErr(R){this.a.resolveErr(R),this.b.dispose()}}class m{static alloc(R,B,V){const j=new m(F.$Ed.alloc(V+1+4),0);return j.writeUInt8(R),j.writeUInt32(B),j}static read(R,B){return new m(R,B)}get buffer(){return this.a}constructor(R,B){this.a=R,this.b=B}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(R){this.a.writeUInt8(R,this.b),this.b+=1}readUInt8(){const R=this.a.readUInt8(this.b);return this.b+=1,R}writeUInt32(R){this.a.writeUInt32BE(R,this.b),this.b+=4}readUInt32(){const R=this.a.readUInt32BE(this.b);return this.b+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this.a.writeUInt8(R.byteLength,this.b),this.b+=1,this.a.set(R,this.b),this.b+=R.byteLength}readShortString(){const R=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readLongString(){const R=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}writeBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readVSBuffer(){const R=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+R);return this.b+=R,B}static sizeMixedArray(R){let B=0;B+=1;for(let V=0,j=R.length;V<j;V++){const W=R[V];switch(B+=1,W.type){case 1:B+=this.sizeLongString(W.value);break;case 2:B+=this.sizeVSBuffer(W.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(W.value);for(let O=0;O<W.buffers.length;++O)B+=this.sizeVSBuffer(W.buffers[O]);break;case 4:break}}return B}writeMixedArray(R){this.a.writeUInt8(R.length,this.b),this.b+=1;for(let B=0,V=R.length;B<V;B++){const j=R[B];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let W=0;W<j.buffers.length;++W)this.writeBuffer(j.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this.a.readUInt8(this.b);this.b+=1;const B=new Array(R);for(let V=0;V<R;V++)switch(this.readUInt8()){case 1:B[V]=this.readLongString();break;case 2:B[V]=this.readVSBuffer();break;case 3:{const W=this.readUInt32(),O=this.readLongString(),z=[];for(let ee=0;ee<W;++ee)z.push(this.readVSBuffer());B[V]=new P.$bA(i(O,z,null));break}case 4:B[V]=void 0;break}return B}}var I;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(I||(I={}));class E{static a(R){for(let B=0,V=R.length;B<V;B++)if(R[B]instanceof F.$Ed||R[B]instanceof P.$bA||typeof R[B]>"u")return!0;return!1}static serializeRequestArguments(R,B){if(this.a(R)){const V=[];for(let j=0,W=R.length;j<W;j++){const O=R[j];if(O instanceof F.$Ed)V[j]={type:2,value:O};else if(typeof O>"u")V[j]={type:4};else if(O instanceof P.$bA){const{jsonString:z,referencedBuffers:ee}=t(O.value,B);V[j]={type:3,value:F.$Ed.fromString(z),buffers:ee}}else V[j]={type:1,value:F.$Ed.fromString(c(O,B))}}return{type:1,args:V}}return{type:0,args:c(R,B)}}static serializeRequest(R,B,V,j,W){switch(j.type){case 0:return this.b(R,B,V,j.args,W);case 1:return this.c(R,B,V,j.args,W)}}static b(R,B,V,j,W){const O=F.$Ed.fromString(V),z=F.$Ed.fromString(j);let ee=0;ee+=m.sizeUInt8(),ee+=m.sizeShortString(O),ee+=m.sizeLongString(z);const X=m.alloc(W?2:1,R,ee);return X.writeUInt8(B),X.writeShortString(O),X.writeLongString(z),X.buffer}static deserializeRequestJSONArgs(R){const B=R.readUInt8(),V=R.readShortString(),j=R.readLongString();return{rpcId:B,method:V,args:JSON.parse(j)}}static c(R,B,V,j,W){const O=F.$Ed.fromString(V);let z=0;z+=m.sizeUInt8(),z+=m.sizeShortString(O),z+=m.sizeMixedArray(j);const ee=m.alloc(W?4:3,R,z);return ee.writeUInt8(B),ee.writeShortString(O),ee.writeMixedArray(j),ee.buffer}static deserializeRequestMixedArgs(R){const B=R.readUInt8(),V=R.readShortString(),j=R.readMixedArray(),W=new Array(j.length);for(let O=0,z=j.length;O<z;O++){const ee=j[O];typeof ee=="string"?W[O]=JSON.parse(ee):W[O]=ee}return{rpcId:B,method:V,args:W}}static serializeAcknowledged(R){return m.alloc(5,R,0).buffer}static serializeCancel(R){return m.alloc(6,R,0).buffer}static serializeReplyOK(R,B,V){if(typeof B>"u")return this.d(R);if(B instanceof F.$Ed)return this.e(R,B);if(B instanceof P.$bA){const{jsonString:j,referencedBuffers:W}=t(B.value,V,!0);return this.g(R,j,W)}else return this.f(R,u(B,V))}static d(R){return m.alloc(7,R,0).buffer}static e(R,B){let V=0;V+=m.sizeVSBuffer(B);const j=m.alloc(8,R,V);return j.writeVSBuffer(B),j.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static f(R,B){const V=F.$Ed.fromString(B);let j=0;j+=m.sizeLongString(V);const W=m.alloc(9,R,j);return W.writeLongString(V),W.buffer}static g(R,B,V){const j=F.$Ed.fromString(B);let W=0;W+=m.sizeUInt32,W+=m.sizeLongString(j);for(const z of V)W+=m.sizeVSBuffer(z);const O=m.alloc(10,R,W);O.writeUInt32(V.length),O.writeLongString(j);for(const z of V)O.writeBuffer(z);return O.buffer}static deserializeReplyOKJSON(R){const B=R.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(R,B){const V=R.readUInt32(),j=R.readLongString(),W=[];for(let O=0;O<V;++O)W.push(R.readVSBuffer());return new P.$bA(i(j,W,B))}static serializeReplyErr(R,B){const V=B?u(L.$1(B),null):void 0;if(typeof V!="string")return this.h(R);const j=F.$Ed.fromString(V);let W=0;W+=m.sizeLongString(j);const O=m.alloc(11,R,W);return O.writeLongString(j),O.buffer}static deserializeReplyErrError(R){const B=R.readLongString();return JSON.parse(B)}static h(R){return m.alloc(12,R,0).buffer}}var r;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})(r||(r={}));var d;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(d||(d={}))}),define(Ae[262],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0;const w=function(L){const A=l=>{globalThis.removeEventListener("message",A);const S=l.data;Object.defineProperties(globalThis,{postMessage:{value(f,P){S.postMessage(f,P)}},onmessage:{get(){return S.onmessage},set(f){S.onmessage=f}}}),S.addEventListener("message",f=>{globalThis.dispatchEvent(new MessageEvent("message",{data:f.data,ports:f.ports?[...f.ports]:void 0}))}),S.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",A)}.toString();class F extends EventTarget{constructor(L,A,l){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${w})('${A}'))`,f=new Blob([S],{type:"application/javascript"}),P=URL.createObjectURL(f),D=new MessageChannel,u=P,p={type:"_newWorker",id:u,port:D.port2,url:P,options:l};L(p,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{L({type:"_terminateWorker",id:u}),URL.revokeObjectURL(P),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set($){D.port1.onmessage=$}},onmessageerror:{get(){return D.port1.onmessageerror},set($){D.port1.onmessageerror=$}}}),D.port1.addEventListener("messageerror",$=>{const h=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(h)}),D.port1.addEventListener("message",$=>{const h=new MessageEvent("message",{data:$.data});this.dispatchEvent(h)}),D.port1.start()}}e.$3ec=F}),define(Ae[263],Re([1,0,5,30,32,4]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$I=e.$0I=e.OutputChannelUpdateMode=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=void 0,e.$YI="text/x-code-output",e.$ZI="output",e.$1I="Log",e.$2I="text/x-code-log-output",e.$3I="log",e.$4I="log",e.$5I="workbench.panel.output",e.$6I=new C.$1i("inOutput",!1),e.$7I=new C.$1i("activeLogOutput",!1),e.$8I=new C.$1i("outputView.scrollLock",!1),e.$9I=(0,L.$Ah)("outputService");var A;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$0I={OutputChannels:"workbench.contributions.outputChannels"};class l{constructor(){this.a=new Map,this.b=new w.$ed,this.onDidRegisterChannel=this.b.event,this.c=new w.$ed,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(P=>f.push(P)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}F.$7m.add(e.$0I.OutputChannels,new l),e.$$I=new C.$1i("activeOutputChannel","")}),define(Ae[110],Re([1,0,3,4,17,20,14,263,61,27,39,130,25,16,38,5,6]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=e.$Ebc=void 0;class i extends A.$0i{get disposed(){return this.n}constructor(b,n,a,s,o){super(),this.id=b,this.name=n,this.r=a,this.s=s,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(a.getLevel()),this.B(a.onDidChangeLogLevel(y=>this.setLevel(y)))}get logLevel(){return this.getLevel()}appendLine(b){this.append(b+`
`)}append(b){this.info(b)}clear(){const b=this.m;this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Clear,b)}replace(b){const n=this.m;this.info(b),this.s.$update(this.id,l.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(b,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof b=="boolean"?b:n))}hide(){this.s.$close(this.id)}g(b,n){this.m+=u.$Ed.fromString(n).byteLength,(0,A.log)(this.r,b,n),this.visible&&(this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class c extends i{appendLine(b){this.append(b)}}let g=class{constructor(b,n,a,s,o,y){this.i=n,this.j=a,this.k=s,this.l=o,this.m=y,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=b.getProxy(w.$UJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,D.$6l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(b){this.h=b;for(const[n,a]of this.g)a.visible=n===this.h}createOutputChannel(b,n,a){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const s=typeof n=="object"&&n.log,o=(0,p.$if)(n)?n:void 0;if((0,p.$if)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let y;const m=this.i.environment.extensionLogLevel?.find(([E])=>L.$Ul.equals(a.identifier,E))?.[1];m&&(y=(0,A.$hj)(m));const I=s?this.o(b,y,a):this.n(b,o,a);return I.then(E=>{this.g.set(E.id,E),E.visible=E.id===this.h}),s?this.r(b,y??this.m.getLevel(),I):this.q(b,I)}async n(b,n,a){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,o=this.k.extUri.joinPath(s,`${this.f++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),y=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(b,o,n,a.identifier.value);return new i(m,b,y,this.a,a)}async o(b,n,a){const s=await this.p(a),o=b.replace(/[\\/:\*\?"<>\|]/g,""),y=this.k.extUri.joinPath(s,`${o}.log`),m=`${a.identifier.value}.${o}`,I=this.l.createLogger(y,{id:m,name:b,logLevel:n,extensionId:a.identifier.value});return new c(m,b,I,this.a,a)}p(b){let n=this.d.get(b.identifier.value);if(!n){const a=this.k.extUri.joinPath(this.i.logsLocation,b.identifier.value);this.d.set(b.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(a)}catch(s){if((0,$.$hk)(s)!==$.FileSystemProviderErrorCode.FileExists)throw s}return a})())}return n}q(b,n){let a=!1;const s=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return b},append(o){s(),n.then(y=>y.append(o))},appendLine(o){s(),n.then(y=>y.appendLine(o))},clear(){s(),n.then(o=>o.clear())},replace(o){s(),n.then(y=>y.replace(o))},show(o,y){s(),n.then(m=>m.show(o,y))},hide(){s(),n.then(o=>o.hide())},dispose(){a=!0,n.then(o=>o.dispose())}}}r(b,n,a){const s=new t.$ic,o=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},y=s.add(new h.$ed);function m(I){n=I,y.fire(I)}return a.then(I=>{s.add(I),I.logLevel!==n&&m(I.logLevel),s.add(I.onDidChangeLogLevel(E=>m(E)))}),{...this.q(b,a),get logLevel(){return n},onDidChangeLogLevel:y.event,trace(I,...E){o(),a.then(r=>r.trace(I,...E))},debug(I,...E){o(),a.then(r=>r.debug(I,...E))},info(I,...E){o(),a.then(r=>r.info(I,...E))},warn(I,...E){o(),a.then(r=>r.warn(I,...E))},error(I,...E){o(),a.then(r=>r.error(I,...E))},dispose(){s.dispose()}}}};e.$Ebc=g,e.$Ebc=g=Ke([Ve(0,C.$WL),Ve(1,f.$aM),Ve(2,S.$hbc),Ve(3,P.$Oac),Ve(4,A.$5i),Ve(5,A.$4i)],g),e.$Fbc=(0,F.$Ah)("IExtHostOutputService")}),define(Ae[264],Re([1,0,4,13]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=void 0,e.$im=(0,w.$Ah)("remoteAgentService"),e.$jm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let L=1/0;for(let l=0;l<this.maxSampleCount;l++){const S=await C.getRoundTripTime();if(S===void 0)return;L=Math.min(L,S/2),await(0,F.$Gg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce((l,S)=>l+S,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce((l,S)=>l+S,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[265],Re([1,0,42,12,19,22,23,2,4,187,53,209,264]),function(be,e,w,F,C,L,A,l,S,f,P,D,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.$qJ=void 0,e.$qJ=(0,S.$Ah)("pathService");let $=p=class{constructor(t,i,c,g){this.d=t,this.e=i,this.f=c,this.g=g,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const k=await this.e.getEnvironment();return this.c=k?.userHome??t})()}hasValidBasename(t,i,c){return typeof i=="string"||typeof i>"u"?this.a.then(g=>this.h(t,g,i)):this.h(t,i,c)}h(t,i,c){return t.scheme===F.Schemas.file||t.scheme===F.Schemas.vscodeRemote?(0,w.$Ff)(c??(0,A.$eg)(t),i===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return F.Schemas.vscodeRemote;const c=(0,f.$nJ)(i.getWorkspace());if(c)return c;const g=i.getWorkspace().folders[0];if(g)return g.uri.scheme;const k=i.getWorkspace().configuration;return k?k.scheme:F.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$4d:C.$5d)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const g=t.indexOf("/",2);g===-1?(i=t.substring(2),t="/"):(i=t.substring(2,g),t=t.substring(g)||"/")}return l.URI.from({scheme:F.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$rJ=$,e.$rJ=$=p=Ke([Ve(1,u.$im),Ve(2,D.$_I),Ve(3,P.$Jh)],$)}),define(Ae[111],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$aI=e.$_H=void 0;class w{constructor(A,l){this.line=A,this.character=l}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,l){return new w(0,0)}with(A){return new w(0,0)}}e.$_H=w;class F{constructor(A,l,S,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(A,l),this.end=new w(S,f)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.$aI=F;var C;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[47],Re([1,0,18,37,24,42,15,4,19,9,111,13]),function(be,e,w,F,C,L,A,l,S,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.SearchErrorCode=e.$pI=e.$oI=e.SearchSortOrder=e.ViewMode=e.$nI=e.$mI=e.$lI=e.$kI=e.SearchCompletionExitCode=e.$jI=e.$iI=e.$hI=e.QueryType=e.SearchProviderType=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$bI="workbench.view.search",e.$cI="workbench.panel.search",e.$dI="workbench.view.search",e.$eI="search-result",e.$fI="search.exclude";const u="\u27EA ",p=" characters skipped \u27EB",$=(u.length+p.length+5)*2;e.$gI=(0,l.$Ah)("searchService");var h;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text"})(h||(e.SearchProviderType=h={}));var t;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text"})(t||(e.QueryType=t={}));function i(Z){return!!Z.preview}e.$hI=i;function c(Z){return!!Z.resource}e.$iI=c;function g(Z){return!!Z.message}e.$jI=g;var k;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(k||(e.SearchCompletionExitCode=k={}));class b{constructor(ue){this.resource=ue,this.results=[]}}e.$kI=b;class n{constructor(ue,ye,ce,$e){this.ranges=ye,this.webviewIndex=$e;const ie=Array.isArray(ye)?ye:[ye];if(ce&&ce.matchLines===1&&a(ie)){ue=(0,A.$bf)(ue,ce.matchLines);let N="",q=0,le=0;const we=Math.floor(ce.charsPerLine/5),ve=[];for(const me of ie){const De=Math.max(me.startColumn-we,0),ne=me.startColumn+ce.charsPerLine;if(De>le+we+$){const he=u+(De-le)+p;N+=he+ue.slice(De,ne),q+=De-(le+he.length)}else N+=ue.slice(le,ne);ve.push(new o(0,me.startColumn-q,me.endColumn-q)),le=ne}this.preview={text:N,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const N=Array.isArray(ye)?ye[0].startLineNumber:ye.startLineNumber;this.preview={text:ue,matches:(0,w.$Yb)(ye,q=>new s(q.startLineNumber-N,q.startColumn,q.endLineNumber-N,q.endColumn))}}}}e.$lI=n;function a(Z){const ue=Z[0].startLineNumber;for(const ye of Z)if(ye.startLineNumber!==ue||ye.endLineNumber!==ue)return!1;return!0}class s{constructor(ue,ye,ce,$e){this.startLineNumber=ue,this.startColumn=ye,this.endLineNumber=ce,this.endColumn=$e}}e.$mI=s;class o extends s{constructor(ue,ye,ce){super(ue,ye,ue,ce)}}e.$nI=o;var y;(function(Z){Z.List="list",Z.Tree="tree"})(y||(e.ViewMode=y={}));var m;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(m||(e.SearchSortOrder=m={}));function I(Z,ue=!0){const ye=Z&&Z.files&&Z.files.exclude,ce=ue&&Z&&Z.search&&Z.search.exclude;if(!ye&&!ce)return;if(!ye||!ce)return ye||ce;let $e=Object.create(null);return $e=C.$Xm($e,C.$Um(ye)),$e=C.$Xm($e,C.$Um(ce),!0),$e}e.$oI=I;function E(Z,ue){return Z.excludePattern&&F.$pj(Z.excludePattern,ue)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&F.$pj(Z.includePattern,ue)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(ye=>{const ce=ye.folder.fsPath;if(L.$Hf(ue,ce)){const $e=S.$0d(ce,ue);return!ye.includePattern||!!F.$pj(ye.includePattern,$e)}else return!1}):!1:!0}e.$pI=E;var r;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(r||(e.SearchErrorCode=r={}));class d extends Error{constructor(ue,ye){super(ue),this.code=ye}}e.$qI=d;function v(Z){const ue=Z.message;if((0,f.$2)(Z))return new d(ue,r.canceled);try{const ye=JSON.parse(ue);return new d(ye.message,ye.code)}catch{return new d(ue,r.other)}}e.$rI=v;function R(Z){const ue={message:Z.message,code:Z.code};return new Error(JSON.stringify(ue))}e.$sI=R;function B(Z){return Z.type==="error"?!0:Z.type==="success"}e.$tI=B;function V(Z){return Z.type==="success"}e.$uI=V;function j(Z){return!!Z.path}e.$vI=j;function W(Z,ue){const ye=Z.searchPath?Z.searchPath:Z.relativePath;return(0,A.$$e)(ye,ue)}e.$wI=W;class O{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$xI=O;function z(Z,ue){const ye={...Z||{},...ue||{}};return Object.keys(ye).filter(ce=>{const $e=ye[ce];return typeof $e=="boolean"&&$e})}e.$yI=z;class ee{constructor(ue,ye){this.c=null,this.a={...ue.excludePattern||{},...ye.excludePattern||{}},this.b=F.$qj(this.a);let ce=ue.includePattern;ye.includePattern&&(ce?ce={...ce,...ye.includePattern}:ce=ye.includePattern),ce&&(this.c=F.$qj(ce))}matchesExcludesSync(ue,ye,ce){return!!(this.b&&this.b(ue,ye,ce))}includedInQuerySync(ue,ye,ce){return!(this.b&&this.b(ue,ye,ce)||this.c&&!this.c(ue,ye,ce))}includedInQuery(ue,ye,ce){const $e=this.b(ue,ye,ce),ie=()=>this.c?!!this.c(ue,ye,ce):!0;return(0,D.$sg)($e)?$e.then(N=>N?!1:ie()):ie()}hasSiblingExcludeClauses(){return X(this.a)}}e.$zI=ee;function X(Z){for(const ue in Z)if(typeof Z[ue]!="boolean")return!0;return!1}function Ee(Z){if(!Z)return;let ue;return ye=>(ue||(ue=(Z()||Promise.resolve([])).then(ce=>ce?Pe(ce):{})),ue.then(ce=>!!ce[ye]))}e.$AI=Ee;function ke(Z){if(!Z)return;let ue;return ye=>{if(!ue){const ce=Z();ue=ce?Pe(ce):{}}return!!ue[ye]}}e.$BI=ke;function Pe(Z){const ue={};for(const ye of Z)ue[ye]=!0;return ue}}),define(Ae[33],Re([1,0,18,13,21,5,6,48,12,118,23,15,2,159,4,14,176,53,39,27,17,8,7,55,47,3]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t,i,c,g,k,b,n,a,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=e.$1ac=void 0;function y(B,V,j){return new P.$9f(W=>r(W,j)).isEqual(B,V)}function m(B,V,j){return y(B.uri,V.uri,j)?0:(0,D.$Ee)(B.uri.toString(),V.uri.toString())}function I(B,V,j){return B.index!==V.index?B.index<V.index?-1:1:y(B.uri,V.uri,j)?(0,D.$Ee)(B.name,V.name):(0,D.$Ee)(B.uri.toString(),V.uri.toString())}function E(B,V,j,W){const O=B.slice(0).sort((ee,X)=>j(ee,X,W)),z=V.slice(0).sort((ee,X)=>j(ee,X,W));return(0,w.$Bb)(O,z,(ee,X)=>j(ee,X,W))}function r(B,V){const j=V.getCapabilities(B.scheme);return!(j&&j&1024)}class d extends i.$Th{static toExtHostWorkspace(V,j,W,O){if(!V)return{workspace:null,added:[],removed:[]};const{id:z,name:ee,folders:X,configuration:Ee,transient:ke,isUntitled:Pe}=V,Z=[],ue=j;j?X.forEach((ie,N)=>{const q=u.URI.revive(ie.uri),le=d.o(W||j,q,O);le?(le.name=ie.name,le.index=ie.index,Z.push(le)):Z.push({uri:q,name:ie.name,index:N})}):Z.push(...X.map(({uri:ie,name:N,index:q})=>({uri:u.URI.revive(ie),name:N,index:q}))),Z.sort((ie,N)=>ie.index<N.index?-1:1);const ye=new d(z,ee,Z,!!ke,Ee?u.URI.revive(Ee):null,!!Pe,ie=>r(ie,O)),{added:ce,removed:$e}=E(ue?ue.workspaceFolders:[],ye.workspaceFolders,m,O);return{workspace:ye,added:ce,removed:$e}}static o(V,j,W){for(let O=0;O<V.folders.length;O++){const z=V.workspaceFolders[O];if(y(z.uri,j,W))return z}}constructor(V,j,W,O,z,ee,X){super(V,W.map(Ee=>new i.$Uh(Ee)),O,z,X),this.t=j,this.u=ee,this.q=[],this.s=l.$Gh.forUris(X),W.forEach(Ee=>{this.q.push(Ee),this.s.set(Ee.uri,Ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,j){return j&&this.s.get(V)&&(V=(0,P.$gg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let v=class{constructor(V,j,W,O,z){this.c=new L.$ed,this.onDidChangeWorkspace=this.c.event,this.g=new L.$ed,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$gd,this.B=new Map,this.h=O,this.s=W,this.t=z,this.j=new f.$Il,this.k=new F.$Eg,this.o=V.getProxy(o.$UJ.MainThreadWorkspace),this.q=V.getProxy(o.$UJ.MainThreadMessageService);const ee=j.workspace;this.l=ee?new d(ee.id,ee.name,[],!!ee.transient,ee.configuration?u.URI.revive(ee.configuration):null,!!ee.isUntitled,X=>r(X,W)):void 0}$initializeWorkspace(V,j){this.v=j,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:S.Schemas.untitled,path:(0,P.$eg)((0,P.$gg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,j,W,...O){const z=[];if(Array.isArray(O)&&O.forEach(Pe=>{u.URI.isUri(Pe.uri)&&!z.some(Z=>y(Z.uri,Pe.uri,this.s))&&z.push({uri:Pe.uri,name:Pe.name||(0,P.$dg)(Pe.uri)})}),this.n||[j,W].some(Pe=>typeof Pe!="number"||Pe<0)||W===0&&z.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(j+W>ee.length)return!1;const X=ee.slice(0);X.splice(j,W,...z.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,P.$dg)(Pe.uri),index:void 0})));for(let Pe=0;Pe<X.length;Pe++){const Z=X[Pe];if(X.some((ue,ye)=>ye!==Pe&&y(Z.uri,ue.uri,this.s)))return!1}X.forEach((Pe,Z)=>Pe.index=Z);const{added:Ee,removed:ke}=E(ee,X,I,this.s);if(Ee.length===0&&ke.length===0)return!1;if(this.o){const Pe=V.displayName||V.name;this.o.$updateWorkspaceFolders(Pe,j,W,z).then(void 0,Z=>{this.n=void 0;const ue={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(t.Severity.Error,(0,p.localize)(0,null,Pe,Z.toString()),ue,[])})}return this.y(X),!0}getWorkspaceFolder(V,j){if(this.x)return this.x.getWorkspaceFolder(V,j)}async getWorkspaceFolder2(V,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,j)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,j){let W,O="";if(typeof V=="string"?(W=u.URI.file(V),O=V):typeof V<"u"&&(W=V,O=V.fsPath),!W)return O;const z=this.getWorkspaceFolder(W,!0);if(!z)return O;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let ee=(0,P.$jg)(z.uri,W);return j&&z.name&&(ee=`${z.name}/${ee}`),ee}y(V){this.x&&(this.n=d.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:j,added:W,removed:O}=d.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:W,removed:O}))}findFiles(V,j,W,O,z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let ee;if(j===null?ee=!1:j&&(typeof j=="string"?ee=j:ee=j.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:Ee}=R(b.GlobPattern.from(V));return this.o.$startFileSearch(X??null,Ee??null,ee??null,W??null,z).then(ke=>Array.isArray(ke)?ke.map(Pe=>u.URI.revive(Pe)):[])}async findTextInFiles(V,j,W,O,z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const ee=this.j.getNext(),X=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:Ee,folder:ke}=R(b.GlobPattern.from(j.include)),Pe=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,Z={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:X,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:Ee,excludePattern:Pe},ue=!1;if(this.u[ee]=ye=>{if(ue)return;const ce=u.URI.revive(ye.resource);ye.results.forEach($e=>{(0,s.$hI)($e)?W({uri:ce,preview:{text:$e.preview.text,matches:(0,w.$Yb)($e.preview.matches,ie=>new n.$YJ(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,w.$Yb)($e.ranges,ie=>new n.$YJ(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):W({uri:ce,text:$e.text,lineNumber:$e.lineNumber})})},z.isCancellationRequested)return{};try{const ye=await this.o.$startTextSearch(V,ke??null,Z,ee,z);return delete this.u[ee],ye||{}}catch(ye){throw delete this.u[ee],ye}}$handleTextSearchResult(V,j){this.u[j]?.(V)}async save(V){const j=await this.o.$save(V,{saveAs:!1});return u.URI.revive(j)}async saveAs(V){const j=await this.o.$save(V,{saveAs:!0});return u.URI.revive(j)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,j){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,j);const W=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,W),(0,A.$hc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(V,j){this.h.info("Getting edit session identifier for workspaceFolder",V);const W=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const O=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!O),!O)return;const z=await O.provideEditSessionIdentity(W,j);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(V,j,W,O){this.h.info("Getting edit session identifier for workspaceFolder",V);const z=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const ee=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!ee),!ee)return;const X=await ee.provideEditSessionIdentityMatch?.(j,W,O);if(this.h.info("Provider returned edit session identifier match result: ",X),!!X)return X}getOnWillCreateEditSessionIdentityEvent(V){return(j,W,O)=>{const z=function(X){j.call(W,X)};return z.extension=V,this.A.event(z,void 0,O)}}async $onWillCreateEditSessionIdentity(V,j,W){const O=await this.resolveWorkspaceFolder(u.URI.revive(V));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},j,async(z,ee)=>{const X=Date.now();await Promise.resolve(z),Date.now()-X>W&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(V,j){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,j);const W=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerCanonicalUriProvider(O,W),(0,A.$hc)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(V,j,W){const O=this.B.get(V.scheme);if(!O)return;const z=await O.provideCanonicalUri?.(u.URI.revive(V),j,W);if(z)return z}async $provideCanonicalUri(V,j,W){return this.provideCanonicalUri(u.URI.revive(V),{targetScheme:j},W)}};e.$1ac=v,e.$1ac=v=Ke([Ve(0,k.$WL),Ve(1,g.$aM),Ve(2,c.$Oac),Ve(3,h.$4i),Ve(4,a.$Yac)],v),e.$2ac=(0,$.$Ah)("IExtHostWorkspace");function R(B){let V,j;return B&&(typeof B=="string"?V=B:(V=B.pattern,j=u.URI.revive(B.baseUri))),{includePattern:V,folder:j}}}),define(Ae[34],Re([1,0,24,5,33,3,7,178,96,16,13,4,17,14,2]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=e.$4ac=e.$3ac=void 0;function h(a,s){if(s){const o=s.split(".");let y=a;for(let m=0;y&&m<o.length;m++)y=y[o[m]];return y}}function t(a){return a instanceof $.URI}function i(a){return a&&a.uri instanceof $.URI&&a.languageId&&typeof a.languageId=="string"}function c(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function g(a){return a&&a.uri instanceof $.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function k(a){if(t(a))return{resource:a};if(i(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(c(a))return{overrideIdentifier:a.languageId};if(g(a))return{resource:a.uri};if(a===null)return{resource:null}}let b=class{constructor(s,o,y){this.a=s.getProxy(L.$UJ.MainThreadConfiguration),this.c=o,this.b=y,this.d=new P.$Eg,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new n(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(s,o))}};e.$3ac=b,e.$3ac=b=Ke([Ve(0,u.$WL),Ve(1,C.$2ac),Ve(2,p.$4i)],b);class n{constructor(s,o,y,m){this.a=new F.$ed,this.b=s,this.f=m,this.c=o,this.e=l.$sn.parse(y),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,o){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=l.$sn.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(o,y))}getConfiguration(s,o,y){const m=k(o)||{},I=this.g(s?h(this.e.getValue(void 0,m,this.c.workspace),s):this.e.getValue(void 0,m,this.c.workspace));s&&this.h(s,m,y?.identifier);function E(d){if(d==null)return null;if(typeof d=="boolean")return d?2:5;switch(d){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const r={has(d){return typeof h(I,d)<"u"},get:(d,v)=>{this.h(s?`${s}.${d}`:d,m,y?.identifier);let R=h(I,d);if(typeof R>"u")R=v;else{let B;const V=(j,W)=>{if((0,f.$kf)(j)){let O;const z=()=>{B=B||(0,w.$Um)(I),O=O||h(B,W)};return new Proxy(j,{get:(ee,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return z(),()=>O;if(B)return O=O||h(B,W),O[X];const Ee=ee[X];return typeof X=="string"?V(Ee,`${W}.${X}`):Ee},set:(ee,X,Ee)=>(z(),O&&(O[X]=Ee),!0),deleteProperty:(ee,X)=>(z(),O&&delete O[X],!0),defineProperty:(ee,X,Ee)=>(z(),O&&Object.defineProperty(O,X,Ee),!0)})}return Array.isArray(j)?(0,w.$Um)(j):j};R=V(R,d)}return R},update:(d,v,R,B)=>{d=s?`${s}.${d}`:d;const V=E(R);return v!==void 0?this.b.$updateConfigurationOption(V,d,v,m,B):this.b.$removeConfigurationOption(V,d,m,B)},inspect:d=>{d=s?`${s}.${d}`:d;const v=this.e.inspect(d,m,this.c.workspace);if(v)return{key:d,defaultValue:(0,w.$Um)(v.policy?.value??v.default?.value),globalValue:(0,w.$Um)(v.user?.value??v.application?.value),workspaceValue:(0,w.$Um)(v.workspace?.value),workspaceFolderValue:(0,w.$Um)(v.workspaceFolder?.value),defaultLanguageValue:(0,w.$Um)(v.default?.override),globalLanguageValue:(0,w.$Um)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,w.$Um)(v.workspace?.override),workspaceFolderLanguageValue:(0,w.$Um)(v.workspaceFolder?.override),languageIds:(0,w.$Um)(v.overrideIdentifiers)}}};return typeof I=="object"&&(0,w.$Xm)(r,I,!1),Object.freeze(r)}g(s){const o=y=>(0,f.$kf)(y)?new Proxy(y,{get:(m,I)=>o(m[I]),set:(m,I,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(m,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(m,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return o(s)}h(s,o,y){const m=S.$jn.test(s)?4:this.d.get(s),I=y?`[${y.value}] `:"";if(m===4){typeof o?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){o?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,o){const y=new l.$un(s,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,I)=>y.affectsConfiguration(m,k(I))})}k(s){return s.reduce((o,y)=>(o.set(y[0],y[1]),o),new Map)}}e.$4ac=n,e.$5ac=(0,D.$Ah)("IExtHostConfiguration")}),define(Ae[112],Re([1,0,2,13,5,3,7,33,59,34,21,62,17,27,4,12,22,14,80,215,9]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t,i,c,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=e.$2bc=e.$1bc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var b;(function(V){function j(O){if(O!=null)return O}V.from=j;function W(O){if(O!=null)return O}V.to=W})(b||(b={}));var n;(function(V){function j(O){if(O!=null)return O}V.from=j;function W(O){if(O!=null)return O}V.to=W})(n||(n={}));var a;(function(V){function j(O){if(O!=null)return O}V.from=j;function W(O){if(O!=null)return O}V.to=W})(a||(a={}));var s;(function(V){function j(z){if(z){const ee=z;return ee&&!!ee.process}else return!1}V.is=j;function W(z){if(z==null)return;const ee={process:z.process,args:z.args};return z.options&&(ee.options=a.from(z.options)),ee}V.from=W;function O(z){if(z!=null)return new A.$FK(z.process,z.args,z.options)}V.to=O})(s||(s={}));var o;(function(V){function j(O){if(O!=null)return O}V.from=j;function W(O){if(O!=null)return O}V.to=W})(o||(o={}));var y;(function(V){function j(z){if(z){const ee=z;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}V.is=j;function W(z){if(z==null)return;const ee={};return z.commandLine!==void 0?ee.commandLine=z.commandLine:(ee.command=z.command,ee.args=z.args),z.options&&(ee.options=o.from(z.options)),ee}V.from=W;function O(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new A.$GK(z.commandLine,z.options):new A.$GK(z.command,z.args?z.args:[],z.options)}V.to=O})(y||(y={}));var m;(function(V){function j(z){if(z){const ee=z;return ee&&ee.customExecution==="customExecution"}else return!1}V.is=j;function W(z){return{customExecution:"customExecution"}}V.from=W;function O(z,ee){return ee.get(z)}V.to=O})(m||(e.CustomExecutionDTO=m={}));var I;(function(V){function j(W,O){let z;return W.scope!==void 0&&typeof W.scope!="number"?z=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===A.TaskScope.Workspace&&O&&O.workspaceFile?z=O.workspaceFile:z=g.$0F),{id:W._id,workspaceFolder:z}}V.from=j})(I||(e.TaskHandleDTO=I={}));var E;(function(V){function j(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}V.from=j})(E||(E={}));var r;(function(V){function j(z,ee){if(z==null)return[];const X=[];for(const Ee of z){const ke=W(Ee,ee);ke&&X.push(ke)}return X}V.fromMany=j;function W(z,ee){if(z==null)return;let X;z.execution instanceof A.$FK?X=s.from(z.execution):z.execution instanceof A.$GK?X=y.from(z.execution):z.execution&&z.execution instanceof A.$HK&&(X=m.from(z.execution));const Ee=b.from(z.definition);let ke;return z.scope?typeof z.scope=="number"?ke=z.scope:ke=z.scope.uri:ke=A.TaskScope.Workspace,!Ee||!ke?void 0:{_id:z._id,definition:Ee,name:z.name,source:{extensionId:ee.identifier.value,label:z.source,scope:ke},execution:X,isBackground:z.isBackground,group:E.from(z.group),presentationOptions:n.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}V.from=W;async function O(z,ee,X){if(z==null)return;let Ee;s.is(z.execution)?Ee=s.to(z.execution):y.is(z.execution)?Ee=y.to(z.execution):m.is(z.execution)&&(Ee=m.to(z._id,X));const ke=b.to(z.definition);let Pe;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?Pe=z.source.scope:Pe=await ee.resolveWorkspaceFolder(w.URI.revive(z.source.scope)):Pe=A.TaskScope.Workspace),!ke||!Pe)return;const Z=new A.$IK(ke,Pe,z.name,z.source.label,Ee,z.problemMatchers);return z.isBackground!==void 0&&(Z.isBackground=z.isBackground),z.group!==void 0&&(Z.group=A.$EK.from(z.group._id),Z.group&&z.group.isDefault&&(Z.group=new A.$EK(Z.group.id,Z.group.label),z.group.isDefault===!0&&(Z.group.isDefault=z.group.isDefault))),z.presentationOptions&&(Z.presentationOptions=n.to(z.presentationOptions)),z._id&&(Z._id=z._id),z.detail&&(Z.detail=z.detail),Z}V.to=O})(r||(e.TaskDTO=r={}));var d;(function(V){function j(O){return O}V.from=j;function W(O){if(O)return Object.assign(Object.create(null),O)}V.to=W})(d||(d={}));class v{#e;constructor(j,W,O){this._id=W,this.a=O,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let R=class{constructor(j,W,O,z,ee,X,Ee,ke){this.q=new C.$ed,this.r=new C.$ed,this.s=new C.$ed,this.t=new C.$ed,this.a=j.getProxy(L.$UJ.MainThreadTask),this.b=O,this.c=z,this.d=ee,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ee,this.g=ke,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,W,O){if(!O)return new A.$WJ(()=>{});const z=this.w();return this.j.set(z,{type:W,provider:O,extension:j}),this.a.$registerTaskProvider(z,W),new A.$WJ(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(j,W){this.a.$registerTaskSystem(j,W)}fetchTasks(j){return this.a.$fetchTasks(d.from(j)).then(async W=>{const O=[];for(const z of W){const ee=await r.to(z,this.b,this.m);ee&&O.push(ee)}return O})}get taskExecutions(){const j=[];return this.k.forEach(W=>j.push(W)),j}terminateTask(j){if(!(j instanceof v))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,W,O){const z=this.m.get(j.id);z&&(this.o.set(j.id,z),this.e.attachPtyToTerminal(W,await z.callback(O))),this.p=j.id,this.q.fire({execution:await this.y(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){const W=await this.y(j);this.l.delete(j.id),this.k.delete(j.id),this.A(j),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const W=await this.y(j.id);this.s.fire({execution:W,processId:j.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(j){const W=await this.y(j.id);this.t.fire({execution:W,exitCode:j.exitCode})}$provideTasks(j,W){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));const z=[],ee=(0,F.$yg)(()=>O.provider.provideTasks(P.CancellationToken.None)).then(X=>this.u(W,z,O,X));return new Promise(X=>{ee.then(Ee=>{Promise.all(z).then(()=>{X(Ee)})})})}async $resolveTask(j,W){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));if(W.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${O.type}].`);const z=await r.to(W,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const ee=await O.provider.resolveTask(z,P.CancellationToken.None);if(!ee)return;this.z(ee,O);const X=r.from(ee,O.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(X.execution)&&await this.x(X,ee,!0),await this.v(X)}w(){return this.h++}async x(j,W,O){const z=await this.a.$createTaskId(j);!O&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,W.execution)),this.m.set(z,W.execution)}async y(j,W){if(typeof j=="string"){const ee=this.l.get(j);if(!ee)throw new k.$_("Unexpected: The specified task is missing an execution");return ee}const O=this.l.get(j.id);if(O)return O;const z=new Promise((ee,X)=>{function Ee(ke,Pe,Z){Z?ee(new v(ke,Pe.id,Z)):X("Unexpected: Task does not exist.")}W?Ee(this,j,W):r.to(j.task,this.b,this.m).then(ke=>Ee(this,j,ke))});return this.l.set(j.id,z),z.then(ee=>(this.k.set(j.id,ee),ee),ee=>Promise.reject(ee))}z(j,W){j._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}A(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const O=this.n.values();let z=O.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=O.next()}};e.$1bc=R,e.$1bc=R=Ke([Ve(0,u.$WL),Ve(1,p.$aM),Ve(2,l.$2ac),Ve(3,S.$8L),Ve(4,f.$5ac),Ve(5,D.$kbc),Ve(6,i.$4i),Ve(7,c.$Rac)],R);let B=class extends R{constructor(j,W,O,z,ee,X,Ee,ke){super(j,W,O,z,ee,X,Ee,ke),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(j,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const O=r.from(W,j);if(O===void 0)throw new Error("Task is not valid");if(m.is(O.execution))await this.x(O,W,!1);else throw new k.$0;const z=await this.y(await this.a.$getTaskExecution(O),W);return this.a.$executeTask(O).catch(ee=>{throw new Error(ee)}),z}u(j,W,O,z){const ee=[];if(z)for(const X of z){this.z(X,O),(!X.definition||!j[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const Ee=r.from(X,O.extension);Ee&&m.is(Ee.execution)?(ee.push(Ee),W.push(this.x(Ee,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:O.extension}}async v(j){if(m.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,W,O){}};e.$2bc=B,e.$2bc=B=Ke([Ve(0,u.$WL),Ve(1,p.$aM),Ve(2,l.$2ac),Ve(3,S.$8L),Ve(4,f.$5ac),Ve(5,D.$kbc),Ve(6,i.$4i),Ve(7,c.$Rac)],B),e.$3bc=(0,$.$Ah)("IExtHostTask")}),define(Ae[266],Re([1,0,19,21,41,37,23,58,47]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=void 0;class f{constructor(u,p,$){this.k=u,this.l=p,this.o=$,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&L.$qj(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&L.$qj(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const p=this.k.folderQueries||[];return new Promise(($,h)=>{const t=i=>{this.f++,u(i)};if(this.g)return $({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const c=i.toString(),g=w.$_d(c);this.j&&this.j(c,g)||this.v(t,{base:i,basename:g})}),Promise.all(p.map(i=>this.p(i,t))).then(i=>{$({limitHit:this.e,stats:i[0]||void 0})},i=>{h(new Error((0,C.$li)(i)))})})}async p(u,p){const $=new F.$od,h=this.q(u),t=this.r(),i=new S.$zI(this.k,u),c=!i.hasSiblingExcludeClauses();let g;try{this.h.add($),g=l.$ad.create();const k=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},h,$.token),b=g.elapsed(),n=l.$ad.create();return this.g&&!this.e||(k&&k.forEach(a=>{const s=w.$5d.relative(u.folder.path,a.path);if(c){const o=w.$_d(a.path);this.v(p,{base:u.folder,relativePath:s,basename:o});return}this.s(t,u.folder,s,p)}),this.g&&!this.e)?null:(this.u(t,i,p),{providerTime:b,postProcessTime:n.elapsed()})}finally{$.dispose(),this.h.delete($)}}q(u){const p=(0,S.$yI)(this.k.includePattern,u.includePattern),$=(0,S.$yI)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:$,includes:p,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},p,$,h){if($===this.a){const i=w.$_d(this.a);this.v(h,{base:p,relativePath:this.a,basename:i})}function t(i){const c=w.$_d(i),g=w.$$d(i);let k=u[g];k||(k=u[g]=[],t(g)),k.push({base:p,relativePath:i,basename:c})}t($)}u({rootEntries:u,pathToEntries:p},$,h){const t=this,i=this.a;function c(g){const k=(0,S.$BI)(()=>g.map(b=>b.basename));for(let b=0,n=g.length;b<n;b++){const a=g[b],{relativePath:s,basename:o}=a;if($.matchesExcludesSync(s,o,i!==o?k:void 0))continue;const y=p[s];if(y)c(y);else{if(s===i)continue;t.v(h,a)}if(t.e)break}}c(u)}v(u,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(p))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,p,$,h){const t=this.c(u.cacheKey),i=new f(u,p,t&&t.token);let c=0;const g=k=>{c+=k.length,$(k.map(b=>this.d(b)))};return this.e(i,P.a,g,h).then(k=>({limitHit:k.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:k.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new F.$od),this.b.get(u)}d(u){return u.relativePath?{resource:A.$hg(u.base,u.relativePath)}:{resource:u.base}}e(u,p,$,h){const t=h.onCancellationRequested(()=>{u.cancel()}),i=g=>{g&&(c.push(g),p>0&&c.length>=p&&($(c),c=[]))};let c=[];return u.search(i).then(g=>(c.length&&$(c),t.dispose(),g),g=>(c.length&&$(c),t.dispose(),Promise.reject(g)))}}e.$acc=P}),define(Ae[267],Re([1,0,18,100,37,90,28,12,19,23,15,16,2,282,168,43,14,53,103,265,47]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t,i,c,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=e.$sJ=void 0;let b=class{constructor(d,v,R,B,V){this.a=d,this.b=v,this.c=R,this.d=B,this.e=V}text(d,v,R={}){d=this.f(d,R);const B=this.a.getValue(),V=v&&v.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(v?.map(i.$Vh),R),type:2,contentPattern:d,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:B.search.usePCRE2||V||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}f(d,v){const R=this.a.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const B={...d,wordSeparators:R.editor.wordSeparators};return this.j(d,v)&&(B.isCaseSensitive=!0),this.k(d)&&(B.isMultiline=!0),v.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=v.notebookSearchConfig.includeMarkupInput),v.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=v.notebookSearchConfig.includeMarkupPreview),v.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=v.notebookSearchConfig.includeCodeInput),v.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=v.notebookSearchConfig.includeOutput),B}file(d,v={}){return{...this.h(d,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}g(d,v){return d?(d=Array.isArray(d)?d.map(y):y(d),v?this.parseSearchPaths(d):{pattern:a(...Array.isArray(d)?d:[d])}):{}}h(d=[],v={}){const R=this.g(v.includePattern,v.expandPatterns),B=this.g(v.excludePattern,v.expandPatterns),V=d.length>1,j=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(z=>this.q(z,v,B)):d.map(z=>this.r(z,v,B,V))).filter(z=>!!z),W={_reason:v._reason,folderQueries:j,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:B.pattern,includePattern:R.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const z=w.$Eb(w.$Ob(this.c.groups.map(Ee=>Ee.editors.map(ke=>ke.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const ee=z.filter(Ee=>(0,k.$pI)(W,Ee.fsPath)),X=this.i(ee);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...W,...X}}const O=v.extraFileResources&&v.extraFileResources.filter(z=>(0,k.$pI)(W,z.fsPath));return W.extraFileResources=O&&O.length?O:void 0,W}i(d){const v=[],R=new A.$yi,B={};let V=!1;return d.forEach(j=>{if(j.scheme===l.Schemas.walkThrough)return;if((0,f.$lg)(j)){const O=this.b.getWorkspaceFolder(j)?.uri??j.with({path:S.$$d(j.fsPath)});let z=R.get(O);z||(V=!0,z={folder:O,includePattern:{}},v.push(z),R.set(O,z));const ee=S.$0d(O.fsPath,j.fsPath);(0,D.$tf)(z.includePattern)[ee.replace(/\\/g,"/")]=!0}else j.fsPath&&(V=!0,B[j.fsPath]=!0)}),{folderQueries:v,includePattern:B,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(d,v){if(v.isSmartCase){if(d.isRegExp){if(P.$_e(d.pattern,!0))return!0}else if(P.$_e(d.pattern))return!0}return!!d.isCaseSensitive}k(d){return d.isMultiline||d.isRegExp&&(0,p.$gC)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const v=X=>S.$7d(X)||/^\.\.?([\/\\]|$)/.test(X),B=(Array.isArray(d)?d:s(d)).map(X=>{const Ee=this.e.resolvedUserHome;return Ee?(0,L.$fA)(X,Ee.scheme===l.Schemas.file?Ee.fsPath:Ee.path):X}),V=F.$I(B,X=>v(X)?"searchPaths":"exprSegments"),j=(V.exprSegments||[]).map(X=>P.$ue(X,"/")).map(X=>P.$ue(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),o(X))),W={},O=this.m(V.searchPaths||[]);O&&O.length&&(W.searchPaths=O);const z=w.$Ob(j),ee=a(...z);return ee&&(W.pattern=ee),W}l(d,v){return v.disregardExcludeSettings?void 0:(0,k.$oI)(d,!v.disregardSearchExcludeSettings)}m(d){if(!d||!d.length)return[];const v=d.flatMap(B=>{let{pathPortion:V,globPortion:j}=n(B);return j&&(j=m(j)),this.n(V).flatMap(O=>this.o(O,j))}),R=new Map;return v.forEach(B=>{const V=B.searchPath.toString(),j=R.get(V);j?B.pattern&&(j.pattern=j.pattern||{},j.pattern[B.pattern]=!0):R.set(V,{searchPath:B.searchPath,pattern:B.pattern?a(B.pattern):void 0})}),Array.from(R.values())}n(d){if(S.$7d(d)){const v=this.b.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==l.Schemas.file?[{searchPath:v[0].uri.with({path:d})}]:[{searchPath:u.URI.file(S.$6d(d))}]}if(this.b.getWorkbenchState()===2){const v=this.b.getWorkspace().folders[0].uri;if(d=y(d),d.startsWith("../")||d===".."){const B=S.$5d.resolve(v.path,d);return[{searchPath:v.with({path:B})}]}const R=m(d);return[{searchPath:v,pattern:R}]}else{if(d==="./"||d===".\\")return[];{const v=d.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(V=>{const j=v.match(new RegExp(`^${P.$pe(V.name)}(?:/(.*)|$)`));return j?{match:j,folder:V}:null}).filter(D.$qf);if(B.length)return B.map(V=>{const j=V.match[1];return{searchPath:V.folder.uri,pattern:j&&m(j)}});{const V=d.match(/\.[\/\\](.+)[\/\\]?/),j=V?V[1]:d,W=$.localize(0,null,j);throw new Error(W)}}}}o(d,v){const R=d.pattern&&v?`${d.pattern}/${v}`:d.pattern||v,B=[{searchPath:d.searchPath,pattern:R}];return R&&!R.endsWith("**")&&B.push({searchPath:d.searchPath,pattern:R+"/**"}),B}q(d,v,R){const B=this.r((0,i.$Vh)(d.searchPath),v,R,!1);return B?{...B,includePattern:d.pattern}:null}r(d,v,R,B){let V;const j=u.URI.isUri(d)?d:d.uri;if(R.searchPaths){const X=R.searchPaths.filter(Ee=>(0,f.$ag)(Ee.searchPath,j))[0];if(X&&!X.pattern)return null;X&&(V=X.pattern)}const W=this.a.getValue({resource:j}),z={...this.l(W,v)||{},...V||{}},ee=u.URI.isUri(d)?(0,f.$eg)(d):d.name;return{folder:j,folderName:B?ee:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!W.search.followSymlinks}}};e.$sJ=b,e.$sJ=b=Ke([Ve(0,h.$7h),Ve(1,i.$Jh),Ve(2,c.$3C),Ve(3,t.$4i),Ve(4,g.$qJ)],b);function n(r){const d=r.match(/[\*\{\}\(\)\[\]\?]/);if(d){const v=d.index,R=r.substr(0,v).match(/[/|\\][^/\\]*$/);if(R){let B=r.substr(0,R.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:r.substr((R.index||0)+1)}}}return{pathPortion:r}}function a(...r){return r.length?r.reduce((d,v)=>(d[v]=!0,d),Object.create(null)):void 0}function s(r){return C.$oj(r,",").map(d=>d.trim()).filter(d=>!!d.length)}function o(r){return[`**/${r}/**`,`**/${r}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function y(r){return r.replace(/\\/g,"/")}function m(r){return y(r).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(r){return r.replace(/([?*[\]])/g,"[$1]")}function E(r,d){r=w.$Jb(r,B=>B.toString());const v=[],R=d.getWorkspace();return r&&r.forEach(B=>{let V;if(d.getWorkbenchState()===2)V=(0,f.$jg)(R.folders[0].uri,B),V&&V!=="."&&(V="./"+V);else{const j=d.getWorkspaceFolder(B);if(j){const W=j.name;if(R.folders.filter(z=>z.name===W).length===1){const z=(0,f.$jg)(j.uri,B);z===""?V=`./${j.name}`:V=`./${j.name}/${z}`}else V=B.fsPath}}V&&v.push(I(V))}),v}e.$tJ=E}),define(Ae[268],Re([1,0,23,2,21,9,4,267,47,53]),function(be,e,w,F,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llb=e.$klb=void 0;const P=7e3;function D(h,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const c=[],g=[];for(const o of i)if(/^workspaceContains:/.test(o)){const y=o.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||h.forceUsingSearch?g.push(y):c.push(y)}if(c.length===0&&g.length===0)return Promise.resolve(void 0);let k;const b=new Promise((o,y)=>{k=o}),n=o=>k({activationEvent:o}),a=Promise.all(c.map(o=>u(h,o,n))).then(()=>{}),s=p(h,t.identifier,g,n);return Promise.all([a,s]).then(()=>{k(void 0)}),b}e.$klb=D;async function u(h,t,i){for(const c of h.folders)if(await h.exists(w.$hg(F.URI.revive(c),t))){i(`workspaceContains:${t}`);return}}async function p(h,t,i,c){if(i.length===0)return Promise.resolve(void 0);const g=new C.$od,k=h.checkExists(h.folders,i,g.token),b=setTimeout(async()=>{g.cancel(),h.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let n=!1;try{n=await k}catch(a){L.$2(a)||L.$Y(a)}g.dispose(),clearTimeout(b),n&&c(`workspaceContains:${i.join(",")}`)}function $(h,t,i,c){const g=h.get(A.$zh),k=h.get(S.$gI),n=g.createInstance(l.$sJ).file(t.map(a=>(0,f.$Vh)(F.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return k.fileSearch(n,c).then(a=>!!a.limitHit,a=>L.$2(a)?!1:Promise.reject(a))}e.$llb=$}),define(Ae[35],Re([1,0,149,19,87,23,13,6,48,2,14,3,34,210,84,33,26,107,9,20,25,189,7,97,4,27,85,17,71,86,62,5,268,83,191,12,81,58,22,82]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t,i,c,g,k,b,n,a,s,o,y,m,I,E,r,d,v,R,B,V,j,W,O,z){"use strict";var ee;Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=e.$ybc=e.$xbc=e.$wbc=e.$vbc=void 0,e.$vbc=(0,s.$Ah)("IHostUtils");let X=ee=class extends l.$jc{constructor(ie,N,q,le,we,ve,me,De,ne,he,se,oe){super(),this.X=oe,this.a=this.B(new d.$ed),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=N,this.g=q,this.f=me,this.j=le,this.m=we,this.s=ve,this.t=ne,this.u=he,this.w=se,this.y=this.g.getProxy(D.$UJ.MainThreadWorkspace),this.z=this.g.getProxy(D.$UJ.MainThreadTelemetry),this.C=this.g.getProxy(D.$UJ.MainThreadExtensionService),this.D=new A.$Eg,this.F=new A.$Eg,this.G=new A.$Eg,this.H=new A.$Eg,this.I=new ce(this.f.activationEvents),this.L=new i.$g3b(this.I,this.f.allExtensions);const fe=new g.$Vl(this.f.myExtensions);this.J=new i.$g3b(this.I,ue(this.L,fe)),O.$s&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new $.$cbc(this.g,this.s),this.N=new R.$obc(this.g),this.O=De,this.h=ie.createChild(new I.$yh([$.$dbc,this.M],[R.$pbc,this.N])),this.P=this.B(new p.$bbc(this.J,this.L,{onExtensionActivationError:(Ie,M,K)=>{this.C.$onExtensionActivationError(Ie,c.$1(M),K)},actualActivateExtension:async(Ie,M)=>{if(i.$g3b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,M),new p.$abc;const K=this.J.getExtensionDescription(Ie);return this.db(K,M)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ie){c.$Y(ie)}}async Y(){this.O.onWillDeactivateAll();let ie=[];try{ie=this.J.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.cb(we))}catch{}await Promise.all(ie)}terminate(ie,N=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ie}`),this.s.flush(),this.u.dispose(),this.P.dispose(),c.setUnexpectedErrorHandler(le=>{this.s.error(le)}),this.g.dispose();const q=this.Y();Promise.race([(0,A.$Gg)(5e3),q]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${N}`):this.s.info(`Extension host exiting with code ${N}`),this.s.flush(),this.s.dispose(),this.c.exit(N)})}isActivated(ie){return this.G.isOpen()?this.P.isActivated(ie):!1}async getExtension(ie){const N=await this.C.$getExtension(ie);return N&&{...N,identifier:new g.$Ul(N.identifier.value),extensionLocation:f.URI.revive(N.extensionLocation)}}Z(ie,N){return this.P.activateByEvent(ie,N)}$(ie,N){return this.P.activateById(ie,N)}activateByIdWithErrors(ie,N){return this.$(ie,N).then(()=>{const q=this.P.getActivatedExtension(ie);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ie=>this.J)}getExtensionExports(ie){if(this.G.isOpen())return this.P.getActivatedExtension(ie).exports;try{return this.P.getActivatedExtension(ie).exports}catch{return null}}async ab(ie){if(ie.scheme===V.Schemas.file&&this.c.fsRealpath){const N=await this.c.fsRealpath(ie.fsPath);return f.URI.file(N)}return ie}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ie=>new ye(ie))),this.Q}async bb(ie){const N=S.$Gh.forUris(q=>L.$$f.ignorePathCasing(q));return await Promise.all(ie.map(async q=>{if(this.ub(q)){const le=await this.ab(q.extensionLocation);N.set(le,q)}})),N}cb(ie){let N=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ie))return N;const q=this.P.getActivatedExtension(ie);if(!q)return N;try{typeof q.module.deactivate=="function"&&(N=Promise.resolve(q.module.deactivate()).then(void 0,le=>(this.s.error(le),Promise.resolve(void 0))))}catch(le){this.s.error(`An error occurred when deactivating the extension '${ie.value}':`),this.s.error(le)}try{(0,l.$ec)(q.subscriptions)}catch(le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this.s.error(le)}return N}async db(ie,N){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ie.identifier):await this.C.$onWillActivateExtension(ie.identifier),this.fb(ie,N).then(q=>{const le=q.activationTimes;return this.C.$onDidActivateExtension(ie.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,N),this.eb(ie,N,"success",le),q},q=>{throw this.eb(ie,N,"failure"),q})}eb(ie,N,q,le){const we=ke(ie,N);this.z.$publicLog2("extensionActivationTimes",{...we,...le||{},outcome:q})}fb(ie,N){const q=ke(ie,N);this.z.$publicLog2("activatePlugin",q);const le=this.ub(ie);if(!le)return Promise.resolve(new p.$_ac(p.$9ac.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${N.startup}, activationEvent: '${N.activationEvent}'${ie.identifier.value!==N.extensionId.value?`, root cause: ${N.extensionId.value}`:""}`),this.s.flush();const we=new p.$0ac(N.startup);return Promise.all([this.vb(ie,(0,L.$hg)(ie.extensionLocation,le),we),this.gb(ie)]).then(ve=>(C.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),ee.hb(this.s,ie.identifier,ve[0],ve[1],we))).then(ve=>(C.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),ve))}gb(ie){const N=new b.$fbc(ie,this.M),q=new b.$ebc(ie.identifier.value,!1,this.M),le=new B.$qbc(ie,this.N),we=ie.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,ve=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([N.whenReady,q.whenReady,this.O.whenReady]).then(()=>{const me=this;let De,ne;const he=(0,t.$NF)(ie,"ipc")?this.f.messagePorts?.get(g.$Ul.toKey(ie.identifier)):void 0;return Object.freeze({globalState:N,workspaceState:q,secrets:le,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(se){return F.$8d(ie.extensionLocation.fsPath,se)},get storagePath(){return me.O.workspaceValue(ie)?.fsPath},get globalStoragePath(){return me.O.globalValue(ie).fsPath},get logPath(){return F.$8d(me.f.logsLocation.fsPath,ie.identifier.value)},get logUri(){return f.URI.joinPath(me.f.logsLocation,ie.identifier.value)},get storageUri(){return me.O.workspaceValue(ie)},get globalStorageUri(){return me.O.globalValue(ie)},get extensionMode(){return we},get extension(){return De===void 0&&(De=new Z(me,ie.identifier,ie,ve,!1)),De},get extensionRuntime(){return(0,t.$OF)(ie,"extensionRuntime"),me.extensionRuntime},get environmentVariableCollection(){return me.u.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!ne){if(!he)return;const se=d.Event.buffer(d.Event.fromDOMEventEmitter(he,"message",oe=>oe.data));he.start(),ne={onDidReceiveMessage:se,postMessage:he.postMessage.bind(he)}}return ne}})})}static hb(ie,N,q,le,we){return q=q||{activate:void 0,deactivate:void 0},this.ib(ie,N,q,le,we).then(ve=>new p.$$ac(!1,null,we.build(),q,ve,le.subscriptions))}static ib(ie,N,q,le,we){if(typeof q.activate=="function")try{we.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${N.value}`);const ve=typeof global=="object"?global:self,me=q.activate.apply(ve,[le]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(me).then(De=>(we.activateResolveStop(),De))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(q)}jb(ie,N){this.$(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:N}).then(void 0,q=>{this.s.error(q)})}kb(ie,N=0){const le=Date.now();(0,O.$A)(()=>{for(let we=N;we<ie.length;we+=1){const ve=ie[we];for(const me of ve.activationEvents??[])if(me==="onStartupFinished")if(Date.now()-le>50){this.kb(ie,we);break}else this.jb(ve,me)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(ie=>{const N=ie.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),q=this.J.getAllExtensionDescriptions();if(N)this.kb(q);else for(const le of q)if(le.activationEvents)for(const we of le.activationEvents)we==="onStartupFinished"&&this.jb(le,we)})}mb(){const ie=this.Z("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.nb(ve.added)));const N=this.j.workspace?this.j.workspace.folders:[],q=this.nb(N),le=this.pb(),we=Promise.all([le,ie,q]).then(()=>{});return Promise.race([we,(0,A.$Gg)(1e4)]).then(()=>{this.lb()}),we}nb(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(N=>this.ob(ie,N))).then(()=>{})}async ob(ie,N){if(this.isActivated(N.identifier))return;const q=!this.f.remote.isRemote&&!!this.f.remote.authority,le={logService:this.s,folders:ie.map(ve=>ve.uri),forceUsingSearch:q||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,me,De)=>this.y.$checkExists(ve,me,De)},we=await(0,v.$klb)(le,N);if(we)return this.$(N.identifier,{startup:!0,extensionId:N.identifier,activationEvent:we.activationEvent}).then(void 0,ve=>this.s.error(ve))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ie){throw console.error(ie),ie}}async qb(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:N}=this.f.environment;if(!ie||!N)throw new Error(w.localize(0,null));const q=await this.vb(null,N,new p.$0ac(!1));if(!q||typeof q.run!="function")throw new Error(w.localize(1,null,N.toString()));return new Promise((le,we)=>{const ve=(ne,he)=>{ne?(O.$s&&this.s.error("Test runner called back with error",ne),we(ne)):(O.$s&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),le(typeof he=="number"&&he>0?1:0))},me=(0,L.$8f)(N),De=q.run(me,ve);De&&De.then&&De.then(()=>{O.$s&&this.s.info("Test runner finished successfully."),le(0)}).catch(ne=>{O.$s&&this.s.error("Test runner finished with error",ne),we(ne instanceof Error&&ne.stack?ne.stack:String(ne))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Gg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,N){return this.R[ie]=N,(0,l.$hc)(()=>{delete this.R[ie]})}async getRemoteExecServer(ie){const{resolver:N}=await this.sb(ie);return N?.resolveExecServer?.(ie,{resolveAttempt:0})}async sb(ie){const N=ie.indexOf("+");if(N===-1)throw new n.$3J("Not an authority that can be resolved!",a.RemoteAuthorityResolverErrorCode.InvalidAuthority);const q=ie.substr(0,N);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this.R[q]}}async $resolveAuthority(ie,N){const q=W.$ad.create(!1),le=()=>`[resolveAuthority(${(0,a.$Mk)(ie)},${N})][${q.elapsed()}ms] `,we=Y=>this.s.info(`${le()}${Y}`),ve=Y=>this.s.warn(`${le()}${Y}`),me=(Y,J=void 0)=>this.s.error(`${le()}${Y}`,J),De=Y=>{if(Y instanceof n.$3J)return{type:"error",error:{code:Y._code,message:Y._message,detail:Y._detail}};throw Y},ne=async Y=>{we(`activating resolver for ${Y}...`);const{resolver:J,authorityPrefix:x}=await this.sb(Y);if(!J)throw me(`no resolver for ${x}`),new n.$3J(`No remote extension installed to resolve ${x}.`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:x,remoteAuthority:Y}},he=ie.split(/@|%40/g).reverse();we(`activating remote resolvers ${he.join(" -> ")}`);let se;try{se=await Promise.all(he.map(ne)).catch(async Y=>{if(!(Y instanceof n.$3J)||Y._code!==a.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Y;return ve(`resolving nested authorities failed: ${Y.message}`),[await ne(ie)]})}catch(Y){return De(Y)}const oe=new A.$Qg;oe.cancelAndSet(()=>we("waiting..."),1e3);let fe,Ie;for(const[Y,{authorityPrefix:J,resolver:x,remoteAuthority:ae}]of se.entries())try{if(Y===se.length-1)we("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${J}`),fe=await x.resolve(ae,{resolveAttempt:N,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${J}`),we("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,n.$2J.isManagedResolvedAuthority(fe)?fe:void 0));else{if(we(`invoking resolveExecServer() for ${ae}`),C.mark(`code/extHost/willResolveExecServer/${J}`),Ie=await x.resolveExecServer?.(ae,{resolveAttempt:N,execServer:Ie}),!Ie)throw new n.$3J(`Exec server was not available for ${ae}`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(Le){return C.mark(`code/extHost/didResolveAuthorityError/${J}`),me("returned an error",Le),oe.dispose(),De(Le)}oe.dispose();const M={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures},K={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};we(`returned ${n.$2J.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let G;if(n.$2J.isManagedResolvedAuthority(fe)){const Y=N;this.X.setFactory(Y,fe.makeConnection),G={authority:ie,connectTo:new a.$Jk(Y),connectionToken:fe.connectionToken}}else G={authority:ie,connectTo:new a.$Kk(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:G,options:K,tunnelInformation:M}}}async $getCanonicalURI(ie,N){this.s.info(`$getCanonicalURI invoked for authority (${(0,a.$Mk)(ie)})`);const{resolver:q}=await this.sb(ie);if(!q)return null;const le=f.URI.revive(N);if(typeof q.getCanonicalURI>"u")return le;const we=await(0,A.$yg)(()=>q.getCanonicalURI(le));return we||le}$startExtensionHost(ie){ie.toAdd.forEach(le=>le.extensionLocation=f.URI.revive(le.extensionLocation));const{globalRegistry:N,myExtensions:q}=Ee(this.I,this.L,this.J,ie);return this.L.set(N.getAllExtensionDescriptions()),this.J.set(q),O.$s&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(ie,N){return N===1?this.D.wait().then(q=>this.Z(ie,!1)):this.G.wait().then(q=>this.Z(ie,!1))}async $activate(ie,N){return await this.G.wait(),this.J.getExtensionDescription(ie)?(await this.$(ie,N),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(ve=>ve.extensionLocation=f.URI.revive(ve.extensionLocation));const{globalRegistry:N,myExtensions:q}=Ee(this.I,this.L,this.J,ie),le=await this.bb(q);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(N.getAllExtensionDescriptions()),this.J.set(q),O.$s&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const N=k.$Ed.alloc(ie),q=Math.random()%256;for(let le=0;le<ie;le++)N.writeUInt8(q,le);return N}async $updateRemoteConnectionData(ie){this.W=ie,this.a.fire()}};e.$wbc=X,e.$wbc=X=ee=Ke([Ve(0,s.$zh),Ve(1,e.$vbc),Ve(2,m.$WL),Ve(3,h.$2ac),Ve(4,u.$5ac),Ve(5,P.$4i),Ve(6,o.$aM),Ve(7,y.$ibc),Ve(8,E.$esb),Ve(9,r.$kbc),Ve(10,j.$sbc),Ve(11,z.$tbc)],X);function Ee($e,ie,N,q){$e.addActivationEvents(q.addActivationEvents);const le=new i.$g3b($e,ie.getAllExtensionDescriptions());le.deltaExtensions(q.toAdd,q.toRemove);const we=new g.$Vl(N.getAllExtensionDescriptions().map(me=>me.identifier));for(const me of q.myToRemove)we.delete(me);for(const me of q.myToAdd)we.add(me);const ve=ue(le,we);return{globalRegistry:le,myExtensions:ve}}function ke($e,ie){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}function Pe($e){return $e.getAllExtensionDescriptions().map(ie=>ie.identifier.value).join(",")}e.$xbc=(0,s.$Ah)("IExtHostExtensionService");class Z{#e;#t;#i;constructor(ie,N,q,le,we){this.#e=ie,this.#t=N,this.#i=q.identifier,this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=F.$6d((0,L.$8f)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=le,this.isFromDifferentExtensionHost=we}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$ybc=Z;function ue($e,ie){return $e.getAllExtensionDescriptions().filter(N=>ie.has(N.identifier))}class ye{constructor(ie){this.a=ie}setSearchTree(ie){this.a=ie}findSubstr(ie){return this.a.findSubstr(ie)}forEach(ie){return this.a.forEach(ie)}}e.$zbc=ye;class ce{constructor(ie){this.a=new g.$Wl,this.addActivationEvents(ie)}readActivationEvents(ie){return this.a.get(ie.identifier)}addActivationEvents(ie){for(const N of Object.keys(ie))this.a.set(N,ie[N])}}}),define(Ae[269],Re([1,0,87,2,3,34,26,20,17,27,4,35,14,15]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=void 0;let h=class{constructor(k,b,n,a,s,o,y){this.c=k,this.d=b,this.e=n,this.f=a,this.g=s,this.h=o,this.i=y,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const k=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const b=await this.g.getExtensionPathIndex();this.register(new i(this.c,b,this.d,k,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(c,b,this.h.environment.appUriScheme))}register(k){if("nodeModuleName"in k)if(Array.isArray(k.nodeModuleName))for(const b of k.nodeModuleName)this.a.set(b,k);else this.a.set(k.nodeModuleName,k);typeof k.alternativeModuleName=="function"&&this.b.push(b=>k.alternativeModuleName(b))}};e.$Vcc=h,e.$Vcc=h=Ke([Ve(2,P.$zh),Ve(3,L.$5ac),Ve(4,D.$xbc),Ve(5,f.$aM),Ve(6,u.$4i)],h);let t=class{static{$=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(k){if(k.environment.appRoot&&$.a.size){const b=(0,p.$pe)(this.c(k.environment.appRoot.fsPath)),n="[a-z0-9_.-]",a=`@${n}+\\/${n}+|${n}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${b}/${s}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(k){if(!this.b)return;const b=this.b.exec(this.c(k));if(!b)return;const[,n,a,s]=b,o=$.a.get(a);if(o!==void 0)return console.warn(`${a} as been renamed to ${o}, please update your imports`),n+o+s}c(k){return k.replace(/\\/g,"/")}};t=$=Ke([Ve(0,f.$aM)],t);class i{constructor(k,b,n,a,s){this.c=k,this.d=b,this.e=n,this.f=a,this.g=s,this.nodeModuleName="vscode",this.a=new l.$Wl}load(k,b){const n=this.d.findSubstr(b);if(n){let a=this.a.get(n.identifier);return a||(a=this.c(n,this.e,this.f),this.a.set(n.identifier,a)),a}if(!this.b){let a="";this.d.forEach((s,o)=>a+=`	${o} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${b}. These are the extension path mappings: 
${a}`),this.b=this.c(A.$IF,this.e,this.f)}return this.b}}let c=class{constructor(k,b,n){this.e=k,this.f=b,this.nodeModuleName=["open","opn"],this.d=n.getProxy(C.$UJ.MainThreadTelemetry);const a=n.getProxy(C.$UJ.MainThreadWindow);this.c=(s,o)=>{const y=F.URI.parse(s);return o?this.g(s,o):y.scheme==="http"||y.scheme==="https"?a.$openUri(y,s,{allowTunneling:!0}):y.scheme==="mailto"||y.scheme===this.f?a.$openUri(y,s,{}):this.g(s,o)}}load(k,b,n){const a=this.e.findSubstr(b);return a&&(this.a=a.identifier.value,this.h()),this.b=n(k),this.c}g(k,b){return this.i(),this.b(k,b)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};c=Ke([Ve(2,S.$WL)],c)}),define(Ae[113],Re([1,0,65,6,19,74,4,59,60,35,7,33,201,34]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=e.$6bc=void 0,e.$6bc=(0,A.$Ah)("IExtHostVariableResolverProvider");class $ extends u.$XM{constructor(i,c,g,k,b,n,a){function s(){if(g){const o=g.activeEditor();if(o)return o.document.uri;const y=k.tabGroups.all.find(m=>m.isActive)?.activeTab;if(y!==void 0){if(y.input instanceof P.$DL||y.input instanceof P.$IL)return y.input.modified;if(y.input instanceof P.$CL||y.input instanceof P.$HL||y.input instanceof P.$FL)return y.input.uri}}}super({getFolderUri:o=>{const y=n.folders.filter(m=>m.name===o);if(y&&y.length>0)return y[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(o,y)=>b.getConfiguration(void 0,o).get(y),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=s();if(o)return C.$6d(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const o=s();if(o){const y=c.getWorkspaceFolder(o);if(y)return C.$6d(y.uri.fsPath)}}},getSelectedText:()=>{if(g){const o=g.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(g){const o=g.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(L.env))}}let h=class extends F.$jc{constructor(i,c,g,k,b){super(),this.b=i,this.c=c,this.g=g,this.h=k,this.j=b,this.a=new w.$T(async()=>{const n=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.j,n,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$7bc=h,e.$7bc=h=Ke([Ve(0,f.$xbc),Ve(1,D.$2ac),Ve(2,l.$8L),Ve(3,p.$5ac),Ve(4,S.$4bc)],h)}),define(Ae[114],Re([1,0,13,5,2,4,3,60,35,17,7,33,194,196,34,113]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=e.$$bc=e.$0bc=e.$9bc=e.$8bc=void 0,e.$8bc=(0,L.$Ah)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,s,o,y,m,I){this.E=s,this.F=o,this.G=y,this.H=m,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$ed,this.n=new F.$ed,this.o=new F.$ed,this.u=new F.$ed,this.k=a.getProxy(A.$UJ.MainThreadDebugService),this.y=new F.$ed,this.A=new F.$ed,this.v=new c(this.k),this.w=new Map,this.F.getExtensionRegistry().then(E=>{E.onDidChange(r=>{this.J(E)}),this.J(E)})}asDebugSourceUri(a,s){const o=a;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let y=`debug:${encodeURIComponent(o.path||"")}`,m="?";return s&&(y+=`${m}session=${encodeURIComponent(s.id)}`,m="&"),y+=`${m}ref=${o.sourceReference}`,C.URI.parse(y)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(a){const s=[];for(const o of a.getAllExtensionDescriptions())if(o.contributes){const y=o.contributes.debuggers;if(y&&y.length>0)for(const m of y)(0,p.$kF)(m)&&s.push(m.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const a=[];return this.w.forEach(s=>a.push(s)),a}addBreakpoints(a){const s=a.filter(m=>{const I=m.id;return this.w.has(I)?!1:(this.w.set(I,m),!0)});this.U(s,[],[]);const o=[],y=new Map;for(const m of s)if(m instanceof P.$WK){let I=y.get(m.location.uri.toString());I||(I={type:"sourceMulti",uri:m.location.uri,lines:[]},y.set(m.location.uri.toString(),I),o.push(I)),I.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof P.$XK&&o.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(a){const s=a.filter(I=>this.w.delete(I.id));this.U([],s,[]);const o=s.filter(I=>I instanceof P.$WK).map(I=>I.id),y=s.filter(I=>I instanceof P.$XK).map(I=>I.id),m=s.filter(I=>I instanceof P.$YK).map(I=>I.id);return this.k.$unregisterBreakpoints(o,y,m)}startDebugging(a,s,o){return this.k.$startDebugging(a?a.uri:void 0,s,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,s,o){if(!s)return new P.$WJ(()=>{});const y=this.d++;return this.f.push({type:a,handle:y,provider:s}),this.k.$registerDebugConfigurationProvider(a,o,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,y),new P.$WJ(()=>{this.f=this.f.filter(m=>m.provider!==s),this.k.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(a,s,o){if(!o)return new P.$WJ(()=>{});if(!this.Q(a,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this.g++;return this.h.push({type:s,handle:y,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(s,y),new P.$WJ(()=>{this.h=this.h.filter(m=>m.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(a,s){if(!s)return new P.$WJ(()=>{});const o=this.i++;return this.j.push({type:a,handle:o,factory:s}),new P.$WJ(()=>{this.j=this.j.filter(y=>y.factory!==s)})}async $runInTerminal(a,s){return Promise.resolve(void 0)}async $substituteVariables(a,s){let o;const y=await this.W(a);return y&&(o={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,s)}K(a,s){if(a.type==="implementation")return new k(a.implementation)}L(){}async $startDASession(a,s){const o=this,y=await this.V(s);return this.S(this.N(y.type),y).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const I=this.M(m),E=this.K(I,y);if(!E)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const r=E;return this.B.set(a,r),this.R(y).then(d=>(d&&this.C.set(a,d),r.onMessage(async v=>{if(v.type==="request"&&v.command==="handshake"){const R=v,B={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(R.arguments.value);B.body={signature:V},r.sendResponse(B)}else throw new Error("no signer")}catch(V){B.success=!1,B.message=V.message,r.sendResponse(B)}}else d&&d.onDidSendMessage&&d.onDidSendMessage(v),v=(0,p.$pF)(v,!0),o.k.$acceptDAMessage(a,v)}),r.onError(v=>{d&&d.onError&&d.onError(v),this.k.$acceptDAError(a,v.name,v.message,v.stack)}),r.onExit(v=>{d&&d.onExit&&d.onExit(v??void 0,void 0),this.k.$acceptDAExit(a,v??void 0,void 0)}),d&&d.onWillStartSession&&d.onWillStartSession(),r.startSession()))})}$sendDAMessage(a,s){s=(0,p.$oF)(s,!1);const o=this.C.get(a);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(s),this.B.get(a)?.sendMessage(s)}$stopDASession(a){const s=this.C.get(a);this.C.delete(a),s&&s.onWillStopSession&&s.onWillStopSession();const o=this.B.get(a);return this.B.delete(a),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const s=[],o=[],y=[];if(a.added)for(const m of a.added){const I=m.id;if(I&&!this.w.has(I)){let E;if(m.type==="function")E=new P.$XK(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")E=new P.$YK(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const r=C.URI.revive(m.uri);E=new P.$WK(new P.$9J(r,new P.$XJ(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,P.$UK)(E,I),this.w.set(I,E),s.push(E)}}if(a.removed)for(const m of a.removed){const I=this.w.get(m);I&&(this.w.delete(m),o.push(I))}if(a.changed){for(const m of a.changed)if(m.id){const I=this.w.get(m.id);if(I){if(I instanceof P.$XK&&m.type==="function"){const E=I;E.enabled=m.enabled,E.condition=m.condition,E.hitCondition=m.hitCondition,E.logMessage=m.logMessage,E.functionName=m.functionName}else if(I instanceof P.$WK&&m.type==="source"){const E=I;E.enabled=m.enabled,E.condition=m.condition,E.hitCondition=m.hitCondition,E.logMessage=m.logMessage,E.location=new P.$9J(C.URI.revive(m.uri),new P.$XJ(m.line,m.character))}y.push(I)}}}this.U(s,o,y)}async $acceptStackFrameFocus(a){let s;const o=a.sessionId?await this.V(a.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");a.kind==="thread"?s=new P.$5K(o,a.threadId):s=new P.$4K(o,a.threadId,a.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(a,s,o){return(0,w.$yg)(async()=>{const y=this.P(a);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.W(s);return y.provideDebugConfigurations(m,o)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(a,s,o,y){return(0,w.$yg)(async()=>{const m=this.P(a);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(s);return m.resolveDebugConfiguration(I,o,y)})}$resolveDebugConfigurationWithSubstitutedVariables(a,s,o,y){return(0,w.$yg)(async()=>{const m=this.P(a);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(s);return m.resolveDebugConfigurationWithSubstitutedVariables(I,o,y)})}async $provideDebugAdapter(a,s){const o=this.O(a);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.V(s);return this.S(o,y).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.M(m)})}async $acceptDebugSessionStarted(a){const s=await this.V(a);this.m.fire(s)}async $acceptDebugSessionTerminated(a){const s=await this.V(a);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,s){(await this.V(a))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(a,s){const y={session:await this.V(a),event:s.event,body:s.body};this.u.fire(y)}M(a){if(a instanceof P.$ZK)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof P.$1K)return{type:"server",port:a.port,host:a.host};if(a instanceof P.$2K)return{type:"pipeServer",path:a.path};if(a instanceof P.$3K)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}N(a){const s=this.h.filter(o=>o.type===a);if(s.length>0)return s[0].factory}O(a){const s=this.h.filter(o=>o.handle===a);if(s.length>0)return s[0].factory}P(a){const s=this.f.filter(o=>o.handle===a);if(s.length>0)return s[0].provider}Q(a,s){if(a.contributes){const o=a.contributes.debuggers;if(o&&o.length>0){for(const y of o)if(y.label&&y.type&&y.type===s)return!0}}return!1}R(a){const o=a.configuration.type,y=this.j.filter(m=>m.type===o||m.type==="*").map(m=>(0,w.$yg)(()=>m.factory.createDebugAdapterTracker(a)).then(I=>I,I=>null));return Promise.race([Promise.all(y).then(m=>{const I=m.filter(E=>!!E);if(I.length>0)return new g(I)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async S(a,s){const o=s.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new P.$1K(o));if(a){const m=await this.F.getExtensionRegistry();return(0,w.$yg)(()=>a.createDebugAdapterDescriptor(s,this.T(s,m))).then(I=>{if(I)return I})}const y=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,y))}T(a,s){}U(a,s,o){(a.length>0||s.length>0||o.length>0)&&this.y.fire(Object.freeze({added:a,removed:s,changed:o}))}async V(a){if(a)if(typeof a=="string"){const s=this.l.get(a);if(s)return s}else{let s=this.l.get(a.id);if(!s){const o=await this.W(a.folderUri),y=a.parent?this.l.get(a.parent):void 0;s=new i(this.k,a.id,a.type,a.name,o,a.configuration,y),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(a){if(a){const s=C.URI.revive(a);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$9bc=t,e.$9bc=t=Ke([Ve(0,f.$WL),Ve(1,D.$2ac),Ve(2,S.$xbc),Ve(3,$.$5ac),Ve(4,l.$4bc),Ve(5,h.$6bc)],t);class i{constructor(a,s,o,y,m,I,E){this.d=a,this.f=s,this.g=o,this.h=y,this.i=m,this.j=I,this.k=E}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,s){return this.d.$customDebugAdapterRequest(this.f,a,s)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.$0bc=i;class c{constructor(a){this.value=Object.freeze({append(s){a.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$$bc=c;class g{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(s=>s.onError?s.onError(a):void 0)}onExit(a,s){this.d.forEach(o=>o.onExit?o.onExit(a,s):void 0)}}class k extends u.$scb{constructor(a){super(),this.h=a,a.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let b=class extends t{constructor(a,s,o,y,m,I){super(a,s,o,y,m,I)}};e.$_bc=b,e.$_bc=b=Ke([Ve(0,f.$WL),Ve(1,D.$2ac),Ve(2,S.$xbc),Ve(3,$.$5ac),Ve(4,l.$4bc),Ve(5,h.$6bc)],b)}),define(Ae[270],Re([1,0,9,87,2,3,261,14,70,71,27,173,17,55,35,57]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=void 0;class t{static async installEarlyHandler(g){Error.stackTraceLimit=100;const k=g.get(l.$4i),n=g.get(u.$WL).getProxy(L.$UJ.MainThreadErrors);w.setUnexpectedErrorHandler(a=>{k.error(a);const s=w.$1(a);n.$onUnexpectedError(s)})}static async installFullHandler(g){const k=g.get(l.$4i),b=g.get(u.$WL),n=g.get($.$xbc),a=g.get(h.$eM),s=b.getProxy(L.$UJ.MainThreadExtensionService),o=b.getProxy(L.$UJ.MainThreadErrors),y=await n.getExtensionPathIndex(),m=new WeakMap;function I(d,v){if(m.has(d))return m.get(d).stack;let R="",B,V;for(const W of v)R+=`
	at ${W.toString()}`,V=W.getFileName(),!B&&V&&(B=y.findSubstr(C.URI.file(V)));const j=`${d.name||"Error"}: ${d.message||""}${R}`;return m.set(d,{extensionIdentifier:B?.identifier,stack:j}),j}const E=Symbol("prepareStackTrace wrapped");let r=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return r},set(d){if(d===I||!d||d[E]){r=d||I;return}r=function(v,R){return I(v,R),d.call(Error,v,R)},Object.assign(r,{[E]:!0})}}),w.setUnexpectedErrorHandler(d=>{k.error(d);const v=w.$1(d),R=m.get(d);if(!R?.extensionIdentifier){o.$onUnexpectedError(v);return}s.$onExtensionRuntimeError(R.extensionIdentifier,v);const B=a.onExtensionError(R.extensionIdentifier,d);k.trace("forwarded error to extension?",B,R)})}}e.$Wcc=t;class i{constructor(g,k,b,n,a){this.a=b,this.b=new A.$o3b(g,null,n),k=i.e(k,this.b);const s=new f.$yh(...(0,S.$lr)());s.set(P.$aM,{_serviceBrand:void 0,...k,messagePorts:a}),s.set(u.$WL,new u.$XL(this.b)),s.set(p.$Yac,new p.$Zac(n)),s.set($.$vbc,b);const o=new D.$4p(s,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(y=>y.get(l.$4i)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",k),this.c=o.invokeFunction(y=>y.get($.$xbc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(g){const k=this.b.getProxy(L.$UJ.MainThreadExtensionService);return C.URI.revive(await k.$asBrowserUri(g))}terminate(g){this.c.terminate(g)}static e(g,k){g.allExtensions.forEach(n=>{n.extensionLocation=C.URI.revive(k.transformIncomingURIs(n.extensionLocation))}),g.environment.appRoot=C.URI.revive(k.transformIncomingURIs(g.environment.appRoot));const b=g.environment.extensionDevelopmentLocationURI;return b&&(g.environment.extensionDevelopmentLocationURI=b.map(n=>C.URI.revive(k.transformIncomingURIs(n)))),g.environment.extensionTestsLocationURI=C.URI.revive(k.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=C.URI.revive(k.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=C.URI.revive(k.transformIncomingURIs(g.environment.workspaceStorageHome)),g.environment.extensionTelemetryLogResource=C.URI.revive(k.transformIncomingURIs(g.environment.extensionTelemetryLogResource)),g.nlsBaseUrl=C.URI.revive(k.transformIncomingURIs(g.nlsBaseUrl)),g.logsLocation=C.URI.revive(k.transformIncomingURIs(g.logsLocation)),g.workspace=k.transformIncomingURIs(g.workspace),g}}e.$Xcc=i}),define(Ae[271],Re([1,0,18,13,21,41,12,19,23,2,47]),function(be,e,w,F,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=e.$ccc=e.$bcc=void 0;class D{constructor(c,g,k,b){this.d=c,this.e=g,this.f=k,this.g=b,this.a=null,this.b=!1,this.c=0}search(c,g){const k=this.d.folderQueries||[],b=new C.$od(g);return new Promise((n,a)=>{this.a=new p(c);let s=!1;const o=(y,m)=>{if(!s&&!this.b){const I=this.h(y);h(y)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,s=!0,b.cancel(),y=this.j(y,this.d.maxResults-this.c));const E=this.h(y);this.c+=E,(E>0||!h(y))&&this.a.add(y,m)}};Promise.all(k.map((y,m)=>this.k(y,I=>o(I,m),b.token))).then(y=>{b.dispose(),this.a.flush();const m=y.some(I=>!!I&&!!I.limitHit);n({limitHit:this.b||m,messages:(0,w.$Ob)(y.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},y=>{b.dispose();const m=(0,L.$li)(y);a(new Error(m))})})}h(c){return h(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,g){const k=Array.isArray(c.ranges)?c.ranges:[c.ranges],b=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:k.slice(0,g),preview:{matches:b.slice(0,g),text:c.preview.text},uri:c.uri}}async k(c,g,k){const b=new P.$zI(this.d,c),n=[],a={report:y=>{if(!this.l(y))return;const m=c.folder.scheme===A.Schemas.file?(0,P.$AI)(()=>this.f.readdir(S.$gg(y.uri))):void 0,I=S.$jg(c.folder,y.uri);if(I){const E=b.includedInQuery(I,l.$_d(I),m);(0,F.$sg)(E)?n.push(E.then(r=>{r&&g(y)})):E&&g(y)}}},s=this.n(c),o=await this.e.provideTextSearchResults(u(this.d.contentPattern),s,a,k);return n.length&&await Promise.all(n),o}l(c){if(h(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const g=(0,P.$yI)(this.d.includePattern,c.includePattern),k=(0,P.$yI)(this.d.excludePattern,c.excludePattern),b={folder:f.URI.from(c.folder),excludes:k,includes:g,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return b.usePCRE2=this.d.usePCRE2,b}}e.$bcc=D;function u(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class p{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new t(512,g=>this.g(g))}add(c,g){this.d&&(this.b!==g||!S.$ag(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=g,this.d={resource:c.uri,results:[]}),this.d.results.push($(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$ccc=p;function $(i){return h(i)?{preview:{matches:(0,w.$Yb)(i.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:i.preview.text},ranges:(0,w.$Yb)(i.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function h(i){return!!i.preview}e.$dcc=h;class t{static{this.a=4e3}static{this.b=50}constructor(c,g){this.g=c,this.h=g,this.c=0,this.d=[],this.e=0}addItem(c,g){c&&this.j(c,g)}addItems(c,g){c&&this.k(c,g)}j(c,g){this.d.push(c),this.e+=g,this.l()}k(c,g){this.d=this.d.concat(c),this.e+=g,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$ecc=t}),define(Ae[115],Re([1,0,6,3,4,266,17,55,14,2,271]),function(be,e,w,F,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=e.$gcc=e.$fcc=void 0,e.$fcc=(0,C.$Ah)("IExtHostSearch");let D=class{constructor(h,t,i){this.k=h,this.l=t,this.n=i,this.c=this.k.getProxy(F.$UJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$acc}o(h){return this.l.transformOutgoingScheme(h)}registerTextSearchProvider(h,t){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(h)),(0,w.$hc)(()=>{this.g.delete(h),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(h,t){if(this.i.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.i.add(h);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(h)),(0,w.$hc)(()=>{this.i.delete(h),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(h,t,i,c){const g=u(i),k=this.h.get(h);if(k)return this.j.fileSearch(g,k,b=>{this.c.$handleFileMatch(h,t,b.map(n=>n.resource))},c);throw new Error("unknown provider: "+h)}$clearCache(h){return this.j.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,t,i,c){const g=this.e.get(h);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const k=u(i);return this.q(k,g).search(n=>this.c.$handleTextMatch(h,t,n),c)}$enableExtensionHostSearch(){}q(h,t){return new P.$bcc(h,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$gcc=D,e.$gcc=D=Ke([Ve(0,A.$WL),Ve(1,l.$Yac),Ve(2,S.$4i)],D);function u($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(p),extraFileResources:$.extraFileResources&&$.extraFileResources.map(h=>f.URI.revive(h))}}e.$hcc=u;function p($){return{...$,folder:f.URI.revive($.folder)}}}),define(Ae[272],Re([1,0,21,9,5,29,2,136,283,125,134,38,3,79,225,224,31,226,34,228,229,230,204,231,59,35,233,234,239,240,242,110,208,248,249,251,84,62,253,211,8,7,52,256,63,109,33,20,199,238,51,108,112,114,115,14,55,17,27,243,197,86,80,218,254,85,61,259,257,258,219,39,252,255,83,60,57,244,111,245,12,95,207,190,236,6,26,195,81,186,246,247,220,235,206,237,82,250,221,222,223,217,232]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t,i,c,g,k,b,n,a,s,o,y,m,I,E,r,d,v,R,B,V,j,W,O,z,ee,X,Ee,ke,Pe,Z,ue,ye,ce,$e,ie,N,q,le,we,ve,me,De,ne,he,se,oe,fe,Ie,M,K,G,Y,J,x,ae,Le,Ue,Ye,He,et,Ze,_e,it,tt,Ne,st,_,Q,pe,je,ze,Qe,nt,gt,vt,Mt,Qt,Vt,wt,Tt,Ot,Jt,Pt,At,zt,jt,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=void 0;function Bt(at){const ut=at.get(ne.$aM),Ht=at.get(Le.$Oac),Ct=at.get(G.$hbc),kt=at.get(o.$xbc),ht=at.get(ue.$2ac),St=at.get(Ze.$eM),Lt=at.get(c.$5ac),Et=at.get(me.$Yac),qe=at.get(De.$WL),Nt=at.get(j.$dbc),Ce=at.get(K.$ibc),Fe=at.get(ve.$5i),ge=at.get(ve.$4i),H=at.get(oe.$esb),Me=at.get(fe.$Rac),Be=at.get(Z.$Vbc),Ge=at.get(He.$pbc),We=at.get(et.$4bc),xe=at.get(Ot.$tbc);qe.set(u.$VJ.ExtHostFileSystemInfo,Ht),qe.set(u.$VJ.ExtHostLogLevelServiceShape,Fe),qe.set(u.$VJ.ExtHostWorkspace,ht),qe.set(u.$VJ.ExtHostConfiguration,Lt),qe.set(u.$VJ.ExtHostExtensionService,kt),qe.set(u.$VJ.ExtHostStorage,Nt),qe.set(u.$VJ.ExtHostTunnelService,H),qe.set(u.$VJ.ExtHostWindow,Be),qe.set(u.$VJ.ExtHostSecretState,Ge),qe.set(u.$VJ.ExtHostTelemetry,St),qe.set(u.$VJ.ExtHostEditorTabs,We),qe.set(u.$VJ.ExtHostManagedSockets,xe);const pt=qe.set(u.$VJ.ExtHostDecorations,at.get(N.$Zbc)),bt=qe.set(u.$VJ.ExtHostDocumentsAndEditors,at.get(s.$8L)),dt=qe.set(u.$VJ.ExtHostCommands,at.get(t.$gM)),ft=qe.set(u.$VJ.ExtHostTerminalService,at.get(W.$kbc)),mt=qe.set(u.$VJ.ExtHostDebugService,at.get(le.$8bc)),gi=qe.set(u.$VJ.ExtHostSearch,at.get(we.$fcc)),Kt=qe.set(u.$VJ.ExtHostTask,at.get(q.$3bc)),Ei=qe.set(u.$VJ.ExtHostOutputService,at.get(d.$Fbc)),Wt=qe.set(u.$VJ.ExtHostLocalization,at.get(nt.$sbc)),mi=qe.set(u.$VJ.ExtHostUrls,new ke.$Obc(qe)),It=qe.set(u.$VJ.ExtHostDocuments,new a.$Mac(qe,bt)),ki=qe.set(u.$VJ.ExtHostDocumentContentProviders,new b.$7ac(qe,bt,ge)),Vi=qe.set(u.$VJ.ExtHostDocumentSaveParticipant,new n.$8ac(ge,It,qe.getProxy(u.$UJ.MainThreadBulkEdits))),Dt=qe.set(u.$VJ.ExtHostNotebook,new he.$lcc(qe,dt,bt,It,Ct)),ti=qe.set(u.$VJ.ExtHostNotebookDocuments,new Q.$Dcc(Dt)),$i=qe.set(u.$VJ.ExtHostNotebookEditors,new _.$Ccc(ge,Dt)),si=qe.set(u.$VJ.ExtHostNotebookKernels,new _e.$zcc(qe,ut,Dt,dt,ge)),Di=qe.set(u.$VJ.ExtHostNotebookRenderers,new tt.$Bcc(qe,Dt)),Si=qe.set(u.$VJ.ExtHostNotebookDocumentSaveParticipant,new wt.$Jcc(ge,Dt,qe.getProxy(u.$UJ.MainThreadBulkEdits))),Rt=qe.set(u.$VJ.ExtHostEditors,new O.$Mbc(qe,bt)),pi=qe.set(u.$VJ.ExtHostTreeViews,new z.$Nbc(qe.getProxy(u.$UJ.MainThreadTreeViews),dt,ge)),Ii=qe.set(u.$VJ.ExtHostEditorInsets,new ce.$Wbc(qe.getProxy(u.$UJ.MainThreadEditorInsets),Rt,ut.remote)),oi=qe.set(u.$VJ.ExtHostDiagnostics,new g.$Qac(qe,ge,Ht,bt)),ai=qe.set(u.$VJ.ExtHostLanguages,new E.$Cbc(qe,It,dt.converter,Et)),ct=qe.set(u.$VJ.ExtHostLanguageFeatures,new I.$Uac(qe,Et,It,dt,oi,ge,Me,St)),qi=qe.set(u.$VJ.ExtHostFileSystem,new y.$Abc(qe,ct)),Xt=qe.set(u.$VJ.ExtHostFileSystemEventService,new m.$Bbc(qe,ge,bt)),ii=qe.set(u.$VJ.ExtHostQuickOpen,(0,R.$Hbc)(qe,ht,dt)),bi=qe.set(u.$VJ.ExtHostSCM,new B.$Jbc(qe,dt,It,ge)),Ci=qe.set(u.$VJ.ExtHostQuickDiff,new Mt.$Gcc(qe,Et)),Ki=qe.set(u.$VJ.ExtHostShare,new Jt.$Lcc(qe,Et)),Pi=qe.set(u.$VJ.ExtHostComments,(0,i.$Xac)(qe,dt,It)),vi=qe.set(u.$VJ.ExtHostProgress,new v.$Gbc(qe.getProxy(u.$UJ.MainThreadProgress))),Ji=qe.set(u.$VJ.ExtHosLabelService,new $e.$Xbc(qe)),Ai=qe.set(u.$VJ.ExtHostTheming,new se.$mcc(qe)),ci=qe.set(u.$VJ.ExtHostAuthentication,new Ie.$ncc(qe)),Hi=qe.set(u.$VJ.ExtHostTimeline,new M.$pcc(qe,dt)),wi=qe.set(u.$VJ.ExtHostWebviews,new Pe.$Rbc(qe,ut.remote,ht,ge,Me)),Ri=qe.set(u.$VJ.ExtHostWebviewPanels,new x.$rcc(qe,wi,ht)),cn=qe.set(u.$VJ.ExtHostCustomEditors,new J.$scc(qe,It,Ce,wi,Ri)),Fi=qe.set(u.$VJ.ExtHostWebviewViews,new Y.$qcc(qe,wi)),ni=qe.set(u.$VJ.ExtHostTesting,new Ue.$ucc(qe,dt,bt)),un=qe.set(u.$VJ.ExtHostUriOpeners,new Ye.$ycc(qe)),ln=qe.set(u.$VJ.ExtHostProfileContentHandlers,new vt.$Fcc(qe));qe.set(u.$VJ.ExtHostInteractive,new pe.$Ecc(qe,Dt,bt,dt,ge));const Gi=qe.set(u.$VJ.ExtHostInlineChat,new Vt.$Icc(qe,dt,It,ge)),fi=qe.set(u.$VJ.ExtHostChatProvider,new Pt.$Mcc(qe,ge)),Yi=qe.set(u.$VJ.ExtHostChatSlashCommands,new At.$Ncc(qe,fi,ge)),Qi=qe.set(u.$VJ.ExtHostChatVariables,new zt.$Occ(qe)),ui=qe.set(u.$VJ.ExtHostChat,new Qt.$Hcc(qe,ge)),Xi=qe.set(u.$VJ.ExtHostAiRelatedInformation,new jt.$Pcc(qe)),Mi=qe.set(u.$VJ.ExtHostAiEmbeddingVector,new qt.$Qcc(qe)),Zi=qe.set(u.$VJ.ExtHostIssueReporter,new Tt.$Kcc(qe)),Zt=qe.set(u.$VJ.ExtHostStatusBar,new V.$Lbc(qe,dt.converter)),yi=Object.values(u.$VJ);qe.assertRegistered(yi);const hn=new ae.$tcc(qe,bt),Gt=new h.$Wac(qe),li=new r.$Dbc(qe,ge),Ti=new k.$6ac(qe);return $.$Vac.register(dt),function(Oe,_t,Li){const $t=function(){let te=!Oe.isUnderDevelopment;function de(){te||(ge.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(rt){if(Array.isArray(rt))rt.forEach(Te);else if(typeof rt=="string")de();else{const yt=rt;typeof yt.scheme>"u"&&de(),typeof yt.exclusive=="boolean"&&(0,ze.$OF)(Oe,"documentFiltersExclusive")}return rt}}(),_i={getSession(te,de,Te){return ci.getSession(Oe,te,de,Te)},getSessions(te,de){return(0,ze.$OF)(Oe,"authGetSessions"),ci.getSessions(Oe,te,de)},async hasSession(te,de){return(0,ze.$OF)(Oe,"authSession"),!!await ci.getSession(Oe,te,de,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(te,de,Te,rt){return ci.registerAuthenticationProvider(te,de,Te,rt)}},xi={registerCommand(te,de,Te){return dt.registerCommand(!0,te,de,Te,void 0,Oe)},registerTextEditorCommand(te,de,Te){return dt.registerCommand(!0,te,(...rt)=>{const yt=Rt.getActiveTextEditor();if(!yt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}return yt.edit(Ft=>{de.apply(Te,[yt,Ft,...rt])}).then(Ft=>{Ft||ge.warn("Edits from command "+te+" were not applied.")},Ft=>{ge.warn("An error occurred while running command "+te,Ft)})},void 0,void 0,Oe)},registerDiffInformationCommand:(te,de,Te)=>((0,ze.$OF)(Oe,"diffCommand"),dt.registerCommand(!0,te,async(...rt)=>{const yt=bt.activeEditor(!0);if(!yt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ft=await Rt.getDiffInformation(yt.id);de.apply(Te,[Ft,...rt])},void 0,void 0,Oe)),executeCommand(te,...de){return dt.executeCommand(te,...de)},getCommands(te=!1){return dt.getCommands(te)}},en={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return ft.getDefaultShell(!1)},get onDidChangeShell(){return ft.onDidChangeShell},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return St.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.$OF)(Oe,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.$OF)(Oe,"telemetry"),St.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ze.$dM)(ut.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,de){return Ze.$cM.validateSender(te),St.instantiateLogger(Oe,te,de)},openExternal(te,de){return Be.openUri(te,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ut.environment.appUriScheme)return mi.createAppUri(te);try{return await Be.asExternalUri(te,{allowTunneling:!!ut.remote.authority})}catch(de){if((0,st.$ET)(te,Ne.Schemas.http)||(0,st.$ET)(te,Ne.Schemas.https))return te;throw de}},get remoteName(){return(0,ie.$Ok)(ut.remote.authority)},get remoteAuthority(){return(0,ze.$OF)(Oe,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind},get logLevel(){return ge.getLevel()},get onDidChangeLogLevel(){return ge.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,ze.$OF)(Oe,"handleIssueUri"),Zi.registerIssueUriRequestHandler(Oe,te)},get appQuality(){return(0,ze.$OF)(Oe,"resolvers"),ut.quality},get appCommit(){return(0,ze.$OF)(Oe,"resolvers"),ut.commit}};ut.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(te,de,Te){return ni.createTestController(Oe,te,de,Te)},createTestObserver(){return(0,ze.$OF)(Oe,"testObserver"),ni.createTestObserver()},runTests(te){return(0,ze.$OF)(Oe,"testObserver"),ni.runTests(te)},get onDidChangeTestResults(){return(0,ze.$OF)(Oe,"testObserver"),ni.onResultsChanged},get testResults(){return(0,ze.$OF)(Oe,"testObserver"),ni.results}},hi=ut.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,tn={getExtension(te,de){(0,ze.$NF)(Oe,"extensionsAny")||(de=!1);const Te=_t.mine.getExtensionDescription(te);if(Te)return new o.$ybc(kt,Oe.identifier,Te,hi,!1);if(de){const rt=_t.all.getExtensionDescription(te);if(rt)return new o.$ybc(kt,Oe.identifier,rt,hi,!0)}},get all(){const te=[];for(const de of _t.mine.getAllExtensionDescriptions())te.push(new o.$ybc(kt,Oe.identifier,de,hi,!1));return te},get allAcrossExtensionHosts(){(0,ze.$OF)(Oe,"extensionsAny");const te=new ye.$Vl(_t.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),de=[];for(const Te of _t.all.getAllExtensionDescriptions()){const rt=!te.has(Te.identifier);de.push(new o.$ybc(kt,Oe.identifier,Te,hi,rt))}return de},get onDidChange(){return(0,ze.$NF)(Oe,"extensionsAny")?C.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},nn={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Oe.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(te,de){return ai.changeLanguage(te.uri,de)},match(te,de){const Te=It.getDocumentData(de.uri)?.notebook;return(0,P.$aF)(ee.LanguageSelector.from(te),de.uri,de.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(te,de,Te){return ct.registerCodeActionProvider(Oe,$t(te),de,Te)},registerDocumentPasteEditProvider(te,de,Te){return(0,ze.$OF)(Oe,"documentPaste"),ct.registerDocumentPasteEditProvider(Oe,$t(te),de,Te)},registerCodeLensProvider(te,de){return ct.registerCodeLensProvider(Oe,$t(te),de)},registerDefinitionProvider(te,de){return ct.registerDefinitionProvider(Oe,$t(te),de)},registerDeclarationProvider(te,de){return ct.registerDeclarationProvider(Oe,$t(te),de)},registerImplementationProvider(te,de){return ct.registerImplementationProvider(Oe,$t(te),de)},registerTypeDefinitionProvider(te,de){return ct.registerTypeDefinitionProvider(Oe,$t(te),de)},registerHoverProvider(te,de){return ct.registerHoverProvider(Oe,$t(te),de,Oe.identifier)},registerEvaluatableExpressionProvider(te,de){return ct.registerEvaluatableExpressionProvider(Oe,$t(te),de,Oe.identifier)},registerInlineValuesProvider(te,de){return ct.registerInlineValuesProvider(Oe,$t(te),de,Oe.identifier)},registerDocumentHighlightProvider(te,de){return ct.registerDocumentHighlightProvider(Oe,$t(te),de)},registerLinkedEditingRangeProvider(te,de){return ct.registerLinkedEditingRangeProvider(Oe,$t(te),de)},registerReferenceProvider(te,de){return ct.registerReferenceProvider(Oe,$t(te),de)},registerRenameProvider(te,de){return ct.registerRenameProvider(Oe,$t(te),de)},registerDocumentSymbolProvider(te,de,Te){return ct.registerDocumentSymbolProvider(Oe,$t(te),de,Te)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Oe,te)},registerDocumentFormattingEditProvider(te,de){return ct.registerDocumentFormattingEditProvider(Oe,$t(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return ct.registerDocumentRangeFormattingEditProvider(Oe,$t(te),de)},registerOnTypeFormattingEditProvider(te,de,Te,...rt){return ct.registerOnTypeFormattingEditProvider(Oe,$t(te),de,[Te].concat(rt))},registerDocumentSemanticTokensProvider(te,de,Te){return ct.registerDocumentSemanticTokensProvider(Oe,$t(te),de,Te)},registerDocumentRangeSemanticTokensProvider(te,de,Te){return ct.registerDocumentRangeSemanticTokensProvider(Oe,$t(te),de,Te)},registerSignatureHelpProvider(te,de,Te,...rt){return typeof Te=="object"?ct.registerSignatureHelpProvider(Oe,$t(te),de,Te):ct.registerSignatureHelpProvider(Oe,$t(te),de,typeof Te>"u"?[]:[Te,...rt])},registerCompletionItemProvider(te,de,...Te){return ct.registerCompletionItemProvider(Oe,$t(te),de,Te)},registerInlineCompletionItemProvider(te,de,Te){return de.handleDidShowCompletionItem&&(0,ze.$OF)(Oe,"inlineCompletionsAdditions"),de.handleDidPartiallyAcceptCompletionItem&&(0,ze.$OF)(Oe,"inlineCompletionsAdditions"),Te&&(0,ze.$OF)(Oe,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Oe,$t(te),de,Te)},registerDocumentLinkProvider(te,de){return ct.registerDocumentLinkProvider(Oe,$t(te),de)},registerColorProvider(te,de){return ct.registerColorProvider(Oe,$t(te),de)},registerFoldingRangeProvider(te,de){return ct.registerFoldingRangeProvider(Oe,$t(te),de)},registerSelectionRangeProvider(te,de){return ct.registerSelectionRangeProvider(Oe,te,de)},registerCallHierarchyProvider(te,de){return ct.registerCallHierarchyProvider(Oe,te,de)},registerTypeHierarchyProvider(te,de){return ct.registerTypeHierarchyProvider(Oe,te,de)},setLanguageConfiguration:(te,de)=>ct.setLanguageConfiguration(Oe,te,de),getTokenInformationAtPosition(te,de){return(0,ze.$OF)(Oe,"tokenInformation"),ai.tokenAtPosition(te,de)},registerInlayHintsProvider(te,de){return ct.registerInlayHintsProvider(Oe,te,de)},createLanguageStatusItem(te,de){return ai.createLanguageStatusItem(Oe,te,de)},registerDocumentDropEditProvider(te,de,Te){return ct.registerDocumentOnDropEditProvider(Oe,te,de,(0,ze.$NF)(Oe,"dropMetadata")?Te:void 0)}},rn={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(te,de,Te){const rt=await(A.URI.isUri(te)?Promise.resolve(sn.openTextDocument(te)):Promise.resolve(te));return Rt.showTextDocument(rt,de,Te)},createTextEditorDecorationType(te){return Rt.createTextEditorDecorationType(Oe,te)},onDidChangeActiveTextEditor(te,de,Te){return Rt.onDidChangeActiveTextEditor(te,de,Te)},onDidChangeVisibleTextEditors(te,de,Te){return Rt.onDidChangeVisibleTextEditors(te,de,Te)},onDidChangeTextEditorSelection(te,de,Te){return Rt.onDidChangeTextEditorSelection(te,de,Te)},onDidChangeTextEditorOptions(te,de,Te){return Rt.onDidChangeTextEditorOptions(te,de,Te)},onDidChangeTextEditorVisibleRanges(te,de,Te){return Rt.onDidChangeTextEditorVisibleRanges(te,de,Te)},onDidChangeTextEditorViewColumn(te,de,Te){return Rt.onDidChangeTextEditorViewColumn(te,de,Te)},onDidCloseTerminal(te,de,Te){return ft.onDidCloseTerminal(te,de,Te)},onDidOpenTerminal(te,de,Te){return ft.onDidOpenTerminal(te,de,Te)},onDidChangeActiveTerminal(te,de,Te){return ft.onDidChangeActiveTerminal(te,de,Te)},onDidChangeTerminalDimensions(te,de,Te){return(0,ze.$OF)(Oe,"terminalDimensions"),ft.onDidChangeTerminalDimensions(te,de,Te)},onDidChangeTerminalState(te,de,Te){return ft.onDidChangeTerminalState(te,de,Te)},onDidWriteTerminalData(te,de,Te){return(0,ze.$OF)(Oe,"terminalDataWriteEvent"),ft.onDidWriteTerminalData(te,de,Te)},onDidExecuteTerminalCommand(te,de,Te){return(0,ze.$OF)(Oe,"terminalExecuteCommandEvent"),ft.onDidExecuteTerminalCommand(te,de,Te)},get state(){return Be.getState(Oe)},onDidChangeWindowState(te,de,Te){return Be.onDidChangeWindowState(te,de,Te)},showInformationMessage(te,...de){return li.showMessage(Oe,L.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return li.showMessage(Oe,L.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return li.showMessage(Oe,L.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Te){return ii.showQuickPick(Oe,te,de,Te)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,de){return ii.showInput(te,de)},showOpenDialog(te){return Ti.showOpenDialog(Oe,te)},showSaveDialog(te){return Ti.showSaveDialog(te)},createStatusBarItem(te,de,Te){let rt,yt,Ft;return typeof te=="string"?(rt=te,yt=de,Ft=Te):(yt=te,Ft=de),Zt.createStatusBarEntry(Oe,rt,yt,Ft)},setStatusBarMessage(te,de){return Zt.setStatusBarMessage(te,de)},withScmProgress(te){return Me.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),vi.withProgress(Oe,{location:X.ProgressLocation.SourceControl},(de,Te)=>te({report(rt){}}))},withProgress(te,de){return vi.withProgress(Oe,te,de)},createOutputChannel(te,de){return Ei.createOutputChannel(te,de,Oe)},createWebviewPanel(te,de,Te,rt){return Ri.createWebviewPanel(Oe,te,de,Te,rt)},createWebviewTextEditorInset(te,de,Te,rt){return(0,ze.$OF)(Oe,"editorInsets"),Ii.createWebviewEditorInset(te,de,Te,rt,Oe)},createTerminal(te,de,Te){return typeof te=="object"?"pty"in te?ft.createExtensionTerminal(te):ft.createTerminalFromOptions(te):ft.createTerminal(te,de,Te)},registerTerminalLinkProvider(te){return ft.registerLinkProvider(te)},registerTerminalProfileProvider(te,de){return ft.registerProfileProvider(Oe,te,de)},registerTerminalQuickFixProvider(te,de){return(0,ze.$OF)(Oe,"terminalQuickFixProvider"),ft.registerTerminalQuickFixProvider(te,Oe.identifier.value,de)},registerTreeDataProvider(te,de){return pi.registerTreeDataProvider(te,de,Oe)},createTreeView(te,de){return pi.createTreeView(te,de,Oe)},registerWebviewPanelSerializer:(te,de)=>Ri.registerWebviewPanelSerializer(Oe,te,de),registerCustomEditorProvider:(te,de,Te={})=>cn.registerCustomEditorProvider(Oe,te,de,Te),registerFileDecorationProvider(te){return pt.registerFileDecorationProvider(te,Oe)},registerUriHandler(te){return mi.registerUriHandler(Oe,te)},createQuickPick(){return ii.createQuickPick(Oe)},createInputBox(){return ii.createInputBox(Oe)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(te,de,Te){return Ai.onDidChangeActiveColorTheme(te,de,Te)},registerWebviewViewProvider(te,de,Te){return Fi.registerWebviewViewProvider(Oe,te,de,Te?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Te){return Dt.onDidChangeActiveNotebookEditor(te,de,Te)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Te){return $i.onDidChangeNotebookEditorSelection(te,de,Te)},onDidChangeNotebookEditorVisibleRanges(te,de,Te){return $i.onDidChangeNotebookEditorVisibleRanges(te,de,Te)},showNotebookDocument(te,de){return Dt.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Te){return(0,ze.$OF)(Oe,"externalUriOpener"),un.registerExternalUriOpener(Oe.identifier,te,de,Te)},registerProfileContentHandler(te,de){return(0,ze.$OF)(Oe,"profileContentHandlers"),ln.registrProfileContentHandler(Oe,te,de)},registerQuickDiffProvider(te,de,Te,rt){return(0,ze.$OF)(Oe,"quickDiffProvider"),Ci.registerQuickDiffProvider($t(te),de,Te,rt)},get tabGroups(){return We.tabGroups},registerShareProvider(te,de){return(0,ze.$OF)(Oe,"shareProvider"),Ki.registerShareProvider($t(te),de)}},sn={get rootPath(){return Me.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(te){throw new F.$7("rootPath")},getWorkspaceFolder(te){return ht.getWorkspaceFolder(te)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(te){throw new F.$7("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(te){throw new F.$7("workspaceFile")},updateWorkspaceFolders:(te,de,...Te)=>ht.updateWorkspaceFolders(Oe,te,de||0,...Te),onDidChangeWorkspaceFolders:function(te,de,Te){return ht.onDidChangeWorkspace(te,de,Te)},asRelativePath:(te,de)=>ht.getRelativePath(te,de),findFiles:(te,de,Te,rt)=>ht.findFiles(te,de,Te,Oe.identifier,rt),findTextInFiles:(te,de,Te,rt)=>{(0,ze.$OF)(Oe,"findTextInFiles");let yt,Ft;return typeof de=="object"?(yt=de,Ft=Te):(yt={},Ft=de,rt=Te),ht.findTextInFiles(te,yt||{},Ft,Oe.identifier,rt)},save:te=>((0,ze.$OF)(Oe,"saveEditor"),ht.save(te)),saveAs:te=>((0,ze.$OF)(Oe,"saveEditor"),ht.saveAs(te)),saveAll:te=>ht.saveAll(te),applyEdit(te,de){return hn.applyWorkspaceEdit(te,Oe,de)},createFileSystemWatcher:(te,de,Te,rt)=>Xt.createFileSystemWatcher(ht,Oe,te,de,Te,rt),get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new F.$7("textDocuments")},openTextDocument(te){let de;const Te=te;if(typeof te=="string")de=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))de=Promise.resolve(te);else if(!Te||typeof Te=="object")de=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>It.ensureDocumentData(rt).then(yt=>yt.document))},onDidOpenTextDocument:(te,de,Te)=>It.onDidAddDocument(te,de,Te),onDidCloseTextDocument:(te,de,Te)=>It.onDidRemoveDocument(te,de,Te),onDidChangeTextDocument:(te,de,Te)=>It.onDidChangeDocument(te,de,Te),onDidSaveTextDocument:(te,de,Te)=>It.onDidSaveDocument(te,de,Te),onWillSaveTextDocument:(te,de,Te)=>Vi.getOnWillSaveTextDocumentEvent(Oe)(te,de,Te),get notebookDocuments(){return Dt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,de){let Te;if(A.URI.isUri(te))Te=te,await Dt.openNotebookDocument(te);else if(typeof te=="string")Te=A.URI.revive(await Dt.createNotebookDocument({viewType:te,content:de}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,de,Te){return ti.onDidSaveNotebookDocument(te,de,Te)},onDidChangeNotebookDocument(te,de,Te){return ti.onDidChangeNotebookDocument(te,de,Te)},onWillSaveNotebookDocument(te,de,Te){return Si.getOnWillSaveNotebookDocumentEvent(Oe)(te,de,Te)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(te,de,Te,rt){return Dt.registerNotebookSerializer(Oe,te,de,Te,(0,ze.$NF)(Oe,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,de,Te)=>Li.onDidChangeConfiguration(te,de,Te),getConfiguration(te,de){return de=arguments.length===1?void 0:de,Li.getConfiguration(te,de,Oe)},registerTextDocumentContentProvider(te,de){return ki.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(Me.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Oe,te,de)),registerFileSystemProvider(te,de,Te){return(0,je.$gc)(qi.registerFileSystemProvider(Oe,te,de,Te),Ct.addFileSystemProvider(te,de,Te))},get fs(){return Ct.value},registerFileSearchProvider:(te,de)=>((0,ze.$OF)(Oe,"fileSearchProvider"),gi.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,ze.$OF)(Oe,"textSearchProvider"),gi.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,ze.$OF)(Oe,"resolvers"),kt.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,ze.$OF)(Oe,"resolvers"),Ji.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,ze.$OF)(Oe,"resolvers"),kt.getRemoteExecServer(te)),onDidCreateFiles:(te,de,Te)=>Xt.onDidCreateFile(te,de,Te),onDidDeleteFiles:(te,de,Te)=>Xt.onDidDeleteFile(te,de,Te),onDidRenameFiles:(te,de,Te)=>Xt.onDidRenameFile(te,de,Te),onWillCreateFiles:(te,de,Te)=>Xt.getOnWillCreateFileEvent(Oe)(te,de,Te),onWillDeleteFiles:(te,de,Te)=>Xt.getOnWillDeleteFileEvent(Oe)(te,de,Te),onWillRenameFiles:(te,de,Te)=>Xt.getOnWillRenameFileEvent(Oe)(te,de,Te),openTunnel:te=>((0,ze.$OF)(Oe,"tunnels"),H.openTunnel(Oe,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,ze.$OF)(Oe,"tunnels"),H.getTunnels()},onDidChangeTunnels:(te,de,Te)=>((0,ze.$OF)(Oe,"tunnels"),H.onDidChangeTunnels(te,de,Te)),registerPortAttributesProvider:(te,de)=>((0,ze.$OF)(Oe,"portsAttributes"),H.registerPortsAttributesProvider(te,de)),registerTunnelProvider:(te,de)=>((0,ze.$OF)(Oe,"tunnelFactory"),H.registerTunnelProvider(te,de)),registerTimelineProvider:(te,de)=>((0,ze.$OF)(Oe,"timeline"),Hi.registerTimelineProvider(te,de,Oe.identifier,dt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:te=>((0,ze.$OF)(Oe,"workspaceTrust"),ht.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,de,Te)=>ht.onDidGrantWorkspaceTrust(te,de,Te),registerEditSessionIdentityProvider:(te,de)=>((0,ze.$OF)(Oe,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(te,de)),onWillCreateEditSessionIdentity:(te,de,Te)=>((0,ze.$OF)(Oe,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Oe)(te,de,Te)),registerCanonicalUriProvider:(te,de)=>((0,ze.$OF)(Oe,"canonicalUriProvider"),ht.registerCanonicalUriProvider(te,de)),getCanonicalUri:(te,de,Te)=>((0,ze.$OF)(Oe,"canonicalUriProvider"),ht.provideCanonicalUri(te,de,Te))},fn={get inputBox(){return Me.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(Oe)},createSourceControl(te,de,Te){return bi.createSourceControl(Oe,te,de,Te)}},on={createCommentController(te,de){return Pi.createCommentController(Oe,te,de)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(te,de,Te){return mt.onDidStartDebugSession(te,de,Te)},onDidTerminateDebugSession(te,de,Te){return mt.onDidTerminateDebugSession(te,de,Te)},onDidChangeActiveDebugSession(te,de,Te){return mt.onDidChangeActiveDebugSession(te,de,Te)},onDidReceiveDebugSessionCustomEvent(te,de,Te){return mt.onDidReceiveDebugSessionCustomEvent(te,de,Te)},onDidChangeBreakpoints(te,de,Te){return mt.onDidChangeBreakpoints(te,de,Te)},onDidChangeStackFrameFocus(te,de,Te){return(0,ze.$OF)(Oe,"debugFocus"),mt.onDidChangeStackFrameFocus(te,de,Te)},registerDebugConfigurationProvider(te,de,Te){return mt.registerDebugConfigurationProvider(te,de,Te||Qe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return mt.registerDebugAdapterDescriptorFactory(Oe,te,de)},registerDebugAdapterTrackerFactory(te,de){return mt.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Te){return!Te||typeof Te=="object"&&"configuration"in Te?mt.startDebugging(te,de,{parentSession:Te}):mt.startDebugging(te,de,Te||{})},stopDebugging(te){return mt.stopDebugging(te)},addBreakpoints(te){return mt.addBreakpoints(te)},removeBreakpoints(te){return mt.removeBreakpoints(te)},asDebugSourceUri(te,de){return mt.asDebugSourceUri(te,de)}},Oi={registerTaskProvider:(te,de)=>Kt.registerTaskProvider(Oe,te,de),fetchTasks:te=>Kt.fetchTasks(te),executeTask:te=>Kt.executeTask(Oe,te),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(te,de,Te)=>Kt.onDidStartTask(te,de,Te),onDidEndTask:(te,de,Te)=>Kt.onDidEndTask(te,de,Te),onDidStartTaskProcess:(te,de,Te)=>Kt.onDidStartTaskProcess(te,de,Te),onDidEndTaskProcess:(te,de,Te)=>Kt.onDidEndTaskProcess(te,de,Te)},zi={createNotebookController(te,de,Te,rt,yt){return si.createNotebookController(Oe,te,de,Te,rt,(0,ze.$NF)(Oe,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(te,de)=>Dt.registerNotebookCellStatusBarItemProvider(Oe,te,de),createRendererMessaging(te){return Di.createRendererMessaging(Oe,te)},createNotebookControllerDetectionTask(te){return(0,ze.$OF)(Oe,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Oe,te)},registerKernelSourceActionProvider(te,de){return(0,ze.$OF)(Oe,"notebookKernelSource"),si.registerKernelSourceActionProvider(Oe,te,de)},onDidChangeNotebookCellExecutionState(te,de,Te){return(0,ze.$OF)(Oe,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,de,Te)}},Ni={t(...te){if(typeof te[0]=="string"){const de=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return Wt.getMessage(Oe.identifier.value,{message:de,args:Te})}return Wt.getMessage(Oe.identifier.value,te[0])},get bundle(){return Wt.getBundle(Oe.identifier.value)},get uri(){return Wt.getBundleUri(Oe.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(te,de){return(0,ze.$OF)(Oe,"interactive"),Gi.registerProvider(Oe,te,de={label:de?.label??Oe.displayName??Oe.name})},registerInteractiveSessionProvider(te,de){return(0,ze.$OF)(Oe,"interactive"),ui.registerChatProvider(Oe,te,de)},addInteractiveRequest(te){return(0,ze.$OF)(Oe,"interactive"),ui.addChatRequest(te)},sendInteractiveRequestToProvider(te,de){return(0,ze.$OF)(Oe,"interactive"),ui.sendInteractiveRequestToProvider(te,de)},get onDidPerformUserAction(){return(0,ze.$OF)(Oe,"interactiveUserActions"),ui.onDidPerformUserAction},transferChatSession(te,de){return(0,ze.$OF)(Oe,"interactive"),ui.transferChatSession(te,de)}},Ui={getRelatedInformation(te,de){return(0,ze.$OF)(Oe,"aiRelatedInformation"),Xi.getRelatedInformation(Oe,te,de)},registerRelatedInformationProvider(te,de){return(0,ze.$OF)(Oe,"aiRelatedInformation"),Xi.registerRelatedInformationProvider(Oe,te,de)},registerEmbeddingVectorProvider(te,de){return(0,ze.$OF)(Oe,"aiRelatedInformation"),Mi.registerEmbeddingVectorProvider(Oe,te,de)}},ji={registerChatResponseProvider(te,de,Te){return(0,ze.$OF)(Oe,"chatProvider"),fi.registerProvider(Oe.identifier,te,de,Te)},registerSlashCommand(te,de,Te){return(0,ze.$OF)(Oe,"chatSlashCommands"),Yi.registerCommand(Oe.identifier,te,de,Te??{description:""})},requestChatAccess(te){return(0,ze.$OF)(Oe,"chatRequestAccess"),fi.requestChatResponseProvider(Oe.identifier,te)},registerVariable(te,de,Te){return(0,ze.$OF)(Oe,"chatVariables"),Qi.registerVariableResolver(Oe,te,de,Te)},registerMappedEditsProvider(te,de){return(0,ze.$OF)(Oe,"mappedEditsProvider"),ct.registerMappedEditsProvider(Oe,te,de)}};return{version:ut.version,ai:Ui,authentication:_i,commands:xi,comments:on,chat:ji,debug:an,env:en,extensions:tn,interactive:di,l10n:Ni,languages:nn,notebooks:zi,scm:fn,tasks:Oi,tests:dn,window:rn,workspace:sn,Breakpoint:X.$VK,TerminalOutputAnchor:X.TerminalOutputAnchor,ChatMessage:X.$LL,ChatMessageRole:X.ChatMessageRole,ChatVariableLevel:X.ChatVariableLevel,CallHierarchyIncomingCall:X.$iK,CallHierarchyItem:X.$hK,CallHierarchyOutgoingCall:X.$jK,CancellationError:F.$3,CancellationTokenSource:w.$od,CandidatePortSource:u.CandidatePortSource,CodeAction:X.$dK,CodeActionKind:X.$eK,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.$kK,Color:X.$xK,ColorInformation:X.$yK,ColorPresentation:X.$zK,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CompletionItem:X.$rK,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.$sK,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.$HK,DebugAdapterExecutable:X.$ZK,DebugAdapterInlineImplementation:X.$3K,DebugAdapterNamedPipeServer:X.$2K,DebugAdapterServer:X.$1K,DebugConfigurationProviderTriggerKind:Qe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.$$J,DiagnosticRelatedInformation:X.$0J,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.$WJ,DocumentHighlight:X.$aK,DocumentHighlightKind:X.DocumentHighlightKind,DocumentLink:X.$wK,DocumentSymbol:X.$cK,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.$6K,InlineValueText:X.$7K,InlineValueVariableLookup:X.$8K,InlineValueEvaluatableExpression:X.$9K,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:C.$ed,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.$gL,FileDecoration2:X.$gL,FileSystemError:X.$$K,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:X.$_K,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.$XK,InlineCompletionItem:X.$tK,InlineCompletionList:X.$uK,Hover:X.$_J,IndentAction:f.IndentAction,Location:X.$9J,MarkdownString:X.$lK,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:X.$mK,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.$XJ,ProcessExecution:X.$FK,ProgressLocation:X.ProgressLocation,QuickInputButtons:X.$fL,Range:X.$YJ,RelativePattern:X.$TK,Selection:X.$ZJ,SelectionRange:X.$gK,SemanticTokens:X.$cL,SemanticTokensBuilder:X.$bL,SemanticTokensEdit:X.$dL,SemanticTokensEdits:X.$eL,SemanticTokensLegend:X.$aL,ShellExecution:X.$GK,ShellQuoting:X.ShellQuoting,SignatureHelp:X.$oK,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.$nK,SnippetString:X.$8J,SourceBreakpoint:X.$WK,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.$bK,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.$IK,TaskGroup:X.$EK,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.$AK,TerminalQuickFixExecuteTerminalCommand:X.$CK,TerminalQuickFixOpener:X.$BK,TerminalLocation:X.TerminalLocation,TerminalProfile:X.$DK,TerminalExitReason:X.TerminalExitReason,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.$4J,SnippetTextEdit:X.$6J,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.$SK,ThemeIcon:X.$RK,TreeItem:X.$JK,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.$BL,UIKind:p.UIKind,Uri:A.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.$7J,DocumentDropEdit:X.$PK,DocumentPasteEdit:X.$QK,InlayHint:X.$qK,InlayHintLabelPart:X.$pK,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.$3J,ResolvedAuthority:X.$1J,ManagedResolvedAuthority:X.$2J,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.$qL,NotebookRange:X.$iL,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.$jL,NotebookData:X.$kL,NotebookRendererScript:X.$oL,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.$mL,NotebookCellOutputItem:X.$lL,NotebookCellStatusBarItem:X.$nL,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.$5J,NotebookKernelSourceAction:X.$pL,PortAttributes:X.$sL,LinkedEditingRanges:X.$rL,TestResultState:X.TestResultState,TestRunRequest:X.$tL,TestMessage:X.$uL,TestMessage2:X.$uL,TestTag:X.$vL,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:X.$OK,DataTransferItem:X.$KK,CoveredCount:X.$wL,FileCoverage:X.$xL,StatementCoverage:X.$yL,BranchCoverage:X.$zL,FunctionCoverage:X.$AL,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.$CL,TabInputTextDiff:X.$DL,TabInputTextMerge:X.$EL,TabInputCustom:X.$FL,TabInputNotebook:X.$HL,TabInputNotebookDiff:X.$IL,TabInputWebview:X.$GL,TabInputTerminal:X.$JL,TabInputInteractiveWindow:X.$KL,TelemetryTrustedValue:Ee.$$n,LogLevel:ve.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:X.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,StackFrameFocus:X.$4K,ThreadFocus:X.$5K,NotebookCodeActionKind:X.$fK,RelatedInformationType:X.RelatedInformationType}}}e.$Rcc=Bt}),define(Ae[273],Re([1,0,70,110,33,108,34,31,59,62,112,114,115,84,86,80,109,61,39,83,57,60,241,14,113,81,82]),function(be,e,w,F,C,L,A,l,S,f,P,D,u,p,$,h,t,i,c,g,k,b,n,a,s,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$kr)(o.$sbc,o.$rbc,1),(0,w.$kr)(a.$5i,n.$Scc,1),(0,w.$kr)(h.$Rac,h.$Sac,1),(0,w.$kr)(l.$gM,l.$fM,0),(0,w.$kr)(A.$5ac,A.$3ac,0),(0,w.$kr)(i.$hbc,i.$gbc,0),(0,w.$kr)(D.$8bc,D.$_bc,0),(0,w.$kr)(L.$Zbc,L.$Ybc,0),(0,w.$kr)(S.$8L,S.$7L,0),(0,w.$kr)(y.$tbc,y.$ubc,0),(0,w.$kr)(c.$Oac,c.$Nac,0),(0,w.$kr)(F.$Fbc,F.$Ebc,1),(0,w.$kr)(u.$fcc,u.$gcc,0),(0,w.$kr)(p.$dbc,p.$cbc,0),(0,w.$kr)(P.$3bc,P.$2bc,0),(0,w.$kr)(f.$kbc,f.$nbc,0),(0,w.$kr)($.$esb,$.$fsb,0),(0,w.$kr)(t.$Vbc,t.$Ubc,0),(0,w.$kr)(C.$2ac,C.$1ac,0),(0,w.$kr)(g.$pbc,g.$obc,0),(0,w.$kr)(k.$eM,k.$bM,0),(0,w.$kr)(b.$4bc,b.$5bc,0),(0,w.$kr)(s.$6bc,s.$7bc,0)}),define(Ae[274],Re([1,0,272,35,2,269,7,13,260]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=void 0;class f extends L.$Vcc{j(){}getModule(p,$){for(const h of this.b){const t=h(p);if(t){p=t;break}}if(this.a.has(p))return this.a.get(p).load(p,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends F.$wbc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(S.$1ec);const p=this.h.invokeFunction(w.$Rcc);this.r=this.h.createInstance(f,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,$,h){$=$.with({path:D($.path,".js")});const t=p?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=C.URI.revive(await this.C.$asBrowserUri($)),c=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const g=await c.text(),k=`${$.toString(!0)}#vscode-extension`,b=`${g}
//# sourceURL=${k}`;let n;try{n=new Function("module","exports","require",b)}catch(y){throw console.error(t?`Loading code for extension ${t} failed: ${y.message}`:`Loading code failed: ${y.message}`),console.error(`${$.toString(!0)}${typeof y.line=="number"?` line ${y.line}`:""}${typeof y.column=="number"?` column ${y.column}`:""}`),console.error(y),y}p&&await this.w.initializeLocalizedMessages(p);const a={},s={exports:a},o=y=>{const m=this.r.getModule(y,$);if(m===void 0)throw new Error(`Cannot load module '${y}'`);return m};try{return h.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(s,a,o),s.exports!==a?s.exports:a}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),h.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+p;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,l.$Gg)(10)}}e.$2ec=P;function D(u,p){return u.endsWith(p)?u:u+p}}),define(Ae[275],Re([1,0,69,70,14,35,188,85,274]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,F.$kr)(C.$4i,new w.$xh(A.$Ucc,[!0],!0)),(0,F.$kr)(L.$xbc,S.$2ec,0),(0,F.$kr)(l.$ibc,l.$jbc,0)}),define(Ae[284],Re([1,0,25,5,79,270,262,19,87,12,2,273,275]),function(be,e,w,F,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(n){return/^(file|vscode-remote):/i.test(n)}const $=fetch.bind(self);function h(n){self.fetch=async function(a,s){return a instanceof Request||p(String(a))&&(a=(await n(P.URI.parse(String(a)))).toString(!0)),$(a,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,s,o,y,m){(async()=>(p(s.toString())&&(s=(await n(P.URI.parse(s.toString()))).toString(!0)),super.open(a,s,o??!0,y,m)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(a,s){if(/^file:/i.test(a.toString()))a=f.$1f.uriToBrowserUri(P.URI.parse(a.toString())).toString(!0);else if(/^vscode-remote:/i.test(a.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const y=`(${function(r){function d(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const v=fetch.bind(self);self.fetch=function(B,V){return B instanceof Request?v(B,V):v(d(B),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,V,j,W,O){return super.open(B,d(V),j??!0,W,O)}};const R=importScripts.bind(self);self.importScripts=(...B)=>{R(...B.map(d))},R(r)}.toString()}('${a}'))`;s=s||{},s.name=s.name||l.$_d(a.toString());const m=new Blob([y],{type:"application/javascript"}),I=URL.createObjectURL(m);return new n(I,s)}}else self.Worker=class extends A.$3ec{constructor(n,a){super(u,n,{name:l.$_d(n.toString()),...a})}};const t=new class{constructor(){this.pid=void 0}exit(n){D()}};class i{constructor(){const a=new MessageChannel,s=new F.$ed;let o=!1;u(a.port2,[a.port2]),a.port1.onmessage=y=>{const{data:m}=y;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const I=w.$Ed.wrap(new Uint8Array(m,0,m.byteLength));if((0,C.$4l)(I,2)){o=!0,g("received terminate message from renderer");return}s.fire(I)},this.protocol={onMessage:s.event,send:y=>{if(!o){const m=y.buffer.buffer.slice(y.buffer.byteOffset,y.buffer.byteOffset+y.buffer.byteLength);a.port1.postMessage(m,[m])}}}}}function c(n){return new Promise(a=>{const s=n.onMessage(o=>{s.dispose();const y=JSON.parse(o.toString());n.send((0,C.$3l)(0)),a({protocol:n,initData:y})});n.send((0,C.$3l)(1))})}let g=n=>D();function k(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function b(){S.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(a){k(a)&&c(n.protocol).then(s=>{S.mark("code/extHost/didWaitForInitData");const o=new L.$Xcc(s.protocol,s.initData,t,null,a.data);h(y=>o.asBrowserUri(y)),g=y=>o.terminate(y)})}}}e.create=b})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7b0ae6cf9d5a0c891ad1adc4da9c36c4dc453d4d/core/vs/workbench/api/worker/extensionHostWorker.js.map
