/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],V=function(F){for(var e=[],A=0,T=F.length;A<T;A++)e[A]=q[F[A]];return e};define(q[21],V([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class A{static get(){const v=new Map,k=new Map,r=new Map,l=new Map;function t(u,n){u.has(n.detail)||u.set(n.detail,-n.timestamp)}function a(u,n){const i=u.get(n.detail);i&&(i>=0||u.set(n.detail,i+n.timestamp))}let h=[];typeof F=="function"&&typeof F.getStats=="function"&&(h=F.getStats().slice(0).sort((u,n)=>u.timestamp-n.timestamp));for(const u of h)switch(u.type){case 10:t(v,u);break;case 11:case 12:a(v,u);break;case 21:t(k,u);break;case 22:a(k,u);break;case 33:t(r,u);break;case 34:a(r,u);break;case 31:t(l,u);break;case 32:a(l,u);break}let c=0;r.forEach(u=>c+=u);function g(u){const n=[];return u.forEach((i,s)=>n.push([s,i])),n}return{amdLoad:g(v),amdInvoke:g(k),nodeRequire:g(r),nodeEval:g(l),nodeRequireTotal:c}}static toMarkdownTable(v,k){let r="";const l=[];return v.forEach((t,a)=>{l[a]=t.length}),k.forEach(t=>{t.forEach((a,h)=>{typeof a>"u"&&(a=t[h]="-");const c=a.toString().length;l[h]=Math.max(c,l[h])})}),v.forEach((t,a)=>{r+=`| ${t+" ".repeat(l[a]-t.toString().length)} `}),r+=`|
`,v.forEach((t,a)=>{r+=`| ${"-".repeat(l[a])} `}),r+=`|
`,k.forEach(t=>{t.forEach((a,h)=>{typeof a<"u"&&(r+=`| ${a+" ".repeat(l[h]-a.toString().length)} `)}),r+=`|
`}),r}}e.$S=A}),define(q[4],V([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uc=e.$Tc=e.$Sc=void 0;let A;function T(i){A=i}e.$Sc=T;function v(){return A}e.$Tc=v;class k{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([l(u("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[l(" "),a(h(s.oldValue,70),{color:"red",strikeThrough:!0}),l(" "),a(h(s.newValue,60),{color:"green"})]:[l(" (unchanged)")]:[l(" "),a(h(s.newValue,60),{color:"green"}),l(" (initial)")]}handleObservableChanged(s,d){console.log(...this.b([t("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c(d)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const d=s.handleChange;this.d.set(s,new Set),s.handleChange=(w,N)=>(this.d.get(s).add(w),d.apply(s,[w,N]))}handleDerivedRecomputed(s,d){const w=this.d.get(s);console.log(...this.b([t("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c(d),this.formatChanges(w),{data:[{fn:s._computeFn}]}])),w.clear()}handleFromEventObservableTriggered(s,d){console.log(...this.b([t("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c(d),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const d=s.handleChange;this.d.set(s,new Set),s.handleChange=(w,N)=>(this.d.get(s).add(w),d.apply(s,[w,N]))}handleAutorunTriggered(s){const d=this.d.get(s);console.log(...this.b([t("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:s._runFn}]}])),d.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let d=s.getDebugName();d===void 0&&(d=""),console.log(...this.b([t("transaction"),a(d,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Uc=k;function r(i){const s=new Array,d=[];let w="";function N(S){if("length"in S)for(const f of S)f&&N(f);else"text"in S?(w+=`%c${S.text}`,s.push(S.style),S.data&&d.push(...S.data)):"data"in S&&d.push(...S.data)}N(i);const L=[w,...s];return L.push(...d),L}function l(i){return a(i,{color:"black"})}function t(i){return a(n(`${i}: `,10),{color:"black",bold:!0})}function a(i,s={color:"black"}){function d(N){return Object.entries(N).reduce((L,[S,f])=>`${L}${S}:${f};`,"")}const w={color:s.color};return s.strikeThrough&&(w["text-decoration"]="line-through"),s.bold&&(w["font-weight"]="bold"),{text:i,style:d(w)}}function h(i,s){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=s?`"${i}"`:`"${i.substr(0,s-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?c(i,s):g(i,s);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function c(i,s){let d="[ ",w=!0;for(const N of i){if(w||(d+=", "),d.length-5>s){d+="...";break}w=!1,d+=`${h(N,s-d.length)}`}return d+=" ]",d}function g(i,s){let d="{ ",w=!0;for(const[N,L]of Object.entries(i)){if(w||(d+=", "),d.length-5>s){d+="...";break}w=!1,d+=`${N}: ${h(L,s-d.length)}`}return d+=" }",d}function u(i,s){let d="";for(let w=1;w<=s;w++)d+=i;return d}function n(i,s){for(;i.length<s;)i+=" ";return i}}),define(q[5],V([0,1,4]),function(F,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=void 0;let T;function v(s){T=s}e.$1c=v;class k{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,w){const N=w===void 0?void 0:d,L=w===void 0?d:w;return T({owner:N,debugName:()=>{const S=c(L);if(S!==void 0)return S;const y=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(L.toString());if(y)return`${this.debugName}.${y[2]}`;if(!N)return`${this.debugName} (mapped)`}},S=>L(this.read(S),S))}}e.$2c=k;class r extends k{constructor(){super(...arguments),this.c=new Set}addObserver(d){const w=this.c.size;this.c.add(d),w===0&&this.f()}removeObserver(d){this.c.delete(d)&&this.c.size===0&&this.g()}f(){}g(){}}e.$3c=r;function l(s,d){const w=new a(s,d);try{s(w)}finally{w.finish()}}e.$4c=l;function t(s,d,w){s?d(s):l(d,w)}e.$5c=t;class a{constructor(d,w){this._fn=d,this.b=w,this.a=[],(0,A.$Tc)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():c(this._fn)}updateObserver(d,w){this.a.push({observer:d,observable:w}),d.beginUpdate(w)}finish(){const d=this.a;this.a=null;for(const{observer:w,observable:N}of d)w.endUpdate(N);(0,A.$Tc)()?.handleEndTransaction()}}e.$6c=a;function h(s,d,w,N){let L;if(s!==void 0)if(typeof s=="function"){if(L=s(),L!==void 0)return L}else return s;if(d!==void 0&&(L=c(d),L!==void 0))return L;if(w!==void 0){for(const S in w)if(w[S]===N)return S}}e.$7c=h;function c(s){const d=s.toString(),N=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(N?N[1]:void 0)?.trim()}e.$8c=c;function g(s,d){return typeof s=="string"?new u(void 0,s,d):new u(s,void 0,d)}e.$9c=g;class u extends r{get debugName(){return h(this.d,void 0,this.b,this)??"ObservableValue"}constructor(d,w,N){super(),this.b=d,this.d=w,this.a=N}get(){return this.a}set(d,w,N){if(this.a===d)return;let L;w||(w=L=new a(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.a;this.e(d),(0,A.$Tc)()?.handleObservableChanged(this,{oldValue:S,newValue:d,change:N,didChange:!0,hadValue:!0});for(const f of this.c)w.updateObserver(f,this),f.handleChange(this,N)}finally{L&&L.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(d){this.a=d}}e.$0c=u;function n(s,d){return typeof s=="string"?new i(void 0,s,d):new i(s,void 0,d)}e.$$c=n;class i extends u{e(d){this.a!==d&&(this.a&&this.a.dispose(),this.a=d)}dispose(){this.a?.dispose()}}e.$_c=i}),define(q[9],V([0,1,42,2,5,4]),function(F,e,A,T,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=void 0;function r(n,i){return new g(n.debugName,i,void 0,void 0)}e.$yc=r;function l(n){return new g(void 0,n,void 0,void 0)}e.$zc=l;function t(n,i){return new g(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.$Ac=t;function a(n,i){const s=new T.$ic,d=t({debugName:n.debugName??(()=>(0,v.$8c)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(w,N)=>{s.clear(),i(w,N,s)});return(0,T.$hc)(()=>{d.dispose(),s.dispose()})}e.$Bc=a;function h(n){const i=new T.$ic,s=r({debugName:()=>(0,v.$8c)(n)||"(anonymous)"},d=>{i.clear(),n(d,i)});return(0,T.$hc)(()=>{s.dispose(),i.dispose()})}e.$Cc=h;var c;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(c||(c={}));class g{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const s=this.h();if(s!==void 0)return s}const i=(0,v.$8c)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,s,d,w){this.h=i,this._runFn=s,this.i=d,this.j=w,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,k.$Tc)()?.handleAutorunCreated(this),this.k(),(0,T.$ac)(this)}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear(),(0,T.$bc)(this)}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;try{if(!this.c){(0,k.$Tc)()?.handleAutorunTriggered(this);const s=this.g;this.g=this.i?.(),this._runFn(this,s)}}finally{(0,k.$Tc)()?.handleAutorunFinished(this);for(const s of this.f)s.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,A.$wc)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,s){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:s,didChange:w=>w===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const s=i.get();return this.e.add(i),this.f.delete(i),s}}e.$Dc=g,function(n){n.Observer=g}(l||(e.$zc=l={}));function u(n,i){let s;return r({debugName:()=>(0,v.$8c)(i)},d=>{const w=n.read(d),N=s;s=w,i({lastValue:N,newValue:w})})}e.$Ec=u}),define(q[10],V([0,1,6,2,5,4]),function(F,e,A,T,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=void 0;const r=(u,n)=>u===n;function l(u,n){return n!==void 0?new g(u,void 0,n,void 0,void 0,void 0,r):new g(void 0,void 0,u,void 0,void 0,void 0,r)}e.$Vc=l;function t(u,n){return new g(u.owner,u.debugName,n,void 0,void 0,void 0,u.equalityComparer??r)}e.$Wc=t;function a(u,n){return new g(u.owner,u.debugName,n,u.createEmptyChangeSummary,u.handleChange,void 0,u.equalityComparer??r)}e.$Xc=a;function h(u,n){let i,s;n===void 0?(i=u,s=void 0):(s=u,i=n);const d=new T.$ic;return new g(s,()=>(0,v.$8c)(i)??"(anonymous)",w=>(d.clear(),i(w,d)),void 0,void 0,()=>d.dispose(),r)}e.$Yc=h,(0,v.$1c)(l);var c;(function(u){u[u.initial=0]="initial",u[u.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",u[u.stale=2]="stale",u[u.upToDate=3]="upToDate"})(c||(c={}));class g extends v.$3c{get debugName(){return(0,v.$7c)(this.n,this._computeFn,this.m,this)??"(anonymous)"}constructor(n,i,s,d,w,N=void 0,L){super(),this.m=n,this.n=i,this._computeFn=s,this.p=d,this.q=w,this.s=N,this.t=L,this.e=0,this.h=void 0,this.i=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.p?.(),(0,k.$Tc)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.j)n.removeObserver(this);this.j.clear(),this.s?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.p?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.j)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const n=this.k;this.k=this.j,this.j=n;const i=this.e!==0,s=this.h;this.e=3;const d=this.l;this.l=this.p?.();try{this.h=this._computeFn(this,d)}finally{for(const N of this.k)N.removeObserver(this);this.k.clear()}const w=i&&!this.t(s,this.h);if((0,k.$Tc)()?.handleDerivedRecomputed(this,{oldValue:s,newValue:this.h,change:void 0,didChange:w,hadValue:i}),w)for(const N of this.c)N.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.i++;const i=this.i===1;if(this.e===3&&(this.e=1,!i))for(const s of this.c)s.handlePossibleChange(this);if(i)for(const s of this.c)s.beginUpdate(this)}endUpdate(n){if(this.i--,this.i===0){const i=[...this.c];for(const s of i)s.endUpdate(this)}if(this.i<0)throw new A.$ab}handlePossibleChange(n){if(this.e===3&&this.j.has(n)&&!this.k.has(n)){this.e=1;for(const i of this.c)i.handlePossibleChange(this)}}handleChange(n,i){if(this.j.has(n)&&!this.k.has(n)){const s=this.q?this.q({changedObservable:n,change:i,didChange:w=>w===n},this.l):!0,d=this.e===3;if(s&&(this.e===1||d)&&(this.e=2,d))for(const w of this.c)w.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.j.add(n),this.k.delete(n),i}addObserver(n){const i=!this.c.has(n)&&this.i>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.c.has(n)&&this.i>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.$Zc=g}),define(q[22],V([0,1,2,9,5,10,4]),function(F,e,A,T,v,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=void 0;function l(m){return new t(m)}e.$Fc=l;class t extends v.$2c{constructor(O){super(),this.a=O}get debugName(){return this.toString()}get(){return this.a}addObserver(O){}removeObserver(O){}toString(){return`Const: ${this.a}`}}function a(m){const O=(0,v.$9c)("promiseValue",{});return m.then(B=>{O.set({value:B},void 0)}),O}e.$Gc=a;function h(m,O){return new Promise(B=>{let $=!1,C=!1;const j=(0,T.$zc)(z=>{const I=m.read(z);O(I)&&($?j.dispose():C=!0,B(I))});$=!0,C&&j.dispose()})}e.$Hc=h;function c(m,O){return new g(m,O)}e.$Ic=c;class g extends v.$3c{constructor(O,B){super(),this.h=O,this._getValue=B,this.b=!1,this.k=$=>{const C=this._getValue($),j=!this.b||this.a!==C;(0,r.$Tc)()?.handleFromEventObservableTriggered(this,{oldValue:this.a,newValue:C,change:void 0,didChange:j,hadValue:this.b}),j&&(this.a=C,this.b&&(0,v.$4c)(z=>{for(const I of this.c)z.updateObserver(I,this),I.handleChange(this,void 0)},()=>{const z=this.i();return"Event fired"+(z?`: ${z}`:"")}),this.b=!0)}}i(){return(0,v.$8c)(this._getValue)}get debugName(){const O=this.i();return"From Event"+(O?`: ${O}`:"")}f(){this.e=this.h(this.k)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$Jc=g,function(m){m.Observer=g}(c||(e.$Ic=c={}));function u(m,O){return new n(m,O)}e.$Kc=u;class n extends v.$3c{constructor(O,B){super(),this.debugName=O,this.b=B,this.h=()=>{(0,v.$4c)($=>{for(const C of this.c)$.updateObserver(C,this),C.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(m){return typeof m=="string"?new s(m):new s(void 0,m)}e.$Lc=i;class s extends v.$3c{get debugName(){return(0,v.$7c)(this.a,void 0,this.b,this)??"Observable Signal"}constructor(O,B){super(),this.a=O,this.b=B}trigger(O,B){if(!O){(0,v.$4c)($=>{this.trigger($,B)},()=>`Trigger signal ${this.debugName}`);return}for(const $ of this.c)O.updateObserver($,this),$.handleChange(this,B)}get(){}}function d(m,O,B){const $=(0,v.$9c)("debounced",void 0);let C;return B.add((0,T.$zc)(j=>{const z=m.read(j);C&&clearTimeout(C),C=setTimeout(()=>{(0,v.$4c)(I=>{$.set(z,I)})},O)})),$}e.$Mc=d;function w(m,O,B){const $=(0,v.$9c)("triggeredRecently",!1);let C;return B.add(m(()=>{$.set(!0,void 0),C&&clearTimeout(C),C=setTimeout(()=>{$.set(!1,void 0)},O)})),$}e.$Nc=w;function N(m){const O=new S(!1);return m.addObserver(O),(0,A.$hc)(()=>{m.removeObserver(O)})}e.$Oc=N;function L(m){const O=new S(!0);return m.addObserver(O),m.reportChanges(),(0,A.$hc)(()=>{m.removeObserver(O)})}e.$Pc=L;class S{constructor(O){this.b=O,this.a=0}beginUpdate(O){this.a++}endUpdate(O){this.a--,this.a===0&&this.b&&O.reportChanges()}handlePossibleChange(O){}handleChange(O,B){}}function f(m){let O;return(0,k.$Vc)($=>(O=m($,O),O))}e.$Qc=f;function y(m,O){let B;const $=(0,v.$9c)("derivedObservableWithWritableCache.counter",0),C=(0,k.$Vc)(m,j=>($.read(j),B=O(j,B),B));return Object.assign(C,{clearCache:j=>{B=void 0,$.set($.get()+1,j)}})}e.$Rc=y}),define(q[11],V([0,1,5,10,9,22,4]),function(F,e,A,T,v,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return A.$9c}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return A.$$c}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return A.$4c}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return A.$5c}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return T.$Vc}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return T.$Wc}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return T.$Xc}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return T.$Yc}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$zc}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$Ec}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$Ac}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$Cc}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return v.$yc}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return v.$Bc}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return k.$Fc}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return k.$Mc}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return k.$Qc}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return k.$Rc}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return k.$Oc}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return k.$Pc}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return k.$Ic}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return k.$Gc}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return k.$Lc}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return k.$Kc}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return k.$Hc}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return k.$Nc}}),!1&&(0,r.$Sc)(new r.$Uc)}),define(q[23],V([0,1,6,2]),function(F,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=void 0;function v(L){const S=L;return S?typeof S.read=="function":!1}e.$pd=v;function k(L){const S=L;return S?[S.on,S.pause,S.resume,S.destroy].every(f=>typeof f=="function"):!1}e.$qd=k;function r(L){const S=L;return S?k(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$rd=r;function l(L,S){return new t(L,S)}e.$sd=l;class t{constructor(S,f){this.e=S,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(f=>f(S))}h(S){this.c.error.length===0?(0,A.$Y)(S):this.c.error.slice(0).forEach(f=>f(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,f){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(S,f){if(this.a.destroyed)return;let y;switch(S){case"data":y=this.c.data;break;case"end":y=this.c.end;break;case"error":y=this.c.error;break}if(y){const m=y.indexOf(f);m>=0&&y.splice(m,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(y=>y())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(L,S){const f=[];let y;for(;(y=L.read())!==null;)f.push(y);return S(f)}e.$td=a;function h(L,S,f){const y=[];let m;for(;(m=L.read())!==null&&y.length<f;)y.push(m);return m===null&&y.length>0?S(y):{read:()=>{if(y.length>0)return y.shift();if(typeof m<"u"){const O=m;return m=void 0,O}return L.read()}}}e.$ud=h;function c(L,S){return new Promise((f,y)=>{const m=[];g(L,{onData:O=>{S&&m.push(O)},onError:O=>{S?y(O):f(void 0)},onEnd:()=>{f(S?S(m):void 0)}})})}e.$vd=c;function g(L,S,f){L.on("error",y=>{f?.isCancellationRequested||S.onError(y)}),L.on("end",()=>{f?.isCancellationRequested||S.onEnd()}),L.on("data",y=>{f?.isCancellationRequested||S.onData(y)})}e.$wd=g;function u(L,S){return new Promise((f,y)=>{const m=new T.$ic,O=[],B=j=>{if(O.push(j),O.length>S)return m.dispose(),L.pause(),f({stream:L,buffer:O,ended:!1})},$=j=>(m.dispose(),y(j)),C=()=>(m.dispose(),f({stream:L,buffer:O,ended:!0}));m.add((0,T.$hc)(()=>L.removeListener("error",$))),L.on("error",$),m.add((0,T.$hc)(()=>L.removeListener("end",C))),L.on("end",C),m.add((0,T.$hc)(()=>L.removeListener("data",B))),L.on("data",B)})}e.$xd=u;function n(L,S){const f=l(S);return f.end(L),f}e.$yd=n;function i(){const L=l(()=>{throw new Error("not supported")});return L.end(),L}e.$zd=i;function s(L){let S=!1;return{read:()=>S?null:(S=!0,L)}}e.$Ad=s;function d(L,S,f){const y=l(f);return g(L,{onData:m=>y.write(S.data(m)),onError:m=>y.error(S.error?S.error(m):m),onEnd:()=>y.end()}),y}e.$Bd=d;function w(L,S,f){let y=!1;return{read:()=>{const m=S.read();return y?m:(y=!0,m!==null?f([L,m]):L)}}}e.$Cd=w;function N(L,S,f){let y=!1;const m=l(f);return g(S,{onData:O=>y?m.write(O):(y=!0,m.write(f([L,O]))),onError:O=>m.error(O),onEnd:()=>{y||(y=!0,m.write(L)),m.end()}}),m}e.$Dd=N}),define(q[12],V([0,1,43,23]),function(F,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=void 0;const v=typeof Buffer<"u",k=new A.$T(()=>new Uint8Array(256));let r,l;class t{static alloc(b){return v?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return v&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,U){return!(U?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from(b)):(r||(r=new TextEncoder),new t(r.encode(b)))}static fromByteArray(b){const U=t.alloc(b.length);for(let K=0,p=b.length;K<p;K++)U.buffer[K]=b[K];return U}static concat(b,U){if(typeof U>"u"){U=0;for(let G=0,_=b.length;G<_;G++)U+=b[G].byteLength}const K=t.alloc(U);let p=0;for(let G=0,_=b.length;G<_;G++){const W=b[G];K.set(W,p),p+=W.byteLength}return K}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return v?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(b,U){return new t(this.buffer.subarray(b,U))}set(b,U){if(b instanceof t)this.buffer.set(b.buffer,U);else if(b instanceof Uint8Array)this.buffer.set(b,U);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),U);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),U);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return g(this.buffer,b)}writeUInt32BE(b,U){u(this.buffer,b,U)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,U){i(this.buffer,b,U)}readUInt8(b){return s(this.buffer,b)}writeUInt8(b,U){d(this.buffer,b,U)}indexOf(b,U=0){return a(this.buffer,b instanceof t?b.buffer:b,U)}}e.$Ed=t;function a(I,b,U=0){const K=b.byteLength,p=I.byteLength;if(K===0)return 0;if(K===1)return I.indexOf(b[0]);if(K>p-U)return-1;const G=k.value;G.fill(b.length);for(let J=0;J<b.length;J++)G[b[J]]=b.length-J-1;let _=U+b.length-1,W=_,H=-1;for(;_<p;)if(I[_]===b[W]){if(W===0){H=_;break}_--,W--}else _+=Math.max(b.length-W,G[I[_]]),W=b.length-1;return H}e.$Fd=a;function h(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0}e.$Gd=h;function c(I,b,U){I[U+0]=b&255,b=b>>>8,I[U+1]=b&255}e.$Hd=c;function g(I,b){return I[b]*2**24+I[b+1]*2**16+I[b+2]*2**8+I[b+3]}e.$Id=g;function u(I,b,U){I[U+3]=b,b=b>>>8,I[U+2]=b,b=b>>>8,I[U+1]=b,b=b>>>8,I[U]=b}e.$Jd=u;function n(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0|I[b+2]<<16>>>0|I[b+3]<<24>>>0}e.$Kd=n;function i(I,b,U){I[U+0]=b&255,b=b>>>8,I[U+1]=b&255,b=b>>>8,I[U+2]=b&255,b=b>>>8,I[U+3]=b&255}e.$Ld=i;function s(I,b){return I[b]}e.$Md=s;function d(I,b,U){I[U]=b}e.$Nd=d;function w(I){return T.$td(I,b=>t.concat(b))}e.$Od=w;function N(I){return T.$Ad(I)}e.$Pd=N;function L(I){return T.$vd(I,b=>t.concat(b))}e.$Qd=L;async function S(I){return I.ended?t.concat(I.buffer):t.concat([...I.buffer,await L(I.stream)])}e.$Rd=S;function f(I){return T.$yd(I,b=>t.concat(b))}e.$Sd=f;function y(I){return T.$Bd(I,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.$Td=y;function m(I){return T.$sd(b=>t.concat(b),I)}e.$Ud=m;function O(I,b){return T.$Cd(I,b,U=>t.concat(U))}e.$Vd=O;function B(I,b){return T.$Dd(I,b,U=>t.concat(U))}e.$Wd=B;function $(I){let b=0,U=0,K=0;const p=new Uint8Array(Math.floor(I.length/4*3)),G=W=>{switch(U){case 3:p[K++]=b|W,U=0;break;case 2:p[K++]=b|W>>>2,b=W<<6,U=3;break;case 1:p[K++]=b|W>>>4,b=W<<4,U=2;break;default:b=W<<2,U=1}};for(let W=0;W<I.length;W++){const H=I.charCodeAt(W);if(H>=65&&H<=90)G(H-65);else if(H>=97&&H<=122)G(H-97+26);else if(H>=48&&H<=57)G(H-48+52);else if(H===43||H===45)G(62);else if(H===47||H===95)G(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${I[W]}`)}}const _=K;for(;U>0;)G(0);return t.wrap(p).slice(0,_)}e.$Xd=$;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function z({buffer:I},b=!0,U=!1){const K=U?j:C;let p="";const G=I.byteLength%3;let _=0;for(;_<I.byteLength-G;_+=3){const W=I[_+0],H=I[_+1],J=I[_+2];p+=K[W>>>2],p+=K[(W<<4|H>>>4)&63],p+=K[(H<<2|J>>>6)&63],p+=K[J&63]}if(G===1){const W=I[_+0];p+=K[W>>>2],p+=K[W<<4&63],b&&(p+="==")}else if(G===2){const W=I[_+0],H=I[_+1];p+=K[W>>>2],p+=K[(W<<4|H>>>4)&63],p+=K[H<<2&63],b&&(p+="=")}return p}e.$Yd=z}),define(q[24],V([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$bd=Symbol("MicrotaskDelay")}),define(q[13],V([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=e.StringEOL=void 0;var A;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(A||(e.StringEOL=A={}));function T(v){let k=0,r=0,l=0,t=0;for(let a=0,h=v.length;a<h;a++){const c=v.charCodeAt(a);c===13?(k===0&&(r=a),k++,a+1<h&&v.charCodeAt(a+1)===10?(t|=2,a++):t|=3,l=a+1):c===10&&(t|=1,k===0&&(r=a),k++,l=a+1)}return k===0&&(r=v.length),[k,r,v.length-l,t]}e.$Us=T}),define(q[14],V([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var A;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(A||(e.LanguageId=A={}));var T;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(T||(e.FontStyle=T={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var k;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(k||(e.StandardTokenType=k={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class l{static getLanguageId(a){return(a&255)>>>0}static getTokenType(a){return(a&768)>>>8}static containsBalancedBrackets(a){return(a&1024)!==0}static getFontStyle(a){return(a&30720)>>>11}static getForeground(a){return(a&16744448)>>>15}static getBackground(a){return(a&4278190080)>>>24}static getClassNameFromMetadata(a){let c="mtk"+this.getForeground(a);const g=this.getFontStyle(a);return g&1&&(c+=" mtki"),g&2&&(c+=" mtkb"),g&4&&(c+=" mtku"),g&8&&(c+=" mtks"),c}static getInlineStyleFromMetadata(a,h){const c=this.getForeground(a),g=this.getFontStyle(a);let u=`color: ${h[c]};`;g&1&&(u+="font-style: italic;"),g&2&&(u+="font-weight: bold;");let n="";return g&4&&(n+=" underline"),g&8&&(n+=" line-through"),n&&(u+=`text-decoration:${n};`),u}static getPresentationFromMetadata(a){const h=this.getForeground(a),c=this.getFontStyle(a);return{foreground:h,italic:!!(c&1),bold:!!(c&2),underline:!!(c&4),strikethrough:!!(c&8)}}}e.$Ss=l}),define(q[25],V([0,1,26]),function(F,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=void 0;class T{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,l){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=l}replace(r,l,t){if(r>=this.a.length)return;if(l===0){this.insert(r,t);return}else if(t===0){this.delete(r,l);return}const a=this.a.slice(0,r),h=this.a.slice(r+l),c=v(t,this.b);this.a=a.concat(c,h)}delete(r,l){l===0||r>=this.a.length||this.a.splice(r,l)}insert(r,l){if(l===0||r>=this.a.length)return;const t=[];for(let a=0;a<l;a++)t[a]=this.b;this.a=(0,A.$Tb)(this.a,r,t)}}e.$vC=T;function v(k,r){const l=[];for(let t=0;t<k;t++)l[t]=r;return l}}),define(q[7],V([0,1,14]),function(F,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class T{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(r,l){const t=T.defaultTokenMetadata,a=new Uint32Array(2);return a[0]=r.length,a[1]=t,new T(a,r,l)}constructor(r,l,t){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=l,this.d=t}equals(r){return r instanceof T?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,l,t){if(this.c!==r.c||this.b!==r.b)return!1;const a=l<<1,h=a+(t<<1);for(let c=a;c<h;c++)if(this.a[c]!==r.a[c])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const l=this.a[(r<<1)+1],t=A.$Ss.getLanguageId(l);return this.d.decodeLanguageId(t)}getStandardTokenType(r){const l=this.a[(r<<1)+1];return A.$Ss.getTokenType(l)}getForeground(r){const l=this.a[(r<<1)+1];return A.$Ss.getForeground(l)}getClassName(r){const l=this.a[(r<<1)+1];return A.$Ss.getClassNameFromMetadata(l)}getInlineStyle(r,l){const t=this.a[(r<<1)+1];return A.$Ss.getInlineStyleFromMetadata(t,l)}getPresentation(r){const l=this.a[(r<<1)+1];return A.$Ss.getPresentationFromMetadata(l)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return T.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,l,t){return new v(this,r,l,t)}static convertToEndOffset(r,l){const a=(r.length>>>1)-1;for(let h=0;h<a;h++)r[h<<1]=r[h+1<<1];r[a<<1]=l}static findIndexInTokensArray(r,l){if(r.length<=2)return 0;let t=0,a=(r.length>>>1)-1;for(;t<a;){const h=t+Math.floor((a-t)/2),c=r[h<<1];if(c===l)return h+1;c<l?t=h+1:c>l&&(a=h)}return t}withInserted(r){if(r.length===0)return this;let l=0,t=0,a="";const h=new Array;let c=0;for(;;){const g=l<this.b?this.a[l<<1]:-1,u=t<r.length?r[t]:null;if(g!==-1&&(u===null||g<=u.offset)){a+=this.c.substring(c,g);const n=this.a[(l<<1)+1];h.push(a.length,n),l++,c=g}else if(u){if(u.offset>c){a+=this.c.substring(c,u.offset);const n=this.a[(l<<1)+1];h.push(a.length,n),c=u.offset}a+=u.text,h.push(a.length,u.tokenMetadata),t++}else break}return new T(new Uint32Array(h),a,this.d)}}e.$Vs=T;class v{constructor(r,l,t,a){this.a=r,this.b=l,this.c=t,this.d=a,this.e=r.findTokenIndexAtOffset(l),this.f=0;for(let h=this.e,c=r.getCount();h<c&&!(r.getStartOffset(h)>=t);h++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof v?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const l=this.a.getEndOffset(this.e+r);return Math.min(this.c,l)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,l){return this.a.getInlineStyle(this.e+r,l)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(q[27],V([0,1,7]),function(F,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=e.$Xs=e.$Ws=void 0,e.$Ws=new Uint32Array(0).buffer;class T{static deleteBeginning(r,l){return r===null||r===e.$Ws?r:T.delete(r,0,l)}static deleteEnding(r,l){if(r===null||r===e.$Ws)return r;const t=v(r),a=t[t.length-2];return T.delete(r,l,a)}static delete(r,l,t){if(r===null||r===e.$Ws||l===t)return r;const a=v(r),h=a.length>>>1;if(l===0&&a[a.length-2]===t)return e.$Ws;const c=A.$Vs.findIndexInTokensArray(a,l),g=c>0?a[c-1<<1]:0,u=a[c<<1];if(t<u){const w=t-l;for(let N=c;N<h;N++)a[N<<1]-=w;return r}let n,i;g!==l?(a[c<<1]=l,n=c+1<<1,i=l):(n=c<<1,i=g);const s=t-l;for(let w=c+1;w<h;w++){const N=a[w<<1]-s;N>i&&(a[n++]=N,a[n++]=a[(w<<1)+1],i=N)}if(n===a.length)return r;const d=new Uint32Array(n);return d.set(a.subarray(0,n),0),d.buffer}static append(r,l){if(l===e.$Ws)return r;if(r===e.$Ws)return l;if(r===null)return r;if(l===null)return null;const t=v(r),a=v(l),h=a.length>>>1,c=new Uint32Array(t.length+a.length);c.set(t,0);let g=t.length;const u=t[t.length-2];for(let n=0;n<h;n++)c[g++]=a[n<<1]+u,c[g++]=a[(n<<1)+1];return c.buffer}static insert(r,l,t){if(r===null||r===e.$Ws)return r;const a=v(r),h=a.length>>>1;let c=A.$Vs.findIndexInTokensArray(a,l);c>0&&a[c-1<<1]===l&&c--;for(let g=c;g<h;g++)a[g<<1]+=t;return r}}e.$Xs=T;function v(k){return k instanceof Uint32Array?k:new Uint32Array(k)}e.$Ys=v}),define(q[28],V([0,1,26,12,44,13,27,15]),function(F,e,A,T,v,k,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0;class t{static deserialize(h,c,g){const u=new Uint32Array(h.buffer),n=(0,T.$Id)(h,c);c+=4;const i=(0,T.$Id)(h,c);c+=4;const s=[];for(let d=0;d<i;d++){const w=(0,T.$Id)(h,c);c+=4,s.push(u.subarray(c/4,c/4+w/4)),c+=w}return g.push(new t(n,s)),c}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(h,c){this.a=h,this.b=c}getLineRange(){return new l.$rs(this.a,this.a+this.b.length)}getLineTokens(h){return this.b[h-this.a]}appendLineTokens(h){this.b.push(h)}serializeSize(){let h=0;h+=4,h+=4;for(let c=0;c<this.b.length;c++){const g=this.b[c];if(!(g instanceof Uint32Array))throw new Error("Not supported!");h+=4,h+=g.byteLength}return h}serialize(h,c){(0,T.$Jd)(h,this.a,c),c+=4,(0,T.$Jd)(h,this.b.length,c),c+=4;for(let g=0;g<this.b.length;g++){const u=this.b[g];if(!(u instanceof Uint32Array))throw new Error("Not supported!");(0,T.$Jd)(h,u.byteLength,c),c+=4,h.set(new Uint8Array(u.buffer),c),c+=u.byteLength}return c}applyEdit(h,c){const[g,u]=(0,k.$Us)(c);this.c(h),this.d(new v.$hs(h.startLineNumber,h.startColumn),g,u)}c(h){if(h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn)return;const c=h.startLineNumber-this.a,g=h.endLineNumber-this.a;if(g<0){const u=g-c;this.a-=u;return}if(!(c>=this.b.length)){if(c<0&&g>=this.b.length){this.a=0,this.b=[];return}if(c===g){this.b[c]=r.$Xs.delete(this.b[c],h.startColumn-1,h.endColumn-1);return}if(c>=0)if(this.b[c]=r.$Xs.deleteEnding(this.b[c],h.startColumn-1),g<this.b.length){const u=r.$Xs.deleteBeginning(this.b[g],h.endColumn-1);this.b[c]=r.$Xs.append(this.b[c],u),this.b.splice(c+1,g-c)}else this.b[c]=r.$Xs.append(this.b[c],null),this.b=this.b.slice(0,c+1);else{const u=-c;this.a-=u,this.b[g]=r.$Xs.deleteBeginning(this.b[g],h.endColumn-1),this.b=this.b.slice(g)}}}d(h,c,g){if(c===0&&g===0)return;const u=h.lineNumber-this.a;if(u<0){this.a+=c;return}if(!(u>=this.b.length)){if(c===0){this.b[u]=r.$Xs.insert(this.b[u],h.column-1,g);return}this.b[u]=r.$Xs.deleteEnding(this.b[u],h.column-1),this.b[u]=r.$Xs.insert(this.b[u],h.column-1,g),this.e(h.lineNumber,c)}}e(h,c){if(c===0)return;const g=[];for(let u=0;u<c;u++)g[u]=null;this.b=A.$Tb(this.b,h,g)}}e.$Zs=t}),define(q[16],V([0,1,12,28]),function(F,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wC=void 0;class v{static deserialize(r){let l=0;const t=(0,A.$Id)(r,l);l+=4;const a=[];for(let h=0;h<t;h++)l=T.$Zs.deserialize(r,l,a);return a}constructor(){this.a=[]}add(r,l){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(l);return}}this.a.push(new T.$Zs(r,[l]))}finalize(){return this.a}serialize(){const r=this.b(),l=new Uint8Array(r);return this.c(l),l}b(){let r=0;r+=4;for(let l=0;l<this.a.length;l++)r+=this.a[l].serializeSize();return r}c(r){let l=0;(0,A.$Jd)(r,this.a.length,l),l+=4;for(let t=0;t<this.a.length;t++)l=this.a[t].serialize(r,l)}}e.$wC=v}),define(q[29],V([0,1,30,3,31,45]),function(F,e,A,T,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=void 0;function r($){return $===47||$===92}e.$Af=r;function l($){return $.replace(/[\\/]/g,A.$5d.sep)}e.$Bf=l;function t($){return $.indexOf("/")===-1&&($=l($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}e.$Cf=t;function a($,C=A.$5d.sep){if(!$)return"";const j=$.length,z=$.charCodeAt(0);if(r(z)){if(r($.charCodeAt(1))&&!r($.charCodeAt(2))){let b=3;const U=b;for(;b<j&&!r($.charCodeAt(b));b++);if(U!==b&&!r($.charCodeAt(b+1))){for(b+=1;b<j;b++)if(r($.charCodeAt(b)))return $.slice(0,b+1).replace(/[\\/]/g,C)}}return C}else if(d(z)&&$.charCodeAt(1)===58)return r($.charCodeAt(2))?$.slice(0,2)+C:$.slice(0,2);let I=$.indexOf("://");if(I!==-1){for(I+=3;I<j;I++)if(r($.charCodeAt(I)))return $.slice(0,I+1)}return""}e.$Df=a;function h($){if(!T.$i||!$||$.length<5)return!1;let C=$.charCodeAt(0);if(C!==92||(C=$.charCodeAt(1),C!==92))return!1;let j=2;const z=j;for(;j<$.length&&(C=$.charCodeAt(j),C!==92);j++);return!(z===j||(C=$.charCodeAt(j+1),isNaN(C)||C===92))}e.$Ef=h;const c=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n($,C=T.$i){const j=C?c:g;return!(!$||$.length===0||/^\s+$/.test($)||(j.lastIndex=0,j.test($))||C&&u.test($)||$==="."||$===".."||C&&$[$.length-1]==="."||C&&$.length!==$.trim().length||$.length>255)}e.$Ff=n;function i($,C,j){const z=$===C;return!j||z?z:!$||!C?!1:(0,v.$Le)($,C)}e.$Gf=i;function s($,C,j,z=A.sep){if($===C)return!0;if(!$||!C||C.length>$.length)return!1;if(j){if(!(0,v.$Me)($,C))return!1;if(C.length===$.length)return!0;let b=C.length;return C.charAt(C.length-1)===z&&b--,$.charAt(b)===z}return C.charAt(C.length-1)!==z&&(C+=z),$.indexOf(C)===0}e.$Hf=s;function d($){return $>=65&&$<=90||$>=97&&$<=122}e.$If=d;function w($,C){return T.$i&&$.endsWith(":")&&($+=A.sep),(0,A.$7d)($)||($=(0,A.$8d)(C,$)),$=(0,A.$6d)($),T.$i?($=(0,v.$ue)($,A.sep),$.endsWith(":")&&($+=A.sep)):($=(0,v.$ue)($,A.sep),$||($=A.sep)),$}e.$Jf=w;function N($){const C=(0,A.$6d)($);return T.$i?$.length>3?!1:L(C)&&($.length===2||C.charCodeAt(2)===92):C===A.$5d.sep}e.$Kf=N;function L($,C=T.$i){return C?d($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}e.$Lf=L;function S($,C=T.$i){return L($,C)?$[0]:void 0}e.$Mf=S;function f($,C,j){return C.length>$.length?-1:$===C?0:(j&&($=$.toLowerCase(),C=C.toLowerCase()),$.indexOf(C))}e.$Nf=f;function y($){const C=$.split(":");let j,z,I;for(const b of C){const U=Number(b);(0,k.$mf)(U)?z===void 0?z=U:I===void 0&&(I=U):j=j?[j,b].join(":"):b}if(!j)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:j,line:z!==void 0?z:void 0,column:I!==void 0?I:z!==void 0?1:void 0}}e.$Of=y;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",O="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function B($,C,j=8){let z="";for(let b=0;b<j;b++){let U;b===0&&T.$i&&!C&&(j===3||j===4)?U=O:U=m,z+=U.charAt(Math.floor(Math.random()*U.length))}let I;return C?I=`${C}-${z}`:I=z,$?(0,A.$8d)($,I):I}e.$Pf=B}),define(q[17],V([0,1,6,3,8]),function(F,e,A,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.Schemas=void 0;var k;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(k||(e.Schemas=k={})),e.$Tf="vscode-tkn",e.$Uf="tkn";class r{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${k.vscodeRemoteResource}`}set(h,c,g){this.a[h]=c,this.b[h]=g}setConnectionToken(h,c){this.c[h]=c}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(s){return A.$Y(s),h}const c=h.authority;let g=this.a[c];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const u=this.b[c],n=this.c[c];let i=`path=${encodeURIComponent(h.path)}`;return typeof n=="string"&&(i+=`&${e.$Uf}=${encodeURIComponent(n)}`),v.URI.from({scheme:T.$o?this.d:k.vscodeRemoteResource,authority:`${g}:${u}`,path:this.f,query:i})}}e.$Vf=new r,e.$Wf="vs/../../extensions",e.$Xf="vs/../../node_modules",e.$Yf="vs/../../node_modules.asar",e.$Zf="vs/../../node_modules.asar.unpacked";class l{static{this.a="vscode-app"}asBrowserUri(h){const c=this.b(h,F);return this.uriToBrowserUri(c)}uriToBrowserUri(h){return h.scheme===k.vscodeRemote?e.$Vf.rewrite(h):h.scheme===k.file&&(T.$m||T.$p&&T.$g.origin===`${k.vscodeFileResource}://${l.a}`)?h.with({scheme:k.vscodeFileResource,authority:h.authority||l.a,query:null,fragment:null}):h}asFileUri(h){const c=this.b(h,F);return this.uriToFileUri(c)}uriToFileUri(h){return h.scheme===k.vscodeFileResource?h.with({scheme:k.file,authority:h.authority!==l.a?h.authority:null,query:null,fragment:null}):h}b(h,c){return v.URI.isUri(h)?h:v.URI.parse(c.toUrl(h))}}e.$1f=new l;var t;(function(a){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(h.get("3"));const c="vscode-coi";function g(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:v.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const s=i?.get(c);if(s)return h.get(s)}a.getHeadersFromQuery=g;function u(n,i,s){if(!globalThis.crossOriginIsolated)return;const d=i&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(c,d):n[c]=d}a.addSearchParam=u})(t||(e.COI=t={}))}),define(q[32],V([0,1,21,17,3,8]),function(F,e,A,T,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$C=void 0;class r{constructor(g,u,n){this.id=g,this.dependencies=u,this.callback=n}}class l{static{this.INSTANCE=new l}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,u,n)=>{typeof g!="string"&&(n=u,u=g,g=null),(typeof u!="object"||!Array.isArray(u))&&(n=u,u=null),this.c.push(new r(g,u,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const u=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!u)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}h(g){return new Promise((u,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const s=()=>{i.removeEventListener("load",d),i.removeEventListener("error",w)},d=N=>{s(),u(this.c.pop())},w=N=>{s(),n(N)};i.addEventListener("load",d),i.addEventListener("error",w),this.f&&(g=this.f.createScriptURL(g)),i.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(i)})}i(g){return new Promise((u,n)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),u(this.c.pop())}catch(i){n(i)}})}async j(g){try{const u=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,s=k.URI.parse(g).fsPath,d=u.readFileSync(s).toString(),w=i.wrap(d.replace(/^#!.*/,""));return new n.Script(w).runInThisContext().apply(),this.c.pop()}catch(u){throw u}}}const t=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function h(c,g,u){if(A.$R){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[c]&&(c=a[c]);const n=`${c}/${g}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const N=`${u&&!v.$o?T.$Yf:T.$Xf}/${n}`;i=T.$1f.asBrowserUri(N).toString(!0)}const s=l.INSTANCE.load(i);return t.set(n,s),s}else return await new Promise((n,i)=>{F([c],n,i)})}e.$$C=h}),define(q[18],V([0,1,29,17,30,3,31,8]),function(F,e,A,T,v,k,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.DataUri=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=void 0;function t(u){return(0,l.$Sf)(u,!0)}e.$8f=t;class a{constructor(n){this.a=n}compare(n,i,s=!1){return n===i?0:(0,r.$Ee)(this.getComparisonKey(n,s),this.getComparisonKey(i,s))}isEqual(n,i,s=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,s)===this.getComparisonKey(i,s)}getComparisonKey(n,i=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,i,s=!1){if(n.scheme===i.scheme){if(n.scheme===T.Schemas.file)return A.$Hf(t(n),t(i),this.a(n))&&n.query===i.query&&(s||n.fragment===i.fragment);if((0,e.$mg)(n.authority,i.authority))return A.$Hf(n.path,i.path,this.a(n),"/")&&n.query===i.query&&(s||n.fragment===i.fragment)}return!1}joinPath(n,...i){return l.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.$eg)(n)||n.authority}basename(n){return v.$5d.basename(n.path)}extname(n){return v.$5d.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===T.Schemas.file?i=l.URI.file(v.$$d(t(n))).path:(i=v.$5d.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===T.Schemas.file?i=l.URI.file(v.$6d(t(n))).path:i=v.$5d.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.$mg)(n.authority,i.authority))return;if(n.scheme===T.Schemas.file){const w=v.$0d(t(n),t(i));return k.$i?A.$Bf(w):w}let s=n.path||"/";const d=i.path||"/";if(this.a(n)){let w=0;for(const N=Math.min(s.length,d.length);w<N&&!(s.charCodeAt(w)!==d.charCodeAt(w)&&s.charAt(w).toLowerCase()!==d.charAt(w).toLowerCase());w++);s=d.substr(0,w)+s.substr(w)}return v.$5d.relative(s,d)}resolvePath(n,i){if(n.scheme===T.Schemas.file){const s=l.URI.file(v.$9d(t(n),i));return n.with({authority:s.authority,path:s.path})}return i=A.$Cf(i),n.with({path:v.$5d.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,r.$Le)(n,i)}hasTrailingPathSeparator(n,i=v.sep){if(n.scheme===T.Schemas.file){const s=t(n);return s.length>A.$Df(s).length&&s[s.length-1]===i}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=v.sep){return(0,e.$ng)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=v.sep){let s=!1;if(n.scheme===T.Schemas.file){const d=t(n);s=d!==void 0&&d.length===A.$Df(d).length&&d[d.length-1]===i}else{i="/";const d=n.path;s=d.length===1&&d.charCodeAt(d.length-1)===47}return!s&&!(0,e.$ng)(n,i)?n.with({path:n.path+"/"}):n}}e.$9f=a,e.$0f=new a(()=>!1),e.$$f=new a(u=>u.scheme===T.Schemas.file?!k.$k:!0),e.$_f=new a(u=>!0),e.$ag=e.$0f.isEqual.bind(e.$0f),e.$bg=e.$0f.isEqualOrParent.bind(e.$0f),e.$cg=e.$0f.getComparisonKey.bind(e.$0f),e.$dg=e.$0f.basenameOrAuthority.bind(e.$0f),e.$eg=e.$0f.basename.bind(e.$0f),e.$fg=e.$0f.extname.bind(e.$0f),e.$gg=e.$0f.dirname.bind(e.$0f),e.$hg=e.$0f.joinPath.bind(e.$0f),e.$ig=e.$0f.normalizePath.bind(e.$0f),e.$jg=e.$0f.relativePath.bind(e.$0f),e.$kg=e.$0f.resolvePath.bind(e.$0f),e.$lg=e.$0f.isAbsolutePath.bind(e.$0f),e.$mg=e.$0f.isEqualAuthority.bind(e.$0f),e.$ng=e.$0f.hasTrailingPathSeparator.bind(e.$0f),e.$og=e.$0f.removeTrailingPathSeparator.bind(e.$0f),e.$pg=e.$0f.addTrailingPathSeparator.bind(e.$0f);function h(u,n){const i=[];for(let s=0;s<u.length;s++){const d=n(u[s]);u.some((w,N)=>N===s?!1:(0,e.$bg)(d,n(w)))||i.push(u[s])}return i}e.$qg=h;var c;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function n(i){const s=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(N=>{const[L,S]=N.split(":");L&&S&&s.set(L,S)});const w=i.path.substring(0,i.path.indexOf(";"));return w&&s.set(u.META_DATA_MIME,w),s}u.parseMetaData=n})(c||(e.DataUri=c={}));function g(u,n,i){if(n){let s=u.path;return s&&s[0]!==v.$5d.sep&&(s=v.$5d.sep+s),u.with({scheme:i,authority:n,path:s})}return u.with({scheme:i})}e.$rg=g}),define(q[19],V([0,1,46,6,33,2,18,3,24]),function(F,e,A,T,v,k,r,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.$3g=e.$2g=e.Promises=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=void 0;function a(M){return!!M&&typeof M.then=="function"}e.$sg=a;function h(M){const o=new A.$od,E=M(o.token),P=new Promise((R,D)=>{const Y=o.token.onCancellationRequested(()=>{Y.dispose(),o.dispose(),D(new T.$3)});Promise.resolve(E).then(Z=>{Y.dispose(),o.dispose(),R(Z)},Z=>{Y.dispose(),o.dispose(),D(Z)})});return new class{cancel(){o.cancel()}then(R,D){return P.then(R,D)}catch(R){return this.then(void 0,R)}finally(R){return P.finally(R)}}}e.$tg=h;function c(M,o,E){return new Promise((P,R)=>{const D=o.onCancellationRequested(()=>{D.dispose(),P(E)});M.then(P,R).finally(()=>D.dispose())})}e.$ug=c;function g(M,o){return new Promise((E,P)=>{const R=o.onCancellationRequested(()=>{R.dispose(),P(new T.$3)});M.then(E,P).finally(()=>R.dispose())})}e.$vg=g;async function u(M){let o=-1;const E=M.map((P,R)=>P.then(D=>(o=R,D)));try{return await Promise.race(E)}finally{M.forEach((P,R)=>{R!==o&&P.cancel()})}}e.$wg=u;function n(M,o,E){let P;const R=setTimeout(()=>{P?.(void 0),E?.()},o);return Promise.race([M.finally(()=>clearTimeout(R)),new Promise(D=>P=D)])}e.$xg=n;function i(M){return new Promise((o,E)=>{const P=M();a(P)?P.then(o,E):o(P)})}e.$yg=i;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(o){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=o,!this.b){const E=()=>{if(this.b=null,this.f)return;const P=this.queue(this.d);return this.d=null,P};this.b=new Promise(P=>{this.a.then(E,E).then(P)})}return new Promise((E,P)=>{this.b.then(E,P)})}return this.a=o(),new Promise((E,P)=>{this.a.then(R=>{this.a=null,E(R)},R=>{this.a=null,P(R)})})}dispose(){this.f=!0}}e.$zg=s;class d{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}e.$Ag=d;class w{constructor(){this.a=new Map}queue(o,E){const R=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(o)===R&&this.a.delete(o)});return this.a.set(o,R),R}}e.$Bg=w;const N=(M,o)=>{let E=!0;const P=setTimeout(()=>{E=!1,o()},M);return{isTriggered:()=>E,dispose:()=>{clearTimeout(P),E=!1}}},L=M=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,M())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class S{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,E=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((R,D)=>{this.d=R,this.f=D}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const P=()=>{this.a=null,this.d?.(null)};return this.a=E===t.$bd?L(P):N(E,P),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Cg=S;class f{constructor(o){this.a=new S(o),this.b=new s}trigger(o,E){return this.a.trigger(()=>this.b.queue(o),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dg=f;class y{constructor(){this.a=!1,this.b=new Promise((o,E)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eg=y;class m extends y{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}e.$Fg=m;function O(M,o){return o?new Promise((E,P)=>{const R=setTimeout(()=>{D.dispose(),E()},M),D=o.onCancellationRequested(()=>{clearTimeout(R),D.dispose(),P(new T.$3)})}):h(E=>O(M,E))}e.$Gg=O;function B(M,o=0){const E=setTimeout(M,o);return(0,k.$hc)(()=>clearTimeout(E))}e.$Hg=B;function $(M){const o=[];let E=0;const P=M.length;function R(){return E<P?M[E++]():null}function D(Y){Y!=null&&o.push(Y);const Z=R();return Z?Z.then(D):Promise.resolve(o)}return Promise.resolve(null).then(D)}e.$Ig=$;function C(M,o=P=>!!P,E=null){let P=0;const R=M.length,D=()=>{if(P>=R)return Promise.resolve(E);const Y=M[P++];return Promise.resolve(Y()).then(Q=>o(Q)?Promise.resolve(Q):D())};return D()}e.$Jg=C;function j(M,o=P=>!!P,E=null){if(M.length===0)return Promise.resolve(E);let P=M.length;const R=()=>{P=-1;for(const D of M)D.cancel?.()};return new Promise((D,Y)=>{for(const Z of M)Z.then(Q=>{--P>=0&&o(Q)?(R(),D(Q)):P===0&&D(E)}).catch(Q=>{--P>=0&&(R(),Y(Q))})})}e.$Kg=j;class z{constructor(o){this.a=0,this.d=o,this.f=[],this.b=0,this.g=new v.$ed}get onDrained(){return this.g.event}get size(){return this.a}queue(o){return this.a++,new Promise((E,P)=>{this.f.push({factory:o,c:E,e:P}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const o=this.f.shift();this.b++;const E=o.factory();E.then(o.c,o.e),E.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Lg=z;class I extends z{constructor(){super(1)}}e.$Mg=I;class b{constructor(){this.a=new x,this.b=0}queue(o){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,o())):this.a.run(this.b++,o())}}e.$Ng=b;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const o=new te;return this.b.add(o),o.p}g(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueFor(o,E=r.$0f){const P=E.getComparisonKey(o);let R=this.a.get(P);if(!R){R=new I;const D=this.f++,Y=v.Event.once(R.onDrained)(()=>{R?.dispose(),this.a.delete(P),this.h(),this.d?.deleteAndDispose(D),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new k.$rc),this.d.set(D,Y),this.a.set(P,R)}return R}h(){this.g()&&this.j()}j(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Og=U;class K{constructor(o,E){this.a=-1,typeof o=="function"&&typeof E=="number"&&this.setIfNotSet(o,E)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,E){this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},E)}setIfNotSet(o,E){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},E))}}e.$Pg=K;class p{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(o,E){this.cancel(),this.a=setInterval(()=>{o()},E)}}e.$Qg=p;class G{constructor(o,E){this.b=-1,this.a=o,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rg=G;class _{constructor(o,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=o,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sg=_;class W extends G{constructor(o,E){super(o,E),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}e.$Tg=W;class H extends k.$jc{constructor(o,E){super(),this.g=o,this.h=E,this.a=[],this.b=this.B(new k.$kc),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of o)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ug=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Vg=M=>{(0,l.$A)(()=>{if(o)return;const E=Date.now()+15;M(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,E-Date.now())}}))});let o=!1;return{dispose(){o||(o=!0)}}}:e.$Vg=(M,o)=>{const E=requestIdleCallback(M,typeof o=="number"?{timeout:o}:void 0);let P=!1;return{dispose(){P||(P=!0,cancelIdleCallback(E))}}}}();class J{constructor(o){this.d=!1,this.a=()=>{try{this.f=o()}catch(E){this.g=E}finally{this.d=!0}},this.b=(0,e.$Vg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Wg=J;async function re(M,o,E){let P;for(let R=0;R<E;R++)try{return await M()}catch(D){P=D,await O(o)}throw P}e.$Xg=re;class x{isRunning(o){return typeof o=="number"?this.a?.taskId===o:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(o,E,P){return this.a={taskId:o,cancel:()=>P?.(),promise:E},E.then(()=>this.d(o),()=>this.d(o)),E}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this.b)this.b.run=o;else{let E,P;const R=new Promise((D,Y)=>{E=D,P=Y});this.b={run:o,promise:R,promiseResolve:E,promiseReject:P}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Yg=x;class ae{constructor(o,E=()=>Date.now()){this.d=o,this.f=E,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}e.$Zg=ae;var ee;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(ee||(ee={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((o,E)=>{this.a=o,this.b=E})}complete(o){return new Promise(E=>{this.a(o),this.d={outcome:0,value:o},E()})}error(o){return new Promise(E=>{this.b(o),this.d={outcome:1,value:o},E()})}cancel(){return this.error(new T.$3)}}e.$1g=te;var ne;(function(M){async function o(P){let R;const D=await Promise.all(P.map(Y=>Y.then(Z=>Z,Z=>{R||(R=Z)})));if(typeof R<"u")throw R;return D}M.settled=o;function E(P){return new Promise(async(R,D)=>{try{await P(R,D)}catch(Y){D(Y)}})}M.withAsyncBody=E})(ne||(e.Promises=ne={}));var ie;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(ie||(ie={}));class X{static fromArray(o){return new X(E=>{E.emitMany(o)})}static fromPromise(o){return new X(async E=>{E.emitMany(await o)})}static fromPromises(o){return new X(async E=>{await Promise.all(o.map(async P=>E.emitOne(await P)))})}static merge(o){return new X(async E=>{await Promise.all(o.map(async P=>{for await(const R of P)E.emitOne(R)}))})}static{this.EMPTY=X.fromArray([])}constructor(o){this.a=0,this.b=[],this.d=null,this.f=new v.$ed,queueMicrotask(async()=>{const E={emitOne:P=>this.g(P),emitMany:P=>this.h(P),reject:P=>this.k(P)};try{await Promise.resolve(o(E)),this.j()}catch(P){this.k(P)}finally{E.emitOne=void 0,E.emitMany=void 0,E.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(o,E){return new X(async P=>{for await(const R of o)P.emitOne(E(R))})}map(o){return X.map(this,o)}static filter(o,E){return new X(async P=>{for await(const R of o)E(R)&&P.emitOne(R)})}filter(o){return X.filter(this,o)}static coalesce(o){return X.filter(o,E=>!!E)}coalesce(){return X.coalesce(this)}static async toPromise(o){const E=[];for await(const P of o)E.push(P);return E}toPromise(){return X.toPromise(this)}g(o){this.a===0&&(this.b.push(o),this.f.fire())}h(o){this.a===0&&(this.b=this.b.concat(o),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(o){this.a===0&&(this.a=2,this.d=o,this.f.fire())}}e.$2g=X;class se extends X{constructor(o,E){super(E),this.l=o}cancel(){this.l.cancel()}}e.$3g=se;function ce(M){const o=new A.$od,E=M(o.token);return new se(o,async P=>{const R=o.token.onCancellationRequested(()=>{R.dispose(),o.dispose(),P.reject(new T.$3)});try{for await(const D of E){if(o.token.isCancellationRequested)return;P.emitOne(D)}R.dispose(),o.dispose()}catch(D){R.dispose(),o.dispose(),P.reject(D)}})}e.$4g=ce}),define(q[20],V([0,1,34]),function(F,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=e.$tC=e.$sC=void 0,e.$sC=new class{clone(){return this}equals(k){return this===k}};function T(k,r){return new A.$3s([new A.$2s(0,"",k)],r)}e.$tC=T;function v(k,r){const l=new Uint32Array(2);return l[0]=0,l[1]=(k<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new A.$4s(l,r===null?e.$sC:r)}e.$uC=v}),define(q[35],V([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(F,e,A,T,v,k,r,l,t,a,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CC=e.$BC=e.$AC=e.$zC=e.$yC=e.$xC=void 0;var u;(function(S){S[S.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(u||(u={}));class n{constructor(f,y){this.tokenizationSupport=y,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(f)}getStartState(f){return this.store.getStartState(f,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$xC=n;class i extends n{constructor(f,y,m,O){super(f,y),this._textModel=m,this._languageIdCodec=O}updateTokensUntilLine(f,y){const m=this._textModel.getLanguageId();for(;;){const O=this.getFirstInvalidLine();if(!O||O.lineNumber>y)break;const B=this._textModel.getLineContent(O.lineNumber),$=N(this._languageIdCodec,m,this.tokenizationSupport,B,!0,O.startState);f.add(O.lineNumber,$.tokens),this.store.setEndState(O.lineNumber,$.endState)}}getTokenTypeIfInsertingCharacter(f,y){const m=this.getStartState(f.lineNumber);if(!m)return 0;const O=this._textModel.getLanguageId(),B=this._textModel.getLineContent(f.lineNumber),$=B.substring(0,f.column-1)+y+B.substring(f.column-1),C=N(this._languageIdCodec,O,this.tokenizationSupport,$,!0,m),j=new g.$Vs(C.tokens,$,this._languageIdCodec);if(j.getCount()===0)return 0;const z=j.findTokenIndexAtOffset(f.column-1);return j.getStandardTokenType(z)}tokenizeLineWithEdit(f,y,m){const O=f.lineNumber,B=f.column,$=this.getStartState(O);if(!$)return null;const C=this._textModel.getLineContent(O),j=C.substring(0,B-1)+m+C.substring(B-1+y),z=this._textModel.getLanguageIdAtPosition(O,0),I=N(this._languageIdCodec,z,this.tokenizationSupport,j,!0,$);return new g.$Vs(I.tokens,j,this._languageIdCodec)}isCheapToTokenize(f){const y=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<y||f===y&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,y,m){if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(y<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,m),{heuristicTokens:!1};let O=this.b(y);const B=this._textModel.getLanguageId();for(let $=y;$<=m;$++){const C=this._textModel.getLineContent($),j=N(this._languageIdCodec,B,this.tokenizationSupport,C,!0,O);f.add($,j.tokens),O=j.endState}return{heuristicTokens:!0}}b(f){let y=this._textModel.getLineFirstNonWhitespaceColumn(f);const m=[];let O=null;for(let C=f-1;y>1&&C>=1;C--){const j=this._textModel.getLineFirstNonWhitespaceColumn(C);if(j!==0&&j<y&&(m.push(this._textModel.getLineContent(C)),y=j,O=this.getStartState(C),O))break}O||(O=this.tokenizationSupport.getInitialState()),m.reverse();const B=this._textModel.getLanguageId();let $=O;for(const C of m)$=N(this._languageIdCodec,B,this.tokenizationSupport,C,!1,$).endState;return $}}e.$yC=i;class s{constructor(f){this.d=f,this.a=new d,this.b=new w,this.b.addRange(new t.$ps(1,f+1))}getEndState(f){return this.a.getEndState(f)}setEndState(f,y){if(!y)throw new T.$ab("Cannot set null/undefined state");this.b.delete(f);const m=this.a.setEndState(f,y);return m&&f<this.d&&this.b.addRange(new t.$ps(f+1,f+2)),m}acceptChange(f,y){this.d+=y-f.length,this.a.acceptChange(f,y),this.b.addRangeAndResize(new t.$ps(f.startLineNumber,f.endLineNumberExclusive),y)}acceptChanges(f){for(const y of f){const[m]=(0,r.$Us)(y.text);this.acceptChange(new l.$rs(y.range.startLineNumber,y.range.endLineNumber+1),m+1)}}invalidateEndStateRange(f){this.b.addRange(new t.$ps(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(f,y){return f===1?y:this.getEndState(f-1)}getFirstInvalidLine(f){const y=this.getFirstInvalidEndStateLineNumber();if(y===null)return null;const m=this.getStartState(y,f);if(!m)throw new T.$ab("Start state must be defined");return{lineNumber:y,startState:m}}}e.$zC=s;class d{constructor(){this.a=new h.$vC(null)}getEndState(f){return this.a.get(f)}setEndState(f,y){const m=this.a.get(f);return m&&m.equals(y)?!1:(this.a.set(f,y),!0)}acceptChange(f,y){let m=f.length;y>0&&m>0&&(m--,y--),this.a.replace(f.startLineNumber,m,y)}acceptChanges(f){for(const y of f){const[m]=(0,r.$Us)(y.text);this.acceptChange(new l.$rs(y.range.startLineNumber,y.range.endLineNumber+1),m+1)}}}e.$AC=d;class w{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const f=this.a[0];return f.start+1===f.endExclusive?this.a.shift():this.a[0]=new t.$ps(f.start+1,f.endExclusive),f.start}delete(f){const y=this.a.findIndex(m=>m.contains(f));if(y!==-1){const m=this.a[y];m.start===f?m.endExclusive===f+1?this.a.splice(y,1):this.a[y]=new t.$ps(f+1,m.endExclusive):m.endExclusive===f+1?this.a[y]=new t.$ps(m.start,f):this.a.splice(y,1,new t.$ps(m.start,f),new t.$ps(f+1,m.endExclusive))}}addRange(f){t.$ps.addRange(f,this.a)}addRangeAndResize(f,y){let m=0;for(;!(m>=this.a.length||f.start<=this.a[m].endExclusive);)m++;let O=m;for(;!(O>=this.a.length||f.endExclusive<this.a[O].start);)O++;const B=y-f.length;for(let $=O;$<this.a.length;$++)this.a[$]=this.a[$].delta(B);if(m===O){const $=new t.$ps(f.start,f.start+y);$.isEmpty||this.a.splice(m,0,$)}else{const $=Math.min(f.start,this.a[m].start),C=Math.max(f.endExclusive,this.a[O-1].endExclusive),j=new t.$ps($,C+B);j.isEmpty?this.a.splice(m,O-m):this.a.splice(m,O-m,j)}}toString(){return this.a.map(f=>f.toString()).join(" + ")}}e.$BC=w;function N(S,f,y,m,O,B){let $=null;if(y)try{$=y.tokenizeEncoded(m,O,B.clone())}catch(C){(0,T.$Y)(C)}return $||($=(0,a.$uC)(S.encodeLanguageId(f),B)),g.$Vs.convertToEndOffset($.tokens,m.length),$}class L{constructor(f,y){this.b=f,this.d=y,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,A.$Vg)(f=>{this.f=!1,this.h(f)}))}h(f){const y=Date.now()+f.timeRemaining(),m=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<y?(0,v.$A)(m):this.g())};m()}j(){const f=this.b._textModel.getLineCount(),y=new c.$wC,m=k.$ad.create(!1);do if(m.elapsed()>1||this.l(y)>=f)break;while(this.k());this.d.setTokens(y.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(f){const y=this.b?.getFirstInvalidLine();return y?(this.b.updateTokensUntilLine(f,y.lineNumber),y.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(f,y){this.b.store.invalidateEndStateRange(new l.$rs(f,y))}}e.$CC=L}),define(q[37],V([0,1,33,2,36,14,34]),function(F,e,A,T,v,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cBb=void 0;class l extends T.$jc{constructor(a,h,c,g,u,n,i){super(),this.c=a,this.f=h,this.g=c,this.h=g,this.j=u,this.m=n,this.n=i,this.a=[],this.b=this.B(new A.$ed),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(a,h,c){throw new Error("Not supported!")}createBackgroundTokenizer(a,h){if(this.h)return this.h(a,h)}tokenizeEncoded(a,h,c){const g=Math.random()*1e4<1,u=this.n||g,n=u?new v.$ad(!0):void 0,i=this.c.tokenizeLine2(a,c,500);if(u){const d=n.elapsed();(g||d>32)&&this.m(d,a.length,g)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${a.substring(0,100)}`),new r.$4s(i.tokens,c);if(this.g){const d=this.a,w=i.tokens;for(let N=0,L=w.length>>>1;N<L;N++){const S=w[(N<<1)+1],f=k.$Ss.getLanguageId(S);d[f]||(d[f]=!0,this.b.fire(f))}}let s;return c.equals(i.ruleStack)?s=c:s=i.ruleStack,new r.$4s(i.tokens,s)}}e.$cBb=l}),define(q[38],V([0,1,20,2,11]),function(F,e,A,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dBb=void 0;class k extends T.$jc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(l,t,a){super(),this.a=l,this.b=t,this.c=a,this.B((0,v.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(l,t,a){throw new Error("Not supported!")}tokenizeEncoded(l,t,a){return l.length>=this.c.get()?(0,A.$uC)(this.a,a):this.b.tokenizeEncoded(l,t,a)}createBackgroundTokenizer(l,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(l,t)}}e.$dBb=k}),define(q[39],V([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(F,e,A,T,v,k,r,l,t,a,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iBb=void 0;class u extends l.$Ku{constructor(s,d,w,N,L,S,f,y){super(s,d,w,N),this.s=L,this.t=S,this.u=f,this.a=null,this.b=!1,this.c=(0,v.observableValue)(this,-1),this.q=new T.$Rg(()=>this.w(),10),this.c.set(y,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,d){this.t=s,this.u=d,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,d){this.a&&(this.a.store.invalidateEndStateRange(new r.$rs(s,d)),this.q.schedule())}async v(){this.a=null;const s=this.t,d=this.u,w=await this.s.getOrCreateGrammar(s,d);if(!(this.b||s!==this.t||d!==this.u||!w)){if(w.grammar){const N=new g.$dBb(this.u,new c.$cBb(w.grammar,w.initialState,!1,void 0,()=>!1,(L,S,f)=>{this.s.reportTokenizationTime(L,s,w.sourceExtensionId,S,f)},!1),this.c);this.a=new t.$xC(this.f.length,N)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:d}=await(0,A.$$C)("vscode-textmate","release/main.js");this.m=d}const s=new Date().getTime();for(;;){let d=0;const w=new a.$wC,N=new n;for(;;){const f=this.a.getFirstInvalidLine();if(f===null||d>200)break;d++;const y=this.f[f.lineNumber-1],m=this.a.tokenizationSupport.tokenizeEncoded(y,!0,f.startState);if(this.a.store.setEndState(f.lineNumber,m.endState)){const B=this.m(f.startState,m.endState);N.setState(f.lineNumber,B)}else N.setState(f.lineNumber,null);if(h.$Vs.convertToEndOffset(m.tokens,y.length),w.add(f.lineNumber,m.tokens),new Date().getTime()-s>20)break}if(d===0)break;const L=N.getStateDeltas();if(this.s.setTokensAndStates(this.h,w.serialize(),L),new Date().getTime()-s>20){(0,k.$A)(()=>this.w());return}}}}e.$iBb=u;class n{constructor(){this.a=-1,this.b=[]}setState(s,d){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(d):this.b.push({startLineNumber:s,stateDeltas:[d]}),this.a=s}getStateDeltas(){return this.b}}}),define(q[40],V([0,1,18]),function(F,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fBb=void 0;class T{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(k){if(this.a[k.scopeName]){const r=this.a[k.scopeName];A.$ag(r.location,k.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${k.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${k.location.toString()}`)}this.a[k.scopeName]=k}getGrammarDefinition(k){return this.a[k]||null}}e.$fBb=T}),define(q[41],V([0,1,2,40]),function(F,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hBb=e.$gBb=void 0,e.$gBb="No TM Grammar registered for this language.";class v extends A.$jc{constructor(r,l,t,a){super(),this.a=r,this.b=t.INITIAL,this.c=new T.$fBb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:a,loadGrammar:async h=>{const c=this.c.getGrammarDefinition(h);if(!c)return this.a.logTrace(`No grammar found for scope ${h}`),null;const g=c.location;try{const u=await this.a.readFile(g);return t.parseRawGrammar(u,g.path)}catch(u){return this.a.logError(`Unable to load and parse grammar for scope ${h} from ${g}`,u),null}},getInjections:h=>{const c=h.split(".");let g=[];for(let u=1;u<=c.length;u++){const n=c.slice(0,u).join(".");g=[...g,...this.f[n]||[]]}return g}}));for(const h of l){if(this.c.register(h),h.injectTo){for(const c of h.injectTo){let g=this.f[c];g||(this.f[c]=g=[]),g.push(h.scopeName)}if(h.embeddedLanguages)for(const c of h.injectTo){let g=this.g[c];g||(this.g[c]=g=[]),g.push(h.embeddedLanguages)}}h.language&&this.h.set(h.language,h.scopeName)}}has(r){return this.h.has(r)}setTheme(r,l){this.j.setTheme(r,l)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,l){const t=this.h.get(r);if(typeof t!="string")throw new Error(e.$gBb);const a=this.c.getGrammarDefinition(t);if(!a)throw new Error(e.$gBb);const h=a.embeddedLanguages;if(this.g[t]){const u=this.g[t];for(const n of u)for(const i of Object.keys(n))h[i]=n[i]}const c=Object.keys(h).length>0;let g;try{g=await this.j.loadGrammarWithConfiguration(t,l,{embeddedLanguages:h,tokenTypes:a.tokenTypes,balancedBracketSelectors:a.balancedBracketSelectors,unbalancedBracketSelectors:a.unbalancedBracketSelectors})}catch(u){throw u.message&&u.message.startsWith("No grammar provided for")?new Error(e.$gBb):u}return{languageId:r,grammar:g,initialState:this.b,containsEmbeddedLanguages:c,sourceExtensionId:a.sourceExtensionId}}}e.$hBb=v}),define(q[49],V([0,1,8,41,39]),function(F,e,A,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function k(l,t){return new r(l,t)}e.create=k;class r{constructor(t,a){this.f=a,this.b=new Map,this.c=[],this.a=t.host;const h=a.grammarDefinitions.map(c=>({location:A.URI.revive(c.location),language:c.language,scopeName:c.scopeName,embeddedLanguages:c.embeddedLanguages,tokenTypes:c.tokenTypes,injectTo:c.injectTo,balancedBracketSelectors:c.balancedBracketSelectors,unbalancedBracketSelectors:c.unbalancedBracketSelectors,sourceExtensionId:c.sourceExtensionId}));this.d=this.g(h)}async g(t){const a=this.f.textmateMainUri,h=await new Promise((i,s)=>{F([a],i,s)}),c=await new Promise((i,s)=>{F([this.f.onigurumaMainUri],i,s)}),u=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await c.loadWASM(u);const n=Promise.resolve({createOnigScanner:i=>c.createOnigScanner(i),createOnigString:i=>c.createOnigString(i)});return new T.$hBb({logTrace:i=>{},logError:(i,s)=>console.error(i,s),readFile:i=>this.a.readFile(i)},t,h,n)}acceptNewModel(t){const a=A.URI.revive(t.uri),h=this;this.b.set(t.controllerId,new v.$iBb(a,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(c,g){const u=await h.d;return u?(h.c[g]||(h.c[g]=u.createGrammar(c,g)),h.c[g]):Promise.resolve(null)},setTokensAndStates(c,g,u){h.a.setTokensAndStates(t.controllerId,c,g,u)},reportTokenizationTime(c,g,u,n,i){h.a.reportTokenizationTime(c,g,u,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,a){this.b.get(t).onEvents(a)}retokenize(t,a,h){this.b.get(t).retokenize(a,h)}acceptModelLanguageChanged(t,a,h){this.b.get(t).onLanguageId(a,h)}acceptRemovedModel(t){const a=this.b.get(t);a&&(a.dispose(),this.b.delete(t))}async acceptTheme(t,a){(await this.d)?.setTheme(t,a)}acceptMaxTokenizationLineLength(t,a){this.b.get(t).acceptMaxTokenizationLineLength(a)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7b0ae6cf9d5a0c891ad1adc4da9c36c4dc453d4d/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
